-- name=int_achiev
--******************************************************************************************
function public.Init()

  public.SHOW_ANIM_TIME = 1;
  public.HIDE_ANIM_TIME = 1;
  public.SET_ANIM_TIME = 4;
  private.pos_x = 0;
  private.pos_x_new = 0;
  private.mouseon = 0;

  private.start_x = -183;
  private.delta_x = 366;

  public.stack_name = {}; --хранит имена ачивок

  public.busy_panel = { 0, 0, 0 }; --хранит информацию о занятых панельках

  public.close_id = 0;

  ObjAttach("int_achiev", interface.originhub);

end;
--******************************************************************************************
--------------------------------------------------------------------------------------------
function public.CheckScreen()

  if GetWideScreen() then
    private.pos_x_new = private.pos_x - 0.5 * ( GetAppWidth() - 1024 ) - 6;
  else
    private.pos_x_new = private.pos_x - 6;
  end;

  ObjSet("int_achiev", {pos_x = private.pos_x_new});

end;
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
function public.EventAnimEnd( event_id, close_id )

  if ( event_id == "show" ) then

    interface_impl.ShowAchiev();

  elseif ( event_id == "hide" ) then

    public.close_id = close_id;
    interface_impl.HideAchiev();

  end;

end;
-----------------------------------------------------------------------------
function public.AchMouseEnter( panel_id, from_tutor )

  if not from_tutor then
    SetCursor(CURSOR_HAND);
  end;
  
  private.mouseon = panel_id;
  public.ShowAnim( "hide", panel_id );

end;
-----------------------------------------------------------------------------
function public.AchMouseEnterSet( panel_id )

  private.mouseon = panel_id;

end;
-----------------------------------------------------------------------------
function public.AchMouseLeave( panel_id, from_tutor )
  
  SetCursor(CURSOR_DEFAULT);
  private.mouseon = 0;
  local trg = function () public.EventAnimEnd( "hide", panel_id ); end;
  
  if from_tutor then
    ObjSet("tmr_ach_"..panel_id,  { playing = false });
    trg();
  else
    ObjSet( "tmr_ach_"..panel_id, { time = public.SET_ANIM_TIME, playing = true, endtrig = trg } );
  end;
    
end;
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
function public.ShowAnim( event_id, panel_id )

  --DbgTrace("***int_achiev::public.ShowAnim: event_id = "..event_id..", panel_id = "..panel_id..", private.mouseon = "..private.mouseon);

  local trg = function () public.EventAnimEnd( event_id, panel_id ); end;
  local tme_show = public.SHOW_ANIM_TIME;
  local tme = public.SET_ANIM_TIME;
  local pos_panel_x = ObjGet("spr_int_achiev_"..panel_id).pos_x;

  ObjAnimate( "spr_int_achiev_"..panel_id, 0, 0, 0, "", { 0.0, 2, pos_panel_x,   tme_show, 2, private.start_x + private.delta_x } );
  if ( panel_id ~= private.mouseon ) then
    ObjSet( "tmr_ach_"..panel_id, { time = public.SET_ANIM_TIME, playing = true, endtrig = trg } );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achivement" );
  else
    ObjSet( "tmr_ach_"..panel_id, { playing = false } );
  end;

end;
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
function public.HideAnim( event_id, panel_id )

  --DbgTrace("***int_achiev::public.HideAnim: event_id = "..event_id..", panel_id = "..panel_id );

  local tme = public.HIDE_ANIM_TIME;
  local trg = function () public.HideAchiev( panel_id ); end;
  local pos_panel_x = ObjGet("spr_int_achiev_"..panel_id).pos_x;--int.achiev.pos_x_new + 370;

  ObjAnimate( "spr_int_achiev_"..panel_id, 0, 0, 0, trg, { 0.0, 2, pos_panel_x,   tme, 2, pos_panel_x - private.delta_x } );

end;
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
function public.HideAchiev( panel_id )

  --DbgTrace("***int_achiev::public.HideAchiev: panel_id = "..panel_id);

  public.busy_panel[ panel_id ] = 0;
  
  ObjMultiSet( { {"txt_int_achiev_"..panel_id, { text = "" }},
                 {"txt_int_achiev_"..panel_id.."_text", { text = ""  }} } );

  if #public.stack_name ~= 0 then 

    local name = public.stack_name[1];

    public.SetAchiev( name );

  end;

end;
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
function public.SetAchiev( achiev_name )

  --DbgTrace( "***int_achiev::public.SetAchiev: achiev_name = "..achiev_name );

  for i = 1, 3, 1 do

    if public.busy_panel[i] == 0 then

      public.busy_panel[i] = 1;

      table.remove(public.stack_name, 1);

      if ( string.sub( achiev_name, 1, 7 ) == "ce_col_" ) then

        ObjSet( "txt_int_achiev_"..i, { text = achiev_name, pos_y = -62 } );
        ObjSet( "txt_int_achiev_"..i.."_text", { text = "ce_col_find", pos_y = 22 } );

        ObjSet( "spr_int_achiev_pic_"..i, {res = "assets/levels/common/collectable/"..achiev_name});
        ObjSet( "spr_int_achiev_"..i, { event_mup = public.GotoCollectable } );

        ObjSet( "txt_int_achiev_"..i.."_collectable", {
          text = #ng_global.collectable.."/"..#rm_collectable.rm_collectable_state,
          alp = 1
        } );

      else

        ObjSet( "txt_int_achiev_"..i, { text = "ce_ach_"..achiev_name, pos_y = -62 } );
        ObjSet( "txt_int_achiev_"..i.."_text", { text = "ce_ach_"..achiev_name.."_text", pos_y = 22 } );

        ObjSet( "spr_int_achiev_pic_"..i, {res = "assets/levels/common/achievement/"..achiev_name});
        ObjSet( "spr_int_achiev_"..i, { event_mup = public.GotoAchievements } );

        ObjSet( "txt_int_achiev_"..i.."_collectable", { alp = 0 } );

      end;

      local event_id = "hide";
      local panel_id = i;

      public.ShowAnim( event_id, panel_id );

      break;

    end;

  end;

end;

--переход в комнату ачивок
function public.GotoAchievements()
  
  common_impl.go_acievements = true;
  
  interface.WidgetSetInput( InterfaceWidget_Achiev, false );

  interface.WidgetSetInput( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
  interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
  interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
  interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

  ObjSet( "int_inventory_impl",        { input = 0 } );
  
  int_complex_inv.Hide();
  if common.IsInSubRoom() then
    common.CloseSubRoom();
  end;

  cmn.GotoRoom("rm_achievements", 1, true);

  if common_impl.is_in_map == 1 then
    int_map_impl.CloseLd();
  end;

end;

--переход в комнату collectable
function public.GotoCollectable()
  
  common_impl.go_acievements = true;
  
  interface.WidgetSetInput( InterfaceWidget_Achiev, false );
  
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
  interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
  interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
  interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

  ObjSet( "int_inventory_impl",        { input = 0 } );
  
  int_complex_inv.Hide();
  if common.IsInSubRoom() then
    common.CloseSubRoom();
  end;

  cmn.GotoRoom("rm_collectable", 1, true);

  if common_impl.is_in_map == 1 then
    int_map_impl.CloseLd();
  end;

end;
----------------------------------------------------------------------------------