-- name=int_bonus
--******************************************************************************************
function public.Init()

  public.npc_cost = {35, 64, 80, 117, 120, 150};

  private.SHOW_ANIM_TIME = 1;
  private.HIDE_ANIM_TIME = 1;
  private.SET_ANIM_TIME = 2;
  private.SLIDE_ANIM_TIME = 0;
  private.pos_x = 1125;
  private.pos_x_new = 1125;

  public.iter = 0;
  public.state = 0;
  public.fly = 0;
  public.event_id = 0;
  private.mouseon = false;
  
  public.show_bonus = 0;

  ObjAttach("int_bonus", interface.originhub);

  --if IsSurveyEdition() then
  --  ObjSet( "spr_int_bonus", { event_mup = function () cmn.DialogWindowShow( 'common', 'strategy_guide_disable_item' ); end } );
  --end;

end;
--******************************************************************************************
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function public.CheckScreen()
  
  if GetWideScreen() then
    private.pos_x_new = private.pos_x + 0.5 * ( GetAppWidth() - 1024 );
  else
    private.pos_x_new = private.pos_x;
  end;
  
  ObjSet("int_bonus", {pos_x = private.pos_x_new});

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
--from_tutor - true если вызвали для туториала, чтобы не уползла панелька
function public.BonusMouseEnter( from_tutor )
  
  if  ( not cmn.is_inmenunow ) then

    if not from_tutor then
      SetCursor(CURSOR_HAND);
    end;
    
    private.mouseon = true;
    ObjSet( "tmr_bonus", { playing = false } );
    
    public.ShowAnim( "hide" );
    
  end;

end;
-----------------------------------------------------------------------------
function public.BonusMouseLeave()
  
  if  ( not cmn.is_inmenunow ) then

    SetCursor(CURSOR_DEFAULT);
    private.mouseon = false;

    --if ( not rm_achievements.in_rm_acievements ) then
    if ( not common_impl.go_acievements ) then

      local trg = interface_impl.HideBonus;
      ObjSet( "tmr_bonus", { time = private.SET_ANIM_TIME, playing = true, endtrig = trg } );

    end;
    
  end;

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function public.ShowAnim( event_id )

  if not private.mouseon then
    --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_achive_open_window"); 
  end;

  local tme_show = private.SHOW_ANIM_TIME;
  local pos_panel_x = ObjGet("spr_int_bonus").pos_x;

  ObjSet( "tmr_bonus", { playing = false } );
  ObjAnimate( "spr_int_bonus", 0, 0, 0, "",
  {
    0.0, 2, pos_panel_x,
    tme_show, 2, -192
  } );

end;

function public.HideAnim( event_id )

  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_achive_close_window"); 

  local pos_panel_x = ObjGet("spr_int_bonus").pos_x;
  local tme = private.HIDE_ANIM_TIME;

  public.show_bonus = 0;
  ObjAnimate( "spr_int_bonus", 0, 0, 0, "",
  {
    0, 2, pos_panel_x,  
    tme, 2, -29;
  } );

end;

function public.WaitAnim( event_id )

  --if ( not rm_achievements.in_rm_acievements ) then
  if ( not common_impl.go_acievements ) then

    local tme = private.SET_ANIM_TIME;

    ObjSet( "tmr_bonus", { endtrig = interface_impl.HideBonus,
                           time = tme,
                           playing = true } );

  end;

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function public.CountTotal( event_id )

  ObjStopAnimate("spr_int_bonus", 0);
  ObjSet( "tmr_bonus", { playing = false } );

  if public.state == 1 then
    if public.event_id == -1 then
      ng_global.bonus_count_current = ng_global.bonus_count_current + public.iter;
    elseif public.event_id == 1 then
      ng_global.bonus_count_current = ng_global.bonus_count_current - public.iter;
    end;
  end;

  public.iter = ng_global.bonus_count_counter - ng_global.bonus_count_current;
  --DbgTrace("public.iter "..public.iter);

  ng_global.bonus_count_current = ng_global.bonus_count_counter;
  --DbgTrace(" ng_global.bonus_count_current ".. ng_global.bonus_count_current);
  
  ng_global.bonus_count_counter = ng_global.bonus_count;
  --DbgTrace(" ng_global.bonus_count_counter ".. ng_global.bonus_count_counter);

  if public.iter < 0 then
    public.event_id = -1;
    public.iter = math.abs( public.iter );
  elseif public.iter > 0 then
    public.event_id = 1;
  end;
  private.SLIDE_ANIM_TIME = 0;
  for i = 2, public.iter, 1 do
    private.SLIDE_ANIM_TIME = private.SLIDE_ANIM_TIME + ( 0.3 / i );
  end;
  private.SLIDE_ANIM_TIME = ( 0.3 + private.SLIDE_ANIM_TIME ) / public.iter;

  if public.state == 0 then
    public.state = 1; --счетчик крутится
    --ng_global.show_bonus = 2;
    private.DrawNewCount( event_id );
  end;

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function private.DrawNewCount( event_id )

  if public.iter <= 0 then
    --ng_global.show_bonus = 1;
    public.state = 0;
    if event_id == "increase" and
       (not private.mouseon) then
      public.WaitAnim( event_id );
    end;
  else
    public.iter = public.iter - 1;
    local trg = function () private.DrawNewCount( event_id ); end;
    private.DrawSwap( 3, trg );
  end;

end;

function private.DrawSwap( id_panel, trg )

  local name = "spr_int_bonus_count_"..id_panel;
  local name_1 = "spr_int_bonus_count_"..id_panel.."_1";

  local name_pos_y = ObjGet(name).pos_y;
  local name_1_pos_y = ObjGet(name_1).pos_y;

  --DbgTrace(name_pos_y.." "..name_1_pos_y);

  trg = trg or "";
  if ( ( ( name_pos_y == -450 ) or ( name_1_pos_y == -450 ) ) and (public.event_id == 1) ) or 
     ( ( ( name_pos_y == 0 ) or ( name_1_pos_y == 0 ) ) and (public.event_id == -1) ) then
    private.DrawSwap( id_panel - 1 );
  end;
  if ( ( name_pos_y <= -500 ) and (public.event_id == 1) ) or ( ( name_pos_y >= 50 ) and (public.event_id == -1) ) then
    ObjSet(name, {pos_y = name_1_pos_y + public.event_id * 500})
  end;
  if ( ( name_1_pos_y <= -500 ) and (public.event_id == 1) ) or ( ( name_1_pos_y >= 50 ) and (public.event_id == -1) ) then
    ObjSet(name_1, {pos_y = name_pos_y + public.event_id * 500})
  end;
  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_achive_number"); 
  ObjAnimate(name, 1, 0, 0, "", {0, 0, ObjGet(name).pos_y,   private.SLIDE_ANIM_TIME, 0, ObjGet(name).pos_y - public.event_id * 50});
  ObjAnimate(name_1, 1, 0, 0, trg, {0, 0, ObjGet(name_1).pos_y,   private.SLIDE_ANIM_TIME, 0, ObjGet(name_1).pos_y - public.event_id * 50});

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function public.GotoSecretroom()
  
  if  ( not cmn.is_inmenunow ) then
  
    common_impl.go_acievements = true;
    rm_achievements.from_int_bonus = true;
    
    interface.WidgetSetInput( InterfaceWidget_Achiev, false );
    interface.WidgetSetInput( InterfaceWidget_Bonus, false );

    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

    ObjSet( "int_inventory_impl",        { input = 0 } );
    
    int_complex_inv.Hide();
    if common.IsInSubRoom() then
      common.CloseSubRoom();
    end;

    cmn.GotoRoom("rm_achievements", 1, true);

    if common_impl.is_in_map == 1 then
      int_map_impl.CloseLd();
    end;
    
  end;

--  if IsSurveyEdition() then
--
--    cmn.DialogWindowShow( 'common', 'strategy_guide_disable_item' );
--
--  else

  --  private.mouseon = false;
  --  --ObjSet("spr_int_bonus",  { pos_x = 0 });
  --  ng_global.show_bonus = 0;
  --
  --  int_complex_inv.Hide();
  --
  --  if common_impl.is_in_map == 1 then
  --    int_map_impl.CloseLd();
  --  end;
  --
  --  ng_global.secretroom_enter = ng_global.currentprogress;
  --  common.LevelSwitch( "secretroom" );

  --end;

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------