-- name=int_button_hint_impl
function public.Init ()

  public.DIRECTION = 0;

  --.port fix to 2700
  private.RELOAD_ANIM_FRAME_COUNT = 2700;

  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME = 0.3;

  private.BUTTON_SPRITE_NAME = "vid_int_button_hint_static";

  --на маке убираем видео стаического хинта и ставим картинку
  if GetPlatform() == "mac" then
    ObjDelete( "vid_int_button_hint_static" );
    ObjDelete( "vid_int_button_hint_hardcore" );
    if ng_global.new_hint then
      --DbgTrace("new_hint")
      ObjMultiSet( { {"spr_int_button_hint_static", { visible= 1 }},
                     {"spr_int_button_hint_static_hardcore", { visible = 1 }} } );
      private.BUTTON_SPRITE_NAME = "spr_int_button_hint_static";
    end;
  else
    ObjDelete( "spr_int_button_hint_static" );
    ObjDelete( "spr_int_button_hint_static_hardcore" );
  end;

end;
--******************************************************************************************
function public.WideScreenUpdate()

  --if ( not GetWideScreen() ) then
  --  ObjSet( "spr_int_button_hint_back_add", { visible = false } );
  --else
  --  ObjSet( "spr_int_button_hint_back_add", { visible = true } );
  --end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  --DbgTrace( "***int_button_hint_impl::public.ShowAnim" );

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_hint", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  --DbgTrace( "***int_button_hint_impl::public.HideAnim" );

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_hint", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.SetNewVid()

  --DbgTrace( "***int_button_hint_impl::private.SetNewVid" );

  ObjMultiSet( { 
    { "vid_int_button_hint_reload",         { pos_x = -47, pos_y = -32, res = "assets/interface/resources/vid_hint_charge2" } },
    { "vid_int_button_hint_reload_end",     { pos_x = -47, pos_y = -32, res = "assets/interface/resources/vid_hint_charge_end2" } },
    { "vid_int_button_hint_reload_begin",   { pos_x = -47, pos_y = -32, res = "assets/interface/resources/vid_hint_use2" } },
    { "vid_int_button_hint_static",         { res = "assets/interface/resources/vid_idle2" } },
    { "vid_int_button_hint_hardcore",       { active = true, visible = true } },
    { "spr_int_button_hint_static",         { active = true, visible = true } },
    { "spr_int_button_hint_static_hardcore",   { active = true, visible = true } },
    { "spr_int_button_hint_static_puf",     { alp = 1 } },
    { "spr_int_button_hint_hardcore_puf",   { alp = 1 } },
    { "spr_int_button_hint_static_chain",   { pos_x = 130, pos_y = 45, scale_x = 0.79, scale_y = 0.79 } },
    { "spr_int_button_hint_hardcore_chain", { pos_x = 130, pos_y = 45, scale_x = 0.79, scale_y = 0.79 } },
    { "obj_int_button_hint_button",         { inputrect_x = -18, inputrect_y = -30, inputrect_w = 113, inputrect_h = 50 } },
    { "obj_int_button_hint_button2",        { inputrect_x = 10, inputrect_y = -127, inputrect_w = 85, inputrect_h = 97 } }
  } );

  ObjDelete( "spr_int_button_hint_static_clock" );
  ObjDelete( "spr_int_button_hint_hardcore_clock" );
  
  if GetPlatform() == "mac" then
    private.BUTTON_SPRITE_NAME = "spr_int_button_hint_static";
  end;

end;
--******************************************************************************************
function private.ChangeVidAnimEnd()

  public.SetNewVid();
  int_button_skip_impl.SetNewVid();

  ObjAnimate( "int_button_hint_impl", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

end;
function public.ChangeVidAnim()

  --DbgTrace( "***int_button_hint_impl::public.ChangeVidAnim" );

  ng_global.new_hint = true;

  ObjAnimate( "int_button_hint_impl", "alp", 0, 0, private.ChangeVidAnimEnd, { 0, 0, 1,    0.3, 0, 0 } );

end;
--******************************************************************************************
function public.ChangeToStatic()

  --DbgTrace( "***int_button_hint_impl::public.ChangeToStatic" );

  if ( game.play_hint_aud ) then  --чтоб не проигрывал при загрузке лвла
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_hint_reload" );
  end;

  ObjSet( "obj_int_button_hint_reload",     { active = false, visible = false } );
  ObjSet( "vid_int_button_hint_reload_end", { active = true,  visible = true, frame = 1 } );
  ObjSet( private.BUTTON_SPRITE_NAME,       { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_static",     { active = true,  visible = true } );

  --DbgTrace( "убрали   obj_int_button_hint_reload" );
  --DbgTrace( "показали vid_int_button_hint_reload_end" );
  --DbgTrace( "убрали   "..private.BUTTON_SPRITE_NAME );
  --DbgTrace( "показали obj_int_button_hint_static" );
  --DbgTrace( "воспроизводим vid_int_button_hint_reload_end" );

  VidPlay("vid_int_button_hint_reload_end",
    function ()
      --DbgTrace( "довоспроизвели и убрали vid_int_button_hint_reload_end" );
      --DbgTrace( "показали "..private.BUTTON_SPRITE_NAME.."\n" );
      ObjSet( "vid_int_button_hint_reload_end", { active = false, visible = false } );
      ObjSet( private.BUTTON_SPRITE_NAME,       { active = true, visible = true } );
    end
  );

  if GetPlatform() ~= "mac" then
    VidPlay( "vid_int_button_hint_static", function () end );
  end;

end;
--******************************************************************************************
function public.ChangeToReload( is_begin )

  --DbgTrace( "***int_button_hint_impl::public.ChangeToReload: is_begin == "..tostring(is_begin) );

  if GetPlatform() ~= "mac" then  
    VidStop( "vid_int_button_hint_static" );
  end;

  --DbgTrace( "убрали     obj_int_button_hint_static" );
  --DbgTrace( "показали   obj_int_button_hint_reload" );
  --DbgTrace( "остановили vid_int_button_hint_reload_begin" );

  ObjSet( "obj_int_button_hint_static", { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_reload", { active = true, visible = true } );
  VidStop( "vid_int_button_hint_reload_begin" );

  if ( is_begin ) then

    if ( ng_global.new_hint ) then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_clk_hint_cat" );
    end;

    --DbgTrace( "убрали vid_int_button_hint_reload" );
    --DbgTrace( "показываем и воспроизводим vid_int_button_hint_reload_begin" );

    ObjSet( "vid_int_button_hint_reload",       { active = false, visible = false } );
    ObjSet( "vid_int_button_hint_reload_begin", { active = true,  visible = true, frame = 0, playing = true,
      endtrig = function ()
        --DbgTrace( "довоспроизвели vid_int_button_hint_reload_begin\n" );
        private.ReloadAnim( true );
      end
    } );

  else

    private.ReloadAnim( true );

  end;

end;
--******************************************************************************************
function public.SetHardcore( is_hardcore )
  
  if ( ng_global.gamemode == 2 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.use_hint == 0 ) then

    ObjMultiSet( { { "obj_int_button_hint_active",   { visible = false } },
                   { "obj_int_button_hint_hardcore", { active = true, visible = true } },
                   { "vid_int_button_hint_hardcore", { playing = true } } } );

  else

    ObjMultiSet( { { "obj_int_button_hint_hardcore", { active = false, visible = false } },
                   { "obj_int_button_hint_active",   { visible = true } },
                   { "vid_int_button_hint_hardcore", { playing = false } } } );

  end;

end;
--******************************************************************************************
function private.ReloadAnim( is_first )

  --DbgTrace( "***int_button_hint_impl::public.ReloadAnim: is_first == "..tostring(is_first) );

  if ( is_first ) then

    --DbgTrace( "убрали   vid_int_button_hint_reload_begin" );
    --DbgTrace( "показали vid_int_button_hint_reload" );

    ObjSet( "vid_int_button_hint_reload_begin", { active = false, visible = false } );
    ObjSet( "vid_int_button_hint_reload",       { active = true,  visible = true } );

  end;

  if ( not ObjGet( "tmr_int_button_hint_reload" ) ) then
    --чтобы предотвратить обращение к несуществующему таймеру при переходе в другой лвл
    return;
  end;

  local time_min    = int_button_hint.GetTimeMin();
  local time_remain = int_button_hint.GetTimeRemain();
  local time_full   = int_button_hint.GetTimeFull();

  local frame_count = private.RELOAD_ANIM_FRAME_COUNT;

  -- время на один фрейм
  local time_frame = time_full / frame_count;
  local time_current = time_full - time_remain;
  local frame_current = math.floor( time_current / time_frame );

  --DbgTrace( "HINT RELOAD: time = "..time_current..", frame = "..frame_current );

  ObjSet( "vid_int_button_hint_reload", { frame = frame_current } );

  if ( time_current < time_full ) then

    ObjSet( "tmr_int_button_hint_reload_anim", { endtrig = function () private.ReloadAnim(); end, time = time_min, playing = true } );

  end;

end;
--******************************************************************************************
function public.MouseEnterAnim()

  if ( cmn.IsPC() ) then

    SetCursor( CURSOR_HAND );

    local obj = "spr_int_button_hint_button_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );

  end;

end;
--******************************************************************************************
function public.MouseLeaveAnim()

  if ( cmn.IsPC() ) then

    SetCursor( CURSOR_DEFAULT );

    local obj = "spr_int_button_hint_button_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

  end;

end;
--******************************************************************************************
function public.DisableActivityWhenOpenGameOptions()

  if ObjGet( "int_button_hint" ).active then
    --DbgTrace( "хинт был активен" );
    private.hint_active_state_before_open_options = true;
    ObjSet( "int_button_hint", { active = false } );
  end;

end;
function public.EnableActivityWhenCloseGameOptions()

  if private.hint_active_state_before_open_options then
    --DbgTrace( "включаем обратно хинт\n" );
    private.hint_active_state_before_open_options = false;
    ObjSet( "int_button_hint", { active = true } );
  end;

end;
--******************************************************************************************