-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = 0;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_map", {
    event_mdown = public.MouseDown,
    event_menter = public.MouseEnterAnim,
    event_mleave = public.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.MouseDown()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  --if common.IsInSubRoom() then
  --  common.CloseSubRoom();
  --end;

  if interface.GetCurrentComplexInv() ~= "" then
    common_impl.HideComplexItem();
  end;

  if ng_global.currentprogress == "std" and ng_global.progress[ "std" ].common.chapter == "level1" then

    if cmn.IsEventDone("tutor_10") and not(cmn.IsEventDone("opn_maptutor")) then

      cmn.SetEventDone("opn_maptutor");

      cmn.TutorialShow( "tutor_16", 0, 512, 384 );

    end;

  end;

  int_button_map.MouseDown();

end;
--******************************************************************************************
function public.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj1 = "spr_int_button_map_1";
  local pos1_x = ObjGet( obj1 ).pos_x;
  local pos1_y = ObjGet( obj1 ).pos_y;
  
  local point_a, point_b = {}, {};
  point_a[1] = pos1_x;
  point_a[2] = pos1_y;
  point_b[1] = -20;
  point_b[2] = 31;
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  point_a[1] = -2;
  point_a[2] = 27;
  len2 = common_impl.math.FindSegmentLength( point_a, point_b );
  local diff = len/len2;
  
  local tme1 = diff * private.MOUSE_OVER_ANIM_TIME;
  
  ObjAnimate( obj1, "pos_xy", 0, 0, "",
  {
    0.0, 2, pos1_x, pos1_y,
    tme1, 2, -20, 31
  } );

  local obj2 = "spr_int_button_map_2";
  local pos2_x = ObjGet( obj2 ).pos_x;
  local pos2_y = ObjGet( obj2 ).pos_y;
  
  ObjAnimate( obj2, "pos_xy", 0, 0, "",
  {
    0.0, 2, pos2_x, pos2_y,
    tme1, 2, 98, 2
  } );
  
  local obj3 = "spr_int_button_map_map";
  local pos3_x = ObjGet( obj3 ).pos_x;
  local pos3_y = ObjGet( obj3 ).pos_y;

  ObjAnimate( obj3, "pos_xy", 0, 0, "",
  {
    0.0, 2, pos3_x, pos3_y,
    tme1, 2, 16, -41
  } );

  if tme1 > 0.13 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_map");
  end;

end;
--******************************************************************************************
function public.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj1 = "spr_int_button_map_1";
  local pos1_x = ObjGet( obj1 ).pos_x;
  local pos1_y = ObjGet( obj1 ).pos_y;
  
  local point_a, point_b = {}, {};
  point_a[1] = pos1_x;
  point_a[2] = pos1_y;
  point_b[1] = -2;
  point_b[2] = 27;
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  point_a[1] = -20;
  point_a[2] = 31;
  len2 = common_impl.math.FindSegmentLength( point_a, point_b );
  local diff = len/len2;
  
  local tme1 = diff * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj1, "pos_xy", 0, 0, "",
  {
    0.0, 2, pos1_x, pos1_y,
    tme1, 2, -2, 27
  } );

  local obj2 = "spr_int_button_map_2";
  local pos2_x = ObjGet( obj2 ).pos_x;
  local pos2_y = ObjGet( obj2 ).pos_y;

  ObjAnimate( obj2, "pos_xy", 0, 0, "",
  {
    0.0, 2, pos2_x, pos2_y,
    tme1, 2, 82, 0
  } );
  
  local obj3 = "spr_int_button_map_map";
  local pos3_x = ObjGet( obj3 ).pos_x;
  local pos3_y = ObjGet( obj3 ).pos_y;

  ObjAnimate( obj3, "pos_xy", 0, 0, "",
  {
    0.0, 2, pos3_x, pos3_y,
    tme1, 2, 26, -20
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************