-- name=int_button_skip_impl
function public.Init ()

  public.DIRECTION = 0;

  --port. 2700 fix
  private.RELOAD_ANIM_FRAME_COUNT = 2700;

  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME = 0.3;

end;
--******************************************************************************************
function public.WideScreenUpdate()

--  if ( not GetWideScreen() ) then
--
--  else
--
--  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_button_skip.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_skip", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_button_skip.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_skip", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.SetNewVid()

  --DbgTrace( "***int_button_skip_impl::private.SetNewVid" );

  ObjMultiSet( { 
    { "vid_int_button_skip_reload",         { pos_x = -47, pos_y = -32, res = "assets/interface/resources/vid_hint_charge2" } },
    { "vid_int_button_skip_reload_end",     { pos_x = -47, pos_y = -32, res = "assets/interface/resources/vid_hint_charge_end2" } },
    { "vid_int_button_skip_reload_begin",   { pos_x = -47, pos_y = -32, res = "assets/interface/resources/vid_hint_use2" } },
    { "vid_int_button_skip_static",         { res = "assets/interface/resources/vid_idle2" } },
    { "vid_int_button_skip_hardcore",       { active = true, visible = true } },
    { "spr_int_button_skip_static_puf",     { alp = 1 } },
    { "spr_int_button_skip_hardcore_puf",   { alp = 1 } },
    { "spr_int_button_skip_static_chain",   { pos_x = 130, pos_y = 45, scale_x = 0.79, scale_y = 0.79 } },
    { "spr_int_button_skip_hardcore_chain", { pos_x = 130, pos_y = 45, scale_x = 0.79, scale_y = 0.79 } },
    { "obj_int_button_skip_button",         { inputrect_x = -18, inputrect_y = -30, inputrect_w = 113, inputrect_h = 50 } },
    { "obj_int_button_skip_button2",        { inputrect_x = 10, inputrect_y = -127, inputrect_w = 85, inputrect_h = 97 } }
  } );

  ObjDelete( "spr_int_button_skip_static_clock" );
  ObjDelete( "spr_int_button_skip_hardcore_clock" );

end;
--******************************************************************************************
function public.ChangeToStatic()

  if ( game.play_hint_aud ) then  --чтоб не проигрывал при загрузке лвла
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_hint_reload" );
  end;

  ObjSet( "obj_int_button_skip_reload",     { active = false, visible = false } );
  ObjSet( "vid_int_button_skip_reload_end", { active = true,  visible = true, frame = 1 } );
  ObjSet( "vid_int_button_skip_static",     { active = false, visible = false } );
  ObjSet( "obj_int_button_skip_static",     { active = true,  visible = true } );

  VidPlay("vid_int_button_skip_reload_end",   
    function ()
      ObjSet( "vid_int_button_skip_reload_end", { active = false, visible = false } );
      ObjSet( "vid_int_button_skip_static",     { active = true, visible = true } );
    end
  );

  VidPlay( "vid_int_button_skip_static", function () end );

end;
--******************************************************************************************
function public.ChangeToReload( is_begin )

  ObjSet( "obj_int_button_skip_static", { active = false, visible = false } );
  ObjSet( "obj_int_button_skip_reload", { active = true,  visible = true } );
  VidStop( "vid_int_button_skip_reload_begin" );

  if ( is_begin ) then

    if ( ng_global.new_hint ) then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_clk_hint_cat" );
    end;

    ObjSet( "vid_int_button_skip_reload",       { active = false, visible = false } );
    ObjSet( "vid_int_button_skip_reload_begin", { active = true,  visible = true, frame = 0, playing = true, 
      endtrig = function ()
        private.ReloadAnim( true );
      end
    } );

  else

    private.ReloadAnim( true );

  end;

end;
--******************************************************************************************
function public.SetHardcore( is_hardcore )

  if ( ng_global.gamemode == 2 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.use_skip == 0 ) then

    ObjMultiSet( { { "obj_int_button_skip_active",   { visible = false } },
                   { "obj_int_button_skip_hardcore", { active = true, visible = true } },
                   { "vid_int_button_skip_hardcore", { playing = true } } } );

  else

    ObjMultiSet( { { "obj_int_button_skip_hardcore", { active = false, visible = false } },
                   { "obj_int_button_skip_active",   { visible = true } },
                   { "vid_int_button_skip_hardcore", { playing = false } } } );

  end;

end;
--******************************************************************************************
function private.ReloadAnim( is_first )

  if ( is_first ) then

    ObjSet( "vid_int_button_skip_reload_begin", { active = false, visible = false } );
    ObjSet( "vid_int_button_skip_reload",       { active = true,  visible = true } );

  end;

  if ( not ObjGet( "tmr_int_button_skip_reload" ) ) then
    --чтобы предотвратить обращение к несуществующему таймеру при переходе в другой лвл
    return;
  end;

  local time_min    = int_button_skip.GetTimeMin();
  local time_remain = int_button_skip.GetTimeRemain();
  local time_full   = int_button_skip.GetTimeFull();

  local frame_count = private.RELOAD_ANIM_FRAME_COUNT;

  -- время на один фрейм
  local time_frame = time_full / frame_count;
  local time_current = time_full - time_remain;
  local frame_current = math.floor( time_current / time_frame );

  --DbgTrace( "SKIP RELOAD: time = "..time_current..", frame = "..frame_current );

  ObjSet( "vid_int_button_skip_reload", { frame = frame_current } );

  if ( time_current < time_full ) then

    ObjSet( "tmr_int_button_skip_reload_anim", { endtrig = function () private.ReloadAnim(); end, time = time_min, playing = true } );

  end;

end;
--******************************************************************************************
function public.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_skip_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function public.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_skip_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.DisableActivityWhenOpenGameOptions()

  if ObjGet( "int_button_skip" ).active then
    --DbgTrace( "скип был активен" );
    private.skip_active_state_before_open_options = true;
    ObjSet( "int_button_skip", { active = false } );
  end;

end;
function public.EnableActivityWhenCloseGameOptions()

  if private.skip_active_state_before_open_options then
    --DbgTrace( "включаем обратно скип\n" );
    private.skip_active_state_before_open_options = false;
    ObjSet( "int_button_skip", { active = true } );
  end;

end;
--******************************************************************************************