-- name=int_dialog_secretroom
--******************************************************************************************
function public.Init()

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME       = 0.6;
  private.event_anim_end = {};

  private.challenge_time = {{10, 60}, {30, 80}};
  public.max_time = 600;

  ObjSet("obj_int_dialog_secretroom_button", {
    event_mup = public.MouseDwn,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

  ObjAttach("int_dialog_secretroom", interface.originhub);

end;
--******************************************************************************************
function public.ShowAnim()

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_ho" );

  ObjSet( "int_dialog_secretroom",      { active = true, visible = true, input = true } );
  local event_id = "show";
  private.event_anim_end[ event_id ] = {};

  local trg = function () public.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_secretroom_root", "scale_xy", 0, 0, trg,
  {
    ( 0.0 * tme ), 2, 0, 0,
    ( 1.0 * tme ), 2, 1, 1
  } );

  ObjAnimate( "int_dialog_secretroom", "alp", 0, 0, "",
  {
    ( 0.0 * tme ), 2, 0,
    ( 0.5 * tme ), 2, 0,
    ( 1.0 * tme ), 2, 1 
  });

end;
--******************************************************************************************
function public.TimeBarDecrease()

  --local challenge = 1;
  local challenge = rm_secretroom.current_challenge;
  local prefix = common.GetObjectPrefix( GetCurrentRoom() );
  --local cur_crop = ObjGet("spr_secretroom_time_bar").croprect_w
  
  --if prefix == "mg" then
  --  challenge = 2;
  --end;

  local bar_size = 500;
  local bar_crop = 500;

  local tme = ObjGet("tmr_secretroom_challenge_timer").time;
  tme = public.max_time - tme;

  local percent = math.floor((private.challenge_time[challenge][2] - tme)/(private.challenge_time[challenge][2]/100))/100;
  local cur_time = math.floor(private.challenge_time[challenge][2] - tme);
  local txt_time = "";

  if cur_time < 60 and cur_time > 9 then
    txt_time = "0:"..cur_time;
  elseif cur_time < 60 and cur_time <= 9 then
    txt_time = "0:0"..cur_time;
  elseif cur_time >= 60 and (cur_time-60) > 9 then
    txt_time = "1:"..(cur_time-60);
  elseif cur_time >= 60 and (cur_time-60) <= 9 then
    txt_time = "1:0"..(cur_time-60);
  end;

  if percent <= 0.01 then
    bar_crop = 1;
    txt_time = "0:00";
  else 
    bar_crop = math.floor(bar_size*percent);
    ObjSet("tmr_secretroom_challenge_timebar_timer",  { playing = 1, time = 0.01, endtrig = public.TimeBarDecrease });
  end;

  ObjMultiSet( { {"spr_secretroom_time_bar", { croprect_w = bar_crop }},
                 {"txt_secretroom_time_bar_time", { text = txt_time }} } );
  --ObjAnimate("spr_secretroom_time_bar", "croprect_w", 0, 0, "", { 0, 0, cur_crop,   0.01, 0, bar_crop });

end;
--******************************************************************************************
function public.StopTimer()
  
  local challenge = common.GetObjectName( GetCurrentRoom() );
  
  local tme_s = math.floor(60 - ObjGet("tmr_extra_challenge_timer").time);
  ObjSet("tmr_extra_challenge_timer",  { playing = false });
  
  local tme_m = rm_extra.count_timer;
  local tme_h = 0;
  
  if tme_m > 59 then
    tme_h = math.floor(tme_m/60);
    tme_m = tme_m % 60;
  end;
  DbgTrace(tme_h, tme_m, tme_s)
  if ng_global.replay_time and not ng_global.replay_time[ "win_"..challenge ] then
    ng_global.replay_time[ "win_"..challenge ] = {0, 0, 0};
    ng_global.replay_time[ "win_"..challenge ][1] = tme_h;
    ng_global.replay_time[ "win_"..challenge ][2] = tme_m;
    ng_global.replay_time[ "win_"..challenge ][3] = tme_s;
  end;
  
  local full_time_new = tme_h*3600 + tme_m*60 + tme_s;
  local full_time_old = 0;
  
  if ng_global.replay_time then
    full_time_old = ng_global.replay_time[ "win_"..challenge ][1]*3600 + ng_global.replay_time[ "win_"..challenge ][2]*60 + ng_global.replay_time[ "win_"..challenge ][3];
  end;
  
  if full_time_old > full_time_new and ng_global.replay_time then
    ng_global.replay_time[ "win_"..challenge ][1] = tme_h;
    ng_global.replay_time[ "win_"..challenge ][2] = tme_m;
    ng_global.replay_time[ "win_"..challenge ][3] = tme_s;
  end;
  
  local text_t = "";
  if tme_s < 10 then
    text_t = tme_m..":0"..tme_s;
  else 
    text_t = tme_m..":"..tme_s;
  end;
  
  if tme_h > 0 then
    text_t = tme_h..":"..text_t;
  end;
  
  ObjSet("txt_int_dialog_secretroom_time_new_count",  { text = text_t });
  
  if ng_global.replay_time then
    
    if ng_global.replay_time[ "win_"..challenge ][3] < 10 then
      text_t = ng_global.replay_time[ "win_"..challenge ][2]..":0"..ng_global.replay_time[ "win_"..challenge ][3];
    else 
      text_t = ng_global.replay_time[ "win_"..challenge ][2]..":"..ng_global.replay_time[ "win_"..challenge ][3];
    end;
  
    if ng_global.replay_time[ "win_"..challenge ][1] > 0 and ng_global.replay_time[ "win_"..challenge ][2] > 9 then
      text_t = ng_global.replay_time[ "win_"..challenge ][1]..":"..text_t;
    elseif ng_global.replay_time[ "win_"..challenge ][1] > 0 then
      text_t = ng_global.replay_time[ "win_"..challenge ][1]..":0"..text_t;
    end;
    
    ObjSet("txt_int_dialog_secretroom_time_best_count",  { text = text_t });
    
  else 
    ObjSet("txt_int_dialog_secretroom_time_best_count",  { text = text_t });
  end;
  
end;
--******************************************************************************************
function public.SetStar()

  local star_size = 140;
  local challenge = 1;
  local prefix = common.GetObjectPrefix( GetCurrentRoom() );
  
  if prefix == "mg" then
    challenge = 2;
  end;

  local tme = ObjGet("tmr_secretroom_challenge_timer").time;
  ObjSet("tmr_secretroom_challenge_timer",  { playing = false });

  tme = public.max_time - tme;

  local percent;
  --min time
  if tme <= private.challenge_time[challenge][1] then
    percent = 100;
  elseif tme >= private.challenge_time[challenge][2] then
    percent = 10;
  else 
    percent = math.floor((private.challenge_time[challenge][2] - tme)/((private.challenge_time[challenge][2] - private.challenge_time[challenge][1])/100));
  end;

  ng_global.secretroom.stars_state[rm_secretroom.current_npc][challenge] = ng_global.secretroom.stars_state[rm_secretroom.current_npc][challenge] + percent;
  if ng_global.secretroom.stars_state[rm_secretroom.current_npc][challenge] > 100 then
    ng_global.secretroom.stars_state[rm_secretroom.current_npc][challenge] = 100;
  end;

  ObjMultiSet( { {"spr_int_dialog_secretroom_star_full", { croprect_w = star_size*percent/100 }},
                 {"txt_int_dialog_secretroom_percent", { text = percent.." %" }} } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () public.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_secretroom_root", "scale_xy", 0, 0, trg,
  {
    ( 0.0 * tme ), 1, 1, 1,
    ( 1.0 * tme ), 1, 0, 0
  } );

  ObjAnimate( "int_dialog_secretroom", "alp", 0, 0, "",
  {
    ( 0.0 * tme ), 1, 1,
    ( 0.5 * tme ), 1, 0,
    ( 1.0 * tme ), 1, 0
  } );

end;
--******************************************************************************************
function public.EventAnimEnd( event_id )

  local event_params = private.event_anim_end[ event_id ];

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then

    ObjSet( "obj_int_dialog_secretroom_exit", { event_mdown = public.MouseDown } );

    ObjSet( "int_dialog_secretroom", { input = true } );

  elseif ( event_id == "hide" ) then

    ObjSet( "int_dialog_secretroom",      { active = false, visible = false, input = false } );
    rm_extra.GoToSecretroom_end();

  end;
------------------------------------------------------------------------------------
end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_dialog_secretroom_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_dialog_secretroom_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );


end;
--******************************************************************************************
function public.MouseDwn() 

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  port.TapDown(1.5);
  ObjSet( "obj_int_dialog_secretroom_exit", { event_mdown = "" } );
  ObjSet( "int_dialog_secretroom", { input = false } );

  local event_id = "hide";
  private.event_anim_end[ event_id ] = {};
  public.HideAnim( event_id );

end;
--******************************************************************************************
