-- name=int_frame_subroom_impl
--******************************************************************************************
function public.Init ()

  public.GRID_CORNER_W = 118;
  public.GRID_CORNER_H = 123;
  public.GRID_MID_W    =  4;
  public.GRID_MID_H    =  4;

  -- расстояние от внут. рамки до границ спрайта
  public.GRID_BORDER_W = 10;
  public.GRID_BORDER_H = 10;

  private.BUTTON_CLOSE_MOUSE_OVER_TIME = 0.3;

  ObjSet("obj_int_frame_subroom_button", {
    event_mdown = function () int_frame_subroom.ButtonCloseClick(); cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk"); end,
    event_menter = function () public.ButtonCloseMouseEnterAnim("button"); end,
    event_mleave = function () public.ButtonCloseMouseLeaveAnim("button"); end
  });

  ObjSet("obj_int_frame_subroom_top", {
    event_mdown = int_frame_subroom.ButtonCloseClick,
    event_menter = int_frame_subroom.FieldCloseMouseEnter,
    event_mleave = int_frame_subroom.FieldCloseMouseLeave
  });
  ObjSet("obj_int_frame_subroom_bot", {
    event_mdown = int_frame_subroom.ButtonCloseClick,
    event_menter = int_frame_subroom.FieldCloseMouseEnter,
    event_mleave = int_frame_subroom.FieldCloseMouseLeave
  });
  ObjSet("obj_int_frame_subroom_left", {
    event_mdown = int_frame_subroom.ButtonCloseClick,
    event_menter = int_frame_subroom.FieldCloseMouseEnter,
    event_mleave = int_frame_subroom.FieldCloseMouseLeave
  });
  ObjSet("obj_int_frame_subroom_right", {
    event_mdown = int_frame_subroom.ButtonCloseClick,
    event_menter = int_frame_subroom.FieldCloseMouseEnter,
    event_mleave = int_frame_subroom.FieldCloseMouseLeave
  });


end;
--******************************************************************************************
function public.ButtonCloseMouseEnterAnim( butt, butt2 )

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_frame_subroom_"..butt.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_CLOSE_MOUSE_OVER_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  if butt2 then
    local alp2 = ObjGet( "spr_int_frame_subroom_"..butt2.."_focus" ).alp;
    local tme2 = ( 1 - alp2 ) * private.BUTTON_CLOSE_MOUSE_OVER_TIME;
    ObjAnimate("spr_int_frame_subroom_"..butt2.."_focus", "alp", 0, 0, "", { 0, 2, alp2,   tme2, 2, 1 });
  end;

end;
--******************************************************************************************
function public.ButtonCloseMouseLeaveAnim( butt, butt2 )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_frame_subroom_"..butt.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_CLOSE_MOUSE_OVER_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  if butt2 then
    local alp2 = ObjGet( "spr_int_frame_subroom_"..butt2.."_focus" ).alp;
    local tme2 = alp2 * private.BUTTON_CLOSE_MOUSE_OVER_TIME;
    ObjAnimate("spr_int_frame_subroom_"..butt2.."_focus", "alp", 0, 0, "", { 0, 1, alp2,   tme2, 1, 0 });
  end;

end;
--******************************************************************************************
function public.GateMouseEnterAnim( butt, cursor )

  SetCursor( cursor );

  local obj = "spr_int_frame_subroom_"..butt.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_CLOSE_MOUSE_OVER_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function public.GateMouseLeaveAnim( butt )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_frame_subroom_"..butt.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_CLOSE_MOUSE_OVER_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************