-- name=int_global_task
--******************************************************************************************
function public.Init()

  public.global_tasks = {};
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME       = 0.6;
  private.SHOWED_TIME          = 5;

  private.PANEL_START_POS = { 1254, 1425 };
  private.PANEL_MOVE = 230;

  private.pos_x_new = 1596;
  private.gt_shown = false;

  ObjAttach("int_global_task", interface.originhub);

end;
--******************************************************************************************
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function public.CheckScreen()

  if GetWideScreen() then
    private.pos_x_new = private.PANEL_START_POS[2];
  else 
    private.pos_x_new = private.PANEL_START_POS[1];
  end;

  ObjSet("int_global_task",  { pos_x = private.pos_x_new });

end;
---------------------------------------------------------------------------------------------------------------------------------------------------------------------
function public.ShowAnim( func_after_anim )

  if not private.gt_shown then
    
    --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_newtask"); 

    private.gt_shown = true;

    ObjMultiSet( { {"txt_int_global_task_text",  { text = StringGet("str_global_task_"..ng_global.global_task_first) }},
                   {"tmr_global_task", { time = private.SHOWED_TIME, playing = 1, endtrig = public.HideAnim }} } );

    local func_after = function ()

      if func_after_anim then
        func_after_anim();
      --else 
      --  ObjSet("spr_int_global_task",  { input = 1 });
      end;

    end;

    local tme_show = private.SHOW_ANIM_TIME;
    local pos_panel_x = ObjGet("spr_int_global_task").pos_x;

    ObjAnimate( "spr_int_global_task", 0, 0, 0, func_after,
    {
      0.0, 2, pos_panel_x,
      tme_show, 2, -277
    } );
    
  end;

end;
------------------------------------------------------------------------------------
function public.HideAnim()

  if private.gt_shown then

    --cmn.Lock(1);
    --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_inv_slide_close"); 

    local func_after = function ()
      private.gt_shown = false;
      ObjSet("obj_int_inventory_btn_global_task",  { input = 1 });
    end;

    local tme_show = private.SHOW_ANIM_TIME;
    local pos_panel_x = ObjGet("spr_int_global_task").pos_x;

    ObjAnimate( "spr_int_global_task", 0, 0, 0, func_after,
    {
      0.0, 2, pos_panel_x,
      tme_show, 2, -52
    } );

  end;

end;
------------------------------------------------------------------------------
