-- name=int_map_impl
--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

  ObjSet( "spr_int_map_back", {
    event_mup = int_map_impl.Close
  } );

  private.MAP_ICON_MOUSE_OVER_ANIM_TIME = 0.3; --время анимации подсветки мест локации

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
private.old_map_room = "";
function public.ShowAnim( event_id )

  --DbgTrace( "***int_map_impl::public.ShowAnim: event_id == "..event_id );

  PauseLevel( 1 );

  common_impl.is_in_map = 1;

  interface.AddIntToList( "int_map" );

  interface_impl.DialogHintHide();
  
  if ng_global.global_task_first > 0 then
    ObjSet("txt_int_map_global_task_txt",  { text = StringGet("str_global_task_"..ng_global.global_task_first) });
  else 
    ObjSet("txt_int_map_global_task_txt",  { text = "" });
  end;

  local trg = function () 
    int_map.EventAnimEnd( event_id );
    ObjSet("obj_int_map_impl_close", { input = 1 } );
  end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_map", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_opn_cls_map");

  if ng_global.currentprogress == "ext" then
    ObjSet("spr_int_map_here",  { res = "assets/interface/resources/map/grettel" });
  else 
    ObjSet("spr_int_map_here",  { res = "assets/interface/resources/map/cindy" });
  end;

  local cur_map_room = common.GetCurrentRoom();

  if ( not game.map_rooms[ cur_map_room ] ) then

    cur_map_room = common.GetPrevRoom();

  end;

  --подсветка дневника, если есть непрочитанные стр
  if ng_global.map_diary_notes_read[ ng_global.currentprogress ] and ng_global.map_diary_notes_read[ ng_global.currentprogress ] < #ng_global.map_diary_notes[ ng_global.currentprogress ] then
    ObjAnimate("spr_int_map_note_journal_glow", "alp", 1, 0, "", { 0, 3, 0,   1, 3, 1,    1.6, 3, 1,    2.6, 3, 0 });
  end;

  if ( private.old_map_room ~= cur_map_room ) then

    local cur_map_room_obj = "obj_int_map_"..cur_map_room;

    --ObjSet( "spr_int_map_here", { pos_x = ObjGet( cur_map_room_obj ).pos_x, pos_y = ObjGet( cur_map_room_obj ).pos_y } );
    ObjAttach("spr_int_map_here", cur_map_room_obj);

    --ObjSet( cur_map_room_spr, { pos_x = ObjGet( cur_map_room_spr ).pos_x + 25 } );

    if ( private.old_map_room ~= "" ) then

      local old_map_room_spr = "spr_int_map_"..private.old_map_room.."_task";

      --ObjSet( old_map_room_spr, { pos_x = ObjGet( old_map_room_spr ).pos_x - 25 } );

    end;

    private.old_map_room = cur_map_room;

  end;

  local task_alp = 1;

  if ( ng_global.gamemode == 1 ) or ( ng_global.gamemode == 2 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tasks == 0 ) then

    task_alp = 0;

    ObjMultiSet({
      {"spr_int_map_all_task_fulfilled",  { alp = 0 }},
      {"spr_int_map_task_to_fulfill",     { alp = 0 }},
      {"spr_int_map_collectibles",        { alp = 0 }}
    });

  else

    task_alp = 1;

    ObjMultiSet({
      {"spr_int_map_all_task_fulfilled",  { alp = 1 }},
      {"spr_int_map_task_to_fulfill",     { alp = 1 }},
      {"spr_int_map_collectibles",        { alp = 1 }}
    });

  end;

  if not IsCollectorsEdition() then
    ObjSet("spr_int_map_collectibles",  { alp = 0 });
  else 
    ObjSet("spr_int_map_collectibles",  { alp = 1 });
  end;

  for key, value in pairs( game.map_rooms ) do

    if game.map_rooms[ key ][ 1 ] == 0 then
      --ObjSet("spr_int_map_"..key,  { alp = 0.25 });
      for i = 1, 3, 1 do
        ObjSet("anm_int_map_"..key.."_cloud_"..i,  {  alp = 1, playing = 1 });
      end;
    else 
      --ObjSet("spr_int_map_"..key,  { alp = 1 });
      for i = 1, 3, 1 do
        ObjSet("anm_int_map_"..key.."_cloud_"..i,  { alp = 0, playing = 0 });
      end;
    end;
    
    if ( game.map_rooms[ key ][ 1 ] == 0 ) or
       ( ng_global.collect_found and ( ng_global.collect_found[ key ] == game.map_rooms[ key ][ 5 ] ) ) or
       not IsCollectorsEdition() and not IsSurveyEdition() or not ng_global.collect_found or
       game.map_rooms[ key ][ 5 ] == 0 or
       ( ng_global.gamemode == 1 ) or ( ng_global.gamemode == 2 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tasks == 0 ) then
       
      ObjSet( "spr_int_map_"..key.."_collect", { alp = 0 } );
    else 
      ObjSet( "spr_int_map_"..key.."_collect", { alp = 1 } );
    end;
    
    --DbgTrace(key.." "..game.map_rooms[ key ][ 1 ]);

    if game.map_rooms[ key ][ 1 ] == 0 then

      ObjSet( "spr_int_map_"..key.."_task", { alp = 1, res = "assets/interface/resources/map/unknown" } );

    elseif game.map_rooms[ key ][ 4 ] == 1 then

      ObjMultiSet( { {"spr_int_map_"..key.."_task", { alp = 1, res = "assets/interface/resources/map/blocked" }},
                     {"spr_int_map_"..key, { color_r = 0.4, color_g = 0.4, color_b = 0.4 }} } );

    elseif game.map_rooms[ key ][ 2 ] == 1 and not( ( ng_global.gamemode == 1 ) or ( ng_global.gamemode == 2 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tasks == 0 ) ) then

      ObjSet( "spr_int_map_"..key.."_task", { alp = 1, res = "assets/interface/resources/map/task_check" } );

    else

      --ObjSet( "spr_int_map_"..key.."_task", { alp = task_alp } );

      if not( ( ng_global.gamemode == 1 ) or ( ng_global.gamemode == 2 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tasks == 0 ) ) and private.CheckRoomTasks( key ) then
        ObjSet( "spr_int_map_"..key.."_task", { alp = 1, res = "assets/interface/resources/map/task" } );
      else
        ObjSet( "spr_int_map_"..key.."_task", { alp = 0, res = "assets/interface/resources/map/task" } );
      end;

    end;
    
    if game.map_rooms[ key ][ 4 ] == 0 then
      ObjSet("spr_int_map_"..key,  { color_r = 1, color_g = 1, color_b = 1 });
    end;

  end;

end;
--******************************************************************************************
function public.HideAnim( event_id )

  --DbgTrace( "***int_map_impl::public.HideAnim: event_id == "..event_id );

  PauseLevel( 0 );

  interface.RemoveIntFromList();

  local trg = function () int_map.EventAnimEnd( event_id ); end;
  local tme = private.HIDE_ANIM_TIME;

  common_impl.is_in_map = 0;

  ObjAnimate( "int_map", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_opn_cls_map");

end;
--******************************************************************************************
function public.MouseEnterMapIcon(room_name)

  SetCursor(CURSOR_HAND);

  local obj = "spr_int_map_"..room_name.."_focus";
  local alp = ObjGet( obj ).alp;
  local scale1 = ObjGet( obj ).scale_x;
  local tme = ( 1 - alp ) * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;

  local obj2 = "obj_int_map_"..room_name;
  local scale = ObjGet( obj2 ).scale_x;
  local tme2 = ( 0.1 - (scale - 1) ) * 10 * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;
  
  if tme > 0.13 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
  end;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  --ObjAnimate( obj, 6, 0, 0, "",
  --{
  --  0.0, 2, scale1, scale1, 
  --  tme2, 2, 1.1, 1.1
  --} );

  ObjAnimate( obj2, 6, 0, 0, "",
  {
    0.0, 2, scale, scale, 
    tme2, 2, 1.1, 1.1
  } );

  interface.PopupShow( "pop_"..cmn.GetObjectName( room_name ) );

end;
--******************************************************************************************
function public.MouseLeaveMapIcon(room_name)

  interface.PopupHide();

  SetCursor(CURSOR_DEFAULT);

  local obj = "spr_int_map_"..room_name.."_focus";
  local alp = ObjGet( obj ).alp;
  local scale1 = ObjGet( obj ).scale_x;
  local tme = alp * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;

  local obj2 = "obj_int_map_"..room_name;
  local scale = ObjGet( obj2 ).scale_x;
  local tme2 = ( scale - 1 ) * 10 * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  --ObjAnimate( obj, 6, 0, 0, "",
  --{
  --  0.0, 2, scale1, scale1, 
  --  tme2, 2, 1, 1
  --} );

  ObjAnimate( obj2, 6, 0, 0, "",
  {
    0.0, 2, scale, scale, 
    tme2, 2, 1, 1
  } );

end;
--******************************************************************************************
function public.CreateRooms( level )

  ObjAttach( "spr_int_map_back_"..level, "int_map_impl" );

  local map_room_obj = "";

  for key, value in pairs( game.map_rooms ) do

    map_room_obj = "spr_int_map_"..key;

    ObjSet( map_room_obj, { event_mup= function () cmn.ShowBbt('wrong_map_clk'); end });

  end;

  --for key, value in pairs( game.map_rooms ) do
  --  DbgTrace( "[ "..key.." ] = { "..value[1]..", "..value[2]..", "..value[3]..", "..value[4].." }");
  --end;

end;
--******************************************************************************************
function public.OpenRoom( room_name )

  game.map_rooms[ room_name ][ 1 ] = 1;

  game.map_rooms[ room_name ][ 4 ] = 0;

  ObjSet( "spr_int_map_"..room_name, { event_mup  = function () int_map_impl.ClkMapRoom(room_name) end,
                                       event_menter = function () int_map_impl.MouseEnterMapIcon(room_name) end, 
                                       event_mleave = function () int_map_impl.MouseLeaveMapIcon(room_name) end } );

  ObjSet( "spr_int_map_"..room_name, {alp = 1} );
  ObjSet( "spr_int_map_"..room_name.."_icon", {alp = 1} );

end;

function private.CheckRoomTasks( room_name )

  local hint_in_curroom = common_impl.FindCurrentHintPlace( room_name );

  if hint_in_curroom then
    return true;
  else 
    return false;
  end;

end;
--******************************************************************************************
function public.BlockRoom( room_name )

  game.map_rooms[ room_name ][ 4 ] = 1;

  ObjSet( "spr_int_map_"..room_name, { event_mup = function () cmn.ShowBbt('blocked_map_clk'); end } );

end;
--******************************************************************************************
function public.ClkMapRoom( room_name )

  if ( common_impl.is_in_map == 1 ) then

    if ( not game.map_rooms[ common.GetCurrentRoom() ] ) and ( room_name == common.GetPrevRoom() ) then

      int_map_impl.CloseLd();

    else
      
      int_map_impl.CloseLd();

      if room_name ~= common.GetCurrentRoom() then
        
        cmn.GotoRoom( room_name );
        
        if common.IsInSubRoom() then
          common.CloseSubRoom();
        end;
        
      end;

    end;

  end;

end;
--******************************************************************************************
function public.DecreaseRoomTasks(room_name)

  game.map_rooms[ room_name ][ 3 ] = game.map_rooms[ room_name ][ 3 ] - 1;

  if ( game.map_rooms[ room_name ][ 3 ] == 0 ) and ( game.map_rooms[ room_name ][ 2 ] == 0 ) then

    game.map_rooms[ room_name ][ 2 ] = 1;

    --ObjSet( "spr_int_map_"..room_name.."_task", { res = "assets/interface/resources/map/task_check" } );

  end;

end;
--******************************************************************************************
function public.AddRoomCollectible(room_name)
  
  if ng_global.collect_found then

    if ng_global.collect_found[ room_name ] then
      ng_global.collect_found[ room_name ] = ng_global.collect_found[ room_name ] + 1;
    else 
      ng_global.collect_found[ room_name ] = 1;
    end;
    
  end;

--  if ( ng_global.collect_found[ room_name ] == game.map_rooms[ room_name ][ 5 ] ) then
--
--    ObjSet( "spr_int_map_"..room_name.."_collect", { alp = 0 } );
--
--  end;

end;
--******************************************************************************************
function public.MouseEnterBack()

  SetCursor(CURSOR_HAND);

  local obj = "spr_int_map_impl_btn_back_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;
  
  if tme > 0.13 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
  end;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
------------------------------------------------------------------------------------
function public.MouseLeaveBack()

  SetCursor(CURSOR_DEFAULT);

  local obj = "spr_int_map_impl_btn_back_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.CloseLd()  --обертка

  ObjSet( "int_map", { input = 0 } );

  int_map.Close();

end;
--******************************************************************************************
function public.AddDiarypage( index )

  local pages_count = #ng_global.map_diary_notes[ ng_global.currentprogress ];
  local clone_check = false;

  for i = 1, pages_count, 1 do
  
    if ng_global.map_diary_notes[ ng_global.currentprogress ][i] == index then
      clone_check = true;
      break;
    end;
    
  end;

  if not clone_check then

    ng_global.map_diary_pages[ ng_global.currentprogress ] = pages_count + 1;
    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_pages[ ng_global.currentprogress ];

    ng_global.map_diary_notes[ ng_global.currentprogress ][ ng_global.map_diary_pages[ ng_global.currentprogress ] ] = index;

    private.AddDiaryPageAnim( index );

  end;

end;
--******************************************************************************************
function private.AddDiaryPageAnim()

  local fx_item = "spr_int_map_effect_add_page";

  if not ObjGet(fx_item) then

    local cur_note = cmn.GetCurrentNote();

    --if cur_note == "" then
    --  cur_note = common.GetCurrentSubRoom();
    --end;
    
    local pos_note;
    
    if cur_note == "" then
      pos_note = { 512, 384 };
    else 
      pos_note = GetObjPosByObj(cur_note);
    end;

    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_object_fly");

    ObjCreate( fx_item, "partsys" );
    ObjSet( fx_item, { res = "assets/interface/resources/map/fx/p_diary", pos_x = pos_note[1], pos_y = pos_note[2] } );
    ObjAttach(fx_item, GetCurrentRoom());
    
    --DbgTrace( ObjGet(fx_item).pos_x.." "..ObjGet(fx_item).pos_y );

    SendMessage( Command_Transporter_MoveObject,
    {
      type       = Trans_HintFly,
      obj_name   = fx_item,
      toobj_name = "spr_int_button_map_map",
      end_trig   = function () ObjDelete( fx_item ); end,
      --red_time   = 0.2
    } );
    
    --DbgTrace( ObjGet(fx_item).pos_x.." "..ObjGet(fx_item).pos_y );

  end;

end;
--******************************************************************************************
function public.ShowGlobalTask( inout )
  
  local obj = "spr_int_map_clock";
  local scale = ObjGet( obj ).scale_x;
  local alf = ObjGet( obj.."_glow" ).alp;
  
  local max_scale = 1.1;
  local max_tme = 0.3;
  local tme, end_scale;
  
  if ng_global.global_task_first > 0 then
  
    if inout == 1 then
      --SetCursor( CURSOR_HAND );
      end_scale = max_scale;
      tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
      interface.PopupShow( "str_global_task_"..ng_global.global_task_first );
    else 
      --SetCursor( CURSOR_DEFAULT );
      end_scale = 1;
      tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
      interface.PopupHide();
    end;
    
    ObjAnimate( obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale } );
    ObjAnimate( obj.."_glow", "alp", 0, 0, "", { 0, 0, alf,   tme, 0, inout });
    
  end;
  
end;
--******************************************************************************************
function public.FocusDiary( inout )
  
  local obj = "spr_int_map_note_journal";
  local scale = ObjGet( obj ).scale_x;
  
  local max_scale = 1.1;
  local max_tme = 0.3;
  local tme, end_scale;
  
  if inout == 1 then
    SetCursor( CURSOR_HAND );
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
    end;
  else 
    SetCursor( CURSOR_DEFAULT );
    end_scale = 1;
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  end;
  
  ObjAnimate( obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale } );
  
end;
--******************************************************************************************
function public.ShowDiary()

  ObjSet( "spr_int_map_diary_back", { input = 1 } );
  ObjSet( "obj_int_map_impl_close", { input = 0, event_mup = int_map_impl.HideDiary } );
  ObjSet( "obj_int_map_impl_btn_back", { event_mup = int_map_impl.HideDiary } );

  local trg = function () ObjSet("obj_int_map_impl_close", { input = 1 } ); ObjSet("spr_int_map_note_journal_glow", { alp = 0 } ); end;

  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "spr_int_map_diary_back", 8, 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_opn_journal");

  int_map_impl.SetDiary();

end;
--******************************************************************************************
function public.HideDiary()

  ObjSet( "spr_int_map_diary_back", { input = 0 } );
  ObjSet( "obj_int_map_impl_close", { input = 0, event_mup = int_map_impl.CloseLd } );
  ObjSet( "obj_int_map_impl_btn_back", { event_mup = int_map_impl.CloseLd } );

  local trg = function () ObjSet("obj_int_map_impl_close", { input = 1 } ); end;

  local tme = private.HIDE_ANIM_TIME;

  ObjAnimate( "spr_int_map_diary_back", 8, 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_cls_journal");

end;
--******************************************************************************************
function public.SetDiary()

  --DbgTrace("***int.map.SetDiary current_page = "..ng_global.map_diary_current_page..", pages = "..ng_global.map_diary_pages);
  
    if ng_global.map_diary_notes_read[ ng_global.currentprogress ] then
      ng_global.map_diary_notes_read[ ng_global.currentprogress ] = #ng_global.map_diary_notes[ ng_global.currentprogress ];
      ObjStopAnimate("spr_int_map_note_journal_glow", "alp");
    end;

    local page_num = ng_global.map_diary_current_page[ ng_global.currentprogress ];

    if ( math.fmod( page_num, 2 ) == 0 ) then
      page_num = page_num - 1;
    end;

    if ( page_num > 1 ) then
      ObjSet( "obj_int_map_btn_left", { input = 1 } );
      ObjSet( "spr_int_map_btn_left_na", { alp = 0 } );
    else
      ObjSet( "obj_int_map_btn_left", { input = 0 } );
      ObjSet( "spr_int_map_btn_left_na", { alp = 1 } );
    end;

    if ( ( page_num + 1 ) < ng_global.map_diary_pages[ ng_global.currentprogress ] ) then
      ObjSet( "obj_int_map_btn_right", { input = 1 } );
      ObjSet( "spr_int_map_btn_right_na", { alp = 0 } );
    else
      ObjSet( "obj_int_map_btn_right", { input = 0 } );
      ObjSet( "spr_int_map_btn_right_na", { alp = 1 } );
    end;

  if ng_global.map_diary_pages[ ng_global.currentprogress ] ~= 0 then

    ObjMultiSet( { {"txt_int_map_diary_page_left", { text = page_num }},
                   {"txt_int_map_diary_page_right", { text = page_num + 1 }} } );

    ObjMultiSet( { {"txt_int_map_diary_left", { alp = 1, text = "str_diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }},
                   {"spr_int_map_diary_left", { alp = 1, res = "assets/interface/resources/map/map_diary/diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }},
                   {"spr_int_map_diary_left_back", { alp = 1 }},
                   {"spr_int_map_diary_left_pin", { alp = 1 }} } );

    if ( page_num < ng_global.map_diary_pages[ ng_global.currentprogress ] ) then

      page_num = page_num + 1;

      ObjMultiSet( { {"txt_int_map_diary_right", { alp = 1, text = "str_diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }},
                     {"spr_int_map_diary_right", { alp = 1, res = "assets/interface/resources/map/map_diary/diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }},
                     {"spr_int_map_diary_right_back", { alp = 1 }},
                     {"spr_int_map_diary_right_pin", { alp = 1 }} } );

    else

      ObjMultiSet( { {"txt_int_map_diary_right", { alp = 0 }},
                     {"spr_int_map_diary_right", { alp = 0 }},
                     {"spr_int_map_diary_right_back", { alp = 0 }},
                     {"spr_int_map_diary_right_pin", { alp = 0 }} } );

    end;

  else 

    ObjMultiSet( { {"txt_int_map_diary_left", { alp = 0 }},
                   {"spr_int_map_diary_left", { alp = 0 }},
                   {"spr_int_map_diary_left_back", { alp = 0 }},
                   {"spr_int_map_diary_left_pin", { alp = 0 }} } );

  end;

  ObjAnimate( "obj_int_map_diary", 8,0,0, "", { 0,0,0, 0.3,0,1 } );

end;
--******************************************************************************************
function public.MouseClkBtnDiary( side )

  ObjSet( "obj_int_map_btn_"..side, { input = 0 } );

  if ( side == "left" ) then

    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_current_page[ ng_global.currentprogress ] - 2;

  elseif ( side == "right" ) and ( math.fmod( ng_global.map_diary_current_page[ ng_global.currentprogress ], 2 ) == 0 ) then

    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_current_page[ ng_global.currentprogress ] + 1;

  elseif ( side == "right" ) and ( math.fmod( ng_global.map_diary_current_page[ ng_global.currentprogress ], 2 ) ~= 0 ) then

    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_current_page[ ng_global.currentprogress ] + 2;

  end

  ObjAnimate( "obj_int_map_diary", 8,0,0, int_map_impl.SetDiary, { 0,0,1, 0.3,0,0 } );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_page");

end;
--******************************************************************************************
function public.MouseEnterBtnDiary( side )

  SetCursor(CURSOR_HAND);

  local obj = "spr_int_map_btn_"..side.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.3;
  
  if tme > 0.13 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
  end;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function public.MouseLeaveBtnDiary( side )

  SetCursor(CURSOR_DEFAULT);

  local obj = "spr_int_map_btn_"..side.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * 0.3;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--*************************************************************************************