-- name=int_taskpanel_impl
--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  private.TASK_COLOR_R = 1;
  private.TASK_COLOR_G = 1;
  private.TASK_COLOR_B = 1;

  private.TASK_MARKED_COLOR_R = 0.517647;
  private.TASK_MARKED_COLOR_G = 0.835294;
  private.TASK_MARKED_COLOR_B = 0.960784;

  private.TASK_COMPLETED_COLOR_R = 0.552941;
  private.TASK_COMPLETED_COLOR_G = 0.454902;
  private.TASK_COMPLETED_COLOR_B = 0.443137;

  private.MOVE_ANIM_TIME      = 0.6;
  private.MOVE_ANIM_POS_Y_TOP = 500;
  private.MOVE_ANIM_POS_Y_BOT = 1000;

  local pos_offset = 0;
  private.TASKHEADER_MOVE_ANIM_TIME_BEG  = int_taskheader_impl.MOVE_ANIM_TIME_BEG;
  private.TASKHEADER_MOVE_ANIM_TIME_END  = int_taskheader_impl.MOVE_ANIM_TIME_END;
  private.TASKHEADER_MOVE_ANIM_POS_Y_TOP = int_taskheader_impl.MOVE_ANIM_POS_Y_TOP + pos_offset;
  private.TASKHEADER_MOVE_ANIM_POS_Y_BOT = int_taskheader_impl.MOVE_ANIM_POS_Y_BOT + pos_offset;

  private.CHANGE_TASK_ALP_TIME = 0.3; --время анимации замены тасков по альфе во время перехода на следующую стадию хо

  public.HO_TASK_NEW = {};   --таблица новых тасков при замене

  private.ICONS_POS_Y = 70;  --параметры иконок для хошек с парами
  private.MOVE_ICON_ANIM_POS_X_START = 360;
  private.MOVE_ICON_ANIM_POS_X_END = 200;
  private.ICON_LINE_SPR_REAL_WIDTH = 152;
  private.ICON_LINE_OFFSET = 10;

  ObjAttach( "obj_int_taskpanel_collect", InterfaceWidget_Top_Name );

  private.task_line_pos_x_offset = 81;
  private.task_line_pos_y_offset = 11;


  private.PANEL_DOORS_1_MOVE_ANIM_POS_Y_TOP =  89;  --параметры для панели дверей
  private.PANEL_DOORS_1_MOVE_ANIM_POS_Y_BOT = 187;
  private.PANEL_DOORS_2_MOVE_ANIM_POS_Y_TOP =  89;
  private.PANEL_DOORS_2_MOVE_ANIM_POS_Y_BOT = 180;
  private.PANEL_DOORS_DRAG_OBJ = "";
  private.PANEL_DOORS_DRAG_OBJ_PARENT = "";

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 2, beg_y,--private.MOVE_ANIM_POS_Y_BOT,
    tme, 2, private.MOVE_ANIM_POS_Y_TOP
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y; 

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 1, beg_y,--private.MOVE_ANIM_POS_Y_TOP,
    tme, 1, private.MOVE_ANIM_POS_Y_BOT
  } );

end;
--******************************************************************************************
function public.TaskHeaderShowAnim( event_id )

  --DbgTrace( "***int_taskpanel_impl::public.TaskHeaderShowAnim: event_id = "..event_id );

  ObjStopAnimate( "obj_int_taskpanel_collect", "pos_y" );
  ObjSet( "obj_int_taskpanel_collect", { pos_y = 0 } );

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme_beg = private.TASKHEADER_MOVE_ANIM_TIME_BEG;
  local tme_end = private.TASKHEADER_MOVE_ANIM_TIME_END;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0,     0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
    tme_beg, 0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
    tme_end, 2, private.TASKHEADER_MOVE_ANIM_POS_Y_TOP
  } );

  -----------------------

  local room = GetCurrentRoom();
  local room_name = common.GetObjectName( room );
  --DbgTrace( "***int_taskpanel_impl.TaskHeaderShowAnim: event_id = "..event_id..", room = "..room );

  local panel_icons_obj_name = "obj_"..room_name.."_panel_icons";

  if ( ObjGet( panel_icons_obj_name ) ) then

    ObjSet( panel_icons_obj_name, { pos_y = private.ICONS_POS_Y } );

    ObjAttach( panel_icons_obj_name, "spr_int_taskpanel" );

  end;

  if ( _G[ room ].changed_name ) and ( _G[ room ].changed_name[1] ~= "" ) then

    local panel_icon_spr_name = _G[ room ].changed_name[1].."_panel_icon";

    if ( ObjGet( panel_icon_spr_name ) ) then

      ObjSet( panel_icon_spr_name, { pos_x = -private.MOVE_ICON_ANIM_POS_X_END, alp = 1 } );

    end;

  end;

  ------------------------

  private.SetPanelDoors( room_name );

  ------------------------

  if ( _G[ room ].task_count_show ) then

    local task_count_show_num = _G[ room ].task_count_show - #ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].found;

    ObjMultiSet( {
      { "obj_int_taskpanel", { pos_x = -140 } },
      { "spr_int_taskpanel", { alp = 0, input = false } },
      { "txt_int_taskpanel_header_text", { alp = 0 } },
      { "spr_int_taskpanel_small", { alp = 1, input = true } },
      { "txt_int_taskpanel_task_count_text", { text = task_count_show_num } }
    } );

    --DbgTrace( "task_count_show_num = "..task_count_show_num );

  else

    ObjMultiSet( {
      { "obj_int_taskpanel", { pos_x = -246 } },
      { "spr_int_taskpanel", { alp = 1, input = true } },
      { "txt_int_taskpanel_header_text", { alp = 1 } },
      { "spr_int_taskpanel_small", { alp = 0, input = false } }
    } );

  end;

end;
--******************************************************************************************
function public.TaskHeaderHideAnim( event_id )

  local obj = "int_taskpanel_impl";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme_beg = ( private.TASKHEADER_MOVE_ANIM_TIME_END - private.TASKHEADER_MOVE_ANIM_TIME_BEG );
  local tme_end = private.TASKHEADER_MOVE_ANIM_TIME_END;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0,     0, beg_y,--private.TASKHEADER_MOVE_ANIM_POS_Y_TOP,
    tme_beg, 1, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
    tme_end, 0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT
  } );

  ObjAnimate( "obj_int_taskpanel_collect", "pos_y", 0, 0, "",
  {
    0.0,     0, 0,
    tme_beg, 1, ( private.TASKHEADER_MOVE_ANIM_POS_Y_BOT - private.TASKHEADER_MOVE_ANIM_POS_Y_TOP )
  } );

end;
--******************************************************************************************
function private.CompleteTaskAnimEnd( task_hub_obj_name, task_count, event_id )
  
  --Trace( "***int_taskpanel_impl::private.CompleteTaskAnimEnd: task_hub_obj_name = "..task_hub_obj_name );

  local fx_task = task_hub_obj_name.."_effect";

  local trg_del = function () ObjDelete(fx_task); end;

  local trg_end = function () int_taskpanel.EventAnimEnd( event_id ); end;

  ObjCreate( fx_task, "partsys" );
  ObjSet( fx_task, { res = "assets/interface/resources/fx/ho_item_list" } );
  ObjAttach( fx_task, task_hub_obj_name );

  ObjAnimate( fx_task, "alp", 0, 0, trg_del,
  {
    0.0, 0, 0,
    0.3, 0, 1,
    0.6, 0, 0
  } );

  --local line_scale_x = ( ObjGet( "txt_"..cmn.GetObjectName( task_hub_obj_name ) ).draw_width + int.taskpanel.ICON_LINE_OFFSET ) / int.taskpanel.ICON_LINE_SPR_REAL_WIDTH;

  ObjSet( task_hub_obj_name.."_line", { scale_x = 0.526,
                                color_r = private.TASK_COMPLETED_COLOR_R,
                                color_g = private.TASK_COMPLETED_COLOR_G,
                                color_b = private.TASK_COMPLETED_COLOR_B } );--scale_x = line_scale_x

  ObjAnimate( task_hub_obj_name.."_line", "alp", 0, 0, trg_end,
  {
    0.0, 0, 0,
    0.3, 0, 0.7
  } );

end;
--******************************************************************************************
function public.CompleteTaskAnim( task_name, item_name, task_id, task_count, event_id )
  
  --DbgTrace( "***int_taskpanel_impl::private.CompleteTaskAnim: task_name = "..task_name );

  local task_hub_obj_name = "obj_int_taskpanel_task_"..task_id;

  local trg;
  
  if ( int_taskpanel_impl.IsTaskImg( task_name ) ) then
    
    trg = function () int_taskpanel.EventAnimEnd( event_id ); end;
    
  elseif ( task_count ~= 0 ) then
    
    trg = function ()
      ObjSet( "txt_int_taskpanel_task_"..task_id, { param4 = int_taskpanel.task_params[ task_id ].count } );
    end;
    
  else
    
    trg = function () private.CompleteTaskAnimEnd( task_hub_obj_name, task_count, event_id ); end;
    
  end;

  local fx_item = item_name.."_effect_"..task_count;

  ObjCreate( fx_item, "partsys" );
  ObjSet( fx_item, { res = "assets/interface/resources/fx/ho_get_obj"  } );
  ObjAttach( fx_item, item_name );

  int_taskpanel.StdFlyAnimation( fx_item, task_hub_obj_name, function () ObjDelete( fx_item ); end );
  int_taskpanel.StdFlyAnimation( item_name, task_hub_obj_name, trg, 0.2 );

end;
--******************************************************************************************
function public.SetTask( task_id, task_params )
  
  --DbgTrace(
  --  "***int_taskpanel_impl::public.SetTask: task_id == "..task_id..
  --  ", task_params: name == "..task_params.name..
  --  ", count == "..task_params.count..
  --  ", marked == "..task_params.marked
  --);

  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;

  if ( task_params.count < 1 ) then

    task_color_r = private.TASK_COMPLETED_COLOR_R;
    task_color_g = private.TASK_COMPLETED_COLOR_G;
    task_color_b = private.TASK_COMPLETED_COLOR_B;    

  end;

  if ( task_params.marked == 1 ) then

    task_color_r = private.TASK_MARKED_COLOR_R;
    task_color_g = private.TASK_MARKED_COLOR_G;
    task_color_b = private.TASK_MARKED_COLOR_B;

  end;

  local task_pattern = "str_int_taskpanel_pattern";

  if ( task_params.count > 1 ) then

    task_pattern = "str_int_taskpanel_pattern_multiple";

  end;

  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    text   = task_pattern,
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b,
    param3 = StringGet( task_params.name ),
    param4 = task_params.count,
    alp = 1
  } );

  if ( task_params.count < 1 ) then

    --local line_scale_x = ( ObjGet( "txt_int_taskpanel_task_"..task_id ).draw_width + int.taskpanel.ICON_LINE_OFFSET ) / int.taskpanel.ICON_LINE_SPR_REAL_WIDTH;

    ObjSet( "obj_int_taskpanel_task_"..task_id.."_line", { scale_x = 0.526, alp = 0.7,
                                                           color_r = private.TASK_COMPLETED_COLOR_R,
                                                           color_g = private.TASK_COMPLETED_COLOR_G,
                                                           color_b = private.TASK_COMPLETED_COLOR_B } );--scale_x = line_scale_x,

  else

    ObjStopAnimate( "obj_int_taskpanel_task_"..task_id.."_line", 8 );

    ObjSet( "obj_int_taskpanel_task_"..task_id.."_line", { alp = 0 } );

  end;

end;
--******************************************************************************************
function public.SetTaskImg( task_id, task_name )
  
  --DbgTrace( "***int_taskpanel_impl::public.SetTaskImg: task_id = "..task_id..", task_name = "..task_name );
  
  local obj_task_img = "spr_"..common.GetObjectName( task_name ).."_task_img";

  ObjAttach( obj_task_img, "obj_int_taskpanel_task_"..task_id );
  
  ObjSet( "txt_int_taskpanel_task_"..task_id, { alp = 0 } );
  
  ObjStopAnimate( "obj_int_taskpanel_task_"..task_id.."_line", 8 );
  ObjSet( "obj_int_taskpanel_task_"..task_id.."_line", { alp = 0 } );

end;
--******************************************************************************************
function public.UnmarkTaskAnim( task_id, event_id )

  local task_color_r = private.TASK_COLOR_R;
  local task_color_g = private.TASK_COLOR_G;
  local task_color_b = private.TASK_COLOR_B;

  ObjSet( "txt_int_taskpanel_task_"..task_id,
  {
    param0 = task_color_r,
    param1 = task_color_g,
    param2 = task_color_b
  } );

end;
--******************************************************************************************
function public.MarkTaskAnim( task_id, event_id )

  --

end;
--******************************************************************************************
function public.SetNewTaskAnim()

  local ho_name = common.GetObjectName( GetCurrentRoom() );

  if ( _G[ "ho_"..ho_name ].change_stage_anim_type ) and ( _G[ "ho_"..ho_name ].change_stage_anim_type == "alp" ) then

    local trg = function () private.SetNewTaskAnimBeg( "alp" ); end;

    ObjAnimate( "obj_int_taskpanel_tasks", "alp", 0, 0, trg,
    {
      0.0,                                0, 1,
      private.CHANGE_TASK_ALP_TIME, 0, 0
    } );

  else

    local trg = private.SetNewTaskAnimBeg;

    local tme_end = ( private.TASKHEADER_MOVE_ANIM_TIME_END - private.TASKHEADER_MOVE_ANIM_TIME_BEG );

    ObjAnimate( "int_taskpanel_impl", "pos_y", 0, 0, trg,
    {
      0.0,     0, ObjGet( "int_taskpanel_impl" ).pos_y,
      tme_end, 1, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT
    } );
    
    if ObjGet( "int_inventory_impl" ) then

      ObjAnimate( "int_inventory_impl", "pos_y", 0, 0, "",
      {
        0.0,     0, ObjGet( "int_inventory_impl" ).pos_y,
        tme_end, 1, int_inventory_impl.TASKHEADER_MOVE_ANIM_POS_Y_BOT
      } );
      
    end;

    ObjAnimate( "int_taskheader_impl", "pos_y", 0, 0, "",
    {
      0.0,     0, ObjGet( "int_taskheader_impl" ).pos_y,
      tme_end, 1, int_taskheader_impl.MOVE_ANIM_POS_Y_BOT
    } );

  end;

end;
--******************************************************************************************
function private.SetNewTaskAnimBeg( change_stage_anim_type )
  
  --DbgTrace( "***int_taskpanel_impl::private.SetNewTaskAnimBeg: change_stage_anim_type = "..tostring(change_stage_anim_type) );

  change_stage_anim_type = change_stage_anim_type or "default";

  int_taskpanel.already_hide = false;

  local ho_tasks = public.HO_TASK_NEW;

  --DbgTrace( "tasks count: "..#ho_tasks );

  int_taskpanel.task_id     = {};
  int_taskpanel.task_params = {};

  for i = 1, #ho_tasks, 1 do

    local task_name   = ho_tasks[ i ][ "name"   ];
    local task_count  = ho_tasks[ i ][ "count"  ];
    local task_marked = ho_tasks[ i ][ "marked" ];

    int_taskpanel.task_id[ task_name ] = i;
    int_taskpanel.task_params[ i ] =
    {
      name   = task_name,
      count  = task_count,
      marked = task_marked
    };

    if ( int_taskpanel_impl.IsTaskImg( task_name ) ) then
      int_taskpanel_impl.SetTaskImg( i, task_name );
    else
      int_taskpanel_impl.SetTask( i, int_taskpanel.task_params[ i ] );
    end;

  end;

  for i = #ho_tasks + 1, 12, 1 do

    ObjSet( "txt_int_taskpanel_task_"..i, { alp = 0 } );

    ObjSet( "obj_int_taskpanel_task_"..i.."_line", { alp = 0 } );

  end;

  public.SetTaskPos( #ho_tasks );


  local trg = private.SetNewTaskAnimEnd;


  if ( change_stage_anim_type == "alp" ) then

    ObjAnimate( "obj_int_taskpanel_tasks", "alp", 0, 0, trg,
    {
      0.0,                          0, 0,
      private.CHANGE_TASK_ALP_TIME, 0, 1
    } );

  else

    local tme_end = private.TASKHEADER_MOVE_ANIM_TIME_BEG;

    ObjAnimate( "int_taskpanel_impl", "pos_y", 0, 0, trg,
    {
      0.0,     0, private.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
      tme_end, 2, private.TASKHEADER_MOVE_ANIM_POS_Y_TOP
    } );
    
    if _G["int_inventory_impl"] then

      ObjAnimate( "int_inventory_impl", "pos_y", 0, 0, "",
      {
        0.0,     0, int_inventory_impl.TASKHEADER_MOVE_ANIM_POS_Y_BOT,
        tme_end, 2, int_inventory_impl.TASKHEADER_MOVE_ANIM_POS_Y_TOP
      } );
      
    end;

    ObjAnimate( "int_taskheader_impl", "pos_y", 0, 0, "",
    {
      0.0,     0, int_taskheader_impl.MOVE_ANIM_POS_Y_BOT,
      tme_end, 2, int_taskheader_impl.MOVE_ANIM_POS_Y_TOP
    } );

  end;

end;
--******************************************************************************************
function private.SetNewTaskAnimEnd()

  public.HO_TASK_NEW = {};

  --int.WidgetSetInput( InterfaceWidget_Inventory, 1 );
  cmn.Lock( 0 );

end;
--******************************************************************************************
function public.SetTaskPos( task_num )

  ObjSet( "obj_int_taskpanel_tasks_line_1", { pos_x = 0 } );
  ObjSet( "obj_int_taskpanel_tasks_line_2", { pos_x = 0 } );
  ObjSet( "obj_int_taskpanel_tasks_line_3", { pos_x = 0 } );

  local task_line_num = math.ceil( task_num / 4 );

  local last_line_task_num = task_num - 4 * ( task_line_num - 1 );

  local tasks_pos_y = -private.task_line_pos_y_offset * ( task_line_num - 1 );

  ObjSet( "obj_int_taskpanel_tasks", { pos_y = tasks_pos_y } );

  local tasks_last_line_pos_x = private.task_line_pos_x_offset * ( 3 - ( last_line_task_num - 1 ) );

  ObjSet( "obj_int_taskpanel_tasks_line_"..task_line_num, { pos_x = tasks_last_line_pos_x } );

end;
--******************************************************************************************
function public.IconShowAnim()
  
  local room =  GetCurrentRoom();

  if ( _G[ room ].changed_name ) and ( _G[ room ].changed_name[1] ~= "" ) and ( _G[ room ].changed_name[2] == "" ) then

    local panel_icon_spr_name = _G[ room ].changed_name[1].."_panel_icon";

    if ( ObjGet( panel_icon_spr_name ).name ) then

      ObjSet( panel_icon_spr_name, { pos_x = -private.MOVE_ICON_ANIM_POS_X_START, alp = 0 } );
      
      ObjAnimate( panel_icon_spr_name, "pos_x", 0, 0, "", {   0, 0, -private.MOVE_ICON_ANIM_POS_X_START,
                                                            0.3, 0, -private.MOVE_ICON_ANIM_POS_X_END    } );

      ObjAnimate( panel_icon_spr_name, "alp",   0, 0, "", {   0, 0, 0,    0.3, 0, 1 } );

    end;

  elseif ( _G[ room ].changed_name ) and ( _G[ room ].changed_name[1] ~= "" ) and ( _G[ room ].changed_name[2] ~= "" ) then

    local panel_icon_spr_name = _G[ room ].changed_name[2].."_panel_icon";

    if ( ObjGet( panel_icon_spr_name ).name ) then

      ObjSet( panel_icon_spr_name, { pos_x = private.MOVE_ICON_ANIM_POS_X_START, active = 1, visible = 1, alp = 0 } );
      
      ObjAnimate( panel_icon_spr_name, "pos_x", 0, 0, "", {   0, 0, private.MOVE_ICON_ANIM_POS_X_START,
                                                            0.3, 0, private.MOVE_ICON_ANIM_POS_X_END    } );

      ObjAnimate( panel_icon_spr_name, "alp",   0, 0, "", {   0, 0, 0,    0.3, 0, 1 } );

    end;

  end;

end;
--******************************************************************************************
function public.IconHideAnim()

  local room = GetCurrentRoom();

  if ( _G[ room ].changed_name ) and ( _G[ room ].changed_name[1] ~= "" ) then

    local panel_icon_spr_name = _G[ room ].changed_name[1].."_panel_icon";

    if ( ObjGet( panel_icon_spr_name )) then

      ObjAnimate( panel_icon_spr_name, "alp",   0, 0, "", {   0, 0, 1,    0.3, 0, 0 } );

    end;

  end;

  if ( _G[ room ].changed_name ) and ( _G[ room ].changed_name[2] ~= "" ) then

    local panel_icon_spr_name = _G[ room ].changed_name[2].."_panel_icon";

    if ( ObjGet( panel_icon_spr_name ) ) then

      ObjAnimate( panel_icon_spr_name, "alp",   0, 0, "", {   0, 0, 1,    0.3, 0, 0 } );

    end;

  end;

end;
--******************************************************************************************
function public.IsTaskImg( task_id )
  
  --DbgTrace("***int_taskpanel_impl::public.IsTaskImg: task_id = "..task_id);
  
  local room = "ho_"..string.match( task_id, ".*_(.*)_.*" );
  local task_name = string.match( task_id, ".*_.*_(.*)" );
  
  if ( _G[ room ].tasks_img ) then
    for i = 1, #_G[ room ].tasks_img, 1 do
      if ( _G[ room ].tasks_img[i] == task_name ) then
        return true;
      end;
    end;
  end;
  
  return false;

end;
--******************************************************************************************
function public.ShowedTaskCountNumSet( ho_name )

  local task_count_show_num = _G[ "ho_"..ho_name ].task_count_show - #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;

  ObjSet( "txt_int_taskpanel_task_count_text", { text = task_count_show_num } );

  --DbgTrace( "task_count_show_num = "..task_count_show_num );

end;
--*********************************************************************************************************************
--***function *** PANEL DOORS *** () end*******************************************************************************
--*********************************************************************************************************************
function public.OpenPanelDoorAnim( num, stage, room_name, trg )

  room_name = room_name or common.GetObjectName( GetCurrentRoom() );

  --DbgTrace( "***int_taskpanel_impl.OpenPanelDoorAnim: num = "..num..", stage = "..stage..", room_name = "..room_name..", trg = "..tostring(trg) );

  local obj = "spr_int_taskpanel_panel_doors_"..stage..num;

  if ( stage == 1 ) then

    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_use_part_inventory");

    ObjAnimate( "spr_"..room_name.."_panel_doors_sil_"..num.."_done", "alp", 0, 0, "", { 0.0, 0, 0,   0.3, 0, 1 } );

    ObjAnimate( obj, "pos_y", 0, 0, trg,
    {
      0.0, 0, private.PANEL_DOORS_1_MOVE_ANIM_POS_Y_TOP,
      0.3, 0, private.PANEL_DOORS_1_MOVE_ANIM_POS_Y_TOP,
      0.8, 1, private.PANEL_DOORS_1_MOVE_ANIM_POS_Y_BOT
    } );

  elseif ( stage == 2 ) then

    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_xx_slide1");

    for i = 1, 12, 1 do
      if ( (((i-1)%4)+1) == num ) then
        ObjAnimate( "txt_int_taskpanel_task_"..i,          "alp", 0, 0, "", { 0.0, 0, 1,     0.3, 0, 0 } );
        ObjAnimate( "obj_int_taskpanel_task_"..i.."_line", "alp", 0, 0, "", { 0.0, 0, 0.7,   0.3, 0, 0 } );
      end;
    end;

    ObjAnimate( obj, "pos_y", 0, 0, function () ObjSet( "spr_int_taskpanel_panel_doors_3"..num, { input = 1 } ); end,
    {
      0.0, 0, private.PANEL_DOORS_2_MOVE_ANIM_POS_Y_TOP,
      0.3, 0, private.PANEL_DOORS_2_MOVE_ANIM_POS_Y_TOP,
      0.8, 1, private.PANEL_DOORS_2_MOVE_ANIM_POS_Y_BOT
    } );

  elseif ( stage == 3 ) then

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );

  end;

end;
--******************************************************************************************
function public.IsAllPanelDoorsItmUsed( room_name )

  room_name = room_name or common.GetObjectName( GetCurrentRoom() );

  local panel_doors = ng_global.progress[ prg.current ][ "win_"..room_name ].panel_doors;

  local all_panel_doors_itm_used = true;

  for i = 1, 4, 1 do
    if ( panel_doors[ i ] ~= 3 ) then
      all_panel_doors_itm_used = false;
      break;
    end;
  end;

  --DbgTrace( "***int_taskpanel_impl.IsAllPanelDoorsItmUsed: room_name = "..room_name..", all_itm_used = "..tostring(all_panel_doors_itm_used) );

  return all_panel_doors_itm_used;

end;
--******************************************************************************************
function private.SetPanelDoors( room_name )

  local panel_doors = ng_global.progress[ prg.current ][ "win_"..room_name ].panel_doors;

  --DbgTrace( "***int_taskpanel_impl.SetPanelDoors: room_name = "..room_name..", panel_doors = "..tostring( panel_doors ) );

  if ( panel_doors ) then

    ObjMultiSet( { { "spr_int_taskpanel_substrate",     { alp = 0 } },
                   { "obj_int_taskpanel_panel_doors_1", { alp = 1 } },
                   { "obj_int_taskpanel_panel_doors_2", { alp = 1, input = true } } } );

    if ( not int_taskpanel_impl.IsAllPanelDoorsItmUsed( room_name ) ) then

      --DbgTrace( "panel_doors = { "..panel_doors[1]..", "..panel_doors[2]..", "..panel_doors[3]..", "..panel_doors[4].." }" );

      for i = 1, 4, 1 do

        ObjAttach( "spr_"..room_name.."_panel_doors_itm_"..i, "spr_int_taskpanel_panel_doors_3"..i );

        if ( panel_doors[i] == 0 ) then

          ObjSet( "spr_int_taskpanel_panel_doors_1"..i, { alp = 1 } );
          ObjSet( "spr_int_taskpanel_panel_doors_2"..i, { alp = 1 } );
          ObjSet( "spr_int_taskpanel_panel_doors_3"..i, { alp = 1, input = 0 } );

          ObjAttach( "spr_"..room_name.."_panel_doors_sil_"..i, "spr_int_taskpanel_panel_doors_1"..i );

        elseif ( panel_doors[i] == 1 ) then

          ObjSet( "spr_int_taskpanel_panel_doors_1"..i, { alp = 0 } );
          ObjSet( "spr_int_taskpanel_panel_doors_2"..i, { alp = 1 } );
          ObjSet( "spr_int_taskpanel_panel_doors_3"..i, { alp = 1, input = 0 } );

        elseif ( panel_doors[i] >= 2 ) then

          ObjSet( "spr_int_taskpanel_panel_doors_1"..i, { alp = 0 } );
          ObjSet( "spr_int_taskpanel_panel_doors_2"..i, { alp = 0 } );
          ObjSet( "spr_int_taskpanel_panel_doors_3"..i, { alp = 1, input = 1 } );

        end;

      end;

    end;

  else

    ObjMultiSet( { { "spr_int_taskpanel_substrate",     { alp = 0 } },
                   { "obj_int_taskpanel_panel_doors_1", { alp = 0 } },
                   { "obj_int_taskpanel_panel_doors_2", { alp = 0, input = false } } } );

  end;

end;
--******************************************************************************************
function public.PanelDoorsObjStartDrag( obj_name )

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");

  private.PANEL_DOORS_DRAG_OBJ        = obj_name;
  private.PANEL_DOORS_DRAG_OBJ_PARENT = ObjGetRelations( obj_name ).parent;

  --DbgTrace("***int_taskpanel_impl.PanelDoorsObjStartDrag: obj_name = "..obj_name..", parent = "..private.PANEL_DOORS_DRAG_OBJ_PARENT);

  ObjAttach( obj_name, InterfaceWidget_Top_Name );

end;
--******************************************************************************************
function public.PanelDoorsObjDragDrop()

  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_use_part_inventory");

  --DbgTrace("***int_taskpanel_impl.PanelDoorsObjDragDrop: obj_name = "..private.PANEL_DOORS_DRAG_OBJ..", parent = "..private.PANEL_DOORS_DRAG_OBJ_PARENT);

  ObjAttach( private.PANEL_DOORS_DRAG_OBJ, private.PANEL_DOORS_DRAG_OBJ_PARENT );

  private.PANEL_DOORS_DRAG_OBJ = "";
  private.PANEL_DOORS_DRAG_OBJ_PARENT = "";

end;
--****************************************************************************************