-- name=interface_impl

function public.Init ()

  private.InitGlobalConstant();

  --создаем объект для блока
  ObjCreate( "obj_int_top_lock", "obj" );
  ObjAttach( "obj_int_top_lock", "int_top" );
  ObjSet( "obj_int_top_lock", { pos_z = 1000, inputrect_init = true, inputrect_x = -171, inputrect_w = 5000, inputrect_h = 5000, input = false } );

end;
--*********************************************************************************************************************
function private.InitGlobalConstant()

  InterfaceWidget_DialogHint = "InterfaceWidget_DialogHint";

--commands

  Command_DialogHint_Show = "Command_DialogHint_Show";
  Command_DialogHint_Hide = "Command_DialogHint_Hide";
  
end;
--*********************************************************************************************************************
--***function *** DialogHint *** () end*********************************************************************************
--*********************************************************************************************************************
  function public.DialogHintAdd( pos_z )

    interface.CustomWidgetAdd( InterfaceWidget_DialogHint, "assets/interface/int_dialog_hint", "int_dialog_hint", pos_z );

  end;
  -------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------
  function public.DialogHintShow( dlg_room )

    MsgSend( Command_DialogHint_Show, { room = dlg_room } );

  end;
  -------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------
  function public.DialogHintHide()

    MsgSend(Command_DialogHint_Hide);

  end;
--*********************************************************************************************************************
--***function *** TaskPanel *** () end*********************************************************************************
--*********************************************************************************************************************
  function public.TaskPanelSetNewTask( ho_tasks )

    cmn.Lock(1, { room = 1 }); 

    --int.WidgetSetInput( InterfaceWidget_Inventory, 0 );

    --if (ho_tasks) then
    --  DbgTrace("ho_tasks exist");
    --end;

    public.taskpanel_countdown = 0;

    local ho_name = cmn.GetObjectName( GetCurrentRoom() );

    for i = 1, #ho_tasks, 1 do

      local task_name = ho_tasks[ i ][ "name" ];

      ho_tasks[ i ][ "name" ] = interface.TaskPanelGetTaskId( ho_name, task_name );

      public.taskpanel_countdown = public.taskpanel_countdown + ho_tasks[ i ][ "count" ];

    end;

    --if (ho_tasks) then
    --  DbgTrace("ho_tasks exist");
    --else 
    --  DbgTrace("ho_tasks does not exist");
    --end;

    int_taskpanel.Show( ho_tasks, true, true);

  end;
--*********************************************************************************************************************
  public.taskpanel_countdown = 0;
  -------------------------------------------------------------------------------------
  function public.TaskPanelShow( ho_tasks, changepanel )

    --DbgTrace( "***interface_impl::public.TaskPanelShow: changepanel = "..tostring(changepanel) );
  
    public.taskpanel_countdown = 0;

    if ( not changepanel ) then
      interface.WidgetSetInput( InterfaceWidget_Inventory, false );
      interface.EnableZoom(true);
    end;

    if ( not _G[ "int_taskheader" ] ) then
      interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    end;
  
    local ho_name = interface.GetObjectName( GetCurrentRoom() );
    local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ];
  
    for i = 1, #ho_tasks, 1 do
  
      local task_name = ho_tasks[ i ][ "name" ];
  
      if ( ho_progress.start == 1 ) then
  
        if ( ho_tasks[ i ][ "marked" ] == 1 ) then

          if ( ho_progress.unmark[ task_name ].done == 1 ) then
  
            ho_tasks[ i ][ "marked" ] = 0;
  
          end;
  
        end;
  
        for j = 1, #ho_progress.found, 1 do
  
          if ( task_name == ho_progress.found[ j ][ "task" ] ) then
  
            ho_tasks[ i ][ "count" ] = ho_tasks[ i ][ "count" ] - 1;
  
          end;
  
        end;
  
      end;
  
      ho_tasks[ i ][ "name" ] = interface.TaskPanelGetTaskId( ho_name, task_name );
  
      public.taskpanel_countdown = public.taskpanel_countdown + ho_tasks[ i ][ "count" ];
      ho_progress.start = 1;

    end;

    --DbgTrace( "taskpanel_countdown == "..public.taskpanel_countdown );
  
    if ( not _G[ "int_taskheader" ] ) then
  
      if _G[ "int_taskpanel" ] then int_taskpanel.Show( ho_tasks ); end;
  
    else
      
      if _G[ "int_taskheader" ] then int_taskheader.Show(); end;
      if _G[ "int_inventory"  ] then int_inventory.ShowForTaskHeader(); end;
      if _G[ "int_taskpanel"  ] then int_taskpanel.ShowForTaskHeader( ho_tasks ); end;
  
    end;

  end;
  -------------------------------------------------------------------------------------
  function public.TaskPanelTaskComplete( ho_name, task_name, object_name )

    public.taskpanel_countdown = public.taskpanel_countdown - 1;

    --DbgTrace( "***interface_impl.TaskPanelTaskComplete: ho_name = "..ho_name..", task_name: "..task_name..", countdown = "..public.taskpanel_countdown );

    if ( public.taskpanel_countdown == 0 ) then

      local ho_stage = ng_global.progress[ prg.current ][ "win_"..ho_name ].stage;

      if ( ho_stage ) and ( ho_stage[1] <= ho_stage[2] ) then

        local panel_doors = ng_global.progress[ prg.current ][ "win_"..ho_name ].panel_doors;

        if ( not panel_doors ) or ( int_taskpanel_impl.IsAllPanelDoorsItmUsed( ho_name ) ) then

          ho_stage[1] = ho_stage[1] + 1;

          --DbgTrace("ho_stage = "..ho_stage[1].." / "..ho_stage[2] );

          if ( ho_stage[1] > ho_stage[2] ) then
            _G[ "ho_"..ho_name ].HoComplete();
          end;

        end;

      else
      
        ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 1;
        ng_global.progress[ ng_global.currentprogress ].common.currentroom = game.relations[ "ho_"..ho_name ].exitroom;
    
        _G[ "ho_"..ho_name ].HoComplete();

      end;
  
    end;
  
    local task_id = interface.TaskPanelGetTaskId( ho_name, task_name );
  
    if _G[ "int_taskpanel" ] then
      int_taskpanel.CompleteTask( task_id, object_name );
    end;

  end;
  --*********************************************************************************************************************
  function public.TaskPanelHide()

    interface.TaskPanelHide();

    --if _G[ "int_inventory"  ] then int_inventory.HideForTaskHeader(); end;

  end;
  --*********************************************************************************************************************
  function public.ChangeTaskPanelToItemPanel( ho_items )

    --DbgTrace( "***interface_impl::public.ChangeTaskPanelToItemPanel" );

    if _G[ "int_taskheader" ] then int_taskheader.Hide(); end;
    if _G[ "int_taskpanel"  ] then int_taskpanel.HideForTaskHeader(); end;

    public.ItemPanelShow( ho_items );

  end;
--*********************************************************************************************************************
--***function *** ItemPanel *** () end*********************************************************************************
--*********************************************************************************************************************
  function public.ItemPanelSetNewItem( ho_items )

    --DbgTrace( "***interface_impl::public.ItemPanelSetNewItem" );

    cmn.Lock( 1, { room = 1 } );

    interface.itempanel = {};
    interface.itempanel.countdown = #ho_items;

    int_itempanel.Show( ho_items, true );

  end;
--*********************************************************************************************************************
  function public.ItemPanelItemEnableToUse( item_name )

    --DbgTrace( "***interface_impl::public.ItemPanelItemEnableToUse: item_name = "..item_name );

    ObjDelete( "spr_"..common.GetObjectName( item_name ).."_1" );

    ObjMultiSet( { { item_name, { input = true } },
                   { "spr_"..common.GetObjectName( item_name ).."_2", { alp = 1 } } } );

  end;
--*********************************************************************************************************************
  function public.ItemPanelItemRemove( item_name, countdown, trytocomplete )

    if ( trytocomplete == nil ) then
      trytocomplete = true;
    end;

    --DbgTrace( "***int.ItemPanelItemRemove: item_name = "..item_name..", countdown = "..countdown..", trytocomplete = "..tostring(trytocomplete) );

    int_itempanel.DeleteObject( item_name );

    if ( countdown >= 7 ) then --ставим инпут для итема который показался на панели

      local new_item_num = 7 + #int_itempanel.ho_items - countdown;

      --DbgTrace( "*появился "..int.itempanel.ho_items[ new_item_num ].name..", marked = "..int.itempanel.ho_items[ new_item_num ].marked..", hint = "..int.itempanel.ho_items[ new_item_num ].hint );

      if ( int_itempanel.ho_items[ new_item_num ].marked == 0 ) then

        ObjSet( int_itempanel.ho_items[ new_item_num ].hint, { input = 1 } );

      end;

    end;

    if ( trytocomplete ) then
      local room_prefix = common.GetObjectPrefix( GetCurrentRoom() );
      if ( room_prefix == "ho" ) then --потомучто можем выйти в другую комнату пока летит предмет
        interface.ItemPanelTryToComplete();
      end;
    end;

  end;
  --*********************************************************************************************************************
  function public.ItemPanelItemAdd( ho_items, item_name, item_marked, ho_hint )

    --DbgTrace("***interface_impl::public.ItemPanelItemAdd: item_name = "..item_name..", item_marked = "..item_marked..", ho_hint = "..ho_hint);

    local ho_name = common.GetObjectName( GetCurrentRoom() );
    local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ];

    local item_object_name = "itm_"..ho_name.."_"..item_name;

    local item_found = false;

    for i = 1, #ho_progress.found, 1 do

      if ( ho_progress.found[ i ][ "item" ] == item_object_name ) then

        item_found = true;
        break;

      end;

    end;

    if ( not item_found ) then

      if ( item_marked == 1 ) then

        if ( ho_progress.unmark[ item_name ].done == 1 ) then

          item_marked = 0;

          --DbgTrace("***item_name = "..item_name..", item_marked = "..item_marked);

        end;

      end;

      local item_table = { name = item_object_name, marked = item_marked, hint = ho_hint };--, count = 1

      table.insert( ho_items, item_table );

      if ( #ho_items > 7 ) or ( item_marked == 1 ) then   --убираем инпут у предметов, которые невидны на панели или требуют доп действий
        ObjSet( ho_hint, { input = false } );
      else
        ObjSet( ho_hint, { input = true } );
      end;

    end;

  end;
  --*********************************************************************************************************************
  function public.ItemPanelHoHintShow()

    if ( int_itempanel.already_hide == false ) then

      local item_found = false;

      for i = 1, #int_itempanel.ho_items, 1 do

        if ( ObjGet( int_itempanel.ho_items[i].hint ).input ) then

          item_found = true;
          break;

        end;

      end;

      if ( item_found ) then

        int_itempanel.ShowHoHint();

      else

        common_impl.HoHint_NoObjects();

      end;

    end;

  end;
  --*********************************************************************************************************************
  function public.ItemPanelShow( ho_items )

    interface.ItemPanelShow( ho_items );

    if _G[ "int_inventory"  ] then int_inventory.ShowForTaskHeader(); end;
    
  end;
  --*********************************************************************************************************************
  function public.ItemPanelHide()

    interface.ItemPanelHide();

    if _G[ "int_inventory"  ] then int_inventory.HideForTaskHeader(); end;

  end;
  -------------------------------------------------------------------------------------
  function public.ItemPanelItemComplete( ho_name, item_object_name, item_name )

    --DbgTrace( "***interface_impl::public.ItemPanelItemComplete: item_object_name = "..item_object_name );

    if ( interface.itempanel.countdown == 0 ) then

      local ho_stage = ng_global.progress[ prg.current ][ "win_"..ho_name ].stage;

      if ( ho_stage ) and ( ho_stage[1] <= ho_stage[2] ) then

        ho_stage[1] = ho_stage[1] + 1;

        --DbgTrace("ho_stage = "..ho_stage[1].." / "..ho_stage[2] );

        if ( ho_stage[1] > ho_stage[2] ) then
          _G[ "ho_"..ho_name ].HoComplete();
        end;

      else

        --DbgTrace( "not stage / stage complete" );

        ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 1;
        ng_global.progress[ ng_global.currentprogress ].common.currentroom = game.relations[ "ho_"..ho_name ].exitroom;
        _G[ "ho_"..ho_name ].HoComplete();

      end;

    end;

    int_itempanel_impl.HoItemContourFindAnim( item_object_name, item_name, interface.itempanel.countdown, _G[ "ho_"..ho_name ].use_ho_items );

  end;
  --*********************************************************************************************************************
  function public.ChangeItemPanelToTaskPanel( ho_tasks )

    --DbgTrace( "***interface_impl::public.ChangeItemPanelToTaskPanel" );

    if _G[ "int_itempanel" ] then int_itempanel.Hide(); end;

    public.TaskPanelShow( ho_tasks, true );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--***function *** Achievements *** () end******************************************************************************
--*********************************************************************************************************************
  ------------------------------------------------------------------------------------
  function public.AchievAdd()

    interface.CustomWidgetAdd( InterfaceWidget_Achiev, "assets/interface/int_achiev", "int_achiev", 250 );

    int_achiev.CheckScreen();

  end;
  ------------------------------------------------------------------------------------
  function private.AchievStackSetCollFirst()

    local achiev_name;
    
    for i = 1, #int_achiev.stack_name, 1 do
            
      if ( string.sub( int_achiev.stack_name[i], 1, 7 ) == "ce_col_" ) then
        achiev_name = table.remove( int_achiev.stack_name, i );
        break;
      end;
      
    end;
    
    table.insert( int_achiev.stack_name, 1, achiev_name );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------
  function public.ShowAchiev( achiev_name )

    --DbgTrace("***interface_impl::public.ShowAchiev: achiev_name = "..achiev_name);

    if ( string.sub( achiev_name, 1, 7 ) == "ce_col_" ) then

      int_achiev.stack_name[#int_achiev.stack_name + 1] = achiev_name;
      int_achiev.SetAchiev( achiev_name );

    else

      local achiev_state = ng_global.achiev[achiev_name][1];
      local achiev_complete = ng_global.achiev[achiev_name][3];

      if achiev_state == achiev_complete then 

        int_achiev.stack_name[#int_achiev.stack_name + 1] = achiev_name;
        int_achiev.SetAchiev( achiev_name );

      end;

    end;
    
    if ( ( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ) ) then

      --показываем разные туториалы на ачивки и коллектеблз
      local tutor_ind = 11;
      local panel = 0;
      local look_for = "ce_ach_";
      
      if ( string.sub( achiev_name, 1, 7 ) == "ce_col_" )  then
        look_for = "ce_col_";
      end;
      
      --ищем первую панельку, нужную нам
      for i = 1, 3, 1 do
        if ( string.sub( ObjGet("txt_int_achiev_"..i).text, 1, 7 ) == look_for ) then
          panel = i;
          break;
        end;
      end;
      
      --collectebles
      if ( string.sub( achiev_name, 1, 7 ) == "ce_col_" )  then
        
        if ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level1" ) then
          tutor_ind = 15;
        elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level2" ) then
          tutor_ind = 23;
        elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level3" ) then
          tutor_ind = 26;
        elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level4" ) then
          tutor_ind = 29;
        end;
      
        --нашли панельку
        if panel > 0 then
        
          --туторил на колл не был показан
          if not ng_global.lvl1_tutor_skip and ng_global.bonus_tutors_shown.coll == 0 and not( cmn.IsEventDone("tutor_"..tutor_ind) ) then
            ng_global.bonus_tutors_shown.coll = 1;
            int_achiev.AchMouseEnter( panel, true );
            public.ShowAchieveTutor( panel, tutor_ind );
          end;
          
        else 
          
          --туторил на колл не был показан
          if not ng_global.lvl1_tutor_skip and ng_global.bonus_tutors_shown.coll == 0 and not( cmn.IsEventDone("tutor_"..tutor_ind) ) then
            
            ng_global.bonus_tutors_shown.coll = 1;
            
            public.ShowAchieveTutor( 1, tutor_ind );
            
            cmn.Lock( 1, {room = 1} );
            ObjSet( "tmr_tutorial_tutor", {
              time = ( int_achiev.HIDE_ANIM_TIME + int_achiev.SHOW_ANIM_TIME ),
              playing = true,
              endtrig = function() cmn.Lock( 0 ); end
            } );
            
            private.AchievStackSetCollFirst();
            int_achiev.AchMouseLeave( 1, true );
            int_achiev.AchMouseEnterSet( 1 );
            
          end;
          
        end;

      --achievements  
      else 
      
        if ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level2" ) then
          tutor_ind = 22;
        elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level3" ) then
          tutor_ind = 25;
        elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level4" ) then
          tutor_ind = 28;
        end;
        
        --нашли панельку
        if panel > 0 then
          
          --туторил на ачивку не был показан
          if not ng_global.lvl1_tutor_skip and ng_global.bonus_tutors_shown.ach == 0 and not( cmn.IsEventDone("tutor_"..tutor_ind) )
          and ( common_impl.tutorial.current ~= "tutor_14" and common_impl.tutorial.current ~= "tutor_21"
          and common_impl.tutorial.current ~= "tutor_24" and common_impl.tutorial.current ~= "tutor_27" ) then
            ng_global.bonus_tutors_shown.ach = 1;
            int_achiev.AchMouseEnter( panel, true );
            public.ShowAchieveTutor( panel, tutor_ind );
          end;
          
        else 
          
          --туторил на ачивку не был показан
          if not ng_global.lvl1_tutor_skip and ng_global.bonus_tutors_shown.ach == 0 and not( cmn.IsEventDone("tutor_"..tutor_ind) )
          and ( common_impl.tutorial.current ~= "tutor_14" and common_impl.tutorial.current ~= "tutor_21"
          and common_impl.tutorial.current ~= "tutor_24" and common_impl.tutorial.current ~= "tutor_27" ) then
          
            ng_global.bonus_tutors_shown.ach = 1;
            
            cmn.Lock( 1, {room = 1} );
            public.ShowAchieveTutor( 1, tutor_ind );
            
            ObjSet( "tmr_tutorial_tutor", {
              time = ( int_achiev.HIDE_ANIM_TIME + int_achiev.SHOW_ANIM_TIME ),
              playing = true,
              endtrig = function() cmn.Lock( 0 ); end
            } );
            
            int_achiev.AchMouseLeave( 1, true );
            int_achiev.AchMouseEnterSet( 1 );
            
          end;
            
        end;
        
      end;
      
    end;
    
  end;
  ------------------------------------------------------------------------------------
  function public.HideAchiev()

    local event_id = "show";
    local panel_id = int_achiev.close_id;

    int_achiev.HideAnim( event_id, panel_id );

  end;
  ------------------------------------------------------------------------------------
  function public.ShowAchieveTutor( panel, tutor_ind )
    
    ObjSet("obj_tutorial_tutor_"..tutor_ind.."_1",  { event_menter = function() int_achiev.AchMouseEnter( panel ); end });

    if ( GetWideScreen() ) then

      ObjMultiSet( { {"obj_tutorial_tutor_"..tutor_ind, { pos_x = -512, pos_y = -(159+168*(panel-1)) }},
                     {"obj_tutorial_tutor_"..tutor_ind.."_1", { pos_x = -80, pos_y = 130+168*(panel-1) }} } );

      local arrows = { { pos_x = -320, pos_y = 0, ang = 1.57 } };

      cmn.TutorialShow( "tutor_"..tutor_ind, 0, 512, 159+168*(panel-1), arrows );

    else 

      ObjMultiSet( { {"obj_tutorial_tutor_"..tutor_ind, { pos_x = -700, pos_y = -(159+168*(panel-1)) }},
                     {"obj_tutorial_tutor_"..tutor_ind.."_1", { pos_x = 69, pos_y = 130+168*(panel-1) }} } );

      local arrows = { { pos_x = -320, pos_y = 0, ang = 1.57 } };

      cmn.TutorialShow( "tutor_"..tutor_ind, 0, 700, 159+168*(panel-1), arrows );

    end;
    
  end;
  -------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------
  function public.PopupAchievementAdd()

    --InterfaceWidget_PopupAchievement = int.CustomWidgetNew();
    interface.CustomWidgetAdd( InterfaceWidget_PopupAchievement, "assets/interface/int_popup_achievements", "int_popup_achievements" );

    --Command_Popup_Achievements_Show = int.CustomWidgetMessageNew();
    --int.CustomWidgetMessageAdd( InterfaceWidget_PopupAchievement, Command_Popup_Achievements_Show );

    --Command_Popup_Achievements_Hide = int.CustomWidgetMessageNew();
    --int.CustomWidgetMessageAdd( InterfaceWidget_PopupAchievement, Command_Popup_Achievements_Hide );

  end;
  -------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------
  function public.PopupAchievementShow( table )

    --SendMessage( Command_Popup_Achievements_Show, { table = table } );

    int_popup_achievements.event_tmr_end = table;

    ObjSet( "tmr_int_popup_achievements_show",
    {
      endtrig = int_popup_achievements.Show,
      time    = int_popup_achievements.SHOW_TIME,
      playing = 1
    } );
  --[[
    local popup_achievements_text1 = table[ "text1" ];
    local popup_achievements_text2 = table[ "text2" ];

    ObjSet( "tmr_int_popup_achievements_show",
    {
      endtrig = int_popup_achievements.Show( &apos;"..popup_achievements_text1.."&apos;,&apos;"..popup_achievements_text2.."&apos; );",
      time    = int_popup_achievements.SHOW_TIME,
      playing = 1
    } );
  --]]

  end;
  -------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------
  function public.PopupAchievementHide()

    --SendMessage( Command_Popup_Achievements_Hide, {} );

    ObjSet( "tmr_int_popup_achievements_show", { playing = 0 } );

    if ( not int_popup_achievements.ishideanim ) then

      int_popup_achievements.ishideanim = true;

      local event_id = "hide";
      int_popup_achievements.event_anim_end[ event_id ] = {};
      int_popup_achievements.HideAnim( event_id );

    end;

  end;
  -------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
--***function *** Bonus *** () end**********************************************************************************
--*********************************************************************************************************************
  -------------------------------------------------------------------------------------
  function public.BonusAdd()

    --InterfaceWidget_Bonus = interface.CustomWidgetNew();

    interface.CustomWidgetAdd( InterfaceWidget_Bonus, "assets/interface/int_bonus", "int_bonus", 250 );

    int_bonus.CheckScreen();

  end;
  --------------------------------------------------------------------
  function public.GetBonus( num, count )

    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_flower"); 

    local bonus_obj = "spr_bonus_"..num;
    local index = num;

    public.AnimBonusObj(bonus_obj);

    --if ng_global.show_bonus == 0 then
    if int_bonus.show_bonus == 0 then

      public.SetBonus();

      int_bonus.ShowAnim( "hide" );

      int_bonus.show_bonus = 1;
      int_bonus.iter = 0;
      int_bonus.state = 0;
      int_bonus.fly = 0;
      ng_global.bonus_count_current = ng_global.bonus_count_counter;

      ng_global.bonus_count_counter = ng_global.bonus_count + count;

    else 

      int_bonus.WaitAnim( "increase" );
      if int_bonus.state == 0 and int_bonus.fly < 1 then
        ng_global.bonus_count_counter = ng_global.bonus_count + count;
      end;

    end;

    ng_global.bonus[index] = 1;
    ng_global.bonus_count = ng_global.bonus_count + count;
    ng_global.bonus_count_total = ng_global.bonus_count_total + count;
    
    local tutor_ind = 14;
    if ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level2" ) then
      tutor_ind = 21;
    elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level3" ) then
      tutor_ind = 24;
    elseif ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "level4" ) then
      tutor_ind = 27;
    end;
    
    local panels_shown = false;
    
    --показ туториала
    if ( ( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ) ) then
    
      if not ng_global.lvl1_tutor_skip and ng_global.bonus_tutors_shown.bonus == 0 and not( cmn.IsEventDone("tutor_"..tutor_ind) ) then
        
        ng_global.bonus_tutors_shown.bonus = 1;
        --чтобы не уползла панелька с цветочками
        int_bonus.BonusMouseEnter( true );
        
        local arrows = { { pos_x = 320, pos_y = 0, ang = -1.57 } };

        if ( GetWideScreen() ) then

          cmn.TutorialShow( "tutor_"..tutor_ind, 0, 620, 340, arrows );

        else 

          cmn.TutorialShow( "tutor_"..tutor_ind, 0, 480, 340, arrows );

        end;
        
        if ng_global.bonus_tutors_shown.ach == 0 then
          
          --local panel = 0;
          --local panels_shown = false;
          
          --ищем первую панельку, нужную нам
          --for i = 1, 3, 1 do
          --  if ( string.sub( ObjGet("txt_int_achiev_"..i).text, 1, 7 ) == "ce_ach_" ) then
          --    panel = i;
          --    break;
          --  end;
          --end;
          
          if ( ng_global.bonus_count_total > 0 ) and ( ng_global.achiev["collect_1_flower"][1] == 0 ) then
            panels_shown = true;
          elseif ( ng_global.bonus_count_total > 4 ) and ( ng_global.achiev["collect_5_flowers"][1] == 0 ) then
            panels_shown = true;
          elseif ( ng_global.bonus_count_total > 14 ) and ( ng_global.achiev["collect_15_flowers"][1] == 0 ) then
            panels_shown = true;
          elseif ( ng_global.bonus_count_total > 29 ) and ( ng_global.achiev["collect_30_flowers"][1] == 0 ) then
            panels_shown = true;
          elseif ( ng_global.bonus_count_total > 99 ) and ( ng_global.achiev["collect_100_flowers"][1] == 0 ) then
            panels_shown = true;
          elseif ( ng_global.bonus_count_total > 142 ) and ( ng_global.achiev["collect_200_flowers"][1] == 0 ) then
            panels_shown = true;
          end;
          
          --чтобы не уползла панелька с ачивкой цветочка
          --if panel > 0 and panels_shown then
          --  int_achiev.AchMouseEnter( panel, true );
          --end;
          
        end;
        
      end;
      
    end;
    
    --DbgTrace("***bonus_count_total = "..ng_global.bonus_count_total);

    if ( ng_global.bonus_count_total > 0 ) and ( ng_global.achiev["collect_1_flower"][1] == 0 ) then
      common_impl.CompleteAchiev("collect_1_flower");
    end;
    if ( ng_global.bonus_count_total > 4 ) and ( ng_global.achiev["collect_5_flowers"][1] == 0 ) then
      common_impl.CompleteAchiev("collect_5_flowers");
    end;
    if ( ng_global.bonus_count_total > 14 ) and ( ng_global.achiev["collect_15_flowers"][1] == 0 ) then
      common_impl.CompleteAchiev("collect_15_flowers");
    end;
    if ( ng_global.bonus_count_total > 29 ) and ( ng_global.achiev["collect_30_flowers"][1] == 0 ) then
      common_impl.CompleteAchiev("collect_30_flowers");
    end;
    if ( ng_global.bonus_count_total > 99 ) and ( ng_global.achiev["collect_100_flowers"][1] == 0 ) then
      common_impl.CompleteAchiev("collect_100_flowers");
    end;
    if ( ng_global.bonus_count_total > 142 ) and ( ng_global.achiev["collect_200_flowers"][1] == 0 ) then
      common_impl.CompleteAchiev("collect_200_flowers");
    end;
    
    if panels_shown then
      
      local panel = 0;
      
      --ищем первую панельку, нужную нам
      for i = 1, 3, 1 do
        if ( string.sub( ObjGet("txt_int_achiev_"..i).text, 1, 7 ) == "ce_ach_" ) then
          panel = i;
          break;
        end;
      end;
      
      if panel > 0 then
        int_achiev.AchMouseEnter( panel, true );
      end;
      
    end;
    
    --показ окна-приглашения в секретрум
    --for i = 6, 1, -1 do
    --  if (ng_global.bonus_count_total >= int_bonus.npc_cost[i]) and (ng_global.secretroom.npc_unlocked[i] == 0) then
    --    ng_global.secretroom.npc_unlocked[i] = 1;
    --    cmn.DialogWindowShow( "common", "dlg_open_bonusroom" );
    --    break;
    --  end;
    --end;

  end;
  -------------------------------------------------------------------------------------
  function public.SetBonus()

    local hundred = math.modf(ng_global.bonus_count / 100);
    local ten = math.modf((ng_global.bonus_count - 100 * hundred) / 10);
    local edin = ng_global.bonus_count - 100 * hundred - 10 * ten;

    int_bonus.iter = 0;
    int_bonus.state = 0;

    ObjSet("spr_int_bonus_count_1", {pos_y = -hundred*50} );
    ObjSet("spr_int_bonus_count_1_1", {pos_y = -hundred*50-500} );
    ObjSet("spr_int_bonus_count_2", {pos_y = -ten*50} );
    ObjSet("spr_int_bonus_count_2_1", {pos_y = -ten*50-500} );
    ObjSet("spr_int_bonus_count_3", {pos_y = -edin*50} );
    ObjSet("spr_int_bonus_count_3_1", {pos_y = -edin*50-500} );

  end;
  ------------------------------------------------------------------------------------
  function public.AnimBonusObj(sender)

    local bonus_obj = sender;
    local pos = GetObjPosByObj(bonus_obj, "int_bonus");
    local offset = 176;

    int_bonus.fly = int_bonus.fly + 1;

    ObjSet(bonus_obj, {input=0});
    ObjCreate("fx_"..bonus_obj, "partsys");
    ObjAttach("fx_"..bonus_obj, "int_bonus");
    ObjAttach(bonus_obj, "int_bonus");
    ObjSet(bonus_obj, {pos_x = pos[1], pos_y = pos[2]});
    ObjSet("fx_"..bonus_obj, {pos_x = pos[1], pos_y = pos[2], res="assets/interface/resources/fx/ho_get_obj"});
    ObjAnimate(bonus_obj, 3,0,0, function () public.AnimBonusObjEnd(bonus_obj); end, {0, 3, pos[1], pos[2],   2, 3, -offset, 0});
    ObjAnimate("fx_"..bonus_obj, 0,0,0, "", {0, 3, pos[1],   2, 3, -offset});
    ObjAnimate("fx_"..bonus_obj, 1,0,0, "", {0, 0, pos[2],   2, 0, 0});

    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_open_window" );
    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_flower" );

  end;
  ------------------------------------------------------------------------------------
  function public.AnimBonusObjEnd(bonus_obj)

    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_number" );

    int_bonus.fly = int_bonus.fly - 1;
    ObjAnimate(bonus_obj, 6,0,0, function () ObjDelete(bonus_obj); end, {0,0,1,1, 0.3,0,0,0});
    ObjAnimate("fx_"..bonus_obj, "alp",0,0, function () ObjDelete("fx_"..bonus_obj); end, {0,0,1, 0.3,0,1, 0.6,0,0});

    int_bonus.CountTotal( "increase" );

  end;
  ------------------------------------------------------------------------------------
  function public.ShowBonus()

    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_open_window" );
    
    --if ng_global.show_bonus == 0 then
    if int_bonus.show_bonus == 0 then

      ng_global.bonus_count_counter = ng_global.bonus_count;
      public.SetBonus();

      int_bonus.ShowAnim( "hide" );

    end;

    --ng_global.show_bonus = 1;
    int_bonus.show_bonus = 1;

  end;
  ------------------------------------------------------------------------------------
  function public.HideBonus()

    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_close_window" );

    int_bonus.HideAnim( "show" );

  end;
  ------------------------------------------------------------------------------------
  function public.SpendBonus(count)

    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_number" );

    if ( ng_global.bonus_count - count ) >= 0 then
      ng_global.bonus_count = ng_global.bonus_count - count;
      ng_global.bonus_count_counter = ng_global.bonus_count;

      --int_bonus.CountTotal( "decrease" );

    else
      -- not flowers
    end;

  end;
  ------------------------------------------------------------------------------------
  function public.RemoveFlowersTotal()

    if  IsCollectorsEdition() or IsSurveyEdition() then

      if (ng_global.bonus) then

        for i = 1, 150, 1 do 

          if ng_global.bonus[i] == 1 then
            ObjDelete("spr_bonus_"..i);
          end;

        end;

      end;

    else
      for i = 1, 150, 1 do 
        ObjDelete("spr_bonus_"..i);
      end;
    end;

  end;
  -------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
--***function *** Global Task *** () end**********************************************************************************
--*********************************************************************************************************************
  -------------------------------------------------------------------------------------
  function public.GlobalTaskAdd( pos_z )

    pos_z = pos_z or 0;

    interface.CustomWidgetAdd( InterfaceWidget_GlobalTask, "assets/interface/int_global_task", "int_global_task", pos_z );

    int_global_task.CheckScreen();

  end;
  ----------------------------------------------------------------------
  function public.SetCurrentGlobalTask( task_num )

    ng_global.global_task_first = task_num;

  end;
  ----------------------------------------------------------------------
  ----------------------------------------------------------------------
  function public.ShowGlobalTask( trg_after )

    int_global_task.ShowAnim( trg_after );

  end;
  ----------------------------------------------------------------------
  function public.HideGlobalTask()

    int_global_task.HideAnim();

  end;
  ----------------------------------------------------------------------
  ----------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
--***function *** Secretroom *** () end**********************************************************************************
--*********************************************************************************************************************
  -------------------------------------------------------------------------------------
  function public.SecretroomAdd()

    interface.CustomWidgetAdd( InterfaceWidget_Secretroom, "assets/interface/int_dialog_secretroom", "int_dialog_secretroom", 260 );

  end;
  --------------------------------------------------------------------
  function public.ShowStarsWindow()

    int_dialog_secretroom.ShowAnim();

  end;
  -----------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
--***function *** Clues Panel *** () end**********************************************************************************
--*********************************************************************************************************************
  -------------------------------------------------------------------------------------
  function public.CluesPanelAdd()

    interface.CustomWidgetAdd( InterfaceWidget_CluesPanel, "assets/interface/int_clues_panel", "int_clues_panel", 1 );

  end;
  -------------------------------------------------------------------------------------
  function public.CluesPanelActivate(func_after_anim)
    
    int_clues_panel.ActivateAnim(func_after_anim);
    
  end;
  ----------------------------------------------------------------------
  function public.AddNewClues( clues )
    
    if ng_global.clues then
    
      local new_clues = {};
      
      for i = 1, #clues, 1 do
        
        local found = false;
        
        for j = 1, #ng_global.clues, 1 do
          
          if clues[i] == ng_global.clues[j] then
            found = true;
            break;
          end;
          
        end;
        
        if not found then
          table.insert( new_clues, clues[i] );
        end;
        
      end;

      for i = 1, #new_clues, 1 do
        
        table.insert( ng_global.clues, new_clues[i] );
        
      end;
      
      int_clues_panel.clues_pull = new_clues;
      int_clues_panel.AddCluesToPanel( clues );
      
    end;
    
  end;
  ----------------------------------------------------------------------
  function public.ShowNewClues( func_after )
    
    func_after = func_after or false;
    
    int_clues_panel.ShowNewClues( int_clues_panel.clues_pull, func_after );
    
  end;
  ----------------------------------------------------------------------
  function public.SetCompleteClues( clues )
    
    if ng_global.clues_found then
      
      local new_clues = {};
      
      for i = 1, #clues, 1 do
        
        local found = false;
        
        for j = 1, #ng_global.clues_found, 1 do
          
          if clues[i] == ng_global.clues_found[j] then
            found = true;
            break;
          end;
          
        end;
        
        if not found then
          table.insert( new_clues, clues[i] );
          --table.remove( clues, clues[i] );
        end;
        
      end;

      for i = 1, #new_clues, 1 do
        
        table.insert( ng_global.clues_found, new_clues[i] );
        
      end;
      
      int_clues_panel.clues_pull = new_clues;
      int_clues_panel.SetCrossedClues( clues );
      
    end;

  end;
  ----------------------------------------------------------------------
  function public.CompleteClues( clues, func_after )
    
    func_after = func_after or false;
    
    int_clues_panel.CrossClues( clues, func_after );
    
  end;
  ----------------------------------------------------------------------
  ----------------------------------------------------------------------
  function public.ShowCluesPanel( trg_after )

    int_clues_panel.ShowAnim( trg_after );

  end;
  ----------------------------------------------------------------------
  function public.HideCluesPanel()

    int_clues_panel.HideAnim();

  end;
  -------------------------------------------------------------------