-- name=ho_debris
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_debris" );
  game.relations[ "ho_debris" ].exitroom = "rm_doctorstudy";

  public.use_ho_items = true;

  private.item_names = { "plate", "brush", "ship", "feather", "boots", "umbrella" };  --стадия 1

  private.InitMarked();

  public.changed_name = {"", ""};
  private.selected_item = "";

  private.cur_progress = "std";
  ------------------------------------------------------------------------------
  game.debris = {};
  game.debris.double_hint = { { "spr_debris_plate1",      "spr_debris_plate2" },
                              { "spr_debris_brush1",      "spr_debris_brush2" },
                              { "spr_debris_ship1",       "spr_debris_ship2" },
                              { "spr_debris_feather1",    "spr_debris_feather2" },
                              { "spr_debris_boots1",      "spr_debris_boots2" },
                              { "spr_debris_umbrella1",   "spr_debris_umbrella2" } };
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_debris" ] = 
  {
    type = "win",
    room = "rm_doctorstudy",
    zz = "ho_debris",
    zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------------
  local win_debris_func = function ()

    if ( cmn.IsEventDone( "win_debris" ) ) then
      ObjDelete("gho_doctorstudy_debris");
      ObjDelete("spr_doctorstudy_closet_therapist");
    end;

  end;
  cmn.AddSubscriber( "win_debris", win_debris_func );
  --------------------------------------------------------------------------------------------------
  local start_debris_func = function ()

    if ( cmn.IsEventStart( "win_debris" ) ) then

      common_impl.ProcessHoStart( "debris", true );

    end;

  end;
  cmn.AddSubscriber( "win_debris", start_debris_func, "ho_debris" );
  
  --for secretroom
  private.tasks =  {    
    
    { "pairs", 12, 0, { {"spr_debris_plate1"}, {"spr_debris_plate2"}, {"spr_debris_brush1"}, {"spr_debris_brush2"},
                     {"spr_debris_ship1"}, {"spr_debris_ship2"}, {"spr_debris_feather1"}, {"spr_debris_feather2"},
                     {"spr_debris_boots1"}, {"spr_debris_boots2"}, {"spr_debris_umbrella1"}, {"spr_debris_umbrella2"} } },
    
    { "glove", 1, 0, { {"spr_debris_glove"} } },
    { "knife", 1, 1, { {"spr_debris_knife"} } },
    { "amulet", 2, 1, { {"obj_debris_amulet"}, {"anm_debris_amulet"} } },

    { "bandage", 1, 1, { {"spr_debris_bandage"} } },
    { "zip", 1, 1, { {"spr_debris_zip"} } },
    { "bottle", 1, 1, { {"spr_debris_bottle"} } },
    
  };
  
  private.actions = {
  
    { "use_hoglove", { "obj_debris_use_glove", "anm_debris_use_glove", "obj_debris_knife" } },
    { "use_hoknife", { "obj_debris_use_knife", "anm_debris_use_knife", "anm_debris_doctor_breath", "anm_debris_doctor_breath_2" } },
    { "use_hoamulet", { "obj_debris_use_amulet", "anm_debris_touch_cover", "anm_debris_touch_firstaidkit", "spr_debris_cover_open", "spr_debris_amulet_in_cover" } },
    
    { "use_hobandage", { "obj_debris_use_bandage", "spr_debris_hand1", "spr_debris_hand2" } },
    { "use_hozip", { "obj_debris_use_zip", "spr_debris_first_aid_kit_open", "spr_debris_zip2" } },
    { "use_hobottle", { "obj_debris_use_bottle" } }
  
  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.items_sh = {
    {0, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1},
    {0}, {0}, {0, 0}, {1}, {0}, {1}
  };
  
  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  private.start_items2 = {};
  
  local nme = "";
  
  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      if private.items_sh[i][j] == 1 then
        table.insert( private.start_sh, {} );
        private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][ j ][ 1 ] ).."_shadow";
        nme = private.start_sh[ #private.start_sh ].name;
        private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
        private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      end;

    end;
    
    if i > 1 then
        
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      private.start_items[ #private.start_items ].type = "obj";
      
      private.start_items2[i-1] = {};
  
      for s = 1, 2, 1 do
        
        private.start_items2[i-1][s] = {};
        private.start_items2[i-1][s].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_"..s;
        private.start_items2[i-1][s].prop = ObjGet( private.start_items2[i-1][s].name );
        private.start_items2[i-1][s].parent = ObjGetRelations( private.start_items2[i-1][s].name ).parent;
        private.start_items2[i-1][s].type = "spr";
        
      end;
      
      if private.tasks[ i ][ 3 ] == 1 then
        
        private.start_items2[i-1][3] = {};
        private.start_items2[i-1][3].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_lock";
        private.start_items2[i-1][3].prop = ObjGet( private.start_items2[i-1][3].name );
        private.start_items2[i-1][3].parent = ObjGetRelations( private.start_items2[i-1][3].name ).parent;
        private.start_items2[i-1][3].type = "spr";
        
      end;
      
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage then
    ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].complete = { 0, 0, 0, 0, 0, 0 };
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].complete = { 0, 0, 0, 0, 0, 0 };
  end;

  private.complete = ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].complete;

end;
--*********************************************************************************************************************
function public.PreOpen()

	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  
  if ng_global.currentprogress == "std" then
    
    private.cur_progress = "std";
    
    common.SetPreviousRoom( "rm_doctorstudy" );
    cmn.StartTimePassing("ho_debris");
    
  else 
    
    private.cur_progress = "secret";
    
    ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].complete = { 0, 0, 0, 0, 0, 0 };
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_debris_doctorstudy",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "debris_doctorstudy", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "debris_doctorstudy" ); end });
    
  end;

  cmn.StopAllEnv( "assets/levels/common/audio/aud_debris_env" );
  cmn.PlayAudio( "env", "assets/levels/common/audio/aud_debris_env" );

  private.DrawScene();

  if not cmn.IsEventStart( "win_debris" ) then

    cmn.InitHo( "debris" );

    cmn.SetMarkedTask( "debris", "glove" );
    cmn.SetMarkedTask( "debris", "knife" );
    cmn.SetMarkedTask( "debris", "amulet" );
    cmn.SetMarkedTask( "debris", "bandage" );
    cmn.SetMarkedTask( "debris", "zip" );
    cmn.SetMarkedTask( "debris", "bottle" );

  end;

  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage;

  if not cmn.IsEventDone("win_debris")
  and ho_stage[1] <= ho_stage[2] then

    if ( ho_stage[1] == 1 ) then
      interface_impl.TaskPanelShow( private.stages_task() );
    elseif ( ho_stage[1] == 2 ) then
      interface_impl.ItemPanelShow( private.stages_task() );
    end;

  else

    public.win();

  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone("tutor_6")) then

    local arrows = { { pos_x = 0, pos_y = 150, ang = 3.14 } };
    cmn.TutorialShow( "tutor_6", 0, 512, 450, arrows );

  end;
  
  if ng_global.currentprogress == "std" and ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage[1] == 2 and not(cmn.IsEventDone("tutor_17")) then

    local arrows = { { pos_x = 0, pos_y = 150, ang = 3.14 } };
    cmn.TutorialShow( "tutor_17", 0, 512, 450, arrows );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  interface_impl.ItemPanelHide();

  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_debris_doctorstudy",  { input = 0 });
    
    if private.selected_item ~= "" then
      ObjStopAnimate( public.changed_name[1], "scale_xy" );
    end;
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()

  if private.cur_progress == "secret" then
    
    if private.selected_item ~= "" then
      ObjAttach( public.changed_name[1], "ho_debris" );
      ObjSet(public.changed_name[1],  { scale_x = 1, scale_y = 1 });
      private.selected_item = "";
      public.changed_name = {"", ""};
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_debris");

    if ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_debris" ] then

      ng_global.nohintho[ "win_debris" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_debris" ] then
      ng_global.playedhops[ "win_debris" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_debris_doctorstudy",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.win()
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler("win_debris");
    cmn.GotoRoom("rm_doctorstudy");
    
  else 
    
    cmn.SetEventDone("win_debris");
    int_dialog_secretroom.StopTimer();
    int_dialog_secretroom.ShowAnim();
    
  end;
    
end;
--*********************************************************************************************************************
function private.DrawScene()
  
  if ng_global.currentprogress == "std" then

    for i = 1, #private.item_names, 1 do
      if private.complete[i] == 1 then
        ObjDelete( "spr_debris_"..private.item_names[i].."1_shadow" );
        ObjDelete( "spr_debris_"..private.item_names[i].."2_shadow" );
        ObjDelete( "spr_debris_"..private.item_names[i].."1" );
        ObjDelete( "spr_debris_"..private.item_names[i].."2" );
      end;
    end;
    
  end;

  if ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage[1] == 2 then
    --ObjMultiSet( { {"spr_debris_blacksmithsbag", { input = 1 }},
    --               {"spr_debris_blacksmithsbag_board", { pos_x = 565, pos_y = 403 }} } );
  end;

end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_num )

  local task_name = private.item_names[ task_num ];

  private.ChooseItem( item_name, task_num );

end;
--*********************************************************************************************************************
function public.AmuletFound()

  ObjSet( "anm_debris_amulet", { playing = false } );

  cmn.HoItemFind( "obj_debris_amulet", 1 );

end;
--*********************************************************************************************************************
function public.ItemFound2( item_name )

  ObjDelete( "spr_debris_"..item_name.."_shadow" );

  cmn.HoItemFind( "spr_debris_"..item_name, 1 );

end;
--*********************************************************************************************************************
function private.Fly( fly_obj )

  cmn.HoTaskFind( "obj_debris_"..private.item_names[fly_obj].."_fly", "pairs", 1 );

  private.complete[ fly_obj ] = 1;  

end;
--*********************************************************************************************************************
function private.ChooseItem( item_name, ind )

  if private.selected_item ~= "" then

    if private.selected_item ~= private.item_names[ind] then

      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_menter_ho" );

      --DbgTrace( "pair don't match" );
      local first_item = public.changed_name[1];

      public.changed_name[1] = item_name;
      private.selected_item = private.item_names[ind];

      private.SelectAnim( first_item, 0 );
      private.SelectAnim( item_name, 1 );

    elseif private.selected_item == private.item_names[ind] and public.changed_name[1] ~= item_name then

      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_menter_ho" );

      --DbgTrace( "found right pair" );
      public.changed_name[2] = item_name;
      private.selected_item = "";
      private.FounPairAnim( ind );

    elseif public.changed_name[1] == item_name then

      --DbgTrace( "cancel selection" );
      public.changed_name[1] = "";
      private.selected_item = "";

      private.SelectAnim( item_name, 0 );

    end;

  else 

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_menter_ho" );

    --DbgTrace( "first selected" );
    public.changed_name[1] = item_name;
    private.selected_item = private.item_names[ind];
    private.SelectAnim( item_name, 1 );

  end;

end;
--*********************************************************************************************************************
function private.FounPairAnim( ind )

  private.selected_item = "";
  private.SelectAnim( public.changed_name[1], 0, true );

  local obj1_pos = { ObjGet( public.changed_name[1] ).pos_x, ObjGet( public.changed_name[1] ).pos_y };
  local obj2_pos = { ObjGet( public.changed_name[2] ).pos_x, ObjGet( public.changed_name[2] ).pos_y };
  local end_pos = common_impl.math.FindSegmentPoint( obj1_pos, obj2_pos, 1 );

  --DbgTrace( "attach "..public.changed_name[2] );
  ObjAttach( public.changed_name[2], "obj_debris_items_fly" );

  ObjMultiSet( { { public.changed_name[1], { input = false } },
                 { public.changed_name[2], { input = false } },
                 { "obj_debris_"..private.item_names[ ind ].."_fly", { pos_x = end_pos[1], pos_y = end_pos[2] } } } );

  ObjAnimate(public.changed_name[1], "pos_xy", 0, 0, function () private.Fly(ind); end, {
    0,   0, obj1_pos[1], obj1_pos[2],
    0.5, 0, end_pos[1],  end_pos[2]
  } );

  ObjAnimate(public.changed_name[2], "pos_xy", 0, 0, "", {
    0,   0, obj2_pos[1], obj2_pos[2],
    0.5, 0, end_pos[1],  end_pos[2]
  } );

  ObjAnimate(public.changed_name[1], "alp", 0, 0, "", { 0, 0, 1,  0.4, 0, 1,    0.6, 0, 0 });
  ObjAnimate(public.changed_name[2], "alp", 0, 0, "", { 0, 0, 1,  0.4, 0, 1,    0.6, 0, 0 });

  ObjAnimate(public.changed_name[1].."_shadow", "alp", 0, 0, "", { 0, 0, 1,  0.2, 0, 0 });
  ObjAnimate(public.changed_name[2].."_shadow", "alp", 0, 0, "", { 0, 0, 1,  0.2, 0, 0 });

  public.changed_name[1] = "";
  public.changed_name[2] = "";

end;
--*********************************************************************************************************************
function private.SelectAnim( name, inout, in_fly )

  if inout == 1 then

    --DbgTrace( "attach "..name );
    ObjAttach( name, "obj_debris_items_fly" );
    ObjAnimate( name, "scale_xy", 1, 0, "", { 0, 2, 1, 1,   0.4, 2, 1.2, 1.2,   0.8, 1, 1, 1 });

  else 

    if ( not in_fly ) then
      --DbgTrace( "detach "..name );
      ObjAttach( name, "ho_debris" );
    end;
    ObjStopAnimate( name, "scale_xy" );
    local cur_scale = ObjGet( name ).scale_x;
    ObjAnimate( name, "scale_xy", 0, 0, "", { 0, 0, cur_scale, cur_scale,   0.15, 0, 1, 1 } );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.stages_task()

  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_debris" ].stage[1];
  local ho_tasks_items = {};

  if ( ho_stage == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks_items, "pairs", 6, 0, {
      { "spr_debris_plate1" },
      { "spr_debris_brush1" },
      { "spr_debris_ship1" },
      { "spr_debris_feather1" },
      { "spr_debris_boots1" },
      { "spr_debris_umbrella1" }
    } );

  elseif ( ho_stage == 2 ) then

    game.debris.double_hint = nil;

    interface_impl.ItemPanelItemAdd( ho_tasks_items, "glove",   0, "spr_debris_glove" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "knife",   1, "spr_debris_knife" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "amulet",  1, "obj_debris_amulet" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "bandage", 1, "spr_debris_bandage" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "zip",     1, "spr_debris_zip" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "bottle",  1, "spr_debris_bottle" );

    ObjMultiSet( { { "obj_debris_use_glove", { input = true } },
                   { "obj_debris_use_knife", { input = true } },
                   { "obj_debris_use_amulet", { input = true } },
                   { "obj_debris_use_bottle", { input = true } } } );

  end;

  return ho_tasks_items;
  
end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_2()

  interface_impl.ChangeTaskPanelToItemPanel( private.stages_task() );
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone("tutor_17")) then

    local arrows = { { pos_x = 0, pos_y = 150, ang = 3.14 } };
    cmn.TutorialShow( "tutor_17", 0, 512, 450, arrows );

  end;

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
function private.InitMarked()

  public.ho_hint_progress_names = { "use_hoglove", "use_hoknife", "use_hoamulet", "use_hobandage","use_hozip", "use_hobottle" };

  --------------------------------------------------------------------------------------------
  -- function use_hoglove () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hoglove" ] = {
      type = "use",
      inv_obj = "itm_debris_glove",
      use_place = "obj_debris_use_glove",
      room = "rm_doctorstudy",
      zz = "ho_debris",
      zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_hoglove = function ()
    ObjDelete("obj_debris_use_glove");
    ObjDelete("anm_debris_use_glove");
    ObjDelete("spr_debris_knife_lock");
  end;
  cmn.AddSubscriber( "use_hoglove", use_hoglove, "ho_debris" );

  --------------------------------------------------------------------------------------------
  -- function use_hoknife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hoknife" ] = {
      type = "use",
      inv_obj = "itm_debris_knife",
      use_place = "obj_debris_use_knife",
      room = "rm_doctorstudy",
      zz = "ho_debris",
      zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_hoknife = function ()
    ObjDelete("obj_debris_use_knife");
    ObjDelete("spr_debris_amulet_lock");
    ObjDelete("anm_debris_use_knife");
    ObjDelete("anm_debris_doctor_breath");
    ObjMultiSet( { { "obj_debris_use_bandage", { input = true } },
                   { "obj_debris_amulet", { pos_z = 24 } },
                   { "anm_debris_doctor_breath_2", { alp = 1 } } } );
  end;
  cmn.AddSubscriber( "use_hoknife", use_hoknife, "ho_debris" );

  --------------------------------------------------------------------------------------------
  -- function use_hoamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hoamulet" ] = {
      type = "use",
      inv_obj = "itm_debris_amulet",
      use_place = "obj_debris_use_amulet",
      room = "rm_doctorstudy",
      zz = "ho_debris",
      zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_hoamulet = function ()
    ObjDelete("obj_debris_use_amulet");
    ObjDelete("spr_debris_bandage_lock");
    ObjDelete("anm_debris_touch_cover");

    ObjMultiSet( { { "anm_debris_touch_firstaidkit", { alp = 1 } },
                 { "spr_debris_bandage", { alp = 1 } },
                 { "spr_debris_bandage_shadow", { alp = 1 } },
                 { "spr_debris_cover_open", { alp = 1 } },
                 { "obj_debris_use_zip", { input = true } } } );
  end;
  cmn.AddSubscriber( "use_hoamulet", use_hoamulet, "ho_debris" );

  --------------------------------------------------------------------------------------------
  -- function use_hobandage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hobandage" ] = {
      type = "use",
      inv_obj = "itm_debris_bandage",
      use_place = "obj_debris_use_bandage",
      room = "rm_doctorstudy",
      zz = "ho_debris",
      zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_hobandage = function ()
    ObjDelete("obj_debris_use_bandage");
    ObjDelete("spr_debris_zip_lock");
    ObjDelete("spr_debris_hand1");

    ObjMultiSet( { { "spr_debris_hand2", { alp = 1 } },
                   { "spr_debris_zip", { pos_z = 24 } } } );
  end;
  cmn.AddSubscriber( "use_hobandage", use_hobandage, "ho_debris" );

  --------------------------------------------------------------------------------------------
  -- function use_hozip () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hozip" ] = {
      type = "use",
      inv_obj = "itm_debris_zip",
      use_place = "obj_debris_use_zip",
      room = "rm_doctorstudy",
      zz = "ho_debris",
      zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_hozip = function ()
    ObjDelete("obj_debris_use_zip");
    ObjDelete("spr_debris_bottle_lock");
    ObjDelete("anm_debris_touch_firstaidkit");

    ObjSet( "spr_debris_first_aid_kit_open", { alp = 1, input = true } );
  end;
  cmn.AddSubscriber( "use_hozip", use_hozip, "ho_debris" );

  --------------------------------------------------------------------------------------------
  -- function use_hobottle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hobottle" ] = {
      type = "use",
      inv_obj = "itm_debris_bottle",
      use_place = "obj_debris_use_bottle",
      room = "rm_doctorstudy",
      zz = "ho_debris",
      zz_gate = "gho_doctorstudy_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_hobottle = function ()
    ObjDelete("obj_debris_use_bottle");
  end;
  cmn.AddSubscriber( "use_hobottle", use_hobottle, "ho_debris" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_glove()

  if cmn.ApplyObj( "itm_debris_glove", "obj_debris_use_glove" ) then

    local func_after = function ()

      cmn.Lock( 0 );

      local pos = GetObjPosByObj( "spr_debris_knife" );
      ObjSet( "spr_debris_knife", { pos_x = pos[1] + 171, pos_y = pos[2] } );

      cmn.HoItemFind( "spr_debris_knife", 1, true );

      cmn.CallEventHandler( "use_hoglove" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_use_glove" );

    cmn.UnmarkItem( "debris", "knife" );
    cmn.SetHoItemFind( "debris", "spr_debris_knife" );

    cmn.HoItemUse( "glove" );
    cmn.SetEventDone( "use_hoglove" );

    ObjSet( "anm_debris_use_glove", { animfunc = "func_glove", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife()

  if cmn.ApplyObj( "itm_debris_knife", "obj_debris_use_knife" ) then

    local func_after2 = function ()

      cmn.Lock( 0 );

      ObjSet( "obj_debris_amulet", { input = true } );

      cmn.CallEventHandler( "use_hoknife" );

    end;

    local func_after = function ()
      ObjAnimate( "anm_debris_use_knife", "alp", 0, 0, func_after2, { 0, 0, 1,    0.5, 0, 0 } );
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_use_knife" );

    cmn.UnmarkItem( "debris", "amulet" );

    cmn.HoItemUse( "knife" );
    cmn.SetEventDone( "use_hoknife" );

    ObjAnimate( "anm_debris_doctor_breath",   "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "anm_debris_doctor_breath_2", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    ObjSet( "anm_debris_use_knife", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amulet()

  if cmn.ApplyObj( "itm_debris_amulet", "obj_debris_use_amulet" ) then

    local func_after2 = function ()

      cmn.Lock( 0 );

      ObjSet( "spr_debris_bandage", { input = true } );

      cmn.CallEventHandler( "use_hoamulet" );

    end;

    local func_after = function ()
      ObjAnimate( "anm_debris_touch_cover", "alp", 0, 0, "",    { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_debris_cover_open", "alp", 0, 0, "",     { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "anm_debris_touch_firstaidkit", "alp", 0, 0, "",  { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_debris_bandage", "alp", 0, 0, "",        { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_debris_bandage_shadow", "alp", 0, 0, func_after2, { 0, 0, 0,    0.3, 0, 1 } );
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_use_amulet_ho");

    cmn.UnmarkItem( "debris", "bandage" );

    cmn.HoItemUse( "amulet" );
    cmn.SetEventDone( "use_hoamulet" );

    ObjAnimate( "spr_debris_amulet_in_cover", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bandage()

  if cmn.ApplyObj( "itm_debris_bandage", "obj_debris_use_bandage" ) then

    local func_after = function ()

      cmn.Lock( 0 );

      ObjSet( "spr_debris_zip", { input = true } );

      cmn.CallEventHandler( "use_hobandage" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_use_bandage1" );

    cmn.UnmarkItem( "debris", "zip" );

    cmn.HoItemUse( "bandage" );
    cmn.SetEventDone( "use_hobandage" );

    ObjAnimate( "spr_debris_hand1", "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_debris_hand2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_zip()

  if cmn.ApplyObj( "itm_debris_zip", "obj_debris_use_zip" ) then

    local func_after = function ()

      cmn.Lock( 0 );

      ObjSet( "spr_debris_bottle", { input = true } );

      cmn.CallEventHandler( "use_hozip" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_use_zipper" );

    cmn.UnmarkItem( "debris", "bottle" );

    cmn.HoItemUse( "zip" );
    cmn.SetEventDone( "use_hozip" );

    ObjAnimate( "spr_debris_zip2",                   "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "anm_debris_touch_firstaidkit",      "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
    ObjAnimate( "spr_debris_first_aid_kit_open", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  else

    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottle()

  if cmn.ApplyObj( "itm_debris_bottle", "obj_debris_use_bottle" ) then

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_hobottle" );

      public.win();

    end;

    cmn.Lock( 1, { room = 1 } );
    --cmn.PlayAudio("snd", "assets/levels/level1/ho_debris/audio/");

    cmn.HoItemUse( "bottle" );
    cmn.SetEventDone( "use_hobottle" );

    cmn.SetEventDone( "win_debris" );
    ng_global.progress[ "std" ].common.currentroom = game.relations[ "ho_debris" ].exitroom;
    public.HoComplete();

    ObjSet( "anm_debris_doctor_breath_2", { animfunc = "func_bottle_2", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function public.touch_knife()

  cmn.ShowBbt( "obj_debris_use_glove" );

  cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_xx_knife" );
  
  cmn.Lock( 1, { room = 1 } );
  
  ObjSet( "anm_debris_use_glove", { playing = true, endtrig = function() cmn.Lock(0); end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_cover()

  cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_xx_door_bollard" );

  cmn.ShowBbt( "obj_debris_use_amulet" );
  
  cmn.Lock( 1, { room = 1 } );
  
  ObjSet( "anm_debris_touch_cover", { playing = true, endtrig = function() cmn.Lock(0); end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_firstaidkit()

  cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_xx_chest" );

  cmn.ShowBbt( "obj_debris_use_zip" );
  
  cmn.Lock( 1, { room = 1 } );
  
  ObjSet( "anm_debris_touch_firstaidkit", { playing = true, endtrig = function() cmn.Lock(0); end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_wire()

  cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_xx_rope_left" );

  ObjSet( "obj_debris_touch_wire", { input = false } );

  ObjSet( "anm_debris_touch_wire", { playing = true, endtrig = function() ObjSet( "obj_debris_touch_wire", { input = true } ); end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_lamp()

  cmn.PlayAudio( "snd", "assets/levels/level1/ho_debris/audio/aud_xx_lamp" );

  ObjSet( "obj_debris_touch_lamp", { input = false } );

  ObjSet( "anm_debris_touch_lamp", { playing = true, endtrig = function() ObjSet( "obj_debris_touch_lamp", { input = true } ); end } );

end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;
  local ho_itm2 = private.start_items2;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do

    if not ObjGet( ho_itm[i].name ) then

      ObjCreate( ho_itm[i].name, ho_itm[i].type );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_debris_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_debris_items" );

    end;
    
    for j = 1, #ho_itm2[i], 1 do
      
      if not ObjGet( ho_itm2[i][j].name ) then

        ObjCreate( ho_itm2[i][j].name, ho_itm2[i][j].type );
        ObjSet( ho_itm2[i][j].name, ho_itm2[i][j].prop );
        ObjAttach( ho_itm2[i][j].name, ho_itm2[i][j].parent );
        
      else 
        
        ObjSet( ho_itm2[i][j].name, ho_itm2[i][j].prop );
        ObjAttach( ho_itm2[i][j].name, ho_itm2[i][j].parent );

      end;
      
    end;

  end;
  
end;
-------------------------------------------------------------------------------------------