-- name=ho_infridge
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_infridge" );
  game.relations[ "ho_infridge" ].exitroom = "rm_kitchen";
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_infridge" ] = 
  {
    type = "win",
    room = "rm_kitchen",
    zz = "ho_infridge",
    zz_gate = "gho_kitchen_infridge"
  };
  --------------------------------------------------------------------------------------------------
  local win_infridge_func = function ()

    if ( cmn.IsEventDone( "win_infridge" ) ) then
      interface.InventoryItemAdd( "inv_hook", "spr_infridge_win" );
      ObjSet("inv_line_star_light",  { alp = 1 });
      ObjDelete("gho_kitchen_infridge");
    end;

  end;
  cmn.AddSubscriber( "win_infridge", win_infridge_func );
  --------------------------------------------------------------------------------------------------
  local start_infridge_func = function ()

    if ( cmn.IsEventStart( "win_infridge" ) ) then

      common_impl.ProcessHoStart( "infridge", true );

    end;

  end;
  cmn.AddSubscriber( "win_infridge", start_infridge_func, "ho_infridge" );
  
  --for secretroom
  private.tasks =  {    
      { "shrimp",      1, 0, { { "spr_infridge_shrimp" } } },
      { "ginger",      1, 0, { { "spr_infridge_ginger" } } },
      { "cheese",      1, 0, { { "spr_infridge_cheese" } } },
      { "iceform",      1, 0, { { "spr_infridge_iceform" } } },

      { "coconut",      1, 0, { { "spr_infridge_coconut" } } },
      { "thermometer",      1, 0, { { "spr_infridge_thermometer" } } },
      { "corn",     1, 0, { { "spr_infridge_corn" } } },
      { "donut",   1, 0, { { "spr_infridge_donut" } } },
      { "icefigure",   1, 0, { { "spr_infridge_icefigure" } } },

      { "cake",  1, 0, { { "spr_infridge_cake" } } },
      { "spoon",    1, 0, { { "spr_infridge_spoon" } } },
      { "lemon", 1, 0, { { "spr_infridge_lemon" } } },
      { "hook",    1, 0, { { "spr_infridge_hook" } } }
  };
    
  private.tasks_sh =  { 0, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0 };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ j ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );

    end;
    
    if private.tasks_sh[i] == 1 then
      
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ 1 ][ 1 ].."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_refrigerator_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_refrigerator_env");
	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_kitchen" );
    cmn.StartTimePassing("ho_infridge");
  else 
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_infridge_kitchen",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                      event_menter = function () rm_extra.GateMouseEnter( "infridge_kitchen", CURSOR_DOWN, "extra" ); end, 
                                      event_mleave = function () common_impl.GateMouseLeave( "infridge_kitchen" ); end });
    
  end;

  if not cmn.IsEventStart( "win_infridge" ) then
    cmn.InitHo( "infridge" );
  end;

  if (not cmn.IsEventDone("win_infridge")) then

    local ho_items = {};

    interface_impl.ItemPanelItemAdd( ho_items, "shrimp",      0, "spr_infridge_shrimp" );
    interface_impl.ItemPanelItemAdd( ho_items, "ginger",      0, "spr_infridge_ginger" );
    interface_impl.ItemPanelItemAdd( ho_items, "cheese",      0, "spr_infridge_cheese" );
    interface_impl.ItemPanelItemAdd( ho_items, "iceform",     0, "spr_infridge_iceform" );
    interface_impl.ItemPanelItemAdd( ho_items, "coconut",     0, "spr_infridge_coconut" );
    interface_impl.ItemPanelItemAdd( ho_items, "thermometer", 0, "spr_infridge_thermometer" );
    interface_impl.ItemPanelItemAdd( ho_items, "corn",        0, "spr_infridge_corn" );
    interface_impl.ItemPanelItemAdd( ho_items, "donut",       0, "spr_infridge_donut" );
    interface_impl.ItemPanelItemAdd( ho_items, "icefigure",   0, "spr_infridge_icefigure" );
    interface_impl.ItemPanelItemAdd( ho_items, "cake",        0, "spr_infridge_cake" );
    interface_impl.ItemPanelItemAdd( ho_items, "spoon",       0, "spr_infridge_spoon" );
    interface_impl.ItemPanelItemAdd( ho_items, "lemon",       0, "spr_infridge_lemon" );
    interface_impl.ItemPanelItemAdd( ho_items, "hook",        0, "spr_infridge_hook" );
  
    interface_impl.ItemPanelShow( ho_items );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
      
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_infridge_kitchen",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_infridge");

    if ng_global.progress[ ng_global.currentprogress ][ "win_infridge" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_infridge" ] then

      ng_global.nohintho[ "win_infridge" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_infridge" ] then
      ng_global.playedhops[ "win_infridge" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_infridge_kitchen",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  ObjDelete( "spr_infridge_"..item_name.."_shadow" );

  cmn.HoItemFind("spr_infridge_"..item_name, 1);

end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_infridge_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_infridge_items" );

    end;
    
  end;
  
end;
--*********************************************************************************************************************
