-- name=ho_intohollow
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_intohollow" );
  game.relations[ "ho_intohollow" ].exitroom = "rm_nearcastle";
  
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_intohollow" ] = 
  {
    type = "win",
    room = "rm_nearcastle",
    zz = "ho_intohollow",
    zz_gate = "gho_nearcastle_intohollow"
  };
  --------------------------------------------------------------------------------------------------
  local win_intohollow_func = function ()

    if ( cmn.IsEventDone( "win_intohollow" ) ) then
      common_impl.InventoryComplexItemAdd( "inv_secretparcel", "spr_intohollow_win" );
      ObjDelete("gho_nearcastle_intohollow");
    end;

  end;
  cmn.AddSubscriber( "win_intohollow", win_intohollow_func );
  --------------------------------------------------------------------------------------------------
  local start_intohollow_func = function ()

    if ( cmn.IsEventStart( "win_intohollow" ) ) then

      common_impl.ProcessHoStart( "intohollow", true );

    end;

  end;
  cmn.AddSubscriber( "win_intohollow", start_intohollow_func, "ho_intohollow" );
  
  --for secretroom
  private.tasks =  {    
  
      { "seashell",      1, 0, { { "spr_intohollow_seashell" } } },
      { "genie",    1, 0, { { "obj_intohollow_genie", "anm_intohollow_genie", "spr_intohollow_genie" } } },
      { "wand",      1, 0, { { "obj_intohollow_wand", "spr_intohollow_wand" } } },
      { "clover",     1, 0, { { "spr_intohollow_clover" } } },
      
      { "spindle",      1, 0, { { "spr_intohollow_spindle" } } },
      { "parcel",     1, 0, { { "spr_intohollow_parcel" } } },
      { "castle",   1, 0, { { "spr_intohollow_castle" } } },
      { "musket",   1, 0, { { "spr_intohollow_musket" } } },
      
      { "flower",  1, 0, { { "spr_intohollow_flower" } } },
      { "fan",    1, 0, { { "spr_intohollow_fan" } } },
      { "reed", 1, 0, { { "spr_intohollow_reed" } } },
      { "snail",    1, 0, { { "obj_intohollow_snail", "anm_intohollow_snail" } } }
      
  };
    
  private.actions = {
  
    { "use_holvl1rag", { "obj_intohollow_use_rag", "spr_intohollow_rag_sh", "spr_intohollow_rag", "anm_intohollow_use_rag", 
                         "obj_intohollow_lamp", "spr_intohollow_lamp", "obj_intohollow_lamp_shadow", "spr_intohollow_lamp_shadow",
                         "spr_intohollow_lamp_rag", "spr_intohollow_lamp_1_mud", "obj_intohollow_lamp_1", "gfx_intohollow_use_rag" } },
    { "use_holvl1hammer", { "obj_intohollow_use_hammer", "spr_intohollow_hammer_sh", "spr_intohollow_hammer", "anm_intohollow_use_hammer", "gfx_intohollow_use_hammer" } },
    { "use_holvl1seed", { "obj_intohollow_use_seed", "spr_intohollow_seed_sh", "spr_intohollow_seed", "anm_intohollow_use_seed", "gfx_intohollow_use_seed" } }
  
  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.tasks_sh =  { 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0 };

  private.start = {};
  private.start_sh = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName(private.tasks[ i ][ 4 ][1][1].."_shadow");
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_nearcastle_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_nearcastle_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_fire_env");
  	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  if ng_global.currentprogress == "std" then

    common.SetPreviousRoom( "rm_nearcastle" );
    cmn.StartTimePassing("ho_intohollow");
    
  else 
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("obj_intohollow_note_small",  { input = 1 });
    
    ObjSet("grm_intohollow_nearcastle",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                           event_menter = function () rm_extra.GateMouseEnter( "intohollow_nearcastle", CURSOR_DOWN, "extra" ); end, 
                                           event_mleave = function () common_impl.GateMouseLeave( "intohollow_nearcastle" ); end });
    
  end;

  if not cmn.IsEventStart( "win_intohollow" ) then
    
    cmn.InitHo( "intohollow" );
    
    if ng_global.currentprogress == "std" then
    
      cmn.SetMarkedTask( "intohollow", "genie" );
      cmn.SetMarkedTask( "intohollow", "castle" );
      cmn.SetMarkedTask( "intohollow", "flower" );
      
    else 
      
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "genie" ] = {};
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "genie" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "genie" ].start = 0;
      
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "castle" ] = {};
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "castle" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "castle" ].start = 0;
      
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "flower" ] = {};
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "flower" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intohollow" ].unmark[ "flower" ].start = 0;
      
    end;
    
  end;

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "seashell", 1, 0, { { "spr_intohollow_seashell" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "genie", 1, 1, { { "obj_intohollow_genie" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "wand", 1, 0, { { "obj_intohollow_wand" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "clover", 1, 0, { { "spr_intohollow_clover" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "spindle", 1, 0, { { "spr_intohollow_spindle" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "parcel", 1, 0, { { "spr_intohollow_parcel" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "castle", 1, 1, { { "spr_intohollow_castle" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "musket", 1, 0, { { "spr_intohollow_musket" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "flower", 1, 1, { { "spr_intohollow_flower" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "fan", 1, 0, { { "spr_intohollow_fan" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "reed", 1, 0, { { "spr_intohollow_reed" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "snail", 1, 0, { { "obj_intohollow_snail" } } );
  
  if cmn.IsEventDone("use_holvl1rag") then
    ObjSet("anm_intohollow_genie",  { playing = 1 });
  else 
    ObjSet("anm_intohollow_genie",  { playing = 0, frame = 0 });
  end;

  if (not cmn.IsEventDone("win_intohollow")) then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjMultiSet( { {"grm_intohollow_nearcastle", { input = 0 }},
                   {"obj_intohollow_note_small", { input = 0 }} } );
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
  
  cmn.HideNote( 0 );
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_intohollow");

    if ng_global.progress[ ng_global.currentprogress ][ "win_intohollow" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_intohollow" ] then

      ng_global.nohintho[ "win_intohollow" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_intohollow" ] then
      ng_global.playedhops[ "win_intohollow" ] = 1;
    end;
    
  else 
    
    ObjMultiSet( { {"grm_intohollow_nearcastle", { input = 0 }},
                   {"obj_intohollow_note_small", { input = 0 }} } );
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( spr_name, item_name, name_type )
  
  if item_name == "lamp" or item_name == "castle" or item_name == "flower" then
    local pos = GetObjPosByObj( spr_name );
    ObjSet( spr_name, { pos_x = pos[1] + 171, pos_y = pos[2] } );
  end;
  
  cmn.HoTaskFind( spr_name, item_name, name_type );
  
  if ObjGet("spr_intohollow_"..item_name.."_shadow") then
    ObjDelete(spr_name.."_shadow");
  end;

end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_holvl1rag", "use_holvl1hammer", "use_holvl1seed" };

  --------------------------------------------------------------------------------------------
  -- function use_holvl1rag () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl1rag" ] = {
      type = "use",
      inv_obj = "spr_intohollow_rag",
      use_place = "obj_intohollow_use_rag",
      room = "rm_nearcastle",
      zz = "ho_intohollow",
      zz_gate = "gho_nearcastle_intohollow"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl1rag_beg = function ()
  
    ObjDelete( "obj_intohollow_use_rag" );
    ObjDelete( "spr_intohollow_rag_sh" );
    ObjDelete( "spr_intohollow_rag" );
  
  end;
  local use_holvl1rag_end = function ()
    
    ObjDelete("anm_intohollow_use_rag");
    ObjDelete("spr_intohollow_lamp_rag");
    ObjDelete("spr_intohollow_lamp_1_mud");
  
    ObjMultiSet( { {"obj_intohollow_lamp_1", { alp = 1 }},
                   {"obj_intohollow_genie", { alp = 1, input = 1 }},
                   {"spr_intohollow_genie", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl1rag", use_holvl1rag_beg, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1rag", use_holvl1rag_end, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1rag_beg", use_holvl1rag_beg, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1rag_end", use_holvl1rag_end, "ho_intohollow" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl1hammer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl1hammer" ] = {
      type = "use",
      inv_obj = "spr_intohollow_hammer",
      use_place = "obj_intohollow_use_hammer",
      room = "rm_nearcastle",
      zz = "ho_intohollow",
      zz_gate = "gho_nearcastle_intohollow"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl1hammer_beg = function ()
  
    ObjDelete( "obj_intohollow_use_hammer" );
    ObjDelete( "spr_intohollow_hammer_sh" );
    ObjDelete( "spr_intohollow_hammer" );
  
  end;
  local use_holvl1hammer_end = function ()
  
    ObjMultiSet( { {"anm_intohollow_use_hammer", { frame = 400 }},
                   {"spr_intohollow_castle", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl1hammer", use_holvl1hammer_beg, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1hammer", use_holvl1hammer_end, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1hammer_beg", use_holvl1hammer_beg, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1hammer_end", use_holvl1hammer_end, "ho_intohollow" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl1seed () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl1seed" ] = {
      type = "use",
      inv_obj = "spr_intohollow_seed",
      use_place = "obj_intohollow_use_seed",
      room = "rm_nearcastle",
      zz = "ho_intohollow",
      zz_gate = "gho_nearcastle_intohollow"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl1seed_beg = function ()
  
    ObjDelete( "obj_intohollow_use_seed" );
    ObjDelete( "spr_intohollow_seed_sh" );
    ObjDelete( "spr_intohollow_seed" );
  
  end;
  local use_holvl1seed_end = function ()
  
    ObjMultiSet( { {"anm_intohollow_use_seed", { frame = 400 }},
                   {"spr_intohollow_flower", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl1seed", use_holvl1seed_beg, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1seed", use_holvl1seed_end, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1seed_beg", use_holvl1seed_beg, "ho_intohollow" );
  cmn.AddSubscriber( "use_holvl1seed_end", use_holvl1seed_end, "ho_intohollow" );
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.start_drag( name )

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach("spr_intohollow_"..name, "obj_intohollow_drag_fly");

  if name == "hammer" then
    ObjSet("spr_intohollow_"..name,  { ang = -2.54 });
  end;
  
  ObjAnimate("spr_intohollow_"..name.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });

end;
------------------------------------------------------------------------------
function public.use_hammer()

  item = "spr_intohollow_hammer";

  if ( cmn.ApplyObj( item, "obj_intohollow_use_hammer" ) ) then

    cmn.CallEventHandler( "use_holvl1hammer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl1hammer" );
      cmn.CallEventHandler( "use_holvl1hammer_end" );

      cmn.UnmarkTask( "intohollow", "castle" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_intohollow/audio/aud_hammer" );

    ObjSet("anm_intohollow_use_hammer",  { playing = 1, endtrig = func_after });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intohollow");
    ObjSet(item,  { ang = 0 });
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_seed()

  item = "spr_intohollow_seed";

  if ( cmn.ApplyObj( item, "obj_intohollow_use_seed" ) ) then

    cmn.CallEventHandler( "use_holvl1seed_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl1seed" );
      cmn.CallEventHandler( "use_holvl1seed_end" );

      cmn.UnmarkTask( "intohollow", "flower" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_intohollow/audio/aud_sprout" );

    ObjSet("anm_intohollow_use_seed",  { playing = 1, endtrig = func_after });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intohollow");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_rag()

  item = "spr_intohollow_rag";

  if ( cmn.ApplyObj( item, "obj_intohollow_use_rag" ) ) then

    cmn.CallEventHandler( "use_holvl1rag_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl1rag" );
      cmn.CallEventHandler( "use_holvl1rag_end" );
      
      ObjSet("anm_intohollow_genie",  { playing = 1 });

      cmn.UnmarkTask( "intohollow", "genie" );

    end;
    
    local anm_rag = function ()
      ObjSet("anm_intohollow_use_rag",  { alp = 1, playing = 1, endtrig = func_after });
      ObjSet("obj_intohollow_lamp_1",  { alp = 0 });
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio( "snd", "assets/levels/level1/ho_intohollow/audio/aud_genie" );

    ObjAnimate("spr_intohollow_lamp_rag", "alp", 0, 0, anm_rag, { 0, 0, 0,   0.3, 0, 1 });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intohollow");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "gfx" then
            typ = "partsys_gm";
          elseif typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;

end;
--*********************************************************************************************************************
