-- name=ho_inwardrobe
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_inwardrobe" );
  game.relations[ "ho_inwardrobe" ].exitroom = "rm_bedroom";
  
  public.change_stage_anim_type = "alp";
  public.task_count_show = 13;
  public.tasks_img = { "socks", "gloves", "shoes", "diploma", "figures", "tennis" };
  
  private.cur_progress = "std";
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------
  game.inwardrobe = {};
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_inwardrobe" ] = 
  {
    type = "win",
    room = "rm_bedroom",
    zz = "ho_inwardrobe",
    zz_gate = "gho_bedroom_inwardrobe"
  };
  --------------------------------------------------------------------------------------------------
  local win_inwardrobe_func = function ()

    if ( cmn.IsEventDone( "win_inwardrobe" ) ) then
      common_impl.InventoryComplexItemAdd( "inv_purse", "spr_inwardrobe_win" );
      ObjDelete("gho_bedroom_inwardrobe");
      
      ObjSet("spr_bedroom_ho_box_open",  { alp = 1 });
      ObjDelete("spr_bedroom_ho_objects");
      ObjDelete("spr_bedroom_ho_box_closed");
      ObjDelete("spr_bedroom_ho_purse");
    end;

  end;
  cmn.AddSubscriber( "win_inwardrobe", win_inwardrobe_func );
  --------------------------------------------------------------------------------------------------
  local start_inwardrobe_func = function ()

    if ( cmn.IsEventStart( "win_inwardrobe" ) ) then

      common_impl.ProcessHoStart( "inwardrobe", true );

    end;

  end;
  cmn.AddSubscriber( "win_inwardrobe", start_inwardrobe_func, "ho_inwardrobe" );
    
  --for secretroom
  private.tasks =  {    
      { "socks",      1, 0, { { "spr_inwardrobe_socks", "spr_inwardrobe_socks_2" } } },
      { "dreamcatcher",      1, 0, { { "spr_inwardrobe_dreamcatcher" } } },
      { "gloves",      1, 0, { { "spr_inwardrobe_gloves", "spr_inwardrobe_gloves_2" } } },
      { "hat",      1, 0, { { "spr_inwardrobe_hat" } } },

      { "shoes",      1, 0, { { "spr_inwardrobe_shoes", "spr_inwardrobe_shoes_2_shadow", "spr_inwardrobe_shoes_2" } } },
      { "belt",     1, 0, { { "spr_inwardrobe_belt" } } },
      { "diploma",   1, 0, { { "spr_inwardrobe_diploma", "spr_inwardrobe_diploma_2" } } },
      { "glasses",   1, 0, { { "spr_inwardrobe_glasses" } } },

      { "figures",  1, 0, { { "spr_inwardrobe_figures", "spr_inwardrobe_figures_2" } } },
      { "umbrella",    1, 0, { { "spr_inwardrobe_umbrella" } } },
      { "tennis", 1, 0, { { "spr_inwardrobe_tennis", "spr_inwardrobe_tennis_2" } } },
      { "book",    1, 0, { { "spr_inwardrobe_book" } } },
      { "purse",    1, 0, { { "spr_inwardrobe_purse" } } }
  };
  
  private.tasks_sh =  { 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 1 };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1,  #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if i < 13 and i % 2 > 0 then

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img_2";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] ).."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "std" and not ( ng_global.progress[ "std" ][ "win_inwardrobe" ].stage ) then
    ng_global.progress[ "std" ][ "win_inwardrobe" ].stage = { 1, 13 };   --[1] - номер стадии, [2] - количество стадий
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].stage = { 1, 13 };
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_bedroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_bedroom_env");
    if port.isPortable() == 1 then
    iOS_EnableMultiTouch(1); 
  end;
  if ng_global.currentprogress == "std" then

    private.cur_progress = "std";
    
    common.SetPreviousRoom( "rm_bedroom" );
    cmn.StartTimePassing("ho_inwardrobe");
    
  else 
    
    private.cur_progress = "secret";
    public.task_count_show = 13;
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].stage = { 1, 13 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_inwardrobe_bedroom",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "inwardrobe_bedroom", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "inwardrobe_bedroom" ); end });
    
  end;

  if not cmn.IsEventStart( "win_inwardrobe" ) then
    cmn.InitHo( "inwardrobe" );
  end;

  local ho_tasks = private.stages_task();
  
  if ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].stage[1] == 13 then
    ObjDelete("spr_inwardrobe_box_closed");
    ObjMultiSet( { {"obj_inwardrobe_box_open", { alp = 1, input = 1 }},
                   {"spr_inwardrobe_purse", { input = 1 }},
                   {"obj_inwardrobe_lock", { input = 0 }} } );
  else 
    ObjMultiSet( { {"obj_inwardrobe_box_open", { alp = 0, input = 0 }},
                   {"spr_inwardrobe_purse", { input = 0 }},
                   {"spr_inwardrobe_box_closed", { alp = 1 }} } );               
  end;                 

  if (not cmn.IsEventDone("win_inwardrobe"))
  and ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);

  if ng_global.currentprogress == "std" and ng_global.progress[ "std" ][ "win_inwardrobe" ].stage[1] == 1 and not(cmn.IsEventDone("tutor_19")) then

    local arrows = { { pos_x = 340, pos_y = -180, ang = -0.42 }, { pos_x = 100, pos_y = 200, ang = 3.14 } };
    cmn.TutorialShow( "tutor_19", 0, 512, 450, arrows );

  end;
  
  if ng_global.currentprogress == "std" and ng_global.progress[ "std" ][ "win_inwardrobe" ].stage[1] == 2 and not(cmn.IsEventDone("tutor_18")) then

    local arrows = { { pos_x = 340, pos_y = 0, ang = -1.57 }, { pos_x = 100, pos_y = 220, ang = 3.14 } };
    cmn.TutorialShow( "tutor_18", 0, 512, 440, arrows );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_inwardrobe_bedroom",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()

  cmn.HideNote( 0 );
  
  if ng_global.progress[ private.cur_progress ][ "win_inwardrobe" ].stage[1] < ng_global.progress[ private.cur_progress ][ "win_inwardrobe" ].stage[2] and
     ng_global.progress[ private.cur_progress ][ "win_inwardrobe" ].stage[1] % 2 > 0 then
    
    local st = (ng_global.progress[ private.cur_progress ][ "win_inwardrobe" ].stage[1]+1)/2;
    
    ObjDetach("spr_inwardrobe_"..public.tasks_img[st].."_task_img");
    
  end;
    
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_inwardrobe");

    if ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_inwardrobe" ] then

      ng_global.nohintho[ "win_inwardrobe" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_inwardrobe" ] then
      ng_global.playedhops[ "win_inwardrobe" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_inwardrobe_bedroom",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemUse( item_name, task_name )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  if ( cmn.ApplyObj( item_name.."_task_img_2", item_name ) ) then
    
    local func_after = function ()

      cmn.Lock( 0 );

      public.ItemFound( item_name, task_name );
    
    end;

    cmn.Lock( 1, { room = 1 } );
    
    ObjSet( item_name.."_task_img",  { alp = 0, input = false } );
    
    ObjAnimate( item_name.."_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    
    if task_name == "shoes" then
      ObjAnimate( item_name.."_2_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )
  
  ObjDelete( item_name.."_shadow" );
  
  if task_name == "shoes" then
    ObjDelete( item_name.."_2_shadow" );
  end;
  
  cmn.HoTaskFind( item_name, task_name, 1 );

end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_inwardrobe" ].stage[1];

  if     ( ho_stage == 1 ) then

    game.inwardrobe.double_hint = { { "spr_inwardrobe_socks",  "spr_inwardrobe_socks_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "socks", 1, 0, { { "spr_inwardrobe_socks" } } );

    ObjSet( "spr_inwardrobe_socks", { input = 1 } );

  elseif ( ho_stage == 2 ) then

    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "dreamcatcher", 1, 0, { { "spr_inwardrobe_dreamcatcher" } } );
    ObjSet( "spr_inwardrobe_dreamcatcher", { input = 1 } );
    
  elseif ( ho_stage == 3 ) then
    
    game.inwardrobe.double_hint = { { "spr_inwardrobe_gloves",  "spr_inwardrobe_gloves_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "gloves", 1, 0, { { "spr_inwardrobe_gloves" } } );

    ObjSet( "spr_inwardrobe_gloves", { input = 1 } );

  elseif ( ho_stage == 4 ) then
    
    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "hat", 1, 0, { { "spr_inwardrobe_hat" } } );
    ObjSet( "spr_inwardrobe_hat", { input = 1 } );
    
  elseif ( ho_stage == 5 ) then
    
    game.inwardrobe.double_hint = { { "spr_inwardrobe_shoes",  "spr_inwardrobe_shoes_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "shoes", 1, 0, { { "spr_inwardrobe_shoes" } } );
    
    ObjSet( "spr_inwardrobe_shoes", { input = 1 } );

  elseif ( ho_stage == 6 ) then
    
    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "belt", 1, 0, { { "spr_inwardrobe_belt" } } );
    ObjSet( "spr_inwardrobe_belt", { input = 1 } );
    
  elseif ( ho_stage == 7 ) then
    
    game.inwardrobe.double_hint = { { "spr_inwardrobe_diploma",  "spr_inwardrobe_diploma_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "diploma", 1, 0, { { "spr_inwardrobe_diploma" } } );

    ObjSet( "spr_inwardrobe_diploma", { input = 1 } );

  elseif ( ho_stage == 8 ) then
    
    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "glasses", 1, 0, { { "spr_inwardrobe_glasses" } } );
    ObjSet( "spr_inwardrobe_glasses", { input = 1 } );
    
  elseif ( ho_stage == 9 ) then
    
    game.inwardrobe.double_hint = { { "spr_inwardrobe_figures",  "spr_inwardrobe_figures_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "figures", 1, 0, { { "spr_inwardrobe_figures" } } );

    ObjSet( "spr_inwardrobe_figures", { input = 1 } );

  elseif ( ho_stage == 10 ) then
    
    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "umbrella", 1, 0, { { "spr_inwardrobe_umbrella" } } );
    ObjSet( "spr_inwardrobe_umbrella", { input = 1 } );
    
  elseif ( ho_stage == 11 ) then
    
    game.inwardrobe.double_hint = { { "spr_inwardrobe_tennis",  "spr_inwardrobe_tennis_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "tennis", 1, 0, { { "spr_inwardrobe_tennis" } } );

    ObjSet( "spr_inwardrobe_tennis", { input = 1 } );

  elseif ( ho_stage == 12 ) then
    
    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "book", 1, 0, { { "spr_inwardrobe_book" } } );
    ObjSet( "spr_inwardrobe_book", { input = 1 } );
    
  elseif ( ho_stage == 13 ) then
    
    game.inwardrobe.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "purse", 1, 0, { { "spr_inwardrobe_purse" } } );
    
  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function public.stage_2()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone("tutor_18")) then

    local arrows = { { pos_x = 340, pos_y = 0, ang = -1.57 }, { pos_x = 100, pos_y = 220, ang = 3.14 } };
    cmn.TutorialShow( "tutor_18", 0, 512, 440, arrows );

  end;
  
end;
------------------------------------------------------------------------------
function public.stage_3()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_4()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_5()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_6()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_7()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_8()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_9()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_10()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_11()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_12()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_13()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  local func_after = function ()
  
    ObjMultiSet( { {"obj_inwardrobe_box_open", { input = 1 }},
                   {"spr_inwardrobe_purse", { input = 1 }},
                   {"obj_inwardrobe_lock", { input = 0 }} } );
  
  end;
  
  ObjSet("obj_inwardrobe_lock",  { input = 1 });
  
  cmn.PlayAudio("snd", "assets/levels/level1/ho_inwardrobe/audio/aud_opn_basket");
  
  ObjAnimate("obj_inwardrobe_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("spr_inwardrobe_box_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.touch_bag( num )
  
  local func_after = function ()
  
    ObjMultiSet( { {"anm_inwardrobe_bag_"..num, { alp = 1, playing = 1 }},
                   {"anm_inwardrobe_bag_"..num.."_touch", { alp = 0 }},
                   {"obj_inwardrobe_bag_"..num.."_touch",  { input = 1 }} } );
  
  end;
  
  ObjSet("obj_inwardrobe_bag_"..num.."_touch",  { input = 0 });
  cmn.PlayAudio("snd", "assets/levels/level1/ho_inwardrobe/audio/aud_xx_bag");
  
  ObjMultiSet( { {"anm_inwardrobe_bag_"..num, { alp = 0, playing = 0 }},
                 {"anm_inwardrobe_bag_"..num.."_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"obj_inwardrobe_bag_"..num.."_touch",  { input = 0 }} } );
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do

    if not ObjGet( ho_itm[i].name ) then

      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------

