-- name=mg_memories
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_memories";
  --------------------------------------------------------------------------------------------
  private.cloud_range = { 45, 505 }; --pos_y
  private.thread_range = { 1, 7 }; --scale_y
  private.win_state = { { 0.9, 0.5, 0.2 } , { 0.2, 0.8, 0.5 }, { 0.3, 0.6, 0.8 } };
  private.start_state = { { 0.7, 0.2, 0.6 } , { 0.7, 0.1, 0.2 }, { 0.7, 0.2, 0.3 } };
  private.current_cloud = 0;
  private.cloud_start_y = 0;
  private.temp_y = 0;
  
  private.pic_count = {8, 12, 16};
  private.voice_time = {11.1, 7, 9.1};
  
  --на какие картинки в каждом этапе действует облако y, x, alp and scale
  private.clouds_move = { { {1, 2, 4, 6, 8}, {1, 2, 3, 5, 7, 8}, {1, 3, 4, 5, 7, 8} },
   { {2, 3, 5, 6, 7, 9, 10, 12}, {1, 3, 4, 5, 7, 9, 11}, {1, 2, 4, 5, 6, 8, 9, 10, 11, 12} },
   { {1, 2, 4, 6, 8, 11, 12, 15, 16}, {2, 3, 5, 6, 7, 8, 9, 10, 12, 14}, {1, 3, 4, 5, 7, 8, 11, 12, 13, 14, 15, 16} }  };
   
  private.pic_scale = { 0.2, 1 }; 
   
  --параметры движения картинок [1] - win pos, [2] - direction, [3] - range
  private.pic_move = { { { {230, 1, 230}, {194, -1, 260}, {356, -1, 280}, {445, 1, 150}, {393, -1, 100} }, 
                         { {408, -1, 400}, {539, 1, 300}, {670, -1, 310}, {538, -1, 150}, {687, 1, 220}, {757, -1, 100} }, 
                         { {1, -1}, {1, 1}, {1, 1}, {1, -1}, {0, 1}, {0, -1} } },
                         
    { { {295, -1, 200}, {340, -1, 120}, {430, 1, 100}, {466, -1, 220}, {421, 1, 160}, {137, 1, 230}, {166, -1, 100}, {439, -1, 300} },
      { {555, 1, 300}, {556, -1, 250}, {686, -1, 320}, {687, 1, 200}, {424, 1, 100}, {449, -1, 140}, {277, -1, 240} },
      { {1, -1}, {1, -1}, {1, 1}, {1, 1}, {1, 1}, {1, -1}, {0, 1}, {0, -1}, {0, 1}, {0, -1} } },
      
    { { {231, 1, 200}, {286, -1, 120}, {283, -1, 100}, {348, 1, 180}, {412, -1, 220}, {136, 1, 160}, {540, -1, 200}, {397, -1, 130}, {120, -1, 80} },
      { {464, -1, 200}, {595, -1, 320}, {727, -1, 240}, {595, 1, 280}, {595, -1, 100}, {464, 1, 200}, {464, 1, 160}, {333, -1, 220}, {741, -1, 80}, {318, 1, 200} },
      { {1, 1}, {1, 1}, {1, -1}, {1, 1}, {1, -1}, {1, 1}, {0, -1}, {0, -1}, {0, -1}, {0, 1}, {0, 1}, {0, 1} } } };
  --------------------------------------------------------------------------------------------
  -- function win_memories () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_memories" ] = {
    type = "win",
    room = "rm_nearhome",
    zz = "mg_memories",
    zz_gate = "gmg_nearhome_memories"
  };
  --------------------------------------------------------------------------------------------
  local win_memories_mg = function ()

    if cmn.IsEventDone( "win_memories" ) then
      ObjSet("obj_memories_control",  { input = 0 });
    end;

  end;
  local win_memories_loc = function ()
  
    if cmn.IsEventDone( "win_memories" ) then
      ObjMultiSet( { {"anm_clockatentrace_win_mg", { alp = 1 }},
                     {"gzz_nearhome_clockatentrace", { alp = 1, input = 1, active = 1 }},
                     {"obj_clockatentrace_after_win", { alp = 1 }} } );
      ObjDelete("gmg_nearhome_memories"); 
      ObjDelete("spr_nearhome_clock_memories"); 
      ObjDelete("spr_clockatentrace_number12"); 
      ObjDelete("obj_clockatentrace_clock"); 
    end;

  end;
  local win_memories_end = function ()
  
    if cmn.IsEventDone( "win_memories" ) then
      ObjDelete( "spr_nearhome_clock_gears" );
      ObjDelete( "spr_nearhome_clock_hands" );
      ObjMultiSet( { {"obj_clockatentrace_after_win", { input = 1 }},
                     {"anm_clockatentrace_win_mg", { frame = 400 }} } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_memories", win_memories_mg, "mg_memories" );
  cmn.AddSubscriber( "win_memories", win_memories_loc, "rm_nearhome" );
  cmn.AddSubscriber( "win_memories", win_memories_end, "rm_nearhome" );
  cmn.AddSubscriber( "win_memories_mg", win_memories_mg, "mg_memories" );
  cmn.AddSubscriber( "win_memories_loc", win_memories_loc, "rm_nearhome" );
  cmn.AddSubscriber( "win_memories_end", win_memories_end, "rm_nearhome" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_memories" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_memories");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;
  
  --if not(cmn.IsEventDone( "opn_memories" )) then
  --  cmn.SetEventDone("opn_memories");
  --  private.AnimStart();
  --end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_clock_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_clock_env");
  
  if ng_global.currentprogress == "std" then
  
    common.SetPreviousRoom( "rm_nearhome" );
    
    if not(cmn.IsEventDone( "opn_memories" )) then
      cmn.Lock(1);
    end;
    
  else 
    
    cmn.Lock(1);
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_memories" ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "opn_memories" ].start = 0;
    
    private.StartConditions();
    
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;
    
    ObjSet("grm_memories_nearhome",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                       event_menter = function () rm_extra.GateMouseEnter( "memories_nearhome", CURSOR_DOWN, "extra" ); end, 
                                       event_mleave = function () common_impl.GateMouseLeave( "memories_nearhome" ); end });
                                     
  end;
                                         
  private.DrawScene();                                       
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  SndStop( common_impl.audio.voc, 0.5 );
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_memories" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_memories" )) then
    rm_extra.MiniGameHide();
  end;
  
  if ng_global.currentprogress == "secret" then
    ObjSet("grm_memories_nearhome",  { input = 0 });
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = true;
  
  local stage = private.state[2];
  
  for i = 1, 3, 1 do
    
    ObjSet("spr_memories_stage_"..i.."_win",  { alp = 0 });
    
    if private.state[1][i] ~= private.start_state[ stage ][i] then
      
      --if not need_r then
      --  need_r = true;
      --end;
    
      local old_pos = private.state[1][i];
      local new = private.start_state[stage][i];
      
      local py_new = private.cloud_range[1] + new*(private.cloud_range[2]-private.cloud_range[1]);
      local py_old = private.cloud_range[1] + old_pos*(private.cloud_range[2]-private.cloud_range[1]);
      
      local sy_new = private.thread_range[1] + new*(private.thread_range[2]-private.thread_range[1]);
      local sy_old = private.thread_range[1] + old_pos*(private.thread_range[2]-private.thread_range[1]);
      
      ObjAnimate("spr_memories_cloud_"..i, "pos_y", 0, 0, "", { 0, 0, py_old,   0.5, 0, py_new });
      ObjAnimate("spr_memories_thread_"..i, "scale_y", 0, 0, "", { 0, 0, sy_old,   0.5, 0, sy_new });
      
    end;
    
  end;
  
  --if stage > 1 then
  --  
  --  if not need_r then
  --    need_r = true;
  --  end;
  --  
  --  for i = 1, 3, 1 do
  --    private.state[1][i] = private.start_state[1][i];
  --  end;
  --  
  --  private.state[2] = 1;
  --  
  --  --private.SetPicturesState( 1, false );
  --  private.SetPicturesState( stage, true );
  --  
  --  ObjMultiSet( { {"obj_memories_stage_1_pics", { alp = 0 }},
  --                 {"spr_memories_stage_1_start", { alp = 1 }} } );
  --  
  --  ObjAnimate("obj_memories_stage_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  --  ObjAnimate("obj_memories_stage_"..stage, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  --  
  --else 
    
    --need_r = true;
    private.SetPicturesState( stage, true );
    
    for i = 1, 3, 1 do
      
      if private.state[1][i] ~= private.win_state[stage][i] then
        
        for j = 1, #private.pic_move[ stage ][i], 1 do
        
          local cur_pos = private.ReturnNewPos( i, j, private.state[1][i] );
          local new_pos = private.ReturnNewPos( i, j, private.win_state[stage][i] );
          
          if i == 1 then
            ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "pos_y", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
          elseif i == 2 then
            ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "pos_x", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
          elseif i == 3 then
            
            local scale, new_scale = cur_pos, new_pos;
            if scale < private.pic_scale[1] then
              scale = private.pic_scale[1];
            end;
            
            if new_scale < private.pic_scale[1] then
              new_scale = private.pic_scale[1];
            end;
            
            ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "alp", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
            ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "scale_xy", 0, 0, "", { 0, 0, scale, scale,   0.5, 0, new_scale, new_scale });
            
          end;
          
        end;
        
      end;
      
    end;
    
    for i = 1, private.pic_count[ stage ], 1 do
    
      local perc_y, perc_x, black;
      
      if private.CheckPicForCloudMovement( stage, 1, i ) then
        perc_y = math.abs(private.state[ 1 ][1]-private.win_state[ stage ][1]);
      else 
        perc_y = 0;
      end;
      
      if private.CheckPicForCloudMovement( stage, 2, i ) then
        perc_x = math.abs(private.state[ 1 ][2]-private.win_state[ stage ][2]);
      else 
        perc_x = 0;
      end;
      
      if perc_x > 0 and perc_y > 0 then
        black = (perc_y+perc_x)/2;
      elseif perc_x == 0 then
        black = perc_y;
      elseif perc_y == 0 then
        black = perc_x;
      end;
      
      ObjAnimate("spr_memories_picture_"..stage.."_"..i.."_black", "alp", 0, 0, "", { 0, 0, black,   0.5, 0, 1 });
      
    end;
    
    ObjAnimate("spr_memories_stage_"..stage.."_start", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
  --end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_rope"..math.random(6));
    
    --private.StartConditions();
    --private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;
    
    for i = 1, 3, 1 do
      private.state[1][i] = private.start_state[stage][i];
    end;
    private.state[3][stage] = 0;
    
    ObjSet("tmr_memories_timer",  { time = 0.5, playing = 1, endtrig = function() private.DrawScene(); end });
    
  end;
    
    
end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_rope"..math.random(6));
  
  ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state = { { 0.9, 0.2, 0.4 }, 3, {1, 1, 1} };
  
  local stage = private.state[2];
  
  for i = 1, 3, 1 do
    
    if private.state[1][i] ~= private.win_state[stage][i] then
      
      local old_pos = private.state[1][i];
      local new = private.win_state[stage][i];
      
      local py_new = private.cloud_range[1] + new*(private.cloud_range[2]-private.cloud_range[1]);
      local py_old = private.cloud_range[1] + old_pos*(private.cloud_range[2]-private.cloud_range[1]);
      
      local sy_new = private.thread_range[1] + new*(private.thread_range[2]-private.thread_range[1]);
      local sy_old = private.thread_range[1] + old_pos*(private.thread_range[2]-private.thread_range[1]);
      
      ObjAnimate("spr_memories_cloud_"..i, "pos_y", 0, 0, "", { 0, 0, py_old,   0.5, 0, py_new });
      ObjAnimate("spr_memories_thread_"..i, "scale_y", 0, 0, "", { 0, 0, sy_old,   0.5, 0, sy_new });
      
    end;
    
  end;
  
  for i = 1, 3, 1 do
    
    if private.state[1][i] ~= private.win_state[stage][i] then
    
      for j = 1, #private.pic_move[ stage ][i], 1 do
      
        local cur_pos = private.ReturnNewPos( i, j, private.state[1][i] );
        local new_pos = private.ReturnNewPos( i, j, private.win_state[stage][i] );
        
        if i == 1 then
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "pos_y", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
        elseif i == 2 then
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "pos_x", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
        elseif i == 3 then
          
          local scale, new_scale = cur_pos, new_pos;
          if scale < private.pic_scale[1] then
            scale = private.pic_scale[1];
          end;
          
          if new_scale < private.pic_scale[1] then
            new_scale = private.pic_scale[1];
          end;
          
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "alp", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "scale_xy", 0, 0, "", { 0, 0, scale, scale,   0.5, 0, new_scale, new_scale });
          
        end;
        
      end;
      
    end;
    
  end;
  
  local stage_3_win = function ()
    
    cmn.ShowDlgBbt( "memories_cheshire_voc_3", 1 );
    cmn.PlayAudio("voc", "assets/levels/level1/mg_memories/audio/aud_memories_1_4_voc");
    
    ObjSet("spr_memories_stage_3_win",  { alp = 1 });
    ObjAnimate("obj_memories_stage_3", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });
    
    ObjSet("tmr_memories_timer",  { time = private.voice_time[3], playing = 1, endtrig = private.Win });
    
  end;
  
  local stage_2_win = function ()
    
    cmn.ShowDlgBbt( "memories_cheshire_voc_2", 1 );
    cmn.PlayAudio("voc", "assets/levels/level1/mg_memories/audio/aud_memories_1_3_voc");
    
    ObjSet("spr_memories_stage_2_win",  { alp = 1 });
    ObjAnimate("obj_memories_stage_2", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });
    
    ObjSet("tmr_memories_timer",  { time = private.voice_time[2], playing = 1, endtrig = stage_3_win });
    
  end;
  
  local anim_stage_win = function ()
  
    cmn.MiniGameHide();
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
    cmn.EndTimePassing( "mg_memories" );
    
    local func = stage_2_win;
    if stage == 2 then
      func = stage_3_win;
    elseif stage == 3 then
      func = private.Win;
    end;
    
    cmn.ShowDlgBbt( "memories_cheshire_voc_"..stage, 1 );
    cmn.PlayAudio("voc", "assets/levels/level1/mg_memories/audio/aud_memories_1_"..(stage+1).."_voc");
    
    ObjAnimate("spr_memories_stage_"..stage.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjSet("tmr_memories_timer",  { time = private.voice_time[stage], playing = 1, endtrig = func });
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;
  
  ObjSet("tmr_memories_timer",  { time = 0.5, playing = 1, endtrig = anim_stage_win });

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state = { { 0.7, 0.2, 0.6 }, 1, {0, 0, 0} }; --[1] - clouds pos in percent, [2] - stage, [3] - stage started

end;
-----------------------------------------------------------------------------------
function private.AnimStart()
  
  cmn.ShowDlgBbt( "memories_cheshire_voc_0", 1 );
  cmn.PlayAudio("voc", "assets/levels/level1/mg_memories/audio/aud_memories_1_1_voc");
  
  ObjAnimate("spr_memories_cloud_1_on", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1,  0.9, 0, 0 });
  ObjAnimate("spr_memories_cloud_2_on", "alp", 0, 0, "", { 0, 0, 0,   0.6, 0, 0,   0.9, 0, 1,  1.2, 0, 1,  1.5, 0, 0 });
  ObjAnimate("spr_memories_cloud_3_on", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   1.2, 0, 0,   1.5, 0, 1,  1.8, 0, 1,  2.1, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  private.SetPicturesState( private.state[2], true );
  
  for i = 1, private.pic_count[ private.state[2] ], 1 do
    ObjSet("spr_memories_picture_"..private.state[2].."_"..i,  { pos_x = 0, pos_y = 0 });
  end;
  
  for i = 1, 3, 1 do
    
    ObjMultiSet( { {"spr_memories_cloud_"..i, { pos_y = private.cloud_range[1] + private.state[1][i]*(private.cloud_range[2]-private.cloud_range[1]) }},
                   {"spr_memories_thread_"..i, { scale_y = private.thread_range[1] + private.state[1][i]*(private.thread_range[2]-private.thread_range[1]) }} } );
    
  end;
                 
  for i = 1, 3, 1 do
    
    if i == private.state[2] then
      ObjSet("obj_memories_stage_"..i,  { alp = 1 });    
    else 
      ObjSet("obj_memories_stage_"..i,  { alp = 0 });   
    end;
    
  end;
  
  --stage started - set user ositions
  if private.state[3][ private.state[2] ] == 1 then
    private.SetPicturesState( private.state[2], false );
    ObjSet("obj_memories_stage_"..private.state[2].."_pics",  { alp = 1 });  
  --stage not started - show start anim
  else 
    cmn.Lock(1);
    private.state[3][ private.state[2] ] = 1;
    private.SetStageStartPos( private.state[2] );
    private.StageStartAnim( private.state[2] );
  end;
  
  if ng_global.currentprogress == "secret" then
    ObjMultiSet( { {"spr_memories_stage_1_win", { alp = 0 }},
                   {"spr_memories_stage_2_win", { alp = 0 }},
                   {"spr_memories_stage_3_win", { alp = 0 }} } );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckPicForCloudMovement( stage, cloud, pic )
  
  local check = false;
  
  for i = 1, #private.clouds_move[ stage ][cloud], 1 do
    
    if private.clouds_move[ stage ][cloud][i] == pic then
      check = true;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.SetStageStartPos( stage )
  
  private.SetPicturesState( stage, true );
  
  for i = 1, private.pic_count[stage], 1 do
    ObjSet("spr_memories_picture_"..stage.."_"..i,  { pos_x = 0, pos_y = 0 });
  end;
  
  for i = 1, 3, 1 do
    for j = 1, #private.pic_move[ stage ][i], 1 do
      
      local cur_pos = private.ReturnNewPos( i, j, private.win_state[ stage ][i] );
      
      if i == 1 then
        ObjSet("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j],  { pos_y = cur_pos });
      elseif i == 2 then
        ObjSet("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j],  { pos_x = cur_pos });
      elseif i == 3 then
        
        local scale = cur_pos;
        if scale < private.pic_scale[1] then
          scale = private.pic_scale[1];
        end;
        
        ObjSet("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j],  { alp = cur_pos, scale_x = scale, scale_y = scale });
        
      end;
      
    end;
  end;
  
  for i = 1, private.pic_count[ stage ], 1 do
    
    ObjSet("spr_memories_picture_"..stage.."_"..i.."_black",  { alp = 1 });
    
  end;
  
  ObjSet("spr_memories_stage_"..stage.."_start",  { alp = 1 });
  
end;
-----------------------------------------------------------------------------------
function private.StageStartAnim( stage )
  
  local end_func = function ()
    
    private.SetPicturesState( private.state[2], false );
    
    if not(cmn.IsEventDone( "opn_memories" )) then
      cmn.SetEventDone("opn_memories");
      private.AnimStart();
    else 
      cmn.Lock(0);
    end;
    
  end;
                   
  local anim_pics = function ()
    
    for i = 1, private.pic_count[ stage ], 1 do
      
      local perc_y, perc_x, black;
      
      if private.CheckPicForCloudMovement( stage, 1, i ) then
        perc_y = math.abs(private.start_state[ stage ][1]-private.win_state[ stage ][1]);
      else 
        perc_y = 0;
      end;
      
      if private.CheckPicForCloudMovement( stage, 2, i ) then
        perc_x = math.abs(private.start_state[ stage ][2]-private.win_state[ stage ][2]);
      else 
        perc_x = 0;
      end;
      
      if perc_x > 0 and perc_y > 0 then
        black = (perc_y+perc_x)/2;
      elseif perc_x == 0 then
        black = perc_y;
      elseif perc_y == 0 then
        black = perc_x;
      end;
      
      ObjAnimate("spr_memories_picture_"..stage.."_"..i.."_black", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, black });
      
    end;
    
    ObjSet("tmr_memories_timer",  { time = 0.5, playing = 1, endtrig = end_func });
   
    for i = 1, 3, 1 do
      for j = 1, #private.pic_move[ stage ][i], 1 do
        
        local cur_pos = private.ReturnNewPos( i, j, private.win_state[ stage ][i] );
        local new_pos = private.ReturnNewPos( i, j, private.start_state[ stage ][i] );
        
        if i == 1 then
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "pos_y", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
        elseif i == 2 then  
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "pos_x", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
        elseif i == 3 then
        
          local scale = cur_pos;
          local scale_new = new_pos;
          if scale < private.pic_scale[1] then
            scale = private.pic_scale[1];
          end;
          if scale_new < private.pic_scale[1] then
            scale_new = private.pic_scale[1];
          end;
          
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "alp", 0, 0, "", { 0, 0, cur_pos,   0.5, 0, new_pos });
          ObjAnimate("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j], "scale_xy", 0, 0, "", { 0, 0, scale, scale,   0.5, 0, scale_new, scale_new });
          
        end;
        
      end;
    end;
   
  end; 
       
  ObjSet("obj_memories_stage_"..stage.."_pics",  { alp = 1 });  
  ObjAnimate("spr_memories_stage_"..stage.."_start", "alp", 0, 0, anim_pics, { 0, 0, 1,    1.7, 0, 1,    2.2, 0, 0 });               
  
end;
-----------------------------------------------------------------------------------
function public.FocusCloud( cloud, inout )
  
  local obj = "spr_memories_cloud_"..cloud.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.StartDragCloud( cloud )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  private.current_cloud = cloud;
  private.cloud_start_y = math.floor(GetZoomCursorPos()[2]);
  private.temp_y = private.cloud_start_y;
  
  public.FocusCloud( cloud, 0 );
  
  ObjStartDrag("obj_memories_drag");
  
end;
-----------------------------------------------------------------------------------
--драг облачка
function public.DragCloud()
  
  local curspos = math.floor(GetZoomCursorPos()[2]);
  local delta_pos = curspos - private.cloud_start_y;
  local old_pos = private.cloud_range[1] + private.state[1][ private.current_cloud ]*(private.cloud_range[2]-private.cloud_range[1]);
  local new_pos = old_pos + delta_pos;
  
  if private.temp_y <= curspos-15 or private.temp_y >= curspos+15 then 
    cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_rope"..math.random(6));
    private.temp_y = curspos;
  end;
  
  if new_pos < private.cloud_range[1] then
    new_pos = private.cloud_range[1];
  elseif new_pos > private.cloud_range[2] then
    new_pos = private.cloud_range[2];
  end;
  
  local percent = (new_pos-private.cloud_range[1])/(private.cloud_range[2]-private.cloud_range[1]);
  
  for j = 1, #private.pic_move[ private.state[2] ][private.current_cloud], 1 do
    
    local cur_pos = private.ReturnNewPos( private.current_cloud, j, percent );
    
    if private.current_cloud == 1 then
      ObjSet("obj_memories_picture_"..private.state[2].."_"..private.clouds_move[ private.state[2] ][private.current_cloud][j],  { pos_y = cur_pos });
    elseif private.current_cloud == 2 then
      ObjSet("obj_memories_picture_"..private.state[2].."_"..private.clouds_move[ private.state[2] ][private.current_cloud][j],  { pos_x = cur_pos });
    elseif private.current_cloud == 3 then
          
      local scale = cur_pos;
      if scale < private.pic_scale[1] then
        scale = private.pic_scale[1];
      end;
      
      ObjSet("obj_memories_picture_"..private.state[2].."_"..private.clouds_move[ private.state[2] ][private.current_cloud][j],  { alp = cur_pos, scale_x = scale, scale_y = scale });
          
    end;
    
  end;
  
  for i = 1, private.pic_count[ private.state[2] ], 1 do
      
    local perc_y, perc_x, black;
    local cloud_state_1, cloud_state_2 = private.state[1][1], private.state[1][2];
    
    if private.current_cloud == 1 then
      cloud_state_1 = percent;
    elseif private.current_cloud == 2 then
      cloud_state_2 = percent;
    end;
    
    if private.CheckPicForCloudMovement( private.state[2], 1, i ) then
      perc_y = math.abs(cloud_state_1-private.win_state[ private.state[2] ][1]);
    else 
      perc_y = 0;
    end;
    
    if private.CheckPicForCloudMovement( private.state[2], 2, i ) then
      perc_x = math.abs(cloud_state_2-private.win_state[ private.state[2] ][2]);
    else 
      perc_x = 0;
    end;
    
    if perc_x > 0 and perc_y > 0 then
      black = (perc_y+perc_x)/2;
    elseif perc_x == 0 then
      black = perc_y;
    elseif perc_y == 0 then
      black = perc_x;
    end;
    
    ObjSet("spr_memories_picture_"..private.state[2].."_"..i.."_black",  { alp = black });
    
  end;
  
  ObjMultiSet( { {"spr_memories_cloud_"..private.current_cloud, { pos_y = new_pos }},
                 {"spr_memories_thread_"..private.current_cloud, { scale_y = private.thread_range[1] + percent*(private.thread_range[2]-private.thread_range[1]) }} } );
  
end;
-----------------------------------------------------------------------------------
--отпустили облачко
function public.SetCloud()
  
  local cloud = private.current_cloud;
  local cloud_start_y = private.cloud_start_y;
  private.current_cloud = 0;
  private.cloud_start_y = 0;
  
  local curpos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    curpos[2] = curpos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curpos[2] = curpos[2] - 75;
    else
      curpos[2] = curpos[2] - 50;
    end;
  end;
    
  local curspos = math.floor(curpos[2]);
  local delta_pos = curspos - cloud_start_y;
  local old_pos = private.cloud_range[1] + private.state[1][ cloud ]*(private.cloud_range[2]-private.cloud_range[1]);
  local new_pos = old_pos + delta_pos;
  
  if new_pos < private.cloud_range[1] then
    new_pos = private.cloud_range[1];
  elseif new_pos > private.cloud_range[2] then
    new_pos = private.cloud_range[2];
  end;
  
  local percent = (new_pos-private.cloud_range[1])/(private.cloud_range[2]-private.cloud_range[1]);
  private.state[1][cloud] = percent;
  
  for j = 1, #private.pic_move[ private.state[2] ][cloud], 1 do
    
    local cur_pos = private.ReturnNewPos( cloud, j, percent );
    
    if cloud == 1 then
      ObjSet("obj_memories_picture_"..private.state[2].."_"..private.clouds_move[ private.state[2] ][cloud][j],  { pos_y = cur_pos });
    elseif cloud == 2 then
      ObjSet("obj_memories_picture_"..private.state[2].."_"..private.clouds_move[ private.state[2] ][cloud][j],  { pos_x = cur_pos });
    elseif cloud == 3 then
          
      local scale = cur_pos;
      if scale < private.pic_scale[1] then
        scale = private.pic_scale[1];
      end;
      
      ObjSet("obj_memories_picture_"..private.state[2].."_"..private.clouds_move[ private.state[2] ][cloud][j],  { alp = cur_pos, scale_x = scale, scale_y = scale });
     
    end;
    
  end;
  
  for i = 1, private.pic_count[ private.state[2] ], 1 do
      
    local perc_y, perc_x, black;
    
    if private.CheckPicForCloudMovement( private.state[2], 1, i ) then
      perc_y = math.abs(private.state[1][1]-private.win_state[ private.state[2] ][1]);
    else 
      perc_y = 0;
    end;
    
    if private.CheckPicForCloudMovement( private.state[2], 2, i ) then
      perc_x = math.abs(private.state[1][2]-private.win_state[ private.state[2] ][2]);
    else 
      perc_x = 0;
    end;
    
    if perc_x > 0 and perc_y > 0 then
      black = (perc_y+perc_x)/2;
    elseif perc_x == 0 then
      black = perc_y;
    elseif perc_y == 0 then
      black = perc_x;
    end;
    
    --DbgTrace(black.." "..i);
    
    ObjSet("spr_memories_picture_"..private.state[2].."_"..i.."_black",  { alp = black });
    
  end;
  
  ObjMultiSet( { {"spr_memories_cloud_"..cloud, { pos_y = new_pos }},
                 {"spr_memories_thread_"..cloud, { scale_y = private.thread_range[1] + percent*(private.thread_range[2]-private.thread_range[1]) }} } );
                 
  private.CheckWin();
  
end;
-----------------------------------------------------------------------------------
--установка положений картинок, запуск/остановка анимации парения
function private.SetPicturesState( stage, stop )
  
  if not stop then
  
    for i = 1, 3, 1 do
      for j = 1, #private.pic_move[ stage ][i], 1 do
        
        local cur_pos = private.ReturnNewPos( i, j, private.state[1][i] );
        
        if i == 1 then
          ObjSet("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j],  { pos_y = cur_pos });
        elseif i == 2 then
          ObjSet("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j],  { pos_x = cur_pos });
        elseif i == 3 then
          
          local scale = cur_pos;
          if scale < private.pic_scale[1] then
            scale = private.pic_scale[1];
          end;
          
          ObjSet("obj_memories_picture_"..stage.."_"..private.clouds_move[ stage ][i][j],  { alp = cur_pos, scale_x = scale, scale_y = scale });
          
        end;
        
      end;
    end;
    
    for i = 1, private.pic_count[ stage ], 1 do
      
      local perc_y, perc_x, black;
      
      if private.CheckPicForCloudMovement( stage, 1, i ) then
        perc_y = math.abs(private.state[1][1]-private.win_state[ stage ][1]);
      else 
        perc_y = 0;
      end;
      
      if private.CheckPicForCloudMovement( stage, 2, i ) then
        perc_x = math.abs(private.state[1][2]-private.win_state[ stage ][2]);
      else 
        perc_x = 0;
      end;
      
      if perc_x > 0 and perc_y > 0 then
        black = (perc_y+perc_x)/2;
      elseif perc_x == 0 then
        black = perc_y;
      elseif perc_y == 0 then
        black = perc_x;
      end;
      
      ObjSet("spr_memories_picture_"..stage.."_"..i.."_black",  { alp = black });
      
    end;
    
    --DbgTrace( private.ReturnNewPos( 1, 1, 0.9 ) );
    
    for i = 1, private.pic_count[stage], 1 do
      
      local range_y = math.random(2, 8);
      local range_x = math.random(1, 6);
      local dir_y = math.random(1, 2);
      local dir_x = math.random(1, 2);
      if dir_y == 2 then
        dir_y = -1;
      end;
      if dir_x == 2 then
        dir_x = -1;
      end;
      
      ObjAnimate("spr_memories_picture_"..stage.."_"..i, "pos_y", 1, 0, "", { 0, 2, 0,     1, 2, range_y*dir_y,    3, 3, -range_y*dir_y,    4, 1, 0 });
      ObjAnimate("spr_memories_picture_"..stage.."_"..i, "pos_x", 1, 0, "", { 0, 2, 0,     1, 2, range_x*dir_x,    3, 3, -range_x*dir_x,    4, 1, 0 });
      
    end;
    
  else 
    
    for i = 1, private.pic_count[stage], 1 do
      ObjStopAnimate("spr_memories_picture_"..stage.."_"..i, "pos_y");
      ObjStopAnimate("spr_memories_picture_"..stage.."_"..i, "pos_x");
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
--движение картинок при управлении облачками - расчет нового значения свойства
function private.ReturnNewPos( cloud, pic, perc )
  
  local win_pos = private.pic_move[ private.state[2] ][cloud][pic][1];
  local dir = private.pic_move[ private.state[2] ][cloud][pic][2];
  
  local range, cur_pos, k = 0, 0, 0;
  
  --движение по x,y
  if cloud < 3 then
    
    range = private.pic_move[ private.state[2] ][cloud][pic][3];
    k = win_pos - dir*private.win_state[ private.state[2] ][cloud]*range;
    cur_pos = k + dir*perc*range;
    
  --изменения по scale и alp
  else 
    
    range = 1;
    k = win_pos - dir*private.win_state[ private.state[2] ][cloud]*range;
    cur_pos = k + dir*perc*range;
    
    if cur_pos < 0 then
      cur_pos = 0;
    elseif cur_pos > 1 then
      cur_pos = 1;
    end;
    
  end;
  
  --if cloud == 1 and pic == 1 then
  --  DbgTrace(win_pos.." "..dir.." "..range.." "..k.." "..private.win_state[ private.state[2] ][cloud]);
  --end;
  
  return cur_pos;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 3, 1 do
    
    if private.state[1][i] < private.win_state[ private.state[2] ][i]-0.06 or private.state[1][i] > private.win_state[ private.state[2] ][i]+0.06 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    if private.state[2] < 3 then
      
      cmn.Lock(1);
      
      private.state[2] = private.state[2] + 1;
      local old_pos = {};
      
      for i = 1, 3, 1 do
        old_pos[i] = private.state[1][i];
        private.state[1][i] = private.start_state[ private.state[2] ][i];
      end;
      
      local change_stage = function ()
        
        int_blackbartext.Hide();
        cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_opn_mmg" );
      
        for i = 1, 3, 1 do
      
          local py_new = private.cloud_range[1] + private.state[1][i]*(private.cloud_range[2]-private.cloud_range[1]);
          local py_old = private.cloud_range[1] + old_pos[i]*(private.cloud_range[2]-private.cloud_range[1]);
          
          local sy_new = private.thread_range[1] + private.state[1][i]*(private.thread_range[2]-private.thread_range[1]);
          local sy_old = private.thread_range[1] + old_pos[i]*(private.thread_range[2]-private.thread_range[1]);
          
          ObjAnimate("spr_memories_cloud_"..i, "pos_y", 0, 0, "", { 0, 0, py_old,   0.5, 0, py_new });
          ObjAnimate("spr_memories_thread_"..i, "scale_y", 0, 0, "", { 0, 0, sy_old,   0.5, 0, sy_new });
          
        end;
        
        ObjAnimate("obj_memories_stage_"..private.state[2], "alp", 0, 0, function() private.state[3][ private.state[2] ] = 1; private.StageStartAnim( private.state[2] ); end, { 0, 0, 0,   1, 0, 1 });
        ObjAnimate("obj_memories_stage_"..(private.state[2]-1), "alp", 0, 0, "", { 0, 0, 1,   1, 0, 0 });
      
      end;
      
      local play_voice = function ()
      
        --private.SetPicturesState( private.state[2], false );
        private.SetStageStartPos( private.state[2] );
        private.SetPicturesState( private.state[2]-1, true );
        
        cmn.ShowDlgBbt( "memories_cheshire_voc_"..(private.state[2]-1), 1 );
        cmn.PlayAudio("voc", "assets/levels/level1/mg_memories/audio/aud_memories_1_"..private.state[2].."_voc");
      
        ObjSet("tmr_memories_timer",  { time = private.voice_time[ private.state[2]-1 ], playing = 1, endtrig = change_stage });
      
      end;
      
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
      
      ObjAnimate("spr_memories_stage_"..(private.state[2]-1).."_win", "alp", 0, 0, play_voice, { 0, 0, 0,   1, 0, 1 });
      
    else
    
      cmn.Lock(1);
      
      if ng_global.currentprogress == "std" then
        
        cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
        
        cmn.MiniGameHide();

        common_impl.PauseAchiev( 1 );
        cmn.EndTimePassing( "mg_memories" );
        
      else 
        
        rm_extra.MiniGameHide();
        int_dialog_secretroom.StopTimer();
        
      end;
      
      local play_voice = function ()
      
        private.SetPicturesState( 3, true );
        
        cmn.ShowDlgBbt( "memories_cheshire_voc_3", 1 );
        cmn.PlayAudio("voc", "assets/levels/level1/mg_memories/audio/aud_memories_1_4_voc");
        
        ObjSet("tmr_memories_timer",  { time = private.voice_time[3], playing = 1, endtrig = private.Win });
      
      end;
      
      ObjAnimate("spr_memories_stage_3_win", "alp", 0, 0, play_voice, { 0, 0, 0,   1, 0, 1 });
      
    end;
    
  end; 

end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.Lock(0);

  cmn.SetEventDone( "win_memories" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_memories_mg" );
    cmn.CallEventHandler( "win_memories_loc" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].skip == 0 and not ng_global.noskipgames[ "win_memories" ] then

      ng_global.noskipgames[ "win_memories" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

    if ng_global.playedgames and not ng_global.playedgames[ "win_memories" ] then
      ng_global.playedgames[ "win_memories" ] = 1;
    end;
    
    common_impl.PauseAchiev( 0 );
    
    cmn.ShowBbt( "nearhome_after_win_memories" );
    
    cmn.GotoRoom( "rm_nearhome" );
    common.GotoSubRoom( "zz_clockatentrace", { 906, 163 } );
    
  else 
    
    interface_impl.ShowStarsWindow();

  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  int_blackbartext.Hide();
  private.WinEnd();

end;
--**********************************************************************************************************