-- name=mg_pursuit
--*********************************************************************************************************************
--Дамир zhestb Мавляветдинов
--*********************************************************************************************************************
function public.Init()

  if port.ios_lang() == "ja" then
    ObjSet("txt_pursuit_start",{ fontsize = 12 });
  end;
  
  private.cur_progress = "std";
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_pursuit";
  --------------------------------------------------------------------------------------------

  private.car_gone = 0;   --число пройденных препятствий
  private.win_car_gone = 20;   --число пройденных препятствий для выйгрыша

  private.life = 3;  --количество жизней

  private.road_pos = 2; --1 - слева, 2 - центр, 3 - справа
  private.pre_road_pos = 0; --предыдущая, нужно для проверки столкновений во время поворота
                            --0 - поворот закончен, 1 - слева, 2 - центр, 3 - справа

  private.in_turning = false; --флаг - в процессе поворота
  private.in_crash = 0; --флаг, 0 - не врезались, 1 - врезались, 2 - замедление после врезания, 3 - ускарение после врезания
  private.in_reset = false; --флаг - в процессе резета
  private.in_move = false; --флаг - поехали
  private.in_win = false;

  private.turning_anim_tme = 1; --время поворота (не влияет на анимацию грида)

  private.road_segments_num = 2100;  --количество сегментов на которое делитса путь, каждый кадр проходим 1 сегмент
  private.start_segment = 1750; --сегмент с которого начинают путь обьекты
  private.car_start_segment = 1875; --сегмент с которого начинают путь припятствия
  private.show_segment = 1875; --сегмент с которого начинают показываться обьекты
  private.car_aud_overtaking_segment = 2050; --сегмент с которого начинает воспроизводится звук обгона машины

  private.show_anim_tme = 0.3;  --время за которое появляються обьекты

  private.move_speed = 0.8;   --скорость движения, для припятствий своя
  private.move_speed_inc = 0.0001;   --увеличение скорости каждый кадр, в %
  private.crash_move_speed = 0.1;   --минимальная скорость движения, при столкновении
  private.crash_move_speed_dec = 0.1;   --уменьшение скорости каждый кадр во время столкновения, в %
  private.crash_move_speed_inc = 0.05;  --увеличение скорости каждый кадр во время столкновения, в %

  private.move_timer_speed = 0.0166666675;  --скорость таймера (кадры в сек)
  private.center_road_length = 404; --минимальный путь машины (дорога по середине)

  private.pos_car = {  --машины и припятствия на 1-3 дороге
    { kind = 0, pos = 0 },  --kind = 0 - нет машины, 1-6 - тип машины
    { kind = 0, pos = 0 },
    { kind = 0, pos = 0 }
  };

  private.car_speed = { 0.8, 0.8, 0.8, 0.8, 0.8, 0.8 };   --скорость машин и припятствий
  private.car_alp = { 0, 0, 0, 0, 0, 0 };   --видимость машин и припятствий
  --private.car_aud_overtaking = { 0, 0, 0, 0, 0, 0 };   --был ли воспроизведен звук обгона
  private.car_aud_overtaking = false;   --был ли воспроизведен звук обгона

  private.car_number = #private.car_speed;  --количество видов припятствий

  private.pos_tree = {  --позиции деревьев/столбов
    2081,    2071,    2061,
    2039,    2029,    2019,
    1997,    1987,    1977,
    1955,    1945,    1935,
    1913,    1903,    1893,
    1871,    1861,    1851,
    1829,    1819,    1809,
    1787,    1777,    1767
  };

  private.tree_alp = {  --видимость деревьев/столбов
    1,    1,    1,
    1,    1,    1,
    1,    1,    1,
    1,    1,    1,
    1,    1,    1,
    0,    0,    0,
    0,    0,    0,
    0,    0,    0
  };

  private.car_max_scale = 2;  --максимальный размер машины (в конце пути)
  private.tree_max_scale = 2;  --максимальный размер дерева/столба (в конце пути)
  private.house_max_scale = 8.6;  --максимальный размер домов (в конце пути)

  private.house_turning_scale_x = { --размер домов по Х в левом/центральном/правом положении
    {  0.425,  1,  1.575 },
    { -1.575, -1, -0.425 }
  };

  private.house_gap = 0;  --растояние между домами

  --private.house_max_show = 6;  --количество отоброжаемых домов на одной стороне

  private.house_length = {  --длина типов домов
    48, 45, 45, 32, 38, 44,
    48, 45, 45, 32, 38, 44, 46   --последний "выйгрышный дом"
  };

  private.house_alp = {  --видимость домов
    {
      0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0 --[13] "выйгрышный дом"
    },
    {
      0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0
    }
  };

  private.house_number = 12;  --количество типов домов

  private.pos_house = {
    {}, --позиция домов левые
    {}  --позиция домов правые
  };

  private.house_next = nil;  --тип дома который появитса следующий (левый , правый)

  private.distance_multiplier = 1;  --индекс интерполяции (в данном случае в начале пути движемся на 100% медленне)
  private.distance_multiplier_degree = 41.2;

  private.road_vertex_pos = { --позиции вертексов дороги
    --left
    {
      0, { pos_x =     0, pos_y = -202 },
      1, { pos_x =     0, pos_y = -202 },
      2, { pos_x =  -676, pos_y = 0 },
      3, { pos_x =  1804, pos_y = 0 }
    },
    --center
    {
      0, { pos_x =     0, pos_y = -202 },
      1, { pos_x =     0, pos_y = -202 },
      2, { pos_x = -1240, pos_y = 0 },
      3, { pos_x =  1240, pos_y = 0 }
    },
    --right
    {
      0, { pos_x =     0, pos_y = -202 },
      1, { pos_x =     0, pos_y = -202 },
      2, { pos_x = -1804, pos_y = 0 },
      3, { pos_x =   676, pos_y = 0 }
    }
  };

  private.car_finish_pos_x = { --конечные точки движения машин
    --left
    {     0, 1038, 2206 },
    --center
    {  -976,    0, 1038 },
    --right
    { -2206, -976,    0 }
  };

  private.tree_finish_pos_x = { --конечные точки движения деревьев/столбов
    --left
    {  -670, 3003 },
    --center
    { -1795, 1838 },
    --right
    { -2955,  703 }
  };

  private.house_finish_pos_x = { --конечные точки движения домов
    --left
    {  -920, 3170 },
    --center
    { -2140, 2140 },
    --right
    { -3170,  920 }
  };

  private.car_frame = { --измениение кадров анимации машин
    { 45, 85 },   --на соседней полосе
    { 210, 225 }  --через одну полосу
  };
  private.cur_car_frame = { 0, 0, 0, 0 }; --текущий фрейм машин
  private.cur_car_func = { 1, 1, 1, 1 };  --текущая функция анимации машин, 1 - left, 2 - right

  private.sky_pos = { 684, 512, 339 };

  private.navigator_map = {
    --x, y
    { 148, 144 },
    { 152, 102 },
    { 179,  65 },
    { 233,  65 },
    { 278,  95 },
    { 324,  89 },
    { 342,  63 },
    { 352,  40 }
  };

  private.navigator_anim_tme = 4.85; --уменьшаетса каждый кадр

  private.navigator_map_ang = { -0.06, -0.48, -1.53, -2.11, -1.4, -0.54, -0.3, -0.3 };

  private.del_tree_after_win_house = 0; --количество убранных деревьев после "выйгрышного дома"
  --------------------------------------------------------------------------------------------
  -- function win_pursuit () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_pursuit" ] = {
    type = "win",
    use_place = "spr_pursuit_start",
    room = "rm_doctorstudy",
    zz = "mg_pursuit",
    zz_gate = "gmg_doctorstudy_pursuit"
  };
  --------------------------------------------------------------------------------------------
  local win_pursuit = function ()

    if cmn.IsEventDone( "win_pursuit" ) then

      int_map_impl.OpenRoom( "rm_nearhome" );
      int_map_impl.BlockRoom( "rm_doctorstudy" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pursuit", win_pursuit );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and ( not ng_global.progress[ ng_global.currentprogress ][ "win_pursuit" ].skip ) then
    ng_global.progress[ ng_global.currentprogress ][ "win_pursuit" ].skip = 0;
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

end;
--*********************************************************************************************************************
function public.Open() 

  if ng_global.currentprogress == "std" and ( not cmn.IsEventDone( "win_pursuit" ) ) and private.in_move then
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_pursuit");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;
  
  if ng_global.currentprogress == "std" and not ( cmn.IsEventDone( "opn_pursuit" ) ) then
    
    local func_after = function ()

      interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );

      ObjSet("mg_pursuit",  { color_r = 1, color_g = 1, color_b = 1 });
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 1 );
      
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);
      cmn.PlayAudio( "env", "assets/levels/common/audio/aud_car_inside1_env" );

    end;

    cmn.Lock(0);
    
    cmn.SetEventDone( "opn_pursuit" );
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_doctorstudy/vid_runingaway2", func_after, "assets/levels/level1/rm_doctorstudy/audio/aud_runingaway2", "assets/levels/level1/rm_doctorstudy/audio/aud_runingaway2_voc", 1, 1);
    
  else 
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);
    
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ng_global.currentprogress == "secret" or cmn.IsEventDone( "opn_pursuit" ) then
    cmn.StopAllEnv( "assets/levels/common/audio/aud_car_inside1_env" );
    cmn.PlayAudio( "env", "assets/levels/common/audio/aud_car_inside1_env" );
  else 
    cmn.StopAllEnv();
  end;
  
  if ng_global.currentprogress == "std" then
    
    private.cur_progress = "std";
    common.SetPreviousRoom( "rm_doctorstudy" );
    
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    
  else 

    private.cur_progress = "secret";

    private.DrawSceneExtraRoom();

    ObjSet("grm_pursuit_doctorstudy",  { active = 1, input = 1, visible = 1 });
    
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_pursuit_doctorstudy_focus");
    end;
    
  end;

  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_pursuit") then
    
    cmn.Lock(1);
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );

    ObjSet("mg_pursuit",  { color_r = 0, color_g = 0, color_b = 0 });
    
  end;

  if ( not private.in_move ) then

    private.DrawScene();

    ObjAnimate( "txt_pursuit_start", 12, 1, 0, "", {
      0,   0, 0.568627, 0.541176, 0.541176,
      0.5, 0, 0,        0.752941, 1,
      1.0, 0, 0.568627, 0.541176, 0.541176
    } );

  end;

end;
--*********************************************************************************************************************
function public.Close()

  if private.cur_progress == "std" then
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
  end;

end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_pursuit" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_pursuit" )) then
    rm_extra.MiniGameHide();
  end;
  
  if ng_global.currentprogress == "secret" then
    SndStop( "assets/levels/level1/mg_pursuit/audio/aud_driving", 0.5 );
    ObjSet("grm_pursuit_doctorstudy",  { input = 0 });
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_pursuit_doctorstudy_focus");
    end;
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()

  if ( not private.in_move ) or private.in_reset then
    return;
  end;

  SndStop( "assets/levels/level1/mg_pursuit/audio/aud_driving", 0.5 );

  cmn.Lock( 1 );

  private.in_reset = true;

  for i = 1, 3, 1 do
    if ( private.pos_car[i].kind ~= 0 ) then
      ObjAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, "alp", 0, 0, "", {
        0,   0, ObjGet( "obj_pursuit_car_"..private.pos_car[i].kind ).alp,
        0.3, 0, 0
      } );
    end;
  end;

  ObjAnimate( "spr_pursuit_btn_left_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "spr_pursuit_btn_right_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "spr_pursuit_btn_left_3", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
  ObjAnimate( "spr_pursuit_btn_right_3", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

  ObjMultiSet( { { "spr_pursuit_btn_left_1", { input = false } },
                 { "spr_pursuit_btn_right_1", { input = false } } } );

  ObjStopAnimate( "grd_pursuit_road_2", 8 );
  ObjAnimate( "grd_pursuit_road_2", "alp", 0, 0, "", { 0, 0, ObjGet( "grd_pursuit_road_2" ).alp,    0.3, 0, 0 } );


  ObjAnimate( "spr_pursuit_dark", "alp", 0, 0, "", {
    0,   0, ObjGet( "spr_pursuit_dark" ).alp,
    0.5, 0, 0
  } );

  if ( private.car_gone >= 16 ) then
    ObjAnimate( "spr_pursuit_sky_2", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  end;

  ObjAnimate( "spr_pursuit_navigator_arrow", "alp", 0, 0,
    function ()
      ObjStopAnimate( "spr_pursuit_navigator_arrow", 3 );
      ObjStopAnimate( "spr_pursuit_navigator_arrow", 7 );
      ObjSet( "spr_pursuit_navigator_arrow", {
        pos_x = private.navigator_map[1][1],
        pos_y = private.navigator_map[1][2],
        ang   = private.navigator_map_ang[1]
      } );
      ObjAnimate( "spr_pursuit_navigator_arrow", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
    end,
    { 0, 0, 1,    0.2, 0, 0 }
  );

end;
--*********************************************************************************************************************
function public.Skip()

  cmn.Lock( 1 );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_pursuit" ].skip = 1;

  if ( private.in_reset ) then
    public.BtnGo();
  end;

  ObjAnimate( "spr_pursuit_dark", "alp", 0, 0, "", {
    0,   0, ObjGet( "spr_pursuit_dark" ).alp,
    0.5, 0, 1
  } );

  if ( private.car_gone < 16 ) then
    ObjAnimate( "spr_pursuit_sky_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
  end;

  ObjAnimate( "spr_pursuit_navigator_arrow", "alp", 0, 0,
    function ()
      ObjStopAnimate( "spr_pursuit_navigator_arrow", 3 );
      ObjStopAnimate( "spr_pursuit_navigator_arrow", 7 );
      ObjSet( "spr_pursuit_navigator_arrow", {
        pos_x = private.navigator_map[8][1],
        pos_y = private.navigator_map[8][2],
        ang   = private.navigator_map_ang[8]
      } );
      ObjAnimate( "spr_pursuit_navigator_arrow", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
    end,
    { 0, 0, 1,    0.2, 0, 0 }
  );

  private.CheckWin( true );

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_pursuit" ].skip = 0;

  private.move_speed = 0.8;   --скорость движения, для припятствий своя
  private.car_speed = { 0.8, 0.8, 0.8, 0.8, 0.8, 0.8 };   --скорость машин и припятствий
  private.life = 3;
  private.in_crash = 0;
  private.car_gone = 0;
  private.navigator_anim_tme = 4.85;
  private.car_aud_overtaking = false;

end;
-----------------------------------------------------------------------------------
function private.DrawScene()

  --DbgTrace( "***DrawScene" );

  local pos_x;  --текущая позиция
  local pos_y;
  local pos_z;
  local scale;

  local all_house_length;
  local new_house_kind;
  local new_house_pos;

  --DbgTrace( "*insert houses" );
  for i = 1, 2, 1 do

    all_house_length = 0;
    pos_z = 20;

    while ( all_house_length < ( private.road_segments_num - private.start_segment ) ) do

      new_house_kind = private.FindFreeHouse( i );
      all_house_length = all_house_length + private.house_length[ new_house_kind ];
      new_house_pos = private.road_segments_num - all_house_length;

      table.insert( private.pos_house[i], { kind = new_house_kind, pos = new_house_pos } );

      pos_x, pos_y, scale = private.GetPoint( i, new_house_pos, "house" );

      ObjAttach( "obj_pursuit_house_"..i..new_house_kind, "obj_pursuit_househub_"..i );

      ObjSet( "obj_pursuit_house_"..i..new_house_kind, {
        pos_x = pos_x,
        pos_y = pos_y,
        pos_z = pos_z,
        scale_x = scale,
        scale_y = scale
      } );

      if ( new_house_pos >= private.show_segment - ( private.house_length[ new_house_kind ] / 2 ) ) then

        ObjSet( "obj_pursuit_house_"..i..new_house_kind, { alp = 1 } );

        private.house_alp[i][ new_house_kind ] = 1;

        --DbgTrace( "side == "..i..", house "..new_house_kind..", alp = 1, pos = "..new_house_pos );

      end;

      --if ( i == 1 ) then
        --DbgTrace(
        --  "side == "..i
        --  ..", pos_z = "..pos_z..", new_house_kind == "..new_house_kind
        --  ..", all_house_length == "..all_house_length..", new_house_pos == "..new_house_pos
        --  .."( "..pos_x..", "..pos_y.." )"
        --);
      --end;

      pos_z = pos_z - 1;

    end;

  end;
  --DbgTrace( "*insert houses end" );

  private.house_next = { private.FindFreeHouse( 1 ), private.FindFreeHouse( 2 ) };
  --DbgTrace( "house_next = { "..private.house_next[1]..", "..private.house_next[2].." }" );

  -------------------

  for i = 1, #private.pos_tree, 1 do

    for j = 1, 2, 1 do  --левая/правая сторона

      pos_x, pos_y, scale = private.GetPoint( j, private.pos_tree[i], "tree" );

      ObjSet( "obj_pursuit_tree_"..j..i, {
        pos_x = pos_x,
        pos_y = pos_y,
        scale_x = scale,
        scale_y = scale
      } );

    end;

  end;

  -------------------

  private.CheckFreeRoad();

end;
-----------------------------------------------------------------------------------
function private.DrawSceneExtraRoom()
  --сбрасываем мг для перепрохождения в экстраруме

  --DbgTrace( "***DrawSceneExtraRoom" );

  ObjSet( "tmr_pursuit_move", { playing = false } );

  local stop_car_name;

  for i = 1, 3, 1 do
    if ( private.pos_car[i].kind ~= 0 ) then

      stop_car_name = "obj_pursuit_car_"..private.pos_car[i].kind;

      ObjStopAnimate( stop_car_name, 6 );
      ObjStopAnimate( stop_car_name, 8 );
      ObjSet( stop_car_name, { alp = 0, scale_x = 0, scale_y = 0 } );

      --DbgTrace( "road "..i.." car "..private.pos_car[i].kind );

      private.car_alp[ private.pos_car[i].kind ] = 0;
      private.pos_car[i].kind = 0;

    end;
  end;

  ObjStopAnimate( "grd_pursuit_road_2", 8 );
  ObjStopAnimate( "spr_pursuit_navigator_arrow", 3 );
  ObjStopAnimate( "spr_pursuit_navigator_arrow", 7 );
  ObjStopAnimate( "obj_pursuit_car", 1 );
  ObjStopAnimate( "spr_pursuit_car_window", 1 );

  GridStop( "grd_pursuit_road_1" );
  GridStop( "grd_pursuit_road_2" );

  GridSet( "grd_pursuit_road_1", 0, private.road_vertex_pos[ 2 ] );
  GridSet( "grd_pursuit_road_2", 0, private.road_vertex_pos[ 2 ] );

  ObjMultiSet( { 
    { "spr_pursuit_btn_left_1", { input = false, alp = 0 } },
    { "spr_pursuit_btn_right_1", { input = false, alp = 0 } },
    { "spr_pursuit_btn_left_3", { alp = 1 } },
    { "spr_pursuit_btn_right_3", { alp = 1 } },
    { "spr_pursuit_navigator_arrow", { 
      pos_x = private.navigator_map[1][1], 
      pos_y = private.navigator_map[1][2], 
      ang = private.navigator_map_ang[1]
    } },
    { "grd_pursuit_road_2", { alp = 0 } },
    { "spr_pursuit_dark", { alp = 0 } } ,
    { "spr_pursuit_start", { alp = 1 } },
    { "txt_pursuit_start", { input = true } },
    { "anm_pursuit_necklace", { playing = false, frame = 0 } },
    { "obj_pursuit_car", { pos_y = -1 } },
    { "spr_pursuit_car_window", { pos_y = 322 } },
    { "obj_pursuit_btn_left",  { input = true } },
    { "obj_pursuit_btn_right", { input = true } },
    { "obj_pursuit_carhub", { alp = 1 } },
    { "grd_pursuit_road_1", { frame = 0 } },
    { "grd_pursuit_road_2", { frame = 0 } },
    { "obj_pursuit_start_bbt", { input = true } }
  } );

  if ( private.car_gone >= 16 ) then
    ObjStopAnimate( "spr_pursuit_sky_2", 8 );
    ObjSet( "spr_pursuit_sky_2", { alp = 0 } );
  end;

  for i = private.life + 1, 3, 1 do
    ObjSet( "spr_pursuit_life_"..i, { alp = 1 } );
  end;

  private.StartConditions();

  private.in_move = false;
  private.in_win = false;
  private.road_pos = 2; --1 - слева, 2 - центр, 3 - справа

  local stop_house_name_obj;
  local house_start_scale_x = 1;

  for i = 1, 2, 1 do
    for j = 1, 13, 1 do

      stop_house_name_obj = "obj_pursuit_house_"..i..j;

      ObjStopAnimate( stop_house_name_obj, 3 );
      ObjStopAnimate( stop_house_name_obj, 6 );
      ObjStopAnimate( stop_house_name_obj, 8 );

      ObjSet( stop_house_name_obj, {
        pos_x = 0,
        pos_y = 0,
        pos_z = 0,
        scale_x = 0,
        scale_y = 0,
        alp = 0
      } );

      ObjStopAnimate( "spr_pursuit_house_"..i..j, 4 );
      ObjSet( "spr_pursuit_house_"..i..j, { scale_x = house_start_scale_x } );--private.house_turning_scale_x[i][ private.road_pos ]

    end;

    house_start_scale_x = -1;

  end;

  private.pos_house = {
    {}, --позиция домов левые
    {}  --позиция домов правые
  };

  private.house_alp = {  --видимость домов
    {
      0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0 --[13] "выйгрышный дом"
    },
    {
      0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0
    }
  };

  private.house_next = nil;  --тип дома который появитса следующий (левый , правый)

  private.pos_tree = {  --позиции деревьев/столбов
    2081,    2071,    2061,
    2039,    2029,    2019,
    1997,    1987,    1977,
    1955,    1945,    1935,
    1913,    1903,    1893,
    1871,    1861,    1851,
    1829,    1819,    1809,
    1787,    1777,    1767
  };

  private.tree_alp = {  --видимость деревьев/столбов
    1,    1,    1,
    1,    1,    1,
    1,    1,    1,
    1,    1,    1,
    1,    1,    1,
    0,    0,    0,
    0,    0,    0,
    0,    0,    0
  };

  private.del_tree_after_win_house = 0; --количество убранных деревьев после "выйгрышного дома"
  private.del_tree_before_win_house = nil;

  for i = 1, #private.pos_tree, 1 do

    ObjStopAnimate( "obj_pursuit_tree_1"..i, 3 );
    ObjStopAnimate( "obj_pursuit_tree_1"..i, 6 );
    ObjStopAnimate( "obj_pursuit_tree_1"..i, 8 );

    ObjStopAnimate( "obj_pursuit_tree_2"..i, 3 );
    ObjStopAnimate( "obj_pursuit_tree_2"..i, 6 );
    ObjStopAnimate( "obj_pursuit_tree_2"..i, 8 );

    ObjMultiSet( { { "obj_pursuit_tree_1"..i, { alp = private.tree_alp[ i ] } },
                   { "obj_pursuit_tree_2"..i, { alp = private.tree_alp[ i ] } },
                   { "spr_pursuit_tree_1"..i, { alp = 1 } } } );

  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin( skip )

  if ( private.car_gone == private.win_car_gone ) or skip then

    --DbgTrace( "WWWWWWWIIIIIIIIINNNNNNNN" );
    
    if ng_global.currentprogress == "secret" then
      int_dialog_secretroom.StopTimer();
    end;

    cmn.ShowBbt( "pursuit_win" );

    SndStop( "assets/levels/level1/mg_pursuit/audio/aud_driving", 0.5 );

    cmn.Lock( 1 );

    private.in_win = 1;

    ObjMultiSet( { { "obj_pursuit_btn_left",  { input = false } },
                   { "obj_pursuit_btn_right", { input = false } } } );

    ObjAnimate( "obj_pursuit_carhub", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

    --for i = 1, 3, 1 do
    --  if ( private.pos_car[i].kind ~= 0 ) then
    --    ObjAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, "alp", 0, 0, "", {
    --      0,   0, ObjGet( "obj_pursuit_car_"..private.pos_car[i].kind ).alp,
    --      0.3, 0, 0
    --    } );
    --    --DbgTrace( "road "..i.." car "..private.pos_car[i].kind );
    --  end;
    --end;
    
    if ( private.road_pos ~= 1 ) and ( private.pre_road_pos == 0 ) then

      --DbgTrace( "не 1 полоса, не в процессе поворота" );

      cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_turn" );

      public.BtnClick( -1 );

    end;
    
    --DbgTrace( "side == 1, house_next = "..private.house_next[1].." -> 13 \n" );

    private.house_next[1] = 13;

  elseif ( private.car_gone == 16 ) then

    ObjAnimate( "spr_pursuit_sky_2", "alp", 0, 0, "", { 0, 0, 0,    1, 0, 1 } );

  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.SetEventDone( "win_pursuit" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_pursuit" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_pursuit" ].skip == 0 and not ng_global.noskipgames[ "win_pursuit" ] then

      ng_global.noskipgames[ "win_pursuit" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_pursuit" ] then
      ng_global.playedgames[ "win_pursuit" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );

    cmn.GotoRoom("rm_nearhome");
    
  else 
    
    interface_impl.ShowStarsWindow();

  end;

  --cmn.Lock( 0 );

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "std" then
  
    cmn.MiniGameHide();
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_pursuit" );
    
  else 
    
    rm_extra.MiniGameHide();
    
  end;

  private.WinEnd();

end;
-----------------------------------------------------------------------------------
function public.BtnClick( side )

  --DbgTrace( "***BtnClick: side == "..side );

  if ( ( private.road_pos + side ) > 0 ) and ( ( private.road_pos + side ) < 4 ) then

    if ( not private.in_win ) then
      SndStop( "assets/levels/level1/mg_pursuit/audio/aud_driving", 0.5 );
      cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_driving" );
      cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_turn" );
    end;

    cmn.Lock( 1 );

    ObjAnimate( "spr_pursuit_wheel", "ang", 0, 0, "", {
      0, 0, 0,
      private.turning_anim_tme/2, 0, 0.38 * -side,
      private.turning_anim_tme,   0, 0
    } );

    private.pre_road_pos = private.road_pos;
    private.in_turning = true;

    --DbgTrace( "road_pos "..private.road_pos.." -> "..private.road_pos + side );

    local func_after =  function ()

      private.pre_road_pos = 0;
      private.in_turning = false;
      --DbgTrace( "BtnClick END" );
      if ( not private.in_win ) then
        cmn.Lock( 0 );
      end;

      if ( private.in_win ) and ( private.road_pos ~= 1 ) then

        --DbgTrace( "не доконца повернули" );

        public.BtnClick( -1 );

      end;

    end;

    for i = 1, 3, 1 do

      ObjAnimate( "obj_pursuit_car_finish_"..i, "pos_x", 0, 0, "", {
        0,                        0, private.car_finish_pos_x[ private.road_pos        ][i],
        private.turning_anim_tme, 0, private.car_finish_pos_x[ private.road_pos + side ][i]
      } );

      if ( private.pos_car[i].kind ~= 0 ) then

        ObjSet( "obj_pursuit_car_"..private.pos_car[i].kind, { pos_z = #private.pos_car - math.abs( ( private.road_pos + side ) - i ) } );
        --DbgTrace( "road "..i..", pos_z = "..( #private.pos_car - math.abs( ( private.road_pos + side ) - i ) ) );

        if ( private.pos_car[i].kind < 5 ) then --только машины
          if ( i < private.road_pos + side ) then

            if ( private.cur_car_func[ private.pos_car[i].kind ] ~= 2 ) then
              private.cur_car_func[ private.pos_car[i].kind ] = 2;
              ObjSet( "anm_pursuit_car_"..private.pos_car[i].kind, { animfunc = "func_car_"..private.pos_car[i].kind.."_anim_right" } );
              --DbgTrace( "[tur]road "..i..", car "..private.pos_car[i].kind..", func right" );
            end;

          elseif ( i > private.road_pos + side ) then

            if ( private.cur_car_func[ private.pos_car[i].kind ] ~= 1 ) then
              private.cur_car_func[ private.pos_car[i].kind ] = 1;
              ObjSet( "anm_pursuit_car_"..private.pos_car[i].kind, { animfunc = "func_car_"..private.pos_car[i].kind.."_anim_left" } );
              --DbgTrace( "[tur]road "..i..", car "..private.pos_car[i].kind..", func left" );
            end;

          end;
        end;

      end;

    end;

    for i = 1, 2, 1 do

      ObjAnimate( "obj_pursuit_tree_finish_"..i, "pos_x", 0, 0, "", {
        0,                        0, private.tree_finish_pos_x[ private.road_pos        ][i],
        private.turning_anim_tme, 0, private.tree_finish_pos_x[ private.road_pos + side ][i]
      } );

      ObjAnimate( "obj_pursuit_house_finish_"..i, "pos_x", 0, 0, "", {
        0,                        0, private.house_finish_pos_x[ private.road_pos        ][i],
        private.turning_anim_tme, 0, private.house_finish_pos_x[ private.road_pos + side ][i]
      } );

      for j = 1, #private.pos_house[i], 1 do
        ObjAnimate( "spr_pursuit_house_"..i..private.pos_house[i][j].kind, "scale_x", 0, 0, "", {
          0,                        0, private.house_turning_scale_x[i][ private.road_pos        ],
          private.turning_anim_tme, 0, private.house_turning_scale_x[i][ private.road_pos + side ]
        } );
      end;

    end;

    GridSet( "grd_pursuit_road_1", 0, private.road_vertex_pos[ private.road_pos ] );
    GridSet( "grd_pursuit_road_2", 0, private.road_vertex_pos[ private.road_pos ] );

    GridSet( "grd_pursuit_road_1", 1, private.road_vertex_pos[ private.road_pos + side ] );
    GridSet( "grd_pursuit_road_2", 1, private.road_vertex_pos[ private.road_pos + side ] );

    GridPlay( "grd_pursuit_road_1", "" );
    GridPlay( "grd_pursuit_road_2", "" );

    ObjSet( "tmr_pursuit_turning", { time = 1, playing = true } );

    ObjAnimate( "spr_pursuit_sky", "pos_x", 0, 0, func_after,
    {
      0,                        0, private.sky_pos[ private.road_pos ],
      private.turning_anim_tme, 0, private.sky_pos[ private.road_pos + side ]
    } );

    if ( private.road_pos + side == 1 ) then

      ObjSet( "spr_pursuit_btn_left_1", { input = false } );
      ObjAnimate( "spr_pursuit_btn_left_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_pursuit_btn_left_3", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    elseif ( private.road_pos + side == 2 ) and ( private.road_pos == 1 ) then

      ObjSet( "spr_pursuit_btn_left_1", { input = true } );
      ObjAnimate( "spr_pursuit_btn_left_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_pursuit_btn_left_3", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

    elseif ( private.road_pos + side == 2 ) and ( private.road_pos == 3 ) then

      ObjSet( "spr_pursuit_btn_right_1", { input = true } );
      ObjAnimate( "spr_pursuit_btn_right_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_pursuit_btn_right_3", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

    elseif ( private.road_pos + side == 3 ) then

      ObjSet( "spr_pursuit_btn_right_1", { input = false } );
      ObjAnimate( "spr_pursuit_btn_right_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_pursuit_btn_right_3", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    end;

    private.road_pos = private.road_pos + side;

  end;

end;
-----------------------------------------------------------------------------------
function public.BtnGo()

  SndStop( "assets/levels/level1/mg_pursuit/audio/aud_driving", 0.5 );
  cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_driving" );

  --private.btn_start_lock = true;

  if ( private.in_reset ) then
    private.in_reset = false;
  end;

  ObjStopAnimate( "txt_pursuit_start", 12 );

  ObjMultiSet( { { "txt_pursuit_start", { color_r = 0.258824, color_g = 0.152941, color_b = 0.156863, input = false } },
                 { "spr_pursuit_btn_left_1", { input = true } },
                 { "spr_pursuit_btn_right_1", { input = true } },
                 { "obj_pursuit_start_bbt", { input = false } } } );

  ObjAnimate( "spr_pursuit_start", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

  ObjAnimate( "spr_pursuit_btn_left_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
  ObjAnimate( "spr_pursuit_btn_right_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

  ObjAnimate( "spr_pursuit_btn_left_3", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "spr_pursuit_btn_right_3", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  ObjAnimate( "grd_pursuit_road_2", "alp",   1, 0, "", { 0, 0, 0,    0.5, 0, 1,    1.0, 0, 0 } );

  if ( not private.in_move ) then

    if ng_global.currentprogress == "std" then
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_pursuit");
    end;

    ObjSet( "anm_pursuit_necklace", { playing = true } );

    ObjAnimate( "obj_pursuit_car",        "pos_y", 1, 0, "", { 0, 0, -1,     0.1, 0, 1,      0.2, 0, -1 } );
    ObjAnimate( "spr_pursuit_car_window", "pos_y", 1, 0, "", { 0, 0, 322,    0.1, 0, 325,    0.2, 0, 322 } );

    private.in_move = true;

  end;

  public.Move();

end;
-----------------------------------------------------------------------------------
function public.Move()

  public.MoveTree();
  public.MoveHouse();
  public.MoveCars();


  if ( private.in_win == 1 ) then

    --DbgTrace( "ждем выйгрышный дом" );
    return;

  elseif ( private.in_win == 2 ) then

    private.move_speed = private.move_speed * 0.98;--0.98;

    for i = 1, private.car_number, 1 do
      private.car_speed[i] = private.car_speed[i] * 0.98;--0.98;
    end;

    if ( private.move_speed <= 0.1 ) and ( not private.road_stoped ) then

      --DbgTrace( "останавливаем дорогу" );

      private.road_stoped = true;

      ObjStopAnimate( "grd_pursuit_road_2", 8 );
      ObjAnimate( "grd_pursuit_road_2", "alp", 0, 0, "", { 0, 0, ObjGet( "grd_pursuit_road_2" ).alp,    0.3, 0, 0 } );

    elseif ( private.move_speed <= 0.01 ) then

      --DbgTrace( "остановились" );

      ObjSet( "tmr_pursuit_move", { playing = false } );

      for i = 1, 3, 1 do
        if ( private.pos_car[i].kind ~= 0 ) then

          ObjStopAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, 6 );
          ObjSet( "obj_pursuit_car_"..private.pos_car[i].kind, { alp = 0, scale_x = 0, scale_y = 0 } );

          --DbgTrace( "road "..i.." car "..private.pos_car[i].kind );

          private.car_alp[ private.pos_car[i].kind ] = 0;
          private.pos_car[i].kind = 0;

        end;
      end;

      cmn.Lock( 0 );

      private.Win();

    end;

  elseif ( private.in_reset ) then

    private.move_speed = private.move_speed * ( 1 - private.crash_move_speed_dec );

    for i = 1, private.car_number, 1 do
      private.car_speed[i] = private.car_speed[i] * ( 1 - private.crash_move_speed_dec );
    end;

    if ( private.move_speed <= 0.01 ) then

      --DbgTrace( "остановились" );

      ObjSet( "tmr_pursuit_move", { playing = false } );

      for i = 1, 3, 1 do
        if ( private.pos_car[i].kind ~= 0 ) then

          ObjStopAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, 6 );
          ObjSet( "obj_pursuit_car_"..private.pos_car[i].kind, { alp = 0, scale_x = 0, scale_y = 0 } );

          --DbgTrace( "road "..i.." car "..private.pos_car[i].kind );

          private.car_alp[ private.pos_car[i].kind ] = 0;
          private.pos_car[i].kind = 0;

        end;
      end;

      for i = private.life + 1, 3, 1 do
        ObjAnimate( "spr_pursuit_life_"..i, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      end;

      private.StartConditions();
      private.CheckFreeRoad();

      --private.btn_start_lock = false;
      ObjSet( "txt_pursuit_start", { input = true } );

      ObjAnimate( "txt_pursuit_start", 12, 1, 0, "", {
        0,   0, 0.568627, 0.541176, 0.541176,
        0.5, 0, 0,        0.752941, 1,
        1.0, 0, 0.568627, 0.541176, 0.541176
      } );

      ObjAnimate( "spr_pursuit_start", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );

      cmn.Lock( 0 );

    end;

  elseif ( private.in_crash == 0 ) then

    private.navigator_anim_tme = private.navigator_anim_tme * ( 1 - private.move_speed_inc );

    private.move_speed = private.move_speed * ( 1 + private.move_speed_inc );

    for i = 1, private.car_number, 1 do
      private.car_speed[i] = private.car_speed[i] * ( 1 + private.move_speed_inc );
    end;

  elseif ( private.in_crash == 1 ) then

    private.move_speed = private.move_speed * ( 1 - private.crash_move_speed_dec );

    for i = 1, private.car_number, 1 do
      private.car_speed[i] = private.car_speed[i] * ( 1 - private.crash_move_speed_dec );
    end;

    if ( private.move_speed <= private.crash_move_speed ) then
      private.in_crash = 2;
      --DbgTrace( "ускорение после стокновения" );
    end;

  elseif ( private.in_crash == 2 ) then

    private.move_speed = private.move_speed * ( 1 + private.crash_move_speed_inc );

    for i = 1, private.car_number, 1 do
      private.car_speed[i] = private.car_speed[i] * ( 1 + private.crash_move_speed_inc );
    end;

    if ( private.move_speed >= private.move_speed_after_crash ) then

      private.move_speed = private.move_speed_after_crash;

      for i = 1, private.car_number, 1 do
        private.car_speed[i] = private.car_speed_after_crash[i];
      end;

      private.in_crash = 0;

      --DbgTrace( "ускорились до" );
      --DbgTrace( "speed "..private.move_speed );
      --for i = 1, private.car_number, 1 do
      --  DbgTrace( "car "..i.." speed "..private.car_speed[i] );
      --end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.MoveCars()

  local move = true;

  local car_cur_pos_x;  --текущая позиция
  local car_cur_pos_y;
  local car_cur_scale;

  local car_new_pos_x;  --следующая позиция
  local car_new_pos_y;
  local car_new_scale;


  local dist_percent;     --процент пройденного растояния
  local car_frame;        --устанавливаемый фрейм анимации машин
  local car_remoteness;   --удаленность машины от текущий полосы

  for i = 1, 3, 1 do

    if ( private.pos_car[i].kind ~= 0 ) then

      ----------------------
      ----------------------установка фреймов машин
      if ( private.pos_car[i].kind < 5 ) then --только машины

        car_remoteness = math.abs(i - private.road_pos);
        dist_percent = ( private.pos_car[i].pos - private.car_start_segment ) / ( private.road_segments_num - private.car_start_segment );

        if private.in_turning then

          local car_remoteness_old = math.abs(i - private.pre_road_pos);

          local car_frame_new;
          local car_frame_old;
          local turning_percent = 1 - ObjGet( "tmr_pursuit_turning" ).time;

          if ( car_remoteness == 0 ) then

            car_frame_old = 
              ( ( private.car_frame[car_remoteness_old][2] - private.car_frame[car_remoteness_old][1] ) * dist_percent )
              + private.car_frame[car_remoteness_old][1];

            car_frame_new = 0;

          elseif ( car_remoteness_old == 0 ) then

            car_frame_old = 0;

            car_frame_new =
              ( ( private.car_frame[car_remoteness][2] - private.car_frame[car_remoteness][1] ) * dist_percent)
              + private.car_frame[car_remoteness][1];

          else

            car_frame_old = 
              ( ( private.car_frame[car_remoteness_old][2] - private.car_frame[car_remoteness_old][1] ) * dist_percent )
              + private.car_frame[car_remoteness_old][1];

            car_frame_new =
              ( ( private.car_frame[car_remoteness][2] - private.car_frame[car_remoteness][1] ) * dist_percent)
              + private.car_frame[car_remoteness][1];

          end;

          car_frame = math.floor( ( ( car_frame_new - car_frame_old ) * turning_percent ) + car_frame_old );

          --DbgTrace(
          --  "road "..i
          --  ..", dist_percent = "..dist_percent
          --  ..", car_remoteness "..car_remoteness_old.." -> "..car_remoteness
          --  ..", frame  "..car_frame_old.." -> "..car_frame_new.." = "..car_frame.." ( "..turning_percent.." )"
          --);

        elseif car_remoteness ~= 0 then

          car_frame = math.floor( 
            ((private.car_frame[car_remoteness][2] - private.car_frame[car_remoteness][1]) * dist_percent) + private.car_frame[car_remoteness][1]
          );

          --DbgTrace(
          --  "road "..i
          --  ..", dist_percent = "..dist_percent
          --  ..", car_remoteness = "..car_remoteness
          --  ..", frame = "..car_frame
          --);

        else

          car_frame = 0;

        end;

        if ( private.cur_car_frame[ private.pos_car[i].kind ] ~= car_frame ) then
          private.cur_car_frame[ private.pos_car[i].kind ] = car_frame;
          ObjSet( "anm_pursuit_car_"..private.pos_car[i].kind, { frame = car_frame } );
          --DbgTrace( "road "..i..", car "..private.pos_car[i].kind..", frame "..car_frame );
        end;

      end;
      ----------------------
      ----------------------

      car_cur_pos_x,car_cur_pos_y,car_cur_scale = private.GetPoint(i, private.pos_car[i].pos, "car");
      car_new_pos_x,car_new_pos_y,car_new_scale = private.GetPoint(i, private.pos_car[i].pos + private.car_speed[ private.pos_car[i].kind ], "car");

      ObjAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, "pos_xy", 0, 0, "", {
        0,                        0, car_cur_pos_x, car_cur_pos_y,
        private.move_timer_speed, 0, car_new_pos_x, car_new_pos_y
      } );

      ObjAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, "scale_xy", 0, 0, "", {
        0,                        0, car_cur_scale, car_cur_scale,
        private.move_timer_speed, 0, car_new_scale, car_new_scale
      } );

      if ( private.car_alp[ private.pos_car[i].kind ] == 0 ) and ( private.pos_car[i].pos >= private.show_segment ) then
        ObjAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, "alp", 0, 0, "", { 0, 0, 0,    private.show_anim_tme, 0, 1 } );
        private.car_alp[ private.pos_car[i].kind ] = 1;
      end;

      if ( not private.in_win )
      and ( private.pos_car[i].kind < 5 )
      --and ( private.car_aud_overtaking[ private.pos_car[i].kind ] == 0 )
      and ( not private.car_aud_overtaking )
      and ( private.pos_car[i].pos >= private.car_aud_overtaking_segment )
      and ( private.pos_car[i].pos <  private.road_segments_num - 1 ) then
        --DbgTrace( "звук обгона машины "..private.pos_car[i].kind..", pos = "..private.pos_car[i].pos );
        cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_overtaking" );
        --private.car_aud_overtaking[ private.pos_car[i].kind ] = 1;
        private.car_aud_overtaking = true;
      end;

      --if ( i == 1 ) then
      --  DbgTrace(
      --    "frame "..math.floor( private.pos_car[i].pos - private.car_start_segment )
      --    --"dist "..(car_new_pos_y - car_cur_pos_y)..
      --    --", pos ( "..car_cur_pos_x..", "..car_cur_pos_y.." ) -> ( "..car_new_pos_x..", "..car_new_pos_y.." )"
      --  );
      --  --DbgTrace( "scale "..car_cur_scale.." -> "..car_new_scale );
      --  --DbgTrace( "multiplier "..car_cur_pos_y_distance_multiplier.." -> "..car_new_pos_y_distance_multiplier );
      --  --DbgTrace( "" );
      --end;

      private.pos_car[i].pos = private.pos_car[i].pos + private.car_speed[ private.pos_car[i].kind ];

      if ( private.pos_car[i].pos >= private.road_segments_num ) then

        ObjStopAnimate( "obj_pursuit_car_"..private.pos_car[i].kind, 6 );
        ObjSet( "obj_pursuit_car_"..private.pos_car[i].kind, { alp = 0, scale_x = 0, scale_y = 0 } );

        if ( not private.in_win ) and ( not private.in_reset ) and (( private.road_pos == i ) or ( private.pre_road_pos == i )) then

          ObjAnimate( "spr_pursuit_life_"..private.life, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

          private.life = private.life - 1;
          --DbgTrace( "столкнулись с машиной "..private.pos_car[i].kind..", life = "..private.life );

          if ( private.pos_car[i].kind < 5 ) then
            if ( not private.playing_aud_crash3 ) then
              cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_crash3" );
            end;
            private.playing_aud_crash3 = true;
          elseif ( private.pos_car[i].kind == 5 ) then
            cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_crash2" );
          elseif ( private.pos_car[i].kind == 6 ) then
            cmn.PlayAudio( "snd", "assets/levels/level1/mg_pursuit/audio/aud_crash1" );
          end;

          if ( private.in_crash == 0 ) then

            if ( private.life > 0 ) then
              cmn.ShowBbt( "pursuit_crash" );
            else
              cmn.ShowBbt( "pursuit_crash2" );
            end;

            ObjStopAnimate( "obj_pursuit_car", 1 );
            ObjStopAnimate( "spr_pursuit_car_window", 1 );

            ObjAnimate( "obj_pursuit_car", "pos_y", 0, 0,
              function ()
                ObjAnimate( "obj_pursuit_car", "pos_y", 1, 0, "", { 0, 0, -1,    0.1, 0, 1,    0.2, 0, -1 } );
              end,
              {
                0, 0, ObjGet( "obj_pursuit_car" ).pos_y;
                0.1, 0, -5,
                0.2, 0, 5,
                0.3, 0, -5,
                0.4, 0, 5,
                0.5, 0, -1
              }
            );

            ObjAnimate( "spr_pursuit_car_window", "pos_y", 0, 0,
              function ()
                ObjAnimate( "spr_pursuit_car_window", "pos_y", 1, 0, "", { 0, 0, 322,    0.1, 0, 325,    0.2, 0, 322 } );
              end,
              {
                0, 0, ObjGet( "spr_pursuit_car_window" ).pos_y;
                0.1, 0, 318,
                0.2, 0, 328,
                0.3, 0, 318,
                0.4, 0, 328,
                0.5, 0, 322
              }
            );

            private.move_speed_after_crash = private.move_speed;  --скорость которая должна быть после ускорения после столкновения
            private.car_speed_after_crash = {};
            --DbgTrace( "speed = "..private.move_speed_after_crash );

            for i = 1, private.car_number, 1 do
              private.car_speed_after_crash[i] = private.car_speed[i];
              --DbgTrace( "car "..i.." speed "..private.car_speed_after_crash[i] );
            end;

          end;

          private.in_crash = 1;

          if ( private.pos_car[i].kind < 5 )
          --and ( private.car_aud_overtaking[ private.pos_car[i].kind ] == 0 )
          and ( private.car_aud_overtaking ) then
            SndStop( "assets/levels/level1/mg_pursuit/audio/aud_overtaking", 0.5 );
            private.car_aud_overtaking = false;
          end;

          private.car_alp[ private.pos_car[i].kind ] = 0;
          private.pos_car[i].kind = 0;

          if private.life <= 0 then
            public.Reset();
          end;

        elseif ( not private.in_win ) and ( not private.in_reset ) then

          if ( private.pos_car[i].kind < 5 )
          --and ( private.car_aud_overtaking[ private.pos_car[i].kind ] == 0 )
          and ( private.car_aud_overtaking ) then
            private.car_aud_overtaking = false;
          end;

          private.car_alp[ private.pos_car[i].kind ] = 0;
          private.pos_car[i].kind = 0;

          private.car_gone = private.car_gone + 1;

          --DbgTrace( "car_gone = "..private.car_gone );

          local navigator_pos, navigator_percent = math.modf( ( private.car_gone * 7 ) /private.win_car_gone );
          navigator_pos = navigator_pos + 1;

          local navigator_pos_next = navigator_pos + 1;

          if ( navigator_pos_next == 9 ) then
            navigator_pos = 7;
            navigator_pos_next = 8;
            navigator_percent = 0.999;
          end;

          local navigator_length = common_impl.math.FindSegmentLength(
            private.navigator_map[ navigator_pos ],
            private.navigator_map[ navigator_pos_next ]
          );

          local navigator_delta = ( navigator_length * navigator_percent ) / ( navigator_length * ( 1 - navigator_percent ) );

          --DbgTrace( "delta = "..( navigator_length * navigator_percent ).." / "..( navigator_length * ( 1 - navigator_percent ) ).." = "..navigator_delta );

          local navigator_pos_xy = common_impl.math.FindSegmentPoint(
            private.navigator_map[ navigator_pos ],
            private.navigator_map[ navigator_pos_next ],
            navigator_delta
          );

          --DbgTrace( "navigator_anim_tme "..private.navigator_anim_tme );

          ObjAnimate( "spr_pursuit_navigator_arrow", "pos_xy", 0, 0, "", {
            0,                          0, ObjGet( "spr_pursuit_navigator_arrow" ).pos_x, ObjGet( "spr_pursuit_navigator_arrow" ).pos_y,
            private.navigator_anim_tme, 0, navigator_pos_xy[1], navigator_pos_xy[2]
          } );

          ObjAnimate( "spr_pursuit_navigator_arrow", "ang", 0, 0, "", {
            0,                          0, ObjGet( "spr_pursuit_navigator_arrow" ).ang,
            private.navigator_anim_tme, 0, private.navigator_map_ang[ navigator_pos ]
          } );

          --DbgTrace( "navigator_pos = "..navigator_pos..", percent "..navigator_percent..", delta "..navigator_delta );
          --DbgTrace( "navigator_pos xy = "..navigator_pos_xy[1].." "..navigator_pos_xy[2].." ang "..private.navigator_map_ang[ navigator_pos ] );

          ObjAnimate( "spr_pursuit_dark", "alp", 0, 0, "", {
            0,   0, ObjGet( "spr_pursuit_dark" ).alp,
            0.5, 0, private.car_gone/private.win_car_gone
          } );
          --DbgTrace( "dark alp "..ObjGet( "spr_pursuit_dark" ).alp.." -> "..private.car_gone/private.win_car_gone );

          private.CheckWin();

        else

          if ( private.pos_car[i].kind < 5 )
          --and ( private.car_aud_overtaking[ private.pos_car[i].kind ] == 0 )
          and ( private.car_aud_overtaking ) then
            private.car_aud_overtaking = false;
          end;

          private.car_alp[ private.pos_car[i].kind ] = 0;
          private.pos_car[i].kind = 0;

        end;

        if ( not private.in_win ) then
          private.CheckFreeRoad();
        end;

        --move = false;

      end;

    end;

  end;

  if ( private.playing_aud_crash3 ) then
    private.playing_aud_crash3 = false;
  end;

  if ( not move ) then
    ObjSet( "tmr_pursuit_move", { playing = false } );
  else
    ObjSet( "tmr_pursuit_move", { time = private.move_timer_speed, endtrig = public.Move, playing = true } );
  end;

end;
-----------------------------------------------------------------------------------
function public.MoveTree()

  local tree_cur_pos_x;  --текущая позиция
  local tree_cur_pos_y;
  local tree_cur_scale;

  local tree_new_pos_x;  --следующая позиция
  local tree_new_pos_y;
  local tree_new_scale;

  for i = 1, #private.pos_tree, 1 do

    for j = 1, 2, 1 do  --левая/правая сторона

      tree_cur_pos_x, tree_cur_pos_y, tree_cur_scale = private.GetPoint( j, private.pos_tree[i], "tree" );
      tree_new_pos_x, tree_new_pos_y, tree_new_scale = private.GetPoint( j, private.pos_tree[i] + private.move_speed, "tree" );

      ObjAnimate( "obj_pursuit_tree_"..j..i, "pos_xy", 0, 0, "",
      {
        0,                        0, tree_cur_pos_x, tree_cur_pos_y,
        private.move_timer_speed, 0, tree_new_pos_x, tree_new_pos_y
      } );

      ObjAnimate( "obj_pursuit_tree_"..j..i, "scale_xy", 0, 0, "",
      {
        0,                        0, tree_cur_scale, tree_cur_scale,
        private.move_timer_speed, 0, tree_new_scale, tree_new_scale
      } );

      --if ( i == 1 ) and ( j == 1 ) then
      --  DbgTrace(
      --    --"pos "..private.pos_tree[i].." -> "..(private.pos_tree[i]+private.move_speed)
      --    "speed "..private.move_speed
      --    --.."dist "..(tree_new_pos_y - tree_cur_pos_y)
      --    --..", pos ( "..tree_cur_pos_x..", "..tree_cur_pos_y.." ) -> ( "..tree_new_pos_x..", "..tree_new_pos_y.." )"
      --  );
      --  --DbgTrace( "scale "..tree_cur_scale.." -> "..tree_new_scale );
      --  --DbgTrace( "multiplier "..tree_cur_pos_y_distance_multiplier.." -> "..tree_new_pos_y_distance_multiplier );
      --  --DbgTrace( "" );
      --end;

    end;

    if ( private.tree_alp[i] == 0 ) and ( private.pos_tree[i] >= private.show_segment ) then

      ObjAnimate( "obj_pursuit_tree_1"..i, "alp", 0, 0, "", { 0, 0, 0,    private.show_anim_tme, 0, 1 } );
      ObjAnimate( "obj_pursuit_tree_2"..i, "alp", 0, 0, "", { 0, 0, 0,    private.show_anim_tme, 0, 1 } );

      private.tree_alp[i] = 1;

    end;

    private.pos_tree[i] = private.pos_tree[i] + private.move_speed;

    if ( private.pos_tree[i] >= private.road_segments_num ) then

      private.pos_tree[i] = private.start_segment;
      private.tree_alp[i] = 0;

      ObjMultiSet( { { "obj_pursuit_tree_1"..i, { alp = 0 } },
                     { "obj_pursuit_tree_2"..i, { alp = 0 } } } );

      if ( private.in_win ) and ( not private.del_tree_before_win_house ) then

        local tree_num = i;
        local tree_sum = 0;

        while ( tree_sum < 4 ) do
          ObjSet( "spr_pursuit_tree_1"..tree_num, { alp = 0 } );
          tree_num = tree_num - 1;

          if ( tree_num < 1 ) then
            tree_num = 24;
          end;

          tree_sum = tree_sum + 1;
          --DbgTrace( "before tree_num = "..tree_num );
        end;

        private.del_tree_before_win_house = true;

      end;

      if ( private.in_win ) and ( private.del_tree_after_win_house < 4 ) then
        private.del_tree_after_win_house = private.del_tree_after_win_house + 1;
        ObjSet( "spr_pursuit_tree_1"..i, { alp = 0 } );
        --DbgTrace( "after tree_num = "..i );
      end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.MoveHouse()

  local house_cur_pos_x;  --текущая позиция
  local house_cur_pos_y;
  local house_cur_scale;

  local house_new_pos_x;  --следующая позиция
  local house_new_pos_y;
  local house_new_scale;

  for i = 1, 2, 1 do

    for j = #private.pos_house[i], 1, -1 do

      --if ( j <= private.house_max_show ) then --анимируем только первые 6

        house_cur_pos_x, house_cur_pos_y, house_cur_scale = private.GetPoint( i, private.pos_house[i][j].pos, "house" );
        house_new_pos_x, house_new_pos_y, house_new_scale = private.GetPoint( i, private.pos_house[i][j].pos + private.move_speed, "house" );

        ObjAnimate( "obj_pursuit_house_"..i..private.pos_house[i][j].kind, "pos_xy", 0, 0, "", {
          0,                        0, house_cur_pos_x, house_cur_pos_y,
          private.move_timer_speed, 0, house_new_pos_x, house_new_pos_y
        } );

        ObjAnimate( "obj_pursuit_house_"..i..private.pos_house[i][j].kind, "scale_xy", 0, 0, "", {
          0,                        0, house_cur_scale, house_cur_scale,
          private.move_timer_speed, 0, house_new_scale, house_new_scale
        } );

        if ( private.house_alp[i][ private.pos_house[i][j].kind ] == 0 )
        and ( private.pos_house[i][j].pos >= private.show_segment - ( private.house_length[ private.pos_house[i][j].kind ] / 2 ) ) then

          ObjAnimate( "obj_pursuit_house_"..i..private.pos_house[i][j].kind, "alp", 0, 0, "", { 0, 0, 0,    private.show_anim_tme, 0, 1 } );

          private.house_alp[i][ private.pos_house[i][j].kind ] = 1;

          --if ( i == 1 ) then
          --  DbgTrace( "side == "..i..", show house "..private.pos_house[i][j].kind..", alp 0 -> 1, pos = "..private.pos_house[i][j].pos );
          --end;

        end;

        if ( private.in_win == 1 ) and ( private.pos_house[i][j].kind == 13 ) and ( private.pos_house[i][j].pos > 1950 ) then
          private.in_win = 2;
          --DbgTrace( "подьезжаем к выйгришному дому" );
        end;

        --if ( i == 1 )  then--and ( j == 1 )
        --  --DbgTrace( "house "..i..j..", kind "..private.pos_house[i][j].kind..", pos "..private.pos_house[i][j].pos );
        --  DbgTrace(
        --    "house "..i..j
        --    .."pos "..private.pos_house[i][j].pos
        --    --..", dist "..(house_new_pos_y - house_cur_pos_y)
        --    ..", pos ( "..house_cur_pos_x..", "..house_cur_pos_y.." ) -> ( "..house_new_pos_x..", "..house_new_pos_y.." )"
        --  );
        --  --DbgTrace( "scale "..house_cur_scale.." -> "..house_new_scale );
        --  --DbgTrace( "multiplier "..house_cur_pos_y_distance_multiplier.." -> "..house_new_pos_y_distance_multiplier );
        --  --DbgTrace( "" );
        --end;

      --end;

      private.pos_house[i][j].pos = private.pos_house[i][j].pos + private.move_speed;

    end;

    if ( private.pos_house[i][1].pos >= private.road_segments_num ) then  --убираем дом

      ObjStopAnimate( "obj_pursuit_house_"..i..private.pos_house[i][1].kind, 6 );
      ObjSet( "obj_pursuit_house_"..i..private.pos_house[i][1].kind, { alp = 0 ,scale_x = 0, scale_y = 0 } );

      --if ( i == 1 ) then
      --  DbgTrace( "side == "..i..", remove house" );
      --end;

      private.house_alp[i][ private.pos_house[i][1].kind ] = 0;

      --DbgTrace( "house "..private.pos_house[i][1].kind..", alp = 0, pos = "..private.pos_house[i][1].pos );

      table.remove( private.pos_house[i], 1 );

    end;

    if ( private.pos_house[i][ #private.pos_house[i] ].pos 
    >= private.start_segment + private.house_length[ private.house_next[i] ] + private.house_gap ) then --ставим дом

      --if ( i == 1 ) then
      --  DbgTrace( "side == "..i..", insert house, kind == "..private.house_next[i]..", # == "..#private.pos_house[i] );
      --end;

      table.insert( private.pos_house[i], { kind = private.house_next[i], pos = private.start_segment } );

      local house_num = #private.pos_house[i];

      ObjStopAnimate( "spr_pursuit_house_"..i..private.pos_house[i][house_num].kind, 4 );
      ObjSet( "spr_pursuit_house_"..i..private.pos_house[i][house_num].kind, { scale_x = private.house_turning_scale_x[i][ private.road_pos ] } );

      for n = 1, house_num, 1 do
        ObjSet( "obj_pursuit_house_"..i..private.pos_house[i][n].kind, { pos_z = house_num - n } );
      end;

      private.house_next[i] = private.FindFreeHouse( i );

      --if ( i == 1 ) then
      --  DbgTrace( "side == "..i..", house_next = "..private.house_next[i].."\n" );
      --end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.GetPoint( i, pos, name )  --i - сторона

  local distance_multiplier = --расчитываем интерполяцию ( в начале пути движемся медленнее )
    (1 + ( ( pos / private.road_segments_num ) * private.distance_multiplier ) - private.distance_multiplier) ^ private.distance_multiplier_degree;

  local pos_y = ( ( private.center_road_length / private.road_segments_num ) * pos ) * distance_multiplier;
  local scale = ( ( private[ name.."_max_scale" ] / private.road_segments_num ) * pos ) * distance_multiplier;

  local finish_pos_x;

  if ( not private.in_turning ) then
    finish_pos_x = private[ name.."_finish_pos_x" ][ private.road_pos ][i];
  else  --во время поворота смотрим реальную позицию точки финиша
    finish_pos_x = ObjGet( "obj_pursuit_"..name.."_finish_"..i ).pos_x;
  end;

  local pos_x = common_impl.math.FindLineIntersection( 
    { 0, 0 },
    { finish_pos_x, private.center_road_length },
    { -44444, pos_y },
    {  44444, pos_y }
  )[1];

  return pos_x, pos_y, scale;

end;
-----------------------------------------------------------------------------------
function private.FindFreeHouse( side )

  local house_find = false;
  local free_house_kind = math.random( 1, private.house_number );

  while ( not house_find ) do

    --DbgTrace( "free_house_kind = "..free_house_kind );

    house_find = true;

    for i = 1, #private.pos_house[side], 1 do
      if ( private.pos_house[side][i].kind == free_house_kind ) then
        house_find = false;
        break;
      end;
    end;

    if ( not house_find ) then
      free_house_kind = free_house_kind + 1;
      if ( free_house_kind > private.house_number ) then
        free_house_kind = 1;
      end;
    end;

  end;

  return free_house_kind;

end;
-----------------------------------------------------------------------------------
function private.FindFreeCar()

  local car_find = false;
  local free_car_kind = math.random( 1, private.car_number );

  while ( not car_find ) do

    car_find = true;

    for i = 1, #private.pos_car, 1 do
      if ( private.pos_car[i].kind == free_car_kind ) then
        car_find = false;
        break;
      end;
    end;

    if ( not car_find ) then
      free_car_kind = free_car_kind + 1;
      if ( free_car_kind > private.car_number ) then
        free_car_kind = 1;
      end;
    end;

  end;

  return free_car_kind;

end;
-----------------------------------------------------------------------------------
function private.CheckFreeRoad()

  local free_road_num = 0;

  for i = 1, #private.pos_car, 1 do
    if ( private.pos_car[i].kind == 0 ) then
      free_road_num = free_road_num + 1;
    end;
  end;

  local start_road = math.random( 1, 2 );
  local end_road = #private.pos_car;
  local offset_road = 1;

  if ( start_road == 2 ) then
    start_road = end_road;
    end_road = 1;
    offset_road = -1;
  end;

  for i = start_road, end_road, offset_road do

    if ( private.pos_car[i].kind == 0 ) then

      --[[
      if ( free_road_num == 2 ) then

        local road_hold = math.random( 1, 2 );

        if ( road_hold == 2 ) then

          private.pos_car[i].kind = private.FindFreeCar();
          private.pos_car[i].pos = private.car_start_segment;

          free_road_num = free_road_num - 1;

          ObjSet( "obj_pursuit_car_"..private.pos_car[i].kind, { pos_z = #private.pos_car - math.abs( private.road_pos - i ) } );
          --DbgTrace( "road "..i..", pos_z = "..( #private.pos_car - math.abs( private.road_pos - i ) ) );

        end;

      elseif ( free_road_num == 3 ) then
      ]]
      if ( free_road_num > 1 ) then

        private.pos_car[i].kind = private.FindFreeCar();
        private.pos_car[i].pos = private.car_start_segment;

        free_road_num = free_road_num - 1;

        ObjSet( "obj_pursuit_car_"..private.pos_car[i].kind, { pos_z = #private.pos_car - math.abs( private.road_pos - i ) } );
        --DbgTrace( "road "..i..", pos_z = "..( #private.pos_car - math.abs( private.road_pos - i ) ) );

        if ( private.pos_car[i].kind < 5 ) then --только машины
          if ( i < private.road_pos ) then

            if ( private.cur_car_func[ private.pos_car[i].kind ] ~= 2 ) then
              private.cur_car_func[ private.pos_car[i].kind ] = 2;
              ObjSet( "anm_pursuit_car_"..private.pos_car[i].kind, { animfunc = "func_car_"..private.pos_car[i].kind.."_anim_right" } );
              --DbgTrace( "[chk]road "..i..", car "..private.pos_car[i].kind..", func right" );
            end;

          elseif ( i > private.road_pos ) then

            if ( private.cur_car_func[ private.pos_car[i].kind ] ~= 1 ) then
              private.cur_car_func[ private.pos_car[i].kind ] = 1;
              ObjSet( "anm_pursuit_car_"..private.pos_car[i].kind, { animfunc = "func_car_"..private.pos_car[i].kind.."_anim_left" } );
              --DbgTrace( "[chk]road "..i..", car "..private.pos_car[i].kind..", func left" );
            end;

          end;
        end;

      end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.FocusBtn( side, inout )
  
  local obj = "spr_pursuit_btn_"..side.."_2";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
-----------------------------------------------------------------------------------
--function public.FocusBtnStart( inout )
--
--  if ( inout == 1 ) then
--
--    SetCursor(CURSOR_HAND);
--    ObjSet( "txt_pursuit_start", { color_r = 0, color_g = 0.752941, color_b = 1 } );
--
--  elseif ( not private.btn_start_lock ) then
--
--    SetCursor(CURSOR_DEFAULT);
--    ObjSet( "txt_pursuit_start", { color_r = 0.568627, color_g = 0.541176, color_b = 0.541176 } );
--
--  end;
--
--end;
--*********************************************************************************************************************