-- name=rm_castlegate
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_castlegate";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  -- function get_coals () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_coals" ] = {
      type = "get",
      get_obj = "spr_castledoor_coals",
      room = private.room_objname,
      zz = "zz_castledoor",
      zz_gate = "gzz_castlegate_castledoor"
  };
  --------------------------------------------------------------------------------------------
  local get_coals_inv = function ()
  
    interface.InventoryItemAdd( "inv_coals", "spr_castledoor_coals" );
  
  end;
  local get_coals_mid = function ()
  
    ObjDelete( "gfx_castledoor_coals" );
    ObjDelete( "spr_castledoor_coals_sh" ); 
    ObjDelete( "spr_castledoor_coals_bl" );
    ObjDelete( "spr_castlegate_gate_coal" );
  
  end;
  local get_coals_end = function ()
  
    ObjMultiSet( { {"anm_castledoor_dog_touch", { alp = 1 }},
                   {"spr_castledoor_gear1", { alp = 1 }},
                   {"spr_castlegate_gate_red_eyes", { alp = 1 }} } );
    ObjDelete( "anm_castledoor_dog_first" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_coals", get_coals_inv );
  cmn.AddSubscriber( "get_coals_inv", get_coals_inv );
  cmn.AddSubscriber( "get_coals", get_coals_end, private.room_objname );
  cmn.AddSubscriber( "get_coals_end", get_coals_end, private.room_objname );
  cmn.AddSubscriber( "get_coals", get_coals_mid, private.room_objname );
  cmn.AddSubscriber( "get_coals_mid", get_coals_mid, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sharpfang () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sharpfang" ] = {
      type = "get",
      get_obj = "spr_snake_sharpfang",
      room = private.room_objname,
      zz = "zz_snake",
      zz_gate = "gzz_castlegate_snake"
  };
  --------------------------------------------------------------------------------------------
  local get_sharpfang_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharpfang", "spr_snake_sharpfang" );
  
  end;
  local get_sharpfang_end = function ()
  
    ObjDelete( "gfx_snake_sharpfang" );
    ObjDelete( "spr_snake_sharpfang_sh" );
    
    ObjDelete( "spr_castlegate_snake_fang_2" );
    
    if cmn.IsEventDone("get_nestling") then
      ObjDelete( "gzz_castlegate_snake" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sharpfang", get_sharpfang_inv );
  cmn.AddSubscriber( "get_sharpfang", get_sharpfang_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nestling () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_nestling" ] = {
      type = "get",
      get_obj = "obj_snake_nestling",
      room = private.room_objname,
      zz = "zz_snake",
      zz_gate = "gzz_castlegate_snake"
  };
  --------------------------------------------------------------------------------------------
  local get_nestling_inv = function ()
  
    interface.InventoryItemAdd( "inv_nestling", "obj_snake_nestling" );
    int_map_impl.DecreaseRoomTasks("rm_castlegate");
  
  end;
  local get_nestling_end = function ()
  
    ObjDelete( "gfx_snake_nestling" );
    ObjDelete( "spr_snake_nestling_sh" );
    
    ObjDelete( "anm_castlegate_snake_bird_2" );
    
    if cmn.IsEventDone("get_sharpfang") then
      ObjDelete( "gzz_castlegate_snake" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_nestling", get_nestling_inv );
  cmn.AddSubscriber( "get_nestling", get_nestling_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_goldenbone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_goldenbone" ] = {
      type = "use",
      inv_obj = "inv_goldenbone",
      use_place = "obj_castledoor_use_goldenbone",
      room = private.room_objname,
      zz = "zz_castledoor",
      zz_gate = "gzz_castlegate_castledoor"
  };
  --------------------------------------------------------------------------------------------
  local use_goldenbone_inv = function ()
  
    interface.InventoryItemRemove( "inv_goldenbone" );
  
  end;
  local use_goldenbone_beg = function ()
  
    ObjDelete( "obj_castledoor_use_goldenbone" );
    ObjDelete( "anm_castledoor_dog_touch" );
    ObjDelete( "spr_castledoor_gear1" );
    ObjDelete( "spr_castledoor_gear2" );
  
  end;
  local use_goldenbone_end = function ()
  
    ObjMultiSet( { {"grm_castlegate_entrancehall",  { active = 1, input = 1, alp = 1 }},
                   {"spr_castlegate_gate_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_castlegate_entrancehall_focus");
    end;
    ObjDelete( "gzz_castlegate_castledoor" );
    ObjDelete( "spr_castlegate_gate_red_eyes" );
  
  end;
  local use_goldenbone_preloc = function ()
  
    ObjMultiSet( { {"spr_nearcastle_gate_open", { alp = 1 }},
                   {"grm_nearcastle_castlegate_focus", { res = "assets/levels/level1/rm_nearcastle/focus_castlegate_2" }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goldenbone", use_goldenbone_beg, private.room_objname );
  cmn.AddSubscriber( "use_goldenbone", use_goldenbone_inv );
  cmn.AddSubscriber( "use_goldenbone", use_goldenbone_end, private.room_objname );
  cmn.AddSubscriber( "use_goldenbone_inv", use_goldenbone_inv, private.room_objname );
  cmn.AddSubscriber( "use_goldenbone_beg", use_goldenbone_beg, private.room_objname );
  cmn.AddSubscriber( "use_goldenbone_end", use_goldenbone_end, private.room_objname );
  cmn.AddSubscriber( "use_goldenbone", use_goldenbone_preloc, "rm_nearcastle" );
  cmn.AddSubscriber( "use_goldenbone_preloc", use_goldenbone_preloc, "rm_nearcastle" );
  --------------------------------------------------------------------------------------------
  -- function use_scales () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scales" ] = {
      type = "use",
      inv_obj = "inv_scales",
      use_place = "obj_snake_use_scales",
      room = private.room_objname,
      zz = "zz_snake",
      zz_gate = "gzz_castlegate_snake"
  };
  --------------------------------------------------------------------------------------------
  local use_scales_inv = function ()
  
    interface.InventoryItemRemove( "inv_scales" );
  
  end;
  local use_scales_beg = function ()
  
    ObjDelete( "obj_snake_use_scales" );
  
  end;
  local use_scales_end = function ()
    
    ObjMultiSet( { {"spr_snake_snake_scales", { alp = 1 }},
                   {"spr_castlegate_snake_scales", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_apple") then
      ObjMultiSet( { {"anm_snake_snake_fang", { input = 1, alp = 1, frame = 400 }},
                     {"spr_castlegate_snake_fang_2", { alp = 1 }},
                     {"spr_castlegate_snake_eye", { alp = 1 }} } );
      ObjDelete( "anm_snake_snake_touch" );
      ObjDelete( "spr_castlegate_snake_fang_1" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scales", use_scales_beg, private.room_objname );
  cmn.AddSubscriber( "use_scales", use_scales_inv );
  cmn.AddSubscriber( "use_scales", use_scales_end, private.room_objname );
  cmn.AddSubscriber( "use_scales_inv", use_scales_inv, private.room_objname );
  cmn.AddSubscriber( "use_scales_beg", use_scales_beg, private.room_objname );
  cmn.AddSubscriber( "use_scales_end", use_scales_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_apple () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_apple" ] = {
      type = "use",
      inv_obj = "inv_apple",
      use_place = "obj_snake_use_apple",
      room = private.room_objname,
      zz = "zz_snake",
      zz_gate = "gzz_castlegate_snake"
  };
  --------------------------------------------------------------------------------------------
  local use_apple_inv = function ()
  
    interface.InventoryItemRemove( "inv_apple" );
  
  end;
  local use_apple_beg = function ()
  
    ObjDelete( "obj_snake_use_apple" );
  
  end;
  local use_apple_end = function ()
    
    ObjMultiSet( { {"anm_snake_snake_apple", { frame = 200 }},
                   {"spr_castlegate_snake_apple", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_scales") then
      ObjMultiSet( { {"anm_snake_snake_fang", { input = 1, alp = 1, frame = 400 }},
                     {"spr_castlegate_snake_fang_2", { alp = 1 }},
                     {"spr_castlegate_snake_eye", { alp = 1 }} } );
      ObjDelete( "anm_snake_snake_touch" );
      ObjDelete( "spr_castlegate_snake_fang_1" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_apple", use_apple_beg, private.room_objname );
  cmn.AddSubscriber( "use_apple", use_apple_inv );
  cmn.AddSubscriber( "use_apple", use_apple_end, private.room_objname );
  cmn.AddSubscriber( "use_apple_inv", use_apple_inv, private.room_objname );
  cmn.AddSubscriber( "use_apple_beg", use_apple_beg, private.room_objname );
  cmn.AddSubscriber( "use_apple_end", use_apple_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_beanwrapping () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_beanwrapping" ] = {
      type = "use",
      inv_obj = "inv_beanwrapping",
      use_place = "obj_snake_use_beanwrapping",
      room = private.room_objname,
      zz = "zz_snake",
      zz_gate = "gzz_castlegate_snake"
  };
  --------------------------------------------------------------------------------------------
  local use_beanwrapping_inv = function ()
  
    interface.InventoryItemRemove( "inv_beanwrapping" );
  
  end;
  local use_beanwrapping_beg = function ()
  
    ObjDelete( "obj_snake_use_beanwrapping" );
    ObjDelete( "anm_snake_bird_touch" );
    ObjDelete("anm_snake_bird");
  
  end;
  local use_beanwrapping_end = function ()
  
    ObjMultiSet( { {"obj_snake_nestling", { alp = 1, input = 1 }},
                   {"anm_castlegate_snake_bird_2", { alp = 1 }}--,
                   --{"obj_snake_beans", { alp = 1 }}
                 } );
    
    ObjDelete( "anm_snake_use_beans" );
    
    ObjDelete( "anm_castlegate_snake_bird_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_beanwrapping", use_beanwrapping_beg, private.room_objname );
  cmn.AddSubscriber( "use_beanwrapping", use_beanwrapping_inv );
  cmn.AddSubscriber( "use_beanwrapping", use_beanwrapping_end, private.room_objname );
  cmn.AddSubscriber( "use_beanwrapping_inv", use_beanwrapping_inv, private.room_objname );
  cmn.AddSubscriber( "use_beanwrapping_beg", use_beanwrapping_beg, private.room_objname );
  cmn.AddSubscriber( "use_beanwrapping_end", use_beanwrapping_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_castlegate () end;
  --------------------------------------------------------------------------------------------
  local opn_castlegate_map = function ()
  
    int_map_impl.OpenRoom( "rm_castlegate" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_castlegate", opn_castlegate_map );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_snake" );
  
  function zz_snake.PreOpen()
    
    if cmn.IsEventDone("use_beanwrapping") and not cmn.IsEventDone("get_nestling") then
      ObjSet("anm_snake_nestling",  { playing = 1 });
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_castlegate();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_castlegate_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_castlegate_env");
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(3) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_goldenbone()

  local item = "inv_goldenbone";

  if cmn.ApplyObj( item, "gzz_castlegate_castledoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_castledoor" );

  elseif ( cmn.ApplyObj( item, "obj_castledoor_use_goldenbone" ) ) then

    cmn.CallEventHandler( "use_goldenbone_inv" );
    cmn.CallEventHandler( "use_goldenbone_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goldenbone" );
      cmn.CallEventHandler( "use_goldenbone_end" );
      cmn.CallEventHandler("use_goldenbone_preloc");
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_use_bone");

    ObjSet("anm_castledoor_use_bone",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scales()

  local item = "inv_scales";
  local scroll = common_impl.CheckScrollSubroomHintPos("zz_snake", 2, "obj_snake_use_scales");

  if cmn.ApplyObj( item, "gzz_castlegate_snake" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_snake" );
    
  elseif (ObjIntersect( item, "obj_int_frame_subroom_frame_gate_top" ) or ObjIntersect( item, "obj_int_frame_subroom_frame_button_top" )) and scroll then
    
    --interface.ObjDoNotDrop();
    common_impl.ScrollSubroom();

  elseif ( cmn.ApplyObj( item, "obj_snake_use_scales" ) and not scroll ) then

    cmn.CallEventHandler( "use_scales_inv" );
    cmn.CallEventHandler( "use_scales_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scales" );
      cmn.CallEventHandler( "use_scales_end" );
    
    end;
    
    local anm_fang = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_opn_mounth");
      
      ObjDelete( "anm_snake_snake_touch" );
      ObjSet("anm_snake_snake_fang",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_use_scales");

    if cmn.IsEventDone("use_apple") then
      ObjAnimate( "spr_snake_snake_scales", "alp", 0, 0, anm_fang, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_snake_snake_scales", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  elseif common.GetCurrentSubRoom() == "zz_snake" and scroll then

    common_impl.HintShowPlace( scroll, "", false, true );
    cmn.WrongApply(); 
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_apple()

  local item = "inv_apple";
  local scroll = common_impl.CheckScrollSubroomHintPos("zz_snake", 2, "obj_snake_use_apple");

  if cmn.ApplyObj( item, "gzz_castlegate_snake" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_snake" );
    
  elseif (ObjIntersect( item, "obj_int_frame_subroom_frame_gate_top" ) or ObjIntersect( item, "obj_int_frame_subroom_frame_button_top" )) and scroll then
    
    --interface.ObjDoNotDrop();
    common_impl.ScrollSubroom();

  elseif ( cmn.ApplyObj( item, "obj_snake_use_apple" ) and not scroll ) then

    cmn.CallEventHandler( "use_apple_inv" );
    cmn.CallEventHandler( "use_apple_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_apple" );
      cmn.CallEventHandler( "use_apple_end" );
    
    end;

    local anm_fang = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_opn_mounth");
      
      ObjDelete( "anm_snake_snake_touch" );
      ObjSet("anm_snake_snake_fang",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_use_apple");

    if cmn.IsEventDone("use_scales") then
      ObjSet("anm_snake_snake_apple",  { playing = 1, endtrig = anm_fang });
    else 
      ObjSet("anm_snake_snake_apple",  { playing = 1, endtrig = func_after });
    end;
    
  elseif common.GetCurrentSubRoom() == "zz_snake" and scroll then

    common_impl.HintShowPlace( scroll, "", false, true );
    cmn.WrongApply(); 

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_beanwrapping()

  local item = "inv_beanwrapping";
  local scroll = common_impl.CheckScrollSubroomHintPos("zz_snake", 2, "obj_snake_use_beanwrapping");

  if cmn.ApplyObj( item, "gzz_castlegate_snake" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_snake" );
    
  elseif (ObjIntersect( item, "obj_int_frame_subroom_frame_gate_bot" ) or ObjIntersect( item, "obj_int_frame_subroom_frame_button_down" )) and scroll then
    
    --interface.ObjDoNotDrop();
    common_impl.ScrollSubroom();

  elseif ( cmn.ApplyObj( item, "obj_snake_use_beanwrapping" ) and not scroll ) then

    cmn.CallEventHandler( "use_beanwrapping_inv" );
    cmn.CallEventHandler( "use_beanwrapping_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.ShowBbt( "snake_after_use_beanwrapping" );

      cmn.SetEventDone( "use_beanwrapping" );
      cmn.CallEventHandler( "use_beanwrapping_end" );
      
      ObjMultiSet( { {"spr_snake_snake", { alp = 1 }},
                     {"anm_snake_bush_1", { alp = 1 }},
                     {"anm_snake_nestling", { playing = 1 }} } );
    
    end;
    
    ObjMultiSet( { {"anm_snake_use_beans",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_snake_snake", { alp = 0 }},
                   {"anm_snake_bush_1", { alp = 0 }} } );
      

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_chick_eat");
    
  elseif common.GetCurrentSubRoom() == "zz_snake" and scroll then

    common_impl.HintShowPlace( scroll, "", false, true );
    cmn.WrongApply(); 

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_coals()

  cmn.SetEventDone( "get_coals" );
  cmn.CallEventHandler( "get_coals_inv" );
  cmn.CallEventHandler( "get_coals_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_xx_dogs_head");
  
  ObjSet("anm_castledoor_dog_first",  { playing = 1, endtrig = function() cmn.CallEventHandler( "get_coals_end" ); cmn.Lock(0); end });

end;
--------------------------------------------------------------------------------------------
function public.get_sharpfang()
  
  ObjSet("spr_snake_sharpfang",  { ang = 1.6947, pos_x = 0, drawoff_x = 0, scale_x = 1.5065, scale_y = 1.5065 });

  cmn.SetEventDone( "get_sharpfang" );
  cmn.CallEventHandler( "get_sharpfang" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if cmn.IsEventDone("get_nestling") then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.get_nestling()

  cmn.SetEventDone( "get_nestling" );
  cmn.CallEventHandler( "get_nestling" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_sharpfang") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_castlegate()

  if not ( cmn.IsEventDone( "opn_castlegate" ) ) then
    
    cmn.SetEventDone( "opn_castlegate" );
    cmn.CallEventHandler("opn_castlegate");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_dog()
  
  cmn.ShowBbt( "obj_castledoor_use_goldenbone" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_xx_dogs_head");
  
  if not cmn.IsEventDone("get_coals") then
    
    cmn.SetEventDone( "get_coals" );
    cmn.CallEventHandler( "get_coals_inv" );
    cmn.CallEventHandler( "get_coals_mid" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    
    ObjSet("anm_castledoor_dog_first",  { playing = 1, endtrig = function() cmn.CallEventHandler( "get_coals_end" ); cmn.Lock(0); end });
      
  else 
    ObjSet("anm_castledoor_dog_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  end;  
    
end;
--------------------------------------------------------------------------------------------
function public.touch_snake( num )
  
  if num == 1 then
    cmn.ShowBbt( "obj_snake_use_scales" );
  else 
    cmn.ShowBbt( "obj_snake_use_apple" );
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_xx_snake_head_2");
  
  ObjSet("anm_snake_snake_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_bird()
  
  cmn.ShowBbt( "obj_snake_use_beanwrapping" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_castlegate/audio/aud_xx_chicken");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_snake_bird", { alp = 1, playing = 1 }},
                   {"anm_snake_bird_touch", { alp = 0 }} } );
    
  end;
  
  cmn.Lock(1);
  
  ObjMultiSet( { {"anm_snake_bird", { alp = 0, playing = 0 }},
                 {"anm_snake_bird_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
    
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_3_1", { alp = 1 }},
                 {"spr_col_3_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_3_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_3_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_3_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_3_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_3_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_3_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
