-- name=rm_entrancehall
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_entrancehall";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.scales_pos = { { {216, -165, 0}, {-195, -179, 0}, {-204, 41, 0}, {-72, 191, 0}, {218, 202, 0} }, 
   { {69, 206, -0.91}, {56, 205, 0}, {82, 204, 0.4}, {76, 194, 0}, {50, 194, 0} } };
  private.scales_end_pos = {72, 204};
  --------------------------------------------------------------------------------------------
  -- function get_yingyangfish () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_yingyangfish" ] = {
      type = "get",
      get_obj = "obj_aquarium_yingyangfish_get",
      room = private.room_objname,
      zz = "zz_aquarium",
      zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local get_yingyangfish_inv = function ()
  
    interface.InventoryItemAdd( "inv_yingyangfish", "obj_aquarium_yingyangfish_get" );
  
  end;
  local get_yingyangfish_end = function ()
  
    ObjDelete( "gfx_aquarium_yingyangfish" );
    ObjDelete( "spr_aquarium_yingyangfish_sh" );
    
    ObjDelete( "spr_entrancehall_tank_fish_2" );
    ObjDelete( "spr_entrancehall_tank_jug" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_yingyangfish", get_yingyangfish_inv );
  cmn.AddSubscriber( "get_yingyangfish", get_yingyangfish_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scales () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scales" ] = {
      type = "get",
      get_obj = "obj_aquarium_scales",
      room = private.room_objname,
      zz = "zz_aquarium",
      zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local get_scales_inv = function ()
  
    interface.InventoryItemAdd( "inv_scales", "obj_aquarium_scales" );
  
  end;
  local get_scales_end = function ()
  
    ObjDelete( "gfx_aquarium_scales" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scales", get_scales_inv );
  cmn.AddSubscriber( "get_scales", get_scales_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_woodenwolf () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_woodenwolf" ] = {
      type = "get",
      get_obj = "obj_couch_woodenwolf",
      room = private.room_objname,
      zz = "zz_couch",
      zz_gate = "gzz_entrancehall_couch"
  };
  --------------------------------------------------------------------------------------------
  local get_woodenwolf_inv = function ()
  
    interface.InventoryItemAdd( "inv_woodenwolf", "obj_couch_woodenwolf" );
  
  end;
  local get_woodenwolf_end = function ()
  
    ObjDelete( "gfx_couch_woodenwolf" );
    ObjDelete( "spr_couch_woodenwolf_sh" );
    
    ObjDelete( "spr_entrancehall_coach_wolf" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_woodenwolf", get_woodenwolf_inv );
  cmn.AddSubscriber( "get_woodenwolf", get_woodenwolf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_note () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_note" ] = {
      type = "get",
      get_obj = "spr_couch_note",
      room = private.room_objname,
      zz = "zz_couch",
      zz_gate = "gzz_entrancehall_couch"
  };
  --------------------------------------------------------------------------------------------
  local get_note_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_note", "spr_couch_note" );
  
  end;
  local get_note_end = function ()
  
    ObjDelete( "gfx_couch_note" );
    ObjDelete( "spr_couch_note_sh" );
    
    ObjDelete( "spr_entrancehall_couch_note" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_note", get_note_inv );
  cmn.AddSubscriber( "get_note", get_note_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wings () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wings" ] = {
      type = "get",
      get_obj = "spr_couch_wings",
      room = private.room_objname,
      zz = "zz_couch",
      zz_gate = "gzz_entrancehall_couch"
  };
  --------------------------------------------------------------------------------------------
  local get_wings_inv = function ()
  
    interface.InventoryItemAdd( "inv_wings", "spr_couch_wings" );
    if cmn.IsEventDone("use_rubyheart") then
      ObjSet("inv_heartmedallion_star_light",  { alp = 1 });
    end;
  
  end;
  local get_wings_end = function ()
  
    ObjDelete( "gfx_couch_wings" );
    ObjDelete( "spr_couch_wings_sh" );
    
    ObjDelete( "spr_entrancehall_coach_wings" );
    ObjDelete( "gzz_entrancehall_couch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wings", get_wings_inv );
  cmn.AddSubscriber( "get_wings", get_wings_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_apple () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_apple" ] = {
      type = "get",
      get_obj = "spr_princessstatuette_apple",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_apple_inv = function ()
  
    interface.InventoryItemAdd( "inv_apple", "spr_princessstatuette_apple" );
  
  end;
  local get_apple_end = function ()
  
    ObjDelete( "gfx_princessstatuette_apple" );
    ObjDelete( "spr_princessstatuette_apple_sh" );
    
    ObjDelete( "spr_entrancehall_statue_apple" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_apple", get_apple_inv );
  cmn.AddSubscriber( "get_apple", get_apple_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flower () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_flower" ] = {
      type = "get",
      get_obj = "spr_princessstatuette_flower",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_flower_inv = function ()
  
    interface.InventoryItemAdd( "inv_flower", "spr_princessstatuette_flower" );
  
  end;
  local get_flower_end = function ()
  
    ObjDelete( "gfx_princessstatuette_flower" );
    ObjDelete( "spr_princessstatuette_flower_sh" );
    
    ObjDelete( "spr_entrancehall_statue_flower" );
    
    ObjSet("spr_princessstatuette_mosaicpart1",  { input = 1 });
    
    if cmn.IsEventDone("get_yarnspindle") and cmn.IsEventDone("get_heartmedallion") and cmn.IsEventDone("get_mosaicpart1") then
      ObjDelete( "gzz_entrancehall_princessstatuette" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_flower", get_flower_inv );
  cmn.AddSubscriber( "get_flower", get_flower_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mosaicpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mosaicpart1" ] = {
      type = "get",
      get_obj = "spr_princessstatuette_mosaicpart1",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_mosaicpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_mosaicpart", "spr_princessstatuette_mosaicpart1", function () cmn.GetMultyObject( 'mosaicpart', 3 ); end );
  
  end;
  local get_mosaicpart1_end = function ()
  
    ObjDelete( "gfx_princessstatuette_mosaicpart1" );
    ObjDelete( "spr_princessstatuette_mosaicpart1_sh" );
    
    ObjDelete( "spr_entrancehall_statue_mosaic" );
    
    if cmn.IsEventDone("get_yarnspindle") and cmn.IsEventDone("get_heartmedallion") and cmn.IsEventDone("get_flower") then
      ObjDelete( "gzz_entrancehall_princessstatuette" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mosaicpart1", get_mosaicpart1_inv );
  cmn.AddSubscriber( "get_mosaicpart1", get_mosaicpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heartmedallion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heartmedallion" ] = {
      type = "get",
      get_obj = "spr_princessstatuette_heartmedallion",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_heartmedallion_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_heartmedallion", "spr_princessstatuette_heartmedallion" );
  
  end;
  local get_heartmedallion_end = function ()
  
    ObjDelete( "gfx_princessstatuette_heartmedallion" );
    ObjDelete( "spr_princessstatuette_heartmedallion_sh" );
    
    ObjDelete( "spr_entrancehall_statue_heart" );
    
    if cmn.IsEventDone("get_yarnspindle") and cmn.IsEventDone("get_mosaicpart1") and cmn.IsEventDone("get_flower") then
      ObjDelete( "gzz_entrancehall_princessstatuette" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_heartmedallion", get_heartmedallion_inv );
  cmn.AddSubscriber( "get_heartmedallion", get_heartmedallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_yarnspindle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_yarnspindle" ] = {
      type = "get",
      get_obj = "spr_princessstatuette_yarnspindle",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_yarnspindle_inv = function ()
  
    interface.InventoryItemAdd( "inv_yarnspindle", "spr_princessstatuette_yarnspindle" );
    ObjSet("inv_brokenscoopnet_star_light",  { alp = 1 });
  
  end;
  local get_yarnspindle_end = function ()
  
    ObjDelete( "gfx_princessstatuette_yarnspindle" );
    ObjDelete( "spr_princessstatuette_yarnspindle_sh" );
    
    ObjDelete( "spr_entrancehall_statue_yarn" );
    
    ObjSet("spr_princessstatuette_heartmedallion",  { input = 1 });
    
    if cmn.IsEventDone("get_heartmedallion") and cmn.IsEventDone("get_mosaicpart1") and cmn.IsEventDone("get_flower") then
      ObjDelete( "gzz_entrancehall_princessstatuette" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_yarnspindle", get_yarnspindle_inv );
  cmn.AddSubscriber( "get_yarnspindle", get_yarnspindle_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_wingedkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wingedkey" ] = {
      type = "use",
      inv_obj = "inv_wingedkey",
      use_place = "obj_halldoors_use_wingedkey",
      room = private.room_objname,
      zz = "zz_halldoors",
      zz_gate = "gzz_entrancehall_halldoors"
  };
  --------------------------------------------------------------------------------------------
  local use_wingedkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_wingedkey" );
  
  end;
  local use_wingedkey_beg = function ()
  
    ObjDelete( "obj_halldoors_use_wingedkey" );
    ObjDelete( "anm_halldoors_touch_door" );
  
  end;
  local use_wingedkey_end = function ()
  
    ObjMultiSet( { {"grm_entrancehall_hall",  { active = 1, input = 1, alp = 1 }},
                   {"spr_entrancehall_open_doors", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_entrancehall_hall_focus");
    end;
    ObjDelete( "gzz_entrancehall_halldoors" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wingedkey", use_wingedkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_wingedkey", use_wingedkey_inv );
  cmn.AddSubscriber( "use_wingedkey", use_wingedkey_end, private.room_objname );
  cmn.AddSubscriber( "use_wingedkey_inv", use_wingedkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_wingedkey_beg", use_wingedkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_wingedkey_end", use_wingedkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_magnet" ] = {
      type = "use",
      inv_obj = "inv_magnet",
      use_place = "obj_aquarium_use_magnet",
      room = private.room_objname,
      zz = "zz_aquarium",
      zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local use_magnet_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnet" );
  
  end;
  local use_magnet_beg = function ()
  
    ObjDelete( "obj_aquarium_use_magnet" );
  
  end;
  local use_magnet_end = function ()
  
    ObjMultiSet( { {"gmg_entrancehall_key", { active = 1, input = 1, alp = 1 }},
                   {"spr_entrancehall_tank_magnet_2_magnet", { alp = 1 }} } );
    
    ObjDelete( "gzz_entrancehall_aquarium" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet", use_magnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet", use_magnet_inv );
  cmn.AddSubscriber( "use_magnet", use_magnet_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_inv", use_magnet_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_beg", use_magnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_end", use_magnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jug () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_jug" ] = {
      type = "use",
      inv_obj = "inv_jug",
      use_place = "obj_aquarium_use_jug",
      room = private.room_objname,
      zz = "zz_aquarium",
      zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local use_jug_inv = function ()
  
    interface.InventoryItemRemove( "inv_jug" );
  
  end;
  local use_jug_beg = function ()
  
    ObjDelete( "obj_aquarium_use_jug" );
  
  end;
  local use_jug_end = function ()
  
    ObjMultiSet( { {"obj_aquarium_jug", { alp = 1 }},
                   {"spr_entrancehall_tank_jug", { alp = 1 }} } );
                   
    if cmn.IsEventDone("use_scoopnet") then
      ObjDelete( "obj_aquarium_jug" );
      ObjDelete( "spr_aquarium_scoopnet" );
      ObjDelete( "spr_entrancehall_tank_net" );
      ObjDelete( "vid_aquarium_use_scoopnet" );
      ObjDelete( "vid_aquarium_fish_yingyang" );
      ObjDelete( "vid_entrancehall_tank_fish_1" );
    
      ObjMultiSet( { {"obj_aquarium_yingyangfish_get", { alp = 1, input = 1 }},
                     {"obj_aquarium_tank", { alp = 1 }},
                     {"spr_entrancehall_tank_fish_2", { alp = 1 }} } );
    else 
      ObjSet("obj_aquarium_use_scoopnet",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jug", use_jug_beg, private.room_objname );
  cmn.AddSubscriber( "use_jug", use_jug_inv );
  cmn.AddSubscriber( "use_jug", use_jug_end, private.room_objname );
  cmn.AddSubscriber( "use_jug_inv", use_jug_inv, private.room_objname );
  cmn.AddSubscriber( "use_jug_beg", use_jug_beg, private.room_objname );
  cmn.AddSubscriber( "use_jug_end", use_jug_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scoopnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scoopnet" ] = {
      type = "use",
      inv_obj = "inv_scoopnet",
      use_place = "obj_aquarium_use_scoopnet",
      room = private.room_objname,
      zz = "zz_aquarium",
      zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local use_scoopnet_inv = function ()
  
    interface.InventoryItemRemove( "inv_scoopnet" );
  
  end;
  local use_scoopnet_beg = function ()
  
    ObjDelete( "obj_aquarium_use_scoopnet" );
  
  end;
  local use_scoopnet_end = function ()
    
    if cmn.IsEventDone("use_jug") then
      ObjDelete( "obj_aquarium_jug" );
      ObjDelete( "spr_aquarium_scoopnet" );
      ObjDelete( "spr_entrancehall_tank_net" );
      ObjDelete( "vid_aquarium_use_scoopnet" );
      ObjDelete( "vid_aquarium_fish_yingyang" );
      ObjDelete( "vid_entrancehall_tank_fish_1" );
    
      ObjMultiSet( { {"obj_aquarium_yingyangfish_get", { alp = 1, input = 1 }},
                     {"obj_aquarium_tank", { alp = 1 }},
                     {"spr_entrancehall_tank_fish_2", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_aquarium_scoopnet", { alp = 1 }},
                     {"spr_entrancehall_tank_net", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scoopnet", use_scoopnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet", use_scoopnet_inv );
  cmn.AddSubscriber( "use_scoopnet", use_scoopnet_end, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet_inv", use_scoopnet_inv, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet_beg", use_scoopnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet_end", use_scoopnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sharpfang () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sharpfang" ] = {
      type = "use",
      inv_obj = "inv_sharpfang",
      use_place = "obj_couch_use_sharpfang",
      room = private.room_objname,
      zz = "zz_couch",
      zz_gate = "gzz_entrancehall_couch"
  };
  --------------------------------------------------------------------------------------------
  local use_sharpfang_inv = function ()
  
    interface.InventoryItemRemove( "inv_sharpfang" );
  
  end;
  local use_sharpfang_beg = function ()
  
    ObjDelete( "obj_couch_use_sharpfang" );
    
  end;
  local use_sharpfang_end = function ()
    
    ObjDelete( "anm_couch_touch_woolf" );
  
    ObjMultiSet( { {"obj_couch_woodenwolf", { input = 1 }},
                   {"anm_couch_use_fang", { alp = 1, frame = 200 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharpfang", use_sharpfang_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharpfang", use_sharpfang_inv );
  cmn.AddSubscriber( "use_sharpfang", use_sharpfang_end, private.room_objname );
  cmn.AddSubscriber( "use_sharpfang_inv", use_sharpfang_inv, private.room_objname );
  cmn.AddSubscriber( "use_sharpfang_beg", use_sharpfang_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharpfang_end", use_sharpfang_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lionhead () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lionhead" ] = {
      type = "use",
      inv_obj = "inv_lionhead",
      use_place = "obj_couch_use_lionhead",
      room = private.room_objname,
      zz = "zz_couch",
      zz_gate = "gzz_entrancehall_couch"
  };
  --------------------------------------------------------------------------------------------
  local use_lionhead_inv = function ()
  
    interface.InventoryItemRemove( "inv_lionhead" );
  
  end;
  local use_lionhead_beg = function ()
  
    ObjDelete( "obj_couch_use_lionhead" );
    ObjDelete( "anm_couch_touch_armrest" );
  
  end;
  local use_lionhead_end = function ()
    
    ObjDelete( "spr_entrancehall_lion_closed" );
  
    ObjMultiSet( { {"spr_couch_note", { input = 1 }},
                   {"anm_couch_use_lionhead", { alp = 1, frame = 400 }},
                   {"spr_entrancehall_lion_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lionhead", use_lionhead_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionhead", use_lionhead_inv );
  cmn.AddSubscriber( "use_lionhead", use_lionhead_end, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_inv", use_lionhead_inv, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_beg", use_lionhead_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionhead_end", use_lionhead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mosaicpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mosaicpart" ] = {
      type = "use",
      inv_obj = "inv_mosaicpart",
      use_place = "obj_couch_use_mosaicpart",
      room = private.room_objname,
      zz = "zz_couch",
      zz_gate = "gzz_entrancehall_couch"
  };
  --------------------------------------------------------------------------------------------
  local use_mosaicpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_mosaicpart" );
  
  end;
  local use_mosaicpart_beg = function ()
  
    ObjDelete( "obj_couch_use_mosaicpart" );
    ObjDelete( "anm_couch_touch_box" );
  
  end;
  local use_mosaicpart_end = function ()
  
    ObjMultiSet( { {"spr_couch_wings", { input = 1 }},
                   {"spr_entrancehall_coach_box_mosaic", { alp = 1 }},
                   {"spr_entrancehall_coach_box_cover", { ang = -0.09, pos_x = 943, pos_y = 483 }} } );
    
    ObjDelete( "anm_couch_use_mosaic" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mosaicpart", use_mosaicpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart", use_mosaicpart_inv );
  cmn.AddSubscriber( "use_mosaicpart", use_mosaicpart_end, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart_inv", use_mosaicpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart_beg", use_mosaicpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart_end", use_mosaicpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_goldenring () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_goldenring" ] = {
      type = "use",
      inv_obj = "inv_goldenring",
      use_place = "obj_princessstatuette_use_goldenring",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local use_goldenring_inv = function ()
  
    interface.InventoryItemRemove( "inv_goldenring" );
  
  end;
  local use_goldenring_beg = function ()
  
    if cmn.IsEventDone("use_silverring") then
      ObjDelete( "obj_princessstatuette_use_goldenring" );
    end;
  
  end;
  local use_goldenring_end = function ()
  
    if cmn.IsEventDone("use_silverring") then
      ObjMultiSet( { {"obj_princessstatuette_hand_1",  { alp = 1, input = 1 }},
                     {"spr_entrancehall_statue_hand_1_open", { alp = 1 }} } );
      ObjDelete( "anm_princessstatuette_touch_hand_1" );
      ObjDelete( "spr_entrancehall_statue_hand_1_closed" );
    else 
      ObjMultiSet( { {"spr_princessstatuette_goldrring", { alp = 1 }},
                     {"spr_entrancehall_statue_gold_ring", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goldenring", use_goldenring_beg, private.room_objname );
  cmn.AddSubscriber( "use_goldenring", use_goldenring_inv );
  cmn.AddSubscriber( "use_goldenring", use_goldenring_end, private.room_objname );
  cmn.AddSubscriber( "use_goldenring_inv", use_goldenring_inv, private.room_objname );
  cmn.AddSubscriber( "use_goldenring_beg", use_goldenring_beg, private.room_objname );
  cmn.AddSubscriber( "use_goldenring_end", use_goldenring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bracelet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bracelet" ] = {
      type = "use",
      inv_obj = "inv_bracelet",
      use_place = "obj_princessstatuette_use_bracelet",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local use_bracelet_inv = function ()
  
    interface.InventoryItemRemove( "inv_bracelet" );
  
  end;
  local use_bracelet_beg = function ()
  
    ObjDelete( "obj_princessstatuette_use_bracelet" );
  
  end;
  local use_bracelet_end = function ()
  
    ObjMultiSet( { {"obj_princessstatuette_hand_2", { alp = 1, input = 1 }},
                   {"spr_princessstatuette_hand_2", { alp = 1 }},
                   {"spr_entrancehall_statue_hand_2_open", { alp = 1 }},
                   {"spr_entrancehall_statue_bracelet", { alp = 1 }} } );
    
    ObjDelete( "anm_princessstatuette_touch_hand_2" );
    ObjDelete( "spr_entrancehall_statue_hand_2_closed" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bracelet", use_bracelet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bracelet", use_bracelet_inv );
  cmn.AddSubscriber( "use_bracelet", use_bracelet_end, private.room_objname );
  cmn.AddSubscriber( "use_bracelet_inv", use_bracelet_inv, private.room_objname );
  cmn.AddSubscriber( "use_bracelet_beg", use_bracelet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bracelet_end", use_bracelet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_silverring () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_silverring" ] = {
      type = "use",
      inv_obj = "inv_silverring",
      use_place = "obj_princessstatuette_use_silverring",
      room = private.room_objname,
      zz = "zz_princessstatuette",
      zz_gate = "gzz_entrancehall_princessstatuette"
  };
  --------------------------------------------------------------------------------------------
  local use_silverring_inv = function ()
  
    interface.InventoryItemRemove( "inv_silverring" );
  
  end;
  local use_silverring_beg = function ()
  
    ObjDelete( "obj_princessstatuette_use_silverring" );
    if cmn.IsEventDone("use_goldenring") then
      ObjDelete( "obj_princessstatuette_use_goldenring" );
    end;
  
  end;
  local use_silverring_end = function ()
  
    if cmn.IsEventDone("use_goldenring") then
      ObjMultiSet( { {"obj_princessstatuette_hand_1",  { alp = 1, input = 1 }},
                     {"spr_entrancehall_statue_hand_1_open", { alp = 1 }} } );
      ObjDelete( "anm_princessstatuette_touch_hand_1" );
      ObjDelete( "spr_entrancehall_statue_hand_1_closed" );
    else 
      ObjMultiSet( { {"spr_princessstatuette_silverring", { alp = 1 }},
                     {"spr_entrancehall_statue_silver_ring", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_silverring", use_silverring_beg, private.room_objname );
  cmn.AddSubscriber( "use_silverring", use_silverring_inv );
  cmn.AddSubscriber( "use_silverring", use_silverring_end, private.room_objname );
  cmn.AddSubscriber( "use_silverring_inv", use_silverring_inv, private.room_objname );
  cmn.AddSubscriber( "use_silverring_beg", use_silverring_beg, private.room_objname );
  cmn.AddSubscriber( "use_silverring_end", use_silverring_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_assemblingscales1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_assemblingscales1" ] = {
    type = "click",
    use_place = "obj_aquarium_clk_assemblingscales1",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local clk_assemblingscales1 = function ()
    
    ObjDelete("obj_aquarium_clk_assemblingscales1");
    ObjSet("spr_aquarium_scales_1_2",  { alp = 1 });
  
    if cmn.IsEventDone("clk_assemblingscales2") and cmn.IsEventDone("clk_assemblingscales3") and cmn.IsEventDone("clk_assemblingscales4") and cmn.IsEventDone("clk_assemblingscales5") then
      ObjMultiSet( { {"obj_aquarium_scales", { input = 1 }},
                     {"gfx_aquarium_scales", { alp = 1 }} } );
      ObjDelete("obj_aquarium_scales_fly");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_assemblingscales1", clk_assemblingscales1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_assemblingscales2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_assemblingscales2" ] = {
    type = "click",
    use_place = "obj_aquarium_clk_assemblingscales2",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local clk_assemblingscales2 = function ()
    
    ObjDelete("obj_aquarium_clk_assemblingscales2");
    ObjSet("spr_aquarium_scales_2_2",  { alp = 1 });
  
    if cmn.IsEventDone("clk_assemblingscales1") and cmn.IsEventDone("clk_assemblingscales3") and cmn.IsEventDone("clk_assemblingscales4") and cmn.IsEventDone("clk_assemblingscales5") then
      ObjMultiSet( { {"obj_aquarium_scales", { input = 1 }},
                     {"gfx_aquarium_scales", { alp = 1 }} } );
      ObjDelete("obj_aquarium_scales_fly");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_assemblingscales2", clk_assemblingscales2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_assemblingscales3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_assemblingscales3" ] = {
    type = "click",
    use_place = "obj_aquarium_clk_assemblingscales3",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local clk_assemblingscales3 = function ()
    
    ObjDelete("obj_aquarium_clk_assemblingscales3");
    ObjSet("spr_aquarium_scales_3_2",  { alp = 1 });
  
    if cmn.IsEventDone("clk_assemblingscales1") and cmn.IsEventDone("clk_assemblingscales2") and cmn.IsEventDone("clk_assemblingscales4") and cmn.IsEventDone("clk_assemblingscales5") then
      ObjMultiSet( { {"obj_aquarium_scales", { input = 1 }},
                     {"gfx_aquarium_scales", { alp = 1 }} } );
      ObjDelete("obj_aquarium_scales_fly");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_assemblingscales3", clk_assemblingscales3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_assemblingscales4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_assemblingscales4" ] = {
    type = "click",
    use_place = "obj_aquarium_clk_assemblingscales4",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local clk_assemblingscales4 = function ()
    
    ObjDelete("obj_aquarium_clk_assemblingscales4");
    ObjSet("spr_aquarium_scales_4_2",  { alp = 1 });
  
    if cmn.IsEventDone("clk_assemblingscales1") and cmn.IsEventDone("clk_assemblingscales2") and cmn.IsEventDone("clk_assemblingscales3") and cmn.IsEventDone("clk_assemblingscales5") then
      ObjMultiSet( { {"obj_aquarium_scales", { input = 1 }},
                     {"gfx_aquarium_scales", { alp = 1 }} } );
      ObjDelete("obj_aquarium_scales_fly");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_assemblingscales4", clk_assemblingscales4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_assemblingscales5 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_assemblingscales5" ] = {
    type = "click",
    use_place = "obj_aquarium_clk_assemblingscales5",
    room = private.room_objname,
    zz = "zz_aquarium",
    zz_gate = "gzz_entrancehall_aquarium"
  };
  --------------------------------------------------------------------------------------------
  local clk_assemblingscales5 = function ()
    
    ObjDelete("obj_aquarium_clk_assemblingscales5");
    ObjSet("spr_aquarium_scales_5_2",  { alp = 1 });
  
    if cmn.IsEventDone("clk_assemblingscales1") and cmn.IsEventDone("clk_assemblingscales2") and cmn.IsEventDone("clk_assemblingscales3") and cmn.IsEventDone("clk_assemblingscales4") then
      ObjMultiSet( { {"obj_aquarium_scales", { input = 1 }},
                     {"gfx_aquarium_scales", { alp = 1 }} } );
      ObjDelete("obj_aquarium_scales_fly");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_assemblingscales5", clk_assemblingscales5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_sharpfang () end;
  --------------------------------------------------------------------------------------------
  local clk_sharpfang = function ()
  
    ObjSet("anm_couch_touch_woolf",  { frame = 0, animfunc = "func_touch_wolf" });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_sharpfang", clk_sharpfang, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_entrancehall () end;
  --------------------------------------------------------------------------------------------
  local opn_entrancehall = function ()
  
    int_map_impl.OpenRoom( "rm_entrancehall" );
    interface_impl.SetCurrentGlobalTask( 6 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_entrancehall", opn_entrancehall );
  --------------------------------------------------------------------------------------------
  -- function opn_eventhall () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "opn_eventhall" ] = {

      type = "clk",
      use_place = "grm_entrancehall_hall",
      room = private.room_objname

  };
  --------------------------------------------------------------------------------------------
  local opn_eventhall = function ()

    ObjMultiSet( { {"obj_entrancehall_gates", { input = 0, active = 0, visible = 0 }},
                   {"rm_entrancehall", { color_r = 0, color_g = 0, color_b = 0 }} } );

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_eventhall", opn_eventhall, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_princessstatuette" );
  subroom.Define( "zz_aquarium" );
  
  function zz_princessstatuette.Open()
    
    if not(cmn.IsEventDone( "opn_princessstatuette" )) then
      cmn.SetEventDone("opn_princessstatuette");
      cmn.ShowBbt( "princessstatuette_open" );
    end;
      
  end;
  
  function zz_aquarium.PreOpen()
    
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_aquarium_env");
    
    if cmn.IsEventDone("use_scoopnet") and not(cmn.IsEventDone( "get_yingyangfish" )) then
      ObjSet("anm_aquarium_fish_injug",  { playing = 1 });
    end;
      
  end;
  
  function zz_aquarium.PreClose()
    
    cmn.StopAllEnv("assets/levels/common/audio/aud_entrancehall_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_entrancehall_env");
    
    if cmn.IsEventDone("use_scoopnet") and not(cmn.IsEventDone( "get_yingyangfish" )) then
      ObjSet("anm_aquarium_fish_injug",  { playing = 1 });
    end;
      
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_entrancehall();
  
  if cmn.IsEventDone( "opn_eventhall" ) then

    local func_after = function ()

      --[[
      if ( IsDemoEdition() ) or ( IsSurveyEdition() ) then
        cmn.GotoRoom( "rm_demoscreen" );
      else
        cmn.LevelSwitch( "level2", 2 );
        ng_global.progress["std"].common.chapter = "level2";
        ng_global.progress[ "std" ].common.currentroom = "ho_incarriage";
      end;
      ]]

      if (iOS_IsBought() == 0) then

        iOS_LogEvents(1);
        cmn.LevelSwitch("menu","unlock");
        
      else
        
        cmn.LevelSwitch( "level2", 2 );
        ng_global.progress["std"].common.chapter = "level2";
        ng_global.progress[ "std" ].common.currentroom = "ho_incarriage";
        
      end; 
    
    end;

    cmn.Lock( 0 );
    cmn.StopAllEnv();

    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_entrancehall/vid_lvl1outro",
                             func_after,
                             "assets/levels/level1/rm_entrancehall/audio/aud_outro_lvl1",
                             "assets/levels/level1/rm_entrancehall/audio/aud_outro_lvl1_voc" );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_entrancehall_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_entrancehall_env");
  
  if cmn.IsEventDone( "opn_eventhall" ) then
    cmn.Lock( 1 );
    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
  end;
  
  if not(cmn.IsEventDone( "win_key" )) then
    mg_key.SetMagnetsPreLoc();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_wingedkey()

  local item = "inv_wingedkey";

  if cmn.ApplyObj( item, "gzz_entrancehall_halldoors" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_halldoors" );

  elseif ( cmn.ApplyObj( item, "obj_halldoors_use_wingedkey" ) ) then

    cmn.CallEventHandler( "use_wingedkey_inv" );
    cmn.CallEventHandler( "use_wingedkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wingedkey" );
      cmn.CallEventHandler( "use_wingedkey_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_key");

    ObjSet("anm_halldoors_use_wingedkey",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magnet()

  local item = "inv_magnet";

  if cmn.ApplyObj( item, "gzz_entrancehall_aquarium" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_aquarium" );

  elseif ( cmn.ApplyObj( item, "obj_aquarium_use_magnet" ) ) then

    cmn.CallEventHandler( "use_magnet_inv" );
    cmn.CallEventHandler( "use_magnet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magnet" );
      cmn.CallEventHandler( "use_magnet_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom("mg_key");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");

    ObjAnimate( "spr_aquarium_magnet", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_jug()

  local item = "inv_jug";

  if cmn.ApplyObj( item, "gzz_entrancehall_aquarium" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_aquarium" );

  elseif ( cmn.ApplyObj( item, "obj_aquarium_use_jug" ) ) then

    cmn.CallEventHandler( "use_jug_inv" );
    cmn.CallEventHandler( "use_jug_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_jug" );
      cmn.CallEventHandler( "use_jug_end" );
      
      if not cmn.IsEventDone("use_scoopnet") then
        cmn.ShowBbt( "aquarium_after_use_jug" );
      else 
        ObjSet("anm_aquarium_fish_injug",  { playing = 1 });
      end;
    
    end;
    
    local anm_scoopnet = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_net2");

      ObjAttach("vid_aquarium_use_scoopnet", "zz_aquarium");
      ObjAnimate("vid_aquarium_use_scoopnet", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("vid_aquarium_fish_yingyang", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("obj_aquarium_jug", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

      VidPlay("vid_aquarium_use_scoopnet", func_after);
                     
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_jug");

    if cmn.IsEventDone("use_scoopnet") then
      ObjAnimate("obj_aquarium_jug", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_aquarium_scoopnet", "alp", 0, 0, anm_scoopnet, { 0, 0, 1,   0.5, 0, 1,  0.8, 0, 0 });
    else 
      ObjAnimate("obj_aquarium_jug", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scoopnet()

  local item = "inv_scoopnet";

  if cmn.ApplyObj( item, "gzz_entrancehall_aquarium" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_aquarium" );

  elseif ( cmn.ApplyObj( item, "obj_aquarium_use_scoopnet" ) ) then

    cmn.CallEventHandler( "use_scoopnet_inv" );
    cmn.CallEventHandler( "use_scoopnet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scoopnet" );
      cmn.CallEventHandler( "use_scoopnet_end" );
      
      if cmn.IsEventDone("use_jug") then
        ObjSet("anm_aquarium_fish_injug",  { playing = 1 });
      else 
        cmn.ShowBbt( "aquarium_after_use_scoopnet" ); 
      end;
    
    end;
    
    local anm_scoopnet = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_net2");

      ObjAttach("vid_aquarium_use_scoopnet", "zz_aquarium");
      ObjAnimate("vid_aquarium_use_scoopnet", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("vid_aquarium_fish_yingyang", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("obj_aquarium_jug", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

      VidPlay("vid_aquarium_use_scoopnet", func_after);
                     
    end;
                   
    cmn.Lock( 1 );
    
    if cmn.IsEventDone("use_jug") then
      anm_scoopnet();
    else 
      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_net");
      ObjAnimate("spr_aquarium_scoopnet", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  elseif cmn.ApplyObj( item, "obj_pond_use_yingyangfish" ) then
      
    cmn.Lock( 1 );
    cmn.ShowBbt( "pond_scoopnet_wrongapply" );       
    ObjAnimate("obj_pond_use_yingyangfish", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 1 });    
                   
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sharpfang()

  local item = "inv_sharpfang";

  if cmn.ApplyObj( item, "gzz_entrancehall_couch" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_couch" );

  elseif ( cmn.ApplyObj( item, "obj_couch_use_sharpfang" ) ) then

    cmn.CallEventHandler( "use_sharpfang_inv" );
    cmn.CallEventHandler( "use_sharpfang_beg" );
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharpfang" );
      cmn.CallEventHandler( "use_sharpfang_end" );
    
    end;
    
    local anm_fang = function ()
      
      ObjDelete( "anm_couch_touch_woolf" );

      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_fang");

      ObjSet("anm_couch_use_fang",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    
    if not cmn.IsEventDone("clk_sharpfang") then
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_single_clk_wood1");
  
      cmn.SetEventDone("clk_sharpfang");
  
      ObjSet("anm_couch_touch_woolf",  { playing = 1, endtrig = anm_fang });
      
    else 
      
      anm_fang();
      
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lionhead()

  local item = "inv_lionhead";

  if cmn.ApplyObj( item, "gzz_entrancehall_couch" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_couch" );

  elseif ( cmn.ApplyObj( item, "obj_couch_use_lionhead" ) ) then

    cmn.CallEventHandler( "use_lionhead_inv" );
    cmn.CallEventHandler( "use_lionhead_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lionhead" );
      cmn.CallEventHandler( "use_lionhead_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_lions_head");

    ObjSet("anm_couch_use_lionhead",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mosaicpart()

  local item = "inv_mosaicpart";

  if cmn.ApplyObj( item, "gzz_entrancehall_couch" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_couch" );

  elseif ( cmn.ApplyObj( item, "obj_couch_use_mosaicpart" ) and cmn.CheckMultiObject( "mosaicpart", 3 ) ) then

    cmn.CallEventHandler( "use_mosaicpart_inv" );
    cmn.CallEventHandler( "use_mosaicpart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mosaicpart" );
      cmn.CallEventHandler( "use_mosaicpart_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_wood_part");

    ObjSet("anm_couch_use_mosaic",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_goldenring()

  local item = "inv_goldenring";

  if cmn.ApplyObj( item, "gzz_entrancehall_princessstatuette" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_princessstatuette" );

  elseif ( cmn.ApplyObj( item, "obj_princessstatuette_use_goldenring" ) ) then

    cmn.CallEventHandler( "use_goldenring_inv" );
    cmn.CallEventHandler( "use_goldenring_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goldenring" );
      cmn.CallEventHandler( "use_goldenring_end" );
    
    end;

    local anm_hand = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_statue_hand");
      
      ObjAnimate("obj_princessstatuette_hand_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_princessstatuette_touch_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_ring");

    if cmn.IsEventDone("use_silverring") then
      ObjAnimate( "spr_princessstatuette_goldrring", "alp", 0, 0, anm_hand, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_princessstatuette_goldrring", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bracelet()

  local item = "inv_bracelet";

  if cmn.ApplyObj( item, "gzz_entrancehall_princessstatuette" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_princessstatuette" );

  elseif ( cmn.ApplyObj( item, "obj_princessstatuette_use_bracelet" ) ) then

    cmn.CallEventHandler( "use_bracelet_inv" );
    cmn.CallEventHandler( "use_bracelet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bracelet" );
      cmn.CallEventHandler( "use_bracelet_end" );
    
    end;
    
    local anm_hand = function ()
      
      ObjSet("spr_princessstatuette_hand_2",  { alp = 1 });
      
      ObjAnimate("obj_princessstatuette_hand_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_princessstatuette_touch_hand_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_bracelet");

    ObjAnimate( "spr_princessstatuette_bracelet", "alp", 0, 0, anm_hand,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_silverring()

  local item = "inv_silverring";

  if cmn.ApplyObj( item, "gzz_entrancehall_princessstatuette" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_princessstatuette" );

  elseif ( cmn.ApplyObj( item, "obj_princessstatuette_use_silverring" ) ) then

    cmn.CallEventHandler( "use_silverring_inv" );
    cmn.CallEventHandler( "use_silverring_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_silverring" );
      cmn.CallEventHandler( "use_silverring_end" );
    
    end;
    
    local anm_hand = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_statue_hand");
      
      ObjAnimate("obj_princessstatuette_hand_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_princessstatuette_touch_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_use_ring");

    if cmn.IsEventDone("use_goldenring") then
      ObjAnimate( "spr_princessstatuette_silverring", "alp", 0, 0, anm_hand, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_princessstatuette_silverring", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_yingyangfish()

  cmn.SetEventDone( "get_yingyangfish" );
  cmn.CallEventHandler( "get_yingyangfish" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_scales()

  cmn.SetEventDone( "get_scales" );
  cmn.CallEventHandler( "get_scales" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_woodenwolf()

  cmn.SetEventDone( "get_woodenwolf" );
  cmn.CallEventHandler( "get_woodenwolf" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_note()

  cmn.SetEventDone( "get_note" );
  cmn.CallEventHandler( "get_note" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_wings()

  cmn.SetEventDone( "get_wings" );
  cmn.CallEventHandler( "get_wings" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_apple()

  cmn.SetEventDone( "get_apple" );
  cmn.CallEventHandler( "get_apple" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_flower()

  cmn.SetEventDone( "get_flower" );
  cmn.CallEventHandler( "get_flower" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_yarnspindle") and cmn.IsEventDone("get_heartmedallion") and cmn.IsEventDone("get_mosaicpart1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_mosaicpart1()

  cmn.SetEventDone( "get_mosaicpart1" );
  cmn.CallEventHandler( "get_mosaicpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_yarnspindle") and cmn.IsEventDone("get_heartmedallion") and cmn.IsEventDone("get_flower") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_heartmedallion()

  cmn.SetEventDone( "get_heartmedallion" );
  cmn.CallEventHandler( "get_heartmedallion" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_yarnspindle") and cmn.IsEventDone("get_mosaicpart1") and cmn.IsEventDone("get_flower") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_yarnspindle()

  cmn.SetEventDone( "get_yarnspindle" );
  cmn.CallEventHandler( "get_yarnspindle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_heartmedallion") and cmn.IsEventDone("get_mosaicpart1") and cmn.IsEventDone("get_flower") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_assemblingscales( num )

  local func_after = function ()

    cmn.SetEventDone( "clk_assemblingscales"..num );
    cmn.CallEventHandler( "clk_assemblingscales"..num );

    cmn.Lock( 0 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_scale2");
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_scale1");
  
  local point_a, point_b = {}, {};
  point_a[1] = private.scales_pos[1][num][1];
  point_a[2] = private.scales_pos[1][num][2];
  point_b[1] = private.scales_pos[2][num][1];
  point_b[2] = private.scales_pos[2][num][2];
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.002 * len;
  
  local check = true;
  for i = 1, 5, 1 do
    if num ~= i and not cmn.IsEventDone("clk_assemblingscales"..i) then
      check = false;
      break;
    end;
  end;
  
  ObjAttach("obj_aquarium_clk_assemblingscales"..num, "obj_aquarium_scales_fly");
  
  if check then
    ObjAnimate("gfx_aquarium_scales", "alp", 0, 0, "", { 0, 0, 0,   tme-0.3, 0, 0,   tme, 0, 1 });
  end;
  
  if num > 1 then
    ObjAnimate("spr_aquarium_scales_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  end;
  
  if private.scales_pos[1][num][3] ~= private.scales_pos[2][num][3] then
    ObjAnimate("obj_aquarium_clk_assemblingscales"..num, "ang", 0, 0, "", { 0, 0, private.scales_pos[1][num][3],   tme, 0, private.scales_pos[2][num][3] });
  end;

  ObjAnimate("obj_aquarium_clk_assemblingscales"..num, "pos_xy", 0, 0, func_after, { 0, 0, private.scales_pos[1][num][1], private.scales_pos[1][num][2],
                                                                           tme, 0, private.scales_pos[2][num][1], private.scales_pos[2][num][2] });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_entrancehall()

  if not ( cmn.IsEventDone( "opn_entrancehall" ) ) then
    cmn.SetEventDone( "opn_entrancehall" );
    cmn.CallEventHandler("opn_entrancehall");
    cmn.ShowBbt( "entrancehall_open" );
    interface_impl.ShowGlobalTask();
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_hall_door()
  
  cmn.ShowBbt( "obj_halldoors_use_wingedkey" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_door2");
  
  ObjSet("anm_halldoors_touch_door",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_coach_wolf()
  
  cmn.ShowBbt( "obj_couch_use_sharpfang" );
  local flag = false;
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    if flag then
      cmn.CallEventHandler("clk_sharpfang");
    end;
    
  end;
  
  cmn.Lock(1);
  
  if not cmn.IsEventDone("clk_sharpfang") then
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_single_clk_wood1");
    cmn.SetEventDone("clk_sharpfang");
    flag = true;
  else 
    cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_clk_box");
  end;
  
  ObjSet("anm_couch_touch_woolf",  { playing = 1, endtrig = func_after });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_coach_box()
  
  cmn.ShowBbt( "obj_couch_use_mosaicpart" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_clk_wood2");
  
  ObjSet("anm_couch_touch_box",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_coach_armrest()
  
  cmn.ShowBbt( "obj_couch_use_lionhead" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_lions_head");
  
  ObjSet("anm_couch_touch_armrest",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_statue_hand( num )
  
  if num == 1 then
    cmn.ShowBbt( "obj_princessstatuette_use_goldenring" );
  else 
    cmn.ShowBbt( "obj_princessstatuette_use_bracelet" );
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_stone");
  
  ObjSet("anm_princessstatuette_touch_hand_"..num,  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.PlayOutro()
  
  local func_after = function ()

    cmn.CallEventHandler( "opn_eventhall" );

   if (iOS_IsBought() == 0) then

        iOS_LogEvents(1);
        cmn.LevelSwitch("menu","unlock");
        
   else

      cmn.LevelSwitch( "level2", 2 );
      ng_global.progress["std"].common.chapter = "level2";
      ng_global.progress[ "std" ].common.currentroom = "ho_incarriage";

   end;

  end;

  local func_playoutro = function ()

    cmn.Lock( 0 );
    cmn.StopAllEnv();
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_entrancehall/vid_lvl1outro",
                             func_after,
                             "assets/levels/level1/rm_entrancehall/audio/aud_outro_lvl1",
                             "assets/levels/level1/rm_entrancehall/audio/aud_outro_lvl1_voc" );

  end;

  if not ( cmn.IsEventDone( "opn_eventhall" ) ) then

    cmn.SetEventDone( "opn_eventhall" );
    cmn.Lock( 1 );

    ObjAnimate( "rm_entrancehall", "color_r", 0, 0, func_playoutro, {0,0,1,  1,0,0} );
    ObjAnimate( "rm_entrancehall", "color_g", 0, 0, "", {0,0,1,  1,0,0} );
    ObjAnimate( "rm_entrancehall", "color_b", 0, 0, "", {0,0,1,  1,0,0} );

  end;
  
end;
--*********************************************************************************************************************