-- name=rm_kitchen
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_kitchen";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Fridge();
  --------------------------------------------------------------------------------------------
  -- function get_toygun () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_toygun" ] = {
      type = "get",
      get_obj = "spr_sink_toygun",
      room = private.room_objname,
      zz = "zz_sink",
      zz_gate = "gzz_kitchen_sink"
  };
  --------------------------------------------------------------------------------------------
  local get_toygun_inv = function ()
  
    interface.InventoryItemAdd( "inv_toygun", "spr_sink_toygun" );
  
  end;
  local get_toygun_end = function ()
  
    ObjDelete( "gfx_sink_toygun" );
    ObjDelete( "spr_sink_toygun_sh" );
    
    if cmn.IsEventDone("get_pumpkinbranch") then
      ObjDelete( "gzz_kitchen_sink" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_toygun", get_toygun_inv );
  cmn.AddSubscriber( "get_toygun", get_toygun_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pumpkinbranch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pumpkinbranch" ] = {
      type = "get",
      get_obj = "spr_sink_pumpkinbranch",
      room = private.room_objname,
      zz = "zz_sink",
      zz_gate = "gzz_kitchen_sink"
  };
  --------------------------------------------------------------------------------------------
  local get_pumpkinbranch_inv = function ()
  
    interface.InventoryItemAdd( "inv_pumpkinbranch", "spr_sink_pumpkinbranch" );
    int_map_impl.DecreaseRoomTasks("rm_kitchen");
  
  end;
  local get_pumpkinbranch_end = function ()
  
    ObjDelete( "gfx_sink_pumpkinbranch" );
    ObjDelete( "spr_sink_pumpkinbranch_sh" );
    
    if cmn.IsEventDone("get_toygun") then
      ObjDelete( "gzz_kitchen_sink" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pumpkinbranch", get_pumpkinbranch_inv );
  cmn.AddSubscriber( "get_pumpkinbranch", get_pumpkinbranch_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_laceandhook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_laceandhookkitchen" ] = {
      type = "use",
      inv_obj = "inv_laceandhook",
      use_place = "obj_sink_use_laceandhook",
      room = private.room_objname,
      zz = "zz_sink",
      zz_gate = "gzz_kitchen_sink"
  };
  
  game.hint[ "use_laceandhookstick" ] = {
      type = "use",
      inv_obj = "inv_laceandhook",
      use_place = "obj_complex_stick_use_laceandhook",
      room = "int_complex_inv",
      zz = "inv_complex_stick",
      zz_gate = "inv_stick"
  };
  --------------------------------------------------------------------------------------------
  local use_laceandhook_beg1 = function ()
  
    ObjDelete( "obj_sink_use_laceandhook" );
    ObjDelete( "anm_sink_branch_touch" );
  
  end;
  local use_laceandhook_end1 = function ()
  
    ObjSet( "anm_sink_use_hook", { input = 1, alp = 1, frame = 400 } );
  
  end;
  
  local use_laceandhook_inv2 = function ()
  
    interface.InventoryItemRemove( "inv_laceandhook" );
  
  end;
  local use_laceandhook_beg2 = function ()
  
    ObjDelete( "obj_complex_stick_use_laceandhook" );
  
  end;
  local use_laceandhook_end2 = function ()
  
    ObjMultiSet( { {"spr_complex_stick_fishingrod", { input = 1 }},
                   {"spr_complex_stick_hook", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_laceandhookkitchen", use_laceandhook_beg1, private.room_objname );
  cmn.AddSubscriber( "use_laceandhookkitchen", use_laceandhook_end1, private.room_objname );
  cmn.AddSubscriber( "use_laceandhook_beg1", use_laceandhook_beg1, private.room_objname );
  cmn.AddSubscriber( "use_laceandhook_end1", use_laceandhook_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_laceandhookstick", use_laceandhook_beg2, "inv_complex_stick" );
  cmn.AddSubscriber( "use_laceandhookstick", use_laceandhook_inv2 );
  cmn.AddSubscriber( "use_laceandhookstick", use_laceandhook_end2, "inv_complex_stick" );
  cmn.AddSubscriber( "use_laceandhook_inv2", use_laceandhook_inv2 );
  cmn.AddSubscriber( "use_laceandhook_beg2", use_laceandhook_beg2, "inv_complex_stick" );
  cmn.AddSubscriber( "use_laceandhook_end2", use_laceandhook_end2, "inv_complex_stick" );
  --------------------------------------------------------------------------------------------
  -- function use_hairdryer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hairdryer" ] = {
      type = "use",
      inv_obj = "inv_hairdryer",
      use_place = "obj_fridgedoor_use_hairdryer",
      room = private.room_objname,
      zz = "zz_fridgedoor",
      zz_gate = "gzz_kitchen_fridgedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_hairdryer_inv = function ()
  
    interface.InventoryItemRemove( "inv_hairdryer" );
  
  end;
  local use_hairdryer_beg = function ()
  
    ObjDelete( "obj_fridgedoor_use_hairdryer" );
    ObjDelete( "anm_fridgedoor_ice_touch" );
    
    ObjSet("obj_fridgedoor_ice",  { alp = 1 });
  
  end;
  local use_hairdryer_end = function ()
    
    ObjSet("spr_fridgedoor_hairdryer",  { alp = 1 });
  
    --ObjSet("gho_kitchen_infridge",  { active = 1, input = 1, alp = 1 });
    --ObjDelete( "gzz_kitchen_fridgedoor" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hairdryer", use_hairdryer_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairdryer", use_hairdryer_inv );
  cmn.AddSubscriber( "use_hairdryer", use_hairdryer_end, private.room_objname );
  cmn.AddSubscriber( "use_hairdryer_inv", use_hairdryer_inv, private.room_objname );
  cmn.AddSubscriber( "use_hairdryer_beg", use_hairdryer_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairdryer_end", use_hairdryer_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_sinkfirst () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local clk_sinkfirst_beg = function ()
  
    ObjDelete( "obj_sink_clk_sinkfirst" );
    ObjDelete( "obj_sink_clk_sinkfirst2" );
  
  end;
  local clk_sinkfirst_end = function ()
  
    ObjMultiSet( { {"obj_sink_use_laceandhook", { input = 1 }},
                   {"anm_sink_branch_touch", { alp = 1 }} } );
    ObjDelete( "anm_sink_branch_fall" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_sinkfirst", clk_sinkfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sinkfirst", clk_sinkfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_sinkfirst_beg", clk_sinkfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sinkfirst_end", clk_sinkfirst_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_kitchen () end;
  --------------------------------------------------------------------------------------------
  local opn_kitchen = function ()
  
    int_map_impl.OpenRoom( "rm_kitchen" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_kitchen", opn_kitchen );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_fridgedoor" );
  
  function zz_fridgedoor.PreOpen()
    
    if cmn.IsEventDone("use_hairdryer") and not cmn.IsEventDone("win_fridgedoor") then
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_hairdryer_env");
      private.zz_fridgedoor.DrawScene();
    end;
    
  end;
  
  function zz_fridgedoor.PreClose()
    
    if cmn.IsEventDone("use_hairdryer") and not cmn.IsEventDone("win_fridgedoor") then
      ObjSet("tmr_fridgedoor_timer",  { playing = 0 });
      cmn.StopAllEnv("assets/levels/common/audio/aud_kitchen_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_kitchen_env");
    end;
    
  end;
  
  function zz_fridgedoor.Open()
    
    if not cmn.IsEventDone("win_fridgedoor") then
      private.zz_fridgedoor.CheckWin();
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_fridgedoor" ].state) then 
    private.zz_fridgedoor.StartConditions();
  end;

  private.zz_fridgedoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_fridgedoor" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_kitchen();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_kitchen_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_kitchen_env");
  
  --ObjSet( "obj_kitchen_gates", { input = 0, active = 0, visible = 0 } );
  --cmn.DialogWindowShow( "common", "thxplaying" );
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_laceandhook()

  local item = "inv_laceandhook";

  if cmn.ApplyObj( item, "gzz_kitchen_sink" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sink" );

  elseif ( cmn.ApplyObj( item, "obj_sink_use_laceandhook" ) ) then

    cmn.CallEventHandler( "use_laceandhook_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_laceandhookkitchen" );
      cmn.CallEventHandler( "use_laceandhook_end1" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_use_hook");

    ObjSet("anm_sink_use_hook",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_stick_use_laceandhook" )  then

    cmn.CallEventHandler( "use_laceandhook_inv2", "inv_complex_stick" );
    cmn.CallEventHandler( "use_laceandhook_beg2", "inv_complex_stick" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_laceandhookstick" );
      cmn.CallEventHandler( "use_laceandhook_end2", "inv_complex_stick" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_line/audio/aud_clk_fishing_line");

    ObjAnimate( "spr_complex_stick_hook", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0, 
      0.5, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hairdryer()

  local item = "inv_hairdryer";

  if cmn.ApplyObj( item, "gzz_kitchen_fridgedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fridgedoor" );

  elseif ( cmn.ApplyObj( item, "obj_fridgedoor_use_hairdryer" ) ) then

    cmn.CallEventHandler( "use_hairdryer_inv" );
    cmn.CallEventHandler( "use_hairdryer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hairdryer" );
      cmn.CallEventHandler( "use_hairdryer_end" );
      
      private.zz_fridgedoor.DragHairdrier( false );
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_hairdryer_env");
    private.zz_fridgedoor.DragHairdrier( true );

    ObjAnimate( "spr_fridgedoor_hairdryer", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_toygun()

  cmn.SetEventDone( "get_toygun" );
  cmn.CallEventHandler( "get_toygun" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_pumpkinbranch") then
    common.CloseSubRoom();
  end;
  
  if not cmn.IsEventDone("clk_sinkfirst") then
    public.clk_sinkfirst();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pumpkinbranch()
  
  ObjSet("spr_sink_pumpkinbranch",  { ang = 1.9297, pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_pumpkinbranch" );
  cmn.CallEventHandler( "get_pumpkinbranch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_toygun") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_sinkfirst()

  cmn.CallEventHandler( "clk_sinkfirst_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_sinkfirst" );
    cmn.CallEventHandler( "clk_sinkfirst_end" );

    cmn.Lock( 0 );
    cmn.ShowBbt( "sink_open" );
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_part");

  ObjSet("anm_sink_branch_fall",  { playing = 1, endtrig = func_after });
  ObjAnimate("gfx_sink_pumpkinbranch_1", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_kitchen()

  if not ( cmn.IsEventDone( "opn_kitchen" ) ) then
    cmn.SetEventDone( "opn_kitchen" );
    cmn.CallEventHandler("opn_kitchen");
    cmn.ShowBbt( "kitchen_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_ice()
  
  cmn.ShowBbt( "obj_fridgedoor_use_hairdryer" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_ice");
  
  ObjSet("anm_fridgedoor_ice_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_pumpkinbranch()
  
  cmn.ShowBbt( "obj_sink_use_laceandhook" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_part");
  
  ObjSet("anm_sink_branch_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Fridge *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_fridgedoor = {};
public.zz_fridgedoor = {};

function private.Init_Fridge()
  
  --------------------------------------------------------------------------------------------
  game.hint[ "win_fridgedoor" ] = {

      type = "use",
      inv_obj = "obj_fridgedoor_hairdryer_air",
      use_place = "obj_fridgedoor_ice_1_hint",
      room = "rm_kitchen",
      zz = "zz_fridgedoor",
      zz_gate = "gzz_kitchen_fridgedoor"
  };
  -----------------------------------------------------------------------------------
  local win_fridgedoor = function ()

    if cmn.IsEventDone( "win_fridgedoor" ) then

      ObjMultiSet( { {"gho_kitchen_infridge", { active = 1, input = 1, alp = 1 }},
                     {"spr_kitchen_fridge_open", { alp = 1 }},
                     {"fx_kitchen_p_fog", { alp = 1 }} } );
                     
      ObjDelete( "gzz_kitchen_fridgedoor" );
      ObjDelete( "spr_kitchen_ice" );
      ObjDelete( "fx_kitchen_p_ice" );
      
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_fridgedoor", win_fridgedoor, "rm_kitchen" );
  
end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.zz_fridgedoor.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fridgedoor" ].state = { {0, 0, 0, 0}, {2, 2, 2, 2} };

end;
-----------------------------------------------------------------------------------
function private.zz_fridgedoor.DrawScene()
  
  for i = 1, 4, 1 do
    
    if private.zz_fridgedoor.state[1][i] == 1 then
      ObjSet("spr_fridgedoor_ice_"..i,  { alp = 0 });
    else 
      ObjSet("spr_fridgedoor_ice_"..i,  { alp = private.zz_fridgedoor.state[2][i]/2 });
    end;
    
  end;
  
  private.zz_fridgedoor.DragHairdrier();
  
end;
-----------------------------------------------------------------------------------
function private.zz_fridgedoor.DragHairdrier( uncheck )
  
  local uncheck = uncheck or false;
  
  local range = { {-134, 208}, {-124, 196} };
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1]) - ObjGet("zz_fridgedoor").pos_x;
  curspos[2] = math.floor(curspos[2]) - ObjGet("zz_fridgedoor").pos_y;
  
  if curspos[1] < range[1][1] then
    curspos[1] = range[1][1];
  elseif curspos[1] > range[1][2] then
    curspos[1] = range[1][2];
  end;
  
  if curspos[2] < range[2][1] then
    curspos[2] = range[2][1];
  elseif curspos[2] > range[2][2] then
    curspos[2] = range[2][2];
  end;
  
  if not uncheck then
    private.zz_fridgedoor.CheckHit();
  end;
  
  ObjMultiSet( { {"spr_fridgedoor_hairdryer", { pos_x = curspos[1], pos_y = curspos[2] }},
                 {"tmr_fridgedoor_timer", { time = 0.01, playing = 1, endtrig = function() private.zz_fridgedoor.DragHairdrier(uncheck); end }} } );
  
end;
-----------------------------------------------------------------------------------
function private.zz_fridgedoor.CheckHit()
  
  for i = 1, 4, 1 do
    
    if private.zz_fridgedoor.state[1][i] == 0 and ObjIntersect("obj_fridgedoor_hairdryer_air", "spr_fridgedoor_ice_"..i) then
      private.zz_fridgedoor.state[2][i] = private.zz_fridgedoor.state[2][i]-0.01;
      if private.zz_fridgedoor.state[2][i] >= 0 then
        ObjSet("spr_fridgedoor_ice_"..i,  { alp = private.zz_fridgedoor.state[2][i]/2 });
      end;
      if private.zz_fridgedoor.state[2][i] <= 0 then
        private.zz_fridgedoor.state[1][i] = 1;
        private.zz_fridgedoor.CheckWin();
      end;
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fridgedoor.CheckWin()
  
  local win_flag = true;
  local ice_win = {0, 0, 0, 0};
  
  for i = 1, 4, 1 do
    
    if private.zz_fridgedoor.state[1][i] == 0 then
      win_flag = false;
      break;
    else 
      ice_win[i] = 1;
    end;
    
  end;
  
  for i = 1, 4, 1 do
  
    if ice_win[i] == 0 then
      game.hint[ "win_fridgedoor" ].use_place = "obj_fridgedoor_ice_"..i.."_hint";
      break;
    end;
    
  end;
  
  if win_flag then
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "win_fridgedoor" );
      cmn.CallEventHandler( "win_fridgedoor" );
      
      common.CloseSubRoom();
    
    end;
    
    cmn.Lock(1);
    
    cmn.StopAllEnv("assets/levels/common/audio/aud_kitchen_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_kitchen_env");
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_opn_refrigerator");
    
    ObjSet("tmr_fridgedoor_timer",  { playing = 0, endtrig = "" });
    ObjAnimate("spr_fridgedoor_hairdryer", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
    ObjSet("anm_fridgedoor_door_open",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;
  
end;
-----------------------------------------------------------------------------------
--*******************************************************************************************************************