-- name=ho_hospitalroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hospitalroom" );
  game.relations[ "ho_hospitalroom" ].exitroom = "rm_nearhospital";
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_hospitalroom" ] = 
  {
    type = "win",
    room = "rm_nearhospital",
    zz = "ho_hospitalroom",
    zz_gate = "gho_nearhospital_hospitalroom"
  };
  --------------------------------------------------------------------------------------------------
  local win_hospitalroom_func = function ()

    if ( cmn.IsEventDone( "win_hospitalroom" ) ) then
      common_impl.InventoryComplexItemAdd( "inv_pileofsheets", "spr_hospitalroom_win" );
      ObjDelete("gho_nearhospital_hospitalroom");
    end;

  end;
  cmn.AddSubscriber( "win_hospitalroom", win_hospitalroom_func );
  --------------------------------------------------------------------------------------------------
  local start_hospitalroom_func = function ()

    if ( cmn.IsEventStart( "win_hospitalroom" ) ) then

      common_impl.ProcessHoStart( "hospitalroom", true );

    end;

  end;
  cmn.AddSubscriber( "win_hospitalroom", start_hospitalroom_func, "ho_hospitalroom" );
  
  --for secretroom
  private.tasks =  {    
      { "caduceus",      1, 0, { { "spr_hospitalroom_caduceus" } } },
      { "crutch",      1, 0, { { "spr_hospitalroom_crutch" } } },
      { "funnel",      1, 0, { { "spr_hospitalroom_funnel" } } },
      { "glasses",      1, 0, { { "spr_hospitalroom_glasses" } } },

      { "glove",      1, 0, { { "spr_hospitalroom_glove" } } },
      { "pills",      1, 0, { { "spr_hospitalroom_pills" } } },
      { "sheets",     1, 0, { { "spr_hospitalroom_sheets" } } },
      { "skull",   1, 0, { { "spr_hospitalroom_skull" } } },

      { "slipper",  1, 0, { { "spr_hospitalroom_slipper" } } },
      { "stethoscope",    1, 0, { { "spr_hospitalroom_stethoscope" } } },
      { "syringe", 1, 0, { { "spr_hospitalroom_syringe" } } },
      { "thermometer",    1, 0, { { "spr_hospitalroom_thermometer" } } }
  };
    
  private.tasks_sh =  { 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0 };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ j ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );

    end;
    
    if private.tasks_sh[i] == 1 then
      
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ 1 ][ 1 ].."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_hospitalroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_hospitalroom_env");
  if port.isPortable() == 1 then
    iOS_EnableMultiTouch(1); 
  end;
  if ng_global.currentprogress == "std" then

    common.SetPreviousRoom( "rm_nearhospital" );
    cmn.StartTimePassing("ho_hospitalroom");
    
  else 
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_hospitalroom_nearhospital",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                               event_menter = function () rm_extra.GateMouseEnter( "hospitalroom_nearhospital", CURSOR_DOWN, "extra" ); end, 
                                               event_mleave = function () common_impl.GateMouseLeave( "hospitalroom_nearhospital" ); end });
    
  end;

  if not cmn.IsEventStart( "win_hospitalroom" ) then
    cmn.InitHo( "hospitalroom" );
  end;

  local ho_items = {};

  interface_impl.ItemPanelItemAdd( ho_items, "caduceus", 0, "spr_hospitalroom_caduceus" );
  interface_impl.ItemPanelItemAdd( ho_items, "crutch", 0, "spr_hospitalroom_crutch" );
  interface_impl.ItemPanelItemAdd( ho_items, "funnel", 0, "spr_hospitalroom_funnel" );
  interface_impl.ItemPanelItemAdd( ho_items, "glasses", 0, "spr_hospitalroom_glasses" );
  interface_impl.ItemPanelItemAdd( ho_items, "glove", 0, "spr_hospitalroom_glove" );
  interface_impl.ItemPanelItemAdd( ho_items, "pills", 0, "spr_hospitalroom_pills" );
  interface_impl.ItemPanelItemAdd( ho_items, "sheets", 0, "spr_hospitalroom_sheets" );
  interface_impl.ItemPanelItemAdd( ho_items, "skull", 0, "spr_hospitalroom_skull" );
  interface_impl.ItemPanelItemAdd( ho_items, "slipper", 0, "spr_hospitalroom_slipper" );
  interface_impl.ItemPanelItemAdd( ho_items, "stethoscope", 0, "spr_hospitalroom_stethoscope" );
  interface_impl.ItemPanelItemAdd( ho_items, "syringe", 0, "spr_hospitalroom_syringe" );
  interface_impl.ItemPanelItemAdd( ho_items, "thermometer", 0, "spr_hospitalroom_thermometer" );

  if (not cmn.IsEventDone("win_hospitalroom")) then
  
    interface_impl.ItemPanelShow( ho_items );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_hospitalroom_nearhospital",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_hospitalroom");

    if ng_global.progress[ ng_global.currentprogress ][ "win_hospitalroom" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_hospitalroom" ] then

      ng_global.nohintho[ "win_hospitalroom" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_hospitalroom" ] then
      ng_global.playedhops[ "win_hospitalroom" ] = 1;
    end;
    
  else 
    int_dialog_secretroom.StopTimer();
    ObjSet("grm_hospitalroom_nearhospital",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  
  if ObjGet("spr_hospitalroom_"..item_name.."_shadow") then
    ObjDelete( "spr_hospitalroom_"..item_name.."_shadow" );
  end;
  
  if item_name == "syringe" or item_name == "glove" or item_name == "funnel" then
    local pos = GetObjPosByObj( "spr_hospitalroom_"..item_name );
    ObjSet( "spr_hospitalroom_"..item_name, { pos_x = pos[1] + 171, pos_y = pos[2] } );
  end;

  cmn.HoItemFind("spr_hospitalroom_"..item_name, 1);

end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_hospitalroom_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_hospitalroom_items" );

    end;
    
  end;
  
end;
--*********************************************************************************************************************
