-- name=ho_incarriage
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_incarriage" );
  game.relations[ "ho_incarriage" ].exitroom = "rm_forestthicket";
  public.change_stage_anim_type = "alp";
  private.win_inprogress = false;
  private.cur_progress = "std";
  --------------------------------------------------------------------------------------------------
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_incarriage" ] = 
  {
    type = "win",
    room = "rm_forestthicket",
    zz = "ho_incarriage",
    zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------------
  local win_incarriage_func = function ()

    if ( cmn.IsEventDone( "win_incarriage" ) ) then
      ObjDelete("gho_forestthicket_incarriage");
    end;

  end;
  cmn.AddSubscriber( "win_incarriage", win_incarriage_func );
  --------------------------------------------------------------------------------------------------
  local start_incarriage_func = function ()

    if ( cmn.IsEventStart( "win_incarriage" ) ) then

      common_impl.ProcessHoStart( "incarriage", true );

    end;

  end;
  cmn.AddSubscriber( "win_incarriage", start_incarriage_func, "ho_incarriage" );
  
  --------------------------------------------------------------------------------------------
  -- function beg_level2 () end;
  --------------------------------------------------------------------------------------------
  local beg_level2 = function ()
  
    int_map_impl.OpenRoom( "rm_forestthicket" );
    interface.InventoryItemAdd( "inv_lvl2sleepingpills" );
    interface.InventoryItemAdd( "inv_bell1" );
    interface.InventoryItemAdd( "inv_lvl2crystalshoe" );
    interface.InventoryItemAdd( "inv_cinderellapage" );
    interface.InventoryItemAdd( "inv_gnomeshammer" );
    
    interface_impl.SetCurrentGlobalTask( 14 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level2", beg_level2 );
  
  --for secretroom
  private.tasks =  {    
  
      { "twelve",      1, 0, { { "spr_incarriage_twelve" } } },
      { "mortar",    1, 0, { { "spr_incarriage_mortar" } } },
      { "snowman",      1, 0, { { "spr_incarriage_snowman", } } },
      { "saw",     1, 0, { { "spr_incarriage_saw" } } },
      
      { "monocle",      1, 0, { { "spr_incarriage_monocle" } } },
      { "cubes",     1, 0, { { "spr_incarriage_cubes", } } },
      { "crown",   1, 0, { { "spr_incarriage_crown" } } },
      { "scissors",   1, 0, { { "spr_incarriage_scissors" } } },
      
      { "screwdriver",  1, 0, { { "spr_incarriage_screwdriver" } } },
      { "jug",    1, 0, { { "spr_incarriage_jug" } } },
      { "skates", 1, 0, { { "spr_incarriage_skates" } } },
      { "pliers",    1, 0, { { "spr_incarriage_pliers" } } }
      
  };
    
  private.actions = {
  
    { "use_lvl2hoclock", { "spr_incarriage_clock", "spr_incarriage_clock_shadow", "spr_incarriage_panel_doors_sil_1", "spr_incarriage_panel_doors_sil_1_done" } },
    { "use_lvl2hoscales", { "spr_incarriage_scales", "spr_incarriage_scales_shadow", "spr_incarriage_panel_doors_sil_2", "spr_incarriage_panel_doors_sil_2_done" } },
    { "use_lvl2hosnowflake", { "spr_incarriage_snowflake", "spr_incarriage_panel_doors_sil_3", "spr_incarriage_panel_doors_sil_3_done" } },
    { "use_lvl2hohammer", { "spr_incarriage_hammer", "spr_incarriage_panel_doors_sil_4", "spr_incarriage_panel_doors_sil_4_done" } },
    
    { "use_lvl2hogear", { "spr_incarriage_panel_doors_itm_1", "obj_incarriage_use_lvl2hogear", "anm_incarriage_gear_chain", "spr_incarriage_gears_bl",
                          "anm_incarriage_use_gear", "anm_incarriage_mechanism", "obj_incarriage_gears", "spr_incarriage_lock_2", "spr_incarriage_gear_1", "spr_incarriage_gear_2", "spr_incarriage_gear_3" } },
    { "use_lvl2howeight", { "spr_incarriage_panel_doors_itm_2", "obj_incarriage_use_lvl2howeight", "anm_incarriage_weight_chain", "anm_incarriage_use_weight",
                            "anm_incarriage_mechanism", "obj_incarriage_gears", "spr_incarriage_lock_2", "spr_incarriage_gear_1", "spr_incarriage_gear_2", "spr_incarriage_gear_3" } },
    { "use_lvl2horune", { "spr_incarriage_panel_doors_itm_3", "obj_incarriage_use_lvl2horune", "anm_incarriage_use_rune" } },
    { "use_lvl2hopickaxe", { "spr_incarriage_panel_doors_itm_4", "obj_incarriage_use_lvl2hopickaxe", "anm_incarriage_use_pickaxe_1", "anm_incarriage_use_pickaxe_2" } }
  
  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.tasks_sh =  { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0 };

  private.start = {};
  private.start_sh = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName(private.tasks[ i ][ 4 ][1][1].."_shadow");
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].panel_doors = { 0, 0, 0, 0 };
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  --ObjAnimate( "obj_incarriage_back", "pos_y", 1, 0, "", { 0, 0, -2,     0.3, 0, 2,      0.4, 0, -2 } );
  private.AnimCarriage();
  
  if ng_global.currentprogress == "std" and not ( cmn.IsEventDone( "beg_level2" ) ) then

    cmn.Lock(1);
    interface.WidgetSetVisible( "InterfaceWidget_TaskPanel", false, false );
    interface.WidgetSetInput( "InterfaceWidget_TaskPanel", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );

    ObjSet("ho_incarriage",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.StopAllEnv();
    
  else 
    
    cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_incarriage_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_incarriage_env");
    
    if ng_global.currentprogress == "std" then
      
      private.cur_progress = "std";
      cmn.StartTimePassing("ho_incarriage");
      
    else 
      
      private.cur_progress = "secret";
      private.CreateNewObjects();
      ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].stage = { 1, 1 };   
      ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].panel_doors = { 0, 0, 0, 0 };
      
      interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
      interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
      
      ObjSet("grm_incarriage_forestthicket",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                          event_menter = function () rm_extra.GateMouseEnter( "incarriage_forestthicket", CURSOR_DOWN, "extra" ); end, 
                                          event_mleave = function () common_impl.GateMouseLeave( "incarriage_forestthicket" ); end });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_incarriage_forestthicket_focus");
        iOS_EnableMultiTouch(1); 
      end;
    end;

    if not cmn.IsEventStart( "win_incarriage" ) then
      cmn.InitHo( "incarriage" );
    end;
    
    private.SetTasks();

  end;

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_forestthicket" );
  else 
    
    ObjSet("obj_incarriage_back",  { pos_y = 0, ang = 0 });
    
    for i = 1, 4, 1 do
      
      ObjMultiSet( { {"spr_int_taskpanel_panel_doors_1"..i, { pos_y = 89 }},
                     {"spr_int_taskpanel_panel_doors_2"..i, { pos_y = 89 }} } );
      
    end;
                   
  end;
  
end;
--*********************************************************************************************************************
function public.Open()
  
  if ng_global.currentprogress == "std" and not ( cmn.IsEventDone( "beg_level2" ) ) then
    
    local func_after = function ()

      ObjSet("ho_incarriage",  { color_r = 1, color_g = 1, color_b = 1 });
      interface.WidgetSetVisible( "InterfaceWidget_TaskPanel", true, true );
      interface.WidgetSetInput( "InterfaceWidget_TaskPanel", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 1 );

      cmn.ShowBbt( "incarriage_open" );
      interface_impl.ShowGlobalTask();
      
      cmn.StartTimePassing("ho_incarriage");

      if not cmn.IsEventStart( "win_incarriage" ) then
        cmn.InitHo( "incarriage" );
      end;
      
      private.SetTasks();
      
      cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_incarriage_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_incarriage_env");

    end;
    
    local play_ho_mus = function ()
      SndStop( "assets/levels/level2/ho_incarriage/audio/aud_intro_lvl2_mus", 2 );
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
    end;

    cmn.Lock(0);
    
    cmn.SetEventDone( "beg_level2" );
    cmn.CallEventHandler("beg_level2");
    
    ObjSet("tmr_incarriage_timer",  { time = 36, playing = 1, endtrig = play_ho_mus });
    cmn.PlayAudio("mus", "assets/levels/level2/ho_incarriage/audio/aud_intro_lvl2_mus", 1, false);
    cmn.PlayFullscreenVideo( "assets/levels/level2/ho_incarriage/vid_guards", func_after, "assets/levels/level2/ho_incarriage/audio/aud_intro_lvl2", "assets/levels/level2/ho_incarriage/audio/aud_intro_lvl2_voc", 1, 3.5, false, true, true);
    
  else 
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_incarriage_forestthicket",  { input = 0 });
    
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_incarriage_forestthicket_focus");
    end;
      
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
  
  --if private.cur_progress == "secret" then
    
    ObjStopAnimate("obj_incarriage_back", "pos_y");
    ObjStopAnimate("obj_incarriage_back", "ang");
    
    for i = 1, 4, 1 do
      
      if ng_global.progress[ private.cur_progress ][ public.ho_hint_progress_names[i] ].done == 0 then
        ObjDetach("spr_incarriage_panel_doors_sil_"..i);
      end;
      if ng_global.progress[ private.cur_progress ][ public.ho_hint_progress_names[i+4] ].done == 0 then
        ObjDetach("spr_incarriage_panel_doors_itm_"..i);
      end;
      
    end;
    
    --end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_incarriage");

    if ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_incarriage" ] then

      ng_global.nohintho[ "win_incarriage" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_incarriage" ] then
      ng_global.playedhops[ "win_incarriage" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_incarriage_forestthicket",  { input = 0 });
    int_dialog_secretroom.StopTimer();
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_incarriage_forestthicket_focus");
    end;
  end;
  
end;
--*********************************************************************************************************************
function public.win()
  
  if not private.win_inprogress then
    
    private.win_inprogress = true;
  
    cmn.StopAllEnv();
    SndStop( "assets/levels/level2/ho_incarriage/audio/aud_intro_lvl2_mus", 2 );
    SndStop( "assets/levels/common/audio/aud_ho_music_theme", 2 );
    
    ObjSet("tmr_incarriage_timer",  { playing = 0, endtrig = "" });

    local func_after = function ()
      ObjSet("ho_incarriage",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.CallEventHandler("win_incarriage");
      cmn.GotoRoom("rm_forestthicket");
    end;
    
    --cmn.PlayAudio("mus", "assets/levels/level2/rm_forestthicket/audio/aud_salvationfromcarriage_mus", 0, false, 40);
    
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_forestthicket/vid_salvationfromcarriage", func_after, "assets/levels/level2/rm_forestthicket/audio/aud_salvationfromcarriage", "", 1, 3.5, false, true);
    
  end;

end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )
  
  if task_name == "saw" then
    ObjDelete( item_name.."_shadow" );
  end;
  
  if task_name == "scissors" or task_name == "snowman" then
    local pos = GetObjPosByObj( item_name );
    ObjSet( item_name, { pos_x = pos[1] + 171, pos_y = pos[2] } );
  end;

  cmn.HoTaskFind(item_name, task_name, 1);

end;
--*********************************************************************************************************************
function private.SetTasks()
  
  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_incarriage" ].stage;
  
  if not cmn.IsEventDone("win_incarriage") and ho_stage[1] <= ho_stage[2] then

    interface.TaskPanelTaskAdd( ho_tasks, "twelve", 1, 0, { { "spr_incarriage_twelve" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "mortar", 1, 0, { { "spr_incarriage_mortar" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "snowman", 1, 0, { { "spr_incarriage_snowman" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "saw", 1, 0, { { "spr_incarriage_saw" } } );
    
    interface.TaskPanelTaskAdd( ho_tasks, "monocle", 1, 0, { { "spr_incarriage_monocle" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "cubes", 1, 0, { { "spr_incarriage_cubes" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "crown", 1, 0, { { "spr_incarriage_crown" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "scissors", 1, 0, { { "spr_incarriage_scissors" } } );
    
    interface.TaskPanelTaskAdd( ho_tasks, "screwdriver", 1, 0, { { "spr_incarriage_screwdriver" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "jug", 1, 0, { { "spr_incarriage_jug" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "skates", 1, 0, { { "spr_incarriage_skates" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "pliers", 1, 0, { { "spr_incarriage_pliers" } } );
    
    interface_impl.TaskPanelShow( ho_tasks );

  else

    public.win();

  end;
  
end;
--*********************************************************************************************************************
function private.AnimCarriage()
  
  ObjAnimate( "obj_incarriage_back", "pos_y", 1, 0, "", 
  { 
    0,   0,   0,
    6,   0,   0,
    6.2, 0,   2,
    6.4, 0,   0,
    6.6, 0,  -2,
    6.8, 0,   0
  } );
 
  ObjAnimate( "obj_incarriage_back", "ang", 1, 0, "", 
  { 
    0,  0,       0,
    3,  0,   0.005,
    6,  0,       0,
    9,  0,  -0.005,
    12, 0,       0
  } );
  
end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_lvl2hoclock", "use_lvl2hoscales", "use_lvl2hosnowflake", "use_lvl2hohammer",
                                    "use_lvl2hogear",  "use_lvl2howeight",  "use_lvl2horune",  "use_lvl2hopickaxe" };
  
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hoclock () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hoclock" ] = {
      type = "use",
      inv_obj = "spr_incarriage_clock",
      use_place = "spr_incarriage_panel_doors_sil_1",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hoclock_beg = function ()
  
    ObjDelete( "spr_incarriage_clock" );
    ObjDelete( "spr_incarriage_clock_shadow" );
  
  end;
  local use_lvl2hoclock_end = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_sil_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hoclock", use_lvl2hoclock_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hoclock", use_lvl2hoclock_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hoclock_beg", use_lvl2hoclock_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hoclock_end", use_lvl2hoclock_end, "ho_incarriage" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hoscales () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hoscales" ] = {
      type = "use",
      inv_obj = "spr_incarriage_scales",
      use_place = "spr_incarriage_panel_doors_sil_2",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hoscales_beg = function ()
  
    ObjDelete( "spr_incarriage_scales" );
    ObjDelete( "spr_incarriage_scales_shadow" );
  
  end;
  local use_lvl2hoscales_end = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_sil_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hoscales", use_lvl2hoscales_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hoscales", use_lvl2hoscales_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hoscales_beg", use_lvl2hoscales_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hoscales_end", use_lvl2hoscales_end, "ho_incarriage" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hosnowflake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hosnowflake" ] = {
      type = "use",
      inv_obj = "spr_incarriage_snowflake",
      use_place = "spr_incarriage_panel_doors_sil_3",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hosnowflake_beg = function ()
  
    ObjDelete( "spr_incarriage_snowflake" );
  
  end;
  local use_lvl2hosnowflake_end = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_sil_3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hosnowflake", use_lvl2hosnowflake_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hosnowflake", use_lvl2hosnowflake_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hosnowflake_beg", use_lvl2hosnowflake_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hosnowflake_end", use_lvl2hosnowflake_end, "ho_incarriage" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hohammer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hohammer" ] = {
      type = "use",
      inv_obj = "spr_incarriage_hammer",
      use_place = "spr_incarriage_panel_doors_sil_4",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hohammer_beg = function ()
  
    ObjDelete( "spr_incarriage_hammer" );
  
  end;
  local use_lvl2hohammer_end = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_sil_4" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hohammer", use_lvl2hohammer_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hohammer", use_lvl2hohammer_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hohammer_beg", use_lvl2hohammer_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hohammer_end", use_lvl2hohammer_end, "ho_incarriage" );
  
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hogear () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hogear" ] = {
      type = "use",
      inv_obj = "spr_incarriage_panel_doors_itm_1",
      use_place = "obj_incarriage_use_lvl2hogear",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hogear_beg = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_itm_1" );
    ObjDelete( "obj_incarriage_use_lvl2hogear" );
    ObjDelete( "anm_incarriage_gear_chain" );
    ObjDelete( "spr_incarriage_gears_bl" );

  end;
  local use_lvl2hogear_end = function ()
    
    if cmn.IsEventDone("use_lvl2howeight") then
      ObjMultiSet( { {"obj_incarriage_use_lvl2horune", { input = 1 }},
                     {"anm_incarriage_mechanism", { alp = 1, frame = 300 }} } );
      ObjDelete( "obj_incarriage_gears" );
      ObjDelete( "spr_incarriage_lock_2" );
      ObjDelete( "anm_incarriage_use_gear" );
      ObjDelete( "anm_incarriage_use_weight" );
    else 
      ObjSet( "anm_incarriage_use_gear", { alp = 1, frame = 300 } );
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hogear", use_lvl2hogear_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hogear", use_lvl2hogear_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hogear_beg", use_lvl2hogear_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hogear_end", use_lvl2hogear_end, "ho_incarriage" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2howeight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2howeight" ] = {
      type = "use",
      inv_obj = "spr_incarriage_panel_doors_itm_2",
      use_place = "obj_incarriage_use_lvl2howeight",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2howeight_beg = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_itm_2" );
    ObjDelete( "obj_incarriage_use_lvl2howeight" );
    ObjDelete( "anm_incarriage_weight_chain" );

  end;
  local use_lvl2howeight_end = function ()

    if cmn.IsEventDone("use_lvl2hogear") then
      ObjMultiSet( { {"obj_incarriage_use_lvl2horune", { input = 1 }},
                     {"anm_incarriage_mechanism", { alp = 1, frame = 300 }} } );
      ObjDelete( "obj_incarriage_gears" );
      ObjDelete( "spr_incarriage_lock_2" );
      ObjDelete( "anm_incarriage_use_gear" );
      ObjDelete( "anm_incarriage_use_weight" );
    else 
      ObjSet( "anm_incarriage_use_weight", { alp = 1, frame = 300 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2howeight", use_lvl2howeight_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2howeight", use_lvl2howeight_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2howeight_beg", use_lvl2howeight_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2howeight_end", use_lvl2howeight_end, "ho_incarriage" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2horune () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2horune" ] = {
      type = "use",
      inv_obj = "spr_incarriage_panel_doors_itm_3",
      use_place = "obj_incarriage_use_lvl2horune",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2horune_beg = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_itm_3" );
    ObjDelete( "obj_incarriage_use_lvl2horune" );

  end;
  local use_lvl2horune_end = function ()

    ObjMultiSet( { {"obj_incarriage_use_lvl2hopickaxe", { input = 1 }},
                   {"anm_incarriage_use_rune", { alp = 1, frame = 300 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2horune", use_lvl2horune_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2horune", use_lvl2horune_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2horune_beg", use_lvl2horune_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2horune_end", use_lvl2horune_end, "ho_incarriage" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hopickaxe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hopickaxe" ] = {
      type = "use",
      inv_obj = "spr_incarriage_panel_doors_itm_4",
      use_place = "obj_incarriage_use_lvl2hopickaxe",
      room = "rm_forestthicket",
      zz = "ho_incarriage",
      zz_gate = "gho_forestthicket_incarriage"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hopickaxe_beg = function ()
  
    ObjDelete( "spr_incarriage_panel_doors_itm_4" );
    ObjDelete( "obj_incarriage_use_lvl2hopickaxe" );
    --ObjDelete( "anm_incarriage_use_rune" );

  end;
  local use_lvl2hopickaxe_end = function ()

    --ObjSet( "anm_incarriage_use_pickaxe_1", { alp = 1, frame = 300 } );
    ObjDelete( "anm_incarriage_use_pickaxe_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hopickaxe", use_lvl2hopickaxe_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hopickaxe", use_lvl2hopickaxe_end, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hopickaxe_beg", use_lvl2hopickaxe_beg, "ho_incarriage" );
  cmn.AddSubscriber( "use_lvl2hopickaxe_end", use_lvl2hopickaxe_end, "ho_incarriage" );
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.start_drag( name )
  
  int_taskpanel_impl.PanelDoorsObjStartDrag( name );
  ObjAnimate(name.."_shadow", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  
end;
------------------------------------------------------------------------------
function public.use_lvl2hoclock()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_clock";

  if ( ObjIntersect( item, "spr_incarriage_panel_doors_sil_1" ) ) then

    cmn.SetEventDone( "use_lvl2hoclock" );
    cmn.CallEventHandler( "use_lvl2hoclock_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_lvl2hoclock_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    --cmn.PlayAudio("snd", "assets/levels/level1/ho_inpicture/audio/aud_drop_element");

    int_taskpanel.OpenPanelDoor( 1, func_after );

  else

    cmn.WrongApply();  
    ObjAnimate(item.."_shadow", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2hoscales()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_scales";

  if ( ObjIntersect( item, "spr_incarriage_panel_doors_sil_2" ) ) then

    cmn.SetEventDone( "use_lvl2hoscales" );
    cmn.CallEventHandler( "use_lvl2hoscales_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_lvl2hoscales_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    --cmn.PlayAudio("snd", "assets/levels/level1/ho_inpicture/audio/aud_drop_element");

    int_taskpanel.OpenPanelDoor( 2, func_after );

  else

    cmn.WrongApply();  
    ObjAnimate(item.."_shadow", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2hosnowflake()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_snowflake";

  if ( ObjIntersect( item, "spr_incarriage_panel_doors_sil_3" ) ) then

    cmn.SetEventDone( "use_lvl2hosnowflake" );
    cmn.CallEventHandler( "use_lvl2hosnowflake_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_lvl2hosnowflake_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    --cmn.PlayAudio("snd", "assets/levels/level1/ho_inpicture/audio/aud_drop_element");

    int_taskpanel.OpenPanelDoor( 3, func_after );

  else

    cmn.WrongApply();  

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2hohammer()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_hammer";

  if ( ObjIntersect( item, "spr_incarriage_panel_doors_sil_4" ) ) then

    cmn.SetEventDone( "use_lvl2hohammer" );
    cmn.CallEventHandler( "use_lvl2hohammer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_lvl2hohammer_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    --cmn.PlayAudio("snd", "assets/levels/level1/ho_inpicture/audio/aud_drop_element");

    int_taskpanel.OpenPanelDoor( 4, func_after );

  else

    cmn.WrongApply();  

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2hogear()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_panel_doors_itm_1";

  if ( cmn.ApplyObj( item, "obj_incarriage_use_lvl2hogear" ) ) then

    cmn.CallEventHandler( "use_lvl2hogear_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl2hogear" );
      cmn.CallEventHandler( "use_lvl2hogear_end" );

    end;
    
    local anm_mech = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/ho_incarriage/audio/aud_opn_chain_lock2");
      
      ObjDelete("anm_incarriage_use_gear");
      ObjDelete("anm_incarriage_use_weight");
      ObjSet("anm_incarriage_mechanism",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level2/ho_incarriage/audio/aud_use_gear");

    if cmn.IsEventDone("use_lvl2howeight") then
      ObjSet("anm_incarriage_use_gear",  { alp = 1, playing = 1, endtrig = anm_mech });
    else 
      ObjSet("anm_incarriage_use_gear",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2howeight()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_panel_doors_itm_2";

  if ( cmn.ApplyObj( item, "obj_incarriage_use_lvl2howeight" ) ) then

    cmn.CallEventHandler( "use_lvl2howeight_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl2howeight" );
      cmn.CallEventHandler( "use_lvl2howeight_end" );

    end;
    
    local anm_mech = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/ho_incarriage/audio/aud_opn_chain_lock2");
      
      ObjDelete("anm_incarriage_use_gear");
      ObjDelete("anm_incarriage_use_weight");
      ObjSet("anm_incarriage_mechanism",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level2/ho_incarriage/audio/aud_opn_chain_lock");

    if cmn.IsEventDone("use_lvl2hogear") then
      ObjSet("anm_incarriage_use_weight",  { alp = 1, playing = 1, endtrig = anm_mech });
    else 
      ObjSet("anm_incarriage_use_weight",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2horune()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_panel_doors_itm_3";

  if ( cmn.ApplyObj( item, "obj_incarriage_use_lvl2horune" ) and cmn.IsEventDone("use_lvl2howeight") and cmn.IsEventDone("use_lvl2hogear") ) then

    cmn.CallEventHandler( "use_lvl2horune_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl2horune" );
      cmn.CallEventHandler( "use_lvl2horune_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level2/ho_incarriage/audio/aud_use_ice_stone");

    ObjSet("anm_incarriage_use_rune",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
function public.use_lvl2hopickaxe()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_incarriage_panel_doors_itm_4";

  if ( cmn.ApplyObj( item, "obj_incarriage_use_lvl2hopickaxe" ) and cmn.IsEventDone("use_lvl2horune") ) then

    cmn.CallEventHandler( "use_lvl2hopickaxe_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      if ng_global.currentprogress == "std" then
        cmn.CallEventHandler( "use_lvl2hopickaxe_end" );
        public.win();
      else 
        
        --cmn.StopAllEnv();
        --SndStop( "assets/levels/level2/ho_incarriage/audio/aud_intro_lvl2_mus", 1 );
        --SndStop( "assets/levels/common/audio/aud_ho_music_theme", 1 );
    
        ObjSet("tmr_incarriage_timer",  { playing = 0, endtrig = "" });
        
        int_dialog_secretroom.ShowAnim();
        
      end;

    end;

    cmn.SetEventDone( "use_lvl2hopickaxe" );
    
    cmn.SetEventDone("win_incarriage");
    public.HoComplete();
    
    if ng_global.currentprogress == "std" then
      func_after();
    else

      cmn.Lock( 1, { room = 1 } );

      ObjMultiSet( { {"anm_incarriage_use_pickaxe_1",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_incarriage_use_pickaxe_2", { alp = 1, playing = 1 }},
                     {"anm_incarriage_use_rune", { alp = 0 }} } );
    
    end;

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

end;
--*******************************************************************************************************************
