-- name=ho_medical
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_medical" );
  game.relations[ "ho_medical" ].exitroom = "rm_clothesroom";
  
  public.changed_name = {"", ""};
  private.selected_item = "";
  private.item_names = {"rope", "brush", "sponge", "pen", "mask", "roller", "clothespin", "soap", "battery", "bulb", "paperboat", "scotchtape"};
  private.boxes = 6;
  private.boxes_open = {0, 0};
  
  private.boxes_content = { 
    {"brush_1", "sponge_1", "rope_1", "pen_1"}, {"soap_1", "clothespin_1", "roller_1", "mask_1"}, {"mask_2", "pen_2", "rope_2", "battery_1"}, 
    {"paperboat_1", "brush_2", "soap_2", "bulb_1"}, {"paperboat_2", "roller_2", "clothespin_2", "scotchtape_1"}, {"scotchtape_2", "bulb_2", "sponge_2", "battery_2"}
  };
  
  --позиции пар и их соединений
  private.items_pos = {{{152, 142}, {885, 332}, {529, 262}},
                       {{144,  58}, {246, 331}, {194, 199}},
                       {{218,  81}, {806, 541}, {518, 334}},
                       {{275, 165}, {784, 271}, {535, 230}},
                       {{494, 205}, {897, 222}, {716, 211}},
                       {{367, 207}, {579, 488}, {473, 347}},

                       {{545, 126}, {483, 501}, {509, 302}},
                       {{430, 114}, {130, 354}, {309, 238}},
                       {{733, 316}, {828, 436}, {800, 395}},
                       {{230, 391}, {914, 464}, {546, 417}},
                       {{146, 292}, {494, 370}, {339, 335}},
                       {{371, 424}, {721, 523}, {568, 486}}};    
  ------------------------------------------------------------------------------
  game.medical = {};
  game.medical.double_hint = {  { {"spr_medical_rope_1", "spr_medical_box_1_closed"},         {"spr_medical_rope_2", "spr_medical_box_3_closed"} },
                                { {"spr_medical_brush_1", "spr_medical_box_1_closed"},        {"spr_medical_brush_2", "spr_medical_box_4_closed"} },
                                { {"spr_medical_sponge_1", "spr_medical_box_1_closed"},       {"spr_medical_sponge_2", "spr_medical_box_6_closed"} },
                                { {"spr_medical_pen_1", "spr_medical_box_1_closed"},          {"spr_medical_pen_2", "spr_medical_box_3_closed"} },
                                { {"spr_medical_mask_1", "spr_medical_box_2_closed"},         {"spr_medical_mask_2", "spr_medical_box_3_closed"} },
                                { {"spr_medical_roller_1", "spr_medical_box_2_closed"},       {"spr_medical_roller_2", "spr_medical_box_5_closed"} },
                                { {"spr_medical_clothespin_1", "spr_medical_box_2_closed"},   {"spr_medical_clothespin_2", "spr_medical_box_5_closed"} },
                                { {"spr_medical_soap_1", "spr_medical_box_2_closed"},         {"spr_medical_soap_2", "spr_medical_box_4_closed"} },
                                { {"spr_medical_battery_1", "spr_medical_box_3_closed"},      {"spr_medical_battery_2", "spr_medical_box_6_closed"} },
                                { {"spr_medical_bulb_1", "spr_medical_box_4_closed"},         {"spr_medical_bulb_2", "spr_medical_box_6_closed"} },
                                { {"spr_medical_paperboat_1", "spr_medical_box_4_closed"},    {"spr_medical_paperboat_2", "spr_medical_box_5_closed"} },
                                { {"spr_medical_scotchtape_1", "spr_medical_box_5_closed"},   {"spr_medical_scotchtape_2", "spr_medical_box_6_closed"} }   };
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_medical" ] = 
  {
    type = "win",
    room = "rm_clothesroom",
    zz = "ho_medical",
    zz_gate = "gho_clothesroom_medical"
  };
  --------------------------------------------------------------------------------------------------
  local win_medical_func = function ()

    if ( cmn.IsEventDone( "win_medical" ) ) then
      interface.InventoryItemAdd( "inv_room13key", "spr_medical_win" );
      ObjDelete("gho_clothesroom_medical");
      ObjDelete("spr_clothesroom_ho_box_key");
      ObjSet("spr_clothesroom_ho_box_open",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "win_medical", win_medical_func );
  --------------------------------------------------------------------------------------------------
  local start_medical_func = function ()

    if ( cmn.IsEventStart( "win_medical" ) ) then

      common_impl.ProcessHoStart( "medical" );

    end;

  end;
  cmn.AddSubscriber( "win_medical", start_medical_func, "ho_medical" );
  
  --for secretroom
  private.tasks =  {    
  
      { "rope",        2, 0, { { "spr_medical_rope_1", "spr_medical_rope_2" } } },
      { "brush",       2, 0, { { "spr_medical_brush_1", "spr_medical_brush_2" } } },
      { "sponge",      2, 0, { { "spr_medical_sponge_1", "spr_medical_sponge_2" } } },
      { "pen",         2, 0, { { "spr_medical_pen_1", "spr_medical_pen_2" } } },
      
      { "mask",        2, 0, { { "spr_medical_mask_1", "spr_medical_mask_2" } } },
      { "roller",      2, 0, { { "spr_medical_roller_1", "spr_medical_roller_2" } } },
      { "clothespin",  2, 0, { { "spr_medical_clothespin_1", "spr_medical_clothespin_2" } } },
      { "soap",        2, 0, { { "spr_medical_soap_1", "spr_medical_soap_2" } } },
      
      { "battery",     2, 0, { { "spr_medical_battery_1", "spr_medical_battery_2" } } },
      { "bulb",        2, 0, { { "spr_medical_bulb_1", "spr_medical_bulb_2" } } },
      { "paperboat",   2, 0, { { "spr_medical_paperboat_1", "spr_medical_paperboat_2" } } },
      { "scotchtape",  2, 0, { { "spr_medical_scotchtape_1", "spr_medical_scotchtape_2" } } },
      
      { "pairs",   12, 0, { { "obj_medical_rope_fly", "obj_medical_brush_fly", "obj_medical_sponge_fly", "obj_medical_pen_fly", 
                             "obj_medical_mask_fly", "obj_medical_roller_fly", "obj_medical_clothespin_fly", "obj_medical_soap_fly", 
                             "obj_medical_battery_fly", "obj_medical_bulb_fly", "obj_medical_paperboat_fly", "obj_medical_scotchtape_fly",  } } }
      
  };
                         
  private.start = {};
  private.start_sh = {};
  local nme = "";
                         
  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ 1 ][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      if i < 13 then
      
        table.insert( private.start_sh, {} );
        private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ 1 ][ j ].."_sh";
        nme = private.start_sh[ #private.start_sh ].name;
        private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
        private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
        
      end;

    end;
    
  end;                      

end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "std" and not(ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage) then

    ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage = {1, 2};
    ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].complete = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    
  elseif ng_global.currentprogress == "secret" then
    
    ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage = {1, 2};
    ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].complete = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

  end;

  private.complete = ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].complete;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_hospitalroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_hospitalroom_env");
  	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_clothesroom" );
    cmn.StartTimePassing("ho_medical");
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage = {1, 2};
    ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].complete = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    
    private.complete = ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].complete;
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_medical_clothesroom",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "medical_clothesroom", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "medical_clothesroom" ); end });
    
  end;
    
  private.DrawScene();

  if not cmn.IsEventStart( "win_medical" ) then
    cmn.InitHo( "medical" );
  end;

  local ho_tasks = private.stages_task();

  if (not cmn.IsEventDone("win_medical")) and
     ( ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage[2] ) then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_medical_clothesroom",  { input = 0 });
    
    if private.selected_item ~= "" then
      ObjStopAnimate( public.changed_name[1], "scale_xy" );
    end;
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()

  if private.cur_progress == "secret" then
    
    if private.selected_item ~= "" then
      ObjAttach( public.changed_name[1], "ho_medical" );
      ObjSet(public.changed_name[1],  { scale_x = 1, scale_y = 1 });
      private.selected_item = "";
      public.changed_name = {"", ""};
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_medical");

    if ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_medical" ] then

      ng_global.nohintho[ "win_medical" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_medical" ] then
      ng_global.playedhops[ "win_medical" ] = 1;
    end;
    
  else 
    ObjSet("grm_medical_clothesroom",  { input = 0 });
  end
  
end;
--*********************************************************************************************************************
function private.DrawScene()

  if ng_global.currentprogress == "std" then

    for i = 1, #private.item_names, 1 do
    
      if private.complete[i] == 1 then
        
        ObjDelete( "spr_medical_"..private.item_names[i].."_1_sh" );
        ObjDelete( "spr_medical_"..private.item_names[i].."_2_sh" );
        ObjDelete( "spr_medical_"..private.item_names[i].."_1" );
        ObjDelete( "spr_medical_"..private.item_names[i].."_2" );

      end;
      
    end;
    
    for i = 1, private.boxes, 1 do
      
      if private.CheckBoxForEmpty( i ) then
        ObjSet("spr_medical_box_"..i.."_closed",  { input = 0 });
      end;
      
    end;
    
    if ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage[1] == 2 then
      game.medical.double_hint = nil;
      ObjMultiSet( { {"spr_medical_key", { input = 1 }},
                     {"spr_medical_box_7_open", { alp = 1 }},
                     {"spr_medical_box_7_closed", { alp = 0 }} } );
    end;

  elseif ng_global.currentprogress == "secret" then

    game.medical.double_hint = nil;
    
    ObjMultiSet( { {"spr_medical_key", { input = 0 }},
                   {"spr_medical_box_7_open", { alp = 0 }},
                   {"spr_medical_box_7_closed", { alp = 1 }} } );
    
    for i = 1, 2, 1 do
      
      if private.boxes_open[i] > 0 then
        ObjMultiSet( { {"spr_medical_box_"..private.boxes_open[i].."_open", { alp = 0, input = 0 }},
                       {"spr_medical_box_"..private.boxes_open[i].."_closed", { alp = 1, input = 1 }} } );
      end;
      
    end;
                   
    private.boxes_open = {0, 0};   
    private.selected_item = "";
    public.changed_name = {"", ""};    
                   
    for i = 1, private.boxes, 1 do
      ObjSet("spr_medical_box_"..i.."_closed",  { input = 1 });
    end;

  end;

end;
--*********************************************************************************************************************
function public.OpenBox( num )
  
  local place = false;
  local need_close = {0, 0};
  
  if private.boxes_open[1] == num or private.boxes_open[2] == num then
    
    ObjMultiSet( { {"spr_medical_box_"..num.."_closed", { input = 1 }},
                   {"spr_medical_box_"..num.."_open", { input = 0 }} } );
    
    local table_num = 1;
    
    if private.boxes_open[1] == num then
      private.boxes_open[1] = 0;
    else 
      table_num = 2;
      private.boxes_open[2] = 0;
    end;
    
    for i = 1, #private.boxes_content[num], 1 do
      local pair_num = private.FindPairInd( string.sub( private.boxes_content[num][i], 1, string.len(private.boxes_content[num][i])-2 ) );
      if private.complete[pair_num] == 0 then
        ObjSet("spr_medical_"..private.boxes_content[num][i],  { input = 0 });
        if public.changed_name[1] == "spr_medical_"..private.boxes_content[num][i] then
          public.changed_name[1] = "";
          private.selected_item = "";
          private.SelectAnim( "spr_medical_"..private.boxes_content[num][i], 0 );
        end;
      end;
    end;
    
  elseif private.boxes_open[1] == 0 then
    private.boxes_open[1] = num;
    place = true;
    ObjMultiSet( { {"spr_medical_box_"..num.."_closed", { input = 0 }},
                   {"spr_medical_box_"..num.."_open", { input = 1 }} } );
  elseif private.boxes_open[1] > 0 and private.boxes_open[2] == 0 then
    place = true;
    private.boxes_open[2] = num;
    ObjMultiSet( { {"spr_medical_box_"..num.."_closed", { input = 0 }},
                   {"spr_medical_box_"..num.."_open", { input = 1 }} } );
  else 
                   
    ObjMultiSet( { {"spr_medical_box_"..num.."_closed", { input = 0 }},
                   {"spr_medical_box_"..num.."_open", { input = 1 }},
                   {"spr_medical_box_"..private.boxes_open[1].."_closed", { input = 1 }},
                   {"spr_medical_box_"..private.boxes_open[1].."_open", { input = 0 }},
                   {"spr_medical_box_"..private.boxes_open[2].."_closed", { input = 1 }},
                   {"spr_medical_box_"..private.boxes_open[2].."_open", { input = 0 }} } );               
    
    for i = 1, #private.boxes_content[ private.boxes_open[1] ], 1 do
      local pair_num = private.FindPairInd( string.sub( private.boxes_content[ private.boxes_open[1] ][i], 1, string.len(private.boxes_content[ private.boxes_open[1] ][i])-2 ) );
      if private.complete[pair_num] == 0 then
        ObjSet("spr_medical_"..private.boxes_content[ private.boxes_open[1] ][i],  { input = 0 });
        if public.changed_name[1] == "spr_medical_"..private.boxes_content[ private.boxes_open[1] ][i] then
          public.changed_name[1] = "";
          private.selected_item = "";
          private.SelectAnim( "spr_medical_"..private.boxes_content[ private.boxes_open[1] ][i], 0 );
        end;
      end;
    end;
    
    for i = 1, #private.boxes_content[ private.boxes_open[2] ], 1 do
      local pair_num = private.FindPairInd( string.sub( private.boxes_content[ private.boxes_open[2] ][i], 1, string.len(private.boxes_content[ private.boxes_open[2] ][i])-2 ) );
      if private.complete[pair_num] == 0 then
        ObjSet("spr_medical_"..private.boxes_content[ private.boxes_open[2] ][i],  { input = 0 });
        if public.changed_name[1] == "spr_medical_"..private.boxes_content[ private.boxes_open[2] ][i] then
          public.changed_name[1] = "";
          private.selected_item = "";
          private.SelectAnim( "spr_medical_"..private.boxes_content[ private.boxes_open[2] ][i], 0 );
        end;
      end;
    end;
    
    need_close[1] = private.boxes_open[1];
    need_close[2] = private.boxes_open[2];
    
    private.boxes_open[1] = num;
    private.boxes_open[2] = 0;
    --public.changed_name = { "", "" };
    place = true;
    
  end;
  
  if place then
  
    for i = 1, #private.boxes_content[num], 1 do
      local pair_num = private.FindPairInd( string.sub( private.boxes_content[num][i], 1, string.len(private.boxes_content[num][i])-2 ) );
      if private.complete[pair_num] == 0 then
        ObjSet("spr_medical_"..private.boxes_content[num][i],  { input = 1 });
      end;
    end;
    
  end;
  
  cmn.Lock( 1, { room = 1 } );
  
  if place then
    cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_opn_box");
    ObjAnimate("spr_medical_box_"..num.."_closed", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_medical_box_"..num.."_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  else 
    cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_cls_box");
    ObjAnimate("spr_medical_box_"..num.."_closed", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_medical_box_"..num.."_open", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  end;
  
  if need_close[1] > 0 then
    private.CloseBox( need_close );
  end;
  
end;
-----------------------------------------------------------------------------
function private.CloseBox( need_close )
  
  cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_cls_box");

  for i = 1, 2, 1 do
    
    ObjAnimate("spr_medical_box_"..need_close[i].."_closed", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_medical_box_"..need_close[i].."_open", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  end;

end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_num )
  
  if task_num > 0 then

    local task_name = private.item_names[task_num];

    private.ChooseItem( item_name, task_num );
    
  else 
    
    cmn.HoTaskFind("spr_medical_"..item_name, item_name, 2);
    ObjDelete("spr_medical_"..item_name.."_sh");
    
  end;
  
end;
-----------------------------------------------------------------------------
function private.Fly(fly_obj, boxes)

  --cmn.Lock(0);

  cmn.HoTaskFind("obj_medical_"..private.item_names[fly_obj].."_fly", "pairs", 1);

  private.complete[fly_obj] = 1;  
  
  if private.CheckBoxForEmpty( boxes[1] ) then
    
    ObjMultiSet( { {"spr_medical_box_"..boxes[1].."_closed", { input = 0 }},
                   {"spr_medical_box_"..boxes[1].."_open", { input = 0 }} } );
                   
    if private.boxes_open[1] == boxes[1] or private.boxes_open[2] == boxes[1] then             
      ObjAnimate("spr_medical_box_"..boxes[1].."_closed", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_medical_box_"..boxes[1].."_open", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });    
    end;
    
    if private.boxes_open[1] == boxes[1] then
      private.boxes_open[1] = 0;
    elseif private.boxes_open[2] == boxes[1] then
      private.boxes_open[2] = 0;
    end;
    
  end;

  if private.CheckBoxForEmpty( boxes[2] ) then
    
    ObjMultiSet( { {"spr_medical_box_"..boxes[2].."_closed", { input = 0 }},
                   {"spr_medical_box_"..boxes[2].."_open", { input = 0 }} } );
                   
    if private.boxes_open[1] == boxes[2] or private.boxes_open[2] == boxes[2] then             
      ObjAnimate("spr_medical_box_"..boxes[2].."_closed", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_medical_box_"..boxes[2].."_open", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });    
    end;
    
    if private.boxes_open[1] == boxes[2] then
      private.boxes_open[1] = 0;
    elseif private.boxes_open[2] == boxes[2] then
      private.boxes_open[2] = 0;
    end;
    
  end;  

end;
--*********************************************************************************************************************
function private.ChooseItem( item_name, ind )
  
  local pair_num = private.FindPairInd( item_name );
  local full_name = "spr_medical_"..item_name.."_"..ind;

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_menter_ho" );
  
  if private.selected_item ~= "" then

    --pair don't match
    if private.selected_item ~= private.item_names[pair_num] then
      
      local first_item = public.changed_name[1];

      public.changed_name[1] = full_name;
      private.selected_item = item_name;

      private.SelectAnim( first_item, 0 );
      private.SelectAnim( full_name, 1 );

    --found right pair
    elseif private.selected_item == private.item_names[pair_num] and public.changed_name[1] ~= full_name then

      public.changed_name[2] = full_name;
      private.selected_item = "";
      private.FounPairAnim( pair_num );

    --cancel selection
    elseif public.changed_name[1] == full_name then
    
      public.changed_name[1] = "";
      private.selected_item = "";

      private.SelectAnim( full_name, 0 );

    end;

  --first selected
  else 
  
    public.changed_name[1] = full_name;
    private.selected_item = private.item_names[pair_num];
    private.SelectAnim( full_name, 1 );

  end;

end;
-----------------------------------------------------------------------------
function private.FounPairAnim( ind )

  private.selected_item = "";
  private.SelectAnim( public.changed_name[1], 0 );

  local len = string.len(public.changed_name[1]);
  local ind1 = tonumber(string.sub(public.changed_name[1], len, len));
  local ind2 = 2;
  local name_1 = public.changed_name[1];
  local name_2 = public.changed_name[2];

  if ind1 == 2 then
    ind2 = 1;
  end;
  
  local boxes = {0, 0};
  boxes[1] = private.boxes_open[1];
  boxes[2] = private.boxes_open[2];
  
  local func_after = function ()
    --!!!обязательно удалить найденные предметы
    ObjDelete(name_1);
    ObjDelete(name_2);
    private.Fly(ind, boxes);
  end;

  ObjAttach(public.changed_name[1], "obj_medical_items_fly");
  ObjAttach(public.changed_name[2], "obj_medical_items_fly");

  ObjMultiSet( { {public.changed_name[1], { input = 0 }},
                 {public.changed_name[2], { input = 0 }} } );

  ObjAnimate(public.changed_name[1], "pos_xy", 0, 0, func_after, 
  { 
    0, 0, private.items_pos[ind][ind1][1], private.items_pos[ind][ind1][2],
    0.5, 0, private.items_pos[ind][3][1], private.items_pos[ind][3][2]
  });

  ObjAnimate(public.changed_name[2], "pos_xy", 0, 0, "", { 0, 0, private.items_pos[ind][ind2][1], private.items_pos[ind][ind2][2],
                                                         0.5, 0, private.items_pos[ind][3][1], private.items_pos[ind][3][2] });

  ObjAnimate(public.changed_name[1], "alp", 0, 0, "", { 0, 0, 1,  0.4, 0, 1,    0.6, 0, 0 });
  ObjAnimate(public.changed_name[2], "alp", 0, 0, "", { 0, 0, 1,  0.4, 0, 1,    0.6, 0, 0 });

  ObjAnimate(public.changed_name[1].."_sh", "alp", 0, 0, "", { 0, 0, 1,  0.2, 0, 0 });
  ObjAnimate(public.changed_name[2].."_sh", "alp", 0, 0, "", { 0, 0, 1,  0.2, 0, 0 });

  public.changed_name[1] = "";
  public.changed_name[2] = "";

end;
-----------------------------------------------------------------------------
function private.SelectAnim( name, inout )

  if inout == 1 then

    ObjAttach(name, "obj_medical_items_fly");
    ObjAnimate( name, "scale_xy", 1, 0, "", { 0, 2, 1, 1,   0.4, 2, 1.2, 1.2,   0.8, 1, 1, 1 });

  else 

    ObjAttach(name, "ho_medical");
    ObjStopAnimate(name, "scale_xy");
    local cur_scale = ObjGet(name).scale_x
    ObjAnimate( name, "scale_xy", 0, 0, "", { 0, 0, cur_scale, cur_scale,   0.15, 0, 1, 1 });

  end;

end;
-----------------------------------------------------------------------------
function private.FindPairInd( name )
  
  local ind = 0;
  
  for i = 1, #private.item_names, 1 do
    
    if private.item_names[i] == name then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------
function private.CheckBoxForEmpty( num )
  
  local check = true;
  local ind = 0;
  
  if num ~= 0 then
  
    for i = 1, #private.boxes_content[num], 1 do
      
      ind = private.FindPairInd( string.sub(private.boxes_content[num][i], 1, string.len(private.boxes_content[num][i])-2));
      
      if private.complete[ind] == 0 then
        check = false;
        break;
      end;
      
    end;
    
  end;
  
  return check;
  
end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.stages_task()

  local ho_tasks = {};

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage[1] == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "pairs", 12, 0, { { "spr_medical_rope_1" },
                                                            { "spr_medical_brush_1" },
                                                            { "spr_medical_sponge_1" },
                                                            { "spr_medical_pen_1" },
                                                            { "spr_medical_mask_1" },
                                                            { "spr_medical_roller_1" },
                                                            { "spr_medical_clothespin_1" },
                                                            { "spr_medical_soap_1" },
                                                            { "spr_medical_battery_1" },
                                                            { "spr_medical_bulb_1" },
                                                            { "spr_medical_paperboat_1" },
                                                            { "spr_medical_scotchtape_1" } } );

  elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage[1] == 2 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "key",  1, 0, { { "spr_medical_key" } } );

  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_1()

  

end;
------------------------------------------------------------------------------
function public.stage_2()

  game.medical.double_hint = nil;

  local func_after = function ()

    ObjSet( "spr_medical_key", { input = 1 } );

  end;

  local ho_tasks = private.stages_task();

  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_opn_box");

  ObjAnimate("spr_medical_box_7_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_medical_box_7_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
end;
--****************************************************************************************************************