-- name=mg_invendingmachine
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_invendingmachine";
  --------------------------------------------------------------------------------------------
  --pos_xy for food
  private.grid_pos = { 
    { {292, 83}, {386, 83}, {480, 83}, {574, 83}, {668, 83}, {761, 83} },
    { {292, 176}, {386, 176}, {480, 176}, {574, 176}, {668, 176}, {761, 176} },
    { {292, 269}, {386, 269}, {480, 269}, {574, 269}, {668, 269}, {761, 269} },
    { {292, 363}, {386, 363}, {480, 363}, {574, 363}, {668, 363}, {761, 363} },
    { {292, 456}, {386, 456}, {480, 456}, {574, 456}, {668, 456}, {761, 456} },
    { {292, 552}, {386, 552}, {480, 552}, {574, 552}, {668, 552}, {761, 552} }
  };
  --grid size
  private.grid_max = { 6, 6 };
  
  --places for move
  private.move_dir = { {-1, 0}, {0, -1}, {1, 0}, {0, 1} };
  
  private.chosen = 0;
  private.win_state = { {6, 1}, {4, 2}, {2, 4}, {1, 6} };
  private.start_state = { {2, 4}, {1, 6}, {4, 2}, {6, 1} };
  
  private.process = false;
  --------------------------------------------------------------------------------------------
  -- function get_giftegg () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_giftegg" ] = {
      type = "get",
      get_obj = "spr_invendingmachine_giftegg",
      room = "rm_nearhospital",
      zz = "mg_invendingmachine",
      zz_gate = "gmg_nearhospital_invendingmachine"
  };
  --------------------------------------------------------------------------------------------
  local get_giftegg_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_giftegg", "spr_invendingmachine_giftegg" );
  
  end;
  local get_giftegg_end = function ()
  
    ObjDelete( "gfx_invendingmachine_giftegg" );
  
  end;
  local get_giftegg_loc = function ()
  
    ObjDelete( "gmg_nearhospital_invendingmachine" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_giftegg", get_giftegg_inv );
  cmn.AddSubscriber( "get_giftegg", get_giftegg_end, private.room_objname );
  cmn.AddSubscriber( "get_giftegg", get_giftegg_loc, "rm_nearhospital" );

  --------------------------------------------------------------------------------------------
  -- function win_invendingmachine () end;
  --------------------------------------------------------------------------------------------
  --game.hint[ "win_invendingmachine" ] = {
  --  type = "win",
  --  room = "rm_nearhospital",
  --  zz = "mg_invendingmachine",
  --  zz_gate = "gmg_nearhospital_invendingmachine"
  --};
  --------------------------------------------------------------------------------------------
  local win_invendingmachine = function ()

    if cmn.IsEventDone( "win_invendingmachine" ) then
      ObjMultiSet( { {"anm_invendingmachine_win", { frame = 300, input = 1 }},
                     {"obj_invendingmachine_buttons", { input = 0 }},
                     {"obj_invendingmachine_game", { input = 0 }} } );
    end;

  end;
--  local win_invendingmachine_loc = function ()
--
--  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_invendingmachine", win_invendingmachine, "mg_invendingmachine" );
--  cmn.AddSubscriber( "win_invendingmachine", win_invendingmachine_loc, "rm_nearhospital" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_invendingmachine" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_invendingmachine");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_nearhospital" );
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state;
    
    private.DrawScene();
    
    ObjSet("grm_invendingmachine_nearhospital",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                                   event_menter = function () rm_extra.GateMouseEnter( "invendingmachine_nearhospital", CURSOR_DOWN, "extra" ); end, 
                                                   event_mleave = function () common_impl.GateMouseLeave( "invendingmachine_nearhospital" ); end });
    
  end;
    
  private.DrawScene();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_invendingmachine" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_invendingmachine" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = 0;
  
  if private.chosen > 0 then
    local func_after = function() 
      ObjAttach("spr_invendingmachine_food_"..private.chosen, "obj_invendingmachine_game"); 
      ObjSet("obj_invendingmachine_movement",  { input = 0 });
    end;
    local num = private.chosen;
    private.chosen = 0;
    need_r = 0.3;
    ObjAnimate("spr_invendingmachine_food_"..num, "scale_xy", 0, 0, func_after, { 0, 0, 1.2, 1.2,   0.3, 0, 1, 1 });
    ObjAnimate("spr_invendingmachine_food_"..num.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  for i = 1, #private.start_state, 1 do
    
    if private.start_state[i][1] ~= private.state[1][i][1] or private.start_state[i][2] ~= private.state[1][i][2] then
      
      if need_r < 1 then
        need_r = 1;
      end;
      
      local func_after = function ()
        
        ObjSet("spr_invendingmachine_food_"..i,  { 
          pos_x = private.grid_pos[ private.start_state[i][2] ][ private.start_state[i][1] ][1], 
          pos_y = private.grid_pos[ private.start_state[i][2] ][ private.start_state[i][1] ][2] 
        });
        
        ObjAnimate("spr_invendingmachine_food_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
      ObjAnimate("spr_invendingmachine_food_"..i, "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      
      if private.state[2][i] == 1 then
        ObjAnimate("spr_invendingmachine_food_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
    end;
    
  end;
  
  if need_r > 0 then
    
    cmn.Lock(1);
    
    private.StartConditions();
  
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state;
    ObjSet("tmr_invendingmachine_timer",  { time = need_r, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state = { { {6, 1}, {4, 2}, {2, 4}, {1, 6} }, { 1, 1, 1, 1 } };
  
  local anm_win = { 0, 0, 0, 0 };
  
  if private.chosen > 0 then
    ObjAnimate("spr_invendingmachine_food_"..private.chosen, "scale_xy", 0, 0, "", { 0, 0, 1.2, 1.2,   0.3, 0, 1, 1 });
    ObjAnimate("spr_invendingmachine_food_"..private.chosen.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  for i = 1, #private.win_state, 1 do
    
    if private.win_state[i][1] ~= private.state[1][i][1] or private.win_state[i][2] ~= private.state[1][i][2] then
      
      local func_after = function ()
        
        ObjAttach("spr_invendingmachine_food_"..i, "obj_invendingmachine_game");
        
        ObjSet("spr_invendingmachine_food_"..i,  { 
          pos_x = private.grid_pos[ private.win_state[i][2] ][ private.win_state[i][1] ][1], 
          pos_y = private.grid_pos[ private.win_state[i][2] ][ private.win_state[i][1] ][2] 
        });
        
        ObjAnimate("spr_invendingmachine_food_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
        if anm_win[i] == 1 then
          ObjAnimate("spr_invendingmachine_food_"..i.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        end;
        
      end;
      
      if private.state[2][i] == 0 then
        anm_win[i] = 1;
      end;
      
      ObjAnimate("spr_invendingmachine_food_"..i, "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  end;
  
  local play_snd = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
    ObjSet("tmr_invendingmachine_timer",  { time = 0.5, playing = 1, endtrig = private.Win });
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state;
  ObjSet("tmr_invendingmachine_timer",  { time = 0.5, playing = 1, endtrig = play_snd });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_giftegg()

  cmn.SetEventDone( "get_giftegg" );
  cmn.CallEventHandler( "get_giftegg" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  cmn.GotoRoom("rm_nearhospital");

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].state = { { {2, 4}, {1, 6}, {4, 2}, {6, 1} }, { 0, 0, 0, 0 } }; --food positions

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, #private.state[1], 1 do
    
    ObjSet("spr_invendingmachine_food_"..i,  { 
      pos_x = private.grid_pos[ private.state[1][i][2] ][ private.state[1][i][1] ][1], 
      pos_y = private.grid_pos[ private.state[1][i][2] ][ private.state[1][i][1] ][2] 
    });
    
    if private.state[2][i] == 1 then
      ObjSet("spr_invendingmachine_food_"..i.."_win",  { alp = 1 });
    end;
    
  end;
  
  if ng_global.currentprogress == "secret" and private.chosen ~= 0 then
    ObjAttach("spr_invendingmachine_food_"..private.chosen, "obj_invendingmachine_game"); 
    ObjMultiSet( { {"obj_invendingmachine_movement", { input = 0 }},
                   {"spr_invendingmachine_food_"..private.chosen, { scale_x = 1, scale_y = 1 }},
                   {"spr_invendingmachine_food_"..private.chosen.."_on", { alp = 0 }} } );
    private.chosen = 0;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusButton( type, num, inout )
  
  local obj = "spr_invendingmachine_button_"..type.."_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
-----------------------------------------------------------------------------------
function public.FocusFood( num, inout )
  
  local obj = "spr_invendingmachine_food_"..num.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  if private.chosen ~= num and not private.process then
    ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  end;

end;
-----------------------------------------------------------------------------------
function public.ChooseItem( num, nolock, onanim )
  
  private.process = true;
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_map");
  
  nolock = nolock or false;
  onanim = onanim or false;
  
  --if not nolock and not onanim then
  --  ObjAnimate("spr_invendingmachine_button_choose_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0,  0.3, 0, 1 });
  --end;
  
  if private.chosen == 0 or private.chosen ~= num then
    
    local func_after = function ()
      
      private.process = false;
      
      if not nolock then
        cmn.Lock( 0 );
      end;
      ObjSet("obj_invendingmachine_movement",  { input = 1 });
      
    end;
    
    local old = private.chosen;
    private.chosen = num;
    
    ObjAttach("spr_invendingmachine_food_"..num, "obj_invendingmachine_game_fly");
    ObjAnimate("spr_invendingmachine_food_"..num, "scale_xy", 0, 0, func_after, { 0, 0, 1, 1,   0.3, 0, 1.2, 1.2 });
    
    if not onanim then
      ObjAnimate("spr_invendingmachine_food_"..num.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    if old > 0 then
      ObjAttach("spr_invendingmachine_food_"..old, "obj_invendingmachine_game");
      ObjAnimate("spr_invendingmachine_food_"..old, "scale_xy", 0, 0, "", { 0, 0, 1.2, 1.2,   0.3, 0, 1, 1 });
      ObjAnimate("spr_invendingmachine_food_"..old.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  elseif private.chosen == num then
    
    local func_after = function ()
      
      private.process = false;
      
      if not nolock then
        cmn.Lock( 0 );
      end;
      ObjSet("obj_invendingmachine_movement",  { input = 0 });
      
    end;
    
    private.chosen = 0;
    
    ObjAttach("spr_invendingmachine_food_"..num, "obj_invendingmachine_game");
    ObjAnimate("spr_invendingmachine_food_"..num, "scale_xy", 0, 0, func_after, { 0, 0, 1.2, 1.2,   0.3, 0, 1, 1 });
    ObjAnimate("spr_invendingmachine_food_"..num.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.MoveItem( dir )
  
  cmn.Lock(1);
  
  local dx = private.move_dir[dir][1];
  local dy = private.move_dir[dir][2];
  
  ObjAnimate("spr_invendingmachine_button_move_"..dir.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1,  0.3, 0, 0 });
  
  local end_pos = private.CheckDirection( dir, private.chosen );
  
  if private.chosen > 0 and end_pos > 0 then
    
    local end_pc, start_pc, move, tme, pos, move_d;
    
    if dx == 0 then
      move = "pos_y";
      tme = 0.3*math.abs(end_pos-private.state[1][ private.chosen ][2]);
      end_pc = private.grid_pos[ end_pos ][ private.state[1][ private.chosen ][1] ][2];
      start_pc = private.grid_pos[ private.state[1][ private.chosen ][2] ][ private.state[1][ private.chosen ][1] ][2];
      pos = private.state[1][ private.chosen ][2];
      move_d = dy;
      private.state[1][ private.chosen ][2] = end_pos;
    else 
      move = "pos_x";
      tme = 0.3*math.abs(end_pos-private.state[1][ private.chosen ][1]);
      end_pc = private.grid_pos[ private.state[1][ private.chosen ][2] ][ end_pos ][1];
      start_pc = private.grid_pos[ private.state[1][ private.chosen ][2] ][ private.state[1][ private.chosen ][1] ][1];
      pos = private.state[1][ private.chosen ][1];
      move_d = dx;
      private.state[1][ private.chosen ][1] = end_pos;
    end;
    
    private.PlayMoveSound( pos, end_pos, move_d );
    
    ObjAnimate("spr_invendingmachine_food_"..private.chosen, move, 0, 0, function() private.CheckWin(); end, { 0, 0, start_pc,   tme, 0, end_pc });
    
  elseif private.chosen > 0 then
    
    ObjAnimate("spr_invendingmachine_food_"..private.chosen, "ang", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.2, 0, -0.1,   0.4, 0, 0.1,  0.6, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.PlayMoveSound( pos, end_p, dir )
  
  pos = pos + dir;
  
  cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_xx_button2");
  
  if dir > 0 and pos < end_p or dir < 0 and pos > end_p then
    ObjSet("tmr_invendingmachine_timer",  { time = 0.3, playing = 1, endtrig = function() private.PlayMoveSound( pos, end_p, dir ); end });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckDirection( dir, food )
  
  local dx = private.move_dir[dir][1];
  local dy = private.move_dir[dir][2];
  
  local final = 0;
  local variants = {};
  local inc = 1;
  
  if dx == 0 then
    
    local end_point = private.grid_max[2];
    if dy < 0 then
      end_point = 1;
    end;
    
    for i = private.state[1][food][2], end_point, dy do
      for j = 1, 4, 1 do
        
        if j ~= food and private.state[1][j][2] == i and private.state[1][j][1] == private.state[1][food][1] then
          variants[inc] = i-dy;
          inc = inc + 1;
        end;
        
      end;
    end;
    
    for i = 1, #variants, 1 do
      
      if dy < 0 and variants[i] > end_point or dy > 0 and variants[i] < end_point then
        end_point = variants[i];
      end;
      
    end;
    
    --DbgTrace(end_point);
    
    if dy < 0 and end_point < private.state[1][food][2] then
      final = end_point;
    elseif dy > 0 and end_point > private.state[1][food][2] then
      final = end_point;
    end;
    
  else 
    
    local end_point = private.grid_max[1];
    if dx < 0 then
      end_point = 1;
    end;
    
    for i = private.state[1][food][1], end_point, dx do
      for j = 1, 4, 1 do
        
        if j ~= food and private.state[1][j][1] == i and private.state[1][j][2] == private.state[1][food][2] then
          variants[inc] = i-dx;
          inc = inc + 1;
        end;
        
      end;
    end;
    
    for i = 1, #variants, 1 do
      
      if dx < 0 and variants[i] > end_point or dx > 0 and variants[i] < end_point then
        end_point = variants[i];
      end;
      
    end;
    
    --DbgTrace(end_point);
    
    if dx < 0 and end_point < private.state[1][food][1] then
      final = end_point;
    elseif dx > 0 and end_point > private.state[1][food][1] then
      final = end_point;
    end;
    
  end;
  
  return final;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = 0;
  local anm_flag = false;
  local anm_win = false;
  
  for i = 1, #private.win_state, 1 do
    
    if private.win_state[i][1] == private.state[1][i][1] and private.win_state[i][2] == private.state[1][i][2] then
      
      win_flag = win_flag + 1;
      
      if private.state[2][i] == 0 then
        
        anm_flag = true;
        anm_win = true;
        private.state[2][i] = 1;
        ObjAnimate("spr_invendingmachine_food_"..i.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 0,    0.5, 0, 1 });
        
      end;
      
    elseif private.state[2][i] == 1 then
        
      anm_flag = true;
      private.state[2][i] = 0;
      ObjAnimate("spr_invendingmachine_food_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        
    end;
    
  end;
  
  if win_flag == 4 then
    
    cmn.Lock(1);
    
    public.ChooseItem( private.chosen, true ); 
    
    ObjSet("tmr_invendingmachine_timer",  { time = 0.5, playing = 1, endtrig = private.Win });
    
  elseif anm_flag then
    
    cmn.Lock(1);
    
    if anm_win then
      cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
    end;
    
    ObjSet("tmr_invendingmachine_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  else 
    
    ObjSet("tmr_invendingmachine_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.Lock(0);

  cmn.SetEventDone( "win_invendingmachine" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_invendingmachine" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_invendingmachine" ].skip == 0 and not ng_global.noskipgames[ "win_invendingmachine" ] then

      ng_global.noskipgames[ "win_invendingmachine" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_invendingmachine" ] then
      ng_global.playedgames[ "win_invendingmachine" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  if ng_global.currentprogress == "std" then
    
    cmn.MiniGameHide();
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_take_egg");
    
    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_invendingmachine" );
    
    ObjSet("anm_invendingmachine_win",  { playing = 1, endtrig = private.WinEnd });
    
  else 
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    private.WinEnd();
  end;

end;
--***************************************************************************************************************