-- name=mg_onmagicstone
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onmagicstone";
  --------------------------------------------------------------------------------------------
  private.stones_pos = { 
    {510, 68}, {724, 118}, {799, 203}, {831, 313}, {798, 421}, {722, 504}, {621, 558}, 
    {510, 574}, {396, 558}, {293, 504}, {221, 418}, {192, 312}, {219, 201}, {296, 116} 
  };
  private.stone_names = { 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
  private.current_stone = 0;
  private.vacant_place = 0;
  private.anim_time = 0.3;
  
  private.start = { 1, 3, 8, 12, 7, 2, 10, 4, 14, 9, 6, 11, 5, 13 };
  private.in_play = false;
  --------------------------------------------------------------------------------------------
  -- function get_bell2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bell2" ] = {
      type = "get",
      get_obj = "spr_onmagicstone_bell2",
      room = "rm_forestthicket",
      zz = "mg_onmagicstone",
      zz_gate = "gmg_forestthicket_onmagicstone"
  };
  --------------------------------------------------------------------------------------------
  local get_bell2_inv = function ()
  
    interface.InventoryItemAdd( "inv_bell2", "spr_onmagicstone_bell2" );
    int_map_impl.DecreaseRoomTasks("rm_forestthicket");
  
  end;
  local get_bell2_end = function ()
  
    ObjDelete( "gfx_onmagicstone_bell2" );
  
  end;
  local get_bell2_loc = function ()

    ObjDelete( "spr_forestthicket_mg_onmagicstone_bell" );
  
    if cmn.IsEventDone("get_crowfigurine") then
      ObjDelete( "gmg_forestthicket_onmagicstone" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bell2", get_bell2_inv );
  cmn.AddSubscriber( "get_bell2", get_bell2_end, private.room_objname );
  cmn.AddSubscriber( "get_bell2", get_bell2_loc, "rm_forestthicket" );
  --------------------------------------------------------------------------------------------
  -- function get_crowfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crowfigurine" ] = {
      type = "get",
      get_obj = "spr_onmagicstone_crowfigurine",
      room = "rm_forestthicket",
      zz = "mg_onmagicstone",
      zz_gate = "gmg_forestthicket_onmagicstone"
  };
  --------------------------------------------------------------------------------------------
  local get_crowfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_crowfigurine", "spr_onmagicstone_crowfigurine" );
    int_map_impl.DecreaseRoomTasks("rm_forestthicket");
  
  end;
  local get_crowfigurine_end = function ()
  
    ObjDelete( "gfx_onmagicstone_crowfigurine" );
  
  end;
  local get_crowfigurine_loc = function ()

    ObjDelete( "spr_forestthicket_mg_onmagicstone_bird" );
  
    if cmn.IsEventDone("get_bell2") then
      ObjDelete( "gmg_forestthicket_onmagicstone" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crowfigurine", get_crowfigurine_inv );
  cmn.AddSubscriber( "get_crowfigurine", get_crowfigurine_end, private.room_objname );
  cmn.AddSubscriber( "get_crowfigurine", get_crowfigurine_loc, "rm_forestthicket" );

  --------------------------------------------------------------------------------------------
  -- function win_onmagicstone () end;
  --------------------------------------------------------------------------------------------
  --game.hint[ "win_onmagicstone" ] = {
  --  type = "win",
  --  room = "rm_forestthicket",
  --  zz = "mg_onmagicstone",
  --  zz_gate = "gmg_forestthicket_onmagicstone"
  --};
  --------------------------------------------------------------------------------------------
  local win_onmagicstone = function ()

    if cmn.IsEventDone( "win_onmagicstone" ) then
      ObjMultiSet( { {"obj_onmagicstone_game", { input = 0 }},
                     {"obj_onmagicstone_play", { input = 0 }},
                     {"spr_onmagicstone_crowfigurine", { input = 1 }},
                     {"spr_onmagicstone_bell2", { input = 1 }},
                     {"anm_onmagicstone_stone_open", { frame = 700 }} } );
      --ObjDelete("anm_onmagicstone_stone_open");
    end;

  end;
  local win_onmagicstone_loc = function ()

    if cmn.IsEventDone( "win_onmagicstone" ) then

      ObjDelete( "spr_forestthicket_mg_onmagicstone2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_onmagicstone", win_onmagicstone, "mg_onmagicstone" );
  cmn.AddSubscriber( "win_onmagicstone", win_onmagicstone_loc, "rm_forestthicket" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_onmagicstone" )) then
    
    cmn.MiniGameShow();
    --private.CheckWin();
    cmn.StartTimePassing("mg_onmagicstone");
    
    if private.CheckWin() then
      public.PlayAnim();
    end;
    
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_forestthicket_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_forestthicket_env");
  
  if ng_global.currentprogress == "std" then

    common.SetPreviousRoom( "rm_forestthicket" );
    private.DrawScene();
    
    if not(cmn.IsEventDone( "win_onmagicstone" )) and private.CheckWin() then
      cmn.Lock(1);
    end;
    
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state;
    
    private.DrawScene();
    
    ObjSet("grm_onmagicstone_forestthicket",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                                event_menter = function () rm_extra.GateMouseEnter( "onmagicstone_forestthicket", CURSOR_DOWN, "extra" ); end, 
                                                event_mleave = function () common_impl.GateMouseLeave( "onmagicstone_forestthicket" ); end });
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_onmagicstone" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_onmagicstone" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  
  local need_r = false;
  local max_tme = 0;
  
  for i = 1, 14, 1 do
    
    if private.state[i] ~= private.start[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local new_pos = 0;
      
      for j = 1, 14, 1 do
        
        if private.state[i] == private.start[j] then
          new_pos = j;
          break;
        end;
        
      end;
      
      if new_pos > 0 then
        
        local point_a, point_b = {}, {};
        point_a[1] = private.stones_pos[ i ][1];
        point_a[2] = private.stones_pos[ i ][2];
        point_b[1] = private.stones_pos[ new_pos ][1];
        point_b[2] = private.stones_pos[ new_pos ][2];
        local len = common_impl.math.FindSegmentLength( point_a, point_b );
        local tme = 0.001 * len;
        
        if tme > max_tme then
          max_tme = tme;
        end;
        
        local func_after = function ( num ) ObjAttach("spr_onmagicstone_stone_"..num, "obj_onmagicstone_game"); end;
        
        ObjAttach("spr_onmagicstone_stone_"..private.state[i], "obj_onmagicstone_game_drag");
        ObjAnimate("spr_onmagicstone_stone_"..private.state[i], "pos_xy", 0, 0, function() func_after(private.state[i]); end, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
        
      end;
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state;
    
    ObjSet("tmr_onmagicstone_timer",  { time = max_tme, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 };
  
  local max_tme = 0;
  
  for i = 1, 14, 1 do
    
    if private.state[i] ~= i then
      
      if not need_r then
        need_r = true;
      end;
      
      local new_pos = private.state[i];
      
      if new_pos > 0 then
        
        local point_a, point_b = {}, {};
        point_a[1] = private.stones_pos[ i ][1];
        point_a[2] = private.stones_pos[ i ][2];
        point_b[1] = private.stones_pos[ new_pos ][1];
        point_b[2] = private.stones_pos[ new_pos ][2];
        local len = common_impl.math.FindSegmentLength( point_a, point_b );
        local tme = 0.001 * len;
        
        if tme > max_tme then
          max_tme = tme;
        end;
        
        local func_after = function ( num ) ObjAttach("spr_onmagicstone_stone_"..num, "obj_onmagicstone_game"); end;
        
        ObjAttach("spr_onmagicstone_stone_"..private.state[i], "obj_onmagicstone_game_drag");
        ObjAnimate("spr_onmagicstone_stone_"..private.state[i], "pos_xy", 0, 0, function() func_after(private.state[i]); end, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
        
      end;
      
    end;
    
  end;
    
  ObjStopAnimate("spr_onmagicstone_play_on", "alp");
  ObjAnimate("spr_onmagicstone_play_on", "alp", 0, 0, "", { 0, 0, ObjGet("spr_onmagicstone_play_on").alp,   0.3, 0, 0 });
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state;
  ObjSet("tmr_onmagicstone_timer",  { time = max_tme, playing = 1, endtrig = public.PlayAnim });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_bell2()

  cmn.SetEventDone( "get_bell2" );
  cmn.CallEventHandler( "get_bell2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crowfigurine") then
    cmn.GotoRoom("rm_forestthicket");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crowfigurine()

  cmn.SetEventDone( "get_crowfigurine" );
  cmn.CallEventHandler( "get_crowfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_bell2") then
    cmn.GotoRoom("rm_forestthicket");
  end;

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state = { 1, 3, 8, 12, 7, 2, 10, 4, 14, 9, 6, 11, 5, 13 }; --порядок камней

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 2, 14, 1 do
    
    ObjSet("spr_onmagicstone_stone_"..private.state[i],  { pos_x = private.stones_pos[i][1], pos_y = private.stones_pos[i][2] });
    
  end;
  
  if not cmn.IsEventDone("win_onmagicstone") and not private.CheckWin() then
    private.AnmPlayButton();
  end;
  
  if ng_global.currentprogress == "secret" then
    
    for i = 2, 14, 1 do
      ObjSet("spr_onmagicstone_stone_1_"..i,  { alp = 0 });
    end;
    
    ObjMultiSet( { {"anm_onmagicstone_stone_open", { frame = 0 }},
                   {"obj_onmagicstone_game", { input = 1 }} } );
    
  end;

end;
-----------------------------------------------------------------------------------
function private.AnmPlayButton()
  
  ObjSet("spr_onmagicstone_play_on",  { alp = 0 });
  ObjAnimate("spr_onmagicstone_play_on", "alp", 1, 0, "", { 0, 0, 0,   0.8, 0, 1,     1.2, 0, 1,    2, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function public.FocusPlay( inout )
  
  local obj = "spr_onmagicstone_play_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;
  
  local func_after = function ()
    
    if inout == 0 and not private.in_play then
      private.AnmPlayButton();
    end;
    
  end;
    
  ObjStopAnimate(obj, "alp");

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, func_after, { 0, 2, alf,   tme, 2, inout });

end;
-----------------------------------------------------------------------------------
function public.PlayAnim()
  
  private.in_play = true;
  cmn.Lock(1);
  
  local func_after = function () 
    private.in_play = false;
    cmn.Lock(0); 
    private.AnmPlayButton();
  end;
  
  if private.CheckWin() then
    ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 };
    func_after = private.Win;
  end;
  
  ObjAnimate("obj_onmagicstone_play", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0,   0.3, 0, 1 });
  
  for i = 1, 14, 1 do
    
    private.MoveStone( private.state[i], i, i );
    ObjSet("spr_onmagicstone_stone_1_"..i,  { res = "assets/levels/level2/mg_onmagicstone/stone_"..private.stone_names[ private.state[i] ] });
    
  end;
  
  private.PlayMainAnim( 1 );
  ObjSet("tmr_onmagicstone_timer",  { time = private.anim_time*14, playing = 1, endtrig = func_after });

  cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_clk_ring");

end;
-----------------------------------------------------------------------------------
function private.PlayMainAnim( num )
  
  if not private.CheckWin() then
  
    if num < 14 then
      
      ObjAnimate("spr_onmagicstone_stone_1_"..(num+1), "alp", 0, 0, function() private.PlayMainAnim( num+1 ); end, { 0, 0, 0,   0.3, 0, 1 });
      
    else 
      
      for i = 2, 13, 1 do
        ObjSet("spr_onmagicstone_stone_1_"..i,  { alp = 0 });
      end;
      
      ObjAnimate("spr_onmagicstone_stone_1_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  else 
    
    if num < 13 then
      
      ObjAnimate("spr_onmagicstone_stone_1_"..(num+1), "alp", 0, 0, function() private.PlayMainAnim( num+1 ); end, { 0, 0, 0,   0.3, 0, 1 });
      
    else 
      
      ObjAnimate("spr_onmagicstone_stone_1_"..(num+1), "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.MoveStone( num, pos, old_pos )
  
  local new_pos = pos - 1;
  if new_pos == 0 then
    new_pos = 14;
  end;
  
  local func_after = function() private.MoveStone( num, new_pos, old_pos ) end;
    
  --if num == 14 then
  --  DbgTrace(num.." ".." "..new_pos.." "..old_pos);
  --end;
    
  if new_pos == old_pos or ( private.CheckWin() and (new_pos == old_pos+1 or num == 14 and new_pos == 1) ) then
    func_after = "";
  end;
    
  ObjAnimate("spr_onmagicstone_stone_"..num, "pos_xy", 0, 0, func_after, 
  {                  0, 0, private.stones_pos[pos][1], private.stones_pos[pos][2],
     private.anim_time, 0, private.stones_pos[new_pos][1], private.stones_pos[new_pos][2]
  });
   
  --if new_pos == 14 then
  --  ObjAnimate("spr_onmagicstone_stone_"..num, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   private.anim_time, 0, 0.5, 0.5 });
  --elseif new_pos == 1 then
  --  ObjAnimate("spr_onmagicstone_stone_"..num, "scale_xy", 0, 0, "", { 0, 0, 0.5, 0.5,   private.anim_time, 0, 1, 1 });
  --end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusStone( num, inout )
  --[[
  local obj = "spr_onmagicstone_stone_"..num.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_menter_stone");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  ]]
end;
-----------------------------------------------------------------------------------
function public.DragStone( num, second )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  if private.current_stone == 0 then
    
    for i = 1, 14, 1 do
      
      if private.state[i] == num then
        private.vacant_place = i;
        break
      end;
      
    end;
    
  end;
  
  private.current_stone = num;
  
  --public.FocusStone( num, 0 );
  
  ObjAttach("spr_onmagicstone_stone_"..num, "obj_onmagicstone_game_drag");
  
end;
-----------------------------------------------------------------------------------
function public.DropStone( num, second )
  
  cmn.Lock(1);
  local second_t = second or nil;
  
  local curspos = GetZoomCursorPos();
  if (second) then
    curspos = private.stones_pos[private.vacant_place];
  else
    if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
  end;
  
    
  local pos = 0;
  
  for i = 2, 14, 1 do

    if (curspos[1] > private.stones_pos[i][1] - 50) and (curspos[1] < private.stones_pos[i][1] + 50) and 
       (curspos[2] > private.stones_pos[i][2] - 50) and (curspos[2] < private.stones_pos[i][2] + 50) then

      pos = i;
      break;
    end;

  end;
  
  if pos == 0 or pos == private.vacant_place then
    
    pos = private.vacant_place;
    
    private.current_stone = 0;
    private.vacant_place = 0;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.stones_pos[ pos ][1];
    point_b[2] = private.stones_pos[ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    end;
    
    ObjAnimate("spr_onmagicstone_stone_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_use_stone2");
        
        private.CheckStone( num, 0,second_t ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  else 
    
    private.current_stone = private.state[ pos ];
    private.state[ pos ] = num;
    private.state[ private.vacant_place ] = private.current_stone;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.stones_pos[ pos ][1];
    point_b[2] = private.stones_pos[ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    end;
    
    ObjAnimate("spr_onmagicstone_stone_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_use_stone2");
        private.CheckStone( num, private.current_stone,second_t ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  end;

end;
-----------------------------------------------------------------------------------
function private.CheckStone( num1, num2, second )
  
  cmn.Lock(0);
  num2 = num2 or 0;
  
  ObjAttach("spr_onmagicstone_stone_"..num1, "obj_onmagicstone_game");
  
  if num2 > 0 then
    if (second == nil) then
      ObjSet("tmr_onmagicstone_drop_timer",{ time = 0.1, playing = true, endtrig = function()
        ObjSet("spr_onmagicstone_stone_"..num2,{ pos_x = private.stones_pos[private.vacant_place][1], pos_y = private.stones_pos[private.vacant_place][2] });
        public.DragStone( num2, true );
        public.DropStone( num2, true );
      end });
    end;
    
    --ObjStartDrag("spr_onmagicstone_stone_"..num2);
  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local check = true;
  
  for i = 1, 14, 1 do
    
    if private.state[i] ~= i then
      check = false;
      break;
    end;
    
  end;
  
  return check;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock(0);
  cmn.SetEventDone( "win_onmagicstone" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_onmagicstone" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_onmagicstone" ].skip == 0 and not ng_global.noskipgames[ "win_onmagicstone" ] then

      ng_global.noskipgames[ "win_onmagicstone" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_onmagicstone" ] then
      ng_global.playedgames[ "win_onmagicstone" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  private.in_play = false;
  
  if ng_global.currentprogress == "std" then
  
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_onmagicstone" );
    
  else 
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    ObjSet("obj_onmagicstone_game",  { input = 0 });
  end;
  
  ObjSet("anm_onmagicstone_stone_open",  { playing = 1, endtrig = private.WinEnd });
  cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_stone_win");

end;
--**************************************************************************************************************