-- name=rm_corridor
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridor";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Liftpanel();
  private.Init_Closetdoor();
  private.Init_Medicalcart();
  private.anim_elevator_process = false;
  --------------------------------------------------------------------------------------------
  -- function get_dollar2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_dollar2" ] = {
      type = "get",
      get_obj = "spr_nurse_dollar2",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local get_dollar2_inv = function ()
  
    interface.InventoryItemAdd( "inv_dollar2", "spr_nurse_dollar2" );
  
  end;
  local get_dollar2_end = function ()
  
    ObjDelete( "gfx_nurse_dollar2" );
    --ObjDelete( "gzz_corridor_nurse" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_dollar2", get_dollar2_inv );
  cmn.AddSubscriber( "get_dollar2", get_dollar2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_accesscard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_accesscard" ] = {
      type = "get",
      get_obj = "spr_nurse_accesscard",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local get_accesscard_inv = function ()
  
    interface.InventoryItemAdd( "inv_accesscard", "spr_nurse_accesscard" );
  
  end;
  local get_accesscard_end = function ()
  
    ObjDelete( "gfx_nurse_accesscard" );
    ObjDelete( "spr_nurse_accesscard_sh" );
    
    ObjDelete( "spr_corridor_nurse_card" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_accesscard", get_accesscard_inv );
  cmn.AddSubscriber( "get_accesscard", get_accesscard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brainamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_brainamulet" ] = {
      type = "get",
      get_obj = "spr_nurse_brainamulet",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local get_brainamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_brainamulet", "spr_nurse_brainamulet" );
  
  end;
  local get_brainamulet_end = function ()
  
    ObjDelete( "gfx_nurse_brainamulet" );
    ObjDelete( "spr_nurse_brainamulet_sh" );
    
    ObjDelete( "spr_corridor_nurse_brain" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brainamulet", get_brainamulet_inv );
  cmn.AddSubscriber( "get_brainamulet", get_brainamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crumpledpackage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crumpledpackage" ] = {
      type = "get",
      get_obj = "spr_nurse_crumpledpackage",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local get_crumpledpackage_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_crumpledpackage", "spr_nurse_crumpledpackage" );
    int_map_impl.DecreaseRoomTasks("rm_corridor");
  
  end;
  local get_crumpledpackage_end = function ()

    ObjAttach( "obj_nurse_cutter", "anm_nurse_trashbox" );
    ObjAttach( "obj_nurse_backlayer_cutter", "anm_nurse_trashbox" );
  
    ObjDelete( "gfx_nurse_crumpledpackage" );
    ObjDelete( "spr_corridor_nurse_nuts" );

    ObjSet("gzz_corridor_nurse",  { alp = 0, active = 0 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crumpledpackage", get_crumpledpackage_inv );
  cmn.AddSubscriber( "get_crumpledpackage", get_crumpledpackage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spiderleg3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spiderleg3" ] = {
      type = "get",
      get_obj = "spr_medicalcart_spiderleg3",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local get_spiderleg3_inv = function ()
  
    interface.InventoryItemAdd( "inv_spiderleg", "spr_medicalcart_spiderleg3", function () cmn.GetMultyObject( 'spiderleg', 3 ); end );
    if cmn.CheckMultiObject( "spiderleg", 3 ) then
      ObjSet("inv_brokenspider_star_light",  { alp = 1 });
    end;
  
  end;
  local get_spiderleg3_end = function ()
  
    ObjDelete( "gfx_medicalcart_spiderleg3" );
    ObjDelete( "spr_medicalcart_spiderleg3_sh" );
    
    ObjDelete( "spr_corridor_medcart_spiderleg" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spiderleg3", get_spiderleg3_inv );
  cmn.AddSubscriber( "get_spiderleg3", get_spiderleg3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_number3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_number3" ] = {
      type = "get",
      get_obj = "spr_medicalcart_number3",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local get_number3_inv = function ()
  
    interface.InventoryItemAdd( "inv_number3", "spr_medicalcart_number3" );
  
  end;
  local get_number3_end = function ()
  
    ObjDelete( "gfx_medicalcart_number3" );
    ObjDelete( "spr_medicalcart_number3_sh" );
    
    ObjDelete( "spr_corridor_medcart_number" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_number3", get_number3_inv );
  cmn.AddSubscriber( "get_number3", get_number3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluecable () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bluecable" ] = {
      type = "get",
      get_obj = "spr_medicalcart_bluecable",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local get_bluecable_inv = function ()
  
    interface.InventoryItemAdd( "inv_bluecable", "spr_medicalcart_bluecable" );
  
  end;
  local get_bluecable_end = function ()
  
    ObjDelete( "gfx_medicalcart_bluecable" );
    ObjDelete( "spr_medicalcart_bluecable_sh" );
    
    ObjDelete( "spr_corridor_medcart_wire" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bluecable", get_bluecable_inv );
  cmn.AddSubscriber( "get_bluecable", get_bluecable_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_switch" ] = {
      type = "get",
      get_obj = "spr_medicalcart_switch",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local get_switch_inv = function ()
  
    interface.InventoryItemAdd( "inv_switch", "spr_medicalcart_switch" );
  
  end;
  local get_switch_end = function ()
  
    ObjDelete( "gfx_medicalcart_switch" );
    ObjDelete( "spr_medicalcart_switch_sh" );
    
    ObjDelete( "spr_corridor_medcart_switch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_switch", get_switch_inv );
  cmn.AddSubscriber( "get_switch", get_switch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicpage5 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpage5" ] = {
      type = "get",
      get_obj = "spr_medicalcart_magicpage5",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpage5_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpage", "spr_medicalcart_magicpage5", function () cmn.GetMultyObject( 'magicpage', 6 ); end );
    int_map_impl.DecreaseRoomTasks("rm_corridor");
  
  end;
  local get_magicpage5_end = function ()
  
    ObjDelete( "gfx_medicalcart_magicpage5" );
    ObjDelete( "spr_medicalcart_magicpage5_sh" );
    
    ObjDelete( "spr_corridor_medcart_page" );
    
    if cmn.IsEventDone("get_windowhandle") then
      ObjDelete( "gzz_corridor_medicalcart" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpage5", get_magicpage5_inv );
  cmn.AddSubscriber( "get_magicpage5", get_magicpage5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_windowhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_windowhandle" ] = {
      type = "get",
      get_obj = "spr_medicalcart_windowhandle",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local get_windowhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_windowhandle", "spr_medicalcart_windowhandle" );
    int_map_impl.DecreaseRoomTasks("rm_corridor");
  
  end;
  local get_windowhandle_end = function ()
  
    ObjDelete( "gfx_medicalcart_windowhandle" );
    
    ObjDelete( "spr_corridor_medcart_handle" );
    
    if cmn.IsEventDone("get_magicpage5") then
      ObjDelete( "gzz_corridor_medicalcart" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_windowhandle", get_windowhandle_inv );
  cmn.AddSubscriber( "get_windowhandle", get_windowhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spiderleg2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spiderleg2" ] = {
      type = "get",
      get_obj = "spr_clothesroomdoor_spiderleg2",
      room = private.room_objname,
      zz = "zz_clothesroomdoor",
      zz_gate = "gzz_corridor_clothesroomdoor"
  };
  --------------------------------------------------------------------------------------------
  local get_spiderleg2_inv = function ()
  
    interface.InventoryItemAdd( "inv_spiderleg", "spr_clothesroomdoor_spiderleg2", function () cmn.GetMultyObject( 'spiderleg', 3 ); end );
    if cmn.CheckMultiObject( "spiderleg", 3 ) then
      ObjSet("inv_brokenspider_star_light",  { alp = 1 });
    end;
  
  end;
  local get_spiderleg2_end = function ()
  
    ObjDelete( "gfx_clothesroomdoor_spiderleg2" );
    ObjDelete( "spr_clothesroomdoor_spiderleg2_sh" );
    
    ObjDelete( "spr_corridor_store_spiderleg" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spiderleg2", get_spiderleg2_inv );
  cmn.AddSubscriber( "get_spiderleg2", get_spiderleg2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_number1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_number1" ] = {
      type = "get",
      get_obj = "spr_warddoor_number1",
      room = private.room_objname,
      zz = "zz_warddoor",
      zz_gate = "gzz_corridor_warddoor"
  };
  --------------------------------------------------------------------------------------------
  local get_number1_inv = function ()
  
    interface.InventoryItemAdd( "inv_number1", "spr_warddoor_number1" );
  
  end;
  local get_number1_end = function ()
  
    ObjDelete( "gfx_warddoor_number1" );
    ObjDelete( "spr_warddoor_number1_sh" );
    
    ObjDelete( "spr_corridor_ward_number" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_number1", get_number1_inv );
  cmn.AddSubscriber( "get_number1", get_number1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bulldogkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bulldogkey" ] = {
      type = "get",
      get_obj = "spr_liftpanel_bulldogkey",
      room = private.room_objname,
      zz = "zz_liftpanel",
      zz_gate = "gzz_corridor_liftpanel"
  };
  --------------------------------------------------------------------------------------------
  local get_bulldogkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulldogkey", "spr_liftpanel_bulldogkey" );
  
  end;
  local get_bulldogkey_end = function ()
  
    ObjDelete( "gfx_liftpanel_bulldogkey" );
    ObjDelete( "gzz_corridor_liftpanel" );
    ObjDelete( "spr_corridor_elevator_bulldog" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bulldogkey", get_bulldogkey_inv );
  cmn.AddSubscriber( "get_bulldogkey", get_bulldogkey_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_lvl2sleepingpills () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2sleepingpills" ] = {
      type = "use",
      inv_obj = "inv_lvl2sleepingpills",
      use_place = "obj_nurse_use_lvl2sleepingpills",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2sleepingpills_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl2sleepingpills" );
  
  end;
  local use_lvl2sleepingpills_beg = function ()
  
    ObjDelete( "obj_nurse_use_lvl2sleepingpills" );
    ObjDelete( "obj_nurse_nurse_touch" );
  
  end;
  local use_lvl2sleepingpills_end = function ()

    ObjDelete( "anm_nurse_sleepingpills" );
    ObjDelete( "anm_corridor_nurse_1" );
  
    ObjMultiSet( { {"spr_nurse_accesscard", { input = 1 }},
                   {"spr_nurse_brainamulet", { input = 1 }},
                   {"gzz_corridor_medicalcart", { alp = 1, input = 1, active = 1 }},
                   {"gzz_corridor_clothesroomdoor", { alp = 1, input = 1, active = 1 }},
                   {"gzz_corridor_warddoor", { alp = 1, input = 1, active = 1 }},
                   {"anm_corridor_nurse_2", { alp = 1 }},
                   {"obj_nurse_asleep_bbt", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2sleepingpills", use_lvl2sleepingpills_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2sleepingpills", use_lvl2sleepingpills_inv );
  cmn.AddSubscriber( "use_lvl2sleepingpills", use_lvl2sleepingpills_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl2sleepingpills_inv", use_lvl2sleepingpills_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl2sleepingpills_beg", use_lvl2sleepingpills_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2sleepingpills_end", use_lvl2sleepingpills_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_horseshoe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_horseshoe" ] = {
      type = "use",
      inv_obj = "inv_horseshoe",
      use_place = "obj_nurse_use_horseshoe",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local use_horseshoe_inv = function ()
  
    interface.InventoryItemRemove( "inv_horseshoe" );
  
  end;
  local use_horseshoe_beg = function ()
  
    ObjDelete( "obj_nurse_use_horseshoe" );
  
  end;
  local use_horseshoe_end = function ()
    
    ObjDelete( "spr_corridor_nurse_moneybox_cover_1" );

    ObjMultiSet( { { "spr_nurse_dollar2", { input = 1 } },
                   { "anm_nurse_moneybox", { animfunc = "func_horseshoe_use", endtrig = "", frame = 54 } },
                   {"spr_corridor_nurse_moneybox_cover_2", { alp = 1 }} } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_horseshoe", use_horseshoe_beg, private.room_objname );
  cmn.AddSubscriber( "use_horseshoe", use_horseshoe_inv );
  cmn.AddSubscriber( "use_horseshoe", use_horseshoe_end, private.room_objname );
  cmn.AddSubscriber( "use_horseshoe_inv", use_horseshoe_inv, private.room_objname );
  cmn.AddSubscriber( "use_horseshoe_beg", use_horseshoe_beg, private.room_objname );
  cmn.AddSubscriber( "use_horseshoe_end", use_horseshoe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cutters () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cutters" ] = {
      type = "use",
      inv_obj = "inv_cutters",
      use_place = "obj_nurse_use_cutters",
      room = private.room_objname,
      zz = "zz_nurse",
      zz_gate = "gzz_corridor_nurse"
  };
  --------------------------------------------------------------------------------------------
  local use_cutters_inv = function ()
  
    interface.InventoryItemRemove( "inv_cutters" );
  
  end;
  local use_cutters_beg = function ()
  
    ObjDelete( "obj_nurse_use_cutters" );

    ObjAttach( "gfx_nurse_crumpledpackage", "spr_nurse_crumpledpackage" );
    ObjSet( "gfx_nurse_crumpledpackage", { pos_x = 0, pos_y = 0 } );
  
  end;
  local use_cutters_end = function ()
  
    ObjSet( "anm_nurse_trashbox", { animfunc = "func_cutter_use", endtrig = "", playing = false, frame = 112 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cutters", use_cutters_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters", use_cutters_inv );
  cmn.AddSubscriber( "use_cutters", use_cutters_end, private.room_objname );
  cmn.AddSubscriber( "use_cutters_inv", use_cutters_inv, private.room_objname );
  cmn.AddSubscriber( "use_cutters_beg", use_cutters_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters_end", use_cutters_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_screwdrivercart" ] = {
      type = "use",
      inv_obj = "inv_screwdriver",
      use_place = "obj_medicalcart_use_screwdriver",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
    
  game.hint[ "use_screwdrivercloset" ] = {
      type = "use",
      inv_obj = "inv_screwdriver",
      use_place = "obj_maidsclothes_use_screwdriver",
      room = "rm_clothesroom",
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local use_screwdriver_inv1 = function ()
  
    if cmn.IsEventDone("use_screwdrivercloset") then
      interface.InventoryItemRemove( "inv_screwdriver" );
    end;
  
  end;
  local use_screwdriver_beg1 = function ()
  
    ObjDelete( "obj_medicalcart_use_screwdriver" );
    ObjDelete( "anm_medicalcart_screw_touch" );
  
  end;
  local use_screwdriver_end1 = function ()
  
    ObjMultiSet( { {"anm_medicalcart_use_screwdriver", { alp = 1, frame = 400 }},
                   {"obj_medicalcart_clk_cartrollsaway", { input = 1 }} } );
  
  end;
  
  local use_screwdriver_inv2 = function ()
  
    if cmn.IsEventDone("use_screwdrivercart") then
      interface.InventoryItemRemove( "inv_screwdriver" );
    end;
  
  end;
  local use_screwdriver_beg2 = function ()
  
    ObjDelete( "obj_maidsclothes_use_screwdriver" );
    ObjDelete( "anm_maidsclothes_wheel_touch" );
  
  end;
  local use_screwdriver_end2 = function ()
  
    ObjDelete( "spr_maidsclothes_wheel_sh_2" );
    
    ObjMultiSet( { {"anm_maidsclothes_use_screwdriver",  { alp = 1, input = 1, frame = 400 }},
                   {"spr_maidsclothes_wheel_sh_3", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdrivercart", use_screwdriver_beg1, private.room_objname );
  cmn.AddSubscriber( "use_screwdrivercart", use_screwdriver_inv1 );
  cmn.AddSubscriber( "use_screwdrivercart", use_screwdriver_end1, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_inv1", use_screwdriver_inv1, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_beg1", use_screwdriver_beg1, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_end1", use_screwdriver_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_screwdrivercloset", use_screwdriver_beg2, "rm_clothesroom" );
  cmn.AddSubscriber( "use_screwdrivercloset", use_screwdriver_inv2 );
  cmn.AddSubscriber( "use_screwdrivercloset", use_screwdriver_end2, "rm_clothesroom" );
  cmn.AddSubscriber( "use_screwdriver_inv2", use_screwdriver_inv2, "rm_clothesroom" );
  cmn.AddSubscriber( "use_screwdriver_beg2", use_screwdriver_beg2, "rm_clothesroom" );
  cmn.AddSubscriber( "use_screwdriver_end2", use_screwdriver_end2, "rm_clothesroom" );
  --------------------------------------------------------------------------------------------
  -- function use_brainamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_brainamulet" ] = {
      type = "use",
      inv_obj = "inv_brainamulet",
      use_place = "obj_medicalcart_use_brainamulet",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local use_brainamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_brainamulet" );
  
  end;
  local use_brainamulet_beg = function ()
  
    ObjDelete( "obj_medicalcart_use_brainamulet" );
  
  end;
  local use_brainamulet_end = function ()
    
    ObjDelete( "spr_corridor_medcart_brain_door_1" );
    
    ObjMultiSet( { {"obj_medicalcart_switch", { alp = 1 }},
                   {"spr_medicalcart_brain", { alp = 1 }},
                   {"obj_medicalcart_brain_drawer", { input = 1, pos_x = 60, pos_y = 27 }},
                   {"spr_corridor_medcart_brain_door_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brainamulet", use_brainamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_brainamulet", use_brainamulet_inv );
  cmn.AddSubscriber( "use_brainamulet", use_brainamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_brainamulet_inv", use_brainamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_brainamulet_beg", use_brainamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_brainamulet_end", use_brainamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heartamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_heartamulet" ] = {
      type = "use",
      inv_obj = "inv_heartamulet",
      use_place = "obj_medicalcart_use_heartamulet",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local use_heartamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_heartamulet" );
  
  end;
  local use_heartamulet_beg = function ()
  
    ObjDelete( "obj_medicalcart_use_heartamulet" );
  
  end;
  local use_heartamulet_end = function ()
    
    ObjDelete( "anm_medicalcart_heart_touch" );
    ObjDelete( "spr_corridor_medcart_heart_door_1" );
  
    ObjMultiSet( { {"obj_medicalcart_heart_drawer", { alp = 1, input = 1 }},
                   {"spr_medicalcart_heart_drawer_open", { alp = 1 }},
                   {"spr_corridor_medcart_heart_door_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heartamulet", use_heartamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartamulet", use_heartamulet_inv );
  cmn.AddSubscriber( "use_heartamulet", use_heartamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_heartamulet_inv", use_heartamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_heartamulet_beg", use_heartamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartamulet_end", use_heartamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cartwheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cartwheel" ] = {
      type = "use",
      inv_obj = "inv_cartwheel",
      use_place = "obj_medicalcart_use_cartwheel",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local use_cartwheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_cartwheel" );
  
  end;
  local use_cartwheel_beg = function ()
  
    ObjDelete( "obj_medicalcart_use_cartwheel" );
  
  end;
  local use_cartwheel_end = function ()
  
    ObjMultiSet( { {"obj_medicalcart_use_screw", { input = 1 }},
                   {"obj_medicalcart_weel", { alp = 1 }},
                   {"spr_corridor_medcart_wheel", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cartwheel", use_cartwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel", use_cartwheel_inv );
  cmn.AddSubscriber( "use_cartwheel", use_cartwheel_end, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel_inv", use_cartwheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel_beg", use_cartwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel_end", use_cartwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_screw" ] = {
      type = "use",
      inv_obj = "inv_screw",
      use_place = "obj_medicalcart_use_screw",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local use_screw_inv = function ()
  
    interface.InventoryItemRemove( "inv_screw" );
  
  end;
  local use_screw_beg = function ()
  
    ObjDelete( "obj_medicalcart_use_screw" );
  
  end;
  local use_screw_end = function ()
    
    ObjDelete( "anm_medicalcart_use_screw" );
  
    ObjMultiSet( { {"obj_medicalcart_use_screwdriver", { input = 1 }},
                   {"anm_medicalcart_screw_touch", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screw", use_screw_beg, private.room_objname );
  cmn.AddSubscriber( "use_screw", use_screw_inv );
  cmn.AddSubscriber( "use_screw", use_screw_end, private.room_objname );
  cmn.AddSubscriber( "use_screw_inv", use_screw_inv, private.room_objname );
  cmn.AddSubscriber( "use_screw_beg", use_screw_beg, private.room_objname );
  cmn.AddSubscriber( "use_screw_end", use_screw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_powder () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_powder" ] = {
      type = "use",
      inv_obj = "inv_powder",
      use_place = "obj_medicalcart_use_powder",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local use_powder_inv = function ()
  
    interface.InventoryItemRemove( "inv_powder" );
  
  end;
  local use_powder_beg = function ()
  
    ObjDelete( "obj_medicalcart_use_powder" );
    if cmn.IsEventDone("use_powderbrush") then
      ObjDelete( "obj_medicalcart_use_powderbrush" );
    end;
  
  end;
  local use_powder_end = function ()
    
    ObjMultiSet( { {"spr_medicalcart_powder", { alp = 1 }},
                   {"spr_corridor_medcart_powder", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_powderbrush") then
      ObjDelete( "obj_medicalcart_powder_brush" );
      ObjDelete( "spr_corridor_medcart_powder_brush" );
      ObjMultiSet( { {"anm_medicalcart_use_powder_brush", { alp = 1, frame = 400 }},
                     {"obj_medicalcart_game", { input = 1}},
                     {"spr_corridor_medcart_safe_powder", { alp = 1}} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_powder", use_powder_beg, private.room_objname );
  cmn.AddSubscriber( "use_powder", use_powder_inv );
  cmn.AddSubscriber( "use_powder", use_powder_end, private.room_objname );
  cmn.AddSubscriber( "use_powder_inv", use_powder_inv, private.room_objname );
  cmn.AddSubscriber( "use_powder_beg", use_powder_beg, private.room_objname );
  cmn.AddSubscriber( "use_powder_end", use_powder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_powderbrush () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_powderbrush" ] = {
      type = "use",
      inv_obj = "inv_powderbrush",
      use_place = "obj_medicalcart_use_powderbrush",
      room = private.room_objname,
      zz = "zz_medicalcart",
      zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local use_powderbrush_inv = function ()
  
    interface.InventoryItemRemove( "inv_powderbrush" );
  
  end;
  local use_powderbrush_beg = function ()
  
    if cmn.IsEventDone("use_powder") then
      ObjDelete( "obj_medicalcart_use_powderbrush" );
    end;
  
  end;
  local use_powderbrush_end = function ()
  
    if cmn.IsEventDone("use_powder") then
      ObjDelete( "obj_medicalcart_powder_brush" );
      ObjDelete( "spr_corridor_medcart_powder_brush" );
      ObjMultiSet( { {"anm_medicalcart_use_powder_brush", { alp = 1, frame = 400 }},
                     {"obj_medicalcart_game", { input = 1}},
                     {"spr_corridor_medcart_safe_powder", { alp = 1}} } );
    else 
      ObjMultiSet( { {"obj_medicalcart_powder_brush", { alp = 1 }},
                     {"spr_corridor_medcart_powder_brush", { alp = 1 }} } );      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_powderbrush", use_powderbrush_beg, private.room_objname );
  cmn.AddSubscriber( "use_powderbrush", use_powderbrush_inv );
  cmn.AddSubscriber( "use_powderbrush", use_powderbrush_end, private.room_objname );
  cmn.AddSubscriber( "use_powderbrush_inv", use_powderbrush_inv, private.room_objname );
  cmn.AddSubscriber( "use_powderbrush_beg", use_powderbrush_beg, private.room_objname );
  cmn.AddSubscriber( "use_powderbrush_end", use_powderbrush_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_accesscard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_accesscard" ] = {
      type = "use",
      inv_obj = "inv_accesscard",
      use_place = "obj_clothesroomdoor_use_accesscard",
      room = private.room_objname,
      zz = "zz_clothesroomdoor",
      zz_gate = "gzz_corridor_clothesroomdoor"
  };
  --------------------------------------------------------------------------------------------
  local use_accesscard_inv = function ()
  
    interface.InventoryItemRemove( "inv_accesscard" );
  
  end;
  local use_accesscard_beg = function ()
  
    ObjDelete( "obj_clothesroomdoor_use_accesscard" );
    ObjDelete( "spr_clothesroomdoor_door_bl" );
    ObjDelete( "anm_clothesroomdoor_door_touch" );
  
  end;
  local use_accesscard_end = function ()
  
    ObjMultiSet( { {"anm_clothesroomdoor_use_accesscard", { alp = 1, frame = 400 }},
                   {"obj_clothesroomdoor_game", { input = 1 }},
                   {"spr_corridor_store_card", { alp = 1 }},
                   {"spr_corridor_store_panel_green", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_accesscard", use_accesscard_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesscard", use_accesscard_inv );
  cmn.AddSubscriber( "use_accesscard", use_accesscard_end, private.room_objname );
  cmn.AddSubscriber( "use_accesscard_inv", use_accesscard_inv, private.room_objname );
  cmn.AddSubscriber( "use_accesscard_beg", use_accesscard_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesscard_end", use_accesscard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_room13key () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_room13key" ] = {
      type = "use",
      inv_obj = "inv_room13key",
      use_place = "obj_warddoor_use_room13key",
      room = private.room_objname,
      zz = "zz_warddoor",
      zz_gate = "gzz_corridor_warddoor"
  };
  --------------------------------------------------------------------------------------------
  local use_room13key_inv = function ()
  
    interface.InventoryItemRemove( "inv_room13key" );
  
  end;
  local use_room13key_beg = function ()
  
    ObjDelete( "obj_warddoor_use_room13key" );
  
  end;
  local use_room13key_end = function ()
  
    ObjMultiSet( { {"grm_corridor_mermaidsward", { alp = 1, input = 1 }},
                   {"spr_corridor_ward_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_corridor_mermaidsward_focus");
    end;
    
    ObjDelete( "gzz_corridor_warddoor" );
    ObjDelete( "spr_corridor_ward_handle" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_room13key", use_room13key_beg, private.room_objname );
  cmn.AddSubscriber( "use_room13key", use_room13key_inv );
  cmn.AddSubscriber( "use_room13key", use_room13key_end, private.room_objname );
  cmn.AddSubscriber( "use_room13key_inv", use_room13key_inv, private.room_objname );
  cmn.AddSubscriber( "use_room13key_beg", use_room13key_beg, private.room_objname );
  cmn.AddSubscriber( "use_room13key_end", use_room13key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emergencykey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_emergencykey" ] = {
      type = "use",
      inv_obj = "inv_emergencykey",
      use_place = "obj_liftpanel_use_emergencykey",
      room = private.room_objname,
      zz = "zz_liftpanel",
      zz_gate = "gzz_corridor_liftpanel"
  };
  --------------------------------------------------------------------------------------------
  local use_emergencykey_inv = function ()
  
    interface.InventoryItemRemove( "inv_emergencykey" );
  
  end;
  local use_emergencykey_beg = function ()
  
    ObjDelete( "obj_liftpanel_use_emergencykey" );
    ObjDelete( "anm_liftpanel_panel_touch" );
  
  end;
  local use_emergencykey_end = function ()
    
    ObjDelete( "spr_corridor_elevator_panel_1" );
  
    ObjMultiSet( { {"obj_liftpanel_game", { input = 1 }},
                   {"anm_liftpanel_use_key", { alp = 1, frame = 400, animfunc = "func_open_cover" }},
                   {"spr_corridor_elevator_panel_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emergencykey", use_emergencykey_beg, private.room_objname );
  cmn.AddSubscriber( "use_emergencykey", use_emergencykey_inv );
  cmn.AddSubscriber( "use_emergencykey", use_emergencykey_end, private.room_objname );
  cmn.AddSubscriber( "use_emergencykey_inv", use_emergencykey_inv, private.room_objname );
  cmn.AddSubscriber( "use_emergencykey_beg", use_emergencykey_beg, private.room_objname );
  cmn.AddSubscriber( "use_emergencykey_end", use_emergencykey_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_cartrollsaway () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_cartrollsaway" ] = {
    type = "click",
    use_place = "obj_medicalcart_clk_cartrollsaway",
    room = private.room_objname,
    zz = "zz_medicalcart",
    zz_gate = "gzz_corridor_medicalcart"
  };
  --------------------------------------------------------------------------------------------
  local clk_cartrollsaway_beg = function ()
  
    ObjDelete( "obj_medicalcart_clk_cartrollsaway" );
    ObjDelete( "anm_medicalcart_wheel_touch" );
    ObjSet("obj_medicalcart_wheel_move",  { alp = 1 });
  
  end;
  local clk_cartrollsaway_end = function ()
  
    ObjMultiSet( { {"obj_medicalcart_under_wheel", { input = 1 }},
                   {"obj_medicalcart_cart", { pos_x = 140, pos_y = -47 }},
                   {"spr_corridor_medcart_cart", { pos_x = 673, pos_y = 500 }},
                   {"gzz_corridor_medicalcart", { pos_x = 685, pos_y = 466 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_cartrollsaway", clk_cartrollsaway_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cartrollsaway", clk_cartrollsaway_end, private.room_objname );
  cmn.AddSubscriber( "clk_cartrollsaway_beg", clk_cartrollsaway_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cartrollsaway_end", clk_cartrollsaway_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_corridor () end;
  --------------------------------------------------------------------------------------------
  local opn_corridor = function ()
  
    int_map_impl.OpenRoom( "rm_corridor" );
    interface_impl.SetCurrentGlobalTask( 11 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_corridor", opn_corridor );
  --------------------------------------------------------------------------------------------
  -- function opn_corridorkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "opn_corridorkey" ] = {
    type = "click",
    use_place = "gzz_corridor_liftpanel",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local opn_corridorkey = function ()
  
    ObjMultiSet( { {"gzz_corridor_liftpanel",  { active = 1, input = 1, alp = 1 }},
                   {"anm_corridor_elevator_tv_1_2", { alp = 1 }},
                   {"anm_corridor_elevator_tv_2_2", { alp = 1 }} } );
    
    ObjDelete("anm_corridor_elevator_tv_1_1");
    ObjDelete("anm_corridor_elevator_tv_2_1");
    ObjDelete("spr_corridor_elevator_floor_1");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_corridorkey", opn_corridorkey, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_nurse () end;
  --------------------------------------------------------------------------------------------
  local opn_nurse = function ()

    ObjSet( "anm_nurse_nurse", { frame = 229 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nurse", opn_nurse, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_liftpanel" );
  subroom.Define( "zz_clothesroomdoor" );
  subroom.Define( "zz_medicalcart" );
  subroom.Define( "zz_nurse" );
  
  function zz_medicalcart.PreOpen()

    if cmn.IsEventDone("use_powder") and cmn.IsEventDone("use_powderbrush") and not cmn.IsEventDone("win_medicalcart") then
      private.zz_medicalcart.DrawScene();
    end;

  end;
  
  function zz_medicalcart.Open()

    if cmn.IsEventDone("use_powder") and cmn.IsEventDone("use_powderbrush") and not cmn.IsEventDone("win_medicalcart") then
      private.zz_medicalcart.CheckWin();
    end;

  end;
  
  function zz_liftpanel.PreOpen()
    
    if cmn.IsEventDone( "use_emergencykey" ) and not(cmn.IsEventDone( "win_liftpanel" )) then
      private.zz_liftpanel.DrawScene();
    end;

  end;
  
  function zz_liftpanel.Open()
    
    if cmn.IsEventDone( "use_emergencykey" ) and not(cmn.IsEventDone( "win_liftpanel" )) then
      cmn.MiniGameShow();
      private.zz_liftpanel.CheckWin();
    end;

  end;

  function zz_liftpanel.PreClose()
    
    if ( cmn.IsEventDone( "use_emergencykey" ) and not(cmn.IsEventDone( "win_liftpanel" )) ) then
      cmn.MiniGameHide("liftpanel");
    end;

  end;
  
  function zz_clothesroomdoor.PreOpen()
    
    if cmn.IsEventDone( "use_accesscard" ) and not(cmn.IsEventDone( "win_clothesroomdoor" )) then
      private.zz_clothesroomdoor.DrawScene();
    end;

  end;
  
  function zz_clothesroomdoor.Open()
    
    if cmn.IsEventDone( "use_accesscard" ) and not(cmn.IsEventDone( "win_clothesroomdoor" )) then
      cmn.MiniGameShow();
      --private.zz_clothesroomdoor.CheckWin();
    end;

  end;

  function zz_clothesroomdoor.PreClose()
    
    if ( cmn.IsEventDone( "use_accesscard" ) and not(cmn.IsEventDone( "win_clothesroomdoor" )) ) then
      cmn.MiniGameHide("clothesroomdoor");
    end;

  end;
  
  function zz_clothesroomdoor.Close()
    
    cmn.HideNote( 0 );
    
  end;

  function zz_nurse.PreOpen()

    if not cmn.IsEventDone( "opn_nurse" ) then
      cmn.Lock( 1 );
    end;

    if ( cmn.IsEventDone( "use_lvl2sleepingpills" ) ) then
      ObjSet( "anm_nurse_nurse", { animfunc = "func_nurse_anm", endtrig = "", playing = true } );
    end;

  end;

  function zz_nurse.Open()
    private.opn_nurse();
  end;
  
  function zz_nurse.Close()
    cmn.HideNote( 0 );
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].state) then 
    private.zz_liftpanel.StartConditions();
  end;

  private.zz_liftpanel.state = ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].state;
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state) then 
    private.zz_clothesroomdoor.StartConditions();
  end;

  private.zz_clothesroomdoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state;
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_medicalcart" ].state) then 
    private.zz_medicalcart.StartConditions();
  end;

  private.zz_medicalcart.state = ng_global.progress[ ng_global.currentprogress ][ "win_medicalcart" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_corridor();
  
  if cmn.IsEventDone("opn_corridorkey") then
    private.anim_elevator();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_corridor_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
  
  if cmn.IsEventDone("get_emergencykey") and not ( cmn.IsEventDone( "opn_corridorkey" ) ) then
    cmn.Lock( 1 );
  end;
  
  if cmn.IsEventDone("win_liftpanel") then
    cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_hunter_env");
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lvl2sleepingpills()

  local item = "inv_lvl2sleepingpills";

  if cmn.ApplyObj( item, "gzz_corridor_nurse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nurse" );

  elseif ( cmn.ApplyObj( item, "obj_nurse_use_lvl2sleepingpills" ) ) then

    cmn.CallEventHandler( "use_lvl2sleepingpills_inv" );
    cmn.CallEventHandler( "use_lvl2sleepingpills_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl2sleepingpills" );
      cmn.CallEventHandler( "use_lvl2sleepingpills_end" );
      
      cmn.ShowBbt( "corridor_after_mermaidsward" );
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
    
    end;
    
    local play_vid = function ()
      
      cmn.Lock( 0 );
      cmn.StopAllEnv();

      ObjSet( "anm_nurse_nurse", { animfunc = "func_nurse_anm", endtrig = "", playing = true } );

      cmn.PlayAudio("mus", "assets/levels/level2/rm_corridor/audio/aud_mermaidsward_mus", 0, false, 15);
      cmn.PlayFullscreenVideo( "assets/levels/level2/rm_corridor/vid_mermaidsward", func_after, "assets/levels/level2/rm_corridor/audio/aud_mermaidsward", "assets/levels/level2/rm_corridor/audio/aud_mermaidsward_voc", 1, 3.5, false, true, true );
      
    end;

    local func_after_beg = function ()

      ObjDelete( "anm_nurse_sleepingpills" );
      ObjSet( "anm_nurse_nurse", { croprect_init = false, animfunc = "func_nurse_sleep", endtrig = play_vid, playing = true } );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_pill");

    ObjMultiSet( { { "anm_nurse_sleepingpills", { alp = 1, endtrig = func_after_beg, playing = true } },
                   { "anm_nurse_nurse", { croprect_init = true, croprect_x = -150, croprect_y = -350, croprect_w = 500, croprect_h = 500 } } } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_horseshoe()

  local item = "inv_horseshoe";

  if cmn.ApplyObj( item, "gzz_corridor_nurse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nurse" );

  elseif ( cmn.ApplyObj( item, "obj_nurse_use_horseshoe" ) ) then

    cmn.CallEventHandler( "use_horseshoe_inv" );
    cmn.CallEventHandler( "use_horseshoe_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_horseshoe" );
      cmn.CallEventHandler( "use_horseshoe_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_opn_money_box");

    ObjSet( "anm_nurse_moneybox", { animfunc = "func_horseshoe_use", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cutters()

  local item = "inv_cutters";

  if cmn.ApplyObj( item, "gzz_corridor_nurse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nurse" );

  elseif ( cmn.ApplyObj( item, "obj_nurse_use_cutters" ) ) then

    cmn.CallEventHandler( "use_cutters_inv" );
    cmn.CallEventHandler( "use_cutters_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cutters" );
      cmn.CallEventHandler( "use_cutters_end" );

      public.get_crumpledpackage();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_tweezers");

    ObjSet( "anm_nurse_trashbox", { animfunc = "func_cutter_use", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver()

  local item = "inv_screwdriver";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_screwdriver" ) and cmn.IsEventDone("use_screw") ) then

    cmn.CallEventHandler( "use_screwdriver_inv1" );
    cmn.CallEventHandler( "use_screwdriver_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_screwdrivercart" );
      cmn.CallEventHandler( "use_screwdriver_end1" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_screwdriver3");

    ObjSet("anm_medicalcart_use_screwdriver",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif cmn.ApplyObj( item, "gzz_clothesroom_maidsclothes" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_maidsclothes" );

  elseif ( cmn.ApplyObj( item, "obj_maidsclothes_use_screwdriver" ) ) then

    cmn.CallEventHandler( "use_screwdriver_inv2" );
    cmn.CallEventHandler( "use_screwdriver_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_screwdrivercloset" );
      cmn.CallEventHandler( "use_screwdriver_end2" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_screwdriver2");
    
    ObjSet("anm_maidsclothes_use_screwdriver",  { alp = 1, playing = 1, endtrig = func_after });
    
    ObjAnimate("spr_maidsclothes_wheel_sh_2", "alp", 0, 0, "", { 0, 0, 1,   1.3, 0, 1,    1.5, 0, 0 });
    ObjAnimate("spr_maidsclothes_wheel_sh_3", "alp", 0, 0, "", { 0, 0, 0,   1.3, 0, 0,    1.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_brainamulet()

  local item = "inv_brainamulet";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_brainamulet" ) ) then

    cmn.CallEventHandler( "use_brainamulet_inv" );
    cmn.CallEventHandler( "use_brainamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_brainamulet" );
      cmn.CallEventHandler( "use_brainamulet_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjSet("obj_medicalcart_switch",  { alp = 1 });
      ObjAnimate("obj_medicalcart_brain_drawer", "pos_xy", 0, 0, func_after, { 0, 0, 0, 0,   1, 0, 60, 27 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_use_brain");

    ObjAnimate( "spr_medicalcart_brain", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_heartamulet()

  local item = "inv_heartamulet";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_heartamulet" ) ) then

    cmn.CallEventHandler( "use_heartamulet_inv" );
    cmn.CallEventHandler( "use_heartamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_heartamulet" );
      cmn.CallEventHandler( "use_heartamulet_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjSet("obj_medicalcart_heart_drawer",  { alp = 1 });
      ObjAnimate("anm_medicalcart_heart_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_medicalcart_heart_drawer_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_heart");

    ObjAnimate( "spr_medicalcart_heart", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cartwheel()

  local item = "inv_cartwheel";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_cartwheel" ) ) then

    cmn.CallEventHandler( "use_cartwheel_inv" );
    cmn.CallEventHandler( "use_cartwheel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cartwheel" );
      cmn.CallEventHandler( "use_cartwheel_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_wheel2");

    ObjAnimate( "obj_medicalcart_weel", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_screw()

  local item = "inv_screw";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_screw" ) and cmn.IsEventDone("use_cartwheel") ) then

    cmn.CallEventHandler( "use_screw_inv" );
    cmn.CallEventHandler( "use_screw_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_screw" );
      cmn.CallEventHandler( "use_screw_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_screw");

    ObjSet("anm_medicalcart_use_screw",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_powder()

  local item = "inv_powder";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_powderbrush" ) or cmn.ApplyObj( item, "spr_medicalcart_powder_brush" ) ) then

    cmn.CallEventHandler( "use_powder_inv" );
    cmn.CallEventHandler( "use_powder_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_powder" );
      cmn.CallEventHandler( "use_powder_end" );
    
    end;
    
    local anm_powder = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_brush");
      ObjSet("anm_medicalcart_use_powder_brush",  { playing = 1, endtrig = func_after });
      
    end;
    
    local anm_brush = function ()
      
      ObjAnimate("anm_medicalcart_use_powder_brush", "alp", 0, 0, anm_powder, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("obj_medicalcart_powder_brush", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    if cmn.IsEventDone("use_powderbrush") then
      ObjAnimate("spr_medicalcart_powder", "alp", 0, 0, anm_brush, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_medicalcart_powder", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_powderbrush()

  local item = "inv_powderbrush";

  if cmn.ApplyObj( item, "gzz_corridor_medicalcart" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_medicalcart" );

  elseif ( cmn.ApplyObj( item, "obj_medicalcart_use_powderbrush" ) or cmn.ApplyObj( item, "spr_medicalcart_powder" ) ) then

    cmn.CallEventHandler( "use_powderbrush_inv" );
    cmn.CallEventHandler( "use_powderbrush_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_powderbrush" );
      cmn.CallEventHandler( "use_powderbrush_end" );
    
    end;
    
    local anm_powder = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_brush");
      ObjSet("anm_medicalcart_use_powder_brush",  { playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    
    if cmn.IsEventDone("use_powder") then
      ObjAnimate("anm_medicalcart_use_powder_brush", "alp", 0, 0, anm_powder, { 0, 0, 0,   0.3, 0, 1 });
    else 
      cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
      ObjAnimate("obj_medicalcart_powder_brush", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_accesscard()

  local item = "inv_accesscard";

  if cmn.ApplyObj( item, "gzz_corridor_clothesroomdoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_clothesroomdoor" );

  elseif ( cmn.ApplyObj( item, "obj_clothesroomdoor_use_accesscard" ) ) then

    cmn.CallEventHandler( "use_accesscard_inv" );
    cmn.CallEventHandler( "use_accesscard_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_accesscard" );
      cmn.CallEventHandler( "use_accesscard_end" );
      
      cmn.MiniGameShow();
      
    end;
    
    if not cmn.IsEventDone("get_spiderleg2") then
      public.get_spiderleg2();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_use_plastic_card");

    ObjSet("anm_clothesroomdoor_use_accesscard",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_room13key()

  local item = "inv_room13key";

  if cmn.ApplyObj( item, "gzz_corridor_warddoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_warddoor" );

  elseif ( cmn.ApplyObj( item, "obj_warddoor_use_room13key" ) ) then

    cmn.CallEventHandler( "use_room13key_inv" );
    cmn.CallEventHandler( "use_room13key_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_room13key" );
      cmn.CallEventHandler( "use_room13key_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_keydoor");

    ObjSet("anm_warddoor_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emergencykey()

  local item = "inv_emergencykey";

  if cmn.ApplyObj( item, "gzz_corridor_liftpanel" ) and cmn.IsEventDone("opn_corridorkey") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_liftpanel" );

  elseif ( cmn.ApplyObj( item, "obj_liftpanel_use_emergencykey" ) ) then

    cmn.CallEventHandler( "use_emergencykey_inv" );
    cmn.CallEventHandler( "use_emergencykey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_emergencykey" );
      cmn.CallEventHandler( "use_emergencykey_end" );
      
      cmn.MiniGameShow();
    
    end;
    
    local anm_open = function ()
      
      ObjSet("anm_liftpanel_use_key",  { frame = 0, animfunc = "func_open_cover", playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_wrench_panel");

    ObjSet("anm_liftpanel_use_key",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_dollar2()

  cmn.SetEventDone( "get_dollar2" );
  cmn.CallEventHandler( "get_dollar2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_accesscard()

  cmn.SetEventDone( "get_accesscard" );
  cmn.CallEventHandler( "get_accesscard" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_brainamulet()

  cmn.SetEventDone( "get_brainamulet" );
  cmn.CallEventHandler( "get_brainamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_crumpledpackage()

  cmn.SetEventDone( "get_crumpledpackage" );
  cmn.CallEventHandler( "get_crumpledpackage" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_spiderleg3()

  cmn.SetEventDone( "get_spiderleg3" );
  cmn.CallEventHandler( "get_spiderleg3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_number3()

  cmn.SetEventDone( "get_number3" );
  cmn.CallEventHandler( "get_number3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bluecable()

  cmn.SetEventDone( "get_bluecable" );
  cmn.CallEventHandler( "get_bluecable" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_switch()

  cmn.SetEventDone( "get_switch" );
  cmn.CallEventHandler( "get_switch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magicpage5()

  cmn.SetEventDone( "get_magicpage5" );
  cmn.CallEventHandler( "get_magicpage5" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_windowhandle") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_windowhandle()

  cmn.SetEventDone( "get_windowhandle" );
  cmn.CallEventHandler( "get_windowhandle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_magicpage5") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_spiderleg2()

  cmn.SetEventDone( "get_spiderleg2" );
  cmn.CallEventHandler( "get_spiderleg2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_number1()

  cmn.SetEventDone( "get_number1" );
  cmn.CallEventHandler( "get_number1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bulldogkey()

  cmn.SetEventDone( "get_bulldogkey" );
  cmn.CallEventHandler( "get_bulldogkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_cartrollsaway()

  cmn.CallEventHandler( "clk_cartrollsaway_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_cartrollsaway" );
    cmn.CallEventHandler( "clk_cartrollsaway_end" );

    cmn.Lock( 0 );
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_clk_cart");

  ObjAnimate("obj_medicalcart_cart", "pos_xy", 0, 0, func_after, { 0, 2, 0, 0,   1.5, 2, 140, -47 });
  ObjAnimate("spr_medicalcart_wheel_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0,    1, 0, 1,    1.5, 0, 0 });
  ObjAnimate("spr_medicalcart_wheel_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1,    1, 0, 0,    1.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_corridor()

  if not ( cmn.IsEventDone( "opn_corridor" ) ) then
    cmn.SetEventDone( "opn_corridor" );
    cmn.CallEventHandler("opn_corridor");
    cmn.ShowBbt( "corridor_open" );
    interface_impl.ShowGlobalTask();
  end;
  
  if cmn.IsEventDone("get_emergencykey") and not ( cmn.IsEventDone( "opn_corridorkey" ) ) then
    
    local func_after = function ()
      
      cmn.CallEventHandler("opn_corridorkey");
      cmn.ShowBbt( "corridor_after_huntsmaninelevator" );
      
      private.anim_elevator();
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
      
    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    
    cmn.PlayAudio("mus", "assets/levels/level2/rm_corridor/audio/aud_huntsmaninelevator_mus", 0, false, 18);
    
    cmn.SetEventDone( "opn_corridorkey" );
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_corridor/vid_huntsmaninelevator", func_after, "assets/levels/level2/rm_corridor/audio/aud_huntsmaninelevator", "", 1, 3.5, false, true, true);
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.anim_elevator()
  
  if not private.anim_elevator_process then
    private.anim_elevator_process = true;
    ObjAnimate("spr_corridor_elevator_floor_2", "alp", 1, 0, "", { 0, 0, 0,   0.4, 0, 1,     0.8, 0, 1,    1.2, 0, 0 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.opn_nurse()

  if not cmn.IsEventDone( "opn_nurse" ) then

    cmn.SetEventDone( "opn_nurse" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.CallEventHandler("opn_nurse");

    end;

    ObjSet( "anm_nurse_nurse", { endtrig = func_after, playing = true } );

  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_lift_panel()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_liftpanel_use_emergencykey" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_panel_metal");
  
  ObjSet("anm_liftpanel_panel_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_store_door()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_clothesroomdoor_use_accesscard" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_beep");
  
  ObjSet("anm_clothesroomdoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_brain_drawer()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_medicalcart_use_brainamulet" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_door_small2");
  
  ObjSet("anm_medicalcart_brain_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_heart_drawer()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_medicalcart_use_heartamulet" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_door_small1");
  
  ObjSet("anm_medicalcart_heart_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_safe()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_medicalcart_use_powderbrush" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_door_small");
  
  ObjSet("anm_medicalcart_safe_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wheel()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_medicalcart_use_screw" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_small_box");
  
  ObjSet("anm_medicalcart_wheel_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_screw()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_medicalcart_use_screwdriver" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_snake_head");
  
  ObjSet("anm_medicalcart_screw_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wardddoor()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_warddoor_use_room13key" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_handle");
  
  ObjSet("anm_warddoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_moneybox()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_nurse_use_horseshoe" );

  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_money_box");
  
  ObjSet( "anm_nurse_moneybox", { playing = true, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_trashbox()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_nurse_use_cutters" );

  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_paper2");
  
  ObjSet( "anm_nurse_trashbox", { playing = true, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Liftpanel *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_liftpanel = {};
public.zz_liftpanel = {};

function private.Init_Liftpanel()
  
  --active exits of swithces in each state
  private.zz_liftpanel.switches_connect = { 
    { {2, 4}, {1, 3}, {2, 4}, {1, 3} },
    { {2, 3, 4}, {1, 2, 3}, {2, 1, 4}, {3, 4, 1} },
    { {3, 4}, {2, 3}, {1, 2}, {1, 4} },
    { {2, 3, 4}, {1, 2, 3}, {2, 1, 4}, {3, 4, 1} },
    { {3, 4}, {2, 3}, {1, 2}, {1, 4} }
  };
  
  --which wires connect with switches
  --[1] - point, [2] - wire
  private.zz_liftpanel.switches_wires = { 
    { {1, 5}, {3, 4} },
    { {2, 4}, {1, 6}, {4, 1} },
    { {1, 7}, {4, 2} },
    { {1, 8}, {4, 9}, {3, 3} },
    { {1, 10}, {2, 9} }
  };
  
  private.zz_liftpanel.switches_ang = { 0, 1.57, 3.14, 4.71, 6.28 };
  private.zz_liftpanel.lamps_connect = { 5, 6, 7, 8, 10 };
  private.zz_liftpanel.always_on = {1, 2, 3};
  
  private.zz_liftpanel.wires_on = {1, 1, 1, 0, 0, 0, 0, 0, 0, 0};
  private.zz_liftpanel.switches_checked = {0, 0, 0, 0, 0};
  
  private.zz_liftpanel.start_switches = { 2, 3, 4, 4, 3 };
  private.zz_liftpanel.win_switches = { 1, 2, 2, 3 };
  -----------------------------------------------------------------------------------
  local win_liftpanel = function ()

    if cmn.IsEventDone( "win_liftpanel" ) then
      
      ObjDelete("obj_liftpanel_game_win_lights");
      ObjDelete("spr_corridor_elevator_panel_wires");
      ObjDelete("spr_corridor_elevator_door_1");
      ObjDelete("spr_corridor_elevator_door_2");

      ObjMultiSet( { {"anm_liftpanel_win_mmg", { alp = 1, input = 1, frame = 500 }},
                     {"obj_liftpanel_game", { input = 0 }},
                     {"spr_corridor_elevator_panel_hole", { alp = 1 }},
                     {"anm_corridor_hunter_in_elevator", { alp = 1 }},
                     {"fx_corridor_p_electro", { active = 1, visible = 1 }},
                     {"fx_liftpanel_p_electro", { active = 1, visible = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_liftpanel", win_liftpanel, "rm_corridor" );

end;
--*********************************************************************************************************************
function private.zz_liftpanel.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].state = { 2, 3, 4, 4, 3 }; --positions of swithces
  
end;
-----------------------------------------------------------------------------------
function public.zz_liftpanel.Reset()
  
  local need_r = false;
  
  for i = 1, #private.zz_liftpanel.start_switches, 1 do
    
    if private.zz_liftpanel.state[i] ~= private.zz_liftpanel.start_switches[i] then
      
      if i ~= 1 or i == 1 and (private.zz_liftpanel.state[i]+private.zz_liftpanel.start_switches[i])%2 ~= 0 then
        
        if not need_r then
          need_r = true;
        end;
        
        local old_ang = private.zz_liftpanel.switches_ang[ private.zz_liftpanel.state[i] ];
        local new_ang = private.zz_liftpanel.switches_ang[ private.zz_liftpanel.start_switches[i] ];
        
        ObjAnimate("spr_liftpanel_switch_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });
        
      end;
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_clk_panel_button");
    
    private.zz_liftpanel.CheckWires();
    private.zz_liftpanel.StartConditions();
    
    local wire_on = false;
    
    for i = 4, #private.zz_liftpanel.wires_on, 1 do
    
      if private.zz_liftpanel.wires_on[i] == 0 then
        
        if not wire_on then
          wire_on = true;
        end;
        
        ObjAnimate("spr_liftpanel_wire_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      end;
      
    end;
    
    if wire_on then
      cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_powerup");
    end;
    
    local count_lamps = 0;
  
    for i = 1, #private.zz_liftpanel.lamps_connect, 1 do
      
      if private.zz_liftpanel.wires_on[ private.zz_liftpanel.lamps_connect[i] ] == 0 then 
        ObjAnimate("spr_liftpanel_lamp_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        count_lamps = count_lamps + 1;
      end;
      
    end;
    
    for i = count_lamps, 1, -1 do
      ObjAnimate("spr_liftpanel_win_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   0.8, 0, 0 });
    end;
    
    private.zz_liftpanel.state = ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].state;
    ObjSet("tmr_liftpanel_timer",  { time = 0.8, playing = 1, endtrig = function () cmn.Lock( 0 ); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_liftpanel.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_clk_panel_button");
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_powerdown");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].state = { 1, 2, 2, 3, 3 };
  
  private.zz_liftpanel.CheckWires();
  
  for i = 1, #private.zz_liftpanel.win_switches, 1 do
    
    if private.zz_liftpanel.state[i] ~= private.zz_liftpanel.win_switches[i] then
      
      local old_ang = private.zz_liftpanel.switches_ang[ private.zz_liftpanel.state[i] ];
      local new_ang = private.zz_liftpanel.switches_ang[ private.zz_liftpanel.win_switches[i] ];
      
      ObjAnimate("spr_liftpanel_switch_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });
      
    end;
    
  end;
  
  for i = 4, #private.zz_liftpanel.wires_on, 1 do
    
    if private.zz_liftpanel.wires_on[i] == 1 then
      ObjAnimate("spr_liftpanel_wire_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
  end;
  
  local count_lamps = 0;
  
  for i = 1, #private.zz_liftpanel.lamps_connect, 1 do
    
    if private.zz_liftpanel.wires_on[ private.zz_liftpanel.lamps_connect[i] ] == 1 then 
      ObjAnimate("spr_liftpanel_lamp_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    else 
      count_lamps = count_lamps + 1;
    end;
    
  end;
  
  for i = (count_lamps+1), #private.zz_liftpanel.lamps_connect, 1 do
    ObjAnimate("spr_liftpanel_win_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   0.8, 0, 1 });
  end;
  
  private.zz_liftpanel.state = ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].state;
  ObjSet("tmr_liftpanel_timer",  { time = 0.8, playing = 1, endtrig = private.zz_liftpanel.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_liftpanel.DrawScene()
  
  local count_lamps = 0;
  
  private.zz_liftpanel.CheckWires();
  local wires = private.zz_liftpanel.wires_on;
  
  for i = 1, 5, 1 do
    
    ObjSet("spr_liftpanel_switch_"..i,  { ang = private.zz_liftpanel.switches_ang[ private.zz_liftpanel.state[i] ] });
    
    if wires[ private.zz_liftpanel.lamps_connect[i] ] == 1 then  
      ObjSet("spr_liftpanel_lamp_"..i,  { alp = 1 });
    else 
      count_lamps = count_lamps + 1;
      ObjSet("spr_liftpanel_lamp_"..i,  { alp = 0 });
    end;
    
  end;
  
  for i = 1, count_lamps, 1 do
    ObjSet("spr_liftpanel_win_light_"..i,  { alp = 1 });
  end;
  
  for i = 1, 10, 1 do
    
    if wires[i] == 1 then  
      ObjSet("spr_liftpanel_wire_"..i,  { alp = 1 });
    else 
      ObjSet("spr_liftpanel_wire_"..i,  { alp = 0 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_liftpanel.FocusSwitch( num, inout )
  
  local obj = "spr_liftpanel_switch_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_liftpanel.ClickSwitch( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_clk_panel_button");
  
  local old_state = {};
  
  private.zz_liftpanel.CheckWires();
  
  for i = 1, #private.zz_liftpanel.wires_on, 1 do
    old_state[i] = private.zz_liftpanel.wires_on[i];
  end;
  
  local count_lamps_old, count_lamps_new  = 0, 0;
  
  for i = 1, #private.zz_liftpanel.lamps_connect, 1 do
    
    if private.zz_liftpanel.wires_on[ private.zz_liftpanel.lamps_connect[i] ] == 0 then  
      count_lamps_old = count_lamps_old + 1;
    end;
    
  end;
  
  local new_pos = private.zz_liftpanel.state[ num ] + 1;
  
  if new_pos > 4 then
    new_pos = 1;
  end;
  
  local old_ang = private.zz_liftpanel.switches_ang[ private.zz_liftpanel.state[num] ];
  local new_ang = private.zz_liftpanel.switches_ang[ new_pos ];
  
  if new_pos == 1 then
    new_ang = private.zz_liftpanel.switches_ang[5];
  end;
  
  private.zz_liftpanel.state[num] = new_pos;
  
  private.zz_liftpanel.CheckWires();
  
  for i = 1, #private.zz_liftpanel.lamps_connect, 1 do
    
    if private.zz_liftpanel.wires_on[ private.zz_liftpanel.lamps_connect[i] ] == 0 then  
      count_lamps_new = count_lamps_new + 1;
    end;
    
  end;
  
  local anm_wires = function ()
    
    local need_time = false;
    local wire_on, wire_out = false, false;
    
    for i = 1, #old_state, 1 do
      
      if old_state[i] ~= private.zz_liftpanel.wires_on[i] then
        
        if not need_time then
          need_time = true;
        end;
        
        local lamp = 0;
        
        for j = 1, #private.zz_liftpanel.lamps_connect, 1 do
          
          if private.zz_liftpanel.lamps_connect[j] == i then
            lamp = j;
            break;
          end;
          
        end;
        
        --DbgTrace("lamp "..lamp.." wire "..i);
        
        if old_state[i] == 0 then
          
          if not wire_on then
            wire_on = true;
          end;
          
          ObjAnimate("spr_liftpanel_wire_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
          if lamp > 0 then
            ObjAnimate("spr_liftpanel_lamp_"..lamp, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
          end;
          
        else 
          
          if not wire_out then
            wire_out = true;
          end;
          
          ObjAnimate("spr_liftpanel_wire_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
          if lamp > 0 then
            ObjAnimate("spr_liftpanel_lamp_"..lamp, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
          end;
          
        end;
        
      end;
      
    end;
    
    if wire_out then
      cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_powerdown");
    end;
    
    if wire_on then
      cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_powerup");
    end;
    
    if need_time then
      
      for i = (count_lamps_old+1), count_lamps_new, 1 do
        ObjAnimate("spr_liftpanel_win_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   0.8, 0, 1 });
      end;
      
      for i = count_lamps_old, (count_lamps_new+1), -1 do
        ObjAnimate("spr_liftpanel_win_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   0.8, 0, 0 });
      end;
      
      ObjSet("tmr_liftpanel_timer",  { time = 0.8, playing = 1, endtrig = private.zz_liftpanel.CheckWin });
      
    else 
      private.zz_liftpanel.CheckWin();
    end;
    
  end;
  
  ObjAnimate("spr_liftpanel_switch_"..num, "ang", 0, 0, anm_wires, { 0, 0, old_ang,   0.5, 0, new_ang });
  
end;
-----------------------------------------------------------------------------------
function private.zz_liftpanel.CheckLamp( num )
  
  if private.zz_liftpanel.wires_on[ private.zz_liftpanel.lamps_connect[num] ] == 1 then
    return true;
  else 
    return false;
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_liftpanel.CheckWires()
  
  private.zz_liftpanel.switches_checked = {0, 0, 0, 0, 0};
  private.zz_liftpanel.wires_on = {1, 1, 1, 0, 0, 0, 0, 0, 0, 0};
  
  --start searching from wires that are always on (connected with power)
  for i = 1, #private.zz_liftpanel.always_on, 1 do
    
    private.zz_liftpanel.Search( private.zz_liftpanel.always_on[i] );
    
  end;
  
end;
-----------------------------------------------------------------------------------
--dynamic search from fire to wire through switches
function private.zz_liftpanel.Search( wire )
  
  local wires = private.zz_liftpanel.wires_on;
  
  local switch = {};
  local new_wires = {}; 
  
  for i = 1, #private.zz_liftpanel.switches_wires, 1 do
    for j = 1, #private.zz_liftpanel.switches_wires[i], 1 do
      
      if private.zz_liftpanel.switches_wires[i][j][2] == wire and private.zz_liftpanel.switches_checked[ i ] == 0 then
        local ind = #switch+1;
        switch[ ind ] = {};
        switch[ ind ][1] = i;
        switch[ ind ][2] = private.zz_liftpanel.switches_wires[i][j][1];
        private.zz_liftpanel.switches_checked[ i ] = 1;
        --DbgTrace("switch "..switch[ind][1].." point "..switch[ind][2]);
      end;
      
    end;
  end;
  
  for i = 1, #switch, 1 do
    for j = 1, #private.zz_liftpanel.switches_connect[ switch[i][1] ][ private.zz_liftpanel.state[ switch[i][1] ] ], 1 do
      
      local point = private.zz_liftpanel.switches_connect[ switch[i][1] ][ private.zz_liftpanel.state[ switch[i][1] ] ][j];
      --DbgTrace("switch "..switch[i][1].." point "..point);
      
      if point == switch[i][2] then
        --DbgTrace("switch "..switch[i][1].." point "..switch[i][2]);
        switch[i][3] = true;
      end;
      
    end;
  end;
  
  --DbgTrace(#switch.." "..wire);
  
  for i = 1, #switch, 1 do
    
    if switch[i][3] then
      
      local points = private.zz_liftpanel.switches_connect[ switch[i][1] ][ private.zz_liftpanel.state[ switch[i][1] ] ];
      
      for j = 1, #points, 1 do
        
        --DbgTrace("switch "..switch[i][1].." point "..points[j]);
        
        if points[j] ~= switch[i][2] then
          
          for x = 1, #private.zz_liftpanel.switches_wires[ switch[i][1] ], 1 do
            
            if private.zz_liftpanel.switches_wires[ switch[i][1] ][x][1] == points[j] then
              new_wires[ #new_wires+1 ] = private.zz_liftpanel.switches_wires[ switch[i][1] ][x][2];
              break;
            end;
            
          end;
          
        end;
        
      end;
      
    end;
    
  end;
  
  if #new_wires > 0 then
    
    local check_end = {};
    --local search_end = true;
    
    for i = 1, #new_wires, 1 do
      wires[ new_wires[i] ] = 1;
      check_end[ i ] = false;
      for j = 1, #private.zz_liftpanel.lamps_connect, 1 do
        if private.zz_liftpanel.lamps_connect[j] == new_wires[i] then
          check_end[ i ] = true;
          break;
        end;
      end;
    end;
    
    for i = 1, #new_wires, 1 do
      if not check_end[i] then
        --search_end = false;
        --DbgTrace( new_wires[i] );
        private.zz_liftpanel.Search( new_wires[i] );
      end;
    end;
    
  --  if search_end then
  --    return wires;
  --  end;
  --  
  --else 
  --  
  --  return wires;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_liftpanel.CheckWin()
  
  local win_flag = true;
  private.zz_liftpanel.CheckWires();
  
  for i = 1, 5, 1 do
    
    if private.zz_liftpanel.CheckLamp( i ) then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("liftpanel");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_crash_panel");
    
    ObjAnimate("obj_liftpanel_game_win_lights", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjSet("anm_liftpanel_win_mmg",  { alp = 1, playing = 1, endtrig = private.zz_liftpanel.Win });
    
  else 
    
    cmn.Lock(0);
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_liftpanel.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_liftpanel" );
  cmn.CallEventHandler( "win_liftpanel" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_liftpanel" ].skip == 0 and ng_global.noskipgames[ "win_liftpanel" ] == nil then

    ng_global.noskipgames[ "win_liftpanel" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_hunter_env");
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 0, false, 90);
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Closetdoor *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_clothesroomdoor = {};
public.zz_clothesroomdoor = {};

function private.Init_Closetdoor()
  
  private.zz_clothesroomdoor.win_code = { 8, 3, {6, 0} };
  private.zz_clothesroomdoor.start_code = { 10, 2, {1, 5} };
  private.zz_clothesroomdoor.symbol_names = { "symbol_6", "symbol_7", "symbolroom", "symbol_9", "symbollocked", "symbolopen", "symbol_2", "symbolthings", "symbol_4", "symbol_5" };
  private.zz_clothesroomdoor.symbol_res = "assets/levels/level2/rm_corridor/zz_clothesroomdoor/";
  private.zz_clothesroomdoor.current_place = 0;
  private.zz_clothesroomdoor.in_progress = false;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_clothesroomdoor" ] = {

      type = "click",
      use_place = "obj_clothesroomdoor_game",
      room = "rm_corridor",
      zz = "zz_clothesroomdoor",
      zz_gate = "gzz_corridor_clothesroomdoor"
  };
  -----------------------------------------------------------------------------------
  local win_clothesroomdoor = function ()

    if cmn.IsEventDone( "win_clothesroomdoor" ) then
      
      ObjMultiSet( { {"grm_corridor_clothesroom", { alp = 1, input = 1 }},
                     {"spr_corridor_store_open", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridor_clothesroom_focus");
      end;
      ObjDelete( "gzz_corridor_clothesroomdoor" );
      ObjDelete( "obj_corridor_store_closed" );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_clothesroomdoor", win_clothesroomdoor, "rm_corridor" );

end;
--*********************************************************************************************************************
function private.zz_clothesroomdoor.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state = { 10, 2, {1, 5} }; --entered symbols
  
end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.Reset()
  
  local need_r = false;
  
  for i = 1, #private.zz_clothesroomdoor.state, 1 do
    
    if i < 3 and private.zz_clothesroomdoor.state[i] ~= private.zz_clothesroomdoor.start_code[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local func_after = function ()
        ObjSet("spr_clothesroomdoor_code_"..i,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ private.zz_clothesroomdoor.start_code[i] ] });
        ObjAnimate("spr_clothesroomdoor_code_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
      end;
      ObjAnimate("spr_clothesroomdoor_code_"..i, "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
      
    elseif i == 3 then
      
      for j = 1, 2, 1 do
        
        if private.zz_clothesroomdoor.state[i][j] ~= private.zz_clothesroomdoor.start_code[i][j] then
          
          if not need_r then
            need_r = true;
          end;
          
          local func_after = function ()
            ObjSet("spr_clothesroomdoor_code_"..i.."_"..j,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ private.zz_clothesroomdoor.start_code[i][j] ] });
            ObjAnimate("spr_clothesroomdoor_code_"..i.."_"..j, "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
          end;
          if private.zz_clothesroomdoor.start_code[i][j] == 0 then
            func_after = function() ObjSet("spr_clothesroomdoor_code_"..i.."_"..j,  { alp = 1, res = "" }); end;
          end;
          ObjAnimate("spr_clothesroomdoor_code_"..i.."_"..j, "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
          
        end;
        
      end;
      
    end;
    
  end;
  
  if private.zz_clothesroomdoor.current_place > 0 then
    local old = private.zz_clothesroomdoor.current_place;
    private.zz_clothesroomdoor.current_place = 0;
    if need_r then
      ObjSet("obj_clothesroomdoor_symbols",  { input = 0 });
      private.zz_clothesroomdoor.SelectAnim( old, 0, true );
    else 
      private.zz_clothesroomdoor.SelectAnim( old, 0 );
    end;
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    private.zz_clothesroomdoor.StartConditions();
    private.zz_clothesroomdoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state;
    ObjSet("tmr_clothesroomdoor_timer",  { time = 0.4, playing = 1, endtrig = function () cmn.Lock(0); end; });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.Skip()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state = { 8, 3, {6, 0} };
  
  cmn.Lock( 1 );
  
  for i = 1, #private.zz_clothesroomdoor.state, 1 do
    
    if i < 3 and private.zz_clothesroomdoor.state[i] ~= private.zz_clothesroomdoor.win_code[i] then
      
      local func_after = function ()
        ObjSet("spr_clothesroomdoor_code_"..i,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ private.zz_clothesroomdoor.win_code[i] ] });
        ObjAnimate("spr_clothesroomdoor_code_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
      end;
      ObjAnimate("spr_clothesroomdoor_code_"..i, "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
      
    elseif i == 3 then
      
      for j = 1, 2, 1 do
        
        if private.zz_clothesroomdoor.state[i][j] ~= private.zz_clothesroomdoor.win_code[i][j] then
          
          local func_after = function ()
            ObjSet("spr_clothesroomdoor_code_"..i.."_"..j,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ private.zz_clothesroomdoor.win_code[i][j] ] });
            ObjAnimate("spr_clothesroomdoor_code_"..i.."_"..j, "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
          end;
          if private.zz_clothesroomdoor.win_code[i][j] == 0 then
            func_after = "";
          end;
          ObjAnimate("spr_clothesroomdoor_code_"..i.."_"..j, "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
          
        end;
        
      end;
      
    end;
    
  end;
  
  private.zz_clothesroomdoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state;
  ObjSet("tmr_clothesroomdoor_timer",  { time = 0.4, playing = 1, endtrig = public.zz_clothesroomdoor.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_clothesroomdoor.DrawScene()
  
  for i = 1, 3, 1 do
    
    if i < 3 then
      if private.zz_clothesroomdoor.state[i] > 0 then
        ObjSet("spr_clothesroomdoor_code_"..i,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ private.zz_clothesroomdoor.state[i] ] });
      else 
        ObjSet("spr_clothesroomdoor_code_"..i,  { res = "" });
      end;
    else 
      
      for j = 1, 2, 1 do
        if private.zz_clothesroomdoor.state[i][j] > 0 then
          ObjSet("spr_clothesroomdoor_code_"..i.."_"..j,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ private.zz_clothesroomdoor.state[i][j] ] });
        else 
          ObjSet("spr_clothesroomdoor_code_"..i.."_"..j,  { res = "" });
        end;
      end;
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.FocusButton( name, inout )
  
  local obj = "spr_clothesroomdoor_"..name.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;
  
  local but_type = string.sub(name, 1, string.len(name)-2);
  local but_num = tonumber(string.sub(name, string.len(name), string.len(name)));
  
  --DbgTrace(but_type);
  --DbgTrace(but_num);
  
  --if private.zz_clothesroomdoor.in_progress then
  --  DbgTrace("true");
  --else 
  --  DbgTrace("false");
  --end;
  
  if but_type ~= "code" or but_type == "code" and private.zz_clothesroomdoor.current_place ~= but_num and not private.zz_clothesroomdoor.in_progress then
    ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.ChooseSymbol( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_button_lock");
  
  ObjAnimate("spr_clothesroomdoor_symbol_"..num, "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.15, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_clothesroomdoor_symbol_"..num.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1,   0.3, 0, 0 });
  
  if private.zz_clothesroomdoor.current_place < 3 then
    
    if num == private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place] then
      private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place] = 0;
      ObjSet("spr_clothesroomdoor_code_"..private.zz_clothesroomdoor.current_place,  { res = "" });
    else
      private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place] = num;
      ObjSet("spr_clothesroomdoor_code_"..private.zz_clothesroomdoor.current_place,  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ num ] });
    end;
    
  else 
    
    if num ~= 5 then
      if num == private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place][1] then
        private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place][1] = 0;
        ObjSet("spr_clothesroomdoor_code_"..private.zz_clothesroomdoor.current_place.."_1",  { res = "" });
      else
        private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place][1] = num;
        ObjSet("spr_clothesroomdoor_code_"..private.zz_clothesroomdoor.current_place.."_1",  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ num ] });
      end;
    else 
      if num == private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place][2] then
        private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place][2] = 0;
        ObjSet("spr_clothesroomdoor_code_"..private.zz_clothesroomdoor.current_place.."_2",  { res = "" });
      else
        private.zz_clothesroomdoor.state[private.zz_clothesroomdoor.current_place][2] = num;
        ObjSet("spr_clothesroomdoor_code_"..private.zz_clothesroomdoor.current_place.."_2",  { res = private.zz_clothesroomdoor.symbol_res..private.zz_clothesroomdoor.symbol_names[ num ] });
      end;
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.ChoosePlace( num )
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_button1");
  
  if private.zz_clothesroomdoor.current_place ~= 0 then

    --cancel selection
    if private.zz_clothesroomdoor.current_place == num then

      private.zz_clothesroomdoor.current_place = 0;
      private.zz_clothesroomdoor.SelectAnim( num, 0 );

      --choose new
    else

      local old = private.zz_clothesroomdoor.current_place;
      private.zz_clothesroomdoor.current_place = num;
      private.zz_clothesroomdoor.SelectAnim( num, 1 );
      private.zz_clothesroomdoor.SelectAnim( old, 0, true );

    end;

  --first selected
  else 

    private.zz_clothesroomdoor.current_place = num;
    private.zz_clothesroomdoor.SelectAnim( num, 1 );

  end;
  
end;
-----------------------------------------------------------------------------
function private.zz_clothesroomdoor.SelectAnim( num, inout, no_after )
  
  if not no_after then
    private.zz_clothesroomdoor.in_progress = true;
    cmn.Lock( 1 );
  end;
  
  no_after = no_after or false;

  local name = "spr_clothesroomdoor_code_"..num.."_focus";
  local cur_alp = ObjGet(name).alp;
  
  local func_after = function()
    private.zz_clothesroomdoor.in_progress = false;
    cmn.Lock( 0 );
    ObjSet("obj_clothesroomdoor_symbols",  { input = inout });
  end;
    
  if no_after then
    func_after = "";
  end;

  if inout == 1 then

    ObjAnimate( name, "alp", 0, 0, func_after, { 0, 2, cur_alp,   0.2, 2, 1 });

  elseif inout == 0 then

    ObjAnimate( name, "alp", 0, 0, func_after, { 0, 0, cur_alp,   0.2, 0, 0 });

  end;

end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.ResetCode()
  
  private.zz_clothesroomdoor.in_progress = true;
  cmn.Lock( 1 );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state = { 0, 0, {0, 0} };
  
  ObjAnimate("spr_clothesroomdoor_reset", "alp", 0, 0, function() cmn.Lock( 0 ); private.zz_clothesroomdoor.in_progress = false; end, { 0, 0, 1,   0.15, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_clothesroomdoor_reset_on", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1,   0.3, 0, 0 });
  
  local old = private.zz_clothesroomdoor.current_place;
  
  if old > 0 then
    private.zz_clothesroomdoor.current_place = 0;
    ObjSet("obj_clothesroomdoor_symbols",  { input = 0 });
    private.zz_clothesroomdoor.SelectAnim( old, 0, true );
  end;
  
  for i = 1, #private.zz_clothesroomdoor.state, 1 do
    
    if i < 3 and private.zz_clothesroomdoor.state[i] ~= 0 then
      
      local func_after = function ()
        ObjSet("spr_clothesroomdoor_code_"..i,  { res = "", alp = 1 });
      end;
      ObjAnimate("spr_clothesroomdoor_code_"..i, "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
      
    elseif i == 3 then
      
      for j = 1, 2, 1 do
        
        if private.zz_clothesroomdoor.state[i][j] ~= 0 then
          
          local func_after = function ()
            ObjSet("spr_clothesroomdoor_code_"..i.."_"..j,  { alp = 1, res = "" });
          end;
          ObjAnimate("spr_clothesroomdoor_code_"..i.."_"..j, "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
          
        end;
        
      end;
      
    end;
    
  end;
  
  private.zz_clothesroomdoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].state;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clothesroomdoor.CheckWin()
  
  cmn.Lock( 1 );
  
  ObjAnimate("spr_clothesroomdoor_enter", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_clothesroomdoor_enter_on", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1,   0.3, 0, 0 });
  
  if private.zz_clothesroomdoor.current_place > 0 then
    local old = private.zz_clothesroomdoor.current_place;
    private.zz_clothesroomdoor.current_place = 0;
    private.zz_clothesroomdoor.SelectAnim( old, 0, true );
  end;
  
  local win_flag = true;
  
  for i = 1, #private.zz_clothesroomdoor.state, 1 do
    
    if i < 3 and private.zz_clothesroomdoor.state[i] ~= private.zz_clothesroomdoor.win_code[i] then
      win_flag = false;
      break;
    elseif i == 3 then
      
      for j = 1, 2, 1 do
        
        if private.zz_clothesroomdoor.state[i][j] ~= private.zz_clothesroomdoor.win_code[i][j] then
          win_flag = false;
          break;
        end;
        
      end;
      
    end;
    
  end;
  
  if win_flag then
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("clothesroomdoor");
    
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_opn_door2");
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    ObjAnimate("spr_clothesroomdoor_screen_green", "alp", 0, 0, private.zz_clothesroomdoor.Win, { 0, 0, 0,   0.3, 0, 0,     0.8, 0, 1,    1.5, 0, 1 });
    
  else 
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_wrong_apply" );
    
    ObjAnimate("spr_clothesroomdoor_screen_red", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 1, 0,   0.2, 1, 1,  0.4, 1, 0,   0.6, 1, 1,  0.8, 1, 0,    1, 1, 1,   1.3, 1, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_clothesroomdoor.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_clothesroomdoor" );
  cmn.CallEventHandler( "win_clothesroomdoor" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_clothesroomdoor" ].skip == 0 and ng_global.noskipgames[ "win_clothesroomdoor" ] == nil then

    ng_global.noskipgames[ "win_clothesroomdoor" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  common.CloseSubRoom();
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Medicalcart *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.zz_medicalcart = {};
public.zz_medicalcart = {};

function private.Init_Medicalcart()

  private.right_code = { 7, 2, 6 };
  private.nums_pos = { {-19, 3}, {0, 0}, {19, -3} };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_medicalcart" ] = {
    type = "click",
    use_place = "obj_medicalcart_game_butt_7",
    room = "rm_corridor",
    zz = "zz_medicalcart",
    zz_gate = "gzz_corridor_medicalcart"
  };
  -----------------------------------------------------------------------------------
  local win_medicalcart = function ()

    if cmn.IsEventDone( "win_medicalcart" ) then

      ObjDelete( "anm_medicalcart_use_powder_brush" );
      ObjDelete( "anm_medicalcart_safe_touch" );
      ObjDelete( "obj_medicalcart_game" );
      ObjDelete( "spr_corridor_medcart_safe_door_1" );
      
      ObjMultiSet( { {"obj_medicalcart_safe_drawer", { alp = 1, input = 1 }},
                     {"spr_medicalcart_safe_open", { alp = 1}},
                     {"spr_corridor_medcart_safe_door_2", { alp = 1}} } );

    end;

  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_medicalcart", win_medicalcart, "rm_corridor" );

end;
--********************************************************************************************************************
function private.zz_medicalcart.StartConditions()

  ng_global.progress[ "std" ][ "win_medicalcart" ].state = { 1, { 0, 0, 0 } }; --current code

end;
-----------------------------------------------------------------------------------
function private.zz_medicalcart.DrawScene()

  if private.zz_medicalcart.state[1] < 4 then
    game.hint[ "win_medicalcart" ].use_place = "obj_medicalcart_game_butt_"..private.right_code[ private.zz_medicalcart.state[1] ];
  else 
    ObjSet("obj_medicalcart_game",  { input = 0 });
  end;

  for i = 1, private.zz_medicalcart.state[1]-1, 1 do
  
    ObjSet("txt_medicalcart_code_number_"..i,  { text = private.zz_medicalcart.state[2][i], 
                                                 pos_x = private.nums_pos[ 4-private.zz_medicalcart.state[1]+i ][1], 
                                                 pos_y = private.nums_pos[ 4-private.zz_medicalcart.state[1]+i ][2],
                                                 alp = 1 });
    
  end;

  for i = private.zz_medicalcart.state[1], 3, 1 do
  
    ObjSet("txt_medicalcart_code_number_"..i,  { alp = 0 });
    
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_medicalcart.PushButton( num )

  cmn.Lock(1);

  local cur_num = private.zz_medicalcart.state[1];

  private.zz_medicalcart.state[2][cur_num] = num;
  private.zz_medicalcart.state[1] = private.zz_medicalcart.state[1] + 1;

  ObjSet("txt_medicalcart_code_number_"..cur_num,  { text = private.zz_medicalcart.state[2][cur_num], 
                                                     pos_x = private.nums_pos[3][1], pos_y = private.nums_pos[3][2] });

  local old_xy = {0, 0};
  local new_xy = {0, 0};

  for i = 1, cur_num-1, 1 do
  
    old_xy[1] = private.nums_pos[4-cur_num+i][1];
    old_xy[2] = private.nums_pos[4-cur_num+i][2];

    new_xy[1] = private.nums_pos[3-cur_num+i][1];
    new_xy[2] = private.nums_pos[3-cur_num+i][2];

    ObjAnimate("txt_medicalcart_code_number_"..i, "pos_xy", 0, 0, "", { 0, 0, old_xy[1], old_xy[2],   0.3, 0, new_xy[1], new_xy[2] });
    
  end;
  
  if private.zz_medicalcart.state[2][cur_num] == private.right_code[cur_num] then
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_button1");
  else 
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_clk_error_button");
  end;

  ObjAnimate("txt_medicalcart_code_number_"..cur_num, "alp", 0, 0, function () private.zz_medicalcart.CheckWin(cur_num) end, { 0, 0, 0,   0.3, 0, 1 });

end;
-----------------------------------------------------------------------------------
function private.zz_medicalcart.CheckWin(pos)
  
  pos = pos or false;
  
  if not pos then
    pos = private.zz_medicalcart.state[1]-1;
  end;
  
  if private.zz_medicalcart.state[1] == 4 and private.zz_medicalcart.state[2][pos] == private.right_code[pos] then
    
    ObjAnimate("obj_medicalcart_game_code", "alp", 0, 0, private.zz_medicalcart.Win, { 0, 0, 1,   1, 0, 1,  1.5, 0, 0 });

  elseif pos > 0 and  private.zz_medicalcart.state[2][pos] ~= private.right_code[pos] then

    local func_after = function ()

      cmn.Lock(0);

      for i = 1, 4, 1 do
  
        ObjSet("txt_medicalcart_code_number_"..i,  { alp = 0, text = "" });
        
      end;

      ObjSet("obj_medicalcart_game_code",  { alp = 1 });

    end;

    game.hint[ "win_medicalcart" ].use_place = "obj_medicalcart_game_butt_7";
    private.zz_medicalcart.state[1] = 1;

    for i = 1, 4, 1 do

      private.zz_medicalcart.state[2][i] = 0;
      
    end;

    --cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/");
    ObjAnimate("obj_medicalcart_game_code", "alp", 0, 0, func_after, { 0, 1, 1,   0.2, 1, 0,  0.4, 1, 1,   0.6, 1, 0,  0.8, 1, 1,    1, 1, 0,   1.2, 1, 1,  1.5, 1, 0 });

  elseif pos then

    game.hint[ "win_medicalcart" ].use_place = "obj_medicalcart_game_butt_"..private.right_code[pos+1];
    cmn.Lock(0);

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_medicalcart.Win()

  cmn.SetEventDone( "win_medicalcart" );

  local func_after = function ()

    cmn.CallEventHandler( "win_medicalcart" );

    cmn.Lock(0);

  end;

  --cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/");

  ObjSet("obj_medicalcart_safe_drawer",  { alp = 1 });
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_opn_safe");
      
  ObjAnimate("anm_medicalcart_use_powder_brush", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("anm_medicalcart_safe_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_medicalcart_safe_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

end;
---------------------------------------------------------------------
--****************************************************************************************
