-- name=ho_fishermans
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_fishermans" );
  game.relations[ "ho_fishermans" ].exitroom = "rm_street";
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_fishermans" ] = 
  {
    type = "win",
    room = "rm_street",
    zz = "ho_fishermans",
    zz_gate = "gho_street_fishermans"
  };
  --------------------------------------------------------------------------------------------------
  local win_fishermans_func = function ()

    if ( cmn.IsEventDone( "win_fishermans" ) ) then
      interface.InventoryItemAdd( "inv_sidecutters", "spr_fishermans_win" );
      ObjDelete("gho_street_fishermans");
    end;

  end;
  local win_fishermans_loc = function ()
    if ( cmn.IsEventDone( "win_fishermans" ) ) then
      ObjDelete( "spr_street_ho_fishermans_glass1" );
      ObjSet( "spr_street_ho_fishermans_glass2", { alp = 1 } );
    end;
  end;
  cmn.AddSubscriber( "win_fishermans", win_fishermans_func );
  cmn.AddSubscriber( "win_fishermans", win_fishermans_loc, "rm_street" );
  --------------------------------------------------------------------------------------------------
  local start_fishermans_func = function ()

    if ( cmn.IsEventStart( "win_fishermans" ) ) then

      common_impl.ProcessHoStart( "fishermans" );

    end;

  end;
  cmn.AddSubscriber( "win_fishermans", start_fishermans_func, "ho_fishermans" );
  
  --for secretroom
  private.tasks =  {    
  
      { "morphitem",    1, 0, { { "obj_fishermans_morphitem1", "spr_fishermans_morphitem11", "spr_fishermans_morphitem12" } } },
      { "morphitem",    1, 0, { { "obj_fishermans_morphitem2", "spr_fishermans_morphitem21", "spr_fishermans_morphitem22" } } },
      { "morphitem",    1, 0, { { "obj_fishermans_morphitem3", "spr_fishermans_morphitem31", "spr_fishermans_morphitem32" } } },
      { "morphitem",    1, 0, { { "obj_fishermans_morphitem4", "spr_fishermans_morphitem41", "spr_fishermans_morphitem42" } } },
      { "morphitem",    1, 0, { { "obj_fishermans_morphitem5", "obj_fishermans_morphitem51", "obj_fishermans_morphitem52",
                                  "spr_fishermans_hook", "spr_fishermans_hook_shadow", "spr_fishermans_pin", "spr_fishermans_pin" } } },
      { "morphitem",    1, 0, { { "obj_fishermans_morphitem6", "spr_fishermans_morphitem61", "spr_fishermans_morphitem62" } } },
      
      { "anchor",     1, 0, { { "spr_fishermans_anchor" } } },
      { "matches",    1, 0, { { "spr_fishermans_matches" } } },
      { "binoculars", 1, 0, { { "spr_fishermans_binoculars" } } },
      { "cup",        1, 0, { { "spr_fishermans_cup" } } },
      { "chair",      1, 0, { { "obj_fishermans_chair", "spr_fishermans_chair", "spr_fishermans_chair_shadow" } } },
      { "fishnet",    1, 0, { { "spr_fishermans_fishnet" } } },
      { "flashlight", 1, 0, { { "spr_fishermans_flashlight" } } },
      { "flint",      1, 0, { { "spr_fishermans_flint", "spr_fishermans_flint_shadow" } } }
      
  };
    
  private.start = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ( ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage ) or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state = { 2, 2, 2, 2, 2, 2 };  --номер отоброжаемого спрайта, 0 - собран
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");
	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_street" );
    cmn.StartTimePassing("ho_fishermans");
  else 
    
    private.CreateNewObjects();
    
    private.morph_item_anim_start = false;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage = { 1, 2 }; 
    ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state = { 2, 2, 2, 2, 2, 2 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_fishermans_street",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                       event_menter = function () rm_extra.GateMouseEnter( "fishermans_street", CURSOR_DOWN, "extra" ); end, 
                                       event_mleave = function () common_impl.GateMouseLeave( "fishermans_street" ); end });
    
  end;

  if not cmn.IsEventStart( "win_fishermans" ) then
    cmn.InitHo( "fishermans" );
  end;

  if  not cmn.IsEventDone("win_fishermans")
  and ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage[1]
  <=  ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage[2] then

    interface_impl.TaskPanelShow( private.stages_task() );

  else
    common_impl.DialogHo_Show();
  end;

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].found;
  for i = 1, #ho_found, 1 do
    if ho_found[ i ][ "task" ] == "chair" then
      ObjDelete( "spr_fishermans_chair_shadow" );
    elseif ho_found[ i ][ "task" ] == "flint" then
      ObjDelete( "spr_fishermans_flint_shadow" );
    end;
  end;

  private.DrawScene();

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    for i = 1, 6, 1 do
      
      local prefix = "spr";
      if i == 5 then
        prefix = "obj";
      end;
        
      if ( ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state[ i ] ~= 0 ) then
      
        ObjStopAnimate(prefix.."_fishermans_morphitem"..i.."2", "alp");
        ObjStopAnimate(prefix.."_fishermans_morphitem"..i.."1", "alp");

      end;

    end;
    
    ObjSet("grm_fishermans_street",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_fishermans");

    if ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_fishermans" ] then

      ng_global.nohintho[ "win_fishermans" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_fishermans" ] then
      ng_global.playedhops[ "win_fishermans" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_fishermans_street",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )

  if task_name == "chair" then
    ObjDelete( "spr_fishermans_chair_shadow" );
  elseif task_name == "flint" then
    ObjDelete( "spr_fishermans_flint_shadow" );
  end;
  
  cmn.HoTaskFind( item_name, task_name, 1 );

end;
--*********************************************************************************************************************
function public.MorphItemFound( item )
  
  local prefix = "spr";

  if item == 5 then
    prefix = "obj";
    ObjDelete( "spr_fishermans_hook_shadow" );
    ObjDelete( "spr_fishermans_pin_shadow" );
  end;

  local item_state = ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state[ item ];
  local item_state_2 = 2;
  if ( item_state == 2 ) then
    item_state_2 = 1;
  end;

  --DbgTrace( "***MorphItemFound: "..item..item_state );

  ObjStopAnimate( prefix.."_fishermans_morphitem"..item..item_state, 8 );
  ObjSet( prefix.."_fishermans_morphitem"..item..item_state, { alp = 1 } );

  ObjStopAnimate( prefix.."_fishermans_morphitem"..item..item_state_2, 8 );
  ObjSet( prefix.."_fishermans_morphitem"..item..item_state_2, { alp = 0 } );

  cmn.HoTaskFind( "obj_fishermans_morphitem"..item, "morphitems" );

  ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state[ item ] = 0;

end;
--*********************************************************************************************************************
function private.DrawScene()

  if  ( ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage[1] == 1 )
  and ( not private.morph_item_anim_start ) then

    --DbgTrace( "***DrawScene" );

    private.morph_item_anim_start = true;

    for i = 1, 6, 1 do
      
      local prefix = "spr";
      if i == 5 then
        prefix = "obj";
      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state[ i ] ~= 0 ) then

        --DbgTrace( "morph item "..i );

        ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state[ i ] = 2;

        ObjSet( prefix.."_fishermans_morphitem"..i.."1", { alp = 0, input = false } );

        ObjAnimate( prefix.."_fishermans_morphitem"..i.."2", "alp", 0, 0, function () private.MorphItemAnim( i, 2 ) end, 
          { 0, 0, 1,    math.random( 2, 8 ), 0, 1 } );

      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.MorphItemAnim( item, num )

  --DbgTrace( "***MorphItemAnim: "..item..num );
  
  local prefix = "spr";
  if item == 5 then
    prefix = "obj";
  end;

  local next_num = 2;
  if ( num == 2 ) then
    next_num = 1;
  end;

  ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].morph_item_state[ item ] = next_num;

  ObjMultiSet( { { prefix.."_fishermans_morphitem"..item..num,      { input = false } },
                 { prefix.."_fishermans_morphitem"..item..next_num, { input = true } } } );

  ObjAnimate( prefix.."_fishermans_morphitem"..item..num,      "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  ObjAnimate( prefix.."_fishermans_morphitem"..item..next_num, "alp", 0, 0, function () private.MorphItemAnim( item, next_num ) end, 
    { 0, 0, 0,    0.5, 0, 1,    math.random( 2, 8 ), 0, 1 } );

end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_fishermans" ].stage[1];

  if     ( ho_stage == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "morphitems", 6, 0, {
      { "obj_fishermans_morphitem1" },
      { "obj_fishermans_morphitem2" },
      { "obj_fishermans_morphitem3" },
      { "obj_fishermans_morphitem4" },
      { "obj_fishermans_morphitem5" },
      { "obj_fishermans_morphitem6" }
    } );

  elseif ( ho_stage == 2 ) then

    ObjMultiSet( { 
      { "spr_fishermans_anchor", { input = true } },
      { "spr_fishermans_matches", { input = true } },
      { "spr_fishermans_binoculars", { input = true } },
      { "spr_fishermans_cup", { input = true } },
      { "obj_fishermans_chair", { input = true } },
      { "spr_fishermans_fishnet", { input = true } },
      { "spr_fishermans_flint", { input = true } },
      { "spr_fishermans_flashlight", { input = true } }
    } );

    interface.TaskPanelTaskAdd( ho_tasks, "anchor", 1, 0,     { { "spr_fishermans_anchor" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "matches", 1, 0,    { { "spr_fishermans_matches" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "binoculars", 1, 0, { { "spr_fishermans_binoculars" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "cup", 1, 0,        { { "spr_fishermans_cup" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "chair", 1, 0,      { { "obj_fishermans_chair" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "fishnet", 1, 0,    { { "spr_fishermans_fishnet" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "flint", 1, 0,      { { "spr_fishermans_flint" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "flashlight", 1, 0, { { "spr_fishermans_flashlight" } } );

  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_2()
  interface_impl.TaskPanelSetNewTask( private.stages_task() );
end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

end;
--*********************************************************************************************************************