-- name=ho_onbasrelief
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_onbasrelief" );
  game.relations[ "ho_onbasrelief" ].exitroom = "rm_castlehall";
  --------------------------------------------------------------------------------------------------

  private.item_win_pos = { 
    { 671, 567 }, { 844, 223 }, { 42, 381 }, { 893, 124 }, --{ 965, 536 }, 
    { 81, 119 }, { 315, 450 }, { 690, 221 }, { 173, 176 }, { 808, 63 }, { 866, 327 }, { 224, 207 }
  };

  private.item_start_pos = { 
    { 198, 537 }, { 728, 384 }, { 510, 521 }, { 283, 372 }, --{ 825, 442 }, 
    { 465, 138 }, { 902, 460 }, { 150, 380 }, { 943, 265 }, { 377, 441 }, { 510, 195 }, { 593, 588 }
  };
  ------------------------------------------------------------------------------

  game.onbasrelief = {};
  game.onbasrelief.double_hint = {
    { "spr_onbasrelief_basrelief1",  "spr_onbasrelief_basrelief1_light" },
    { "spr_onbasrelief_basrelief2",  "spr_onbasrelief_basrelief2_light" },
    { "spr_onbasrelief_basrelief3",  "spr_onbasrelief_basrelief3_light" },
    { "spr_onbasrelief_basrelief4",  "spr_onbasrelief_basrelief4_light" },
    { "spr_onbasrelief_basrelief5",  "spr_onbasrelief_basrelief5_light" },
    { "spr_onbasrelief_basrelief6",  "spr_onbasrelief_basrelief6_light" },
    { "spr_onbasrelief_basrelief7",  "spr_onbasrelief_basrelief7_light" },
    { "spr_onbasrelief_basrelief8",  "spr_onbasrelief_basrelief8_light" },
    { "spr_onbasrelief_basrelief9",  "spr_onbasrelief_basrelief9_light" },
    { "spr_onbasrelief_basrelief10", "spr_onbasrelief_basrelief10_light" },
    { "spr_onbasrelief_basrelief11", "spr_onbasrelief_basrelief11_light" },
    --{ "spr_onbasrelief_basrelief12", "spr_onbasrelief_basrelief12_light" }
  };

  ------------------------------------------------------------------------------

  game.hint[ "win_onbasrelief" ] = 
  {
    type = "win",
    room = "rm_castlehall",
    zz = "ho_onbasrelief",
    zz_gate = "gho_castlehall_onbasrelief"
  };
  --------------------------------------------------------------------------------------------------
  local win_onbasrelief_func = function ()

    if ( cmn.IsEventDone( "win_onbasrelief" ) ) then
      common_impl.InventoryComplexItemAdd( "inv_casket", "spr_onbasrelief_win" );
      ObjDelete("gho_castlehall_onbasrelief");
    end;

  end;
  cmn.AddSubscriber( "win_onbasrelief", win_onbasrelief_func );
  --------------------------------------------------------------------------------------------------
  local start_onbasrelief_func = function ()

    if ( cmn.IsEventStart( "win_onbasrelief" ) ) then

      common_impl.ProcessHoStart( "onbasrelief" );

    end;

  end;
  cmn.AddSubscriber( "win_onbasrelief", start_onbasrelief_func, "ho_onbasrelief" );
  
  --for secretroom
  private.tasks2 =  {    
    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief1_fly" } } },
    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief2_fly" } } },
    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief3_fly" } } },
    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief4_fly" } } },

    { "basrelief", 1, 0, { { "obj_onbasrelief_basrelief5_fly" } } },
    { "basrelief", 1, 0, { { "obj_onbasrelief_basrelief6_fly" } } },
    { "basrelief", 1, 0, { { "obj_onbasrelief_basrelief7_fly" } } },
    { "basrelief", 1, 0, { { "obj_onbasrelief_basrelief8_fly" } } },

    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief9_fly" } } },
    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief10_fly" } } },
    { "basrelief",  1, 0, { { "obj_onbasrelief_basrelief11_fly" } } },
    --{ "basrelief",  1, 0, { { "obj_onbasrelief_basrelief12_fly" } } },
    
    { "box",      1, 0, { { "spr_onbasrelief_box", "spr_onbasrelief_box_shadow" } } }
  };
    
  private.start = {};
  
  for i = 1, #private.tasks2, 1 do

    for j = 1, private.tasks2[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks2[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage then

    ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage = { 1, 2 };
    ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].complete = 
    { false, false, false, false, false, false, false, false, false, false, false--, false
    };
      
  elseif ng_global.currentprogress == "secret" then
      
    ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage = { 1, 2 };
    ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].complete = 
    { false, false, false, false, false, false, false, false, false, false, false--, false 
    };

  end;

  private.complete = ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].complete;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_castlehall_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_castlehall_env");
  if port.isPortable() == 1 then
    iOS_EnableMultiTouch(1); 
  end;
  if ng_global.currentprogress == "std" then
  
    common.SetPreviousRoom( "rm_castlehall" );
    cmn.StartTimePassing("ho_onbasrelief");
    
  else 
    
    private.CreateNewObjects();
    
    ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage = { 1, 2 };
    ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].complete = 
    { false, false, false, false, false, false, false, false, false, false, false--, false 
    };
      
    private.complete = ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].complete;  
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_onbasrelief_castlehall",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                            event_menter = function () rm_extra.GateMouseEnter( "onbasrelief_castlehall", CURSOR_DOWN, "extra" ); end, 
                                            event_mleave = function () common_impl.GateMouseLeave( "onbasrelief_castlehall" ); end });
    
  end;
  
  private.DrawScene();

  if not cmn.IsEventStart( "win_onbasrelief" ) then
    cmn.InitHo( "onbasrelief" );
  end;

  if  not cmn.IsEventDone("win_onbasrelief")
  and ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage[1] 
  <=  ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage[2] then

    interface_impl.TaskPanelShow( private.stages_task() );

  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_onbasrelief_castlehall",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_onbasrelief");

    if ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_onbasrelief" ] then

      ng_global.nohintho[ "win_onbasrelief" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_onbasrelief" ] then
      ng_global.playedhops[ "win_onbasrelief" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_onbasrelief_castlehall",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function private.DrawScene()

  for i = 1, 11, 1 do
    if ( private.complete[i] ) then
      ObjDelete( "spr_onbasrelief_basrelief"..i.."_shadow" );
      ObjSet( "spr_onbasrelief_basrelief"..i, { pos_x = private.item_win_pos[i][1], pos_y = private.item_win_pos[i][2], input = false } );
    else 
      ObjSet( "spr_onbasrelief_basrelief"..i, { pos_x = private.item_start_pos[i][1], pos_y = private.item_start_pos[i][2], input = true } );
    end;
  end;

  if ( private.complete[7] ) then
    ObjSet( "spr_onbasrelief_basrelief7", { pos_x = 0, pos_y = 0 } );
    ObjAttach( "spr_onbasrelief_basrelief7", "obj_onbasrelief_basrelief7" );
  else 
    ObjSet( "spr_onbasrelief_basrelief7", { pos_x = 150, pos_y = 380 } );
    ObjAttach( "spr_onbasrelief_basrelief7", "ho_onbasrelief" );
  end;

  if ( private.complete[10] ) then
    ObjSet( "spr_onbasrelief_basrelief10", { ang = -1.19 } );
  else 
    ObjSet( "spr_onbasrelief_basrelief10", { ang = 0.909999 } );
  end;

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage[1] == 2 ) then
    ObjMultiSet( { { "spr_onbasrelief_box", { input = true } },
                   { "anm_onbasrelief_hands_queen", { frame = 91 } } } );
  else 
    ObjMultiSet( { { "spr_onbasrelief_box", { input = false } },
                   { "anm_onbasrelief_hands_queen", { frame = 0, playing = 0 } } } );
  end;

end;
--*********************************************************************************************************************
function private.ItemFound( num )

  if ( num == 7 ) then
    ObjSet( "spr_onbasrelief_basrelief7", { pos_x = 0, pos_y = 0 } );
    ObjAttach( "spr_onbasrelief_basrelief7", "obj_onbasrelief_basrelief8" );
  end;

  cmn.HoTaskFind( "obj_onbasrelief_basrelief"..num.."_fly", "basrelief" );

  private.complete[ num ] = true;
  
  public.LightAnim(num,0);

end;
--*********************************************************************************************************************
function public.BoxFound()

  ObjDelete( "spr_onbasrelief_box_shadow" );

  cmn.HoTaskFind( "spr_onbasrelief_box", "box", 1 );

end;
--*********************************************************************************************************************
function public.StartDragItem( num )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");

  private.drag_item = num;

  ObjAttach( "spr_onbasrelief_basrelief"..num, "obj_onbasrelief_fly" );

  ObjAnimate( "spr_onbasrelief_basrelief"..num.."_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.05, 0, 0 } );

end;
--*********************************************************************************************************************
function public.DropDragItem( num )

  public.LightAnim( num, 0 );

  local item = "spr_onbasrelief_basrelief"..num;

  ObjAttach( item, "ho_onbasrelief" );

  if ( ObjIntersect( item, item.."_light" ) ) then
    
    cmn.PlayAudio("snd", "assets/levels/level3/ho_onbasrelief/audio/aud_xx_use_stone3");

    local curspos = GetZoomCursorPos();
    --port feature
    if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
    
    ObjMultiSet( { 
      { item, { pos_x = curspos[1], pos_y = curspos[2], input = false } },
      { "obj_onbasrelief_basrelief"..num.."_fly", { pos_x = private.item_win_pos[num][1], pos_y = private.item_win_pos[num][2] } } 
    } );

    ObjAnimate( item, "pos_xy", 0, 0, function () private.ItemFound( num ); end, { 
      0,    0, curspos[1], curspos[2],
      0.15, 0, private.item_win_pos[num][1], private.item_win_pos[num][2]
    } );

    if ( num == 10 ) then
      ObjAnimate( item, "ang", 0, 0, "", { 
        0,    0, 0.909999,
        0.15, 0, -1.19
      } );
    end;

  else

    ObjAnimate( item.."_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.05, 0, 1 } );

    cmn.WrongApply();  

  end;


end;
--*********************************************************************************************************************
function public.LightAnim( num, inout )

  if ( private.drag_item ~= num ) then
    return;
  end;

  local obj = "spr_onbasrelief_basrelief"..num.."_light"
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    --SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    --SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_onbasrelief" ].stage[1];

  if ( ho_stage == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "basrelief", 11, 0, { 
      { "spr_onbasrelief_basrelief1" },
      { "spr_onbasrelief_basrelief2" },
      { "spr_onbasrelief_basrelief3" },
      { "spr_onbasrelief_basrelief4" },
      { "spr_onbasrelief_basrelief5" },
      { "spr_onbasrelief_basrelief6" },
      { "spr_onbasrelief_basrelief7" },
      { "spr_onbasrelief_basrelief8" },
      { "spr_onbasrelief_basrelief9" },
      { "spr_onbasrelief_basrelief10" },
      { "spr_onbasrelief_basrelief11" },
      --{ "spr_onbasrelief_basrelief12" }
    } );

  elseif ( ho_stage == 2 ) then

    game.onbasrelief.double_hint = nil;

    interface.TaskPanelTaskAdd( ho_tasks, "box",  1, 0, { { "spr_onbasrelief_box" } } );

  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
function public.stage_2()

  local func_after = function ()

    ObjSet( "spr_onbasrelief_box", { input = true } );

  end;

  interface_impl.TaskPanelSetNewTask( private.stages_task() );
  
  cmn.PlayAudio("snd", "assets/levels/level3/ho_onbasrelief/audio/aud_win_basrelief");

  ObjSet( "anm_onbasrelief_hands_queen", { endtrig = func_after, playing = true } );

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

end;
--*********************************************************************************************************************
