-- name=mg_fightingqueen
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_fightingqueen";
  --------------------------------------------------------------------------------------------
  private.chosen_symbol = 0;
  private.crows_active = false;
  private.snakes_order = {3, 2, 1};
  private.bow_pos = 540;
  private.cur_progress = "std";
  --------------------------------------------------------------------------------------------
  -- function win_fightingqueen () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_fightingqueen" ] = {
    type = "win",
    room = "rm_castlehall",
    zz = "mg_fightingqueen",
    zz_gate = "gmg_castlehall_fightingqueen"
  };
  --------------------------------------------------------------------------------------------
  local win_fightingqueen_game = function ()

    if cmn.IsEventDone( "win_fightingqueen" ) then
      ObjDelete("inv_magiconion_arrow");
    end;

  end;
  local win_fightingqueen_loc = function ()

    if cmn.IsEventDone( "win_fightingqueen" ) then
      ObjDelete("gmg_castlehall_fightingqueen");
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_fightingqueen", win_fightingqueen_game );
  cmn.AddSubscriber( "win_fightingqueen", win_fightingqueen_loc, "rm_castlehall" );
  
  --------------------------------------------------------------------------------------------
  -- function opn_fightingqueen () end;
  --------------------------------------------------------------------------------------------
  local opn_fightingqueen_loc = function ()

    ObjDelete("anm_fightingqueen_game_start");

  end;
  local opn_fightingqueen_map = function ()

    int_map_impl.BlockRoom( "rm_witchhouse" );
    int_map_impl.BlockRoom( "rm_housegarden" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_fightingqueen", opn_fightingqueen_loc, "mg_fightingqueen" );
  cmn.AddSubscriber( "opn_fightingqueen", opn_fightingqueen_map );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  if ng_global.currentprogress == "std" then

    if cmn.IsEventDone("opn_fightingqueen") and not(cmn.IsEventDone( "win_fightingqueen" )) then
      
      cmn.MiniGameShow();
      private.CheckWin();
      cmn.StartTimePassing("mg_fightingqueen");
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);
      
    elseif not cmn.IsEventDone( "opn_fightingqueen" ) then
      cmn.SetEventDone("opn_fightingqueen");
      private.AnimGameStart();
    end;
    
  else 
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);
    rm_extra.MiniGameShow();
    
    for i = 1, 3, 1 do
      ObjAttach("anm_fightingqueen_snake_head_"..i, "anm_fightingqueen_snake_"..i);
    end;
    
    local func_set = function ()
      ObjSet("spr_fightingqueen_black",  { input = 0 });
    end;
    
    ObjAnimate("spr_fightingqueen_black", "alp", 0, 0, func_set, { 0, 0, 1,   0.3, 0, 0 });
    
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_castlehall_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_castlehall_env");
  
  if ng_global.currentprogress == "std" then
    
    private.cur_progress = "std";
    
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, true );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    
    common.SetPreviousRoom( "rm_castlehall" );
    
    if cmn.IsEventDone("opn_fightingqueen") then
      private.DrawScene();
      cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_env");
    else 
      cmn.Lock(1);
    end;
    
  else 
    
    private.cur_progress = "secret";
    
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_env");
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].state;
    
    private.chosen_symbol = 0;
    private.crows_active = false;
    
    private.DrawScene();
    
    for i = 1, 3, 1 do
      
      ObjMultiSet( { {"anm_fightingqueen_snake_head_"..i, { alp = 1, frame = 0 }},
                     {"anm_fightingqueen_snake_explode_"..i, { frame = 0 }},
                     {"anm_fightingqueen_snake_attack_"..i, { frame = 0 }},
                     {"fx_fightingqueen_snake_fire_"..i, { active = 0, visible = 0 }} } );
      
      ObjAttach("anm_fightingqueen_snake_head_"..i, "anm_fightingqueen_snake_"..i);
      ObjAttach("anm_fightingqueen_snake_explode_"..i, "obj_fightingqueen_fx_to_add");
      ObjAttach("anm_fightingqueen_snake_attack_"..i, "obj_fightingqueen_fx_to_add");
      ObjAttach("fx_fightingqueen_snake_dead_"..i, "obj_fightingqueen_fx_to_add");
      ObjAttach("fx_fightingqueen_crow_explode_"..i, "obj_fightingqueen_crows");
      
      for j = 1, #private.state[i], 1 do
        
        ObjMultiSet( { {"spr_fightingqueen_lvl_"..i.."_"..j.."_1_on", { alp = 0 }},
                       {"spr_fightingqueen_lvl_"..i.."_"..j.."_2_on", { alp = 0 }} } );
        
      end;
                     
    end;
    
    ObjMultiSet( { {"grm_fightingqueen_castlehall", { input = 1 }},
                   {"anm_fightingqueen_game_start", { alp = 0 }},
                   {"spr_fightingqueen_black", { alp = 1, input = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_fightingqueen_castlehall_focus");
    end;
  end;
                 
  private.MoveBow();
                 
end;
--*********************************************************************************************************************
function public.Close()
  
  if private.cur_progress == "std" then
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_fightingqueen" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_fightingqueen" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  local tme = 0;
  
  local end_reset = function ()
    
    --DbgTrace("end_reset");
    
    private.DrawScene( true );
    cmn.Lock(0);
    
  end;
  
  if private.state[5] == 0 and not private.crows_active then
    
    tme = 0.5;
    
    for i = 1, #private.state[ private.state[4] ], 1 do
          
      if private.state[ private.state[4] ][i] == 1 then
        
        if not need_r then
          need_r = true;
        end;
        
        ObjMultiSet( { {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1_on", { alp = 0 }},
                       {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2_on", { alp = 0 }} } );
        
        ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
    end;
    
  else 
    
    need_r = true;
    
    tme = 1;
    
    local anm_dragon = function ()
      
      --DbgTrace("anm_dragon");
      
      local snake = private.snakes_order[ private.state[4] ];
      
      for i = 1, 3, 1 do
      
        if private.state[6][i] == 0 then
          
          ObjAttach("fx_fightingqueen_crow_explode_"..i, "obj_fightingqueen_fx_to_add");
          ObjSet("fx_fightingqueen_crow_explode_"..i,  { active = false, visible = false });
          
        end;
        
      end;
      
      cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_env");
      
      ObjSet("anm_fightingqueen_snake_head_"..snake,  { alp = 0, playing = 1 });
      ObjAttach("anm_fightingqueen_snake_head_"..snake, "anm_fightingqueen_snake_"..snake);
      
      ObjAnimate("anm_fightingqueen_snake_head_"..snake, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("fx_fightingqueen_snake_dead_"..snake, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      private.AnmDragonFire( snake );
      
      for i = 1, #private.state[ private.state[4] ], 1 do
          
        ObjMultiSet( { {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1_on", { alp = 0 }},
                       {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2_on", { alp = 0 }} } );
        ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_clk_raven");
    
    cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_castlehall_env");
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_env");
    
    for i = 1, 3, 1 do
      
      if private.state[6][i] == 0 then
        
        ObjAttach("fx_fightingqueen_crow_explode_"..i, "obj_fightingqueen_crows");
        local pos = GetObjPosByObj("anm_fightingqueen_crow_"..i);
        ObjSet("fx_fightingqueen_crow_explode_"..i,  { pos_x = pos[1], pos_y = pos[2], active = true, visible = true });
        PartSysRestart("fx_fightingqueen_crow_explode_"..i);
        ObjAnimate("obj_fightingqueen_crow_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
    end;
    
    ObjSet("tmr_fightingqueen_timer_2",  { time = 0.5, playing = 1, endtrig = anm_dragon });
    
  end;
  
  if private.chosen_symbol > 0 then
    
    local pair = math.floor(private.chosen_symbol/10);
    local num = private.chosen_symbol - pair*10;
    private.chosen_symbol = 0;
    
    if not need_r then
      cmn.Lock( 1 );
      ObjAnimate( "spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0 });
    else 
      ObjAnimate( "spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    
    private.crows_active = false;
    
    private.state[5] = 0;
    private.state[6] = {0, 0, 0};
    
    for i = 1, #private.state[ private.state[4] ], 1 do
      private.state[ private.state[4] ][i] = 0;
    end;
    
    ObjSet("tmr_fightingqueen_timer",  { time = tme, playing = 1, endtrig = end_reset });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].state = { {1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1, 1}, 4, 0, {0, 0, 0} };
  
  if private.state[5] == 0 and not private.crows_active then
    
    for i = 1, #private.state[ private.state[4] ], 1 do
          
      if private.state[ private.state[4] ][i] == 0 then
        ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
    end;
    
  else 
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_clk_raven");
    
    cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_castlehall_env");
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_env");
    
    for i = 1, 3, 1 do
      
      if private.state[6][i] == 0 then
        
        ObjAttach("fx_fightingqueen_crow_explode_"..i, "obj_fightingqueen_crows");
        local pos = GetObjPosByObj("anm_fightingqueen_crow_"..i);
        ObjSet("fx_fightingqueen_crow_explode_"..i,  { pos_x = pos[1], pos_y = pos[2], active = true, visible = true });
        PartSysRestart("fx_fightingqueen_crow_explode_"..i);
        ObjAnimate("obj_fightingqueen_crow_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
    end;
    
  end;
  
  local end_skip = function ()
    
    private.Win();
    
  end;
  
  local anm_dragons = function ()
    
    if not private.crows_active or private.state[4] < 3 then
      
      ObjSet("tmr_fightingqueen_timer",  { time = 1, playing = 1, endtrig = end_skip });
      
      local dragon = private.state[4];
      if private.crows_active then
        dragon = dragon + 1;
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_dead");
    
      for i = dragon, 3, 1 do
        
        local crows_cast = function ()
      
          local snake = private.snakes_order[ i ];
          
          ObjAttach("anm_fightingqueen_snake_explode_"..snake, "obj_fightingqueen_fx_to_add");
          ObjAttach("fx_fightingqueen_snake_dead_"..snake, "anm_fightingqueen_snake_"..snake);
        
        end;
                       
        local snake = private.snakes_order[ i ];
                       
        --snake head explode
        ObjAttach("anm_fightingqueen_snake_head_"..snake, "obj_fightingqueen_fx_to_add");
        ObjAttach("anm_fightingqueen_snake_explode_"..snake, "anm_fightingqueen_snake_"..snake);
        
        ObjMultiSet( { {"anm_fightingqueen_snake_head_"..snake, { frame = 0, playing = 0 }},
                       {"anm_fightingqueen_snake_explode_"..snake, { alp = 1, playing = 1, endtrig = crows_cast }} } );
        
      end;
                     
    else
      end_skip();               
    end;
    
  end;
    
  ObjSet("tmr_fightingqueen_timer",  { time = 0.5, playing = 1, endtrig = anm_dragons });

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].state = { {0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0, 0}, 1, 0, {0, 0, 0} }; --[1]-[3] - собранные пары каждого лвла, [4] - текущий лвл

end;
-----------------------------------------------------------------------------------
function private.AnimGameStart()
  
  local end_func = function ()
    
    private.DrawScene( true );
    cmn.Lock(0);
    cmn.CallEventHandler("opn_fightingqueen");
    
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_env");
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);
    
    if ng_global.currentprogress == "std" then
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_fightingqueen");
    else 
      rm_extra.MiniGameShow();
    end;
    
    for i = 1, 3, 1 do
      private.AnmDragonFire( i );
    end;
    
  end;
  
  local func_after = function ()
    
    ObjMultiSet( { {"anm_fightingqueen_portal_front", { alp = 1, playing = 1 }},
                   {"anm_fightingqueen_portal_back", { alp = 1, playing = 1 }},
                   {"anm_fightingqueen_game_start", { alp = 0 }} } );
    
    for i = 1, 3, 1 do
      
      ObjMultiSet( { {"anm_fightingqueen_snake_"..i, { alp = 1, playing = 1 }},
                     {"anm_fightingqueen_chain_"..i, { alp = 1, playing = 1 }} } );
      
    end;
                   
    ObjAnimate("fx_fightingqueen_p_portal", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });               
    
    for i = 1, #private.state[ 1 ], 1 do
      
      ObjAnimate("spr_fightingqueen_lvl_1_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
      ObjAnimate("spr_fightingqueen_lvl_1_"..i.."_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
      
    end;
    
    ObjSet("tmr_fightingqueen_timer",  { time = 1, playing = 1, endtrig = end_func });
    
  end;
    
  local reset_queen = function ()
    
    ObjMultiSet( { {"anm_fightingqueen_queen_static", { alp = 1, playing = 1 }},
                   {"anm_fightingqueen_queen_cast", { alp = 0, frame = 0 }} } );
    
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_dragons_appearance");
  
  ObjMultiSet( { {"anm_fightingqueen_queen_static", { alp = 0, playing = 0, frame = 0 }},
                 {"anm_fightingqueen_queen_cast", { alp = 1, playing = 1, endtrig = reset_queen }},
                 {"anm_fightingqueen_game_start", { playing = 1, endtrig = func_after }} } );
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene( flag )
  
  flag = flag or false;
  
  if not flag then
  
    ObjMultiSet( { {"anm_fightingqueen_portal_front", { alp = 1, playing = 1 }},
                   {"anm_fightingqueen_portal_back", { alp = 1, playing = 1 }},
                   {"fx_fightingqueen_p_portal", { alp = 1 }} } );
    
    for i = 1, 3, 1 do
      
      ObjMultiSet( { {"anm_fightingqueen_snake_"..i, { alp = 1, playing = 1 }},
                     {"anm_fightingqueen_chain_"..i, { alp = 1, playing = 1 }} } );
      
    end;
                   
    for i = 1, 3, 1 do
      private.AnmDragonFire( i );
    end;
                   
  end;
                 
  if private.state[4] < 4 then
    
    local pair = private.state[ private.state[4] ];
    
    for i = 1, private.state[4]-1, 1 do
      
      ObjAttach("anm_fightingqueen_snake_head_"..private.snakes_order[i], "obj_fightingqueen_fx_to_add");
      ObjAttach("fx_fightingqueen_snake_dead_"..private.snakes_order[i], "anm_fightingqueen_snake_"..private.snakes_order[i]);
      
    end;

    for i = 1, 3, 1 do

      if (i ~= private.state[4]) then
        
        for j = 1, #private.state[ i ], 1 do
          
          ObjMultiSet( { {"spr_fightingqueen_lvl_"..i.."_"..j.."_1", { alp = 0, input = 0 }},
                         {"spr_fightingqueen_lvl_"..i.."_"..j.."_2", { alp = 0, input = 0 }} } );
          
        end;
                     
      end;

    end;

    for i = 1, #pair, 1 do

      if (pair[i] == 0) then
        ObjMultiSet( { {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1", { alp = 1, input = 1 }},
                       {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2", { alp = 1, input = 1 }} } );
      else
        ObjMultiSet( { {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1", { alp = 0, input = 0 }},
                       {"spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2", { alp = 0, input = 0 }} } );
      end;

    end;
                   
    if private.state[5] > 0 then
      
      private.crows_active = true;
  
      ObjMultiSet( { {"obj_fightingqueen_crows", { input = 1 }},
                     {"anm_fightingqueen_crows", { alp = 1, frame = 400 }} } );
                     
    else
      
      private.state[6] = {0, 0, 0};               
      ObjMultiSet( { {"obj_fightingqueen_crows", { input = 0 }},
                     {"anm_fightingqueen_crows", { alp = 0, frame = 0 }} } );        

    end;      
                   
    for i = 1, 3, 1 do
      
      if private.state[6][i] == 1 then
        ObjSet("obj_fightingqueen_crow_"..i,  { alp = 0, input = 0 });
      else 
        ObjSet("obj_fightingqueen_crow_"..i,  { alp = 1, input = 1 });
      end;
      
    end;
                   
  else

    for i = 1, 3, 1 do

      for j = 1, #private.state[ i ], 1 do
          
        ObjMultiSet( { {"spr_fightingqueen_lvl_"..i.."_"..j.."_1", { alp = 0, input = 0 }},
                       {"spr_fightingqueen_lvl_"..i.."_"..j.."_2", { alp = 0, input = 0 }} } );
        
      end;

    end;
    
  end;
                 
end;
-----------------------------------------------------------------------------------
function private.CheckDragonForActive( dragon )
  
  local stage = private.state[4];
  local active = false;
  
  for i = stage, 3, 1 do
    
    if private.snakes_order[i] == dragon then
      active = i;
      break;
    end;
    
  end;
  
  if private.crows_active and stage == active then
    active = false;
  elseif active then
    active = true;
  end;
  
  return active;
  
end;
-----------------------------------------------------------------------------------
function private.MoveBow()

  local curspos = GetZoomCursorPos();
  
  private.bow_pos = math.floor(curspos[1]);
  
  if private.bow_pos < 120 then
    private.bow_pos = 120;
  elseif private.bow_pos > 916 then
    private.bow_pos = 916;
  end;

  ObjMultiSet( { {"obj_fightingqueen_bow_move", { pos_x = private.bow_pos }},
                 {"tmr_fightingqueen_timer_bow", { time = 0.01, playing = 1, endtrig = private.MoveBow }} } );


end;
-----------------------------------------------------------------------------------
function private.AnmDragonFire( num )
  
  local pause = math.random(12, 25);
  
  local reset_fx = function ()
    
    ObjSet("fx_fightingqueen_snake_fire_"..num,  { active = 0, visible = 0, alp = 1 });
    private.AnmDragonFire( num );
    
  end;
  
  local anm_fire = function ()
    
    if private.CheckDragonForActive( num ) then
      
      --DbgTrace("active "..num);
      
      local ran = math.random(1, 2);
      cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_fire");
    
      if ran == 1 then
      
        ObjSet("fx_fightingqueen_snake_fire_"..num,  { active = 1, visible = 1 });
        PartSysRestart("fx_fightingqueen_snake_fire_"..num);
        
        ObjAnimate("fx_fightingqueen_snake_fire_"..num, "alp", 0, 0, reset_fx, { 0, 0, 1,   3, 0, 1,  3.5, 0, 0 });
        
      else 
        
        local reset_anim = function ( snake )
          
          ObjAttach("anm_fightingqueen_snake_attack_"..snake, "obj_fightingqueen_fx_to_add");
          ObjAttach("anm_fightingqueen_snake_head_"..snake, "anm_fightingqueen_snake_"..snake);
        
          ObjMultiSet( { {"anm_fightingqueen_snake_head_"..snake, { alp = 1, playing = 1 }},
                         {"anm_fightingqueen_snake_attack_"..snake, { frame = 0, playing = 0 }} } );
                         
          private.AnmDragonFire( num );
          
        end;
                       
        local snake = num;
        
        ObjAttach("anm_fightingqueen_snake_head_"..num, "obj_fightingqueen_fx_to_add");
        ObjAttach("anm_fightingqueen_snake_attack_"..num, "anm_fightingqueen_snake_"..num);
        
        ObjMultiSet( { {"anm_fightingqueen_snake_head_"..num, { alp = 0, playing = 0 }},
                       {"anm_fightingqueen_snake_attack_"..num, { frame = 0, playing = 1, endtrig = function() reset_anim(snake); end }} } );
      
      end;
                       
    else 
      --DbgTrace("not active "..num);
    end;
    
  end;
  
  ObjSet("tmr_fightingqueen_fire_timer_"..num,  { time = pause, playing = 1, endtrig = anm_fire });
  
end;
-------------------------------------------------------------------------------------
function public.FocusSymbol( pair, num, inout )
  
  --local name = "spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num;
  
  if inout == 0 then
    SetCursor( CURSOR_DEFAULT );
  else 
    SetCursor( CURSOR_HAND );
  end;
  
end;
-----------------------------------------------------------------------------
function private.SelectAnim( pair, num, inout )
  
  cmn.Lock(1);

  local name = "spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on";
  local cur_alp = ObjGet(name).alp;

  if inout == 1 then

    ObjAnimate( name, "alp", 0, 0, function () cmn.Lock(0); end, { 0, 2, 0,   0.2, 2, 1 });

  elseif inout == 0 then

    ObjAnimate( name, "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, cur_alp,   0.2, 0, 0 });

  end;

end;
-------------------------------------------------------------------------------------
--клик по символу
function public.ClickSymbol( pair, num )

  if ( private.chosen_symbol == 0 ) then
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");

    private.chosen_symbol = pair*10 + num;
    private.SelectAnim( pair, num, 1 );

  else

    --DbgTrace(math.floor( private.chosen_symbol/10 ));

    --отмена выбора
    if (private.chosen_symbol == pair*10 + num) then
      
      private.SelectAnim( pair, num, 0 );
      private.chosen_symbol = 0;

    --проверка на пару
    elseif (math.floor(private.chosen_symbol/10) == pair) then

      cmn.Lock(1);
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_menter");
      
      local num_1 = private.chosen_symbol - pair*10;

      private.state[ private.state[4] ][pair] = 1;
      private.chosen_symbol = 0;

      ObjSet("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_1", { input = 0 });
      ObjSet("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_2", { input = 0 });
      
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });

      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num, "alp", 0, 0, private.CheckWin, { 0, 0, 1,   0.3, 0, 1,    0.8, 0, 0 });
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num_1, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,    0.8, 0, 0 });

    else

      cmn.Lock(1);
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");

      --wrong
      local pair_1 = math.floor(private.chosen_symbol/10);
      local num_1 = private.chosen_symbol - pair_1*10;
      
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on", "color_g", 0, 0, "", { 0, 0, 1,   0.3, 0, 0,     0.6, 0, 0,    0.9, 0, 1 });
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on", "color_b", 0, 0, "", { 0, 0, 1,   0.3, 0, 0,     0.6, 0, 0,    0.9, 0, 1 });
      
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair_1.."_"..num_1.."_on", "color_g", 0, 0, "", { 0, 0, 1,   0.3, 0, 0,     0.6, 0, 0,    0.9, 0, 1 });
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair_1.."_"..num_1.."_on", "color_b", 0, 0, "", { 0, 0, 1,   0.3, 0, 0,     0.6, 0, 0,    0.9, 0, 1 });
      
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair.."_"..num.."_on", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.6, 0, 1,   0.9, 0, 0 });
      ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..pair_1.."_"..num_1.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.9, 0, 0 });
      
      private.chosen_symbol = 0;

    end;

  end;

end;
-------------------------------------------------------------------------------------
--клик на ворону
function public.KillCrow( num )
  
  common_impl.audio.env[ "assets/levels/level3/mg_fightingqueen/audio/aud_raven"..num.."_env" ] = false;
  SndStop( "assets/levels/level3/mg_fightingqueen/audio/aud_raven"..num.."_env", 1 );
  
  local end_func = function ()
    
    private.DrawScene( true );
    cmn.Lock(0);
    
  end;
  
  local func_after = function ()
    
    ObjAttach("fx_fightingqueen_crow_explode_"..num, "obj_fightingqueen_fx_to_add");
    ObjSet("fx_fightingqueen_crow_explode_"..num,  { active = false, visible = false });
    
    if private.state[5] == 0 then
      
      private.crows_active = false;
      
      private.state[6] = {0, 0, 0};
      private.state[4] = private.state[4] + 1;
      
      if private.state[4] < 4 then
      
        for i = 1, #private.state[ private.state[4] ], 1 do
          
          ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
          ObjAnimate("spr_fightingqueen_lvl_"..private.state[4].."_"..i.."_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
          
        end;
        
        local reset_queen = function ()
          
          ObjMultiSet( { {"anm_fightingqueen_queen_static", { alp = 1, playing = 1 }},
                         {"anm_fightingqueen_queen_cast", { alp = 0, playing = 0 }} } );
          
        end;
                       
        cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_queen_cast");
        
        ObjMultiSet( { {"anm_fightingqueen_queen_static", { alp = 0, playing = 0, frame = 0 }},
                       {"anm_fightingqueen_queen_cast", { alp = 1, playing = 1, endtrig = reset_queen }},
                       {"tmr_fightingqueen_timer",  { time = 1, playing = 1, endtrig = end_func }} } );
        
      else 
        
        private.Win();
        
      end;
      
    else 
      
      cmn.Lock( 0 );
      
    end;
    
  end;
  
  cmn.Lock( 1 );
  
  private.state[5] = private.state[5] + 1;
  private.state[6][num] = 1;
  if private.state[5] == 3 then
    private.state[5] = 0;
  end;
  
  local anm_crow_kill = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_clk_raven");
  
    ObjAttach("fx_fightingqueen_crow_explode_"..num, "obj_fightingqueen_crows");
    local pos = GetObjPosByObj("anm_fightingqueen_crow_"..num);
    ObjSet("fx_fightingqueen_crow_explode_"..num,  { pos_x = pos[1], pos_y = pos[2], active = true, visible = true });
    PartSysRestart("fx_fightingqueen_crow_explode_"..num);
    
    ObjAnimate("obj_fightingqueen_crow_"..num, "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    
    ObjAttach("spr_fightingqueen_arrow", "obj_fightingqueen_bow_move");
    ObjSet("spr_fightingqueen_arrow",  { pos_x = 0, pos_y = 722, scale_x = 1, scale_y = 1 });
    
    ObjAnimate("spr_fightingqueen_arrow", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_bow_shot");
  
  local crow_pos = GetObjPosByObj("obj_fightingqueen_crow_"..num);
  crow_pos[1] = math.floor(crow_pos[1]);
  crow_pos[2] = math.floor(crow_pos[2]);
  
  ObjAttach("spr_fightingqueen_arrow", "obj_fightingqueen_bow");
  ObjSet("spr_fightingqueen_arrow",  { pos_x = private.bow_pos });

  ObjAnimate("spr_fightingqueen_arrow", "pos_xy", 0, 0, anm_crow_kill, { 0, 1, private.bow_pos, 722,   0.4, 1, crow_pos[1], crow_pos[2] });
  ObjAnimate("spr_fightingqueen_arrow", "scale_xy", 0, 0, "", { 0, 1, 1, 1,   0.4, 1, 0.2, 0.2 });
  ObjAnimate("spr_fightingqueen_arrow", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 1,   0.4, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.EndStage()
  
  private.crows_active = true;
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet("obj_fightingqueen_crows",  { input = 1 });
                   
  end;
                 
  local func_set_anm = function ()
    ObjMultiSet( { {"anm_fightingqueen_queen_static", { alp = 1, playing = 1 }},
                   {"anm_fightingqueen_queen_cast", { alp = 0, frame = 0 }} } );
  end;
  
  local crows_cast = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_queen_cast");
    
    if private.state[4] >= 3 then
      cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_castlehall_env");
    end;
    
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_raven1_env");
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_raven2_env");
    cmn.PlayAudio("env", "assets/levels/level3/mg_fightingqueen/audio/aud_raven3_env");
    
    local snake = private.snakes_order[ private.state[4] ];
    
    PartSysRestart("fx_fightingqueen_snake_dead_"..snake);
  
    ObjMultiSet( { {"anm_fightingqueen_queen_static", { alp = 0, playing = 0, frame = 0 }},
                   {"anm_fightingqueen_queen_cast", { alp = 1, playing = 1, endtrig = func_set_anm }},
                   {"fx_fightingqueen_snake_dead_"..snake, { alp = 1 }},
                   {"anm_fightingqueen_crows", { alp = 1, playing = 1, endtrig = func_after }} } );
                   
    ObjAttach("anm_fightingqueen_snake_explode_"..snake, "obj_fightingqueen_fx_to_add");
    ObjAttach("fx_fightingqueen_snake_dead_"..snake, "anm_fightingqueen_snake_"..snake);
    
  end;
  
  local snake = private.snakes_order[ private.state[4] ];
  
  local head_explode = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_dragon_dead");
                 
    ObjMultiSet( { {"anm_fightingqueen_snake_head_"..snake, { frame = 0, playing = 0 }},
                   {"anm_fightingqueen_snake_attack_"..snake, { frame = 0, playing = 0 }},
                   {"anm_fightingqueen_snake_explode_"..snake, { alp = 1, playing = 1, endtrig = crows_cast }} } );
                   
    --snake head explode
    ObjAttach("anm_fightingqueen_snake_head_"..snake, "obj_fightingqueen_fx_to_add");
    ObjAttach("anm_fightingqueen_snake_attack_"..snake, "obj_fightingqueen_fx_to_add");
    ObjAttach("anm_fightingqueen_snake_explode_"..snake, "anm_fightingqueen_snake_"..snake);
    
    ObjAttach("spr_fightingqueen_arrow", "obj_fightingqueen_bow_move");
    ObjSet("spr_fightingqueen_arrow",  { pos_x = 0, pos_y = 722, scale_x = 1, scale_y = 1, ang = -0.28 });
    
    ObjAnimate("spr_fightingqueen_arrow", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  local head_pos = GetObjPosByObj("anm_fightingqueen_snake_head_"..snake);
  head_pos[1] = math.floor(head_pos[1]);
  head_pos[2] = math.floor(head_pos[2]);
  
  local point_a, point_b, point_c = {}, {}, {};
  point_a[1] = private.bow_pos;
  point_a[2] = 722;
  point_b[1] = private.bow_pos;
  point_b[2] = head_pos[2];
  point_c[1] = head_pos[1];
  point_c[2] = head_pos[2];
  local ang_step = common_impl.math.FindTriangleApexAng( point_a, point_b, point_c );
  local new_ang = 0;
  
  if head_pos[1] < private.bow_pos then
    new_ang = -0.28 + ang_step;
  else 
    new_ang = -0.28 - ang_step;
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/aud_bow_shot");
  
  ObjAttach("spr_fightingqueen_arrow", "obj_fightingqueen_bow");
  ObjSet("spr_fightingqueen_arrow",  { pos_x = private.bow_pos });

  ObjAnimate("spr_fightingqueen_arrow", "pos_xy", 0, 0, head_explode, { 0, 1, private.bow_pos, 722,   0.4, 1, head_pos[1], head_pos[2] });
  ObjAnimate("spr_fightingqueen_arrow", "scale_xy", 0, 0, "", { 0, 1, 1, 1,   0.4, 1, 0.2, 0.2 });
  ObjAnimate("spr_fightingqueen_arrow", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 1,   0.4, 0, 0 });
  ObjAnimate("spr_fightingqueen_arrow", "ang", 0, 0, "", { 0, 0, -0.28,   0.2, 0, new_ang });
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = true;
  local pair = private.state[ private.state[4] ];

  if (private.state[4] < 4) then
  
    for i = 1, #pair, 1 do

      if (pair[i] == 0) then
        win_flag = false;
        break;
      end;

    end;

  end;

  if win_flag and not private.crows_active and private.state[5] == 0 then
    
    cmn.Lock(1);

    --DbgTrace("win lvl");

    --cmn.PlayAudio("snd", "assets/levels/level3/mg_fightingqueen/audio/");

    --private.state[4] = private.state[4] + 1;

    private.EndStage();

  else

    cmn.Lock(0);

  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.Lock(0);

  cmn.SetEventDone( "win_fightingqueen" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_fightingqueen" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_fightingqueen" ].skip == 0 and not ng_global.noskipgames[ "win_fightingqueen" ] then

      ng_global.noskipgames[ "win_fightingqueen" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
  
    if ng_global.playedgames and not ng_global.playedgames[ "win_fightingqueen" ] then
      ng_global.playedgames[ "win_fightingqueen" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    cmn.GotoRoom("rm_castlehall");
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "std" then

    cmn.MiniGameHide();
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_fightingqueen" );
    
  else 
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
  end;

  private.WinEnd();

end;
--********************************************************************************************************