-- name=mg_onscroll
--*********************************************************************************************************************
function public.Init()

  --1 - синий, 2 - фиолетовый, 3 - розовый, 4 - желтый
  private.start_map_stage_1 = {
    { 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0 },
    { 3, 0, 0, 0, 0 },
    { 2, 2, 2, 0, 0 },
    { 0, 0, 3, 0, 0 }
  };

  private.start_map_stage_2 = {
    { 0, 0, 0, 0, 0 },
    { 1, 3, 3, 1, 0 },
    { 2, 4, 0, 2, 0 },
    { 3, 4, 2, 4, 0 },
    { 2, 3, 0, 4, 0 }
  };
  private.start_map_stage_3 = {
    { 4, 2, 4, 4, 1 },
    { 2, 4, 2, 2, 3 },
    { 4, 1, 4, 1, 3 },
    { 1, 1, 3, 4, 3 },
    { 3, 2, 3, 1, 3 }
  };
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onscroll";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_scalepan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scalepan" ] = {
      type = "get",
      get_obj = "spr_onscroll_scalepan",
      room = "rm_nearpolicedepartment",
      zz = "mg_onscroll",
      zz_gate = "gmg_nearpolicedepartment_onscroll"
  };
  --------------------------------------------------------------------------------------------
  local get_scalepan_inv = function ()
  
    interface.InventoryItemAdd( "inv_scalepan", "spr_onscroll_scalepan" );
  
  end;
  local get_scalepan_end = function ()
  
    ObjDelete( "gfx_onscroll_scalepan" );
    ObjDelete( "spr_onscroll_scalepan_shadow" );
  
  end;
  local get_scalepan_loc = function ()
    
    if cmn.IsEventDone("get_redhatpage3") then
      ObjDelete( "gmg_nearpolicedepartment_onscroll" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_scalepan", get_scalepan_inv );
  cmn.AddSubscriber( "get_scalepan", get_scalepan_end, private.room_objname );
  cmn.AddSubscriber( "get_scalepan", get_scalepan_loc, "rm_nearpolicedepartment" );
  --------------------------------------------------------------------------------------------
  -- function get_redhatpage3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_redhatpage3" ] = {
      type = "get",
      get_obj = "spr_onscroll_redhatpage3",
      room = "rm_nearpolicedepartment",
      zz = "mg_onscroll",
      zz_gate = "gmg_nearpolicedepartment_onscroll"
  };
  --------------------------------------------------------------------------------------------
  local get_redhatpage3_inv = function ()
  
    interface.InventoryItemAdd( "inv_redhatpage", "spr_onscroll_redhatpage3", function () cmn.GetMultyObject( 'redhatpage', 4 ); end );
  
  end;
  local get_redhatpage3_end = function ()
  
    ObjDelete( "gfx_onscroll_redhatpage3" );
    ObjDelete( "spr_onscroll_redhatpage3_shadow" );
  
  end;
  local get_redhatpage3_loc = function ()
  
    if cmn.IsEventDone("get_scalepan") then
      ObjDelete( "gmg_nearpolicedepartment_onscroll" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_redhatpage3", get_redhatpage3_inv );
  cmn.AddSubscriber( "get_redhatpage3", get_redhatpage3_end, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage3", get_redhatpage3_loc, "rm_nearpolicedepartment" );

  --------------------------------------------------------------------------------------------
  -- function win_onscroll () end;
  --------------------------------------------------------------------------------------------
  --game.hint[ "win_onscroll" ] = {
  --  type = "win",
  --  room = "rm_nearpolicedepartment",
  --  zz = "mg_onscroll",
  --  zz_gate = "gmg_nearpolicedepartment_onscroll"
  --};
  --------------------------------------------------------------------------------------------
  local win_onscroll = function ()

    if cmn.IsEventDone( "win_onscroll" ) then

      ObjDelete( "anm_onscroll_scroll" );
      ObjDelete( "obj_onscroll_scroll" );
      ObjDelete( "anm_onscroll_eraser" );

      ObjMultiSet( { { "anm_onscroll_scroll_open", { alp = 1, frame = 84 } },
                     { "anm_onscroll_cover", { frame = 82 } },
                     { "spr_onscroll_redhatpage3", { input = true } },
                     { "spr_onscroll_scalepan", { input = true } } } );

    end;

  end;
--  local win_onscroll_loc = function ()
--
--  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_onscroll", win_onscroll, "mg_onscroll" );
--  cmn.AddSubscriber( "win_onscroll", win_onscroll_loc, "rm_nearpolicedepartment" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not cmn.IsEventDone( "win_onscroll" ) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_onscroll");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  iOS_NeedDrag(0);
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");
  
  if ng_global.currentprogress == "std" then

    common.SetPreviousRoom( "rm_nearpolicedepartment" );
   
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].state;
    
    ObjSet("grm_onscroll_nearpolicedepartment",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                                event_menter = function () rm_extra.GateMouseEnter( "onscroll_nearpolicedepartment", CURSOR_DOWN, "extra" ); end, 
                                                event_mleave = function () common_impl.GateMouseLeave( "onscroll_nearpolicedepartment" ); end });
    
  end;

  if not cmn.IsEventDone( "win_onscroll" ) then
    private.DrawScene();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  iOS_NeedDrag(1);
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not cmn.IsEventDone( "win_onscroll" ) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_onscroll" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset( auto )

  --DbgTrace( "***Reset" );

  local go_reset = false;

  local new_map = "start_map_stage_"..private.state.stage;

  for i = 1, 5, 1 do
    for j = 1, 5, 1 do
      
      if private.state.map[ i ][ j ] ~= private[ new_map ][ i ][ j ] then

        private.state.map[ i ][ j ] = private[ new_map ][ i ][ j ];
        go_reset = true;

        ObjAnimate( "spr_onscroll_point_"..i..j..private.state.map[ i ][ j ], "alp", 0, 0, "", 
          ( (not auto) and { 0, 0, 0,    0.3, 0, 1 } or { 0, 0, 0,    0.6, 0, 0,    0.9, 0, 1 } ) );

      elseif auto and private[ new_map ][ i ][ j ] ~= 0 then

        --DbgTrace( "["..i.."]["..j.."] wrong" );

        ObjAnimate( "spr_onscroll_point_"..i..j..private.state.map[ i ][ j ], "alp", 0, 0, "", 
          { 0, 0, 1,    0.15, 0, 0,    0.3, 0, 1,    0.45, 0, 0,    0.6, 0, 1 } );

      end;

    end;
  end;

  if ( go_reset ) then
    cmn.Lock( 1 );
    ObjSet( "tmr_onscroll_animlock", { time = ( (not auto) and 0.3 or 0.9 ), endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  end;

end;
--*********************************************************************************************************************
function public.Skip()

  cmn.Lock( 1 );

  ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].skip = 1;

  private.state.stage = 3;

  for i = 1, 5, 1 do
    for j = 1, 5, 1 do
      private.state.map[ i ][ j ] = 0;
    end;
  end;

  ObjAnimate( "obj_onscroll_scroll", "alp", 0, 0, private.CheckWin, { 0, 0, 1,    0.5, 0, 0 } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_scalepan()

  cmn.SetEventDone( "get_scalepan" );
  cmn.CallEventHandler( "get_scalepan" );
  
  if not cmn.IsEventDone("get_redhatpage3") then
    cmn.SetEventDone( "get_redhatpage3" );
    cmn.CallEventHandler( "get_redhatpage3" );
  end;

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_redhatpage3") then
    cmn.GotoRoom("rm_nearpolicedepartment");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_redhatpage3()

  cmn.SetEventDone( "get_redhatpage3" );
  cmn.CallEventHandler( "get_redhatpage3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_scalepan") then
    cmn.GotoRoom("rm_nearpolicedepartment");
  end;

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].state = {
    stage = 1,
    map = {
      { 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0 },
      { 3, 0, 0, 0, 0 },
      { 2, 2, 2, 0, 0 },
      { 0, 0, 3, 0, 0 }
    }
  };

end;
-----------------------------------------------------------------------------------
function private.DrawScene( not_clean )

  for i = 1, 5, 1 do
    for j = 1, 5, 1 do
      if ( private.state.map[ i ][ j ] ~= 0 ) then
        ObjSet( "spr_onscroll_point_"..i..j..private.state.map[ i ][ j ], { alp = 1 } );
      end;
    end;
  end;

  ------------------

  if ng_global.currentprogress ~= "secret" or not_clean then
    --DbgTrace( "currentprogress == "..ng_global.currentprogress );
    return;
  end;

  local start_map;

  for k = 2, 3, 1 do

    start_map = "start_map_stage_"..k;
    --DbgTrace( "start map "..k );

    for i = 1, 5, 1 do
      for j = 1, 5, 1 do
        if ( private[ start_map ][ i ][ j ] ~= 0 ) and ( private.state.map[ i ][ j ] ~= private[ start_map ][ i ][ j ] ) then

          ObjSet( "spr_onscroll_point_"..i..j..private[ start_map ][ i ][ j ], { alp = 0 } );
          --DbgTrace( "убрали "..i.." "..j.." - "..private[ start_map ][ i ][ j ] );

        end;
      end;
    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()

  --DbgTrace( "***CheckWin" );

  cmn.Lock( 1 );

  local game_win = true;

  for i = 1, 5, 1 do
    for j = 1, 5, 1 do
      if ( private.state.map[ i ][ j ] ~= 0 ) then
        game_win = false;
        break;
      end;
    end;
  end;

  if ( game_win and ( private.state.stage == 3 ) )
  or ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].skip == 1 then

    --DbgTrace( "WWWWWIIIIIIIIINNNNN" );
    if ng_global.currentprogress == "std" then
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
    else 
      int_dialog_secretroom.StopTimer();
    end;

    private.Win();

  elseif game_win and ( private.state.stage < 3 ) then

    private.state.stage = private.state.stage + 1;

    --DbgTrace( "stage = "..private.state.stage );

    local new_map = "start_map_stage_"..private.state.stage;

    for i = 1, 5, 1 do
      for j = 1, 5, 1 do
        private.state.map[ i ][ j ] = private[ new_map ][i][j];
      end;
    end;

    ObjSet( "obj_onscroll_scroll", { alp = 0 } );

    private.DrawScene( true );

    ObjAnimate( "obj_onscroll_scroll", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );

  else

    --DbgTrace( "not win" );

    for i = 1, 5, 1 do  --проверка на отсутсвие ходов
      for j = 1, 5, 1 do
        if ( private.state.map[ i ][ j ] ~= 0 ) then

          --DbgTrace( "["..i.."]["..j.."] == "..private.state.map[ i ][ j ] );

          for lin = i, 5, 1 do
            for col = 1, 5, 1 do

              if  ( private.state.map[ lin ][ col ] == private.state.map[ i ][ j ] )  --одинаковый цвет
              and not ( i == lin and j == col )  --не начальная ячейка
              and ( ( i == lin ) or ( j == col ) or ( math.abs( i - lin ) == math.abs( j - col ) ) )  --в одной строке/столбце/диагонале
              and private.CheckPointsColoreInLine( lin, col, i, j ) then  --проверка на одинаковость цветов в линии

                --DbgTrace( "  -> ["..lin.."]["..col.."] == "..private.state.map[ lin ][ col ] );
                cmn.Lock( 0 );
                return;

              end;

            end;
          end;

        end;
      end;
    end;

    public.Reset( true );

  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );
  cmn.SetEventDone( "win_onscroll" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_onscroll" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_onscroll" ].skip == 0 and not ng_global.noskipgames[ "win_onscroll" ] then

      ng_global.noskipgames[ "win_onscroll" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

    if ng_global.playedgames and not ng_global.playedgames[ "win_onscroll" ] then
      ng_global.playedgames[ "win_onscroll" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  local func_after = function () 
    ObjSet( "anm_onscroll_cover", { endtrig = private.WinEnd, playing = true } );
  end
  
  if ng_global.currentprogress == "std" then

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_onscroll" );

    ObjDelete( "anm_onscroll_scroll" );
    ObjDelete( "obj_onscroll_scroll" );
    ObjDelete( "anm_onscroll_eraser" );
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_onscroll/audio/aud_win_onscroll");

    ObjSet( "anm_onscroll_scroll_open", { alp = 1, endtrig = func_after, playing = true } );
    
  else 
    
    rm_extra.MiniGameHide();
    private.WinEnd();
    
  end;

end;
-----------------------------------------------------------------------------------
function public.StartDragPoint( lin, col )  --начинаем драгать

  DbgTrace( "***StartDragPoint" );

  if ( private.state.map[ lin ][ col ] == 0 ) then  --пустую ячейку выбрасываем
    private.start_drag_point = false;
    ObjStopDrag();
    return;
  end;

  private.start_drag_point = { lin, col };
  private.menter_drag_point = { lin, col };

  ObjAttach( "spr_onscroll_start", "obj_onscroll_point_"..lin..col );
  ObjAttach( "spr_onscroll_line",  "obj_onscroll_point_"..lin..col );

  ObjMultiSet( { { "spr_onscroll_start", { alp = 1 } },
                 { "obj_onscroll_point_"..lin..col, { pos_z = 2 } } } );

  public.FocusObj( "spr_onscroll_point_"..lin..col..private.state.map[ lin ][ col ].."_focus", 1 );

end;
-----------------------------------------------------------------------------------
function public.DropDragPoint( lin, col )

  DbgTrace( "***DropDragPoint "..lin.." "..col );

  if ( private.state.map[ lin ][ col ] == 0 ) then
    return;
  end;

  ObjMultiSet( { 
    { "spr_onscroll_start",  { alp = 0 } },
    { "spr_onscroll_line",   { alp = 0 } },
    { "spr_onscroll_finish", { alp = 0 } },
    { "obj_onscroll_point_"..lin..col, { pos_z = 0 } }
  } );

  public.FocusObj( "spr_onscroll_point_"..lin..col..private.state.map[ lin ][ col ].."_focus", 0 );
  public.FocusObj(
    "spr_onscroll_point_"..private.menter_drag_point[1]..private.menter_drag_point[2]
    ..private.state.map[ private.menter_drag_point[1] ][ private.menter_drag_point[2] ].."_focus", 0
  );

  if ( private.right_point ) then --стираем ячейки

    --DbgTrace( "right_point" );

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/mg_onscroll/audio/aud_use_cloth");

    local eraser_pos_start = { 
      ObjGet( "obj_onscroll_point_"..private.right_point[1][1]..private.right_point[1][2] ).pos_x,
      ObjGet( "obj_onscroll_point_"..private.right_point[1][1]..private.right_point[1][2] ).pos_y
    };
    local eraser_pos_end = { 
      ObjGet( "obj_onscroll_point_"..private.right_point[#private.right_point][1]..private.right_point[#private.right_point][2] ).pos_x,
      ObjGet( "obj_onscroll_point_"..private.right_point[#private.right_point][1]..private.right_point[#private.right_point][2] ).pos_y
    };

    local eraser_func_end = function () 
      ObjMultiSet( { { "anm_onscroll_use_eraser", { alp = 0 } },
                     { "anm_onscroll_eraser",     { alp = 1 } } } );
      private.CheckWin();
    end;

    local eraser_func_after = function () 
      ObjSet( "anm_onscroll_use_eraser", { playing = true } );
      ObjAnimate( "anm_onscroll_use_eraser", "pos_xy", 0, 0, eraser_func_end, { 
        0,      0, eraser_pos_start[1], eraser_pos_start[2],
        1.1333, 0, eraser_pos_end[1], eraser_pos_end[2],
        1.4333, 0, 176, 610
      } );
    end;

    ObjMultiSet( { { "anm_onscroll_use_eraser", { alp = 1 } },
                   { "anm_onscroll_eraser",     { alp = 0 } } } );

    ObjAnimate( "anm_onscroll_use_eraser", "pos_xy", 0, 0, eraser_func_after, { 
      0,   0, 176, 610,
      0.3, 0, eraser_pos_start[1], eraser_pos_start[2] 
    } );

    for i = 1, #private.right_point, 1 do

      --DbgTrace( private.right_point[i][1].." "..private.right_point[i][2] );

      ObjAnimate( 
        "spr_onscroll_point_"..private.right_point[i][1]..private.right_point[i][2]
        ..private.state.map[ private.right_point[i][1] ][ private.right_point[i][2] ], 
        "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 1,    1.6, 0, 0 } 
      );

      private.state.map[ private.right_point[i][1] ][ private.right_point[i][2] ] = 0;

    end;

    private.right_point = false;

  end;

  private.start_drag_point = false;

end;
-----------------------------------------------------------------------------------
function public.MEnterDragPoint( lin, col ) --наведение при драге ячеек

  --DbgTrace( "***MEnterDragPoint" );

  if private.state.map[ lin ][ col ] == 0 --пустая ячейка
  or not private.start_drag_point --тоскаем какойто левый обьект
  or not ( ( private.start_drag_point[1] == lin ) or ( private.start_drag_point[2] == col ) --в одной строке/столбце
  or ( math.abs( private.start_drag_point[1] - lin ) == math.abs( private.start_drag_point[2] - col ) ) ) --по диагонале
  or not ( private.state.map[ lin ][ col ] == private.state.map[ private.start_drag_point[1] ][ private.start_drag_point[2] ] ) then  --цвет
    --DbgTrace( "упс" );
    private.right_point = false;
    return;
  end;

  private.right_point = private.CheckPointsColoreInLine( lin, col, private.start_drag_point[1], private.start_drag_point[2] );
  --проверка на одинаковость цветов в линии
  --если все одинаковы возвращает таблицу с ячейками для стирания

  --DbgTrace( "private.right_point = "..tostring( private.right_point ) );

  if not private.right_point then
    return;
  --else
  --  for i = 1, #private.right_point, 1 do
  --    DbgTrace( private.right_point[i][1].." "..private.right_point[i][2] );
  --  end;
  end;

  private.menter_drag_point = { lin, col };

  ObjAttach( "spr_onscroll_finish", "obj_onscroll_point_"..lin..col );

  local finish_ang = 0;

  local point_a = { 
    ObjGet( "obj_onscroll_point_"..private.start_drag_point[1]..private.start_drag_point[2] ).pos_x,
    ObjGet( "obj_onscroll_point_"..private.start_drag_point[1]..private.start_drag_point[2] ).pos_y
  };
  local point_c = { 
    ObjGet( "obj_onscroll_point_"..lin..col ).pos_x,
    ObjGet( "obj_onscroll_point_"..lin..col ).pos_y
  };
  local point_b = { point_a[1] + point_c[1], point_a[2] };

  --DbgTrace( point_a[1].." "..point_a[2].." , "..point_c[1].." "..point_c[2].." , "..point_b[1].." "..point_b[2] );

  finish_ang = private.GetFinishPointAng( point_a, point_b, point_c );  --получаем угл для стрелки

  if ( point_a[2] < point_c[2] ) then --если конечная точка ниже начальной, вертим в противоположную сторону
    finish_ang = -finish_ang;
    --DbgTrace( "ниже" );
  end;

  --DbgTrace( "finish_ang = "..finish_ang );

  local len_ac = common_impl.math.FindSegmentLength( point_a, point_c );  --получаем длину стрелки
  local line_scale_x = len_ac / 276;

  --DbgTrace( "line_scale_x = "..line_scale_x );
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");

  ObjMultiSet( { { "spr_onscroll_finish", { alp = 1, ang = finish_ang } },
                 { "spr_onscroll_line",   { alp = 1, ang = finish_ang, scale_x = line_scale_x } } } );

  public.FocusObj( "spr_onscroll_point_"..lin..col..private.state.map[ lin ][ col ].."_focus", 1 );

end;
-----------------------------------------------------------------------------------
function public.MLeaveDragPoint( lin, col )

  --DbgTrace( "***MLeaveDragPoint "..lin.." "..col );

  private.right_point = false;

  ObjMultiSet( { { "spr_onscroll_finish", { alp = 0 } },
                 { "spr_onscroll_line", { alp = 0 } } } );

  if private.state.map[ lin ][ col ] ~= 0 then--пустая ячейка
    public.FocusObj( "spr_onscroll_point_"..lin..col..private.state.map[ lin ][ col ].."_focus", 0 );
  end;

end;
-----------------------------------------------------------------------------------
function private.GetFinishPointAng( point_a, point_b, point_c )
  --параметры координаты вершин {x,y}
  --вычисление угла A треугольника
  --        C
  --       / \
  --      /   \
  --     A-----B

  local len_side_a = common_impl.math.FindSegmentLength( point_b, point_c );
  local len_side_b = common_impl.math.FindSegmentLength( point_a, point_c );
  local len_side_c = common_impl.math.FindSegmentLength( point_a, point_b );

  --DbgTrace( len_side_a.." "..len_side_b.." "..len_side_c );

  local ang = math.acos( ( len_side_b^2 + len_side_c^2 - len_side_a^2 ) / ( 2 * len_side_b * len_side_c ) );

  return ang;

end;
-----------------------------------------------------------------------------------
function private.CheckPointsColoreInLine( lin, col, start_drag_point_lin, start_drag_point_col  )
  --проверка на одинаковость цветов в линии
  --если все одинаковы возвращает таблицу с ячейками для стирания

  --DbgTrace( "***CheckPointsColoreInLine ["..start_drag_point_lin.."]["..start_drag_point_col.."] -> ["..lin.."]["..col.."]" );

  local points_color_same = {}; --таблица с ячейками с одинаковыми цветами

  local start_lin = start_drag_point_lin;
  local start_col = start_drag_point_col;
  local lin_inc = 0;
  local col_inc = 0;

  if     ( start_drag_point_lin < lin ) then
    lin_inc =  1;
  elseif ( start_drag_point_lin > lin ) then
    lin_inc = -1;
  end;

  if     ( start_drag_point_col < col ) then
    col_inc =  1;
  elseif ( start_drag_point_col > col ) then
    col_inc = -1;
  end;

  while ( start_lin ~= lin + lin_inc ) or ( start_col ~= col + col_inc ) do

    if  private.state.map[ start_lin ][ start_col ] ~= private.state.map[ start_drag_point_lin ][ start_drag_point_col ]
    and private.state.map[ start_lin ][ start_col ] ~= 0 then
      points_color_same = false;
      --DbgTrace( start_lin.." "..start_col.." цвет не совподает" );
      break;
    end;

    table.insert( points_color_same, { start_lin, start_col } );

    start_lin = start_lin + lin_inc;
    start_col = start_col + col_inc;

  end;

  return points_color_same;

end;
-----------------------------------------------------------------------------------
function public.FocusObj( obj, inout )--анимация фокуса
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    --SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    --SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
-----------------------------------------------------------------------------------
function public.MEnterPoint( lin, col )

  if ( private.state.map[ lin ][ col ] == 0 ) then  --пустая ячейка
    return;
  end;

  SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************