-- name=ho_dogarea
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_dogarea" );
  game.relations[ "ho_dogarea" ].exitroom = "rm_insophiashouse";
  public.change_stage_anim_type = "alp";
  private.cur_progress = "ext";
  --------------------------------------------------------------------------------------------------
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_dogarea" ] = 
  {
    type = "win",
    room = "rm_insophiashouse",
    zz = "ho_dogarea",
    zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------------
  local win_dogarea_func = function ()

    if ( cmn.IsEventDone( "win_dogarea" ) ) then
      common_impl.InventoryComplexItemAdd( "inv_brokenalarmclock", "spr_dogarea_win" );
      ObjDelete("gho_insophiashouse_dogarea");
    end;

  end;
  cmn.AddSubscriber( "win_dogarea", win_dogarea_func );
  --------------------------------------------------------------------------------------------------
  local start_dogarea_func = function ()

    if ( cmn.IsEventStart( "win_dogarea" ) ) then

      common_impl.ProcessHoStart( "dogarea", true );

    end;

  end;
  cmn.AddSubscriber( "win_dogarea", start_dogarea_func, "ho_dogarea" );
  
   --for secretroom
  private.tasks =  {    
  
      { "ball",      1, 0, { { "spr_dogarea_ball" } } },
      { "clothes",    1, 0, { { "spr_dogarea_clothes" } } },
      { "bow",      1, 0, { { "spr_dogarea_bow" } } },
      { "bowl",     1, 0, { { "spr_dogarea_bowl" } } },
      
      { "frisbee",      1, 0, { { "spr_dogarea_frisbee" } } },
      { "glove",     1, 0, { { "spr_dogarea_glove" } } },
      { "comb",   1, 0, { { "spr_dogarea_comb" } } },
      { "lead",   1, 0, { { "spr_dogarea_lead" } } },
      
      { "whistle",  1, 0, { { "spr_dogarea_whistle" } } },
      { "sock",    1, 0, { { "spr_dogarea_sock" } } },
      { "collar", 1, 0, { { "spr_dogarea_collar" } } },
      { "book",    1, 0, { { "spr_dogarea_book" } } },
      
      { "alarm",    1, 0, { { "spr_dogarea_alarm" } } }
      
  };
  
  private.actions = {
  
    { "use_hobone1", { "spr_dogarea_panel_doors_sil_1", "spr_dogarea_panel_doors_sil_1_done" } },
    { "use_hobone2", { "spr_dogarea_panel_doors_sil_2", "spr_dogarea_panel_doors_sil_2_done" } },
    { "use_hobone3", { "spr_dogarea_panel_doors_sil_3", "spr_dogarea_panel_doors_sil_3_done" } },
    { "use_hobone4", { "spr_dogarea_panel_doors_sil_4", "spr_dogarea_panel_doors_sil_4_done" } },
    
    { "use_hodogpart1", { "spr_dogarea_panel_doors_itm_1", "spr_dogarea_box_part_1" } },
    { "use_hodogpart2", { "spr_dogarea_panel_doors_itm_2", "spr_dogarea_box_part_2" } },
    { "use_hodogpart3", { "spr_dogarea_panel_doors_itm_3", "spr_dogarea_box_part_3" } },
    { "use_hodogpart4", { "spr_dogarea_panel_doors_itm_4", "spr_dogarea_box_part_4" } }
  
  };
  
  private.additional = { "spr_dogarea_bone_1", "spr_dogarea_bone_2", "spr_dogarea_bone_3", "spr_dogarea_bone_4", "spr_dogarea_bone_1_shadow", "spr_dogarea_bone_2_shadow", "obj_dogarea_use_dogpart" };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.tasks_sh =  { 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1 };

  private.start = {};
  private.start_sh = {};
  private.start_add = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;
  
  for i = 1, #private.additional, 1 do
    
    table.insert( private.start_add, {} );
    private.start_add[ #private.start_add ].name = private.additional[ i ];
    nme = private.start_add[ #private.start_add ].name;
    private.start_add[ #private.start_add ].prop = ObjGet( nme );
    private.start_add[ #private.start_add ].parent = ObjGetRelations( nme ).parent;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].panel_doors = { 0, 0, 0, 0 };
    ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].state_use = { 0, 0, 0, 0 };
  end;
  
  private.uses = ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].state_use;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_bedroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_bedroom_env");
  if port.isPortable() == 1 then
    iOS_EnableMultiTouch(1); 
  end;
  if ng_global.currentprogress == "ext" then
    
    private.cur_progress = "ext";
  
    common.SetPreviousRoom( "rm_insophiashouse" );
    cmn.StartTimePassing("ho_dogarea");
    
  else 
    
    private.cur_progress = "secret";
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].stage = { 1, 2 };   
    ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].panel_doors = { 0, 0, 0, 0 };
    ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].state_use = { 0, 0, 0, 0 };
    private.uses = ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].state_use;
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_dogarea_insophiashouse",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "dogarea_insophiashouse", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "dogarea_insophiashouse" ); end });
    
  end;
  
  public.GenHint();

  if not cmn.IsEventStart( "win_dogarea" ) then
    cmn.InitHo( "dogarea" );
  end;

  local ho_tasks = private.stages_task();
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].stage;

  if not cmn.IsEventDone("win_dogarea") and ho_stage[1] <= ho_stage[2] then
    
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;
  
  if ( ho_stage[1] == 2 ) then

    ObjMultiSet( { {"obj_dogarea_box_open", { alp = 1 }},
                   {"spr_dogarea_alarm", { input = 1 }},
                   {"spr_dogarea_box_closed", { alp = 0 }} } );
    
  else 
    
    ObjMultiSet( { {"spr_dogarea_box_closed", { alp = 1 }},
                   {"obj_dogarea_box_open", { alp = 0 }},
                   {"spr_dogarea_alarm", { input = 0 }} } );

  end;
                 
  if ng_global.currentprogress == "secret" then      

    for i = 1, 4, 1 do
      
      ObjMultiSet( { {"spr_int_taskpanel_panel_doors_1"..i, { pos_y = 89 }},
                     {"spr_int_taskpanel_panel_doors_2"..i, { pos_y = 89 }} } );
      
    end;

  end;  

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else
    
    ObjSet("grm_dogarea_insophiashouse",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
  
  --if private.cur_progress == "secret" then
    
    for i = 1, 4, 1 do
      
      if ng_global.progress[ private.cur_progress ][ "use_hobone"..i ].done == 0 then
        ObjDetach("spr_dogarea_panel_doors_sil_"..i);
      end;
      if ng_global.progress[ private.cur_progress ][ "use_hodogpart"..i ].done == 0 then
        ObjDetach("spr_dogarea_panel_doors_itm_"..i);
      end;
      
    end;
    
    --end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_dogarea");

    if ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_dogarea" ] then

      ng_global.nohintho[ "win_dogarea" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_dogarea" ] then
      ng_global.playedhops[ "win_dogarea" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_dogarea_insophiashouse",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )
  
  if task_name ~= "sock" and task_name ~= "glove" then
    ObjDelete( item_name.."_shadow" );
  end;
  
  cmn.HoTaskFind(item_name, task_name, 1);

end;
--------------------------------------------------------------------------------------------
function public.touch_duck()
  
  ObjSet("obj_dogareat_duck_touch",  { input = 0 });
  
  cmn.PlayAudio("snd", "assets/levels/level4/ho_dogarea/audio/aud_xx_clk_chicken");
  
  ObjSet("anm_dogarea_duck",  { playing = 1, endtrig = function() ObjSet("obj_dogareat_duck_touch",  { input = 1 }); end });
  
end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_hobone1", "use_hobone2", "use_hobone3", "use_hobone4",
                                    "use_hodogpart1", "use_hodogpart2", "use_hodogpart3", "use_hodogpart4" };
  
  --------------------------------------------------------------------------------------------
  -- function use_hobone1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hobone1" ] = {
      type = "use",
      inv_obj = "spr_dogarea_bone_1",
      use_place = "spr_dogarea_panel_doors_sil_1",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hobone1_beg = function ()
  
    ObjDelete( "spr_dogarea_bone_"..private.uses[1] );
    ObjDelete( "spr_dogarea_bone_"..private.uses[1].."_shadow" );
  
  end;
  local use_hobone1_end = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_sil_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hobone1", use_hobone1_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone1", use_hobone1_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone1_beg", use_hobone1_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone1_end", use_hobone1_end, "ho_dogarea" );
  --------------------------------------------------------------------------------------------
  -- function use_hobone2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hobone2" ] = {
      type = "use",
      inv_obj = "spr_dogarea_bone_2",
      use_place = "spr_dogarea_panel_doors_sil_2",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hobone2_beg = function ()
  
    ObjDelete( "spr_dogarea_bone_"..private.uses[2] );
    ObjDelete( "spr_dogarea_bone_"..private.uses[2].."_shadow" );
  
  end;
  local use_hobone2_end = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_sil_2" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hobone2", use_hobone2_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone2", use_hobone2_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone2_beg", use_hobone2_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone2_end", use_hobone2_end, "ho_dogarea" );
  --------------------------------------------------------------------------------------------
  -- function use_hobone3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hobone3" ] = {
      type = "use",
      inv_obj = "spr_dogarea_bone_3",
      use_place = "spr_dogarea_panel_doors_sil_3",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hobone3_beg = function ()
  
    ObjDelete( "spr_dogarea_bone_"..private.uses[3] );
    ObjDelete( "spr_dogarea_bone_"..private.uses[3].."_shadow" );
  
  end;
  local use_hobone3_end = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_sil_3" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hobone3", use_hobone3_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone3", use_hobone3_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone3_beg", use_hobone3_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone3_end", use_hobone3_end, "ho_dogarea" );
  --------------------------------------------------------------------------------------------
  -- function use_hobone4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hobone4" ] = {
      type = "use",
      inv_obj = "spr_dogarea_bone_4",
      use_place = "spr_dogarea_panel_doors_sil_4",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hobone4_beg = function ()
  
    ObjDelete( "spr_dogarea_bone_"..private.uses[4] );
    ObjDelete( "spr_dogarea_bone_"..private.uses[4].."_shadow" );
  
  end;
  local use_hobone4_end = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_sil_4" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hobone4", use_hobone4_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone4", use_hobone4_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone4_beg", use_hobone4_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hobone4_end", use_hobone4_end, "ho_dogarea" );
  
  --------------------------------------------------------------------------------------------
  -- function use_hodogpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hodogpart1" ] = {
      type = "use",
      inv_obj = "spr_dogarea_panel_doors_itm_1",
      use_place = "obj_dogarea_use_dogpart",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hodogpart1_beg = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_itm_1" );

    if cmn.IsEventDone( "use_hodogpart2" ) and cmn.IsEventDone( "use_hodogpart3" ) and cmn.IsEventDone( "use_hodogpart4" ) then
      ObjDelete( "obj_dogarea_use_dogpart" );
    end;

  end;
  local use_hodogpart1_end = function ()

    ObjSet( "spr_dogarea_box_part_1", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hodogpart1", use_hodogpart1_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart1", use_hodogpart1_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart1_beg", use_hodogpart1_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart1_end", use_hodogpart1_end, "ho_dogarea" );
  --------------------------------------------------------------------------------------------
  -- function use_hodogpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hodogpart2" ] = {
      type = "use",
      inv_obj = "spr_dogarea_panel_doors_itm_2",
      use_place = "obj_dogarea_use_dogpart",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hodogpart2_beg = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_itm_2" );

    if cmn.IsEventDone( "use_hodogpart1" ) and cmn.IsEventDone( "use_hodogpart3" ) and cmn.IsEventDone( "use_hodogpart4" ) then
      ObjDelete( "obj_dogarea_use_dogpart" );
    end;

  end;
  local use_hodogpart2_end = function ()

    ObjSet( "spr_dogarea_box_part_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hodogpart2", use_hodogpart2_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart2", use_hodogpart2_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart2_beg", use_hodogpart2_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart2_end", use_hodogpart2_end, "ho_dogarea" );
  --------------------------------------------------------------------------------------------
  -- function use_hodogpart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hodogpart3" ] = {
      type = "use",
      inv_obj = "spr_dogarea_panel_doors_itm_3",
      use_place = "obj_dogarea_use_dogpart",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hodogpart3_beg = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_itm_3" );

    if cmn.IsEventDone( "use_hodogpart1" ) and cmn.IsEventDone( "use_hodogpart2" ) and cmn.IsEventDone( "use_hodogpart4" ) then
      ObjDelete( "obj_dogarea_use_dogpart" );
    end;

  end;
  local use_hodogpart3_end = function ()

    ObjSet( "spr_dogarea_box_part_3", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hodogpart3", use_hodogpart3_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart3", use_hodogpart3_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart3_beg", use_hodogpart3_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart3_end", use_hodogpart3_end, "ho_dogarea" );
  --------------------------------------------------------------------------------------------
  -- function use_hodogpart4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hodogpart4" ] = {
      type = "use",
      inv_obj = "spr_dogarea_panel_doors_itm_4",
      use_place = "obj_dogarea_use_dogpart",
      room = "rm_insophiashouse",
      zz = "ho_dogarea",
      zz_gate = "gho_insophiashouse_dogarea"
  };
  --------------------------------------------------------------------------------------------
  local use_hodogpart4_beg = function ()
  
    ObjDelete( "spr_dogarea_panel_doors_itm_4" );

    if cmn.IsEventDone( "use_hodogpart1" ) and cmn.IsEventDone( "use_hodogpart2" ) and cmn.IsEventDone( "use_hodogpart3" ) then
      ObjDelete( "obj_dogarea_use_dogpart" );
    end;

  end;
  local use_hodogpart4_end = function ()

    ObjSet( "spr_dogarea_box_part_4", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hodogpart4", use_hodogpart4_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart4", use_hodogpart4_end, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart4_beg", use_hodogpart4_beg, "ho_dogarea" );
  cmn.AddSubscriber( "use_hodogpart4_end", use_hodogpart4_end, "ho_dogarea" );
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.GenHint()
  
  local vacant_bones = {};
  
  for i = 1, 4, 1 do
    
    local occup = false;
    
    for j = 1, 4, 1 do
      if i == private.uses[j] then
        occup = true;
        break;
      end;
    end;
    
    if not occup then
      table.insert( vacant_bones, i );
    end;
      
  end;
  
  local inc = 1;
  
  for i = 1, 4, 1 do
    
    if not cmn.IsEventDone("use_hobone"..i) then
      game.hint[ "use_hobone"..i ].inv_obj = "spr_dogarea_bone_"..vacant_bones[inc];
      inc = inc+1;
    end;
    
  end;
  
end;
------------------------------------------------------------------------------
function public.start_drag( name )
  
  int_taskpanel_impl.PanelDoorsObjStartDrag( name );
  ObjAnimate(name.."_shadow", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  
  if name == "spr_dogarea_bone_1" then
    ObjSet("spr_dogarea_bone_1",  { ang = -1.15 });
  end;
  
end;
------------------------------------------------------------------------------
function public.use_hobone( num )
  
  int_taskpanel_impl.PanelDoorsObjDragDrop();
  
  local door = 0;
  local item = "spr_dogarea_bone_"..num;
  
  for i = 1, 4, 1 do
    
    if ( ObjIntersect( item, "spr_dogarea_panel_doors_sil_"..i ) ) then
      door = i;
      break;
    end;
    
  end;
  
  if door == 0 or cmn.IsEventDone("use_hobone"..door) then
    
    cmn.WrongApply(); 
    
    if num == 1 then
      ObjSet("spr_dogarea_bone_1",  { ang = 0 });
    end;
    
    if num < 3 then
      ObjAnimate(item.."_shadow", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });
    end;
    
  else 
    
    private.uses[door] = num;
    
    cmn.SetEventDone( "use_hobone"..door );
    cmn.CallEventHandler( "use_hobone"..door.."_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      public.GenHint();

      cmn.CallEventHandler( "use_hobone"..door.."_end" );

    end;

    cmn.Lock( 1, { room = 1 } );

    int_taskpanel.OpenPanelDoor( door, func_after );
    
  end;
  
end;
------------------------------------------------------------------------------
function public.use_hodogpart1()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_dogarea_panel_doors_itm_1";

  if ( cmn.ApplyObj( item, "obj_dogarea_use_dogpart" ) ) then

    cmn.CallEventHandler( "use_hodogpart1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hodogpart1" );
      cmn.CallEventHandler( "use_hodogpart1_end" );
      
      int_taskpanel.OpenPanelDoor( 1 );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");

    ObjAnimate("spr_dogarea_box_part_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
function public.use_hodogpart2()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_dogarea_panel_doors_itm_2";

  if ( cmn.ApplyObj( item, "obj_dogarea_use_dogpart" ) ) then

    cmn.CallEventHandler( "use_hodogpart2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hodogpart2" );
      cmn.CallEventHandler( "use_hodogpart2_end" );
      
      int_taskpanel.OpenPanelDoor( 2 );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");

    ObjAnimate("spr_dogarea_box_part_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
function public.use_hodogpart3()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_dogarea_panel_doors_itm_3";

  if ( cmn.ApplyObj( item, "obj_dogarea_use_dogpart" ) ) then

    cmn.CallEventHandler( "use_hodogpart3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hodogpart3" );
      cmn.CallEventHandler( "use_hodogpart3_end" );
      
      int_taskpanel.OpenPanelDoor( 3 );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");

    ObjAnimate("spr_dogarea_box_part_3", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
function public.use_hodogpart4()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_dogarea_panel_doors_itm_4";

  if ( cmn.ApplyObj( item, "obj_dogarea_use_dogpart" ) ) then

    cmn.CallEventHandler( "use_hodogpart4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hodogpart4" );
      cmn.CallEventHandler( "use_hodogpart4_end" );
      
      int_taskpanel.OpenPanelDoor( 4 );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");

    ObjAnimate("spr_dogarea_box_part_4", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();

  end;

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.stages_task()

  local ho_tasks = {};

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].stage[1] == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "ball",    1, 0, { { "spr_dogarea_ball" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "clothes", 1, 0, { { "spr_dogarea_clothes" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "bow",     1, 0, { { "spr_dogarea_bow" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "bowl",    1, 0, { { "spr_dogarea_bowl" } } );
    
    interface.TaskPanelTaskAdd( ho_tasks, "frisbee", 1, 0, { { "spr_dogarea_frisbee" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "glove",   1, 0, { { "spr_dogarea_glove" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "comb",    1, 0, { { "spr_dogarea_comb" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "lead",    1, 0, { { "spr_dogarea_lead" } } );
    
    interface.TaskPanelTaskAdd( ho_tasks, "whistle", 1, 0, { { "spr_dogarea_whistle" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "sock",    1, 0, { { "spr_dogarea_sock" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "collar",  1, 0, { { "spr_dogarea_collar" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "book",    1, 0, { { "spr_dogarea_book" } } );

  elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_dogarea" ].stage[1] == 2 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "alarm",  1, 0, { { "spr_dogarea_alarm" } } );

  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
function public.stage_1()

end;
------------------------------------------------------------------------------
function public.stage_2()

  interface_impl.TaskPanelSetNewTask( private.stages_task() );

  local func_after = function ()
    ObjSet( "spr_dogarea_alarm", { input = 1 } );
    cmn.Lock( 0 );
  end;

  cmn.Lock( 1, { interface = 1, room = 1 } );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_box4");

  ObjAnimate( "spr_dogarea_box_closed", "alp", 0, 0, "",       { 0, 0, 1,    0.5, 0, 0 } );
  ObjAnimate( "obj_dogarea_box_open", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #private.start_add, 1 do
    
    if not ObjGet( private.start_add[i].name ) then
      
      local typ = common.GetObjectPrefix( private.start_add[i].name );
      
      ObjCreate( private.start_add[i].name, typ );
      ObjSet( private.start_add[i].name, private.start_add[i].prop );
      ObjAttach( private.start_add[i].name, private.start_add[i].parent );

    else 
      
      ObjSet( private.start_add[i].name, private.start_add[i].prop );
      ObjAttach( private.start_add[i].name, private.start_add[i].parent );

    end;

  end;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

end;
--*****************************************************************************************************************