-- name=ho_honorary
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_honorary" );
  game.relations[ "ho_honorary" ].exitroom = "rm_lvl4corridor";
  
  private.tasks = { "pumpkin", "dna", "stethoscope", "caduceus", "formula", "cardiogram", "pills", "bat", "microscope", "syringe", "photo", "tubes" };
  private.slider = 0;
  private.slider_borders = { -164, 164 };
  
  private.back_borders = { {-1366, 0}, {-768, 0} };
  
  private.objects_pos = { 
    {-1023, -101}, {-1356, -303}, {-538, 0}, {-941, -417}, {-1362, -437}, {-1304, -701},
    {-1185, -530}, {-564, -395}, {-245, -605}, {0, -422}, {0, 0}, {-1, -523}
  };
  
  private.foreground_pos = {
    {848, 153}, {693, 199}, {886, 354}, {573, 361}, {492, 491}, {830, 461},
    {171, 547}, {675, 445}, {450, 309}, {381, 558}, {190, 272}, {472, 132}
  };
  
  private.active_objects = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  
  private.slider_dev = 0;
  ------------------------------------------------------------------------------
  game.honorary = {};
  game.honorary.double_hint = nil;
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_honorary" ] = 
  {
    type = "win",
    room = "rm_lvl4corridor",
    zz = "ho_honorary",
    zz_gate = "gho_lvl4corridor_honorary"
  };
  --------------------------------------------------------------------------------------------------
  local win_honorary_func = function ()

    if ( cmn.IsEventDone( "win_honorary" ) ) then
      common_impl.InventoryComplexItemAdd( "inv_pictureinframe", "spr_honorary_win" );
      ObjDelete("gho_lvl4corridor_honorary");
    end;

  end;
  cmn.AddSubscriber( "win_honorary", win_honorary_func );
  --------------------------------------------------------------------------------------------------
  local start_honorary_func = function ()

    if ( cmn.IsEventStart( "win_honorary" ) ) then

      common_impl.ProcessHoStart( "honorary" );

    end;

  end;
  cmn.AddSubscriber( "win_honorary", start_honorary_func, "ho_honorary" );
  
  --for secretroom
    private.tasks2 =  {    
      { "pumpkin",     1, 0, { { "obj_honorary_pumpkin" } } },
      { "dna",         1, 0, { { "obj_honorary_dna" } } },
      { "stethoscope",  1, 0, { { "obj_honorary_stethoscope" } } },
      { "caduceus",     1, 0, { { "obj_honorary_caduceus" } } },

      { "formula",    1, 0, { { "obj_honorary_formula" } } },
      { "cardiogram", 1, 0, { { "obj_honorary_cardiogram" } } },
      { "pills",      1, 0, { { "obj_honorary_pills" } } },
      { "bat",        1, 0, { { "obj_honorary_bat" } } },

      { "microscop",  1, 0, { { "obj_honorary_microscope" } } },
      { "syringe",    1, 0, { { "obj_honorary_syringe" } } },
      { "tubes",      1, 0, { { "obj_honorary_tubes" } } },
      { "photo",      1, 0, { { "obj_honorary_photo" } } }
  };
    
  private.start = {};
  
  for i = 1, #private.tasks2, 1 do

    for j = 1, private.tasks2[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks2[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "ext" and not ( ng_global.progress[ "ext" ][ "win_honorary" ].state ) then
    ng_global.progress[ "ext" ][ "win_honorary" ].state = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {0.5, 0.5} };  
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_honorary" ].state = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {0.5, 0.5} };
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_honorary" ].state;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_corridor_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
  if port.isPortable() == 1 then
    iOS_EnableMultiTouch(1); 
  end;
  if ng_global.currentprogress == "ext" then
    common.SetPreviousRoom( "rm_lvl4corridor" );
    cmn.StartTimePassing("ho_honorary");
  else 
    
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_honorary" ].state = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {0.5, 0.5} };
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_honorary" ].state;
    private.active_objects = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_honorary_lvl4corridor",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "honorary_lvl4corridor", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "honorary_lvl4corridor" ); end });
    
  end;
  
  private.DrawScene();

  if not cmn.IsEventStart( "win_honorary" ) then
    cmn.InitHo( "honorary" );
  end;

  local ho_tasks = {};
  
  interface.TaskPanelTaskAdd( ho_tasks, "pumpkin", 1, 0, { { "obj_honorary_pumpkin" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "dna", 1, 0, { { "obj_honorary_dna" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "stethoscope", 1, 0, { { "obj_honorary_stethoscope" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "caduceus", 1, 0, { { "obj_honorary_caduceus" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "formula", 1, 0, { { "obj_honorary_formula" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cardiogram", 1, 0, { { "obj_honorary_cardiogram" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "pills", 1, 0, { { "obj_honorary_pills" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bat", 1, 0, { { "obj_honorary_bat" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "microscope", 1, 0, { { "obj_honorary_microscope" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "syringe", 1, 0, { { "obj_honorary_syringe" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "photo", 1, 0, { { "obj_honorary_photo" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "tubes", 1, 0, { { "obj_honorary_tubes" } } );

  if (not cmn.IsEventDone("win_honorary")) then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

  iOS_NeedDrag(0);
end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
  if ng_global.currentprogress == "ext" and not ng_global.lvl1_tutor_skip and not(cmn.IsEventDone("tutor_30")) then

    local arrows = { { pos_x = 0, pos_y = -250, ang = 0 }, { pos_x = -420, pos_y = 0, ang = 1.57 } };
    cmn.TutorialShow( "tutor_30", 0, 512, 340, arrows );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  
  iOS_NeedDrag(1);
  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_honorary_lvl4corridor",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_honorary");

    if ng_global.progress[ ng_global.currentprogress ][ "win_honorary" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_honorary" ] then

      ng_global.nohintho[ "win_honorary" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_honorary" ] then
      ng_global.playedhops[ "win_honorary" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_honorary_lvl4corridor",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  
  local ind = private.FindIndex( item_name );
  
  private.state[ind] = 1;
  private.active_objects[ind] = 0;
  
  ObjSet("fx_honorary_"..item_name,  { active = 1, visible = 1, alp = 1 });
  PartSysRestart("fx_honorary_"..item_name);
  
  cmn.HoTaskFind( "obj_honorary_"..item_name, item_name, 1 );
  
  local back_pos, perc = {}, {};
  perc[1] = private.state[13][1];
  perc[2] = private.state[13][2];
  
  back_pos[1] = math.floor( private.back_borders[1][2] - (private.back_borders[1][2] - private.back_borders[1][1])*perc[1] );
  back_pos[2] = math.floor( private.back_borders[2][2] - (private.back_borders[2][2] - private.back_borders[2][1])*perc[2] );
  
  private.CreateHint( back_pos );
  
  ObjAnimate("spr_honorary_"..item_name.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.7, 0, 0 });
  ObjAnimate("spr_honorary_"..item_name.."_2", "alp", 0, 0, "", { 0, 0, 1,   0.7, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, #private.tasks, 1 do
    
    if private.state[i] == 1 then
      ObjDelete("spr_honorary_"..private.tasks[i].."_1");
      ObjDelete("spr_honorary_"..private.tasks[i].."_2");
    end;
    
  end;
  
  if ng_global.currentprogress == "secret" then
    
    for i = 1, #private.tasks, 1 do
      
      ObjMultiSet( { {"spr_honorary_"..private.tasks[i].."_1", { alp = 1 }},
                     {"spr_honorary_"..private.tasks[i].."_2", { alp = 1 }},
                     {"spr_honorary_"..private.tasks[i].."_1_on", { alp = 0 }},
                     {"spr_honorary_"..private.tasks[i].."_2_on", { alp = 0 }} } );
    
    end;
    
  end;
  
  local slider_pos, back_pos, perc = {}, {}, {};
  perc[1] = private.state[13][1];
  perc[2] = private.state[13][2];
  
  back_pos[1] = math.floor( private.back_borders[1][2] - (private.back_borders[1][2] - private.back_borders[1][1])*perc[1] );
  back_pos[2] = math.floor( private.back_borders[2][2] - (private.back_borders[2][2] - private.back_borders[2][1])*perc[2] );
  
  slider_pos[1] = math.floor( private.slider_borders[1] + (private.slider_borders[2] - private.slider_borders[1])*perc[1] );
  slider_pos[2] = math.floor( private.slider_borders[1] + (private.slider_borders[2] - private.slider_borders[1])*perc[2] );
  
  private.CheckActiveObjects( back_pos, false );
  private.CreateHint( back_pos );
  
  ObjMultiSet( { {"spr_honorary_slider_1", { pos_x = slider_pos[1] }},
                 {"spr_honorary_slider_2", { pos_y = slider_pos[2] }},
                 {"obj_honorary_back", { pos_x = back_pos[1], pos_y = back_pos[2] }} } );
  
end;
--------------------------------------------------------------------------------------------------
function public.FocusSlider( num, inout )
  
  local obj_name = "spr_honorary_slider_"..num.."_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
    ObjSet(obj_name,  { pos_z = 0 });
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    ObjSet(obj_name,  { pos_z = 2 });
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
--------------------------------------------------------------------------------------------------
function public.StartDragSlider( num )
  
  cmn.PlayAudio("snd", "assets/levels/level4/ho_honorary/audio/aud_clk_ho4");
  
  private.slider = num;
  ObjStartDrag("obj_honorary_interface_drag");
  
  local curs = GetZoomCursorPos();
  curs[1] = math.floor( curs[1] - 512 );
  curs[2] = math.floor( curs[2] - 340 );
  
  if num == 1 then
    private.slider_dev = curs[1];
  else 
    private.slider_dev = curs[2];
  end;
  
  public.FocusSlider( num, 0 );

end;
--------------------------------------------------------------------------------------------------
function public.DragSlider()
  
  local slider = private.slider;
  local dev = private.slider_dev;
  local curs = GetZoomCursorPos();
  curs[1] = math.floor( curs[1] - 512 );
  curs[2] = math.floor( curs[2] - 340 );
  
  local delta1 = curs[ slider ] - dev;
  
  local slider_pos = math.floor( private.slider_borders[1] + (private.slider_borders[2] - private.slider_borders[1])*private.state[13][slider] ) + delta1;
  
  if slider_pos < private.slider_borders[1] then
    slider_pos = private.slider_borders[1];
  elseif slider_pos > private.slider_borders[2] then
    slider_pos = private.slider_borders[2];
  end;
  
  local delta = slider_pos - private.slider_borders[1];
  local perc = ( delta/( (private.slider_borders[2] - private.slider_borders[1])/100 ) )/100;
  
  local back_pos = {0, 0}
  back_pos[ slider ] = math.floor( private.back_borders[ slider ][2] - (private.back_borders[ slider ][2] - private.back_borders[ slider ][1])*perc );
  
  if slider == 1 then
    back_pos[2] = math.floor( private.back_borders[2][2] - (private.back_borders[2][2] - private.back_borders[2][1])*private.state[13][2] );
  else 
    back_pos[1] = math.floor( private.back_borders[1][2] - (private.back_borders[1][2] - private.back_borders[1][1])*private.state[13][1] );
  end;
  
  private.CheckActiveObjects( back_pos, true );
  
  if slider == 1 then
    ObjMultiSet( { {"spr_honorary_slider_"..slider, { pos_x = slider_pos }},
                   {"obj_honorary_back", { pos_x = back_pos[1] }} } );
  else 
    ObjMultiSet( { {"spr_honorary_slider_"..slider, { pos_y = slider_pos }},
                   {"obj_honorary_back", { pos_y = back_pos[2] }} } );
  end;
  
end;
--------------------------------------------------------------------------------------------------
function public.DropSlider()
  
  local slider = private.slider;
  local dev = private.slider_dev;
  private.slider_dev = 0;
  private.slider = 0;
  
  local curs = GetZoomCursorPos();

  curs[1] = math.floor( curs[1] - 512 );
  curs[2] = math.floor( curs[2] - 340 );
  
  local delta1 = curs[ slider ] - dev;
  local slider_pos = math.floor( private.slider_borders[1] + (private.slider_borders[2] - private.slider_borders[1])*private.state[13][slider] ) + delta1;
  
  if slider_pos < private.slider_borders[1] then
    slider_pos = private.slider_borders[1];
  elseif slider_pos > private.slider_borders[2] then
    slider_pos = private.slider_borders[2];
  end;
  
  local delta = slider_pos - private.slider_borders[1];
  local perc = ( delta/( (private.slider_borders[2] - private.slider_borders[1])/100 ) )/100;
  
  local back_pos = {0, 0}
  back_pos[ slider ] = math.floor( private.back_borders[ slider ][2] - (private.back_borders[ slider ][2] - private.back_borders[ slider ][1])*perc );
  
  if slider == 1 then
    back_pos[2] = math.floor( private.back_borders[2][2] - (private.back_borders[2][2] - private.back_borders[2][1])*private.state[13][2] );
  else 
    back_pos[1] = math.floor( private.back_borders[1][2] - (private.back_borders[1][2] - private.back_borders[1][1])*private.state[13][1] );
  end;
  
  private.state[13][ slider ] = perc;
  
  private.CheckActiveObjects( back_pos, true );
  private.CreateHint( back_pos );
  
  if slider == 1 then
    ObjMultiSet( { {"spr_honorary_slider_"..slider, { pos_x = slider_pos }},
                   {"obj_honorary_back", { pos_x = back_pos[1] }} } );
  else 
    ObjMultiSet( { {"spr_honorary_slider_"..slider, { pos_y = slider_pos }},
                   {"obj_honorary_back", { pos_y = back_pos[2] }} } );
  end;
                 
end;
--------------------------------------------------------------------------------------------------
function private.FindIndex( name )
  
  local ind = 0;
  
  for i = 1, #private.tasks, 1 do
    
    if private.tasks[i] == name then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;

end;
--------------------------------------------------------------------------------------------------
--оболочка для вызова при изменении размеров окна
function public.CreateHint()
  
  local back_pos, perc = {}, {};
  perc[1] = private.state[13][1];
  perc[2] = private.state[13][2];
  
  back_pos[1] = math.floor( private.back_borders[1][2] - (private.back_borders[1][2] - private.back_borders[1][1])*perc[1] );
  back_pos[2] = math.floor( private.back_borders[2][2] - (private.back_borders[2][2] - private.back_borders[2][1])*perc[2] );
  
  private.CreateHint( back_pos );
  
end;
--------------------------------------------------------------------------------------------------
function private.CreateHint( back_pos )
  
  local check = false;
  
  for i = 1, #private.active_objects, 1 do
    
    if private.active_objects[i] == 1 then
      check = true;
      break;
    end;
    
  end;
  
  if check then
    
    game.honorary.double_hint = nil;
    
  else 
    
    game.honorary.double_hint = {};
    
    local range_y, range_x, centr = {}, {}, {};
    range_y[1] = 20;
    range_y[2] = 600;
    range_x[1] = 20;
    range_x[2] = 1000;
    
    if GetWideScreen() then
      range_x[1] = -170;
      range_x[2] = range_x[2] + 170;
    end;
    
    --DbgTrace( range_x[1].." "..range_x[2] );
    --DbgTrace( range_y[1].." "..range_y[2] );
    
    for i = 1, 12, 1 do
    
      centr[1] = private.foreground_pos[i][1] + ( back_pos[1] - private.objects_pos[i][1] );
      centr[2] = private.foreground_pos[i][2] + ( back_pos[2] - private.objects_pos[i][2] );
      
      if private.state[i] == 0 and centr[1] > range_x[1] and centr[1] < range_x[2]
      and centr[2] > range_y[1] and centr[2]< range_y[2] then 
      
        table.insert( game.honorary.double_hint, {} );
        game.honorary.double_hint[ #game.honorary.double_hint ][1] = "spr_honorary_"..private.tasks[i].."_1";
        game.honorary.double_hint[ #game.honorary.double_hint ][2] = "spr_honorary_"..private.tasks[i].."_2";
        
      end;
    
    end;
    
    if #game.honorary.double_hint == 0 then
      
      table.insert( game.honorary.double_hint, {"spr_honorary_slider_1", "spr_honorary_slider_2"} );
      
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------------
function private.CheckActiveObjects( back_pos, need_anm )
  
  need_anm = need_anm or false;
  
  local centr = {0, 0}; 
  local accuracy = 10;
  
  for i = 1, 12, 1 do
    
    centr[1] = private.objects_pos[i][1];
    centr[2] = private.objects_pos[i][2];
    
    if private.state[i] == 0 and ( (back_pos[1] - centr[1])^2 + (back_pos[2] - centr[2])^2 ) <= accuracy^2 then 
      
      if need_anm then
        
        if private.active_objects[i] == 0 then
        
          private.active_objects[i] = 1;
          
          cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_xx_menter_darkroom");
          
          local alf = ObjGet("spr_honorary_"..private.tasks[i].."_1_on").alp;
          local tme = ( 1 - alf ) * 0.3;
          
          ObjSet("obj_honorary_"..private.tasks[i],  { input = 1 });
          
          ObjAnimate("spr_honorary_"..private.tasks[i].."_1_on", "alp", 0, 0, "", { 0, 0, alf,   tme, 0, 1 });
          ObjAnimate("spr_honorary_"..private.tasks[i].."_2_on", "alp", 0, 0, "", { 0, 0, alf,   tme, 0, 1 });
          
        end;
        
      else 
        ObjMultiSet( { {"spr_honorary_"..private.tasks[i].."_1_on", { alp = 1 }},
                       {"spr_honorary_"..private.tasks[i].."_2_on", { alp = 1 }},
                       {"obj_honorary_"..private.tasks[i], { input = 1 }} } );
      end;
                     
    elseif private.state[i] == 0 and not( ( (back_pos[1] - centr[1])^2 + (back_pos[2] - centr[2])^2 ) <= accuracy^2 ) then
                     
      if need_anm then
        
        if private.active_objects[i] == 1 then
        
          private.active_objects[i] = 0;
          
          local alf = ObjGet("spr_honorary_"..private.tasks[i].."_1_on").alp;
          local tme = alf * 0.3;
          
          ObjSet("obj_honorary_"..private.tasks[i],  { input = 0 });
          
          ObjAnimate("spr_honorary_"..private.tasks[i].."_1_on", "alp", 0, 0, "", { 0, 0, alf,   tme, 0, 0 });
          ObjAnimate("spr_honorary_"..private.tasks[i].."_2_on", "alp", 0, 0, "", { 0, 0, alf,   tme, 0, 0 });
          
        end;
        
      else 
        ObjMultiSet( { {"spr_honorary_"..private.tasks[i].."_1_on", { alp = 0 }},
                       {"spr_honorary_"..private.tasks[i].."_2_on", { alp = 0 }},
                       {"obj_honorary_"..private.tasks[i], { input = 0 }} } );
      end;
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  
  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;
  
end;
--********************************************************************************************************************