-- name=ho_introllscave
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_introllscave" );
  game.relations[ "ho_introllscave" ].exitroom = "mg_trollrift";
  
  public.change_stage_anim_type = "alp";
  public.task_count_show = 13;
  public.tasks_img = { "picture", "lute", "cauldron", "clock", "boots", "helmet" };
  
  private.cur_progress = "ext";
  
  private.tasks_order = { "gauntlet", "picture", "basket", "lute", "sack", "cauldron", "sword", "clock", "saddle", "boots", "bell", "helmet" };
  
  private.parts_order = { 1, 2, 7, 3, 8, 4, 9, 5, 11, 6, 12, 10 };
  private.parts_pos = { 
    {440, 317}, {593, 437}, {560, 167}, {142, 358}, {772, 478}, {158, 117},
    {490, 498}, {803, 241}, {341, 580}, {933, 87}, {951, 443}, {105, 534}
  };
  private.final_pos = { 
    {609, 630}, {661, 610}, {716, 601}, {729, 627}, {673, 549}, {632, 590},
    {634, 597}, {683, 629}, {621, 618}, {682, 577}, {651, 621}, {709, 620}
  };
  
  private.object_pos = { 
    { 
      {439, 309, 0}, {613, 422, 0}, {490, 501, 0}, {543, 161, 0}, {809, 219, 0}, {143, 364, 0},
      {325, 551, 0}, {770, 439, 0}, {938, 422, 0}, {161, 110, 0}, {114, 510, 0}, {916, 86, 0}
    },
    { 
      {316, 242, 0}, {663, 260, 0.29}, {538, 606, -0.25}, {448, 93, 0}, {890, 285, 0.54}, {37, 366, 0.36},
      {359, 670, 0.77}, {701, 453, -0.07}, {1007, 311, -0.61}, {93, 139, 0.05}, {219, 553, 0}, {851, 73, 0.09}
    }
  };
  --------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------
  game.introllscave = {};
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_introllscave" ] = 
  {
    type = "win",
    room = "mg_trollrift",
    zz = "ho_introllscave",
    zz_gate = "gho_trollrift_introllscave"
  };
  --------------------------------------------------------------------------------------------------
  local win_introllscave_func = function ()

    if ( cmn.IsEventDone( "win_introllscave" ) ) then
      interface.InventoryItemAdd( "inv_bucket", "spr_introllscave_win" );
      ObjDelete("gho_trollrift_introllscave");
    end;

  end;
  cmn.AddSubscriber( "win_introllscave", win_introllscave_func );
  --------------------------------------------------------------------------------------------------
  local start_introllscave_func = function ()

    if ( cmn.IsEventStart( "win_introllscave" ) ) then

      --common_impl.ProcessHoStart( "introllscave", true );

    end;

  end;
  cmn.AddSubscriber( "win_introllscave", start_introllscave_func, "ho_introllscave" );
  
  --for secretroom
  private.tasks =  {    
      { "gauntlet",  1, 0, { { "spr_introllscave_gauntlet", "obj_introllscave_gauntlet_fly" } } },
      { "picture",   1, 0, { { "spr_introllscave_picture", "spr_introllscave_picture_2", "spr_introllscave_picture_2_frame", "obj_introllscave_picture_fly" } } },
      { "basket",    1, 0, { { "spr_introllscave_basket", "obj_introllscave_basket_fly" } } },
      { "lute",      1, 0, { { "spr_introllscave_lute", "spr_introllscave_lute_2", "obj_introllscave_lute_fly" } } },

      { "sack",      1, 0, { { "spr_introllscave_sack", "obj_introllscave_sack_fly" } } },
      { "cauldron",  1, 0, { { "spr_introllscave_cauldron", "spr_introllscave_cauldron_2", "obj_introllscave_cauldron_fly" } } },
      { "sword",   1, 0, { { "spr_introllscave_sword", "obj_introllscave_sword_fly" } } },
      { "clock",   1, 0, { { "spr_introllscave_clock", "spr_introllscave_clock_2", "obj_introllscave_clock_fly" } } },

      { "saddle",  1, 0, { { "spr_introllscave_saddle", "obj_introllscave_saddle_fly", "spr_introllscave_saddle_bl", "spr_introllscave_saddle_bl_2" } } },
      { "boots",   1, 0, { { "spr_introllscave_boots", "spr_introllscave_boots_2", "obj_introllscave_boots_fly" } } },
      { "bell",    1, 0, { { "spr_introllscave_bell", "obj_introllscave_bell_fly" } } },
      { "helmet",  1, 0, { { "spr_introllscave_helmet", "spr_introllscave_helmet_2", "obj_introllscave_helmet_fly" } } },
      { "bucket",  1, 0, { { "obj_introllscave_bucket_whole", "spr_introllscave_bucket", "spr_introllscave_bucket_shadow" } } }
  };
  
  private.start = {};
  private.start_items = {};
  local nme = "";

  for i = 1,  #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if i < 13 and i % 2 == 0 then

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img_2";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "ext" and not ( ng_global.progress[ "ext" ][ "win_introllscave" ].stage ) then
    ng_global.progress[ "ext" ][ "win_introllscave" ].stage = { 1, 13 };   --[1] - номер стадии, [2] - количество стадий
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage = { 1, 13 };
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_trollrift_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_trollrift_env");
	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  if ng_global.currentprogress == "ext" then
    private.cur_progress = "ext";
    common.SetPreviousRoom( "mg_trollrift" );
    cmn.StartTimePassing("ho_introllscave");
  else 
    
    private.cur_progress = "secret";
    public.task_count_show = 13;
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage = { 1, 13 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_introllscave_trollrift",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "introllscave_trollrift", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "introllscave_trollrift" ); end });
    
  end;

  if not cmn.IsEventStart( "win_introllscave" ) then
    cmn.InitHo( "introllscave" );
  end;

  local ho_tasks = private.stages_task();
  
  private.DrawScene()
  
  if (not cmn.IsEventDone("win_introllscave"))
  and ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_introllscave_trollrift",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()

  if ng_global.progress[ private.cur_progress ][ "win_introllscave" ].stage[1] < ng_global.progress[ private.cur_progress ][ "win_introllscave" ].stage[2] and
     ng_global.progress[ private.cur_progress ][ "win_introllscave" ].stage[1] % 2 == 0 then
    
    local st = ng_global.progress[ private.cur_progress ][ "win_introllscave" ].stage[1]/2;
    
    ObjDetach("spr_introllscave_"..public.tasks_img[st].."_task_img");
    
  end;
    
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_introllscave");

    if ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_introllscave" ] then

      ng_global.nohintho[ "win_introllscave" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_introllscave" ] then
      ng_global.playedhops[ "win_introllscave" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_introllscave_trollrift",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[1]-1, 1 do
    
    if i < 13 then
    
      ObjDelete("spr_introllscave_bucket_part_"..private.parts_order[ i ]);
      ObjDelete("spr_introllscave_bucket_part_"..private.parts_order[ i ].."_sh");
      
      if i ~= 2 then
        ObjMultiSet( { {"spr_introllscave_bucket_"..private.parts_order[ i ],  { alp = 1 }},
                       {"spr_introllscave_"..private.tasks_order[ i ], { pos_x = private.object_pos[2][i][1], pos_y = private.object_pos[2][i][2] }},
                       {"spr_introllscave_"..private.tasks_order[ i ].."_2", { alp = 1 }} } );
      else 
        ObjMultiSet( { {"spr_introllscave_bucket_"..private.parts_order[ i ],  { alp = 1 }},
                       {"spr_introllscave_"..private.tasks_order[ i ].."_2", { alp = 1, pos_x = private.object_pos[2][i][1], pos_y = private.object_pos[2][i][2] }},
                       {"spr_introllscave_"..private.tasks_order[ i ], { alp = 0 }} } );
      end;
                     
      if i == 9 then
        ObjDelete("spr_introllscave_saddle_bl");
        ObjSet("spr_introllscave_saddle_bl_2",  { alp = 1 });
      end;
                     
    end;
    
  end;
  
  if ng_global.currentprogress == "secret" then
    
    ObjSet("obj_introllscave_bucket_parts_2",  { alp = 1 });
    
    for i = 1, 12, 1 do
      
      ObjAttach( "spr_introllscave_bucket_part_"..private.parts_order[ i ], "obj_introllscave_bucket_parts" );
      
      ObjMultiSet( { {"spr_introllscave_bucket_part_"..private.parts_order[ i ], { alp = 1, pos_x = private.parts_pos[ private.parts_order[ i ] ][1], pos_y = private.parts_pos[ private.parts_order[ i ] ][2] }},
                     {"spr_introllscave_bucket_part_"..private.parts_order[ i ].."_sh", { alp = 1 }},
                     {"spr_introllscave_bucket_"..private.parts_order[ i ], { alp = 0 }} } );
      
    end;
    
  end;
  
  if ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[1] == 13 then
    ObjMultiSet( { {"obj_introllscave_bucket_whole", { alp = 1, input = 1 }},
                   {"spr_introllscave_bucket", { input = 1 }},
                   {"obj_introllscave_bucket_parts_2", { alp = 0 }} } );
  else
    ObjMultiSet( { {"obj_introllscave_bucket_whole", { alp = 0, input = 0 }},
                   {"spr_introllscave_bucket", { input = 0 }},
                   {"obj_introllscave_bucket_parts_2", { alp = 1 }} } );              
  end;
                 
  if cmn.IsEventDone("win_introllscave") or ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[1] > ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[2] then
    ObjDelete("spr_introllscave_bucket_shadow");
    ObjSet("obj_introllscave_bucket_parts_2",  { alp = 0 });
  end;
  
end;
------------------------------------------------------------------------------
function private.MoveObject( name )
  
  local num = ng_global.progress[ private.cur_progress ][ "win_introllscave" ].stage[1]
  local part = private.parts_order[ num ];
  
  local point_a, point_b = {}, {};
  point_a[1] = private.object_pos[1][num][1];
  point_a[2] = private.object_pos[1][num][2];
  point_b[1] = private.object_pos[2][num][1];
  point_b[2] = private.object_pos[2][num][2];
  
  if num == 9 then
    ObjAnimate("spr_introllscave_saddle_bl", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
    ObjAnimate("spr_introllscave_saddle_bl_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.4, 0, 1 });
  end;
  
  ObjAnimate(name, "ang", 0, 0, "", { 0, 0, private.object_pos[1][num][3],   0.4, 0, private.object_pos[2][num][3] });
  ObjAnimate(name, "pos_xy", 0, 0, function() private.PartFly( part ); end, { 0, 0, point_a[1], point_a[2],   0.4, 0, point_b[1], point_b[2] });
  
end;
------------------------------------------------------------------------------
function private.PartFly( part )
  
  local point_a, point_b = {}, {};
  point_a[1] = private.parts_pos[part][1];
  point_a[2] = private.parts_pos[part][2];
  point_b[1] = private.final_pos[part][1];
  point_b[2] = private.final_pos[part][2];
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.002 * len;
  
  if tme > 0.6 then
    tme = 0.6;
  end;

  local anm_end = function ()
    
    ObjAnimate("spr_introllscave_bucket_part_"..part, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_introllscave_bucket_"..part, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  ObjAnimate("spr_introllscave_bucket_part_"..part.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
  
  ObjAttach( "spr_introllscave_bucket_part_"..part, "obj_introllscave_fly" );
  ObjAnimate("spr_introllscave_bucket_part_"..part, "pos_xy", 0, 0, anm_end, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
  
end;
------------------------------------------------------------------------------
function public.ItemUse( item_name, task_name )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  if ( cmn.ApplyObj( item_name.."_task_img_2", item_name ) ) then
    
    local func_after = function ()

      cmn.Lock( 0 );

      if task_name ~= "picture" then
        public.ItemFound( item_name, task_name );
      else 
        public.ItemFound( item_name.."_2", task_name );
      end;
    
    end;

    cmn.Lock( 1, { room = 1 } );
    
    ObjSet( item_name.."_task_img",  { alp = 0, input = false } );
    
    if task_name == "picture" then
      ObjAnimate( item_name, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    end;
    
    ObjAnimate( item_name.."_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    
  end;
  
end;
------------------------------------------------------------------------------
function public.ItemFound( item_name, task_name )
  
  if task_name ~= "bucket" then
    ObjSet(item_name,  { input = 0 });
    private.MoveObject( item_name );
    cmn.HoTaskFind( "obj_introllscave_"..task_name.."_fly", task_name, 1 );
  else 
    ObjDelete("spr_introllscave_bucket_shadow");
    cmn.HoTaskFind( item_name, task_name, 1 );
  end;

end;
------------------------------------------------------------------------------
function public.touch_bat( num )
  
  local func_after = function ()
    
    ObjMultiSet( { {"anm_introllscave_bat_"..num.."_touch", { alp = 0 }},
                   {"anm_introllscave_bat_"..num, { playing = 1, alp = 1 }},
                   {"obj_introllscave_bat_"..num.."_touch", { input = 1 }} } );
    
  end;
  
  if num == 1 then
    cmn.PlayAudio("snd", "assets/levels/level4/ho_introllscave/audio/aud_xx_clk_bat");
  else
    cmn.PlayAudio("snd", "assets/levels/level4/ho_introllscave/audio/aud_xx_clk_bat2");
  end;
  
  ObjMultiSet( { {"anm_introllscave_bat_"..num.."_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_introllscave_bat_"..num, { playing = 0, alp = 0 }},
                 {"obj_introllscave_bat_"..num.."_touch", { input = 0 }} } );
  
end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_introllscave" ].stage[1];

  if     ( ho_stage == 1 ) then

    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "gauntlet", 1, 0, { { "spr_introllscave_gauntlet" } } );
    ObjSet( "spr_introllscave_gauntlet", { input = 1 } );

  elseif ( ho_stage == 2 ) then

    game.introllscave.double_hint = { { "spr_introllscave_picture",  "spr_introllscave_picture_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "picture", 1, 0, { { "spr_introllscave_picture" } } );

    ObjSet( "spr_introllscave_picture", { input = 1 } );
    
  elseif ( ho_stage == 3 ) then
    
    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "basket", 1, 0, { { "spr_introllscave_basket" } } );
    ObjSet( "spr_introllscave_basket", { input = 1 } );

  elseif ( ho_stage == 4 ) then
    
    game.introllscave.double_hint = { { "spr_introllscave_lute",  "spr_introllscave_lute_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "lute", 1, 0, { { "spr_introllscave_lute" } } );

    ObjSet( "spr_introllscave_lute", { input = 1 } );
    
  elseif ( ho_stage == 5 ) then
    
    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "sack", 1, 0, { { "spr_introllscave_sack" } } );
    ObjSet( "spr_introllscave_sack", { input = 1 } );

  elseif ( ho_stage == 6 ) then
    
    game.introllscave.double_hint = { { "spr_introllscave_cauldron",  "spr_introllscave_cauldron_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "cauldron", 1, 0, { { "spr_introllscave_cauldron" } } );

    ObjSet( "spr_introllscave_cauldron", { input = 1 } );
    
  elseif ( ho_stage == 7 ) then
    
    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "sword", 1, 0, { { "spr_introllscave_sword" } } );
    ObjSet( "spr_introllscave_sword", { input = 1 } );

  elseif ( ho_stage == 8 ) then
    
    game.introllscave.double_hint = { { "spr_introllscave_clock",  "spr_introllscave_clock_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "clock", 1, 0, { { "spr_introllscave_clock" } } );

    ObjSet( "spr_introllscave_clock", { input = 1 } );
    
  elseif ( ho_stage == 9 ) then
    
    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "saddle", 1, 0, { { "spr_introllscave_saddle" } } );
    ObjSet( "spr_introllscave_saddle", { input = 1 } );

  elseif ( ho_stage == 10 ) then
    
    game.introllscave.double_hint = { { "spr_introllscave_boots",  "spr_introllscave_boots_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "boots", 1, 0, { { "spr_introllscave_boots" } } );

    ObjSet( "spr_introllscave_boots", { input = 1 } );
    
  elseif ( ho_stage == 11 ) then
    
    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "bell", 1, 0, { { "spr_introllscave_bell" } } );
    ObjSet( "spr_introllscave_bell", { input = 1 } );

  elseif ( ho_stage == 12 ) then
    
    game.introllscave.double_hint = { { "spr_introllscave_helmet",  "spr_introllscave_helmet_task_img" } };

    interface.TaskPanelTaskAdd( ho_tasks, "helmet", 1, 0, { { "spr_introllscave_helmet" } } );

    ObjSet( "spr_introllscave_helmet", { input = 1 } );
    
  elseif ( ho_stage == 13 ) then
    
    game.introllscave.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "bucket", 1, 0, { { "spr_introllscave_bucket" } } );
    
  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function public.stage_2()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
end;
------------------------------------------------------------------------------
function public.stage_3()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_4()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_5()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_6()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_7()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_8()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_9()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_10()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_11()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_12()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_13()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  local func_after = function ()
  
    ObjMultiSet( { {"obj_introllscave_bucket_whole", { alp = 1, input = 1 }},
                   {"spr_introllscave_bucket", { input = 1 }},
                   {"obj_introllscave_lock", { input = 0 }},
                   {"obj_introllscave_bucket_parts_2", { alp = 0 }} } );
  
  end;
  
  ObjSet("obj_introllscave_lock",  { input = 1 });
  
  --cmn.PlayAudio("snd", "assets/levels/level4/ho_introllscave/audio/");
  
  ObjAnimate("obj_introllscave_bucket_whole", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("obj_introllscave_bucket_parts_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_itm = private.start_items;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do

    if not ObjGet( ho_itm[i].name ) then

      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );

    end;

  end;
  
end;
--********************************************************************************************************************