-- name=ho_lvl4memories
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_lvl4memories" );
  game.relations[ "ho_lvl4memories" ].exitroom = "rm_ingingerbreadhouse";
  public.change_stage_anim_type = "alp";
  
  private.cur_progress = "ext";
  --------------------------------------------------------------------------------------------
  private.room_objname = "ho_lvl4memories";
  --------------------------------------------------------------------------------------------
  private.exeptions = { {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 1} };
  private.skip_in_progress = false;
  --------------------------------------------------------------------------------------------
  -- function opn_lvl4memories () end;
  --------------------------------------------------------------------------------------------
  local opn_lvl4memories = function ()
  
    ObjDelete("anm_lvl4memories_start_mg");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_lvl4memories", opn_lvl4memories, "ho_lvl4memories" );
  
  --------------------------------------------------------------------------------------------
  -- function win_lvl4memories () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_lvl4memories" ] = {
    type = "win",
    room = "rm_ingingerbreadhouse",
    zz = "ho_lvl4memories",
    zz_gate = "gho_ingingerbreadhouse_lvl4memories"
  };
  --------------------------------------------------------------------------------------------
  local win_lvl4memories_func = function ()

    if cmn.IsEventDone( "win_lvl4memories" ) then
      
      ObjDelete("obj_lvl4memories_stage_1");
      ObjDelete("obj_lvl4memories_stage_2");
      ObjDelete("obj_lvl4memories_stage_2_2");
      level4.in_progress = false;
      
    end;

  end;
  --------------------------------------------------------------------------------------------------
  local start_lvl4memories_func = function ()

    if ( cmn.IsEventStart( "win_lvl4memories" ) ) then

      common_impl.ProcessHoStart( "lvl4memories" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_lvl4memories", start_lvl4memories_func, "ho_lvl4memories" );
  cmn.AddSubscriber( "win_lvl4memories", win_lvl4memories_func, "ho_lvl4memories" );
  
  --for secretroom
  private.tasks =  {    
  
      { "symbol_1",   1, 0, { { "spr_lvl4memories_stage_1_symbol_1" } } },
      { "symbol_2",   1, 0, { { "spr_lvl4memories_stage_1_symbol_2" } } },
      { "symbol_3",   1, 0, { { "spr_lvl4memories_stage_1_symbol_3" } } },
      { "symbol_4",   1, 0, { { "spr_lvl4memories_stage_1_symbol_4" } } },
      
      { "symbol_5",   1, 0, { { "spr_lvl4memories_stage_1_symbol_5" } } },
      { "symbol_6",   1, 0, { { "spr_lvl4memories_stage_1_symbol_6" } } },
      { "symbol_7",   1, 0, { { "spr_lvl4memories_stage_1_symbol_7" } } },
      { "symbol_8",   1, 0, { { "spr_lvl4memories_stage_1_symbol_8" } } },
      
      { "symbol_9",   1, 0, { { "spr_lvl4memories_stage_2_symbol_1" } } },
      { "symbol_10",  1, 0, { { "spr_lvl4memories_stage_2_symbol_2" } } },
      { "symbol_11",  1, 0, { { "spr_lvl4memories_stage_2_symbol_3" } } },
      { "symbol_12",  1, 0, { { "spr_lvl4memories_stage_2_symbol_4" } } },
      
      { "symbol_13",  1, 0, { { "spr_lvl4memories_stage_2_symbol_5" } } },
      { "symbol_14",  1, 0, { { "spr_lvl4memories_stage_2_symbol_6" } } },
      { "symbol_15",  1, 0, { { "spr_lvl4memories_stage_2_symbol_7" } } },
      { "symbol_16",  1, 0, { { "spr_lvl4memories_stage_2_symbol_8" } } }
      
  };
    
  private.actions = { 
    { "opn_lvl4memories", { "anm_lvl4memories_start_mg" } }
  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
    
  private.start = {};
  
  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "ext" and not ( ng_global.progress[ "ext" ][ "win_lvl4memories" ].stage ) then
    ng_global.progress[ "ext" ][ "win_lvl4memories" ].stage = { 1, 16 };   --[1] - номер стадии, [2] - количество стадий
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage = { 1, 16 };
  end;

end;
--*********************************************************************************************************************
function public.Open() 
  
  if not cmn.IsEventDone("opn_lvl4memories") then
    cmn.SetEventDone("opn_lvl4memories");
    private.ActivateGame();
  else 
    
    local end_func = function ()
    
      ObjSet("obj_lvl4memories_lock",  { input = 0 });
    
      --убираем видимость таск панели и перемещаем ее
      if ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1] < 9 then
        ObjSet("int_taskpanel_impl",  { pos_x = 520, pos_y = 470 });
      else 
        ObjSet("int_taskpanel_impl",  { pos_x = 520, pos_y = 70 });
      end;
      
    end;
    
    ObjMultiSet( { {"tmr_lvl4memories_timer", { time = 1, playing = 1, endtrig = end_func }},
                   {"obj_lvl4memories_lock", { input = 1 }} } );
    
  end;
  
  if ng_global.currentprogress == "ext" and cmn.IsEventDone("win_lvl4memories") then
    
    local func_after = function()
      
      cmn.GotoRoom( "rm_credits", 0, true );
      
    end;
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level4/ho_lvl4memories/vid_lvl4outro",
                             func_after,
                             "assets/levels/level4/ho_lvl4memories/audio/aud_lvl4_outro",
                             "assets/levels/level4/ho_lvl4memories/audio/aud_lvl4_outro_voc" );
                             
  elseif ng_global.currentprogress == "ext" and ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1] > ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[2] then
                             
    public.win();
                             
  else 
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_ingingerbreadhouse_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_ingingerbreadhouse_env");
  	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  --убираем видимость таск панели и перемещаем ее
  if ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1] < 9 then
    ObjSet("int_taskpanel_impl",  { alp = 0, input = 0 });
  else 
    ObjSet("int_taskpanel_impl",  { alp = 0, input = 0 });
  end;

  if ng_global.currentprogress == "ext" then
    
    common.SetPreviousRoom( "rm_ingingerbreadhouse" );
  
    if cmn.IsEventDone("opn_lvl4memories") and not(cmn.IsEventDone( "win_lvl4memories" )) then
      cmn.StartTimePassing("ho_lvl4memories");
    end;
    
  else 
    
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage = { 1, 16 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    for i = 1, 2, 1 do
      for j = 1, 8, 1 do
        ObjMultiSet( { {"anm_lvl4memories_stage_"..i.."_win_"..j,  { alp = 0 }},
                       {"spr_lvl4memories_stage_"..i.."_task_"..j, { alp = 0 }} } );
      end;
    end;
                   
    for i = 1, 4, 1 do
      ObjMultiSet( { {"spr_lvl4memories_stage_2_clue_"..i, { scale_x = 0, scale_y = 0 }},
                     {"spr_lvl4memories_stage_2_clue_"..i.."_1", { alp = 0 }} } );
    end;
 
    ObjMultiSet( { {"obj_lvl4memories_stage_2", { alp = 0, input = 0 }},
                   {"obj_lvl4memories_stage_2_2", { alp = 0, input = 0 }},
                   {"obj_lvl4memories_stage_1", { alp = 0, input = 0 }},
                   {"anm_lvl4memories_stage_2_clouds", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_2_crystals", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_2_bat", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_2_greed", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_2_man", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_2_bear", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_2_heart", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_1_objects", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_1_clouds", { playing = 0, frame = 0 }},
                   {"anm_lvl4memories_stage_1_crystals", { playing = 0, frame = 0 }},
                   {"grm_lvl4memories_ingingerbreadhouse", { input = 1 }},
                   {"anm_lvl4memories_game_win_1", { alp = 0, playing = 0, frame = 0 }},
                   {"anm_lvl4memories_game_win_2", { alp = 0, playing = 0, frame = 0 }},
                   {"obj_lvl4memories_stage_2_clues", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lvl4memories_ingingerbreadhouse_focus");
    end;
  end;
  
  if not cmn.IsEventStart( "win_lvl4memories" ) then
    cmn.InitHo( "lvl4memories" );
  end;
  
  if cmn.IsEventDone("opn_lvl4memories") then
    private.DrawScene();
  else 
    cmn.Lock( 1, { room = 1 } );
  end;
  
  local ho_tasks = private.stages_task();
  
  if (not cmn.IsEventDone("win_lvl4memories"))
  and ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  elseif cmn.IsEventDone("win_lvl4memories") then
  
    ObjSet("ho_lvl4memories",  { color_r = 0, color_g = 0, color_b = 0 });

    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );

    ng_global.progress[ "ext" ].common.gamewin = true;
    
  elseif ng_global.currentprogress == "ext" and ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1] > ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[2] then
    cmn.Lock( 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  --восстанавливаем видимость таск панели и перемещаем ее обратно
  ObjStopAnimate("int_taskpanel_impl", "pos_y");
  ObjSet("int_taskpanel_impl",  { alp = 1, input = 1, pos_x = 512, pos_y = 830 });
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_lvl4memories_ingingerbreadhouse",  { input = 0 });
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_lvl4memories_ingingerbreadhouse_focus");
    end;
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_lvl4memories");

    if ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_lvl4memories" ] then

      ng_global.nohintho[ "win_lvl4memories" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_lvl4memories" ] then
      ng_global.playedhops[ "win_lvl4memories" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_lvl4memories_ingingerbreadhouse",  { input = 0 });
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_lvl4memories_ingingerbreadhouse_focus");
    end;
  end;
  
end;
--*********************************************************************************************************************
function public.win()
  
  --ObjSet("obj_lvl4memories_lock",  { input = 1 });
      
  cmn.Lock( 1, { room = 1 } );
  common_impl.PauseAchiev( 1 );
  
  local win_func = function ()
    
    cmn.SetEventDone( "win_lvl4memories" );
    
    --ObjSet("obj_lvl4memories_lock",  { input = 0 });
    cmn.Lock( 0 );
    
    if ng_global.currentprogress == "ext" then
      cmn.CallEventHandler( "win_lvl4memories" );
      private.PlayOutro();
    else 
      int_dialog_secretroom.ShowAnim();
    end;
    
  end;
  
  local anm_win_3 = function ()
    
    ObjMultiSet( { {"anm_lvl4memories_game_win_1", { alp = 0 }},
                   {"anm_lvl4memories_game_win_2", { alp = 1, playing = 1, endtrig = win_func }} } );
    
  end;
  
  local anm_win_2 = function ()
    
    ObjAnimate("obj_lvl4memories_stage_2_clues", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    
    ObjMultiSet( { {"obj_lvl4memories_stage_2", { alp = 0 }},
                   {"anm_lvl4memories_game_win_1", { alp = 1, playing = 1, endtrig = anm_win_3 }} } );
    
  end;
                 
  local anm_win_1 = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/ho_lvl4memories/audio/aud_ho_final_animation");
                 
    for i = 1, 4, 1 do
      
      ObjAnimate("spr_lvl4memories_stage_2_clue_"..i, "scale_xy", 0, 0, "", { 0, 0, 0, 0,   0.5, 0, 1, 1, });
      ObjAnimate("spr_lvl4memories_stage_2_clue_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 0,   1.5, 0, 1 });
      
    end;
    
    ObjAnimate("obj_lvl4memories_stage_2_2", "alp", 0, 0, anm_win_2, { 0, 0, 1,   1.5, 0, 1,   2, 0, 0 });
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
  
  ObjAnimate("spr_lvl4memories_stage_2_task_8", "alp", 0, 0, anm_win_1, { 0, 0, 1,   0.5, 0, 0 });
  ObjSet("anm_lvl4memories_stage_2_win_8",  { alp = 1, playing = 1 });
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.ActivateGame()
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    if ng_global.currentprogress == "ext" then
      cmn.StartTimePassing("ho_lvl4memories");
    end;
    
    ObjMultiSet( { {"spr_lvl4memories_stage_1_task_1", { alp = 1 }},
                   {"spr_lvl4memories_stage_1_symbol_1", { input = 1 }},
                   {"int_taskpanel_impl",  { pos_x = 520, pos_y = 470 }},
                   {"obj_lvl4memories_lock",  { input = 0 }} } );
    
  end;
  
  local symbol_show = function ()
    
    cmn.CallEventHandler("opn_lvl4memories");
    
    ObjMultiSet( { {"obj_lvl4memories_stage_1", { alp = 1, input = 1 }},
                   {"anm_lvl4memories_stage_1_objects", { playing = 1 }},
                   {"anm_lvl4memories_stage_1_clouds", { playing = 1 }},
                   {"anm_lvl4memories_stage_1_crystals", { playing = 1 }} } );
    
    ObjAnimate("spr_lvl4memories_stage_1_task_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local voice_2 = function ()
    
    cmn.ShowDlgBbt( "lvl4memories_voice_2" );
    
  end;
  
  cmn.ShowDlgBbt( "lvl4memories_voice_1" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/ho_lvl4memories/audio/aud_opn_final_ho");
  
  ObjAnimate("spr_lvl4memories_ball", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

  ObjMultiSet( { {"anm_lvl4memories_start_mg",  { alp = 1, playing = 1, endtrig = symbol_show }},
                 {"tmr_lvl4memories_timer",  { time = 2, playing = 1, endtrig = voice_2 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1];
  
  local s_stage = 1;
  local item = ho_stage;
  
  if ho_stage > 8 then
    s_stage = 2;
    item = ho_stage - 8;
  end;

  if s_stage == 1 then
    
    ObjMultiSet( { {"obj_lvl4memories_stage_1", { alp = 1, input = 1 }},
                   {"anm_lvl4memories_stage_1_objects", { playing = 1 }},
                   {"anm_lvl4memories_stage_1_clouds", { playing = 1 }},
                   {"anm_lvl4memories_stage_1_crystals", { playing = 1 }} } );
    
  else 
                   
    ObjMultiSet( { {"obj_lvl4memories_stage_2", { alp = 1, input = 1 }},
                   {"obj_lvl4memories_stage_2_2", { alp = 1, input = 1 }},
                   {"anm_lvl4memories_stage_2_clouds", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_crystals", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_bat", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_greed", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_man", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_bear", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_heart", { playing = 1 }} } );
    
  end;
                 
  for i = 1, item-1, 1 do
    ObjMultiSet( { {"anm_lvl4memories_stage_"..s_stage.."_win_"..i,  { alp = 1, frame = 200 }},
                   {"spr_lvl4memories_stage_"..s_stage.."_symbol_"..i, { alp = 0 }} } );
  end;
  for i = item, 8, 1 do
    ObjMultiSet( { {"anm_lvl4memories_stage_"..s_stage.."_win_"..i,  { alp = 1, frame = 0 }},
                   {"spr_lvl4memories_stage_"..s_stage.."_symbol_"..i, { alp = 1 }} } );
  end;
                 
  if item < 9 then
                 
    ObjMultiSet( { {"spr_lvl4memories_stage_"..s_stage.."_symbol_"..item, { input = 1 }},
                   {"spr_lvl4memories_stage_"..s_stage.."_task_"..item, { alp = 1 }} } );
                   
  else 
    ObjSet("spr_lvl4memories_stage_"..s_stage.."_task_8",  { alp = 1 });               
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FoundSymbol( num )
  
  ObjSet("obj_lvl4memories_lock",  { input = 1 });
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1];
  
  local s_stage = 1;
  
  if ho_stage > 8 then
    s_stage = 2;
  end;
  
  local item_name = "spr_lvl4memories_stage_"..s_stage.."_symbol_"..num;
  local pos = GetObjPosByObj(item_name);
  
  if private.exeptions[ s_stage ][ num ] == 0 then
    ObjSet( item_name, { input = false, pos_x = pos[1]+171, pos_y = pos[2] } );
  else 
    ObjSet( item_name, { input = false } );
  end;
  
  cmn.HoTaskFind(item_name, "symbol"..ho_stage);
  
end;
-----------------------------------------------------------------------------------
function private.PlayOutro()
  
  local func_after = function ()

    ObjSet("ho_lvl4memories",  { color_r = 0, color_g = 0, color_b = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_TaskPanel, false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_TaskPanel, false, false );

    ng_global.progress[ "ext" ].common.gamewin = true;
    cmn.GotoRoom( "rm_credits", 0, true );
    
  end;
  
  ObjSet("obj_lvl4memories_game",  { input = 0 });
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level4/ho_lvl4memories/vid_lvl4outro", func_after, "assets/levels/level4/ho_lvl4memories/audio/aud_lvl4_outro", "assets/levels/level4/ho_lvl4memories/audio/aud_lvl4_outro_voc");
  
end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()
  
  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1];
  
  local s_stage = 1;
  local item = ho_stage;
  
  if ho_stage > 8 then
    s_stage = 2;
    item = ho_stage - 8;
  end;
  
  interface.TaskPanelTaskAdd( ho_tasks, "symbol"..ho_stage, 1, 0, { { "spr_lvl4memories_stage_"..s_stage.."_symbol_"..item } } );

  return ho_tasks;

end;
------------------------------------------------------------------------------
function private.anim_new_tasks()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_lvl4memories" ].stage[1];
  
  local stage = 1;
  local item = ho_stage;
  
  if ho_stage > 8 then
    stage = 2;
    item = ho_stage - 8;
  end;
  
  local func_after = function ()
      
    ObjMultiSet( { {"spr_lvl4memories_stage_"..stage.."_symbol_"..item,  { input = 1 }},
                   {"obj_lvl4memories_lock", { input = 0 }} } );
    
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
                 
  ObjAnimate("spr_lvl4memories_stage_"..stage.."_task_"..(item-1), "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_lvl4memories_stage_"..stage.."_task_"..item, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
  ObjSet("anm_lvl4memories_stage_"..stage.."_win_"..(item-1),  { alp = 1, playing = 1 });
  
end;
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function public.stage_2()
  
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_3()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_4()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_5()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_6()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_7()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_8()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_9()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
    
  ObjSet("obj_lvl4memories_lock",  { input = 1 });
  cmn.ShowDlgBbt( "lvl4memories_voice_3" );
  
  local func_after = function ()
    
    ObjMultiSet( { {"spr_lvl4memories_stage_2_task_1", { alp = 1 }},
                   {"spr_lvl4memories_stage_2_symbol_1", { input = 1 }},
                   {"obj_lvl4memories_lock", { input = 0 }},
                   {"int_taskpanel_impl",  { pos_x = 520, pos_y = 70 }} } );
    
  end;
  
  local symbol_show = function ()
    
    ObjMultiSet( { {"obj_lvl4memories_stage_2", { alp = 1, input = 1 }},
                   {"obj_lvl4memories_stage_2_2", { alp = 1, input = 1 }},
                   {"anm_lvl4memories_stage_2_clouds", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_crystals", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_bat", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_greed", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_man", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_bear", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_heart", { playing = 1 }},
                   {"anm_lvl4memories_stage_2_start", { alp = 0 }},
                   {"anm_lvl4memories_change_stage", { alp = 0 }} } );
    
    ObjAnimate("spr_lvl4memories_stage_2_task_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local change_stage_2 = function ()
    
    cmn.ShowDlgBbt( "lvl4memories_voice_4" );
    
    ObjSet("anm_lvl4memories_stage_2_start",  { alp = 1, playing = 1, endtrig = symbol_show });
    
  end;
  
  local change_stage_1 = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/ho_lvl4memories/audio/aud_ho_red");
  
    ObjMultiSet( { {"obj_lvl4memories_stage_1", { alp = 0, input = 0 }},
                   {"anm_lvl4memories_change_stage", { alp = 1, playing = 1, endtrig = change_stage_2 }} } );
                   
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");               
  
  ObjAnimate("spr_lvl4memories_stage_1_task_8", "alp", 0, 0, change_stage_1, { 0, 0, 1,   0.5, 0, 0 });
  ObjSet("anm_lvl4memories_stage_1_win_8",  { alp = 1, playing = 1 });
  
end;
------------------------------------------------------------------------------
function public.stage_10()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_11()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_12()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_13()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_14()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_15()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
function public.stage_16()
    
  private.anim_new_tasks();
  
end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          if typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;
  
  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;
  
end;
--*************************************************************************************************************