-- name=ho_pumpkins
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_pumpkins" );
  game.relations[ "ho_pumpkins" ].exitroom = "rm_nearnurseshouse";
  
  public.items = {"spr_pumpkins_bat", "spr_pumpkins_candle", "spr_pumpkins_cat", "spr_pumpkins_cake", "spr_pumpkins_ghost", "spr_pumpkins_spider", "spr_pumpkins_trident"};
  private.items_sh = { {0, 0, 0}, {1, 0, 1}, {1, 0, 1}, {0, 0, 0}, {0, 0, 0}, {0, 1, 0}, {1, 0, 0} };
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_pumpkins" ] = 
  {
    type = "win",
    room = "rm_nearnurseshouse",
    zz = "ho_pumpkins",
    zz_gate = "gho_nearnurseshouse_pumpkins"
  };
  --------------------------------------------------------------------------------------------------
  local win_pumpkins_func = function ()

    if ( cmn.IsEventDone( "win_pumpkins" ) ) then
      
      interface.InventoryItemAdd( "inv_shellpart", "spr_pumpkins_win", function () cmn.GetMultyObject( 'shellpart', 3 ); end );
        
      if cmn.IsEventDone("get_shellpart1") and cmn.IsEventDone("get_shellpart2") then
        ObjSet("inv_keyholder_star_light",  { alp = 1 });
      end;
      
      ObjDelete("gho_nearnurseshouse_pumpkins");
      ObjDelete("spr_nearnurseshouse_pumpkins_obj");
      
    end;

  end;
  cmn.AddSubscriber( "win_pumpkins", win_pumpkins_func );
  --------------------------------------------------------------------------------------------------
  local start_pumpkins_func = function ()

    if ( cmn.IsEventStart( "win_pumpkins" ) ) then

      --common_impl.ProcessHoStart( "pumpkins" );

    end;

  end;
  cmn.AddSubscriber( "win_pumpkins", start_pumpkins_func, "ho_pumpkins" );
  
  --for secretroom
  private.tasks =  {    
    { "bat", 3, 0, { {"spr_pumpkins_bat_1"}, {"spr_pumpkins_bat_2"}, {"spr_pumpkins_bat_3"} } },
    { "candle", 3, 0, { {"spr_pumpkins_candle_1"}, {"spr_pumpkins_candle_2"}, {"spr_pumpkins_candle_3"} } },
    { "cat", 3, 0, { {"spr_pumpkins_cat_1"}, {"spr_pumpkins_cat_2"}, {"spr_pumpkins_cat_3"} } },
    { "cake", 3, 0, { {"spr_pumpkins_cake_1"}, {"spr_pumpkins_cake_2"}, {"spr_pumpkins_cake_3"} } },

    { "ghost", 3, 0, { {"spr_pumpkins_ghost_1"}, {"spr_pumpkins_ghost_2"}, {"spr_pumpkins_ghost_3"} } },
    { "spider", 3, 0, { {"spr_pumpkins_spider_1"}, {"spr_pumpkins_spider_2"}, {"spr_pumpkins_spider_3"} } },
    { "trident", 3, 0, { {"spr_pumpkins_trident_1"}, {"spr_pumpkins_trident_2"}, {"spr_pumpkins_trident_3"} } },
  };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";
  
  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ j ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
      if private.items_sh[i][j] == 1 then
        table.insert( private.start_sh, {} );
        private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ j ][ 1 ].."_sh";
        nme = private.start_sh[ #private.start_sh ].name;
        private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
        private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      end;

    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "ext" and not(ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].item_parts) then

    ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].item_parts = { {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3} }; --[1] - found parts, [2] - all parts
    ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].state = { {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0} };

  elseif ng_global.currentprogress == "secret" then
    
    ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].item_parts = { {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3} }; --[1] - found parts, [2] - all parts
    ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].state = { {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0} };
    
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  	if port.isPortable() == 1 then
		iOS_EnableMultiTouch(1); 
	end;
  if ng_global.currentprogress == "ext" then
  
    common.SetPreviousRoom( "rm_nearnurseshouse" );
    cmn.StartTimePassing("ho_pumpkins");
    
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].item_parts = { {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3}, {0, 3} }; --[1] - found parts, [2] - all parts
    ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].state = { {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0} };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    private.CreateNewObjects();
    
    ObjSet("grm_pumpkins_nearnurseshouse",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                              event_menter = function () rm_extra.GateMouseEnter( "pumpkins_nearnurseshouse", CURSOR_DOWN, "extra" ); end, 
                                              event_mleave = function () common_impl.GateMouseLeave( "pumpkins_nearnurseshouse" ); end });
    
  end;

  if not cmn.IsEventStart( "win_pumpkins" ) then
    cmn.InitHo( "pumpkins" );
  end;
  
  private.DrawScene();

  local ho_items = {};

  common_impl.ItemPanelColorItemAdd( ho_items, "bat", 3, 0, { {"spr_pumpkins_bat_1"},
                                                              {"spr_pumpkins_bat_2"},
                                                              {"spr_pumpkins_bat_3"} } );
  common_impl.ItemPanelColorItemAdd( ho_items, "candle", 3, 0, { {"spr_pumpkins_candle_1"},
                                                                 {"spr_pumpkins_candle_2"},
                                                                 {"spr_pumpkins_candle_3"} } );
  common_impl.ItemPanelColorItemAdd( ho_items, "cat", 3, 0, { {"spr_pumpkins_cat_1"},
                                                              {"spr_pumpkins_cat_2"},
                                                              {"spr_pumpkins_cat_3"} } );
  common_impl.ItemPanelColorItemAdd( ho_items, "cake", 3, 0, { {"spr_pumpkins_cake_1"},
                                                               {"spr_pumpkins_cake_2"},
                                                               {"spr_pumpkins_cake_3"} } );
  common_impl.ItemPanelColorItemAdd( ho_items, "ghost", 3, 0, { {"spr_pumpkins_ghost_1"},
                                                                {"spr_pumpkins_ghost_2"},
                                                                {"spr_pumpkins_ghost_3"} } );
  common_impl.ItemPanelColorItemAdd( ho_items, "spider", 3, 0, { {"spr_pumpkins_spider_1"},
                                                                 {"spr_pumpkins_spider_2"},
                                                                 {"spr_pumpkins_spider_3"} } );
  common_impl.ItemPanelColorItemAdd( ho_items, "trident", 3, 0, { {"spr_pumpkins_trident_1"},
                                                                  {"spr_pumpkins_trident_2"},
                                                                  {"spr_pumpkins_trident_3"} } );

  if (not cmn.IsEventDone("win_pumpkins")) then
  
    interface_impl.ItemPanelShow( ho_items );
    common_impl.HoItemCountColor();
  
  else
    
    if not cmn.IsEventDone("get_shellpart3") then
      cmn.SetEventDone("get_shellpart3");
    end;
    
    common_impl.DialogHo_Show();
    
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
    if cmn.IsEventDone("win_pumpkins") and not cmn.IsEventDone("get_shellpart3") then
      cmn.SetEventDone("get_shellpart3");
    end;  
    
  else 
    
    ObjSet("grm_pumpkins_nearnurseshouse",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_pumpkins");
    cmn.SetEventDone("get_shellpart3");

    if ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_pumpkins" ] then

      ng_global.nohintho[ "win_pumpkins" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    ObjAnimate("spr_pumpkins_pumpkin_cover", "pos_xy", 0, 0, "", { 0, 0, 554, 448,   0.4, 0, 571, 392,   0.8, 0, 671, 611 });
    ObjAnimate("spr_pumpkins_pumpkin_cover", "ang", 0, 0, "", { 0, 0, 0,   0.4, 0, 0,   0.8, 0, 0.33 });
    
  else 

    ObjSet("grm_pumpkins_nearnurseshouse",  { input = 0 });

  end;
  
  if ng_global.playedhops and not ng_global.playedhops[ "win_pumpkins" ] then
    ng_global.playedhops[ "win_pumpkins" ] = 1;
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_num, num2 )
  
  ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].state[item_num][num2] = 1;

  if private.items_sh[item_num][num2] == 1 then
    ObjDelete( public.items[item_num].."_"..num2.."_sh" );
  end;

  ObjSet(public.items[item_num].."_"..num2,  { input = 0 });
  
  if ( item_num == 1 and num2 == 3 ) or ( item_num == 5 and num2 == 2 ) then
    local pos = GetObjPosByObj( public.items[item_num].."_"..num2 );
    ObjSet( public.items[item_num].."_"..num2, { pos_x = pos[1] + 171, pos_y = pos[2] } );
  end;

  cmn.HoItemFind(item_num, 1, false, num2);

end;
--*********************************************************************************************************************
function private.DrawScene()

  local ho_items = ng_global.progress[ ng_global.currentprogress ][ "win_pumpkins" ].state;

  for i = 1, #ho_items, 1 do
    for j = 1, 3, 1 do

      if (ho_items[i][j] == 1) then
        
        ObjDelete( public.items[i].."_"..j );
        
        if private.items_sh[i][j] == 1 then
          ObjDelete( public.items[i].."_"..j.."_sh" );
        end;
        
      end;

    end;
  end;

end;
--*********************************************************************************************************************
function private.CreateNewObjects()
  
  local ho_obj = private.start;
  local ho_obj_sh = private.start_sh;
  local ho_itm = private.start_items;

  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then

      ObjCreate( ho_obj[i].name, "spr" );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );
      
    else 

      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );
      
    end;

  end;
  
  for i = 1, #ho_obj_sh, 1 do

    if not ObjGet( ho_obj_sh[i].name ) then

      ObjCreate( ho_obj_sh[i].name, "spr" );
      ObjSet( ho_obj_sh[i].name, ho_obj_sh[i].prop );
      ObjAttach( ho_obj_sh[i].name, ho_obj_sh[i].parent );

    else 

      ObjSet( ho_obj_sh[i].name, ho_obj_sh[i].prop );
      ObjAttach( ho_obj_sh[i].name, ho_obj_sh[i].parent );

    end;

  end;

  for i = 1, #ho_itm, 1 do

    if not ObjGet( ho_itm[i].name ) then

      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );

    end;

  end;

end;
--*********************************************************************************************************************
