-- name=mg_boxdoors
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_boxdoors";
  private.cur_progress = "ext";
  --------------------------------------------------------------------------------------------
  private.stones_pos = { 
    {-303, 0}, {-242, 0}, {-181, 0}, {-120, 0}, {120, 0}, {181, 0}, {242, 0}, {303, 0}
  };
  
  private.stones_start = {
    { {1, 3}, {2, 1}, {4, 2}, {2, 8}, {1, 4}, {3, 3}, {3, 8}, {4, 6} },
    { {2, 4}, {1, 2}, {2, 6}, {3, 1}, {4, 8}, {3, 5}, {1, 6}, {4, 5} },
    { {4, 7}, {3, 4}, {3, 6}, {1, 1}, {2, 2}, {2, 3}, {4, 1}, {2, 7} },
    { {3, 7}, {1, 7}, {2, 5}, {3, 2}, {1, 8}, {4, 3}, {1, 5}, {4, 4} }
  };
  private.ang_start = {-0.08, 0.08, -0.08, 0.08};
  
  private.stones_weight = { 1, 2, 3, 2, 1, 2, 3, 2 };
  private.stone_chosen = {0, 0};
  
  private.scales_centers = { {489, 95}, {489, 254}, {489, 416}, {489, 579} };
  --------------------------------------------------------------------------------------------
  -- function get_boxkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_boxkey" ] = {
      type = "get",
      get_obj = "spr_boxdoors_boxkey",
      room = "rm_ward",
      zz = "mg_boxdoors",
      zz_gate = "gmg_ward_boxdoors"
    };
    --------------------------------------------------------------------------------------------
  local get_boxkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxkey", "spr_boxdoors_boxkey" );
  
  end;
  local get_boxkey_end = function ()
  
    ObjDelete( "gfx_boxdoors_boxkey" );
    ObjDelete( "spr_boxdoors_boxkey_sh" );
  
  end;
  local get_boxkey_loc = function ()
    
    ObjDelete("spr_ward_drawers_key");
  
    if cmn.IsEventDone("get_unfinishedsocks") then
      ObjDelete( "gmg_ward_boxdoors" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_boxkey", get_boxkey_inv );
  cmn.AddSubscriber( "get_boxkey", get_boxkey_end, private.room_objname );
  cmn.AddSubscriber( "get_boxkey", get_boxkey_loc, "rm_ward" );
  --------------------------------------------------------------------------------------------
  -- function get_unfinishedsocks () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_unfinishedsocks" ] = {
      type = "get",
      get_obj = "spr_boxdoors_unfinishedsocks",
      room = "rm_ward",
      zz = "mg_boxdoors",
      zz_gate = "gmg_ward_boxdoors"
    };
    --------------------------------------------------------------------------------------------
  local get_unfinishedsocks_inv = function ()
  
    interface.InventoryItemAdd( "inv_unfinishedsocks", "spr_boxdoors_unfinishedsocks" );
  
  end;
  local get_unfinishedsocks_end = function ()
  
    ObjDelete( "gfx_boxdoors_unfinishedsocks" );
    
  end;
  local get_unfinishedsocks_loc = function ()
    
    ObjDelete("spr_ward_drawers_socks");
  
    if cmn.IsEventDone("get_boxkey") then
      ObjDelete( "gmg_ward_boxdoors" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_unfinishedsocks", get_unfinishedsocks_inv );
  cmn.AddSubscriber( "get_unfinishedsocks", get_unfinishedsocks_end, private.room_objname );
  cmn.AddSubscriber( "get_unfinishedsocks", get_unfinishedsocks_loc, "rm_ward" );

  --------------------------------------------------------------------------------------------
  -- function win_boxdoors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_boxdoors" ] = {
    type = "win",
    room = "rm_ward",
    zz = "mg_boxdoors",
    zz_gate = "gmg_ward_boxdoors"
  };
  --------------------------------------------------------------------------------------------
  local win_boxdoors = function ()

    if cmn.IsEventDone( "win_boxdoors" ) then
      ObjMultiSet( { {"obj_boxdoors_game", { input = 0 }},
                     {"obj_boxdoors_open_drawer", { alp = 1, input = 1 }} } );
    end;

  end;
  local win_boxdoors_loc = function ()

    if cmn.IsEventDone( "win_boxdoors" ) then
      ObjSet("spr_ward_drawers_open",  { alp = 1 });
      ObjDelete("spr_ward_drawers_closed");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_boxdoors", win_boxdoors, "mg_boxdoors" );
  cmn.AddSubscriber( "win_boxdoors", win_boxdoors_loc, "rm_ward" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_boxdoors" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_boxdoors");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_mermaidsward_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_mermaidsward_env");

  if ng_global.currentprogress == "ext" then
    private.cur_progress = "ext";
    common.SetPreviousRoom( "rm_ward" );
  else 
    
    private.cur_progress = "secret";
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state;
    
    ObjSet("grm_boxdoors_ward",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                   event_menter = function () rm_extra.GateMouseEnter( "boxdoors_ward", CURSOR_DOWN, "extra" ); end, 
                                   event_mleave = function () common_impl.GateMouseLeave( "boxdoors_ward" ); end });
    
  end;
  
  private.DrawScene();
  
end;
--*********************************************************************************************************************
function public.Close()
  
  if private.cur_progress == "secret" and private.stone_chosen[1] ~= 0 then
    
    for i = 1, #private.state, 1 do
      for j = 1, #private.state[i], 1 do
        
        ObjSet("spr_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2],  { input = 1 });
        
      end;
    end;
    
    local connect = {};
    local ind = private.FindIndex( private.stone_chosen[1], private.stone_chosen[2] );
    
    if ind[1] > 1 then
      table.insert( connect, private.state[ ind[1]-1 ][ ind[2] ] );
    end;
    if ind[1] < 4 then
      table.insert( connect, private.state[ ind[1]+1 ][ ind[2] ] );
    end;
    if ind[2] > 1 then
      table.insert( connect, private.state[ ind[1] ][ ind[2]-1 ] );
    end;
    if ind[2] < 8 then
      table.insert( connect, private.state[ ind[1] ][ ind[2]+1 ] );
    end;
    
    for i = 1, #connect, 1 do
      ObjSet("spr_boxdoors_stone_"..connect[i][1].."_"..connect[i][2].."_on",  { alp = 0 });
    end;
    
    ObjSet("spr_boxdoors_stone_"..private.stone_chosen[1].."_"..private.stone_chosen[2].."_on",  { alp = 0 });
    
    private.stone_chosen = {0, 0};
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "ext" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_boxdoors" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_boxdoors" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  
  local angles = private.CheckScalesOrient();
  local colors = private.CheckScalesColor();
  
  for i = 1, 4, 1 do
    for j = 1, #private.state[i], 1 do
      
      if private.state[i][j][1] ~= private.stones_start[i][j][1] or private.state[i][j][2] ~= private.stones_start[i][j][2] then
        
        if not need_r then
          need_r = true;
        end;
        
        local ind1 = private.FindIndex( private.state[i][j][1], private.state[i][j][2] );
        local ind2 = private.FindIndex( private.state[i][j][1], private.state[i][j][2], true );
        
        local rad1 = math.abs(private.stones_pos[ ind1[2] ][1]);
        local rad2 = math.abs(private.stones_pos[ ind2[2] ][1]);
        
        local center1 = private.scales_centers[ ind1[1] ];
        local center2 = private.scales_centers[ ind2[1] ];
        
        local angle1 = angles[ ind1[1] ];
        local angle2 = angles[ ind2[1] ];
        
        if ind1[2] > 4 then
          angle1 = 3.14 + angle1;
        end;
        if ind2[2] > 4 then
          angle2 = 3.14 + angle2;
        end;
        
        local point1 = common_impl.math.FindCirclePoint( center1[1], center1[2], rad1, angle1 );
        local point2 = common_impl.math.FindCirclePoint( center2[1], center2[2], rad2, angle2 );
        point1[1] = math.floor( point1[1] );
        point1[2] = math.floor( point1[2] );
        point2[1] = math.floor( point2[1] );
        point2[2] = math.floor( point2[2] );
        
        ObjAttach("obj_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2], "obj_boxdoors_game_fly");
        ObjAnimate("obj_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2], "pos_xy", 0, 0, "", { 0, 0, point1[1], point1[2],   0.4, 0, point2[1], point2[2] });
        
      end;
        
    end;
  end;
  
  local func_after = function ()
    
    local end_func = function ()
      cmn.Lock( 0 );
    end;
    
    private.DrawScene();
    
    for i = 1, 4, 1 do
    
      if colors[i] and angles[i] == 0 then
        ObjAnimate("spr_boxdoors_drawer_"..i.."_handle_win", "alp", 0, 0, "", { 0, 0, 1,   0.4, 0, 0 });
      end;
      if angles[i] ~= private.ang_start[i] then
        ObjAnimate("obj_boxdoors_drawer_"..i, "ang", 0, 0, "", { 0, 0, angles[i],   0.4, 0, private.ang_start[i] });
      end;
      
    end;
    
    ObjSet("tmr_boxdoors_timer",  { time = 0.4, playing = 1, endtrig = end_func });
    
  end;
  
  if private.stone_chosen[1] ~= 0 then
    
    local color = private.stone_chosen[1];
    local num = private.stone_chosen[2];
    private.stone_chosen = {0, 0};
    private.SelectAnim( color, num, 0 );
    
    if not need_r then
      cmn.Lock( 1 );
      ObjSet("tmr_boxdoors_timer",  { time = 0.2, playing = 1, endtrig = func_after });
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state;
    
    ObjSet("tmr_boxdoors_timer",  { time = 0.4, playing = 1, endtrig = func_after });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock( 1 );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state = {
    { {1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8} },
    { {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8} },
    { {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8} },
    { {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8} }
  };
  
  local angles = private.CheckScalesOrient();
  local colors = private.CheckScalesColor();
  
  for i = 1, 4, 1 do
    for j = 1, #private.state[i], 1 do
      
      if private.state[i][j][1] ~= i or private.state[i][j][2] ~= j then
        
        local ind1 = private.FindIndex( private.state[i][j][1], private.state[i][j][2] );
        local ind2 = {};
        ind2[1] = private.state[i][j][1];
        ind2[2] = private.state[i][j][2];
        
        local rad1 = math.abs(private.stones_pos[ ind1[2] ][1]);
        local rad2 = math.abs(private.stones_pos[ ind2[2] ][1]);
        
        local center1 = private.scales_centers[ ind1[1] ];
        local center2 = private.scales_centers[ ind2[1] ];
        
        local angle1 = angles[ ind1[1] ];
        local angle2 = angles[ ind2[1] ];
        
        if ind1[2] > 4 then
          angle1 = 3.14 + angle1;
        end;
        if ind2[2] > 4 then
          angle2 = 3.14 + angle2;
        end;
        
        local point1 = common_impl.math.FindCirclePoint( center1[1], center1[2], rad1, angle1 );
        local point2 = common_impl.math.FindCirclePoint( center2[1], center2[2], rad2, angle2 );
        point1[1] = math.floor( point1[1] );
        point1[2] = math.floor( point1[2] );
        point2[1] = math.floor( point2[1] );
        point2[2] = math.floor( point2[2] );
        
        ObjAttach("obj_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2], "obj_boxdoors_game_fly");
        ObjAnimate("obj_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2], "pos_xy", 0, 0, "", { 0, 0, point1[1], point1[2],   0.4, 0, point2[1], point2[2] });
        
      end;
        
    end;
  end;
  
  if private.stone_chosen[1] ~= 0 then
    
    local color = private.stone_chosen[1];
    local num = private.stone_chosen[2];
    private.stone_chosen = {0, 0};
    private.SelectAnim( color, num, 0 );
    
  end;
  
  local func_after = function ()
    
    private.DrawScene();
    
    for i = 1, 4, 1 do
    
      if not colors[i] or angles[i] ~= 0 then
        ObjAnimate("spr_boxdoors_drawer_"..i.."_handle_win", "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 1 });
      end;
      if angles[i] ~= 0 then
        ObjAnimate("obj_boxdoors_drawer_"..i, "ang", 0, 0, "", { 0, 0, angles[i],   0.4, 0, 0 });
      end;
      
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level4/mg_boxdoors/audio/aud_parts_move");
    
    ObjSet("tmr_boxdoors_timer",  { time = 0.4, playing = 1, endtrig = private.CheckWin });
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state;
    
  ObjSet("tmr_boxdoors_timer",  { time = 0.4, playing = 1, endtrig = func_after });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_boxkey()

  cmn.SetEventDone( "get_boxkey" );
  cmn.CallEventHandler( "get_boxkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_unfinishedsocks") then
    cmn.GotoRoom("rm_ward");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_unfinishedsocks()

  cmn.SetEventDone( "get_unfinishedsocks" );
  cmn.CallEventHandler( "get_unfinishedsocks" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_boxkey") then
    cmn.GotoRoom("rm_ward");
  end;

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].state = {
    { {1, 3}, {2, 1}, {4, 2}, {2, 8}, {1, 4}, {3, 3}, {3, 8}, {4, 6} },
    { {2, 4}, {1, 2}, {2, 6}, {3, 1}, {4, 8}, {3, 5}, {1, 6}, {4, 5} },
    { {4, 7}, {3, 4}, {3, 6}, {1, 1}, {2, 2}, {2, 3}, {4, 1}, {2, 7} },
    { {3, 7}, {1, 7}, {2, 5}, {3, 2}, {1, 8}, {4, 3}, {1, 5}, {4, 4} }
  }; --расположение камней по ящикам

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  local angles = private.CheckScalesOrient();
  local colors = private.CheckScalesColor();
  
  for i = 1, 4, 1 do
    for j = 1, #private.state[i], 1 do
      
      ObjAttach("obj_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2], "obj_boxdoors_drawer_"..i);
      ObjSet("obj_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2],  { pos_x = private.stones_pos[j][1], pos_y = private.stones_pos[j][2] });
      
    end;
  end;
  
  for i = 1, 4, 1 do
    ObjSet("obj_boxdoors_drawer_"..i,  { ang = angles[i] });
    if colors[i] and angles[i] == 0 and not cmn.IsEventDone("win_boxdoors") then
      ObjSet("spr_boxdoors_drawer_"..i.."_handle_win",  { alp = 1 });
    else 
      ObjSet("spr_boxdoors_drawer_"..i.."_handle_win",  { alp = 0 });
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusStone( color, num, inout )
  
  local obj = "spr_boxdoors_stone_"..color.."_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.05;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_HAND);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseStone( color, num )

  if private.stone_chosen[1] ~= 0 then

    --cancel selection
    if private.stone_chosen[1] == color and private.stone_chosen[2] == num then

      private.stone_chosen = {0, 0};
      private.SelectAnim( color, num, 0 );

    --switch items
    else

      local old = {};
      local new = {};
      old[1] = private.stone_chosen[1];
      old[2] = private.stone_chosen[2];
      new[1] = color;
      new[2] = num;
      
      private.stone_chosen = {0, 0};
      
      private.SelectAnim( old[1], old[2], 0 );
      private.SwitchAnim( old, new );

    end;

  --first selected
  else 
  
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_menter");

    private.stone_chosen[1] = color;
    private.stone_chosen[2] = num;
    private.SelectAnim( color, num, 1 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.SwitchAnim( old, new )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
  
  local ind1 = private.FindIndex( old[1], old[2] );
  local ind2 = private.FindIndex( new[1], new[2] );
  
  local rad1 = math.abs(private.stones_pos[ ind1[2] ][1]);
  local rad2 = math.abs(private.stones_pos[ ind2[2] ][1]);
  
  local center1 = private.scales_centers[ ind1[1] ];
  local center2 = private.scales_centers[ ind2[1] ];
  
  local angles = private.CheckScalesOrient();
  local colors = private.CheckScalesColor();
  
  local angle1 = angles[ ind1[1] ];
  local angle2 = angles[ ind2[1] ];
  
  if ind1[2] > 4 then
    angle1 = 3.14 + angle1;
  end;
  if ind2[2] > 4 then
    angle2 = 3.14 + angle2;
  end;
  
  local point1 = common_impl.math.FindCirclePoint( center1[1], center1[2], rad1, angle1 );
  local point2 = common_impl.math.FindCirclePoint( center2[1], center2[2], rad2, angle2 );
  point1[1] = math.floor( point1[1] );
  point1[2] = math.floor( point1[2] );
  point2[1] = math.floor( point2[1] );
  point2[2] = math.floor( point2[2] );
  
  private.state[ ind1[1] ][ ind1[2] ][1] = new[1];
  private.state[ ind1[1] ][ ind1[2] ][2] = new[2];
  private.state[ ind2[1] ][ ind2[2] ][1] = old[1];
  private.state[ ind2[1] ][ ind2[2] ][2] = old[2];
  
  ObjAnimate("spr_boxdoors_stone_"..old[1].."_"..old[2].."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
  ObjAnimate("spr_boxdoors_stone_"..new[1].."_"..new[2].."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
  
  ObjAttach( "obj_boxdoors_stone_"..old[1].."_"..old[2], "obj_boxdoors_game_fly" );
  ObjAttach( "obj_boxdoors_stone_"..new[1].."_"..new[2], "obj_boxdoors_game_fly" );
  
  ObjMultiSet( { {"obj_boxdoors_stone_"..old[1].."_"..old[2], { pos_x = point1[1], pos_y = point1[2] }},
                 {"obj_boxdoors_stone_"..new[1].."_"..new[2], { pos_x = point2[1], pos_y = point2[2] }} } );
                 
  local func_after = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part");
    
    ObjAnimate("spr_boxdoors_stone_"..old[1].."_"..old[2].."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
    ObjAnimate("spr_boxdoors_stone_"..new[1].."_"..new[2].."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
    
    ObjAttach("obj_boxdoors_stone_"..old[1].."_"..old[2], "obj_boxdoors_drawer_"..ind2[1]);
    ObjAttach("obj_boxdoors_stone_"..new[1].."_"..new[2], "obj_boxdoors_drawer_"..ind1[1]);
    
    ObjMultiSet( { {"obj_boxdoors_stone_"..old[1].."_"..old[2], { pos_x = private.stones_pos[ ind2[2] ][1], pos_y = private.stones_pos[ ind2[2] ][2] }},
                   {"obj_boxdoors_stone_"..new[1].."_"..new[2], { pos_x = private.stones_pos[ ind1[2] ][1], pos_y = private.stones_pos[ ind1[2] ][2] }} } );
    
    private.CheckScales( angles, colors );
    
  end;
                 
  ObjAnimate("obj_boxdoors_stone_"..old[1].."_"..old[2], "pos_xy", 0, 0, func_after, { 0, 0, point1[1], point1[2],   0.4, 0, point2[1], point2[2] });
  ObjAnimate("obj_boxdoors_stone_"..new[1].."_"..new[2], "pos_xy", 0, 0, "", { 0, 0, point2[1], point2[2],   0.4, 0, point1[1], point1[2] });
  
end;
-----------------------------------------------------------------------------------
function private.CheckScales( old_angles, old_colors )
  
  local angles = private.CheckScalesOrient();
  local colors = private.CheckScalesColor();
  local flag = false;
  
  for i = 1, 4, 1 do
    
    if angles[i] ~= old_angles[i] then
      
      if not flag then
        flag = true;
      end;
      
      ObjAnimate("obj_boxdoors_drawer_"..i, "ang", 0, 0, "", { 0, 0, old_angles[i],   0.4, 0, angles[i] });
      
    end;
    
  end;
  
  local func_after = function ()
    
    for i = 1, 4, 1 do
      
      if colors[i] and angles[i] == 0 and ( not old_colors[i] or old_angles[i] ~= 0 ) then
        if not flag then
          flag = true;
        end;
        ObjAnimate("spr_boxdoors_drawer_"..i.."_handle_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      elseif ( old_colors[i] and old_angles[i] == 0 ) and ( not colors[i] or angles[i] ~= 0 ) then
        if not flag then
          flag = true;
        end;
        ObjAnimate("spr_boxdoors_drawer_"..i.."_handle_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
    if flag then
      ObjSet("tmr_boxdoors_timer",  { time = 0.3, playing = 1, endtrig = private.CheckWin });
    else 
      private.CheckWin();
    end;
    
  end;
  
  if flag then
    cmn.PlayAudio("snd", "assets/levels/level4/mg_boxdoors/audio/aud_parts_move");
    ObjSet("tmr_boxdoors_timer",  { time = 0.4, playing = 1, endtrig = func_after });
  else 
    func_after();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.SelectAnim( color, num, inout )
  
  local name = "spr_boxdoors_stone_"..color.."_"..num.."_on";
  local cur_alp = ObjGet(name).alp;
  
  local connect = {};
  local ind = private.FindIndex( color, num );
  
  if ind[1] > 1 then
    table.insert( connect, private.state[ ind[1]-1 ][ ind[2] ] );
  end;
  if ind[1] < 4 then
    table.insert( connect, private.state[ ind[1]+1 ][ ind[2] ] );
  end;
  if ind[2] > 1 then
    table.insert( connect, private.state[ ind[1] ][ ind[2]-1 ] );
  end;
  if ind[2] < 8 then
    table.insert( connect, private.state[ ind[1] ][ ind[2]+1 ] );
  end;
  
  
  if inout == 1 then
    
    for i = 1, #private.state, 1 do
      for j = 1, #private.state[i], 1 do
        
        ObjSet("spr_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2],  { input = 0 });
        
      end;
    end;
    
  else 
    
    for i = 1, #private.state, 1 do
      for j = 1, #private.state[i], 1 do
        
        ObjSet("spr_boxdoors_stone_"..private.state[i][j][1].."_"..private.state[i][j][2],  { input = 1 });
        
      end;
    end;
    
  end;
  
  for i = 1, #connect, 1 do
    
    if inout == 1 then
      ObjSet("spr_boxdoors_stone_"..connect[i][1].."_"..connect[i][2],  { input = 1 });
      ObjAnimate( "spr_boxdoors_stone_"..connect[i][1].."_"..connect[i][2].."_on", "alp", 0, 0, "", { 0, 2, 0,   0.2, 2, 1 });
    elseif inout == 0 then
      ObjAnimate( "spr_boxdoors_stone_"..connect[i][1].."_"..connect[i][2].."_on", "alp", 0, 0, "", { 0, 0, cur_alp,   0.2, 0, 0 });
    end;
    
  end;

  if inout == 1 then

    ObjSet("spr_boxdoors_stone_"..color.."_"..num,  { input = 1 });
    ObjAnimate( name, "alp", 0, 0, "", { 0, 2, 0,   0.2, 2, 1 });

  elseif inout == 0 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, cur_alp,   0.2, 0, 0 });

  end;
  
end;
-----------------------------------------------------------------------------------
function private.FindIndex( color, num, start )
  
  start = start or false;

  local ind = {0, 0};
  
  if not start then

    for i = 1, #private.state, 1 do
      for j = 1, #private.state[i], 1 do
        
        if private.state[i][j][1] == color and private.state[i][j][2] == num then
          ind[1] =  i;
          ind[2] =  j;
          break;
        end;
        
      end;
    end;
    
  else
    
    for i = 1, #private.stones_start, 1 do
      for j = 1, #private.stones_start[i], 1 do
        
        if private.stones_start[i][j][1] == color and private.stones_start[i][j][2] == num then
          ind[1] =  i;
          ind[2] =  j;
          break;
        end;
        
      end;
    end;
    
  end;

  return ind;

end;
-----------------------------------------------------------------------------------
function private.CheckScalesColor()
  
  local color_flag = { true, true, true, true };
  
  for i = 1, 4, 1 do
    for j = 1, #private.state[i], 1 do
      
      if private.state[i][j][1] ~= i and color_flag[i] then
        color_flag[i] = false;
      end;
      
    end;
  end;
  
  return color_flag;
  
end;
-----------------------------------------------------------------------------------
function private.CheckScalesOrient()
  
  local count_scales = { {0, 0}, {0, 0}, {0, 0}, {0, 0} };
  local angle = {0, 0, 0, 0};
  
  for i = 1, 4, 1 do
    for j = 1, #private.state[i], 1 do
      
      if j < 5 then
        count_scales[i][1] = count_scales[i][1] + private.stones_weight[ private.state[i][j][2] ];
      else 
        count_scales[i][2] = count_scales[i][2] + private.stones_weight[ private.state[i][j][2] ];
      end;
      
    end;
  end;
  
  for i = 1, 4, 1 do
    
    if count_scales[i][1] > count_scales[i][2] then
      angle[i] = 0.08;
    elseif count_scales[i][1] < count_scales[i][2] then
      angle[i] = -0.08;
    end;
    
  end;
  
  return angle;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local count_scales = { {0, 0}, {0, 0}, {0, 0}, {0, 0} };
  local color_flag = { true, true, true, true };
  local win_flag = true;
  
  for i = 1, 4, 1 do
    for j = 1, #private.state[i], 1 do
      
      if j < 5 then
        count_scales[i][1] = count_scales[i][1] + private.stones_weight[ private.state[i][j][2] ];
      else 
        count_scales[i][2] = count_scales[i][2] + private.stones_weight[ private.state[i][j][2] ];
      end;
      
      if private.state[i][j][1] ~= i and color_flag[i] then
        color_flag[i] = false;
      end;
      
    end;
  end;
  
  for i = 1, 4, 1 do
    
    if not color_flag[i] or ( count_scales[i][1] ~= count_scales[i][2] ) then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    private.Win();
    
  else 
    cmn.Lock( 0 );
  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );
  cmn.SetEventDone( "win_boxdoors" );
  
  if ng_global.currentprogress == "ext" then
  
    cmn.CallEventHandler( "win_boxdoors" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_boxdoors" ].skip == 0 and not ng_global.noskipgames[ "win_boxdoors" ] then

      ng_global.noskipgames[ "win_boxdoors" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

    if ng_global.playedgames and not ng_global.playedgames[ "win_boxdoors" ] then
      ng_global.playedgames[ "win_boxdoors" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "ext" then

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_boxdoors" );
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
    cmn.PlayAudio("snd", "assets/levels/level4/mg_boxdoors/audio/aud_opn_drawer4");

    ObjAnimate("obj_boxdoors_open_drawer", "alp", 0, 0, private.WinEnd, { 0, 0, 0,   1, 0, 0,   1.5, 0, 1 });
    
    for i = 1, 4, 1 do
      
      ObjAnimate("spr_boxdoors_drawer_"..i.."_handle_win", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,     1, 0, 0 });
      
    end;
    
  else 
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    private.WinEnd();
  end;

end;
--***********************************************************************************************************