-- name=mg_trollrift
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_trollrift";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Trollstatue();
  
  private.win_state = {3, 2, 5, 1, 4};
  private.start_state = {1, 3, 2, 4, 5};
  private.crystals_on = { 
    {0, 3, 2, 0, 0, 0, 0, 0, 0, 0}, 
    {0, 3, 0, 0, 0, 0, 5, 4, 0, 0}, 
    {0, 0, 0, 0, 4, 2, 0, 0, 0, 0}, 
    {5, 0, 0, 0, 2, 0, 0, 0, 0, 0}, 
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 3} };
  private.rays_on = {0, 0, 0, 0, 0};
  private.right_rays = {0, 1, 2, 3, 4};
  
  private.in_progress = false;
  --------------------------------------------------------------------------------------------
  -- function get_travelersbag () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_travelersbag" ] = {
        type = "get",
        get_obj = "spr_skeleton_travelersbag",
        room = private.room_objname,
        zz = "zz_skeleton",
        zz_gate = "gzz_trollrift_skeleton"
    };
    --------------------------------------------------------------------------------------------
  local get_travelersbag_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_travelersbag", "spr_skeleton_travelersbag" );
  
  end;
  
  local get_travelersbag_end = function ()
  
    ObjDelete( "gfx_skeleton_travelersbag" );
    ObjDelete( "spr_skeleton_travelersbag_sh" );
    
    ObjDelete( "spr_trollrift_skeleton_bag" );
  
  end;
  
  cmn.AddSubscriber( "get_travelersbag", get_travelersbag_inv );
  cmn.AddSubscriber( "get_travelersbag", get_travelersbag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hotwater () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_hotwater" ] = {
        type = "get",
        get_obj = "spr_skeleton_hotwater",
        room = private.room_objname,
        zz = "zz_skeleton",
        zz_gate = "gzz_trollrift_skeleton"
    };
    --------------------------------------------------------------------------------------------
  local get_hotwater_inv = function ()
  
    interface.InventoryItemAdd( "inv_hotwater", "spr_skeleton_hotwater" );
  
  end;
  
  local get_hotwater_end = function ()
    
    ObjMultiSet( { {"spr_skeleton_hotwater_water", { alp = 1 }},
                   {"gzz_trollrift_skeleton", { alp = 0, active = 0 }} } );
  
    ObjDelete( "gfx_skeleton_hotwater" );
    ObjDelete( "anm_skeleton_use_fullwateringcan" );
  
  end;
  
  cmn.AddSubscriber( "get_hotwater", get_hotwater_inv );
  cmn.AddSubscriber( "get_hotwater", get_hotwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_runestone1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_runestone1" ] = {
        type = "get",
        get_obj = "spr_crystals_runestone1",
        room = private.room_objname,
        zz = "zz_crystals",
        zz_gate = "gzz_trollrift_crystals"
    };
    --------------------------------------------------------------------------------------------
  local get_runestone1_inv = function ()
  
    interface.InventoryItemAdd( "inv_runestone", "spr_crystals_runestone1", function () cmn.GetMultyObject( 'runestone', 3 ); end );
  
  end;
  
  local get_runestone1_end = function ()
  
    ObjDelete( "gfx_crystals_runestone1" );
    ObjDelete( "spr_crystals_runestone1_sh" );
    
    ObjDelete( "spr_trollrift_crystal_rune" );
  
  end;
  
  cmn.AddSubscriber( "get_runestone1", get_runestone1_inv );
  cmn.AddSubscriber( "get_runestone1", get_runestone1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sharpstone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_sharpstone" ] = {
        type = "get",
        get_obj = "spr_trollcave_sharpstone",
        room = private.room_objname,
        zz = "zz_trollcave",
        zz_gate = "gzz_trollrift_trollcave"
    };
    --------------------------------------------------------------------------------------------
  local get_sharpstone_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharpstone", "spr_trollcave_sharpstone" );
    
    ObjMultiSet( { {"inv_travelersbag_star_light", { alp = 1 }},
                   {"inv_dirtytorch_star_light", { alp = 1 }} } );
  
  end;
  
  local get_sharpstone_end = function ()
  
    ObjDelete( "gfx_trollcave_sharpstone" );
    ObjDelete( "spr_trollcave_sharpstone_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_sharpstone", get_sharpstone_inv );
  cmn.AddSubscriber( "get_sharpstone", get_sharpstone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pegs () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pegs" ] = {
        type = "get",
        get_obj = "spr_trollstatue_pegs",
        room = private.room_objname,
        zz = "zz_trollstatue",
        zz_gate = "gzz_trollrift_trollstatue"
    };
    --------------------------------------------------------------------------------------------
  local get_pegs_inv = function ()
  
    interface.InventoryItemAdd( "inv_pegs", "spr_trollstatue_pegs" );
  
  end;
  
  local get_pegs_end = function ()
  
    ObjDelete( "gfx_trollstatue_pegs" );
    ObjDelete( "spr_trollstatue_pegs_sh" );
    
    ObjDelete( "spr_trollrift_statue_pegs" );
  
  end;
  
  cmn.AddSubscriber( "get_pegs", get_pegs_inv );
  cmn.AddSubscriber( "get_pegs", get_pegs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pyramid () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pyramid" ] = {
        type = "get",
        get_obj = "spr_trollstatue_pyramid",
        room = private.room_objname,
        zz = "zz_trollstatue",
        zz_gate = "gzz_trollrift_trollstatue"
    };
    --------------------------------------------------------------------------------------------
  local get_pyramid_inv = function ()
  
    interface.InventoryItemAdd( "inv_pyramid", "spr_trollstatue_pyramid" );
    int_map_impl.DecreaseRoomTasks("mg_trollrift");
  
  end;
  
  local get_pyramid_end = function ()
  
    ObjDelete( "gfx_trollstatue_pyramid" );
    ObjDelete( "spr_trollrift_statue_pyramid" );
    
    if cmn.IsEventDone("get_lvl4wings") then
      ObjDelete( "gzz_trollrift_trollstatue" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_pyramid", get_pyramid_inv );
  cmn.AddSubscriber( "get_pyramid", get_pyramid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4wings () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4wings" ] = {
        type = "get",
        get_obj = "spr_trollstatue_lvl4wings",
        room = private.room_objname,
        zz = "zz_trollstatue",
        zz_gate = "gzz_trollrift_trollstatue"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4wings_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4wings", "spr_trollstatue_lvl4wings" );
    ObjSet("inv_brokenfigurine_star_light",  { alp = 1 });
    int_map_impl.DecreaseRoomTasks("mg_trollrift");
  
  end;
  
  local get_lvl4wings_end = function ()
  
    ObjDelete( "gfx_trollstatue_lvl4wings" );
    ObjDelete( "spr_trollrift_statue_wing" );
    
    if cmn.IsEventDone("get_pyramid") then
      ObjDelete( "gzz_trollrift_trollstatue" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4wings", get_lvl4wings_inv );
  cmn.AddSubscriber( "get_lvl4wings", get_lvl4wings_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_fullwateringcan () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_fullwateringcan" ] = {
        type = "use",
        inv_obj = "inv_fullwateringcan",
        use_place = "obj_skeleton_use_fullwateringcan",
        room = private.room_objname,
        zz = "zz_skeleton",
        zz_gate = "gzz_trollrift_skeleton"
    };
  --------------------------------------------------------------------------------------------
  local use_fullwateringcan_inv = function ()
  
    interface.InventoryItemRemove( "inv_fullwateringcan" );
  
  end;
  local use_fullwateringcan_beg = function ()
  
    ObjDelete( "obj_skeleton_use_fullwateringcan" );
  
  end;
  local use_fullwateringcan_end = function ()
  
    --ObjSet( "spr_skeleton_hotwater", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fullwateringcan", use_fullwateringcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan", use_fullwateringcan_inv );
  cmn.AddSubscriber( "use_fullwateringcan", use_fullwateringcan_end, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan_inv", use_fullwateringcan_inv, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan_beg", use_fullwateringcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan_end", use_fullwateringcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sculptorsset () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_sculptorsset" ] = {
        type = "use",
        inv_obj = "inv_sculptorsset",
        use_place = "obj_crystals_use_sculptorsset",
        room = private.room_objname,
        zz = "zz_crystals",
        zz_gate = "gzz_trollrift_crystals"
    };
  --------------------------------------------------------------------------------------------
  local use_sculptorsset_inv = function ()
  
    interface.InventoryItemRemove( "inv_sculptorsset" );
  
  end;
  local use_sculptorsset_beg = function ()
  
    ObjDelete( "obj_crystals_use_sculptorsset" );
    ObjDelete( "spr_crystals_crystals_dust" );
    ObjDelete( "anm_crystals_crystal_touch" );
    ObjDelete( "spr_crystals_crystals" );
  
  end;
  local use_sculptorsset_mid = function ()
    
    ObjDelete( "gzz_trollrift_crystals" );
    ObjDelete( "spr_trollrift_crystal_dirty" );
    
    ObjMultiSet( { {"gzz_trollrift_skeleton", { alp = 0, active = 0, input = 0 }},
                   {"gzz_trollrift_trollcave", { alp = 0, active = 0, input = 0 }},
                   {"gzz_trollrift_trollstatue", { alp = 0, active = 0, input = 0 }} } );
    
  end;
  local use_sculptorsset_end = function ()
  
    ObjMultiSet( { {"obj_trollrift_game", { input = 1 }},
                   {"obj_trollrift_light", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sculptorsset", use_sculptorsset_beg, private.room_objname );
  cmn.AddSubscriber( "use_sculptorsset", use_sculptorsset_inv );
  cmn.AddSubscriber( "use_sculptorsset", use_sculptorsset_mid, private.room_objname );
  cmn.AddSubscriber( "use_sculptorsset", use_sculptorsset_end, private.room_objname );
  cmn.AddSubscriber( "use_sculptorsset_inv", use_sculptorsset_inv, private.room_objname );
  cmn.AddSubscriber( "use_sculptorsset_beg", use_sculptorsset_beg, private.room_objname );
  cmn.AddSubscriber( "use_sculptorsset_mid", use_sculptorsset_mid, private.room_objname );
  cmn.AddSubscriber( "use_sculptorsset_end", use_sculptorsset_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4torch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4torch" ] = {
        type = "use",
        inv_obj = "inv_lvl4torch",
        use_place = "obj_trollcave_use_lvl4torch",
        room = private.room_objname,
        zz = "zz_trollcave",
        zz_gate = "gzz_trollrift_trollcave"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4torch_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4torch" );
  
  end;
  local use_lvl4torch_beg = function ()
  
    ObjDelete( "obj_trollcave_use_lvl4torch" );
    ObjDelete( "anm_trollcave_touch" );
  
  end;
  local use_lvl4torch_end = function ()
  
    ObjDelete( "gzz_trollrift_trollcave" );

    ObjMultiSet( { {"gho_trollrift_introllscave", { input = 1, alp = 1, active = 1 }},
                   {"spr_trollrift_cave_light", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4torch", use_lvl4torch_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4torch", use_lvl4torch_inv );
  cmn.AddSubscriber( "use_lvl4torch", use_lvl4torch_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4torch_inv", use_lvl4torch_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4torch_beg", use_lvl4torch_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4torch_end", use_lvl4torch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_runestone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_runestone" ] = {
        type = "use",
        inv_obj = "inv_runestone",
        use_place = "obj_trollstatue_use_runestone",
        room = private.room_objname,
        zz = "zz_trollstatue",
        zz_gate = "gzz_trollrift_trollstatue"
    };
  --------------------------------------------------------------------------------------------
  local use_runestone_inv = function ()
  
    interface.InventoryItemRemove( "inv_runestone" );
  
  end;
  local use_runestone_beg = function ()
  
    ObjDelete( "obj_trollstatue_use_runestone" );
  
  end;
  local use_runestone_end = function ()
  
    ObjMultiSet( { {"spr_trollstatue_runestone_1", { alp = 1 }},
                   {"spr_trollstatue_runestone_2", { alp = 1, }},
                   {"spr_trollstatue_runestone_3", { alp = 1 }},
                   {"obj_trollstatue_game", { alp = 1, input = 1 }},
                   {"obj_trollrift_statue_slots", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_runestone", use_runestone_beg, private.room_objname );
  cmn.AddSubscriber( "use_runestone", use_runestone_inv );
  cmn.AddSubscriber( "use_runestone", use_runestone_end, private.room_objname );
  cmn.AddSubscriber( "use_runestone_inv", use_runestone_inv, private.room_objname );
  cmn.AddSubscriber( "use_runestone_beg", use_runestone_beg, private.room_objname );
  cmn.AddSubscriber( "use_runestone_end", use_runestone_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_trollrift () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local win_trollrift = function ()

    if cmn.IsEventDone( "win_trollrift" ) then
      
      ObjDelete( "anm_trollrift_troll" );
      ObjDelete( "anm_trollrift_troll_touch" );
      ObjDelete( "obj_trollrift_troll_bbt" );
      ObjDelete( "obj_trollrift_light" );
      
      ObjMultiSet( { {"obj_trollrift_game", { input = 0 }},
                     {"grm_trollrift_neargingerbreadhouse", { alp = 1, input = 1 }},
                     {"gzz_trollrift_skeleton", { alp = 1, active = 1, input = 1 }},
                     {"gzz_trollrift_trollcave", { alp = 1, active = 1, input = 1 }},
                     {"gzz_trollrift_trollstatue", { alp = 1, active = 1, input = 1 }},
                     {"spr_trollrift_troll_stones", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_trollrift_neargingerbreadhouse_focus");
      end;               
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_trollrift", win_trollrift, "mg_trollrift" );

  --------------------------------------------------------------------------------------------
  -- function beg_level4 () end;
  --------------------------------------------------------------------------------------------
  local beg_level4 = function ()
  
    int_map_impl.OpenRoom( "mg_trollrift" );
    common_impl.AddAvailibleMusic( 4 );
    interface_impl.SetCurrentGlobalTask( 22 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level4", beg_level4 );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_crystals" );
  subroom.Define( "zz_trollstatue" );
  subroom.Define( "zz_skeleton" );
  
  function zz_crystals.Close()
    
    if cmn.IsEventDone("use_sculptorsset") then
      private.GameActivate();
    end;
    
  end;
  
  function zz_trollstatue.PreOpen()
    
    if not(cmn.IsEventDone( "win_trollstatue" )) then
      private.zz_trollstatue.DrawScene();
    end;

  end;
  
  function zz_trollstatue.Open()
    
    if not cmn.IsEventDone("opn_trollstatue") then
      cmn.SetEventDone("opn_trollstatue");
      cmn.ShowBbt( "trollstatue_open" );
    end;
    
    if cmn.IsEventDone( "use_runestone" ) and not(cmn.IsEventDone( "win_trollstatue" )) then
      cmn.MiniGameShow();
      private.zz_trollstatue.CheckWin();
    end;

  end;

  function zz_trollstatue.PreClose()
    
    if ( cmn.IsEventDone( "use_runestone" ) and not(cmn.IsEventDone( "win_trollstatue" )) ) then
      cmn.MiniGameHide("trollstatue");
    end;

  end;
  
  function zz_skeleton.Close()
    
    cmn.HideNote( 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state;
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].state then 
    private.zz_trollstatue.StartConditions();
  end;
  
  private.zz_trollstatue.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_trollrift();
  
  if cmn.IsEventDone("use_sculptorsset") and not(cmn.IsEventDone( "win_trollrift" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_trollrift");
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if not ( cmn.IsEventDone( "beg_level4" ) ) then

    cmn.Lock(1);
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );

    ObjSet("mg_trollrift",  { color_r = 0, color_g = 0, color_b = 0 });
    
  else 
    cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_trollrift_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_trollrift_env");
  end;
  
  if not(cmn.IsEventDone( "win_trollrift" )) then
    private.DrawScene();
  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  if cmn.IsEventDone("use_sculptorsset") and not(cmn.IsEventDone( "win_trollrift" )) then
    cmn.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fullwateringcan()

  local item = "inv_fullwateringcan";

  if cmn.ApplyObj( item, "gzz_trollrift_skeleton" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_skeleton" );

  elseif ( cmn.ApplyObj( item, "obj_skeleton_use_fullwateringcan" ) ) then

    cmn.CallEventHandler( "use_fullwateringcan_inv" );
    cmn.CallEventHandler( "use_fullwateringcan_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fullwateringcan" );
      cmn.CallEventHandler( "use_fullwateringcan_end" );
      
      public.get_hotwater();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_use_bucket2");

    ObjSet("anm_skeleton_use_fullwateringcan",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sculptorsset()

  local item = "inv_sculptorsset";

  if cmn.ApplyObj( item, "gzz_trollrift_crystals" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_crystals" );

  elseif ( cmn.ApplyObj( item, "obj_crystals_use_sculptorsset" ) ) then

    cmn.CallEventHandler( "use_sculptorsset_inv" );
    cmn.CallEventHandler( "use_sculptorsset_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_sculptorsset" );
      cmn.CallEventHandler( "use_sculptorsset_mid" );
      
      common.CloseSubRoom();
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_use_tools");

    if not cmn.IsEventDone("get_runestone1") then
      public.get_runestone1();
    end;

    ObjSet("anm_crystals_use_sculptorsset",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4torch()

  local item = "inv_lvl4torch";

  if cmn.ApplyObj( item, "gzz_trollrift_trollcave" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_trollcave" );

  elseif ( cmn.ApplyObj( item, "obj_trollcave_use_lvl4torch" ) ) then

    cmn.CallEventHandler( "use_lvl4torch_inv" );
    cmn.CallEventHandler( "use_lvl4torch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4torch" );
      cmn.CallEventHandler( "use_lvl4torch_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_use_lamp4");

    ObjAnimate("obj_trollcave_lantern", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_trollcave_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.2, 0, 0,   0.7, 0, 1,   1.2, 0, 1 });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_runestone()

  local item = "inv_runestone";

  if cmn.ApplyObj( item, "gzz_trollrift_trollstatue" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_trollstatue" );

  elseif ( cmn.ApplyObj( item, "obj_trollstatue_use_runestone" ) and cmn.CheckMultiObject( "runestone", 3 ) ) then

    cmn.CallEventHandler( "use_runestone_inv" );
    cmn.CallEventHandler( "use_runestone_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_runestone" );
      cmn.CallEventHandler( "use_runestone_end" );
      
      cmn.MiniGameShow();
    
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_trollstatue_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_use_stones4");

    ObjAnimate("spr_trollstatue_runestone_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_trollstatue_runestone_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    ObjAnimate("spr_trollstatue_runestone_3", "alp", 0, 0, anm_game, { 0, 0, 0,   0.6, 0, 0,   0.9, 0, 1,   1.2, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_travelersbag()

  cmn.SetEventDone( "get_travelersbag" );
  cmn.CallEventHandler( "get_travelersbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_hotwater()
  
  ObjSet("spr_skeleton_hotwater",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_hotwater" );
  cmn.CallEventHandler( "get_hotwater" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_runestone1()

  cmn.SetEventDone( "get_runestone1" );
  cmn.CallEventHandler( "get_runestone1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_sharpstone()

  cmn.SetEventDone( "get_sharpstone" );
  cmn.CallEventHandler( "get_sharpstone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_pegs()

  cmn.SetEventDone( "get_pegs" );
  cmn.CallEventHandler( "get_pegs" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_pyramid()

  cmn.SetEventDone( "get_pyramid" );
  cmn.CallEventHandler( "get_pyramid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if not cmn.IsEventDone("get_lvl4wings") then
    cmn.SetEventDone( "get_lvl4wings" );
    cmn.CallEventHandler( "get_lvl4wings" );
  end;
  
  if cmn.IsEventDone("get_lvl4wings") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4wings()

  cmn.SetEventDone( "get_lvl4wings" );
  cmn.CallEventHandler( "get_lvl4wings" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_pyramid") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_trollrift()

  if not ( cmn.IsEventDone( "beg_level4" ) ) then
    
    local func_after = function ()

      ObjSet("mg_trollrift",  { color_r = 1, color_g = 1, color_b = 1 });
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 1 );

      cmn.ShowBbt( "trollrift_open" );
      interface_impl.ShowGlobalTask();
      int_map_impl.AddDiarypage( 11 );
      
      cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_trollrift_env");

    end;

    cmn.Lock(0);
    
    cmn.SetEventDone( "beg_level4" );
    cmn.CallEventHandler("beg_level4");
    
    cmn.PlayFullscreenVideo( "assets/levels/level4/mg_trollrift/vid_lvl4intro", func_after, "assets/levels/level4/mg_trollrift/audio/aud_4lvl_intro", "assets/levels/level4/mg_trollrift/audio/aud_4lvl_intro_voc");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_crystal()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_crystals_use_sculptorsset" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_xx_stones4");
  
  ObjSet("anm_crystals_crystal_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_troll_stone()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_trollstatue_use_runestone" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_clk_stone");
  
  ObjSet("anm_trollstatue_stone_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.skeleton_touch()
  
  cmn.Lock(1);
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_xx_clk_armor");
  
  ObjSet("anm_skeleton_skeleton",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cave()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_trollcave_use_lvl4torch" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_xx_clk_bats");
  
  ObjSet("anm_trollcave_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_troll_loc()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_trollrift_troll_touch", { alp = 0 }},
                   {"anm_trollrift_troll", { playing = 1, alp = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "trollrift_troll" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_xx_troll");
  
  ObjMultiSet( { {"anm_trollrift_troll_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_trollrift_troll", { playing = 0, alp = 0 }} } );
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if private.state[i] ~= private.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_trollrift_crystal_"..i.."_"..private.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_trollrift_crystal_"..i.."_"..private.start_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_move_crystall");
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state;
    
    private.BuildRays();
    local new_rays = {0, 0, 0, 0, 0};
    for i = 1, 5, 1 do
      new_rays[i] = private.rays_on[i];
    end;
    
    for i = 1, 5, 1 do
    
      if old_rays[i] ~= 0 and new_rays[i] == 0 then
        ObjAnimate("spr_trollrift_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
        ObjAnimate("spr_trollrift_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
        ObjAnimate("spr_trollrift_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_trollrift_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      elseif new_rays[i] ~= 0 and new_rays[i] ~= old_rays[i] then
        ObjAnimate("spr_trollrift_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
        ObjAnimate("spr_trollrift_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      end;
      
    end;
    
    ObjSet("tmr_trollrift_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock( 0 ); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_move_crystall");
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state = { 3, 2, 5, 1, 4 };
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if private.state[i] ~= private.win_state[i] then
      ObjAnimate("spr_trollrift_crystal_"..i.."_"..private.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_trollrift_crystal_"..i.."_"..private.win_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state;
  
  private.BuildRays();
  local new_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    new_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if old_rays[i] ~= 0 and new_rays[i] == 0 then
      ObjAnimate("spr_trollrift_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
    elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
      ObjAnimate("spr_trollrift_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_trollrift_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    elseif new_rays[i] ~= 0 and new_rays[i] ~= old_rays[i] then
      ObjAnimate("spr_trollrift_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  ObjSet("tmr_trollrift_timer",  { time = 0.5, playing = 1, endtrig = private.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state = { 1, 3, 2, 4, 5 };  --crystal pos
  
end;
-----------------------------------------------------------------------------------
function private.GameActivate()
  
  local func_after = function ()
  
    cmn.Lock( 0 );
    cmn.CallEventHandler( "use_sculptorsset_end" );
    cmn.MiniGameShow();
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
  
  ObjAnimate("obj_trollrift_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, 5, 1 do
    for j = 1, 5, 1 do
      
      if private.state[i] == j then
        ObjSet("spr_trollrift_crystal_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_trollrift_crystal_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
  end;
  
  private.BuildRays();
  
  for i = 1, 5, 1 do
    
    if private.rays_on[i] ~= 0 then
      ObjMultiSet( { {"spr_trollrift_light_"..i, { alp = 1 }},
                     {"spr_trollrift_ray_"..i.."_"..private.rays_on[i], { alp = 1 }} } );
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.BuildRays()
  
  private.rays_on = {0, 0, 0, 0, 0};
  
  private.rays_on[1] = private.state[1];
  
  if private.crystals_on[1][ private.state[1] ] ~= 0 then
    private.BuildRayNum( private.crystals_on[1][ private.state[1] ], 1 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.BuildRayNum( num, from )
  
  if from == private.right_rays[num] then
    private.rays_on[num] = private.state[num];
  else 
    private.rays_on[num] = private.state[num]+5;
  end;
  
  local next_c = private.crystals_on[num][ private.rays_on[num] ];
  
  if next_c ~= 0 and private.rays_on[next_c] == 0 then
    private.BuildRayNum( next_c, num );
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusCrystal( num, inout )
  
  local ray = private.state[num];
  
  if private.in_progress then
    
    ray = ray - 1;
    
    if ray < 1 then
      ray = 5;
    end;
    
  end;
  
  local obj_name = "spr_trollrift_crystal_"..num.."_"..ray.."_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ClickCrystal( num )
  
  private.in_progress = true;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_move_crystall");
  
  local old = private.state[num];
  local new = private.state[num]+1;
  
  if new > 5 then
    new = 1;
  end;
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  private.state[num] = new;
  
  private.BuildRays();
  local new_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    new_rays[i] = private.rays_on[i];
  end;
  
  local light_flag = false;
  
  for i = 1, 5, 1 do
    
    --DbgTrace( old_rays[i].." "..new_rays[i] );
    
    if old_rays[i] ~= 0 and new_rays[i] == 0 then
      ObjAnimate("spr_trollrift_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
    elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
      light_flag = true;
      ObjAnimate("spr_trollrift_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_trollrift_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    elseif new_rays[i] ~= 0 and new_rays[i] ~= old_rays[i] then
      ObjAnimate("spr_trollrift_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  if light_flag then
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
  end;
  
  ObjAnimate("spr_trollrift_crystal_"..num.."_"..old, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_trollrift_crystal_"..num.."_"..new, "alp", 0, 0, private.CheckWin, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  private.in_progress = false;
  
  local win_flag = true;
  
  for i = 1, 5, 1 do
    
    if private.state[i] ~= private.win_state[i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_trollrift" );
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
    
    ObjSet("tmr_trollrift_timer",  { time = 0.5, playing = 1, endtrig = private.Win });
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.SetEventDone( "win_trollrift" );
  cmn.CallEventHandler( "win_trollrift" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].skip == 0 and not ng_global.noskipgames[ "win_trollrift" ] then

    ng_global.noskipgames[ "win_trollrift" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  common_impl.PauseAchiev( 0 );
  cmn.Lock( 0 );
  
  if ng_global.playedgames and not ng_global.playedgames[ "win_trollrift2" ] then
    ng_global.playedgames[ "win_trollrift2" ] = 1;
  end;
  
  --cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_trollrift_env");
  cmn.ShowBbt( "trollrift_after_defeat" );

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  cmn.MiniGameHide();

  cmn.Lock( 0 );
  cmn.StopAllEnv();
  
  cmn.PlayFullscreenVideo( "assets/levels/level4/mg_trollrift/vid_defeatingtroll", private.WinEnd, "assets/levels/level4/mg_trollrift/audio/aud_defeatingtroll", "");
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Trollstatue *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_trollstatue = {};
public.zz_trollstatue = {};

function private.Init_Trollstatue()
  
  private.zz_trollstatue.win_parts = { {14, 13}, {11, 12}, {15, 16} };
  private.zz_trollstatue.chosen = 0;
  
  private.zz_trollstatue.pos = {
    {-117, 172}, {197, -152}, {26, 163}, {-182, 111}, {134, 122}, {-64, 106}, {179, 27}, {197, -46},
    {145, 56}, {136, -126}, {163, 180}, {-87, -181}, {71, -219}, {-210, -84}, {-187, 18}, {-174, -196}
  };
  
  private.zz_trollstatue.in_progress = false;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_trollstatue" ] = {
    type = "win",
    room = "mg_trollrift",
    zz = "zz_trollstatue",
    zz_gate = "gzz_trollrift_trollstatue"
  };
  -----------------------------------------------------------------------------------
  local win_trollstatue = function ()

    if cmn.IsEventDone( "win_trollstatue" ) then
      
      ObjDelete("obj_trollstatue_game");
      
      ObjMultiSet( { {"obj_trollstatue_niche_open", { alp = 1, input = 1 }},
                     {"obj_trollstatue_runestone_win", { alp = 1 }},
                     {"spr_trollrift_statue_niche", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_trollstatue", win_trollstatue, "mg_trollrift" );

end;
--*********************************************************************************************************************
function private.zz_trollstatue.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].state = { {0, 0}, {0, 0}, {0, 0} }; --собраны части рун
  
end;
-----------------------------------------------------------------------------------
function public.zz_trollstatue.Reset()
  
  local need_r = false;
  
  for i = 1, #private.zz_trollstatue.state, 1 do
    
    for j = 1, 2, 1 do
      
      if private.zz_trollstatue.state[i][j] == 1 then
        
        if not need_r then
          need_r = true;
        end;
        
        ObjSet("spr_trollstatue_part_"..private.zz_trollstatue.win_parts[i][j],  { pos_x = private.zz_trollstatue.pos[ private.zz_trollstatue.win_parts[i][j] ][1], pos_y = private.zz_trollstatue.pos[ private.zz_trollstatue.win_parts[i][j] ][2] });
        private.zz_trollstatue.AnimateSymbol( private.zz_trollstatue.win_parts[i][j] );
        
        ObjAnimate("spr_trollstatue_rune_"..i.."_"..j.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        ObjAnimate("spr_trollstatue_part_"..private.zz_trollstatue.win_parts[i][j], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
    end;
      
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    private.zz_trollstatue.StartConditions();
    private.zz_trollstatue.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].state;
    
    ObjSet("tmr_trollstatue_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock( 0 ); private.zz_trollstatue.DrawScene(); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_trollstatue.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_xx_menter_darkroom");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].state = { {1, 1}, {1, 1}, {1, 1} };
  
  for i = 1, #private.zz_trollstatue.state, 1 do
    
    for j = 1, 2, 1 do
      
      if private.zz_trollstatue.state[i][j] == 0 then
        
        ObjAnimate("spr_trollstatue_rune_"..i.."_"..j.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_trollstatue_part_"..private.zz_trollstatue.win_parts[i][j], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
    end;
      
  end;
  
  private.zz_trollstatue.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].state;
  ObjSet("tmr_trollstatue_timer",  { time = 0.5, playing = 1, endtrig = private.zz_trollstatue.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_trollstatue.DrawScene()
  
  for i = 1, #private.zz_trollstatue.state, 1 do
    
    for j = 1, 2, 1 do
      
      if private.zz_trollstatue.state[i][j] == 1 then
        ObjMultiSet( { {"spr_trollstatue_rune_"..i.."_"..j.."_on", { alp = 1 }},
                       {"spr_trollstatue_part_"..private.zz_trollstatue.win_parts[i][j], { alp = 0, input = 0 }} } );
      else 
        ObjMultiSet( { {"spr_trollstatue_rune_"..i.."_"..j.."_on", { alp = 0 }},
                       {"spr_trollstatue_part_"..private.zz_trollstatue.win_parts[i][j], { alp = 1, input = 1 }} } );             
      end;
      
    end;
      
    if private.zz_trollstatue.state[i][1] == 1 and private.zz_trollstatue.state[i][2] == 1 then  
      ObjSet("obj_trollstatue_rune_"..i.."_use",  { input = 0 });
    else 
      ObjSet("obj_trollstatue_rune_"..i.."_use",  { input = 1 });
    end;
      
  end;
  
  if not private.zz_trollstatue.in_progress then
    
    private.zz_trollstatue.in_progress = true;
    
    for i = 1, 16, 1 do
      
      private.zz_trollstatue.AnimateSymbol( i );
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_trollstatue.AnimateSymbol( num )
  
  local range_y = math.random(2, 8);
  local range_x = math.random(1, 6);
  local dir_y = math.random(1, 2);
  local dir_x = math.random(1, 2);
  if dir_y == 2 then
    dir_y = -1;
  end;
  if dir_x == 2 then
    dir_x = -1;
  end;
  
  ObjAnimate("spr_trollstatue_part_"..num, "pos_y", 1, 0, "", { 
    0, 2, private.zz_trollstatue.pos[num][2],     
    1, 2, private.zz_trollstatue.pos[num][2] + range_y*dir_y,    
    3, 3, private.zz_trollstatue.pos[num][2] - range_y*dir_y,    
    4, 1, private.zz_trollstatue.pos[num][2] 
  });
  ObjAnimate("spr_trollstatue_part_"..num, "pos_x", 1, 0, "", { 
    0, 2, private.zz_trollstatue.pos[num][1],     
    1, 2, private.zz_trollstatue.pos[num][1] + range_x*dir_x,    
    3, 3, private.zz_trollstatue.pos[num][1] - range_x*dir_x,    
    4, 1, private.zz_trollstatue.pos[num][1] 
  });
  
end;
-----------------------------------------------------------------------------------
function public.zz_trollstatue.FocusSymbol( num, inout )
  
  if inout == 1 then
    SetCursor( CURSOR_GET );
  else 
    SetCursor( CURSOR_DEFAULT );
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_trollstatue.ChooseSymbol( num )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  private.zz_trollstatue.chosen = num;
  
  ObjStopAnimate("spr_trollstatue_part_"..num, "pos_x");
  ObjStopAnimate("spr_trollstatue_part_"..num, "pos_y");
  
  ObjAttach("spr_trollstatue_part_"..num, "obj_trollstatue_game_fly");
  ObjStartDrag("obj_trollstatue_drag");
  
  public.zz_trollstatue.FocusSymbol( num, 0 );
  
end;
-----------------------------------------------------------------------------------
function public.zz_trollstatue.OnDrag()
  
  local num = private.zz_trollstatue.chosen;
  local curs = GetZoomCursorPos();
  curs[1] = math.floor( curs[1] ) - ObjGet("zz_trollstatue").pos_x;
  curs[2] = math.floor( curs[2] ) - ObjGet("zz_trollstatue").pos_y;
  
  if curs[1] < -250 then
    curs[1] = -250;
  elseif curs[1] > 250 then
    curs[1] = 250;
  end;
  
  if curs[2] < -250 then
    curs[2] = -250;
  elseif curs[2] > 250 then
    curs[2] = 250;
  end;
  
  ObjSet("spr_trollstatue_part_"..num,  { pos_x = curs[1], pos_y = curs[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_trollstatue.OnDrop()
  
  cmn.Lock( 1 );
  
  local num = private.zz_trollstatue.chosen;
  private.zz_trollstatue.chosen = 0;
  
  local curs = GetZoomCursorPos();
  curs[1] = math.floor( curs[1] ) - ObjGet("zz_trollstatue").pos_x;
  curs[2] = math.floor( curs[2] ) - ObjGet("zz_trollstatue").pos_y;
  if  tostring(GetPlatform()) == "android" then
    curs[2] = curs[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curs[2] = curs[2] - 75;
    else
      curs[2] = curs[2] - 50;
    end;
  end;
  
  if curs[1] < -250 then
    curs[1] = -250;
  elseif curs[1] > 250 then
    curs[1] = 250;
  end;
  
  if curs[2] < -250 then
    curs[2] = -250;
  elseif curs[2] > 250 then
    curs[2] = 250;
  end;
  
  ObjSet("spr_trollstatue_part_"..num,  { pos_x = curs[1], pos_y = curs[2] });
  
  local rune = private.zz_trollstatue.CheckRune( num );
  
  ObjAttach("spr_trollstatue_part_"..num, "obj_trollstatue_game");
  
  if rune ~= 0 and cmn.ApplyObj( "spr_trollstatue_part_"..num, "obj_trollstatue_rune_"..rune[1].."_use" ) then
    
    private.zz_trollstatue.state[ rune[1] ][ rune[2] ] = 1;
    ObjSet("spr_trollstatue_part_"..num,  { alp = 0, input = 0 });
    
    local part2 = 2;
    if rune[2] == 2 then
      part2 = 1;
    end;
    
    if private.zz_trollstatue.state[ rune[1] ][ part2 ] == 1 then
      ObjSet("obj_trollstatue_rune_"..rune[1].."_use",  { input = 0 });
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_xx_menter_darkroom");
    
    ObjAnimate("spr_trollstatue_rune_"..rune[1].."_"..rune[2].."_on", "alp", 0, 0, private.zz_trollstatue.CheckWin, { 0, 0, 0,   0.5, 0, 1 });
    
  else 
    
    local point_a, point_b = {}, {};
    point_a[1] = curs[1];
    point_a[2] = curs[2];
    point_b[1] = private.zz_trollstatue.pos[num][1];
    point_b[2] = private.zz_trollstatue.pos[num][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.001 * len;
    
    if tme > 0.3 then
      tme = 0.3;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    
    ObjAnimate("spr_trollstatue_part_"..num, "pos_xy", 0, 0, function() cmn.Lock( 0 ); private.zz_trollstatue.AnimateSymbol( num ); end, { 0, 0, curs[1], curs[2],   tme, 0, private.zz_trollstatue.pos[num][1], private.zz_trollstatue.pos[num][2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_trollstatue.CheckRune( num )
  
  local rune = 0;
  
  for i = 1, #private.zz_trollstatue.win_parts, 1 do
    
    for j = 1, 2, 1 do
      
      if private.zz_trollstatue.win_parts[i][j] == num then
        rune = {};
        rune[1] = i;
        rune[2] = j;
        break;
      end;
      
    end;
      
  end;
  
  return rune;
  
end;
-----------------------------------------------------------------------------------
function private.zz_trollstatue.CheckWin()
  
  local win_flag = true;
  
  for i = 1, #private.zz_trollstatue.state, 1 do
    
    if private.zz_trollstatue.state[i][1] == 0 or private.zz_trollstatue.state[i][2] == 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("trollstatue");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    local anm_open = function ()
      cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_use_stones");
      ObjAnimate("obj_trollstatue_niche_open", "alp", 0, 0, private.zz_trollstatue.Win, { 0, 0, 0,    0.5, 0, 1 });
    end;
    
    ObjAnimate("obj_trollstatue_game", "alp", 0, 0, "", { 0, 0, 1,   1, 0, 1,    1.5, 0, 0 });
    ObjAnimate("obj_trollstatue_runestone_win", "alp", 0, 0, anm_open, { 0, 0, 1,   1.5, 0, 0,    2, 0, 1,   2.5, 0, 1 });
    
  else 
    
    cmn.Lock( 0 );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_trollstatue.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_trollstatue" );
  cmn.CallEventHandler( "win_trollstatue" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_trollstatue" ].skip == 0 and ng_global.noskipgames[ "win_trollstatue" ] == nil then

    ng_global.noskipgames[ "win_trollstatue" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
end;
--*************************************************************************************************************