-- name=mg_trollrift2
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_trollrift2";
  --------------------------------------------------------------------------------------------
 
  private.win_state = {3, 2, 5, 1, 4};
  private.start_state = {1, 3, 2, 4, 5};
  private.crystals_on = { 
    {0, 3, 2, 0, 0, 0, 0, 0, 0, 0}, 
    {0, 3, 0, 0, 0, 0, 5, 4, 0, 0}, 
    {0, 0, 0, 0, 4, 2, 0, 0, 0, 0}, 
    {5, 0, 0, 0, 2, 0, 0, 0, 0, 0}, 
    {0, 0, 0, 0, 0, 1, 0, 0, 0, 3} };
  private.rays_on = {0, 0, 0, 0, 0};
  private.right_rays = {0, 1, 2, 3, 4};
  
  private.in_progress = false;
    
  --------------------------------------------------------------------------------------------
  -- function win_trollrift2 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local win_trollrift2 = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_trollrift2", win_trollrift2, "mg_trollrift2" );

end;
--*********************************************************************************************************************
function public.Load()
  
  private.StartConditions();

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].state;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);
 
  if not(cmn.IsEventDone( "win_trollrift2" )) then
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_trollrift_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_trollrift_env");
  
  ObjMultiSet( { {"spr_trollrift2_troll_stones", { alp = 0 }},
                 {"anm_trollrift2_troll", { alp = 1 }} } );
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    ObjSet("spr_trollrift2_ray_"..i.."_"..old_rays[i],  { alp = 0 });
    
  end;
   
  private.StartConditions();
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].state;
  
  private.BuildRays();
  local new_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    new_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if old_rays[i] ~= 0 and new_rays[i] == 0 then
      ObjSet("spr_trollrift2_light_"..i,  { alp = 0 });
    elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
      ObjSet("spr_trollrift2_light_"..i,  { alp = 1 });
    end;
    
  end;
  
  private.DrawScene();

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  
  if not(cmn.IsEventDone( "win_trollrift2" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if private.state[i] ~= private.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_trollrift2_crystal_"..i.."_"..private.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_trollrift2_crystal_"..i.."_"..private.start_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_move_crystall");
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].state;
    
    private.BuildRays();
    local new_rays = {0, 0, 0, 0, 0};
    for i = 1, 5, 1 do
      new_rays[i] = private.rays_on[i];
    end;
    
    for i = 1, 5, 1 do
    
      if old_rays[i] ~= 0 and new_rays[i] == 0 then
        ObjAnimate("spr_trollrift2_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
        ObjAnimate("spr_trollrift2_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
        ObjAnimate("spr_trollrift2_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_trollrift2_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      elseif new_rays[i] ~= 0 and new_rays[i] ~= old_rays[i] then
        ObjAnimate("spr_trollrift2_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
        ObjAnimate("spr_trollrift2_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      end;
      
    end;
    
    ObjSet("tmr_trollrift2_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock( 0 ); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_move_crystall");
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].state = { 3, 2, 5, 1, 4 };
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if private.state[i] ~= private.win_state[i] then
      ObjAnimate("spr_trollrift2_crystal_"..i.."_"..private.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_trollrift2_crystal_"..i.."_"..private.win_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_trollrift" ].state;
  
  private.BuildRays();
  local new_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    new_rays[i] = private.rays_on[i];
  end;
  
  for i = 1, 5, 1 do
    
    if old_rays[i] ~= 0 and new_rays[i] == 0 then
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift2_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
    elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
      ObjAnimate("spr_trollrift2_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    elseif new_rays[i] ~= 0 and new_rays[i] ~= old_rays[i] then
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  ObjSet("tmr_trollrift2_timer",  { time = 0.5, playing = 1, endtrig = private.CheckWin });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_troll_loc()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_trollrift2_troll_touch", { alp = 0 }},
                   {"anm_trollrift2_troll", { playing = 1, alp = 1 }} } );
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_xx_troll");
  
  ObjMultiSet( { {"anm_trollrift2_troll_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_trollrift2_troll", { playing = 0, alp = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_trollrift2" ].state = { 1, 3, 2, 4, 5 };  --crystal pos
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, 5, 1 do
    for j = 1, 5, 1 do
      
      if private.state[i] == j then
        ObjSet("spr_trollrift2_crystal_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_trollrift2_crystal_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
  end;
  
  private.BuildRays();
  
  for i = 1, 5, 1 do
    
    if private.rays_on[i] ~= 0 then
      ObjMultiSet( { {"spr_trollrift2_light_"..i, { alp = 1 }},
                     {"spr_trollrift2_ray_"..i.."_"..private.rays_on[i], { alp = 1 }} } );
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.BuildRays()
  
  private.rays_on = {0, 0, 0, 0, 0};
  
  private.rays_on[1] = private.state[1];
  
  if private.crystals_on[1][ private.state[1] ] ~= 0 then
    private.BuildRayNum( private.crystals_on[1][ private.state[1] ], 1 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.BuildRayNum( num, from )
  
  if from == private.right_rays[num] then
    private.rays_on[num] = private.state[num];
  else 
    private.rays_on[num] = private.state[num]+5;
  end;
  
  local next_c = private.crystals_on[num][ private.rays_on[num] ];
  
  if next_c ~= 0 and private.rays_on[next_c] == 0 then
    private.BuildRayNum( next_c, num );
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusCrystal( num, inout )
  
  local ray = private.state[num];
  
  if private.in_progress then
    
    ray = ray - 1;
    
    if ray < 1 then
      ray = 5;
    end;
    
  end;
  
  local obj_name = "spr_trollrift2_crystal_"..num.."_"..ray.."_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ClickCrystal( num )
  
  private.in_progress = true;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_move_crystall");
  
  local old = private.state[num];
  local new = private.state[num]+1;
  
  if new > 5 then
    new = 1;
  end;
  
  private.BuildRays();
  local old_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    old_rays[i] = private.rays_on[i];
  end;
  
  private.state[num] = new;
  
  private.BuildRays();
  local new_rays = {0, 0, 0, 0, 0};
  for i = 1, 5, 1 do
    new_rays[i] = private.rays_on[i];
  end;
  
  local light_flag = false;
  
  for i = 1, 5, 1 do
    
    --DbgTrace( old_rays[i].." "..new_rays[i] );
    
    if old_rays[i] ~= 0 and new_rays[i] == 0 then
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift2_light_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
    elseif old_rays[i] == 0 and new_rays[i] ~= 0 then
      light_flag = true;
      ObjAnimate("spr_trollrift2_light_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    elseif new_rays[i] ~= 0 and new_rays[i] ~= old_rays[i] then
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..old_rays[i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
      ObjAnimate("spr_trollrift2_ray_"..i.."_"..new_rays[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  if light_flag then
    cmn.PlayAudio("snd", "assets/levels/level4/mg_trollrift/audio/aud_glow_crystall");
  end;
  
  ObjAnimate("spr_trollrift2_crystal_"..num.."_"..old, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_trollrift2_crystal_"..num.."_"..new, "alp", 0, 0, private.CheckWin, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  private.in_progress = false;
  
  local win_flag = true;
  
  for i = 1, 5, 1 do
    
    if private.state[i] ~= private.win_state[i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    ObjSet("tmr_trollrift2_timer",  { time = 0.5, playing = 1, endtrig = private.Win });
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.SetEventDone( "win_trollrift2" );
  
  ObjMultiSet( { {"spr_trollrift2_troll_stones", { alp = 1 }},
                 {"anm_trollrift2_troll", { alp = 0 }} } );

  cmn.Lock( 0 );
  
  --cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_trollrift_env");
  interface_impl.ShowStarsWindow();

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  rm_extra.MiniGameHide();
  int_dialog_secretroom.StopTimer();

  cmn.Lock( 0 );
  cmn.StopAllEnv();
  
  cmn.PlayFullscreenVideo( "assets/levels/level4/mg_trollrift/vid_defeatingtroll", private.WinEnd, "assets/levels/level4/mg_trollrift/audio/aud_defeatingtroll", "");
  
end;
--*********************************************************************************************************************