-- name=menu
--*********************************************************************************************************************
function public.Start( param )

  interface.WidgetAdd( InterfaceWidget_Window );
  interface.WidgetAdd( InterfaceWidget_Pause, 666 );
  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_Effects );
  interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
    interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
    interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    
    interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
    interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");
    
    interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
    interface.WidgetAdd( InterfaceWidget_Popup, 250 );
    
    interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
    interface.WidgetAdd( InterfaceWidget_Dialog );
    
    interface_impl.SecretroomAdd();
    
    interface_impl.BonusAdd();
    
  end;

  local modules = 
  {
    "rm_intro"
    ,"rm_obb"
    ,"rm_menu"
    ,"rm_extra"
    ,"rm_achievements"
    ,"rm_collectable"
    ,"rm_credits"
    ,"rm_moregames"    
    ,"rm_unlock"
    ,"rm_sequel"
  };
  
  if IsCollectorsEdition() then
    
    game.progress_names =
    {
    
      "win_debris"
      ,"use_hoglove"
      ,"use_hoknife"
      ,"use_hoamulet"
      ,"use_hobandage"
      ,"use_hozip"
      ,"use_hobottle"
      ,"win_inwardrobe"
      ,"win_infridge"
      ,"win_intohollow"
      ,"use_holvl1rag"
      ,"use_holvl1hammer"
      ,"use_holvl1seed"
      
      ,"use_lvl2hoclock"
      ,"use_lvl2hoscales"
      ,"use_lvl2hosnowflake"
      ,"use_lvl2hohammer"
      ,"use_lvl2hogear"
      ,"use_lvl2howeight"
      ,"use_lvl2horune"
      ,"use_lvl2hopickaxe"
      ,"win_incarriage"
      ,"win_hospitalroom"
      ,"win_medical"
      
      ,"win_fishermans"
      ,"win_charmonlock"
      ,"win_onbasrelief"
      
      ,"win_introllscave"
      ,"win_honorary"
      ,"win_pumpkins"
      ,"use_hobone1"
      ,"use_hobone2"
      ,"use_hobone3"
      ,"use_hobone4"
      ,"use_hodogpart1"
      ,"use_hodogpart2"
      ,"use_hodogpart3"
      ,"use_hodogpart4"
      ,"win_dogarea"
      ,"opn_lvl4memories"
      ,"win_lvl4memories"
      
      ,"win_pursuit"
      ,"opn_memories"
      ,"win_memories"
      ,"win_key"
      ,"win_onmagicstone"
      ,"win_invendingmachine"
      ,"opn_onposter"
      ,"win_onposter"
      ,"win_onscroll"
      ,"win_safe"
      ,"win_fightingqueen"
      ,"win_darkroom"
      ,"win_trollrift2"
      ,"win_boxdoors"
      ,"win_angels"
    
    };

    game.relations = {};
    
  end;
  
  if IsDemoEdition() and IsCollectorsEdition() then

    game.progress_names =
    {
    
      "win_debris"
      ,"use_hoglove"
      ,"use_hoknife"
      ,"use_hoamulet"
      ,"use_hobandage"
      ,"use_hozip"
      ,"use_hobottle"
      ,"win_inwardrobe"
      ,"win_infridge"
      ,"win_intohollow"
      ,"use_holvl1rag"
      ,"use_holvl1hammer"
      ,"use_holvl1seed"      
      ,"win_pursuit"
      ,"win_memories"
      ,"win_key"
    
    };

  end;

  if  not IsCollectorsEdition() and not IsSurveyEdition() then

    modules = 
    {
      "rm_intro"
      ,"rm_obb"
      ,"rm_menu"
      ,"rm_credits"
      ,"rm_moregames"  
      ,"rm_unlock"    
      ,"rm_sequel"
    };

  else 

    interface_impl.PopupAchievementAdd();

    if IsSurveyEdition() then

      modules = 
      {
        "rm_intro"
        ,"rm_obb"
        ,"rm_menu"
        ,"rm_achievements"
        ,"rm_collectable"
        ,"rm_credits"
        ,"rm_moregames"   
        ,"rm_unlock"
        ,"rm_sequel"
    };

    end;

  end;

  common.MenuLoad( param, modules );
  common.ProjectSet();

end;

--*********************************************************************************************************************