-- name=rm_collectable
--******************************************************************************************
function public.Init()

  public.rm_collectable_state = {
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0
  };

end;
--******************************************************************************************
function public.PreOpen()

  private.enable_popup = false;
  ObjSet("tmr_rm_collectable",{ time = 1, playing = true, endtrig = function() private.enable_popup = true; end });
  interface_impl.DialogHintHide();

  cmn.StopAllEnv();
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_surf8_17_mus", 1);
  -------------------------------------------------------------------------
  if  ( not cmn.is_inmenunow ) then

    interface.WidgetSetInput( InterfaceWidget_Achiev, false );

    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, true );

    ObjSet( "int_inventory_impl",        { input = 0 } );
    --ObjSet( "int_button_hint",      { input = 0, alp = 0 } );
    --ObjSet( "obj_int_button_guide", { input = 0, alp = 0 } );
    --ObjSet( "int_button_map",       { input = 0, alp = 0 } );
    --ObjSet( "int_button_menu",      { input = 0, alp = 0 } );

  end;
  -------------------------------------------------------------------------
  public.rm_collectable_state = {
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0
  };

  for i = 1, #ng_global.collectable, 1 do

    public.rm_collectable_state[ ng_global.collectable[i].num ] = 1;

    if ng_global.collectable[i].first_appearance then

      ng_global.collectable[i].first_appearance = false;

      ObjSet("fx_collectable_"..ng_global.collectable[i].num, { playing = true, active = true });
      --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_fx" );

    end;

  end;

  for i = 1, #public.rm_collectable_state, 1 do
    
    ObjStopAnimate( "spr_collectable_"..i.."_mirror", 8 );

    if ( public.rm_collectable_state[i] == 0 ) then
      ObjMultiSet( { {"spr_collectable_"..i.."_mirror", { alp = 0 }},
                     {"spr_collectable_"..i, { alp = 0, input = 0 }} } );
    else 
      ObjMultiSet( { {"spr_collectable_"..i.."_mirror", { alp = 1 }},
                     {"spr_collectable_"..i, { alp = 1, input = 1 }} } );
    end;
                   
    if i == 8 and public.rm_collectable_state[i] == 1 then
      ObjSet("spr_collectable_"..i.."_2",  { alp = 1, input = 1 });
    end;

  end;

end;
--******************************************************************************************
function public.Open()
  
end;
--******************************************************************************************
function public.PreClose()

  interface_impl.PopupAchievementHide();

  cmn.StopAllMus();

  if  ( not cmn.is_inmenunow ) then

    --interface.WidgetSetInput( InterfaceWidget_Achiev,    true );

    --interface.WidgetSetInput( InterfaceWidget_Inventory, true );
    --interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    --interface.WidgetSetInput( InterfaceWidget_BtnGuide,  true );
    --interface.WidgetSetInput( InterfaceWidget_BtnMap,    true );
    --interface.WidgetSetInput( InterfaceWidget_BtnMenu,   true );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   true, true );

    --ObjSet("int_inventory_impl", {input = 1});
    --ObjSet("int_button_hint", {input = 1, alp = 1});
    --ObjSet("obj_int_button_guide", {alp = 1, input = 1});
    --ObjSet("int_button_map", {input = 1, alp = 1});
    --ObjSet("int_button_menu", {input = 1, alp = 1});

  end;

end;
--******************************************************************************************
function public.Close()
  
  common_impl.go_acievements = false;

  --костыль - чтобы снимался блок в комнате из который мы вошли при открытом сложном предмете
  if  ( not cmn.is_inmenunow ) then

    cmn.Lock( 0 );
    
    interface.WidgetSetInput( InterfaceWidget_Achiev,    true );
    interface.WidgetSetInput( InterfaceWidget_Bonus,     true );

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  true );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    true );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   true );

    ObjSet("int_inventory_impl", {input = 1});

  end;

end;
--******************************************************************************************
--port.
function public.Hide()
  public.Exit();  -- public. or private.
end;
--******************************************************************************************
--выход из комнаты
function public.Exit()

  if cmn.is_inmenunow then
    room.Switch("rm_extra");
  else
    room.Switch(common.GetCurrentRoom());
  end;

end;
--******************************************************************************************
function public.MouseEnterBack()

  local alp = ObjGet( "spr_collectable_exit_focus" ).alp;
  ObjAnimate( "spr_collectable_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,1});
  SetCursor(CURSOR_HAND);

end;

function public.MouseLeaveBack()

  local alp = ObjGet( "spr_collectable_exit_focus" ).alp;
  ObjAnimate( "spr_collectable_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,0});
  SetCursor(CURSOR_DEFAULT);

end;
--******************************************************************************************
--вывод попапа и подсветка
function public.AreaEnter( num, curs )   --num - номер collectable, curs - состояние курсора мыши (1-в области, 0-вне области)

  if (private.enable_popup == true) then
    if curs == 1 then

      SetCursor(CURSOR_QUESTION);
      
      local loc_table = { {
        str_1 = "ce_col_"..num, str_2 = "",
        color_r_1 = 1, color_g_1 = 1, color_b_1 = 1,
        color_r_2 = 1, color_g_2 = 1, color_b_2 = 1
      } };
    
      if public.rm_collectable_state[num] == 1 then

        loc_table = { {
          str_1 = "ce_col_"..num, str_2 = "ce_col_"..num.."_text",
          color_r_1 = 1, color_g_1 = 1, color_b_1 = 1,
          color_r_2 = 1, color_g_2 = 1, color_b_2 = 1
        } };
        
      end;

      interface_impl.PopupAchievementShow( loc_table );

    else
      
      interface_impl.PopupAchievementHide();
      SetCursor(CURSOR_DEFAULT);

    end;

    if public.rm_collectable_state[num] == 0 then

      ObjAnimate("spr_collectable_"..num.."_mirror", "alp", 0, 0, "", {0, 0, ObjGet("spr_collectable_"..num.."_mirror").alp,   1.2, 0, curs * 0.5});

    end;
  end;
end;
--******************************************************************************************