-- name=rm_extra
--******************************************************************************************
function public.Init()

  game.wallp_scr=1;
  game.cart_scr=1;
  game.screen_scr=1;
  game.num_track=1;
  
  game.hop_scr=1;
  game.minigame_scr=1;
  
  --порядок номеров у ресурсов дла картинок на мг и хо
  private.ho_order = {1, 4, 2, 3, 6, 7, 5, 9, 8, 10, 13, 12, 14, 11, 15};
  private.mg_order = {1, 2, 3, 5, 6, 4, 8, 7, 9, 10, 13, 11, 12};
  
  private.hop_names = { {"debris", 1}, {"inwardrobe", 1}, {"infridge", 1}, {"intohollow", 1}, {"incarriage", 2}, {"hospitalroom", 2}, {"medical", 2},
    {"fishermans", 3}, {"charmonlock", 3}, {"onbasrelief", 3}, {"introllscave", 4}, {"honorary", 4}, {"pumpkins", 4}, {"dogarea", 4}, {"lvl4memories", 4} };
                        
  private.minigame_names = { {"pursuit", 1}, {"memories", 1}, {"key", 1}, {"onmagicstone", 2}, {"invendingmachine", 2}, {"onposter", 2},
    {"onscroll", 3}, {"safe", 3}, {"fightingqueen", 3}, {"darkroom", 3}, {"trollrift2", 4}, {"boxdoors", 4}, {"angels", 4} };
    
  private.modules_loaded = {};
  
  public.count_timer = 0;

  if IsDemoEdition() == 1 then

    ObjSet( "obj_extra_gameplay", { alp = 0, active = 0, visible = 0, input = 0 } );
    ObjSet( "spr_extra_gameplay_sel_btn", { alp = 0, active = 0, visible = 0 } );
    ObjSet( "obj_extra_arr_gameplay", {alp=0,active=0,visible=0,input=0});

    ObjSet( "obj_extra_music", { alp = 1, active = 1, visible = 1, input = 1 } );
    ObjSet( "spr_extra_music_sel_btn", { alp = 1, active = 1, visible = 1 } );
    ObjSet( "obj_extra_arr_music", {alp=1,active=1,visible=1,input=1});
    ObjSet( "obj_extra_btn_play", {event_mdown=public.ClickPlay_music});

    ObjSet( "obj_extra_btn_gameplay", { color_r = 0.5, color_g = 0.5, color_b = 0.5 } );
    --ObjSet( "obj_extra_btn_conceptart", { color_r = 0.5, color_g = 0.5, color_b = 0.5 } );
    --ObjSet( "obj_extra_btn_screensaver", { color_r = 0.5, color_g = 0.5, color_b = 0.5 } );

  end;

  --удаление кнопки "скринсейвер" в MAC - версии
  if GetPlatform() == "mac" then
    ObjSet("obj_extra_btn_screensaver",{input=0,visible=0,active=0});
    ObjSet("spr_extra_btn_screensaver_focus",{input=0,visible=0,active=0});
  end;

end;
--******************************************************************************************
function public.PreOpen()

  ng_global.isinextra = 1;

  for i=1,5,1 do
    ObjSet("spr_extra_music_play_"..i,{input=1,alp=1});
    ObjSet("spr_extra_music_pause_"..i,{alp=0,input=0});
    ObjSet("spr_extra_music_track_"..i.."_focus",{alp=0});
    ObjSet("spr_extra_music_text_"..i.."_focus",{alp=0});
  end;
  
  ObjMultiSet( { {"spr_extra_music_pause_3", { alp = 1, input = 1 }},
                 {"spr_extra_music_play_3", { alp = 0, input = 0 }},
                 {"spr_extra_music_text_3_focus", { alp = 1 }},
                 {"spr_extra_music_track_3_focus", { alp = 1 }} } );

  local ho_name = private.hop_names[ game.hop_scr ][1];
  if IsDemoEdition() then
    ObjSet("spr_extra_hop_back",  { res = "" });
  elseif not ng_global.playedhops[ "win_"..ho_name ] then
    ObjSet("spr_extra_hop_back",  { res = "assets/levels/menu/rm_extra/ho/ho_"..private.ho_order[ game.hop_scr ].."_a" });
  else 
    ObjSet("spr_extra_hop_back",  { res = "assets/levels/menu/rm_extra/ho/ho_"..private.ho_order[ game.hop_scr ] });
    private.SetTimeReplay( ho_name, "hop" );
  end;
  
  local mg_name = private.minigame_names[ game.minigame_scr ][1];
  if IsDemoEdition() then
    ObjSet("spr_extra_minigame_back",  { res = "" });
  elseif not ng_global.playedgames[ "win_"..mg_name ] then
    ObjSet("spr_extra_minigame_back",  { res = "assets/levels/menu/rm_extra/mg/mg_"..private.mg_order[ game.minigame_scr ].."_a" });
  else 
    ObjSet("spr_extra_minigame_back",  { res = "assets/levels/menu/rm_extra/mg/mg_"..private.mg_order[ game.minigame_scr ] });
    private.SetTimeReplay( mg_name, "minigame" );
  end;

end;
--******************************************************************************************
function public.Open()

  cmn.StopAllEnv();
  cmn.StopAllMus();

  if IsCollectorsEdition() and rm_achievements.in_rm_acievements then
    rm_achievements.in_rm_acievements = false;
  else
    game.num_track=3;
    rm_menu.playing_main_theme = false;
    PlaySoundtrack( "assets/levels/menu/rm_extra/music/soundtrack_3" , 1,"", 1,5 );
  end;

end;
--******************************************************************************************
function public.PreClose()

  ng_global.isinextra = 0;

end;
--******************************************************************************************
function public.Close()

  if not common_impl.go_acievements then
    for i = 1,5,1 do
      SndStop( "assets/levels/menu/rm_extra/music/soundtrack_"..i, 0.5 );
    end;
  end;

end;
--******************************************************************************************
--******************************************************************************************
function public.BtnExtraMouse( alpha, sender )

  if alpha==1 then
    SetCursor(CURSOR_HAND);
  else
    SetCursor(CURSOR_DEFAULT);
  end;
  local name_btn=sender;

  if string.find(sender, "obj") then

    name_btn="spr_"..string.match(sender, "obj_(.*)");

  end;

  local name_fcs=name_btn.."_focus";
  local alp_fcs=ObjGet(name_fcs).alp;

  ObjAnimate(name_fcs,"alp",0,0,"",{0,0,alp_fcs, 0.2,0,alpha});
  if alpha==1 then
    --PlaySfx( "assets/levels/common/audio/aud_smallwhoosh",0,"",0 );
  end;
  
end;
--******************************************************************************************
--клик по кнопкам в меню (вывод экранов "Все МИ", "Геймплей" и т.д.)
function public.ClickBtnMenu( sender )

  local name_btn=sender;
  local name_spr=string.match(name_btn , "obj_extra_btn(.*)");
  local name_obj="obj_extra"..name_spr;
  local name_sel="spr_extra"..name_spr.."_sel_btn";
  local name_arw="obj_extra_arr"..name_spr;
  local array_obj={"obj_extra_gameplay","obj_extra_screensaver","obj_extra_wallpaper","obj_extra_conceptart","obj_extra_music","obj_extra_hop","obj_extra_minigame"};
  local ss="";
  local i=0;

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if IsDemoEdition() and (name_spr == "_gameplay" or name_spr == "_hop" or name_spr == "_minigame") then

    cmn.DialogWindowShow( "common", "extbonus" );

  else

    for i=1,#array_obj,1 do

      ObjSet(array_obj[i],{alp=0,active=0,visible=0,input=0});
      ss=string.match(array_obj[i] , "obj_extra_(.*)");
      ObjSet("spr_extra_"..ss.."_sel_btn",{alp=0,active=0,visible=0,input=0});
      ObjSet("obj_extra_arr_"..ss,{alp=0,active=0,visible=0,input=0});

    end;

    ObjSet(name_obj,{alp=1,active=1,visible=1,input=1});
    ObjSet(name_sel,{alp=1,active=1,visible=1});
    ObjSet(name_arw,{alp=1,active=1,visible=1,input=1});
    ObjSet("obj_extra_btn_play",{event_mup="rm_extra.ClickPlay"..name_spr.."()"});

  end;
  
  if name_spr == "_music" and (GetPlatform() == "ios" or GetPlatform() == "android") then
    ObjSet("obj_extra_downbuttons",{ active = false, input = false, visible = false, alp = 0 });
    ObjSet("obj_extra_arr_music",{ active = false, input = false, visible = false, alp = 0 });
    ObjSet("obj_extra_btn_play",{ active = false, input = false, visible = false, alp = 0 });
  else
    ObjSet("obj_extra_downbuttons",{ active = true, visible = true, alp = 1 });
    ObjSet("obj_extra_btn_play",{ active = true, input = true, visible = true, alp = 1 });
  end;
  
end;
--******************************************************************************************
--Функции клика по кнопке "Play"/"Save"-------
--------------------------------GamePlay
function public.ClickPlay_gameplay()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if ng_global.progress[ "std" ].common.gamewin~=true and not(IsDemoEdition()) then 

    cmn.DialogWindowShow( "common", "extgame" );

--  elseif ng_global.progress[ "std" ].common.gamewin~=true and (IsDemoEdition()) then 
--
--    cmn.DialogWindowShow( "common", "extbonus" );
    
  elseif IsDemoEdition() then 
    
    cmn.DialogWindowShow( "common", "extbonus" );

  else

    local prg = "ext";

    ng_global.currentprogress = prg;

    if ( not ng_global.progress[ prg ].common.gamestart ) then
      ng_global.progress[ prg ].common.gamestart = true;
    end;

    SetCursor( CURSOR_DEFAULT );
    local level = ng_global.progress[ prg ].common.chapter;
    cmn.is_inmenunow = false;
    common.LevelSwitch( level );
 
  end; 
  
end;
--------------------------------Screensaver
function public.ClickPlay_screensaver()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if (IsCollectorsEdition()) and not(IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "setscr" );

  elseif (IsCollectorsEdition()) and (IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "extbonus" );

  end;

end;
--------------------------------Wallpaper
function public.ClickPlay_wallpaper()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if (IsCollectorsEdition()) and not(IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "setwlp" );

  elseif (IsCollectorsEdition()) and (IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "extbonus2" );

  end;

end;
--------------------------------ConceptArt
function public.ClickPlay_conceptart()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if (IsCollectorsEdition()) and not(IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "savecart" );

  elseif (IsCollectorsEdition()) and (IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "extbonus" );

  end;

end;
--------------------------------Music
function public.ClickPlay_music()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if (IsCollectorsEdition()) and not(IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "savemusic" );

  elseif (IsCollectorsEdition()) and (IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "extbonus2" );

  end;

end;
--------------------------------HOPs
function public.ClickPlay_hop()
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if (IsCollectorsEdition()) and not(IsDemoEdition()) then
    
    local ho_name = private.hop_names[ game.hop_scr ][1];

    if not ng_global.playedhops[ "win_"..ho_name ] then
      
      cmn.DialogWindowShow( "common", "playhop" );
      
    else 
      
      ng_global.currentprogress = "secret";
      common_impl.SetCurrentProgress( ng_global.currentprogress );
      
      if not private.CheckForLoad( ho_name ) then
        
        private.modules_loaded[ #private.modules_loaded+1 ] = ho_name;
      
        ModLoad( "assets/levels/level"..private.hop_names[ game.hop_scr ][2].."/ho_"..ho_name.."/mod_"..ho_name );
        
        --ObjAttach( "ho_"..ho_name, room.hub );
        if game and game.relations then
          game.relations[ "ho_"..ho_name ] = {};
        end;
        
        _G[ "ho_"..ho_name ].Init();
        _G[ "ho_"..ho_name ].Load();
        
      end;
      
      private.GoToReplay( "ho", ho_name );
      
    end;

  elseif (IsCollectorsEdition()) and (IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "extbonus" );

  end;
  
end;
--------------------------------Minigames
function public.ClickPlay_minigame()
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if (IsCollectorsEdition()) and not(IsDemoEdition()) then
    
    local mg_name = private.minigame_names[ game.minigame_scr ][1];

    if not ng_global.playedgames[ "win_"..mg_name ] then
      
      cmn.DialogWindowShow( "common", "playmg" );
      
    else 
      
      ng_global.currentprogress = "secret";
      common_impl.SetCurrentProgress( ng_global.currentprogress );
      
      if not private.CheckForLoad( mg_name ) then
        
        private.modules_loaded[ #private.modules_loaded+1 ] = mg_name;
      
        ModLoad( "assets/levels/level"..private.minigame_names[ game.minigame_scr ][2].."/mg_"..mg_name.."/mod_"..mg_name );
        _G[ "mg_"..mg_name ].Init();
        _G[ "mg_"..mg_name ].Load();
        
      end;
      
      private.GoToReplay( "mg", mg_name );
      
    end;

  elseif (IsCollectorsEdition()) and (IsDemoEdition()) then

    cmn.DialogWindowShow( "common", "extbonus" );

  end;
  
end;
--******************************************************************************************
function public.BonusroomDown()

  cmn.GotoRoom( "rm_collectable" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

end;
---------------------------------------------------------------------------------
function public.AchDown()

  common_impl.go_acievements = true;

  common.MenuAchievements();
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

end;
--******************************************************************************************
--------------------------------клик по стрелкам влево-вправо--------------------
-----------------------анимация стрелки
function private.ArrowAnim( sender, type )

  local name_arrow = sender;

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if type == 1 then
    ObjAnimate(name_arrow,"alp",0,0,"",{0,0,1, 0.15,0,0, 0.3,0,1});
  else 
    ObjAnimate(name_arrow,"alp",0,0,"",{0,0,1, 0.15,0,0});
  end;

end;
--------------------------------------------клик на стрелки 
--влево-deg<0,вправо-deg>0,inc-инкрементная переменная 
function private.ClikArrowBtn(inc,name_scr,name_txt,count_scr,deg, sender, type)
  
  if (deg>0) and (inc<count_scr) then

    inc=inc+1;  

  elseif (deg<0) and (inc>1) then

    inc=inc-1;  

  end;

  if name_scr == "wall" then
    ObjSet("spr_extra_"..type.."_back",{ res = "assets/levels/menu/rm_extra/wallpaper/mini_"..name_scr.."_"..inc });  
  elseif name_scr == "concept" then
    ObjSet("spr_extra_"..type.."_back",{ res = "assets/levels/menu/rm_extra/concept_art/mini_"..name_scr.."_"..inc });
  elseif name_scr == "ho" then
    
    local ho_name = private.hop_names[ inc ][1];
    if not ng_global.playedhops[ "win_"..ho_name ] then
      ObjSet("spr_extra_hop_back",  { res = "assets/levels/menu/rm_extra/ho/ho_"..private.ho_order[ inc ].."_a" });
    else 
      ObjSet("spr_extra_hop_back",  { res = "assets/levels/menu/rm_extra/ho/ho_"..private.ho_order[ inc ] });
    end;
    
    private.SetTimeReplay( ho_name, "hop" );
    
  elseif name_scr == "mg" then
    
    local mg_name = private.minigame_names[ inc ][1];
    if not ng_global.playedgames[ "win_"..mg_name ] then
      ObjSet("spr_extra_minigame_back",  { res = "assets/levels/menu/rm_extra/mg/mg_"..private.mg_order[ inc ].."_a" });
    else 
      ObjSet("spr_extra_minigame_back",  { res = "assets/levels/menu/rm_extra/mg/mg_"..private.mg_order[ inc ] });
    end;
    
    private.SetTimeReplay( mg_name, "minigame" );
    
  end;

  if inc == 1 then
    private.ArrowAnim(sender, 2);
    ObjMultiSet( { {"spr_extra_arr_"..type.."_right", { alp = 1, input = 1 }},
                   {"spr_extra_arr_"..type.."_left", { input = 0 }} } );
  elseif inc == count_scr then
    private.ArrowAnim(sender, 2);
    ObjMultiSet( { {"spr_extra_arr_"..type.."_left", { alp = 1, input = 1 }},
                   {"spr_extra_arr_"..type.."_right", { input = 0 }} } );
  else 
    private.ArrowAnim(sender, 1);
    ObjMultiSet( { {"spr_extra_arr_"..type.."_left", { alp = 1, input = 1 }},
                   {"spr_extra_arr_"..type.."_right", { alp = 1, input = 1 }} } );
  end;

  ObjSet(name_scr..inc,{alp=1,visible=1,active=1,input=1});
  ObjSet(name_txt,{text=inc.."/"..count_scr});

  return inc;

end;
-----------------------------------------------------------------------
--------------------------------Wallpapers
function public.ClickLeft_wallpaper() 

  game.wallp_scr=private.ClikArrowBtn(game.wallp_scr,"wall","txt_extra_btnplay_wallpaper",10,-1, "spr_extra_arr_wallpaper_left", "wallpaper"); 
 
end;

function public.ClickRight_wallpaper()

  game.wallp_scr=private.ClikArrowBtn(game.wallp_scr,"wall","txt_extra_btnplay_wallpaper",10,1, "spr_extra_arr_wallpaper_right", "wallpaper");

end;
--------------------------------ConceptArt
function public.ClickLeft_conceptart() 

  game.cart_scr=private.ClikArrowBtn(game.cart_scr,"concept","txt_extra_btnplay_conceptart",10,-1, "spr_extra_arr_conceptart_left", "conceptart");

end;

function public.ClickRight_conceptart()

  game.cart_scr=private.ClikArrowBtn(game.cart_scr,"concept","txt_extra_btnplay_conceptart",10,1, "spr_extra_arr_conceptart_right", "conceptart");

end;
--------------------------------Screensaver
function public.ClickLeft_screensaver() 

  game.screen_scr=private.ClikArrowBtn(game.screen_scr,"screensaver","txt_extra_btnplay_screensaver",2,-1, "spr_extra_arr_screensaver_left", "screensaver");

end;

function public.ClickRight_screensaver()

  game.screen_scr=private.ClikArrowBtn(game.screen_scr,"screensaver","txt_extra_btnplay_screensaver",2,1, "spr_extra_arr_screensaver_right", "screensaver");

end;
--------------------------------HOPs
function public.ClickLeft_hop() 

  game.hop_scr=private.ClikArrowBtn(game.hop_scr,"ho","txt_extra_btnplay_hop",15,-1, "spr_extra_arr_hop_left", "hop"); 
 
end;

function public.ClickRight_hop()

  game.hop_scr=private.ClikArrowBtn(game.hop_scr,"ho","txt_extra_btnplay_hop",15,1, "spr_extra_arr_hop_right", "hop");

end;
--------------------------------Minigames
function public.ClickLeft_minigame() 

  game.minigame_scr=private.ClikArrowBtn(game.minigame_scr,"mg","txt_extra_btnplay_minigame",13,-1, "spr_extra_arr_minigame_left", "minigame"); 
 
end;

function public.ClickRight_minigame()

  game.minigame_scr=private.ClikArrowBtn(game.minigame_scr,"mg","txt_extra_btnplay_minigame",13,1, "spr_extra_arr_minigame_right", "minigame");

end;
---------------------------------------------------------------------------------
--функция клика на кнопки Play и Pause окно music
function public.ClkMusicPlayPause( sender )

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  cmn.StopAllMus();
  local name_obj=sender;
  local alp=ObjGet(name_obj).alp;
  local s_name=tostring(name_obj);
  local length=string.len(s_name);
  local s_number=string.sub(s_name,length,length);
  local s_name=string.sub(s_name,1,length-1);
  local num=tonumber(s_number); 

  game.num_track=num;

  if s_name=="spr_extra_music_play_" then

    for i=1,5,1 do

      ObjSet("spr_extra_music_play_"..i,{input=1,alp=1});
      ObjSet("spr_extra_music_pause_"..i,{alp=0,input=0});
      SndStop( "assets/levels/menu/rm_extra/music/soundtrack_"..i, 1.5 );
      ObjSet("spr_extra_music_track_"..i.."_focus",{alp=0});
      ObjSet("spr_extra_music_text_"..i.."_focus",{alp=0});

    end;

    ObjSet("spr_extra_music_pause_"..num,{alp=1,input=1});
    ObjSet("spr_extra_music_play_"..num,{input=0,alp=0});
    ObjSet("spr_extra_music_track_"..num.."_focus",{alp=1});
    ObjSet("spr_extra_music_text_"..num.."_focus",{alp=1});
    PlaySoundtrack( "assets/levels/menu/rm_extra/music/soundtrack_"..num , 1,"", 1,5 );

  else 

    ObjSet("spr_extra_music_pause_"..num,{input=0,alp=0});
    ObjSet("spr_extra_music_play_"..num,{input=1,alp=1});
    SndStop( "assets/levels/menu/rm_extra/music/soundtrack_"..num, 1.5 );

  end

end;
---------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** Replay mg and ho *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------------------------------
function public.ResetChallengeTimer()
  
  public.count_timer = public.count_timer + 1;
  ObjSet("tmr_extra_challenge_timer",  { time = 60, playing = 1, endtrig = public.ResetChallengeTimer });
  
end;
-------------------------------------------------------------------------
function private.SetTimeReplay( name, typ )
  
  if ng_global.replay_time and ng_global.replay_time[ "win_"..name ] then
      
    local text_t = "";
    local text_d = StringGet("str_dialog_common_replay_ho_mg_time_best");
    
    if ng_global.replay_time[ "win_"..name ][3] < 10 then
      text_t = ng_global.replay_time[ "win_"..name ][2]..":0"..ng_global.replay_time[ "win_"..name ][3];
    else 
      text_t = ng_global.replay_time[ "win_"..name ][2]..":"..ng_global.replay_time[ "win_"..name ][3];
    end;

    if ng_global.replay_time[ "win_"..name ][1] > 0 and ng_global.replay_time[ "win_"..name ][2] > 9 then
      text_t = ng_global.replay_time[ "win_"..name ][1]..":"..text_t;
    elseif ng_global.replay_time[ "win_"..name ][1] > 0 then
      text_t = ng_global.replay_time[ "win_"..name ][1]..":0"..text_t;
    end;
  
    ObjMultiSet( { {"spr_extra_"..typ.."_time", { alp = 1 }},
                   {"txt_extra_"..typ.."_time", { text = text_d.." "..text_t }} } );
    
  else
    ObjSet("spr_extra_"..typ.."_time",  { alp = 0 });
  end;
  
end;
-------------------------------------------------------------------------
function private.CheckForLoad( name )
  
  local check = false;
  
  for i = 1, #private.modules_loaded, 1 do
    
    if private.modules_loaded[i] == name then
      check = true;
      break;
    end;
    
  end;
  
  return check;
  
end;
-------------------------------------------------------------------------
function private.GoToReplay( type, name )
  
  ng_global.progress[ ng_global.currentprogress ][ "win_"..name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_"..name ].start = 0;
  
  if type == "ho" then
    ng_global.progress[ ng_global.currentprogress ][ "win_"..name ].found = {};
  end;
  
  public.count_timer = 0;
  ObjAttach("tmr_extra_challenge_timer", type.."_"..name);
  ObjSet("tmr_extra_challenge_timer",  { time = 60, playing = 1, endtrig = public.ResetChallengeTimer });
  
  cmn.GotoRoom( type.."_"..name, 1, true );
  
end;
-------------------------------------------------------------------------
function public.GoToSecretroom()

  cmn.DialogWindowShow( "common", "secretroom_leave_challenge" );

end;
-------------------------------------------------------------------------
function public.GoToSecretroom_end()
  
  public.count_timer = 0;
  ObjAttach("tmr_extra_challenge_timer", "rm_extra");
  ObjSet("tmr_extra_challenge_timer",  { time = 0, playing = 0, endtrig = "" });
  
  cmn.GotoRoom( "rm_extra" );

  ng_global.currentprogress = "std";
  common_impl.SetCurrentProgress( ng_global.currentprogress );

end;
--------------------------------------------------------------------
function public.GateMouseEnter( sender, type_cursor, dest )
  
  type_cursor = type_cursor or CURSOR_DEFAULT;
  SetCursor( type_cursor );

  local obj = "grm_"..sender;
  local obj_focus = obj.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0.0, 0, alp,   0.3 *( 1 - alp ), 0, 1 } );

  common_impl.PopupShow( dest );

end;
--*********************************************************************************************************************
--***function *** MINIGAME *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.MiniGameShow( minigame_name, skip_multiplier )

    if ( skip_multiplier ) then

      if ( common.GetGamemode() == 0 ) then

        skip_multiplier = 3.333333;

      elseif ( common.GetGamemode() > 0 ) then

        skip_multiplier = 3.5;

      end;

    end;

    minigame_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    local result = false;

    local event_name = "win_"..minigame_name;

    if ( not cmn.IsEventStart( event_name ) ) then

      cmn.SetEventStart( event_name );
      --private.SetSkipTimer( minigame_name, 1 );

      result = true;

    end;

    interface.ButtonInfoShow();
    interface.ButtonResetShow();

    --interface.ButtonSkipReload( private.GetSkipTimer( minigame_name ), skip_multiplier or 1 );

    return result;

  end;
  -------------------------------------------------------------------------------------
  function public.MiniGameHide( minigame_name )
    
    minigame_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    local result = false;

    local event_name = "win_"..minigame_name;

    if  (     cmn.IsEventStart( event_name ) )
    and ( not cmn.IsEventDone( event_name )  )
    then
    
      --private.SetSkipTimer( minigame_name, interface.ButtonSkipGetTime() );

      interface.ButtonInfoHide();
      interface.ButtonResetHide();

      result = true;

    end;

    return result;

  end;
--***************************************************************************************************************