-- name=rm_menu
--******************************************************************************************
function public.Init()

  ObjSet("menu_but_play", 
  {
    event_mdown = private.PlayDown,
    event_menter = function () private.ButtonMouseEnter('play'); end,
    event_mleave = function () private.ButtonMouseLeave('play'); end
  });
  
  ObjSet("menu_but_options", 
  {
    event_mdown = private.OptionsDown
  });
  ObjSet("menu_but_moregames", 
  {
    event_mdown = private.MoregamesDown
  });
  ObjSet("menu_but_profile", 
  {
    event_mdown = private.ProfileDown
  });
  
  private.but_play_pos = { 790, 672 };
  private.but_play_shown = false;
  public.playing_main_theme = false;
  
    
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_forum", { event_mdown = private.ForumDown });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
  
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown,
    event_menter = function() private.ButMouseEnter( "unlock" ); end,
    event_mleave = function() private.ButMouseLeave( "unlock" ); end
    });
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end,
    event_menter = function() private.ButMouseEnter( "close_gear" ); end,
    event_mleave = function() private.ButMouseLeave( "close_gear" ); end
    });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end,
    event_menter = function() private.ButMouseEnter( "gear" ); end,
    event_mleave = function() private.ButMouseLeave( "gear" ); end 
    });
  ObjSet( "menu_but_extra", 
  {
    event_mdown = function() private.ExtraDown(); end--,
    --event_menter = function() private.ButMouseEnter( "extra" ); end,
    --event_mleave = function() private.ButMouseLeave( "extra" ); end 
  } );
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
  if (port.ios_lang()=="ja") then
    ObjSet("txt_menu_but_sequel",{ scale_x = 0.9, scale_y = 0.9 });
  end;
end;

--******************************************************************************************
function private.ButMouseEnter(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1.1, scale_y = 1.1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1.1, scale_y = 1.1 }); 
  end;
end;
--******************************************************************************************
function private.ButMouseLeave(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1, scale_y = 1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1, scale_y = 1 }); 
  end;
end;
--******************************************************************************************
local wait_gear;
public.sub_menu_active = false;
--******************************************************************************************
function public.closeGearSubMenu()
  public.sub_menu_active = false;
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
end;
--******************************************************************************************
function public.openGearSubMenu()
  port.TapDownTimer(0.5,
    function() 
      public.sub_menu_active = true;
      ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
      private.ButMouseLeave("gear");
    end
  );
  
end;
--******************************************************************************************
function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
--fix
function public.PreClose()
  ObjSet( "tmr_gear",{ playing = 0 });
end;
--******************************************************************************************
function public.PreOpen()
  
  if IsCollectorsEdition() then
    ObjMultiSet( { {"menu_ce_buttons", { active = true, visible = true, input = true }},
                   {"spr_menu_logo_ce", { alp = 1 }} } );
  else
    ObjMultiSet( { {"menu_ce_buttons", { active = false, visible = false, input = false }},
                   {"spr_menu_logo_ce", { alp = 0 }} } );

    if not IsSurveyEdition() then
      
      ObjSet("menu_but_strguide",  { active = false, visible = false, input = false });

      --убираем иконки CE из хелпа
      ObjMultiSet( { {"obj_dialog_help_common", { pos_y = 60 }},
                     {"obj_dialog_help_ce", { visible = false }} } );
                     
    --else 
    -- 
    --  ObjMultiSet( { {"obj_dialog_help_counter", { visible = false }},
    --                 {"obj_dialog_help_flower", { visible = false }},
    --                 {"obj_dialog_help_common", { pos_y = 20 }},
    --                 {"obj_dialog_help_ce", { pos_y = 50 }} } );

    end;

  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
    
    iOS_LogEvents(2);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if port.isTablet() == 0 then
      if preformance_warning == 0 then
        preformance_warning = 1;
        ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 2, playing = 1 });
      end;
    end;
      
    

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
  
end;
--******************************************************************************************
function public.Open()

  ng_global.currentprogress = "std";

  cmn.StopAllEnv("assets/levels/common/audio/aud_mainmenu_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_mainmenu_env");

  --if (IsCollectorsEdition() or IsSurveyEdition()) and rm_achievements.in_rm_acievements then
  --  rm_achievements.in_rm_acievements = false;
  --else
  --  cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_surf8_main_mus", 1 );
  --end;

  if not public.playing_main_theme then
    public.playing_main_theme = true;
    cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_maintheme1_mus", 1 );
  end;

  if ng_global.progress
  and ng_global.progress[ "std" ].common.gamewin == true
  and ng_global.progress[ "ext" ].common.gamewin == false
  and not ng_global.gamewin_dialog
  and IsCollectorsEdition() then

    cmn.DialogWindowShow( "common", "bonus_level" );

    ng_global.gamewin_dialog = true;

  end;

  if ng_global.progress
  and ng_global.progress[ "ext" ].common.gamewin == true
  and not ng_global.gamewin_dialog_ext
  and IsCollectorsEdition() then

    cmn.DialogWindowShow( "common", "bonus_level_win" );

    ng_global.gamewin_dialog_ext = true;

  end;
  
  if IsCollectorsEdition() or IsSurveyEdition() then
    common_impl.CreateMenuProgress( "secret" );
  end;
  
  --if not private.but_play_shown then
  --  private.AnimButtonPlay();
  --end;

end;
--**************IOS****************************************************************************
function private.PerformanceWarning()
  if tostring(GetPlatform()) == "ios" then
    iOS_PerformanceWarning();
  else
    DbgTrace("SetPerformanceMode(1)");
    SetPerformanceMode(1);
  end;
end;
--***************IOS***************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--**************IOS****************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-----------------IOS--------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--*************************************ios*****************************************************
function private.Save50Down()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  port.TapDownTimer(0.5,
    function()
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
      common.MenuUnlock();
    end
   );
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  iOS_LaunchForum();
end;
--******************************************************************************************
--******************************************************************************************
function public.SetProfileText ( name )
  
  local obj = "txt_menu_but_profile";
  local profile_name = "";
  if  ( name ~= "ng_noprofiles" )
  and ( name ~= "ng_error" )
  then
  profile_name = name;
  end;
  ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PlayDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuPlay();
end;
--******************************************************************************************
function private.OptionsDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuOptions();
end;
--******************************************************************************************
function private.CreditsDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuCredits();
end;
--******************************************************************************************
function private.QuitDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuQuit();  
end;
--******************************************************************************************
function private.ExtraDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  private.ButMouseEnter( "extra" );
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave( "extra" );
      if port.isPortable() == 1 then
        if iOS_IsBought() == 1 then
          common.MenuExtra();
        else
          common.MenuUnlock();
        end;
      else
        common.MenuExtra();
      end;
    end
    );   
end;
--******************************************************************************************
function private.AchDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common_impl.go_acievements = true;
  common.MenuAchievements();
end;
--******************************************************************************************
function private.StrguideDown()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  if IsCollectorsEdition() then
    interface.StrategyGuideShow();
  else
    local url = GetUrl();
    OpenBrowser( url );
  end;

end;
--******************************************************************************************
function private.MoregamesDown()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  iOS_MoreGamesPressed();
  --cmn.GotoRoom( "rm_moregames" );

end;
--******************************************************************************************
function private.ProfileDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuProfile();
end;
--******************************************************************************************
function private.ShopDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.MenuShop();
end;
--******************************************************************************************
function private.HelpDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  common.DialogWindowShow("help", nil, true);
end;
--******************************************************************************************
function private.ButtonMouseEnter( but_name )

  SetCursor( CURSOR_HAND );
  
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( common_impl.animtime * ( 1 - alp ) );
  
  if tme > 0.13 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
  end;
  
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp,  tme, 0, 1 } );
  --ObjAnimate( obj.."_back", "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave( but_name )

  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  --ObjAnimate( obj.."_back", "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function public.ButtonSetPos()
  local offwidth = 0.5 * ( GetAppWidth() - 1024 );
  ObjSet( "menu_objects_left",  { pos_x = ( 512 - offwidth ) } );
  ObjSet( "menu_objects_right", { pos_x = ( 512 + offwidth ) } );
end;
--******************************************************************************************
function private.AnimButtonPlay()
  
  private.but_play_shown = true;
  
  local func_after = function ()
    ObjSet("menu_but_play",  { input = 1 });
  end;
  
  ObjAnimate("menu_but_play", "pos_y", 0, 0, func_after, { 0, 2, private.but_play_pos[1],   0.7, 2, private.but_play_pos[2] });
  
end;
--******************************************************************************************
--******************************************************************************************
