-- name=int_button_reset
--******************************************************************************************
function public.Init( pos_z )

  interface.LoadImplementation( "button_reset" );
  ObjAttach( "int_button_reset", interface.originhub );
  ObjSet( "int_button_reset", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  private.event_anim_end = {};

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show()

  ObjSet( "int_button_reset", { active = true, visible = true } );

  local event_id = "show";
  private.event_anim_end[ event_id ] = {};
  int_button_reset_impl.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide()

  ObjSet( "int_button_reset", { input = false } );

  local event_id = "hide";
  private.event_anim_end[ event_id ] = {};
  int_button_reset_impl.HideAnim( event_id );

end;
--******************************************************************************************
function public.EventAnimEnd( event_id )

  local event_params = private.event_anim_end[ event_id ];

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "int_button_reset", { input = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "int_button_reset", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;
  
end;
--******************************************************************************************
function public.MouseDown()
    
  MsgSend( Event_ButtonReset_Click, {} );
    
end;
--******************************************************************************************
function private.WideScreenUpdate()

  interface.WideScreenUpdate( "button_reset" );

end;
--******************************************************************************************