-- name=common
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Start( point, param )

  local t = ne.GetTestMode();
  --DbgTrace("t = "..tostring(t));

  local cinfo = ng.GetConfigInfo("notEngine.test_bot");
  --DbgTrace("cinfo = "..tostring(cinfo));

  ne.SetTestMode(0);
  --ne.SetTestMode(1, 2.0);
  

   StringLoad("assets/strings");
   StringLoad("assets/strings_ce");
   
   if tostring(GetPlatform()) == "android" then
     need_download_obb = ObbInit();
   MsgSubscribe( Event_ObbDownloadCompleted, private.DownloadIsComplete );
     DbgTrace("public.Start need_download_obb = "..tostring(need_download_obb));
     if ( need_download_obb == "download" ) then
   
       ObjAttach("spr_common_loading","ng_level_internal");
       ObjSet("spr_common_loading", { input = 1, visible = 1, active = 1, alp = 1 });
       iOS_EnableMultiTouch(0);
       MsgSend( Command_Level_SetZoom, { zoom = false } );
       --private.LoadingCompleate();
   
     elseif ( need_download_obb  == "ready" ) then
   
       ObjSet("spr_common_loading", { input = 0, visible = 0, active = 0, alp = 0 });
   
       if point == nil and param == nil then
       private.InitEvents();
       private.SubscribeEvents();
       end;
   
       private.Init();
       
       point = point or "menu";
       local path = string.format( "assets/levels/%s/mod_%s", point, point );
       ModLoad( path );  
       _G[ point ].Start( param );
     
   
     elseif ( need_download_obb  == "error" ) then
   
       ObjAttach("spr_common_loading","ng_level_internal");
       ObjSet("spr_common_loading", { input = 1, visible = 1, active = 1, alp = 1 });
       --private.LoadingCompleate();
       
     else
       
       if point == nil and param == nil then
       private.InitEvents();
       private.SubscribeEvents();
       end;
   
       private.Init();
       
       point = point or "menu";
       local path = string.format( "assets/levels/%s/mod_%s", point, point );
       ModLoad( path );  
       _G[ point ].Start( param );
     
   
     end;
   
   else
     
     if point == nil and param == nil then
       private.InitEvents();
       private.SubscribeEvents();
     end;
   
     private.Init();
     
     point = point or "menu";
     local path = string.format( "assets/levels/%s/mod_%s", point, point );
     ModLoad( path );  
     _G[ point ].Start( param );
     
   end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------
function private.DownloadIsComplete( )
  MsgUnsubscribe( Event_ObbDownloadCompleted, private.DownloadIsComplete );
  public.LevelSwitch("menu");
end;
--*********************************************************************************************************************
function private.Init()
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  -- Инициализация хабов
  cmn = {};
  prg = {};
  --------------------------------------------------------------------
  --cmn.is_inmenunow = nil;
  --------------------------------------------------------------------
  cmn.progress_types = { "std", "ext" };
  cmn.gamemode_types = { "casual", "advanced", "hardcore" };
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  ModLoad( "assets/shared/mod_room" );
  room.Init();

  ModLoad( "assets/shared/mod_subroom" );
  subroom.Init();

  ModLoad( "assets/shared/interface/mod_interface" );
  interface.Init();

  ModLoad( "assets/levels/common/mod_common_impl" );
  common_impl.Init();

  private.InitSubscribers();
  --------------------------------------------------------------------
  ObjCreate( "cmn_timers", "obj" );
  ObjAttach( "cmn_timers", "ng_level_internal" );
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  -- настройка вывода в лог
  if IsCheater() and IsEditor() then
    private.logtrace_enabled = { 1, 0, 1, 1, 1 };
  end;
  private.is_enabled_show_window = true;

  --------------------------------------------------------------------
  function cmn.IsPC ()

    return ( GetPlatform() ~= "ios" and GetPlatform() ~= "android" );

  end;
  --------------------------------------------------------------------
  function cmn.GetScreenSize ()

    return private.screenSize;

  end;
  --------------------------------------------------------------------
  function cmn.GetGameFieldSize ()

    return private.gameFieldSize;

  end;
  --------------------------------------------------------------------
  function cmn.CorrectCoords ( params )

    local screen_size = cmn.GetScreenSize();
    local field_size  = cmn.GetGameFieldSize();

    local corr_k = { x = screen_size.w / field_size.w, y = screen_size.h / field_size.h };

    if not ( params ) then

      return nil;

    elseif ( #params == 0 ) then

      params.pos_x = params.pos_x * corr_k.x;
      params.pos_y = params.pos_y * corr_k.y;

      return params;

    else

      return { params[ 1 ] * corr_k.x, params[ 2 ] * corr_k.y };

    end;
    
  end;

  --------------------------------------------------------------------
  function cmn.CorrectCoordsTutorial ( pos )

    local screen_size = cmn.GetScreenSize();
    local field_size = cmn.GetGameFieldSize();
    local coords = { pos_x = pos[1], pos_y = pos[2] };

    local sc = { x = screen_size.w/field_size.w, y = screen_size.h/field_size.h };

    local scale = 1;

    if ( coords.pos_x < ( field_size.w / 2 ) ) then

      --scale = field_size.w / screen_size.w;
      scale = 1 - ( sc.x - 1 );

    else

      --scale = screen_size.w / field_size.w;
      scale = sc.x;

    end;
    --DbgTrace(" scale_x= "..scale);
    coords.pos_x = coords.pos_x * scale;


    if ( coords.pos_y < ( field_size.h / 2 ) ) then

      --scale = field_size.h / screen_size.h;
      scale = 1 - ( sc.y - 1 );

    else

      --scale = screen_size.h / field_size.h;
      --scale = 1 - ( sc.y - 1 );
      scale = sc.y;

    end;
    --DbgTrace(" scale_y= "..scale);
    coords.pos_y = coords.pos_y * scale;

    return { coords.pos_x, coords.pos_y };

  end;
  --------------------------------------------------------------------
  function cmn.GetInterfaceScale ()

    return  private.interfaceScale
    
  end;
  --------------------------------------------------------------------
  function cmn.CorrectInterfaceScale ( params )

    local screen_size = cmn.GetScreenSize();
    local field_size  = cmn.GetGameFieldSize();
    local scr_scales      = { x = screen_size.w/field_size.w, y = screen_size.h/field_size.h };
    local int_scale   = cmn.GetInterfaceScale();

    params.scale_x = ( params.scale_x/scr_scales.x )*int_scale;
    params.scale_y = ( params.scale_y/scr_scales.y )*int_scale;

    return params;

  end;

  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function private.SetScreenSize ()

    DbgTrace("[SetScreenSize] "..tostring(GetPlatform()));
    private.screenSize = GetScreenSize();
    DbgTrace("[SetScreenSize] private.screenSize.w = "..tostring(private.screenSize.w));
    DbgTrace("[SetScreenSize] private.screenSize.h = "..tostring(private.screenSize.h));

  end;
  --------------------------------------------------------------------
  function private.SetInterfaceScale ()

    local screen_size = cmn.GetScreenSize();
    local field_size  = cmn.GetGameFieldSize();
    local scr_scales  = { x = screen_size.w / field_size.w, y = screen_size.h / field_size.h };

    local scale = scr_scales.x;

    if scr_scales.x > scr_scales.y then

      scale = scr_scales.y;

    end;

    private.interfaceScale = scale;

  end;
  --------------------------------------------------------------------
  function private.SetGameFieldSize ()

    local game_size = { w = 1024, h = 768 };

    private.gameFieldSize = game_size;

  end;
  --------------------------------------------------------------------
  private.SetGameFieldSize();
  private.SetScreenSize();
  private.SetInterfaceScale();

end;
--*********************************************************************************************************************
--***function *** Common *** () end************************************************************************************
--*********************************************************************************************************************
  --------------------------------------------------------------------
  -- возвращает имя объекта без префикса
  --------------------------------------------------------------------
  function public.GetObjectName( object )

    local underscore = string.find( object, "_" );
    local name = nil;

    if ( underscore ) then
      name = string.sub( object, ( underscore + 1 ) );
    end;

    return name;

  end;
  --------------------------------------------------------------------
  -- возвращает префикс объекта
  --------------------------------------------------------------------
  function public.GetObjectPrefix( object )

    local underscore = string.find( object, "_" );
    local prefix = nil;

    if ( underscore ) then
      prefix = string.sub( object, 1, ( underscore - 1 ) );
    end;

    return prefix;

  end;
  --------------------------------------------------------------------
  -- условная операция
  --------------------------------------------------------------------
  function public.ConditionChoose( condition, value1, value2 )
    if ( condition ) then
      return value1;
    else
      return value2;
    end;
  end;
  --------------------------------------------------------------------
  -- получение всех параметров объекта кроме имени
  --------------------------------------------------------------------
  function public.GetObjParamsForSet( object )
    local params = ObjGet( object );
    if params then
      params.name = nil;
    end;
    return params;
  end;
  --------------------------------------------------------------------
  function public.LogTrace( logtrace_type, logtrace_text )

    local logtrace = { 
      unknown = 1,
      info    = 2,
      message = 3,
      warning = 4,
      error   = 5
    };

    if ( private.logtrace_enabled ) then

      if ( type( logtrace_type ) == "string" ) and ( not logtrace_text ) then

      logtrace_text = logtrace_type;
      logtrace_type = 1;

      end;

      if ( private.logtrace_enabled[ logtrace_type ] == 1 ) then

      local message = "";

      if ( logtrace_type == logtrace.unknown ) then

        message = "[ cmn.UNKNOWN ]";
      
      elseif ( logtrace_type == logtrace.info ) then

        message = "[ cmn.INFO ]   ";

      elseif ( logtrace_type == logtrace.message ) then

        message = "[ cmn.MESSAGE ]";

      elseif ( logtrace_type == logtrace.warning ) then

        message = "[ cmn.WARNING ]";

      elseif ( logtrace_type == logtrace.error ) then

        message = "[ cmn.ERROR ]  ";

      end;

      message = message.." || "..logtrace_text;
    
      DbgTrace( message );

      end;

    end;

  end;
  --------------------------------------------------------------------
  -- применение в зз
  --------------------------------------------------------------------
  function public.ApplyObj( objname, toobjname )
    local currentroom = GetCurrentRoom();
    if public.IsInSubRoom() then
      currentroom = public.GetCurrentSubRoom();
    end;
    return ApplyObj( objname, toobjname, currentroom );
  end;
--*********************************************************************************************************************
--***function *** Room - Subroom *** () end****************************************************************************
--*********************************************************************************************************************
  function public.GotoRoom( room_object, need_fade, dontsave )

    local room_current = GetCurrentRoom();

    if  ( not cmn.is_inmenunow )
    and ( not dontsave )
    then

      if not ( "zz" == public.GetObjectPrefix( room_current ) ) then

        private.previousroom = room_current;

      else

        private.previousroom = private.currentroom;

      end;

      private.currentroom = room_object;

      local prg = ng_global.currentprogress;

      ng_global.progress[ prg ].common.currentroom = room_object;

      public.CallRoomEventHandlers( room_object );

    end;
    
    interface.CheaterUpdateRoom( room_object );

    need_fade = need_fade or 1;

    --public.SetMultiTouch(room_object);
    --DbgTrace  ("GOTOROOM")
    --port. fix 
    if port.isPortable() == 1 then 
      port.GrmLightOn(room_object); 
      port.VideoResizeInRoom(room_object);
      MsgSend( Command_Level_ResetZoomHO );
      port.Scale( 1, room_object );

      if port.active_popup == true then
        port.active_popup = false;
        interface.PopupHide();
      end;
    end;
    
    common_impl.GotoRoom( room_object, need_fade, dontsave );

    room.Switch( room_object, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GetCurrentRoom()

    return private.currentroom;

  end;
  --------------------------------------------------------------------
  function public.GetPrevRoom()

    return private.previousroom;

  end;
  --------------------------------------------------------------------
  function public.SetPreviousRoom( room )

    private.previousroom = room;

  end;
  --------------------------------------------------------------------
  function public.GotoStartRoom( room_name )

    local room_name_saved = ng_global.progress[ ng_global.currentprogress ].common.currentroom or room_name;
    
    public.GotoRoom( room_name_saved, 0 );

  end;
  --------------------------------------------------------------------
  function public.GotoSubRoom( zz_object, pos_beg, pos_end )

    if game.zz_end_pos and game.zz_end_pos[ zz_object ] then
      pos_end = game.zz_end_pos[ zz_object ];
    else 
      pos_end = pos_end or { 512, 384 };
    end;

    local room_current = GetCurrentRoom();

    if ( "zz" == public.GetObjectPrefix( room_current ) ) then
      
      private.previous_zz = room_current;

    end;

    cmn.current_zz = zz_object;

    interface.CheaterUpdateSubroom( zz_object );

    local zz_params = ObjGet( zz_object );

    pos_beg = pos_beg or GetZoomCursorPos();

    pos_end = pos_end or { zz_params.pos_x, zz_params.pos_y };

    public.SetMultiTouch(zz_object);

    MsgSend( Command_Level_ResetZoomHO );
  
  --port. fix 
    if port.isPortable() == 1 then 
      port.TapDown(0.5);
      port.Scale( 0 );
      if port.active_popup == true then
        port.active_popup = false;
        interface.PopupHide();
      end;
    end;
  
    common_impl.GotoSubRoom( zz_object, pos_beg, pos_end );

    subroom.Open( zz_object, { x = pos_beg[ 1 ], y = pos_beg[ 2 ] }, { x = pos_end[ 1 ], y = pos_end[ 2 ] } );

  end;
  --------------------------------------------------------------------
  function public.IsInSubRoom()

    return public.GetCurrentSubRoom() ~= nil;

  end;
  --------------------------------------------------------------------
  function public.CloseSubRoom()
  
  --port. fix 
    if port.isPortable() == 1 then 
      port.TapDown(0.5);
      port.Scale( 1 );
      if port.active_popup == true then
        port.active_popup = false;
        interface.PopupHide();
      end;
    end;
    
    cmn.current_zz = nil;
    subroom.Close();

  end;
  --------------------------------------------------------------------
  function public.GetCurrentSubRoom()

    return cmn.current_zz;

  end;
  --------------------------------------------------------------------
  function public.GetPrevSubRoom()

    return private.previous_zz;

  end;
--*********************************************************************************************************************
--***function *** Cursor *** () end************************************************************************************
--*********************************************************************************************************************
  private.cursors_count = 0;
  --------------------------------------------------------------------
  function public.CursorLoad( cur_name, cur_path, cur_idx )

    _G[ cur_name ] = private.cursors_count;
    CursorLoad( cur_path, cur_idx );
    private.cursors_count = private.cursors_count + 1;

  end;
--*********************************************************************************************************************
--***function *** Cheater *** () end***********************************************************************************
--*********************************************************************************************************************
  private.cheater_key_f = {};
  --------------------------------------------------------------------
  function public.SetCheaterKeyF( key_id, level, prg_elem, startroom )

    private.cheater_key_f[ "F"..key_id ] = { level = level, prg_elem = prg_elem, startroom = startroom };

  end;
  --------------------------------------------------------------------
  function private.CheaterReset()

    if IsCheater() then

      if _G[ "cheater" ] then cheater.Destroy(); end;
      ModLoad( "assets/shared/cheater/mod_cheater" );
      cheater.Init();
    
    end;

  end;
--*********************************************************************************************************************
--***function *** Project *** () end***********************************************************************************
--*********************************************************************************************************************
  function public.ProjectSet()

    private.project = {};

    local project_name_id = "window_title";
    if ( IsCollectorsEdition() ) then
      project_name_id = project_name_id.."_ce";
    end;

    private.project.name = StringGet( project_name_id );
    private.project.version = ConfigGetProjectVersion();

    if not ( private.menu.is_fromgame ) then
      private.ProjectVersion();
    end;

    private.CheaterReset();

  end;
  --------------------------------------------------------------------
  function private.ProjectVersion()

    local projectname = private.project.name;
    local projectversion = private.project.version;
    local versiontype = "";

    if ( IsCollectorsEdition() ) then
      versiontype = versiontype.."COLLECTORS ";
    end;

    if ( IsDemoEdition() ) then
      versiontype = versiontype.."DEMO ";
    end;

    if ( IsSurveyEdition() ) then
      versiontype = versiontype.."SURVEY ";
    end;

    if ( IsCheater() ) then
      versiontype = versiontype.."CHEATER ";
    end;

    if ( not versiontype ) then
      versiontype = "NONE ";
    end;

    DbgTrace( "********************************************************************************************" ); 
    DbgTrace( string.format( "Project < %s > version: %s ( %s).", projectname, projectversion, versiontype ) );
    DbgTrace( "********************************************************************************************" ); 

  end;
--*********************************************************************************************************************
--***function *** Settings *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.UpdateGameMode( gamemode )

    --port. fix 
    local realmode = gamemode;
    common_impl.UpdateGameMode( gamemode );
    MsgSend( Command_Interface_UpdateGameMode, { mode = gamemode, realmode = realmode } );
    -- end fix 

  end;
  -------------------------------------------------------------------------------------
  function public.GetGameMode()
    if ng_global.gamemode then return ng_global.gamemode else return 0; end;
  end;
  -------------------------------------------------------------------------------------
  function private.SaveInterfaceTimers()

    local room = GetCurrentRoom();

    local prg_type = ng_global.currentprogress;
    local current_progress = ng_global.progress[ prg_type ];

    local room_type = public.GetObjectPrefix( room );
    if ( room_type == "mg" ) then

      local prg_name = "win_"..public.GetObjectName( room );

      if  ( current_progress[ prg_name ].start == 1 )
      and ( current_progress[ prg_name ].done == 0 )
      then

        current_progress[ prg_name ].skiptimer = interface.ButtonSkipGetTime();
        --DbgTrace( "save skip for < "..prg_name.." > =  "..current_progress[ prg_name ].skiptimer );

      end;

    end;

    current_progress.common.hinttimer = interface.ButtonHintGetTime();
    --DbgTrace( "Save HINT = "..current_progress.common.hinttimer );

    common_impl.SaveInterfaceTimers();

  end;
--*********************************************************************************************************************
--***function *** Sound *** () end*************************************************************************************
--*********************************************************************************************************************
  -- Проигрывание озвучки видео ( стримится ).
  function PlaySfxTrack( path, loop, fade )

    SndPlay( path, "sfx", loop or 0, 0, fade or 0 );

  end;
--*********************************************************************************************************************
--***function *** Check *** () end*************************************************************************************
--*********************************************************************************************************************
  -- функция проверки наличия аудиустройства 
  function private.SoundDeviceCheck()

    public.LogTrace( "[ 2 ] Проверка аудиоустройства.: "..tostring( IsNoSoundDevice() ) );

    private.is_sounddevicechecked = true;

    if ( IsNoSoundDevice() and not private.menu.is_fromgame ) then

      private.is_enabled_show_window = false;
      public.DialogWindowShow( "common", "noaudio" );

      private.ProfileInit();

    else

      private.ProfileSet( GetCurrentProfile() );

    end

  end;
  --------------------------------------------------------------------
  -- функция проверки на автоматическую смену фуллскрина 
  function private.CheckForceFullScreen()

    public.LogTrace( "[ 2 ] Проверка на автоматическую смену фуллскрина." );

    if ( IsForceFullscreen() and not private.menu.is_fromgame ) then

      public.DialogWindowShow( "togglescreen", nil, false );

    else

      private.SoundDeviceCheck();

    end

  end;
  --------------------------------------------------------------------
  private.fps = {};
  private.fps.is_checkdone = false;
  private.fps.time = 1;
  --------------------------------------------------------------------
  -- функция проверки FPS
  function private.fps.Check( is_showagain )

    ObjSet( "tmr_common_fps", { playing = false } );
    ObjDelete( "tmr_common_fps" );

    local is_needtoshow = false;

    if ( ( is_showagain ) or ( not private.fps.is_checkdone ) ) 
      and ( not private.menu.is_fromgame ) then

      is_needtoshow = true;

    end;

--    if  ( cmn.is_inmenunow )
--    and ( GetPerformanceMode() == 0 )
--    and ( GetFPS() < 25 )
--    and ( is_needtoshow )
--    then
--
--      private.fps.is_checkdone = true;
--      public.DialogWindowShow( "common", "fpscheck" );
--
--    end;

    --port. fix
    private.fps.is_checkdone = true;
    
  end;
--*********************************************************************************************************************
--****function *** Dialog *** () end***********************************************************************************
--*********************************************************************************************************************
  function public.DialogWindowShow( dlgname, trgparam, showfromcursor )

    local objname = "wnd_dialog_"..dlgname;
    local pos_beg = { 512, 384 };

    if ( showfromcursor ) then
      pos_beg = GetZoomCursorPos();
    end;

    interface.WindowShow( "assets/levels/common/mod_common_impl", 
                    "common_impl", 
                    objname, 
                    function () public.dialog[ dlgname ].Open( trgparam or "", pos_beg ); end );

  end;
  --------------------------------------------------------------------
  function public.DialogWindowHide( dlgname )

    local objname = "wnd_dialog_"..dlgname;
    interface.WindowHide( objname );

  end;
  --------------------------------------------------------------------
  -- инициализация функций окон
  public.dialog = {};
  --------------------------------------------------------------------
  function public.dialog.ButtonMouseDown( dialog_name, dialog_button, param )

    common_impl.DialogButtonMouseDown( dialog_name, dialog_button, param );
    public.dialog[ dialog_name ].ButtonMouseDown( dialog_button, param );

  end;
  --------------------------------------------------------------------
  function public.dialog.ButtonsSet( dialog_name, t_button_param, index )

    local t_button_name = { "left", "center", "right" };

    for i = 1, #t_button_name do

      local state = t_button_param[ index ][ i ];

      ObjSet( "dialog_"..dialog_name.."_button_"..t_button_name[ i ], 
      { 
        active  = state,
        visible = state,
        input   = state 
      } );

    end;

  end;
--*********************************************************************************************************************
--***function *** - common: () end ************************************************************************************
--*********************************************************************************************************************
  --
  --[[
    МАССИВ СТАНДАРТНЫХ ДИАЛОГОВ
    Формат: ИМЯ_ДИАЛОГА = { left, center, right, trg_open };
    Параметры кнопок ( left, center, right ) - массив из двух элементов,
      первый элемент - текст кнопки, второй элемент - триггер на клик.
      ВАЖНО: триггер должен иметь название "trg_dialog_common_"..DOWNTRGNAME,
      причем в параметре указывается только DOWNTRGNAME.
    Триггер на открытие диалога ( trg_open ).
      ВАЖНО: триггер должен иметь название "trg_dialog_common_"..OPENTRGNAME.."_open",
      причем в параметре указывается только OPENTRGNAME.
  ]]
  --------------------------------------------------------------------
  public.dialog.common = {};
  --------------------------------------------------------------------
  public.dialog.common.buttons =
  {
    -- нет звукового устройства
    noaudio      = { left = nil, center = { text = "ok", func = "NoAudio" }, right = nil },
    -- профиль поврежден
    corrupt      = { left = nil, center = { text = "ok", func = "Corrupt" }, right = nil },
    -- выход из приложения
    quit         = { left = { text = "yes", func = "Quit" }, center = nil, right = { text = "no", func = "Close" } },
    -- поле ввода имени профиля не заполнено
    emptyfield   = { left = nil, center = { text = "ok", func = "Close" }, right = nil },
    -- профиль уже существует
    existprofile = { left = nil, center = { text = "ok", func = "Close" }, right = nil },
    -- удаление профиля
    delprofile   = { left = { text = "yes", func = "DelProfile" }, center = nil, right = { text = "no", func = "Close" } },
    -- сброс прогресса игры
    reset        = { left = { text = "yes", func = "Reset" }, center = nil, right = { text = "no", func = "Close" } },
    -- диалог first playable
    thxplaying   = { left = nil, center = { text = "ok", func = "ThxPlaying" }, right = nil },
    -- проверка производительности 
    fpscheck     = { left = { text = "yes", func = "PerfModeOff" }, center = nil, right = { text = "no", func = "Close" } },

    -- первый вход в secretroom 
    secretroom_first  = { left = nil, center = { text = "ok", func = "Close" }, right = nil },
    -- выход из хо или мг в secretroom 
    secretroom_leave_challenge  = { left = { text = "yes", func = "GoToSecretroom" }, center = nil, right = { text = "no", func = "Close" } },
    --окно вы открыли бонусный уровень
    bonus_level = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно вы прошли бонусный уровень
    bonus_level_win = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно вы не разблокировали соответствующий доп контент (секретрум)
    needmorestars = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно вы не разблокировали соответствующий доп контент (секретрум)
    playhop = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно вы не разблокировали соответствующий доп контент (секретрум)
    playmg = { left = nil, center = { text = "ok", func = "Close" }, right = nil };

    --установка скринсейвера(меню экстра) 
    setscr             = { left = { text = "yes", func = "Setscr" }, center = nil, right = { text = "no", func = "Close" }};
    --установка обоев(меню экстра) 
    setwlp             = { left = { text = "yes", func = "Setwlp" }, center = nil, right = { text = "no", func = "Close" }};
    --сохранение концепт-артов(меню экстра)
    savecart           = { left = { text = "yes", func = "Savecart" }, center = nil, right = { text = "no", func = "Close" }};
    --сохранение музыки(меню экстра)
    savemusic          = { left = { text = "yes", func = "Savemusic" }, center = nil, right = { text = "no", func = "Close" }};
    --окно пройдите основной контент чтобы разблочить игру(меню экстра)
    extgame            = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно бонус контент не доступен в демо-версии(экстра меню) 
    extbonus           = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно бонус контент нельзя сохранять в демо-версии(экстра меню) 
    extbonus2          = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно другие страницы strategy guide не доступны в демо-версии(экстра меню) 
    strategy_guide_disable_item         = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно пройдите игру для разблокировки бонус-контента(экстра меню) 
    extcontent         = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
    --окно приглашения для первого посещения bonus room
    dlg_open_bonusroom = { left = { text = "secretroom_now", func = "goto_secretroom" }, center = nil, right = { text = "secretroom_later", func = "Close" } };
    
    --окно вы хотите скипнуть мг
    skip_confirmation = { left = { text = "yes", func = "skip_mg" }, center = nil, right = { text = "no", func = "Close" } };

  };
  --------------------------------------------------------------------
  function public.dialog.common.Open ( dialog_type )

    public.dialog.common.current = dialog_type;

    ObjSet( "txt_dialog_common", { text = "str_dialog_common_"..dialog_type, visible = true } );

    local buttons = { "left", "center", "right" };

    for i = 1, 3, 1 do

      local button_name = "dialog_common_button_"..buttons[ i ];

      local button_params = public.dialog.common.buttons[ dialog_type ][ buttons[ i ] ];

      if ( button_params ) then

        ObjSet( "txt_"..button_name, { text = "str_common_"..button_params.text } );

        local func = function ()

          public.dialog.ButtonMouseDown( "common", buttons[ i ] );

        end;

        ObjSet( button_name, 
        { 
          event_mdown = func,
          visible = true, 
          input = true 
        } );

      else

        ObjSet( button_name, { event_mdown = "", visible = false, input = false  });

      end;

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.common.Close()

    public.DialogWindowHide( "common" );

  end;
  --------------------------------------------------------------------
  function public.dialog.common.ButtonMouseDown ( button )

    local func_string = public.dialog.common.buttons[ public.dialog.common.current ][ button ].func;

    public.dialog.common[ func_string ]();

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.NoAudio()

    public.dialog.common.Close();

    private.is_enabled_show_window = true;
    private.ProfileSet( GetCurrentProfile() );

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.Corrupt()

    public.dialog.common.Close();
    local profiles = GetProfileList();
    if ( #profiles == 0 ) then
      public.LogTrace( "[ - ] Закрытие диалога < corrupt >: нет профилей." );
      public.DialogWindowShow( "addprofile", "new" );
    else
      private.ProfileSet( GetCurrentProfile() );
    end;

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.DelProfile()

    -- получаем список профилей
    local profiles = GetProfileList();

    -- получаем текущий
    local current = GetCurrentProfile();

    local is_current_selected = false;

    if ( profiles[ public.dialog.profile.current ] == current ) then

      is_current_selected = true;

    end;

    for i = 1, #profiles do
      public.LogTrace( "2 "..profiles[i] );
    end;
    -- удаляем выделенный профиль
    DeleteProfile( profiles[ public.dialog.profile.current ] );

    public.dialog.common.Close();

    -- обновляем после удаления
    local profiles = GetProfileList();
    -- проверяем профили: если нет, выводим создание нового
    if #profiles == 0 then

      public.dialog.addprofile.is_fromdialogprofile = true;
      public.DialogWindowShow( "addprofile", "new", true );

    else

      public.dialog.profile.current = 1;

      if ( not is_current_selected ) then
        
        for i = 1, #profiles, 1 do

          if ( profiles[ i ] == current ) then
          
            public.dialog.profile.current = i;
            break;

          end;

        end;

      end;

      private.ProfileSet( profiles[ public.dialog.profile.current ] );

    end;

    public.dialog.profile.Open();

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.Reset()

    local prg = public.dialog.playchoice.resetprogress;
    local commonsave = ng_global.progress[ prg ].common;

    private.ProgressReset( prg, commonsave );

    SaveProfiles();

    public.dialog.common.Close();
    public.DialogWindowHide( "playchoice" );
    public.DialogWindowShow( "gamemode", "newgame" );

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.PerfModeOff()

    SetPerformanceMode( 1 );
    public.dialog.common.Close();

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.ThxPlaying()

    public.dialog.common.Close();

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.GoToSecretroom()

    public.dialog.common.Close();
    rm_extra.GoToSecretroom_end();

  end;
  --------------------------------------------------------------------
  function public.dialog.common.goto_secretroom()

    public.dialog.common.Close();
    ng_global.secretroom_enter = ng_global.currentprogress;
    common.LevelSwitch( "secretroom" );

  end;
  --------------------------------------------------------------------
  function public.dialog.common.skip_mg()

    public.dialog.common.Close();
    
    local mg_name = GetCurrentRoom();

    if common.IsInSubRoom() then

      local zz_name = common.GetCurrentSubRoom();
      _G[ mg_name ][ zz_name ].Skip();

    elseif interface.GetCurrentComplexInv() ~= "" then

      local cur_chapter_num = string.sub( ng_global.progress[ prg.current ].common.chapter, -1 );
      local inv_name = common.GetObjectName( interface.GetCurrentComplexInv() );
      --local inv_name = interface.GetCurrentComplexInv();

      _G[ "inventory"..cur_chapter_num ][ inv_name ].Skip();

    else 

      _G[ mg_name ].Skip();

    end;

    interface.ButtonSkipReload( 1 );

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.dialog.common.Quit()

    --port. fix for close application
    if tostring(GetPlatform()) == "android" then
      iOS_Exit();
    else
      Quit();
    end;

  end;
  -----------------------функции меню "экстра"------------------------

  function public.dialog.common.Setscr()
    --SetScreensaver( "assets/levels/menu/rm_extra/screensaver/screensaver_"..game.screen_scr.."/surface_alone_in_the_mist_ce.scr");
    SetScreensaver( "assets/levels/menu/rm_extra/screensaver/screensaver/surface_lost_tales_ce.scr");
    public.dialog.common.Close();
  end;
  --------------------------------------------------------------------
  function public.dialog.common.Setwlp()
    
    CopyFileToMyDocs("assets/levels/menu/rm_extra/wallpaper/wall_"..game.wallp_scr);
    public.dialog.common.Close();

  end;
  --------------------------------------------------------------------
  function public.dialog.common.Savecart()

    CopyFileToMyDocs("assets/levels/menu/rm_extra/concept_art/concept_"..game.cart_scr);
    public.dialog.common.Close();

  end;
  --------------------------------------------------------------------
  function public.dialog.common.Savemusic()

    CopyFileToMyDocs("assets/levels/menu/rm_extra/music/soundtrack_"..game.num_track..".mp3");

    public.dialog.common.Close();

  end;
--*********************************************************************************************************************
--***function *** - addprofile: () end*********************************************************************************
--*********************************************************************************************************************
  --------------------------------------------------------------------
  public.dialog.addprofile = {};
  public.dialog.addprofile.is_fromdialogprofile = false;
  --------------------------------------------------------------------
  function public.dialog.addprofile.Open( command )

    public.LogTrace( "addprofile command = "..command );

    local ted_name = "ted_dialog_addprofile";
    local name_player = "PLAYER";
    if port.isPortable() == 1 then

      ObjSet("wnd_dialog_addprofile_keyboard",{ input= 1, visible = 1, active = 1, alp = 1 });
      
      if port.ios_lang() == "ru" then
        name_player = "PLAYER";
      elseif port.ios_lang() == "en" then
        name_player = "PLAYER";
      elseif port.ios_lang() == "fr" then
        name_player = "JOUEUR";
      elseif port.ios_lang() == "de" then 
        name_player = "SPIELER";
      elseif port.ios_lang() == "ja" then 
        name_player = "PLAYER";
      end;
      
      public.dialog.newprofileclick = 1;

    end;
    
    ObjSet( ted_name, { text = name_player, visible = true } );

    local t_button_param = { new = { false, true, false }, add = { true, false, true } };
    public.dialog.ButtonsSet( "addprofile", t_button_param, command );

  end;
  --------------------------------------------------------------------
  function public.dialog.addprofile.Down()
    public.LogTrace( "[ - ] Создание профиля." );
    local profilename = private.ProfileNameTrim( ObjGet( "ted_dialog_addprofile" ).text );

    if ( profilename == "" ) then

      public.LogTrace( "[ - ] Создание профиля: пустое поле." );
      public.DialogWindowShow( "common", "emptyfield", true );

    else

      local profile_exist = false;

      local profilename_low = string.lower( profilename );

      local profile_list = GetProfileList();

      for p = 1, #profile_list do

        if ( string.lower( profile_list[ p ] ) == profilename_low ) then

          profile_exist = true;

          break;

        end;

      end;

      if ( profile_exist ) or ( AddProfile( profilename ) == 0 ) then


        public.LogTrace( "[ - ] Создание профиля: профиль уже существует." );
        public.DialogWindowShow( "common", "existprofile", true );
        
      else

        public.LogTrace( "[ - ] Создание профиля: профиль создан, установка профиля." );

        local profiles = GetProfileList();
        public.dialog.profile.current = #profiles;
        private.ProfileSet( profiles[ public.dialog.profile.current ], true );
        
        if ( public.dialog.addprofile.is_fromdialogprofile ) then
          public.dialog.addprofile.is_fromdialogprofile = false;
          public.dialog.profile.Open();
        end

        public.LogTrace( "[ - ] Создание профиля: закрытие окна." );
        public.dialog.addprofile.Close();

      end
    end

  end
  --------------------------------------------------------------------
  function public.dialog.addprofile.Close()

    public.DialogWindowHide( "addprofile" );

  end;
  --------------------------------------------------------------------
  function public.dialog.addprofile.ButtonMouseDown( button )

    if ( button == "left" ) or ( button == "center" ) then
    
      public.dialog.addprofile.Down();

    elseif ( button == "right" ) then

      public.dialog.addprofile.Close();

    end;

  end;

--*********************************************************************************************************************
--***function *** - - portable_keyboard: () end************************************************************************************
--*********************************************************************************************************************

  ----port.------------------------keyboard----------------------------------------
  function public.dialog.addprofile.ButtonFadeOn(name)
      ObjAnimate(name, 12, 0, 0, "", {0,0,1,1,1,  0.15,0,0.6,0.6,0.6, 0.3,0,1,1,1,});
  end;
  -----------------------------------------------------------------
  function public.dialog.addprofile.ButtonFadeOff()

  end;
  -------------------------------------------------
  function public.dialog.addprofile.ButtonTap(word)
     
      local name = "wnd_dialog_addprofile_"..word;
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
      
      common.dialog.addprofile.ButtonFadeOn( name );

      if public.dialog.newprofileclick == 1 then

        public.dialog.newprofileclick = 0;
        ObjSet("ted_dialog_addprofile", {text = ""});

      end;

      if string.len(ObjGet("ted_dialog_addprofile").text) < 10  then

          local txt;
          if (string.len(ObjGet("ted_dialog_addprofile").text) < 1) then
            txt = ObjGet("ted_dialog_addprofile").text..string.upper(word);
          else
            txt = ObjGet("ted_dialog_addprofile").text..word;
          end;

          ObjSet("ted_dialog_addprofile", { text = txt });
         

      end;
  end;

  ----------------------------------------------------------
  function public.dialog.addprofile.BackspaceTap()

      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
      
      common.dialog.addprofile.ButtonFadeOn("wnd_dialog_addprofile_backspace");

      if public.dialog.newprofileclick == 1 then

        public.dialog.newprofileclick = 0;
        ObjSet("ted_dialog_addprofile", { text = "" });

      end;

      if string.len(ObjGet("ted_dialog_addprofile").text) > 0 then

        local txt = string.sub(ObjGet("ted_dialog_addprofile").text, 0, string.len(ObjGet("ted_dialog_addprofile").text) - 1)   
        ObjSet("ted_dialog_addprofile", { text = txt });
    
      end;

  end;  
--*********************************************************************************************************************
--***function *** - profile: () end************************************************************************************
--*********************************************************************************************************************
  public.dialog.profile = {};
  public.dialog.profile.current = 1;
  public.dialog.profile.profiles_count = 8;
  --------------------------------------------------------------------
  function public.dialog.profile.Open()

    public.LogTrace( "[ - ] Открытие/обновление окна профилей." );
    local profiles = GetProfileList();
    local current_profile = GetCurrentProfile();
    for i = 1, public.dialog.profile.profiles_count, 1 do

      local profile_name = profiles[ i ] or "";
      local profile_input = false;

      if ( profile_name ~= "" ) then

        profile_input = true;

      end;

      ObjSet( "txt_dialog_profile_names_"..i, { text = profile_name, input = profile_input } );
      
      if ( profile_name == current_profile ) then

        public.dialog.profile.current = i;

      end;
      
    end;

    local text_object = "txt_dialog_profile_names_"..public.dialog.profile.current;

    local text_params = ObjGet( text_object );

    ObjSet( "spr_dialog_profile_names_focus",
    { 
      pos_x = text_params.pos_x, 
      pos_y = text_params.pos_y
    } );
    
    if #profiles > ( public.dialog.profile.profiles_count - 1 ) then

      ObjSet( "dialog_profile_button_center", { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5 } );

    else

      ObjSet( "dialog_profile_button_center", { input = true, color_r = 1, color_g = 1, color_b = 1 } );

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.profile.NameDown( place_number )

    local profile_name = "txt_dialog_profile_names_"..place_number;
    public.dialog.profile.current = place_number;

    ObjSet( "spr_dialog_profile_names_focus", { 
        pos_x = ObjGet( profile_name ).pos_x, 
        pos_y = ObjGet( profile_name ).pos_y });

  end;
  --------------------------------------------------------------------
  function public.dialog.profile.OkDown() 

    public.DialogWindowHide( "profile" );

    local profiles = GetProfileList();
    private.ProfileSet( profiles[ public.dialog.profile.current ] );

  end;
  --------------------------------------------------------------------
  function public.dialog.profile.NewDown()
   
    public.LogTrace( "[ - ] Создание нового профиля из окна профиля." );

    public.dialog.addprofile.is_fromdialogprofile = true;
    public.DialogWindowShow( "addprofile", "add", true );

  end;
  --------------------------------------------------------------------
  function public.dialog.profile.DeleteDown()

    public.DialogWindowShow( "common", "delprofile", true );

  end;
  --------------------------------------------------------------------
  function public.dialog.profile.ButtonMouseDown( button, param )

    if ( button == "name" ) then

      public.dialog.profile.NameDown( param );

    elseif ( button == "left" ) then

      public.dialog.profile.OkDown();

    elseif ( button == "center" ) then

      public.dialog.profile.NewDown();
    
    elseif ( button == "right" ) then

      public.dialog.profile.DeleteDown();

    end;

  end;
--*********************************************************************************************************************
--***function *** - playchoice: () end*********************************************************************************
--*********************************************************************************************************************
  public.dialog.playchoice = {};
  public.dialog.playchoice.resetprogress = "";
  --------------------------------------------------------------------
  function public.dialog.playchoice.Open()

    if ( ng_global.progress[ "std" ].common.gamewin and IsCollectorsEdition() ) then

      ObjSet( "obj_dialog_playchoice_std", { pos_x = -226 } );
      ObjSet( "obj_dialog_playchoice_ext", { input = true, visible = true } );

      ObjSet( "spr_dialog_playchoice_std", { visible = false } );
      ObjSet( "spr_dialog_playchoice_ext", { visible = true } );

    else

      ObjSet( "obj_dialog_playchoice_std", { pos_x = 0 } );
      ObjSet( "obj_dialog_playchoice_ext", { input = false, visible = false } );

      ObjSet( "spr_dialog_playchoice_std", { visible = true } );
      ObjSet( "spr_dialog_playchoice_ext", { visible = false } );

    end;

    local prg = { "std", "ext" };
    
    for i = 1, #prg, 1 do

      local currentroom  = ng_global.progress[ prg[i] ].common.currentroom;
      local level = ng_global.progress[ prg[i] ].common.chapter;
      local playchoice_params = 
      { 
        text = "str_dialog_playchoice_continue", 
        res  = "assets/levels/"..level.."/"..( currentroom or "" ).."/miniback",
        input = true
      };  

      if ( not ng_global.progress[ prg[i] ].common.gamestart ) then

        playchoice_params.text  = "str_dialog_playchoice_play";
        playchoice_params.res   = "assets/levels/common/playchoice_"..prg[ i ].."_miniback";
        playchoice_params.input = false;
      
      end;

      ObjSet( "txt_dialog_playchoice_"..prg[ i ].."_button_play",  { text  = playchoice_params.text  } );
      ObjSet( "spr_dialog_playchoice_"..prg[ i ].."_button_reset", { input = playchoice_params.input } );
      ObjSet( "spr_dialog_playchoice_"..prg[ i ].."_miniback",     { res   = playchoice_params.res   } );

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.playchoice.Play( prg )

    public.DialogWindowHide( "playchoice" );

    ng_global.currentprogress = prg;

    if ( not ng_global.progress[ prg ].common.gamestart ) then
      ng_global.progress[ prg ].common.gamestart = true;
    end;

    SetCursor( CURSOR_DEFAULT );
    local level = ng_global.progress[ prg ].common.chapter;
    cmn.is_inmenunow = false;

    local check_paywall = false;
    
    if (iOS_IsBought() == 0) then
      if (ng_global.progress[ "std" ][ "opn_eventhall" ]) then
        if (ng_global.progress[ "std" ][ "opn_eventhall" ].done==1) then
          check_paywall = true;
        end;
      end;
    end;
    
    local func_after = function ()
      public.LevelSwitch( level );
    end;
    
    if check_paywall == true then
      func_after = function ()
        public.LevelSwitch("menu","unlock");
      end;
    end;
    
    common_impl.MenuMorph( func_after );

  end;
  --------------------------------------------------------------------
  function public.dialog.playchoice.Reset( prg )

    public.dialog.playchoice.resetprogress = prg;
    public.DialogWindowShow( "common", "reset", true );

  end;
  --------------------------------------------------------------------
  function public.dialog.playchoice.Close()

    public.DialogWindowHide( "playchoice" );

  end;
  --------------------------------------------------------------------
  function public.dialog.playchoice.ButtonMouseDown( button, param )

    if ( button == "center" ) then

      public.dialog.playchoice.Close();
    
    elseif ( button == "play" ) then

      public.dialog.playchoice.Play( param );

    elseif ( button == "reset" ) then

      public.dialog.playchoice.Reset( param );

    end;

  end;
--*********************************************************************************************************************
--***function *** - gamemode: () end***********************************************************************************
--*********************************************************************************************************************
  public.dialog.gamemode = {};
  ng_global.gamemode = 1;
  --------------------------------------------------------------------
  function public.dialog.gamemode.Open( sender_name )

    local t_button_param = { newgame = { false, true, false }, options = { true, false, true } };
    public.dialog.ButtonsSet( "gamemode", t_button_param, sender_name );

    public.dialog.gamemode.CheckDown( cmn.gamemode_types[ ng_global.gamemode + 1 ] );

  end;
  --------------------------------------------------------------------
  function public.dialog.gamemode.Close( sender_name )

    public.DialogWindowHide( "gamemode" );

    if ( sender_name ~= "right" ) then

      for i = 1, #cmn.gamemode_types do

        local gamemode_type = cmn.gamemode_types[ i ];

        if ( ObjGet( "spr_dialog_gamemode_"..gamemode_type.."_check_light" ).alp == 1 ) then

          ng_global.gamemode = i - 1;
          public.UpdateGameMode( ng_global.gamemode );
          break;

        end;

      end;

    end;

    if ( sender_name == "left" ) then

      public.dialog.options.Open( "gamemode" );

    elseif ( sender_name == "center" ) then

      SetCursor( CURSOR_NULL );
      local prg = ng_global.currentprogress;
      local level = ng_global.progress[ prg ].common.chapter;
      ng_global.progress[ prg ].common.gamestart = true;
      cmn.is_inmenunow = false;

      local func_after = function ()
        public.LevelSwitch( level );
      end;

      common_impl.MenuMorph( func_after );

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.gamemode.ButtonMouseDown( button, param )

    if ( button == "check" ) then

      public.dialog.gamemode.CheckDown( param );

    else

      public.dialog.gamemode.Close( button );

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.gamemode.CheckDown( gamemode_name )

    for i = 1, #cmn.gamemode_types do

      local check_alp = 0;
      local check_fx = 0;

      if ( cmn.gamemode_types[ i ] == gamemode_name ) then

        check_alp = 1;
        check_fx = 1;

      end;
      
      ObjSet("spr_dialog_gamemode_"..cmn.gamemode_types[ i ].."_check_light", { alp = check_alp });

      --ObjMultiSet( { {"spr_dialog_gamemode_"..cmn.gamemode_types[ i ].."_check_light", { alp = check_alp } },
      --               {"fx_dialog_gamemode_"..cmn.gamemode_types[ i ].."_light", { active = check_fx, visible = check_fx } } } );

    end;  
    
  end;
  --------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** - options: () end************************************************************************************
--*********************************************************************************************************************
  public.dialog.options = {};
  public.dialog.options.is_open = false;
  public.dialog.options.slider_width = 160;
  public.dialog.options.slider_offx = 0;
  public.dialog.options.is_slider_startdrag = false;
  public.dialog.options.is_slider_startplay = { mus = false, voc = false, sfx = false, env = false };
  --------------------------------------------------------------------
  function public.dialog.options.Open( sender_name )

    public.dialog.options.is_open = true;

    if port.isPortable() == 1 then
      iOS_LogEvents(3);
      ios_menu_open = 1;
      port.Scale( 0 );
    end;
    
    --DbgTrace("***common.dialog.options.Open: is_open = "..tostring( public.dialog.options.is_open ));

    public.LogTrace( "[ - ] Вызов окна опций из [ "..sender_name.." ]." );

    --ObjSet( "txt_dialog_options_info", { text = GetEngineVersion().."/"..ng_global.project.version } );

    --установка режима сложности
    ObjSet( "txt_dialog_options_button_gamemode_mode", { text = "str_dialog_"..cmn.gamemode_types[ ng_global.gamemode + 1 ] } );

    -- если триггер вызван не из окна режима игры, устанавливаем все объекты
    if ( sender_name ~= "gamemode" ) then

      -- установка кнопок
      local t_button_param = { menu = { false, true, false }, game = { true, false, true } };
      public.dialog.ButtonsSet( "options", t_button_param, sender_name );
      
      -- установка громкости
      local slidertype = { "sfx", "env", "mus", "voc", "gamma" };
      local new_x = 0;
      for i = 1, #slidertype, 1 do

        if ( i == #slidertype ) then
          new_x = ( GetGamma() - 0.5 ) * public.dialog.options.slider_width;
        else
          new_x = GetSoundVolume( public.GetSlideType( slidertype[ i ] ) ) * public.dialog.options.slider_width;      
        end;
        local percent = math.floor( ( new_x * 100 ) / public.dialog.options.slider_width );

        ObjSet(     "dialog_options_"..slidertype[ i ].."_scroll_slider", { pos_x = new_x } );
        ObjSet( "spr_dialog_options_"..slidertype[ i ].."_scroll_slider", { pos_x = new_x } );
        --ObjSet( "txt_dialog_options_"..slidertype[ i ].."_percent", { text = percent.."%" } );

      end

      -- установка курсора и режима экрана
      local t_check_names = { "fullscreen", "widescreen", "cursor", "perfmode" };
      public.dialog.options.CheckSet( t_check_names );

      if ( sender_name == "game" ) then

        if _G[ "int_button_hint" ] then
          int_button_hint_impl.DisableActivityWhenOpenGameOptions();
        end;

        if _G[ "int_button_skip" ] then
          int_button_skip_impl.DisableActivityWhenOpenGameOptions();
        end;

        PauseLevel( 1 );

      end;

    end

    --port.
    if int_dialog_video.GetDialogVideoActive() ~= nil then
      ObjSet("dialog_options_button_credits",{ active = false, visible = false, input = false, alp = 0});
      VidPause(int_dialog_video.GetDialogVideoActive(),1);
      SndPauseAll( true );
    else
      ObjSet("dialog_options_button_credits",{ active = true, visible = true, input = true, alp = 1});
    end;
    
  end;
  --------------------------------------------------------------------
  function public.dialog.options.Close( sender_name )

    public.dialog.options.is_open = false;

    if port.isPortable() == 1 then
       port.Scale( 1 );
    end;
     
    --DbgTrace("***common.dialog.options.Close: is_open = "..tostring( public.dialog.options.is_open ));

    public.LogTrace( "[ - ] Закрытие окна опций: сохранение настроек." );

    SaveProfiles();
    SaveSettings();
    public.DialogWindowHide( "options" );

    local platform = GetPlatform();
    if ( platform == "android" ) or ( platform == "ios" ) then
       if GetCurrentRoom() == "rm_menu" then
          iOS_ManageAds(1);
       end;
    end;

    public.SetMultiTouch(GetCurrentRoom());

    if ( sender_name == "left" ) then

      public.ApplicationClose();

      SetCursor( CURSOR_DEFAULT );
      public.LevelSwitch( "menu", "game" );

    elseif( sender_name == "right" ) then

      if _G[ "int_button_hint" ] then
        int_button_hint_impl.EnableActivityWhenCloseGameOptions();
      end;

      if _G[ "int_button_skip" ] then
        int_button_skip_impl.EnableActivityWhenCloseGameOptions();
      end;

      PauseLevel( 0 );

      common_impl.DialogCustomUpdate();
    
    end;

    --port.
    if int_dialog_video.GetDialogVideoActive() ~= nil then
      VidPause(int_dialog_video.GetDialogVideoActive(),0);
      SndPauseAll( false );  
      PauseLevel( 0 );
    end;
    
  end;
  --------------------------------------------------------------------
  function public.dialog.options.ButtonMouseDown( button, param )

    if ( button == "check" ) then

      public.dialog.options.CheckDown( param );

    elseif ( button == "gamemode" ) then

      public.dialog.options.GameMode();

    else

      public.dialog.options.Close( button );

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.options.CheckSet( t_check_names )

    local check_param = 
    { 
        fullscreen = public.ConditionChoose( GetFullScreen(), 1, 0 ), 
        widescreen = public.ConditionChoose( GetWideScreen(), 1, 0 ),
        cursor     = public.ConditionChoose( GetSysCursor(), 0, 1 ),
        perfmode   = public.ConditionChoose( GetPerformanceMode() == 0, 1, 0 )
    };

    for i = 1, #t_check_names do
      ObjSet( "spr_dialog_options_"..t_check_names[ i ].."_check_light", 
      { 
        alp = check_param[ t_check_names[i] ]
      } );
    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.options.CheckDown( scroll_name )

    --DbgTrace("");
    --DbgTrace("***CheckDown: scroll_name = "..scroll_name);
    
    local check_name = "spr_dialog_options_"..scroll_name.."_check_light";

    local func_get = { fullscreen = GetFullScreen, widescreen = GetWideScreen, cursor = GetSysCursor, perfmode = GetPerformanceMode };
    local func_set = { fullscreen = SetFullScreen, widescreen = SetWideScreen, cursor = SetSysCursor, perfmode = SetPerformanceMode };

    local new_value;
    local new_alp;

    public.dialog.togglescreen.is_changed[ scroll_name ] = true;

    if ( scroll_name == "widescreen" ) then common_dialog_togglescreen_is_changed_widescreen = true; end; --костыль
    --DbgTrace("[1]common_dialog_togglescreen_is_changed_widescreen = "..tostring( common_dialog_togglescreen_is_changed_widescreen ) );
    --DbgTrace("[1]public.dialog.togglescreen.is_changed[ 'widescreen' ] = "..tostring( public.dialog.togglescreen.is_changed[ "widescreen" ] ) );

    if ( scroll_name == "perfmode" ) then

      new_value = public.ConditionChoose( func_get[ scroll_name ]() == 0, 1, 0 );
      
      func_set[ scroll_name ]( new_value );

      new_alp = func_get[ scroll_name ]();

      private.fps.Check( true );

    else
      
      new_value = not func_get[ scroll_name ]();

      func_set[ scroll_name ]( new_value );

      new_alp = public.ConditionChoose( func_get[ scroll_name ](), 1, 0 );

    end;

    if ( scroll_name == "cursor" ) or ( scroll_name == "perfmode" ) then

      new_alp = public.ConditionChoose( new_alp == 1, 0, 1 );

    end;

    public.dialog.togglescreen.is_changed[ scroll_name ] = false;

    if ( scroll_name == "widescreen" ) then common_dialog_togglescreen_is_changed_widescreen = false; end; --костыль
    --DbgTrace("[3]common_dialog_togglescreen_is_changed_widescreen = "..tostring( common_dialog_togglescreen_is_changed_widescreen ) );
    --DbgTrace("[3]public.dialog.togglescreen.is_changed[ 'widescreen' ] = "..tostring( public.dialog.togglescreen.is_changed[ "widescreen" ] ) );

    ObjSet( check_name, { alp = new_alp } );

  end;
  --------------------------------------------------------------------
  function public.dialog.options.ScrollDown( scroll_name )

    -- позиция объекта относительно главного объекта
    local slider_objname = "dialog_options_"..scroll_name.."_scroll_slider";
    local obj_x = GetObjPosByObj( "spr_"..slider_objname )[ 1 ];
    
    local cur_x = GetZoomCursorPos()[ 1 ];
    local off_x = cur_x - obj_x;

    local new_x = ObjGet( "spr_"..slider_objname ).pos_x + off_x;

    if ( new_x < 0 ) then new_x = 0; end;
    if ( new_x > public.dialog.options.slider_width ) then new_x = public.dialog.options.slider_width; end;

    ObjSet( slider_objname, { pos_x = new_x });

    public.dialog.options.ScrollSet( scroll_name, new_x );

  end;
  --------------------------------------------------------------------
  function public.dialog.options.ScrollDrag( scroll_name )

    SetCursor( CURSOR_HAND );

    local cur_pos = GetZoomCursorPos();

    if ( not public.dialog.options.is_slider_startdrag ) then
      public.dialog.options.is_slider_startdrag = true;
      local obj_x = ObjGet( "dialog_options_"..scroll_name.."_scroll_slider" ).pos_x;
      public.dialog.options.slider_offx = cur_pos[ 1 ] - obj_x;
    end;

    local new_x = cur_pos[ 1 ] - public.dialog.options.slider_offx;

    if ( new_x < 0 ) then new_x = 0; end;
    if ( new_x > public.dialog.options.slider_width ) then new_x = public.dialog.options.slider_width; end;

    public.dialog.options.ScrollSet( scroll_name, new_x );
    public.dialog.options.ScrollPlaySound( scroll_name );

  end;
  --------------------------------------------------------------------
  function public.dialog.options.ScrollDrop( scroll_name )

    -- драг завершен
    public.dialog.options.is_slider_startdrag = false;

    local new_x = ObjGet( "spr_dialog_options_"..scroll_name.."_scroll_slider" ).pos_x;
    local new_y = ObjGet( "spr_dialog_options_"..scroll_name.."_scroll_slider" ).pos_y;

    -- возвращаем drag-объект в позиции слайдера
    ObjSet( "dialog_options_"..scroll_name.."_scroll_slider", { pos_x = new_x, pos_y = new_y });

    public.dialog.options.ScrollSet( scroll_name, new_x );
    public.dialog.options.ScrollStopSound( scroll_name );

  end;
  --------------------------------------------------------------------
  function public.dialog.options.ScrollSet( scroll_name, new_x )

    local percent = math.floor( ( new_x * 100 ) / public.dialog.options.slider_width );
    --ObjSet( "txt_dialog_options_"..scroll_name.."_percent", { text = percent.."%" } );
    ObjSet( "spr_dialog_options_"..scroll_name.."_scroll_slider", { pos_x = new_x } );

    if ( scroll_name == "gamma" ) then
      SetGamma( ( new_x / public.dialog.options.slider_width ) + 0.5 );
    else
      SetSoundVolume( public.GetSlideType( scroll_name ), ( new_x / public.dialog.options.slider_width ) );
    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.options.ScrollPlaySound( scroll_name )

    local path = "assets/levels/common/ad_temp_"..scroll_name;
    local trgafter = "*public.dialog.options.ScrollStopSound('"..scroll_name.."');";

    if ( not public.dialog.options.is_slider_startplay[ scroll_name ] and scroll_name ~= "gamma" ) then

      if ( scroll_name == "voc" ) then
        PlayVoice( path, 0, trgafter, 0 );

      elseif ( scroll_name == "sfx" ) then
        PlaySfx( path, 0, trgafter, 0 );

      elseif ( scroll_name == "mus" ) then
        PlaySoundtrack( path, 0, trgafter, 0 );

      elseif ( scroll_name == "env" ) then
        PlayEnv( path, 0, trgafter, 0 );

      end 
      public.dialog.options.is_slider_startplay[ scroll_name ] = true;

    end;

  end;
  --------------------------------------------------------------------
  function public.dialog.options.ScrollStopSound( scroll_name )

    public.dialog.options.is_slider_startplay[ scroll_name ] = false;
    local path = "assets/levels/common/ad_temp_"..scroll_name;
    SndStop( path );

  end;
  --------------------------------------------------------------------
  function public.dialog.options.GameMode()

    public.DialogWindowShow( "gamemode", "options", true );

  end;
  --------------------------------------------------------------------
  function public.GetSlideType( type )

    local types = {};

    types[ "mus" ]   = "soundtrack";
    types[ "env" ]   = "env";
    types[ "sfx" ]   = "sfx";
    types[ "voc" ]   = "voice";
    types[ "gamma" ] = "gamma";

    return types[ type ];

  end;
--*********************************************************************************************************************
--***function *** -  - portable_options: () end*******************************************************************************
--*********************************************************************************************************************
  
  ---------port.---------------------portable_options--------------------------------------
  function public.dialog.options.TermsDown()
    --DbgTrace( "push iOS_Terms" );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
    iOS_Terms();

  end;
  --------------------------------------------------------------------
  function public.dialog.options.SupportDown()
    --DbgTrace( "push iOS_Support" );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
    iOS_Support();

  end;
  --------------------------------------------------------------------
  function public.dialog.options.PolicyDown()
    --DbgTrace( "push iOS_Policy" );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
    iOS_Policy();

  end;
--*********************************************************************************************************************
--***function *** - togglescreen: () end*******************************************************************************
--*********************************************************************************************************************
  --------------------------------------------------------------------
  public.dialog.togglescreen = {};
  public.dialog.togglescreen.is_changed = {};
  --DbgTrace("[0]public.dialog.togglescreen.is_changed[ 'widescreen' ] = "..tostring( public.dialog.togglescreen.is_changed[ "widescreen" ] ) );
  --------------------------------------------------------------------
  function public.dialog.togglescreen.Close()

    public.DialogWindowHide( "togglescreen" );

    if ( cmn.is_inmenunow and not private.is_sounddevicechecked ) then

      private.SoundDeviceCheck();

    end
   
  end
  --------------------------------------------------------------------
  function public.dialog.togglescreen.Open( msg_type )

    local textid = "str_dialog_fullscreen";

    if ( msg_type == "wide" ) then
      
      textid = "str_dialog_widescreen";

    end;

    ObjSet( "txt_dialog_togglescreen", { text = textid } );

  end
  --------------------------------------------------------------------
  function public.dialog.togglescreen.ButtonMouseDown( button )

    if ( button == "center" ) then

      public.dialog.togglescreen.Close();

    end;

  end;
--*********************************************************************************************************************
--**function *** Level *** () end**************************************************************************************
--*********************************************************************************************************************
  function public.LevelSwitch( level, param )

    int_pause.Destroy();

    local trig = "";

    if ( param ) then

      trig = string.format( "common.Start('%s','%s');", level, param );

    else

      trig = string.format( "common.Start('%s');", level );

    end;

    MsgSend(Command_Level_CanShowLoading, { visible = true });

    int_loading_impl.CheckLevel(level);
    SwitchLevel( "assets/shared/mod_common", trig, 1 );

  end;
  --------------------------------------------------------------------
  -- функция загрузки и инициализации модулей уровня, инициализации и загрузки прогресса
  function public.LevelLoad( level, prg_type, start_room, key_f_id )

    int_loading_impl.CheckLevel(level);
    -- Загрузка и инициализация модулей локаций.
    private.InitLevelModules( level );

    -- Загрузка прогресса. Сейв должен существовать.

    if not ( LoadCurrentProfile() ) then

      DbgTrace( "FATAL ERROR!!! Save doesn't exist!" );

    else

      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      -- В сейве на момент загрузки уровня существует таблица "ng_global.progress[ prg_type ].common".

      public.UpdateGameMode( ng_global.gamemode );

      ng_global.currentprogress = prg_type;

      ng_global.progress[ prg_type ].common.chapter = level;

      local current_progress = ng_global.progress[ prg_type ];

      interface.InventoryAutoHideLoad();

      interface.ButtonHintReload( current_progress.common.hinttimer );
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      
      -- Переход по читу: отмечаем выполненным до указанного.
      if ( key_f_id ) then

        current_progress.common.currentroom = private.cheater_key_f[ "F"..key_f_id ].startroom;

        local done = 0;

        local breakpoint = private.cheater_key_f[ "F"..key_f_id ].prg_elem;

        if ( breakpoint ) then

          done = 1;

        end;

        for i = 1, #game.progress_names, 1 do

          local current_element_name = game.progress_names[ i ];

          --current_progress[ current_element_name ] = {};

          if ( current_element_name == breakpoint ) then

            done = 0;

          end;

          current_progress[ current_element_name ] = {};
          current_progress[ current_element_name ].done  = done;
          current_progress[ current_element_name ].start = done;

        end;

      end;

      -- Проверяем на целостность, добавляем в очередь.
      for i = 1, #game.progress_names, 1 do

        local current_element_name = game.progress_names[ i ];

        if not ( current_progress[ current_element_name ] ) then

          current_progress[ current_element_name ] = {};
          current_progress[ current_element_name ].done  = 0;
          current_progress[ current_element_name ].start = 0;

        else
          
          if ( current_progress[ current_element_name ].done  == 1 )
          or ( current_progress[ current_element_name ].start == 1 )
          then

            public.AddSubscribersToQueue( current_element_name );

          end;

        end;

      end;

    end;

    prg.current = prg_type;

    private.LoadLevelModules( level );

    SetCursor( CURSOR_DEFAULT );
    room.SetAutosave( true );
    public.GotoStartRoom( start_room );

    private.CheaterReset();
    
  end;
  --------------------------------------------------------------------
  function private.InitLevelModules( level, modules )

    modules = modules or game.room_names;

    for i = 1, #modules do

      local module = modules[ i ];

      local mod_name = public.GetObjectName( module );

      ModLoad( string.format( "assets/levels/%s/%s/mod_%s", level, module, mod_name ) );
      ObjAttach( module, room.hub );
      if game and game.relations then
        game.relations[ module ] = {};
      end;
      _G[ module ].Init();

    end;

  end;
  --------------------------------------------------------------------
  function private.LoadLevelModules( level, modules )

    modules = modules or game.room_names;

    for i = 1, #modules do
      local module = modules[ i ];
      if _G[ module ].Load then
        _G[ module ].Load();
      end;
    end;

  end;
--*********************************************************************************************************************
--***function *** Menu *** () end**************************************************************************************
--*********************************************************************************************************************
  private.menu = {};
  --------------------------------------------------------------------
  function public.MenuLoad( is_fromgame, modules )

    if ( not LoadCurrentProfile() ) then
      DbgTrace( "public.Start Проверка профилей: текущий поврежден." );
      local profile = GetCurrentProfile();
      if (profile ~= "ng_noprofiles") then
        private.ProfileSet( profile, true );
      end; 
    else 
      if ng_global == nil then
        DbgTrace( "public.Start Проверка профилей: game_data null" );
        local profile = GetCurrentProfile();
        if (profile ~= "ng_noprofiles") then
          private.ProfileSet( profile, true );
        end; 
      end;
    end;
    private.menu.is_fromgame = is_fromgame;

    private.InitLevelModules( "menu", modules );

    SetCursor( CURSOR_DEFAULT );

    cmn.is_inmenunow = true;
    private.is_enabled_show_window = false;

    local startroom = "rm_intro";

    if ( is_fromgame ) then

      startroom = "rm_menu";

    else

      local menu_open_func = rm_menu.Open; 

      local MenuCheckStart = function () 

        ObjAttach( "tmr_common_fps", "cmn_timers" );
        private.is_enabled_show_window = true;
        private.CheckForceFullScreen();

        rm_menu.Open = menu_open_func;
        _G[ "rm_menu" ].Open();

      end;

      rm_menu.Open = MenuCheckStart;

      if ( GetPlatform() == "android" ) then --or ( GetPlatform() == "ios" ) then
        -- Test BigFist zastavka  
        param = "obb";
      end

    end;

    --startroom = "rm_menu";
    if is_fromgame == "unlock" then
      --port.
      cmn.is_inmenunow = false;
      startroom = "rm_unlock"; 
      iOS_LogEvents(1);
      public.GotoRoom( startroom, 0, 1 );
    else
      public.GotoRoom( startroom, 0 );
    end;

  end;
  --------------------------------------------------------------------
  function public.MenuPlay()

    if ( not ng_global.progress[ "std" ].common.gamestart ) then
      public.DialogWindowShow( "gamemode", "newgame", true );
    else
      public.DialogWindowShow( "playchoice", nil, true );
    end;

  end;
  --------------------------------------------------------------------
  function public.MenuOptions()
    public.DialogWindowShow( "options", "menu", true );
  end;
  --------------------------------------------------------------------
  function public.MenuQuit()
    public.DialogWindowShow( "common", "quit", true );
  end;
  --------------------------------------------------------------------
  function public.MenuCredits()
    public.GotoRoom( "rm_credits" );
  end;
  --------------------------------------------------------------------
  function public.MenuExtra()
    public.GotoRoom( "rm_extra" );
  end;
  --------------------------------------------------------------------
  function public.MenuAchievements()
    public.GotoRoom( "rm_achievements" );
  end;
  --------------------------------------------------------------------
  function public.MenuProfile()
    public.DialogWindowShow( "profile", nil, true );
  end;
  --------------------------------------------------------------------
  function public.MenuShop()
    public.GotoRoom( "rm_shop" );
  end;
  
--*********************************************************************************************************************
--***function *** - menu portable_mdown *** () end***********************************************************************************
--*********************************************************************************************************************

  ----------port.---------------ios-------------------------------------------
  function public.MenuSave50()
    iOS_iSplashPressed();
  end;
  -------------------------ios-------------------------------------------
  function public.MenuUnlock()
    iOS_LogEvents(4);
    menu_unlock_press = 1;
    cmn.is_inmenunow = true;
    public.GotoRoom( "rm_unlock" );
  end;
  ------------------------ios-------------------------------------------
  function public.MenuSneakPeak()
    public.GotoRoom( "rm_sequel" );
  end;
--*********************************************************************************************************************
--***function *** Profile *** () end***********************************************************************************
--*********************************************************************************************************************
  public.profile = {};
  public.profile.types = { "std", "ext", "secret" };
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  -- функция инициализации глобальных переменных 
  --------------------------------------------------------------------
  function private.ProfileInit()

    public.LogTrace( "[ - ] Инициализация глобальных переменных." );
    ng_global = {};

    ng_global.project = {};
    ng_global.project = private.project;

    ng_global.gamemode = 0;
    ng_global.inventory_autohide = 1;
    ng_global.currentprogress = "std";
    ng_global.progress = {};

    if port.isPortable() == 1 then 
      ng_global.inventory_autohide = false;
    end;
    
    for i = 1, #public.profile.types, 1 do    
      private.ProgressReset( public.profile.types[ i ] );
    end;

    common_impl.ProfileInit();

  end;
    --------------------------------------------------------------------
  function public.ProfileSetIos( newprofile, needcheck )
    if port.isPortable() == 1 then
      private.ProfileSet( newprofile, needcheck );
    end;
  end;
  --------------------------------------------------------------------
  -- функция установки профиля 
  function private.ProfileSet( newprofile, needcheck )

    public.LogTrace( "[ - ] Установка профиля: профиль установлен." );

    SetCurrentProfile( newprofile );

    --rm_menu.SetProfileText( newprofile );
    private.ProfileInit();

    if not needcheck then
      
      private.ProfileCheck();

    end;

    SaveProfiles();

  end;
  --------------------------------------------------------------------
  function private.ProfileNameTrim( profile_name )

    while ( " " == string.sub( profile_name, 1, 1 ) ) do

      profile_name = string.sub( profile_name, 2 );

    end;

    while ( " " == string.sub( profile_name, - 1 ) ) do

      profile_name = string.sub( profile_name, 1, - 2 );

    end;

    return profile_name;

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function private.ProgressReset( prg, save )

    local default = { gamewin = false };
    if ( save ) then default = save; end;

    ng_global.progress[ prg ] = {};
    ng_global.progress[ prg ].common = {};
    ng_global.progress[ prg ].common.gamestart = false;
    ng_global.progress[ prg ].common.gamewin = default.gamewin;
    ng_global.progress[ prg ].common.chapter = "level";
    ng_global.progress[ prg ].common.currentroom = nil;
    ng_global.progress[ prg ].common.hinttimer = 0;

    if port.isPortable() == 1 then 
      ng_global.inventory_autohide = false;
    end;
    
    common_impl.ProgressReset( prg, save );

  end;
  --------------------------------------------------------------------
  -- функция проверки профилей 
  function private.ProfileCheck()

    public.LogTrace( "[ - ] Проверка профилей." );
    local status = GetCurrentProfile();

    if ( status == "ng_error" ) then
      public.LogTrace( "[ - ] Проверка профилей: < profile_list > поврежден." );
      public.DialogWindowShow( "common", "corrupt" );

    elseif ( status ~= "ng_noprofiles" ) then
      public.LogTrace( "[ - ] Проверка профилей: существуют." );

      local profiles = GetProfileList();
      for i = 1, #profiles, 1 do
        if ( profiles[i] == GetCurrentProfile() ) then
          public.dialog.profile.current = i;
          break;
        end
      end

      public.LogTrace( "[ - ] Проверка профилей: текущий выделен." );

      if ( not LoadCurrentProfile() ) then

        public.LogTrace( "[ - ] Проверка профилей: текущий поврежден." );
        public.DialogWindowShow( "common", "corrupt" );

      else

        public.LogTrace( "[ - ] Проверка профилей: текущий загружен, установка режима игры." );
        public.UpdateGameMode( ng_global.gamemode );
        ObjSet( "tmr_common_fps", { time = private.fps.time, playing = true, endtrig = function () private.fps.Check(true); end } );

      end

    else

      public.LogTrace( "[ - ] Проверка профилей: нет профилей." );
      rm_menu.SetProfileText( "" );
      public.DialogWindowShow( "addprofile", "new" );

    end

  end;
--*********************************************************************************************************************
--***function *** Events *** () end************************************************************************************
--*********************************************************************************************************************
  function private.InitEvents()

    Event_ButtonGuide_Click       = "Event_ButtonGuide_Click";
    Event_ButtonHint_Click        = "Event_ButtonHint_Click";
    Event_ButtonInfo_Click        = "Event_ButtonInfo_Click";
    Event_ButtonReset_Click       = "Event_ButtonReset_Click";
    Event_ButtonSkip_Click        = "Event_ButtonSkip_Click";
    Event_ButtonLock_Click        = "Event_ButtonLock_Click";
    Event_ButtonMap_Click         = "Event_ButtonMap_Click";
    Event_ButtonMenu_Click        = "Event_ButtonMenu_Click";
    Event_FrameSubroom_Click      = "Event_FrameSubroom_Click";
    Event_Tutorial_Click          = "Event_Tutorial_Click";
    Event_HoHint_NoObjects        = "Event_HoHint_NoObjects";
    Event_DialogHo_Show           = "Event_DialogHo_Show";
    Event_DialogHo_Hide           = "Event_DialogHo_Hide";
    Event_PanelNotification_Click = "Event_PanelNotification_Click";

  end;
  -----------------------------------------------------------------------------
  function private.SubscribeEvents()

    MsgSubscribe( Event_ButtonGuide_Click, private.Handle_Event_ButtonGuide_Click );
    MsgSubscribe( Event_ButtonHint_Click, private.Handle_Event_ButtonHint_Click );
    MsgSubscribe( Event_ButtonInfo_Click, private.Handle_Event_ButtonInfo_Click );
    MsgSubscribe( Event_ButtonReset_Click, private.Handle_Event_ButtonReset_Click );
    MsgSubscribe( Event_ButtonSkip_Click, private.Handle_Event_ButtonSkip_Click );
    MsgSubscribe( Event_ButtonLock_Click, private.Handle_Event_ButtonLock_Click );
    MsgSubscribe( Event_ButtonMap_Click, private.Handle_Event_ButtonMap_Click );
    MsgSubscribe( Event_ButtonMenu_Click, private.Handle_Event_ButtonMenu_Click );
    MsgSubscribe( Event_FrameSubroom_Click, private.Handle_Event_FrameSubroom_Click );
    MsgSubscribe( Event_Tutorial_Click, private.Handle_Event_Tutorial_Click );
    MsgSubscribe( Event_HoHint_NoObjects, private.Handle_Event_HoHint_NoObjects );
    MsgSubscribe( Event_DialogHo_Show, private.Handle_Event_DialogHo_Show );
    MsgSubscribe( Event_DialogHo_Hide, private.Handle_Event_DialogHo_Hide );
    MsgSubscribe( Event_PanelNotification_Click, private.Handle_Event_PanelNotification_Click );

    MsgSubscribe( Event_Level_CheatKeyPressed,        private.Handle_Event_Level_CheatKeyPressed );
    MsgSubscribe( Event_Application_ToggleFullScreen, private.Handle_Event_Application_ToggleFullScreen );
    MsgSubscribe( Event_Application_Closing,          private.Handle_Event_Application_Closing );

    MsgSubscribe( Event_GotoMainMenu,       private.Handle_Event_GotoMainMenu );
    MsgSubscribe( Event_FullHideWait,       private.Handle_Event_FullHideWait );
    MsgSubscribe( Event_FullBack,           private.Handle_Event_FullBack );

    MsgSubscribe( Event_Application_Unpaused,         private.Handle_Event_Application_Unpaused );
    
    MsgSubscribe( Event_notEngine_ScriptHub_Script_Error, private.Handle_Script_Error );
    
    if tostring(GetPlatform()) == "android" then
       if not ( private.subscribe_android_back_pressed ) then
          private.subscribe_android_back_pressed = true;
          MsgSubscribe( Event_Android_BackPressed, private.AndroidBackPressed );
       end;
    end;

  end;
  -----------------------------------------------------------------------------
  function private.UnubscribeEvents()

    MsgUnsubscribe( Event_ButtonGuide_Click, private.Handle_Event_ButtonGuide_Click );
    MsgUnsubscribe( Event_ButtonHint_Click, private.Handle_Event_ButtonHint_Click );
    MsgUnsubscribe( Event_ButtonInfo_Click, private.Handle_Event_ButtonInfo_Click );
    MsgUnsubscribe( Event_ButtonReset_Click, private.Handle_Event_ButtonReset_Click );
    MsgUnsubscribe( Event_ButtonSkip_Click, private.Handle_Event_ButtonSkip_Click );
    MsgUnsubscribe( Event_ButtonLock_Click, private.Handle_Event_ButtonLock_Click );
    MsgUnsubscribe( Event_ButtonMap_Click, private.Handle_Event_ButtonMap_Click );
    MsgUnsubscribe( Event_ButtonMenu_Click, private.Handle_Event_ButtonMenu_Click );
    MsgUnsubscribe( Event_FrameSubroom_Click, private.Handle_Event_FrameSubroom_Click );
    MsgUnsubscribe( Event_Tutorial_Click, private.Handle_Event_Tutorial_Click );
    MsgUnsubscribe( Event_HoHint_NoObjects, private.Handle_Event_HoHint_NoObjects );
    MsgUnsubscribe( Event_DialogHo_Show, private.Handle_Event_DialogHo_Show );
    MsgUnsubscribe( Event_DialogHo_Hide, private.Handle_Event_DialogHo_Hide );
    MsgUnsubscribe( Event_PanelNotification_Click, private.Handle_Event_PanelNotification_Click );

    MsgUnsubscribe( Event_Level_CheatKeyPressed,        private.Handle_Event_Level_CheatKeyPressed );
    MsgUnsubscribe( Event_Application_ToggleFullScreen, private.Handle_Event_Application_ToggleFullScreen );
    MsgUnsubscribe( Event_Application_Closing,          private.Handle_Event_Application_Closing );

    MsgUnsubscribe( Event_GotoMainMenu,       private.Handle_Event_GotoMainMenu );
    MsgUnsubscribe( Event_FullHideWait,       private.Handle_Event_FullHideWait );
    MsgUnsubscribe( Event_FullBack,           private.Handle_Event_FullBack );

    MsgUnsubscribe( Event_Application_Unpaused,         private.Handle_Event_Application_Unpaused );
    
    MsgUnsubscribe( Event_notEngine_ScriptHub_Script_Error, private.Handle_Script_Error );
    
    if tostring(GetPlatform()) == "android" then
      MsgUnsubscribe( Event_Android_BackPressed, private.AndroidBackPressed );
    end;

  end;
  --****.port fix*********************************************  
  function private.AndroidBackPressed ( )

    common_impl.AndroidBackPressed();

  end;
  -----------------------------------------------------------------------------  
  --*************************************************  
  function private.Handle_Script_Error(msg, params)
     if (cmn.bError == 1) then
       return;
     end;
     cmn.bError = 1;
     local sError = private.TableToString(params);
     DbgTrace("Handle_Script_Error sError = "..sError);
     cmn.bError = 0;
  end;
  
  
  function private.TableToString ( table_in, table_depth, symbol_lf, symbol_ct )

    if not ( table_in and "table" == type( table_in ) ) then
    
      return "";

    end;
    
    symbol_lf = symbol_lf or "\n";
    symbol_ct = symbol_ct or "\t";

    table_depth = table_depth or 0;
    
    local string_depth = "";

    for d = 1, table_depth do

      string_depth = string_depth..symbol_ct;

    end;
        
    local string_out = "";

    if ( 0 == table_depth ) then

      string_out = symbol_lf;

    end;
    
    for key, value in pairs( table_in ) do
   
      if ( "string" == type( value ) ) then

        value = "'"..value.."'";

      end;
   
      string_out = string_out..string_depth..tostring( key ).." = "..tostring( value )..symbol_lf;
   
      if ( "table" == type( value ) ) then

        string_out = string_out..private.TableToString( value, 1 + table_depth, symbol_lf, symbol_ct );

      end;
   
    end;
    
    return string_out;

  end; 
  -----------------------------------------------------------------------------
  function public.ApplicationClose()

    if ( not cmn.is_inmenunow ) then

      private.SaveInterfaceTimers();
      interface.InventoryAutoHideSave();

    end;

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonGuide_Click()

    common_impl.ButtonGuide_Click();
    interface.StrategyGuideShow();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonHint_Click( msg, params )

    common_impl.ButtonHint_Click( params.hint_state );

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonInfo_Click()

    common_impl.ButtonInfo_Click();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonLock_Click()

    local autohide = interface.InventoryAutoHideGet();
    interface.InventoryAutoHideSet( not autohide );

    common_impl.ButtonLock_Click();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonMap_Click()

    common_impl.ButtonMap_Click();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonMenu_Click()

    common_impl.ButtonMenu_Click();
    public.DialogWindowShow( "options", "game", true );

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonReset_Click()

    common_impl.ButtonReset_Click();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_ButtonSkip_Click( msg, params )

    common_impl.ButtonSkip_Click( params.skip_ready );

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_FrameSubroom_Click()

    public.CloseSubRoom();
    common_impl.FrameSubroom_Click();
    interface.CheaterUpdateSubroom( "" );

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_Tutorial_Click( msg, params )

    common_impl.Tutorial_Click( params.button_id );

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_HoHint_NoObjects()

    common_impl.HoHint_NoObjects();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_DialogHo_Show()

    common_impl.DialogHo_Show();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_DialogHo_Hide()

    common_impl.DialogHo_Hide();

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_PanelNotification_Click( msg, params )

    common_impl.PanelNotification_Click( params.notification_type );

  end;
  -----------------------------------------------------------------------------
  function private.Handle_Event_Level_CheatKeyPressed( msg, params )

    local keycode = params.key;

    local key_f_id = keycode - 111;

    if ( key_f_id > 0 ) and ( key_f_id < 13 ) then

      if ( private.cheater_key_f[ "F"..key_f_id ] ) then

        public.LevelSwitch( private.cheater_key_f[ "F"..key_f_id ].level, key_f_id );

      end;

    end;

    common_impl.CheaterKeyPress( keycode );
    
  end;
  --*********************************************************************************************************************
  function private.Handle_Event_Application_Closing()

    public.ApplicationClose();
    private.UnubscribeEvents();
    common_impl.Application_Closing();

  end;
  --*********************************************************************************************************************
  function private.Handle_Event_Application_ToggleFullScreen( msg, params )

    local togglefullscreen = params.togglefullscreen; 
    local togglewidescreen = params.togglewidescreen;

    public.LogTrace( "[ ! ] Изменение режима экрана: ширина = "..GetAppWidth().."." );

    if ( cmn.is_inmenunow ) then

      rm_menu.ButtonSetPos();

    end;

    if ( togglefullscreen == false ) and ( togglewidescreen == false ) and ( private.is_enabled_show_window ) then

      public.LogTrace( "[ ! ] Изменение режима экрана: невозможно." );

      local type = "full";

      --DbgTrace("[2]public.dialog.togglescreen.is_changed[ 'widescreen' ] = "..tostring( public.dialog.togglescreen.is_changed[ "widescreen" ] ) );
      --DbgTrace("[2]common_dialog_togglescreen_is_changed_widescreen = "..tostring( common_dialog_togglescreen_is_changed_widescreen ) );

      --if ( togglewidescreen == false and public.dialog.togglescreen.is_changed[ "widescreen" ] ) then
      if ( togglewidescreen == false and common_dialog_togglescreen_is_changed_widescreen ) then   --костыль

        type = "wide";

      end;

      public.DialogWindowShow( "togglescreen", type, false );

    else

      public.LogTrace( "[ ! ] Изменение режима экрана: установка опций." );

      local t_check_names = { "fullscreen", "widescreen" };
      public.dialog.options.CheckSet( t_check_names );

      if ( private.is_enabled_show_window ) then

        private.fps.Check( true );

      end;

      if ( not cmn.is_inmenunow ) then

        if _G[ "int_global_task" ] then
          int_global_task.CheckScreen();
        end;

      end;

      if IsCollectorsEdition() or IsSurveyEdition() then

        --if ( not cmn.is_inmenunow ) then

          if _G[ "int_achiev" ] then
            int_achiev.CheckScreen();
          end;

          if _G[ "int_bonus" ] then
            int_bonus.CheckScreen();
          end;

        --end;

      end;
      
      if ( not cmn.is_inmenunow ) then
        
        if GetCurrentRoom() == "ho_honorary" then
          ho_honorary.CreateHint();
        end;
        
      end;

    end;
    
  end;
  ---------------------------------------------------------------------------------------
  function private.Handle_Event_GotoMainMenu( msg, params )
  
    DbgTrace( "[common] Handle_Event_GotoMainMenu");
    common_impl.GotoMainMenu();

  end;
  --------------------------------------------------------------------------------------
  function private.Handle_Event_FullHideWait( msg, params )
  
    DbgTrace( "[common] Handle_Event_FullHideWait");
    common_impl.FullHideWait();

  end;
  --------------------------------------------------------------------------------------
  function private.Handle_Event_FullBack( msg, params )
  
    DbgTrace( "[common] Handle_Event_FullBack");
    common_impl.FullBack();

  end;
  --------------------------------------------------------------------------------------
  function private.Handle_Event_Application_Unpaused( msg, params )

    DbgTrace( "[common] Handle_Event_Application_Unpaused");
    common_impl.Application_Unpaused();

  end;
--*********************************************************************************************************************
--***function *** Subscribers *** () end*******************************************************************************
--*********************************************************************************************************************
  function private.InitSubscribers()

    -- таблица 1: подписчиков
    cmn.subscribers = {};
    -- таблица 2: динамическая очередь событий
    cmn.event_queue = {};

    cmn.AddSubscriber = public.AddSubscriber;
    cmn.CallEventHandler = public.CallEventHandler;

  end;
  -----------------------------------------------------------------------------------
  function public.AddSubscriber( event_name, func, room_name )

    local room_name = room_name or "instant";

    if ( not cmn.subscribers[ event_name ] ) then

      cmn.subscribers[ event_name ] = {};

    end;

    if ( cmn.subscribers[ event_name ] ) then

      table.insert( cmn.subscribers[ event_name ], { room = room_name, func = func } );

      if ( not func ) then

        --DbgTrace( "event "..event_name.." have nil subscr!!!" );

      end;

      --*DbgTrace( "Add subscriber FOR EVENT '"..event_name.."' ( room = "..tostring( room_name )..", func = "..tostring( func ).." )"  );

    end;

  end
  -----------------------------------------------------------------------------------
  function public.CallRoomEventHandlers( room_name )

    --DbgTrace( "CallRoomEventHandlers: " );

    local id = 1;

    while ( id <= #cmn.event_queue ) do

      if ( cmn.event_queue[ id ].room == room_name ) or ( cmn.event_queue[ id ].room == "instant" ) then

        --DbgTrace( "  - - Call event handler ( "..cmn.event_queue[ id ].room.." ) : " );

        local event_handler_params = table.remove( cmn.event_queue, id );
        event_handler_params.func();
        -- если луа говорит, что зхдесь ошибка, значит, что прередан вместо функции в AddSubscriber nil

      else

        id = id + 1;

      end;

      --DbgTrace( "  - - id = "..id );

    end;

  end
  -----------------------------------------------------------------------------------
  function public.AddSubscribersToQueue( event_name )

    if ( cmn.subscribers[ event_name ] ) then

      --DbgTrace( "Add subscriber to QUEUE for event '"..event_name.."' "..#cmn.subscribers[ event_name ] );

      for id = 1, #cmn.subscribers[ event_name ] do

        table.insert( cmn.event_queue, cmn.subscribers[ event_name ][ id ] );

        --DbgTrace( "  - - !!!! "..event_name.."  "..tostring( cmn.event_queue[ #cmn.event_queue ].room ).." "..tostring( cmn.event_queue[ #cmn.event_queue ].func ) );

      end;

    end;

  end;
  -----------------------------------------------------------------------------------
  function public.CallEventHandler( event_name, current_room, prg )

    public.AddSubscribersToQueue( event_name );

    local current_room = current_room or GetCurrentRoom();
    public.CallRoomEventHandlers( current_room );

  end
--*********************************************************************************************************************
--***function *** Android - Ios *** () end*******************************************************************************
--*********************************************************************************************************************
  function public.SetMultiTouch(room_object)
    --[[
    local platform = GetPlatform();
  
    --DbgTrace("[common] public.SetMultiTouch room_object = "..tostring(room_object).."; platform = "..tostring(platform));
  
    if ( platform == "android" ) or ( platform == "ios" ) then
  
      if (IsIpad() == true) then

        if ("ho" == public.GetObjectPrefix( room_object )) then
          DbgTrace("[common] public.SetMultiTouch::iOS_EnableMultiTouch(1) room_object = "..tostring(room_object));
          iOS_EnableMultiTouch(1);
        else
          DbgTrace("[common] public.SetMultiTouch::iOS_EnableMultiTouch(0) room_object = "..tostring(room_object));
          iOS_EnableMultiTouch(0);
        end;
      
      elseif (IsIphone() == true) then
      
        if ("zz" == public.GetObjectPrefix( room_object )) then
          DbgTrace("[common] public.SetMultiTouch::iOS_EnableMultiTouch(0) room_object = "..tostring(room_object));
          iOS_EnableMultiTouch(0);
        else
          DbgTrace("[common] public.SetMultiTouch::iOS_EnableMultiTouch(1) room_object = "..tostring(room_object));
          iOS_EnableMultiTouch(1);
        end;
      
      end;

    end;
    ]]
  end;
--********************************************************************************************************************