-- name=rm_housegarden
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_housegarden";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.dlg_finished = true;
  
  private.Init_Subroom();
  private.Init_Flowerbed();
  --------------------------------------------------------------------------------------------
  -- function get_fernflower () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_fernflower" ] = {
        type = "get",
        get_obj = "spr_flowerbed_fernflower",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_fernflower_inv = function ()
  
    interface.InventoryItemAdd( "inv_fernflower", "spr_flowerbed_fernflower" );
  
  end;
  
  local get_fernflower_end = function ()
  
    ObjDelete( "gfx_flowerbed_fernflower" );
    ObjDelete( "spr_flowerbed_fernflower_sh" );
    ObjDelete( "spr_housegarden_flowerbed_fernflower" );
  
  end;
  
  cmn.AddSubscriber( "get_fernflower", get_fernflower_inv );
  cmn.AddSubscriber( "get_fernflower", get_fernflower_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pearl () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pearl" ] = {
        type = "get",
        get_obj = "spr_flowerbed_pearl",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_pearl_inv = function ()
  
    interface.InventoryItemAdd( "inv_pearl", "spr_flowerbed_pearl" );
  
  end;
  
  local get_pearl_end = function ()
  
    ObjDelete( "gfx_flowerbed_pearl" );
    ObjDelete( "spr_flowerbed_pearl_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_pearl", get_pearl_inv );
  cmn.AddSubscriber( "get_pearl", get_pearl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leavewithstickydew () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_leavewithstickydew" ] = {
        type = "get",
        get_obj = "spr_flowerbed_leavewithstickydew",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_leavewithstickydew_inv = function ()
  
    interface.InventoryItemAdd( "inv_leavewithstickydew", "spr_flowerbed_leavewithstickydew" );
    ObjSet("inv_brokenbugle_star_light",  { alp = 1 });
  
  end;
  
  local get_leavewithstickydew_end = function ()
  
    ObjDelete( "anm_flowerbed_tree_drops" );
    ObjDelete( "spr_flowerbed_leavewithstickydew_sh" );
    
    if cmn.IsEventDone("get_goldcrown") then
      ObjDelete( "gzz_housegarden_flowerbed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_leavewithstickydew", get_leavewithstickydew_inv );
  cmn.AddSubscriber( "get_leavewithstickydew", get_leavewithstickydew_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_goldcrown () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_goldcrown" ] = {
        type = "get",
        get_obj = "spr_flowerbed_goldcrown",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_goldcrown_inv = function ()
  
    interface.InventoryItemAdd( "inv_goldcrown", "spr_flowerbed_goldcrown" );
  
  end;
  
  local get_goldcrown_end = function ()
  
    ObjDelete( "gfx_flowerbed_goldcrown" );
    ObjDelete( "spr_flowerbed_goldcrown_sh" );

    ObjDelete( "spr_housegarden_flowerbed_crown" );
    
    if cmn.IsEventDone("get_leavewithstickydew") then
      ObjDelete( "gzz_housegarden_flowerbed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_goldcrown", get_goldcrown_inv );
  cmn.AddSubscriber( "get_goldcrown", get_goldcrown_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_quiverofgoldarrows () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_quiverofgoldarrows" ] = {
        type = "get",
        get_obj = "spr_robinstatuette_quiverofgoldarrows",
        room = private.room_objname,
        zz = "zz_robinstatuette",
        zz_gate = "gzz_housegarden_robinstatuette"
    };
    --------------------------------------------------------------------------------------------
  local get_quiverofgoldarrows_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_housegarden");
    interface.InventoryItemAdd( "inv_quiverofgoldarrows", "spr_robinstatuette_quiverofgoldarrows" );
  
  end;
  
  local get_quiverofgoldarrows_end = function ()
  
    ObjDelete( "gfx_robinstatuette_quiverofgoldarrows" );
    ObjDelete( "spr_robinstatuette_quiverofgoldarrows_sh" );
    ObjDelete( "obj_robinstatuette_quiverofgoldarrows_get" );
    ObjDelete( "spr_housegarden_robinstatuette_quiver" );

    if cmn.IsEventDone("get_fleurdelis") then
      ObjDelete( "gzz_housegarden_robinstatuette" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_quiverofgoldarrows", get_quiverofgoldarrows_inv );
  cmn.AddSubscriber( "get_quiverofgoldarrows", get_quiverofgoldarrows_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fleurdelis () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_fleurdelis" ] = {
        type = "get",
        get_obj = "spr_robinstatuette_fleurdelis",
        room = private.room_objname,
        zz = "zz_robinstatuette",
        zz_gate = "gzz_housegarden_robinstatuette"
    };
    --------------------------------------------------------------------------------------------
  local get_fleurdelis_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_housegarden");
    interface.InventoryItemAdd( "inv_fleurdelis", "spr_robinstatuette_fleurdelis" );
  
  end;
  
  local get_fleurdelis_end = function ()
  
    ObjDelete( "gfx_robinstatuette_fleurdelis" );
    ObjDelete( "spr_robinstatuette_fleurdelis_sh" );
    ObjDelete( "spr_housegarden_robinstatuette_fleurdelis" );
    
    if cmn.IsEventDone("get_quiverofgoldarrows") then
      ObjDelete( "gzz_housegarden_robinstatuette" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_fleurdelis", get_fleurdelis_inv );
  cmn.AddSubscriber( "get_fleurdelis", get_fleurdelis_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_redhatpage1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_redhatpage1" ] = {
      type = "get",
      get_obj = "spr_housegarden_redhatpage1",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_redhatpage1_inv = function ()
  
    interface.InventoryItemAdd( "inv_redhatpage", "spr_housegarden_redhatpage1", function () cmn.GetMultyObject( 'redhatpage', 4 ); end );
  
  end;
  local get_redhatpage1_mid = function ()
  
    ObjDelete( "gfx_housegarden_redhatpage1" );
    ObjDelete( "spr_housegarden_redhatpage1_sh" );
  
  end;
  local get_redhatpage1_end = function ()
  
    ObjDelete( "obj_housegarden_dialog_granny1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_redhatpage1", get_redhatpage1_inv );
  cmn.AddSubscriber( "get_redhatpage1_inv", get_redhatpage1_inv, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage1", get_redhatpage1_mid, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage1_mid", get_redhatpage1_mid, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage1", get_redhatpage1_end, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage1_end", get_redhatpage1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicamuletrecipe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicamuletrecipe" ] = {
      type = "get",
      get_obj = "spr_housegarden_magicamuletrecipe",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_magicamuletrecipe_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicamuletrecipe", "spr_housegarden_magicamuletrecipe" );
  
  end;
  local get_magicamuletrecipe_mid = function ()
  
    ObjDelete( "gfx_housegarden_magicamuletrecipe" );
    ObjDelete( "spr_housegarden_magicamuletrecipe_sh" );
    
    ObjSet("obj_housegarden_use_teleportamulet",  { alp = 1, input = 1 });
  
  end;
  local get_magicamuletrecipe_end = function ()
  
    ObjDelete( "obj_housegarden_dialog_granny2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicamuletrecipe", get_magicamuletrecipe_inv );
  cmn.AddSubscriber( "get_magicamuletrecipe_inv", get_magicamuletrecipe_inv, private.room_objname );
  cmn.AddSubscriber( "get_magicamuletrecipe", get_magicamuletrecipe_mid, private.room_objname );
  cmn.AddSubscriber( "get_magicamuletrecipe_mid", get_magicamuletrecipe_mid, private.room_objname );
  cmn.AddSubscriber( "get_magicamuletrecipe", get_magicamuletrecipe_end, private.room_objname );
  cmn.AddSubscriber( "get_magicamuletrecipe_end", get_magicamuletrecipe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magiconion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magiconion" ] = {
      type = "get",
      get_obj = "obj_housegarden_magiconion_hint",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_magiconion_inv = function ()
  
    interface.InventoryItemAdd( "inv_magiconion", "spr_housegarden_magiconion" );
  
  end;
  local get_magiconion_mid = function ()
  
    ObjDelete( "gfx_housegarden_magiconion" );
    ObjDelete( "spr_housegarden_magiconion_sh" );
    ObjDelete( "obj_housegarden_magiconion_get" );
    ObjDelete( "obj_housegarden_magiconion_hint" );
  
  end;
  local get_magiconion_end = function ()
  
    ObjDelete( "obj_housegarden_dialog_granny3" );
    ObjSet( "gho_housegarden_charmonlock", { input = 1, alp = 1, active = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magiconion", get_magiconion_inv );
  cmn.AddSubscriber( "get_magiconion_inv", get_magiconion_inv, private.room_objname );
  cmn.AddSubscriber( "get_magiconion", get_magiconion_mid, private.room_objname );
  cmn.AddSubscriber( "get_magiconion_mid", get_magiconion_mid, private.room_objname );
  cmn.AddSubscriber( "get_magiconion", get_magiconion_end, private.room_objname );
  cmn.AddSubscriber( "get_magiconion_end", get_magiconion_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_cauldronwtihfertilizer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_cauldronwtihfertilizer" ] = {
        type = "use",
        inv_obj = "inv_cauldronwtihfertilizer",
        use_place = "obj_flowerbed_use_cauldronwtihfertilizer",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
  --------------------------------------------------------------------------------------------
  local use_cauldronwtihfertilizer_inv = function ()
  
    interface.InventoryItemRemove( "inv_cauldronwtihfertilizer" );
  
  end;
  local use_cauldronwtihfertilizer_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_cauldronwtihfertilizer" );
  
  end;
  local use_cauldronwtihfertilizer_end = function ()
  
    ObjDelete( "anm_flowerbed_use_cauldron" );
    
    ObjAttach("obj_flowerbed_leavewithstickydew", "anm_flowerbed_tree_grow");
    
    ObjMultiSet( { {"anm_flowerbed_tree_grow", { alp = 1, frame = 400 }},
                   {"anm_flowerbed_tree_grow_2", { alp = 1, input = 1, frame = 400 }},
                   {"anm_flowerbed_tree_drops", { alp = 1 }},
                   {"spr_flowerbed_leavewithstickydew", { input = 1 }},
                   {"spr_housegarden_flowerbed_apple_flower", { alp = 1 }},
                   {"anm_flowerbed_leaves", { pos_z = 15 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cauldronwtihfertilizer", use_cauldronwtihfertilizer_beg, private.room_objname );
  cmn.AddSubscriber( "use_cauldronwtihfertilizer", use_cauldronwtihfertilizer_inv );
  cmn.AddSubscriber( "use_cauldronwtihfertilizer", use_cauldronwtihfertilizer_end, private.room_objname );
  cmn.AddSubscriber( "use_cauldronwtihfertilizer_inv", use_cauldronwtihfertilizer_inv, private.room_objname );
  cmn.AddSubscriber( "use_cauldronwtihfertilizer_beg", use_cauldronwtihfertilizer_beg, private.room_objname );
  cmn.AddSubscriber( "use_cauldronwtihfertilizer_end", use_cauldronwtihfertilizer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_runescoop () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_runescoop" ] = {
        type = "use",
        inv_obj = "inv_runescoop",
        use_place = "obj_flowerbed_use_runescoop",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
  --------------------------------------------------------------------------------------------
  local use_runescoop_inv = function ()
  
    interface.InventoryItemRemove( "inv_runescoop" );
  
  end;
  local use_runescoop_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_runescoop" );
  
  end;
  local use_runescoop_end = function ()
    
    ObjMultiSet( { {"obj_flowerbed_use_poisonedseeds", { input = 1 }},
                   {"anm_flowerbed_touch_ground", { alp = 1, animfunc = "func_clk_big_hole" }},
                   {"anm_flowerbed_use_scoop", { alp = 0 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_runescoop", use_runescoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_runescoop", use_runescoop_inv );
  cmn.AddSubscriber( "use_runescoop", use_runescoop_end, private.room_objname );
  cmn.AddSubscriber( "use_runescoop_inv", use_runescoop_inv, private.room_objname );
  cmn.AddSubscriber( "use_runescoop_beg", use_runescoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_runescoop_end", use_runescoop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pruners () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pruners" ] = {
        type = "use",
        inv_obj = "inv_pruners",
        use_place = "obj_flowerbed_use_pruners",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
  --------------------------------------------------------------------------------------------
  local use_pruners_inv = function ()
  
    interface.InventoryItemRemove( "inv_pruners" );
  
  end;
  local use_pruners_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_pruners" );
    ObjDelete( "anm_flowerbed_bush_touch" );
    ObjDelete( "anm_flowerbed_bush" );
  
  end;
  local use_pruners_end = function ()
    
    ObjDelete( "anm_flowerbed_use_pruners" );
    ObjDelete( "anm_housegarden_branch" );
  
    ObjSet("obj_flowerbed_game",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pruners", use_pruners_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners", use_pruners_inv );
  cmn.AddSubscriber( "use_pruners", use_pruners_end, private.room_objname );
  cmn.AddSubscriber( "use_pruners_inv", use_pruners_inv, private.room_objname );
  cmn.AddSubscriber( "use_pruners_beg", use_pruners_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_end", use_pruners_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_poisonedseeds () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_poisonedseeds" ] = {
        type = "use",
        inv_obj = "inv_poisonedseeds",
        use_place = "obj_flowerbed_use_poisonedseeds",
        room = private.room_objname,
        zz = "zz_flowerbed",
        zz_gate = "gzz_housegarden_flowerbed"
    };
  --------------------------------------------------------------------------------------------
  local use_poisonedseeds_inv = function ()
  
    interface.InventoryItemRemove( "inv_poisonedseeds" );
  
  end;
  local use_poisonedseeds_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_poisonedseeds" );
    
  end;
  local use_poisonedseeds_end = function ()
  
    ObjDelete( "anm_flowerbed_use_seeds" );
    ObjDelete( "anm_flowerbed_touch_ground" );
    
    ObjMultiSet( { {"anm_flowerbed_use_scoop", { alp = 1, frame = 300, animfunc = "func_use_garden_shovel_02" }},
                   {"obj_flowerbed_use_cauldronwtihfertilizer", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_poisonedseeds", use_poisonedseeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_poisonedseeds", use_poisonedseeds_inv );
  cmn.AddSubscriber( "use_poisonedseeds", use_poisonedseeds_end, private.room_objname );
  cmn.AddSubscriber( "use_poisonedseeds_inv", use_poisonedseeds_inv, private.room_objname );
  cmn.AddSubscriber( "use_poisonedseeds_beg", use_poisonedseeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_poisonedseeds_end", use_poisonedseeds_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_copperfeather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_copperfeather" ] = {
        type = "use",
        inv_obj = "inv_copperfeather",
        use_place = "obj_robinstatuette_use_copperfeather",
        room = private.room_objname,
        zz = "zz_robinstatuette",
        zz_gate = "gzz_housegarden_robinstatuette"
    };
  --------------------------------------------------------------------------------------------
  local use_copperfeather_inv = function ()
  
    interface.InventoryItemRemove( "inv_copperfeather" );
  
  end;
  local use_copperfeather_beg = function ()
  
    ObjDelete( "obj_robinstatuette_use_copperfeather" );
  
  end;
  local use_copperfeather_end = function ()
    
    ObjDelete( "anm_robinstatuette_hands_touch" );
    ObjDelete( "spr_housegarden_robinstatuette_closed_hands" );
  
    ObjMultiSet( { {"obj_robinstatuette_statue_open", { input = 1 }},
                   {"obj_robinstatuette_statue_open_2", { alp = 1 }},
                   {"obj_robinstatuette_feather_1", { alp = 1 }},
                   {"obj_robinstatuette_feather_2", { alp = 1 }},
                   {"spr_housegarden_robinstatuette_feather_02", { alp = 1 }},
                   {"spr_housegarden_robinstatuette_feather_01", { alp = 1 }},
                   {"spr_housegarden_robinstatuette_opened_hands", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_copperfeather", use_copperfeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_copperfeather", use_copperfeather_inv );
  cmn.AddSubscriber( "use_copperfeather", use_copperfeather_end, private.room_objname );
  cmn.AddSubscriber( "use_copperfeather_inv", use_copperfeather_inv, private.room_objname );
  cmn.AddSubscriber( "use_copperfeather_beg", use_copperfeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_copperfeather_end", use_copperfeather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_teleportamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_teleportamulet" ] = {
        type = "use",
        inv_obj = "inv_teleportamulet",
        use_place = "obj_housegarden_use_teleportamulet",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_teleportamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_teleportamulet" );
  
  end;
  local use_teleportamulet_beg = function ()
  
    ObjDelete( "obj_housegarden_use_teleportamulet" );
    ObjDelete( "obj_housegarden_portal_bbt" );
  
  end;
  local use_teleportamulet_end = function ()
  
    ObjAttach("obj_housegarden_dialog_granny3", "rm_housegarden");
    
    ObjDelete( "anm_housegarden_dialog_granny3_hand_1" );
    ObjDelete( "anm_housegarden_dialog_granny3_hand_give" );
    
    ObjDelete("vid_housegarden_dialog_granny3_lipsync1");
    ObjDelete("vid_housegarden_dialog_granny3_lipsync2");
    
    ObjMultiSet( { {"obj_housegarden_dialog_granny3", { alp = 1, input = 1 }},
                   {"obj_housegarden_dialog_granny3_hand_2", { alp = 1, input = 1 }},
                   {"obj_housegarden_dialog_granny3_head", { alp = 1 }},
                   {"anm_housegarden_portal", { alp = 1 }},
                   {"anm_housegarden_pornal_stone", { animfunc = "func_pornal_stone_anm" }} } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_teleportamulet", use_teleportamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_teleportamulet", use_teleportamulet_inv );
  cmn.AddSubscriber( "use_teleportamulet", use_teleportamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_teleportamulet_inv", use_teleportamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_teleportamulet_beg", use_teleportamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_teleportamulet_end", use_teleportamulet_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_housegardenfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_housegardenfirst" ] = {
    type = "click",
    use_place = "obj_housegarden_clk_housegardenfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_housegardenfirst = function ()
    
    ObjDelete("obj_housegarden_clk_housegardenfirst");
    ObjDelete("anm_housegarden_dialog_granny1_hand_1");
    ObjDelete("anm_housegarden_dialog_granny1_hand_give");
    
    ObjDelete("vid_housegarden_dialog_granny1_lipsync1");
    
    ObjAttach("obj_housegarden_dialog_granny1", "rm_housegarden");
    
    ObjMultiSet( { { "obj_housegarden_dialog_granny1", { input = 1, alp = 1 } },
                   { "obj_housegarden_dialog_granny1_hand_2", { input = 1, alp = 1 } },
                   { "obj_housegarden_dialog_granny1_head", { alp = 1 } },
                   { "obj_housegarden_portal_bbt", { input = 1 } },

                   { "gzz_housegarden_flowerbed", { event_mdown = function() cmn.GotoSubRoomMDown( "housegarden_flowerbed" ); end, event_mup = function() cmn.GotoSubRoomMUp( "housegarden_flowerbed", "zz_flowerbed" ); end } },
                   { "gzz_housegarden_robinstatuette", { event_mdown = function() cmn.GotoSubRoomMDown( "housegarden_robinstatuette" ); end, event_mup = function() cmn.GotoSubRoomMUp( "housegarden_robinstatuette", "zz_robinstatuette" ); end } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_housegardenfirst", clk_housegardenfirst, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_housegarden () end;
  --------------------------------------------------------------------------------------------
  local opn_housegarden = function ()
  
    int_map_impl.OpenRoom( "rm_housegarden" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_housegarden", opn_housegarden );
  --------------------------------------------------------------------------------------------
  -- function opn_housegardenwithred () end;
  --------------------------------------------------------------------------------------------
  local opn_housegardenwithred_task = function ()

    int_map_impl.BlockRoom( "rm_street" );
    int_map_impl.BlockRoom( "rm_nearpolicedepartment" );
    int_map_impl.BlockRoom( "rm_policedepartment" );

    int_map_impl.OpenRoom( "rm_witchhouse" );
    int_map_impl.OpenRoom( "rm_housegarden" );

    interface_impl.SetCurrentGlobalTask( 18 );
    
    interface.InventoryItemAdd( "inv_fixedredhoodpage" );
    interface.InventoryItemRemove( "inv_redhatpage" );

  end;
  local opn_housegardenwithred_loc = function ()
    
    ObjDelete("anm_housegarden_dialog_granny2_hand_1");
    ObjDelete("anm_housegarden_dialog_granny2_hand_give");
    
    ObjDelete("vid_housegarden_dialog_granny2_lipsync1");
    ObjDelete("vid_housegarden_dialog_granny2_lipsync2");
    ObjDelete("vid_housegarden_dialog_granny2_lipsync3");
    ObjDelete("vid_housegarden_dialog_granny2_lipsync4");
  
    ObjAttach("obj_housegarden_dialog_granny2", "rm_housegarden");
  
    ObjMultiSet( { {"obj_housegarden_dialog_granny2", { alp = 1, input = 1 }},
                   {"obj_housegarden_dialog_granny2_hand_2", { alp = 1, input = 1 }},
                   {"obj_housegarden_dialog_granny2_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_housegardenwithred", opn_housegardenwithred_loc, private.room_objname );
  cmn.AddSubscriber( "opn_housegardenwithred_loc", opn_housegardenwithred_loc, private.room_objname );
  cmn.AddSubscriber( "opn_housegardenwithred", opn_housegardenwithred_task );
  cmn.AddSubscriber( "opn_housegardenwithred_task", opn_housegardenwithred_task );

end;

--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_flowerbed" );
  
  function zz_flowerbed.PreOpen()
    
    if not(cmn.IsEventDone( "win_flowerbed" )) then
      private.zz_flowerbed.DrawScene();
    end;

  end;
  
  function zz_flowerbed.Open()
    
    if cmn.IsEventDone( "use_pruners" ) and not(cmn.IsEventDone( "win_flowerbed" )) then
      cmn.MiniGameShow();
      private.zz_flowerbed.CheckWin();
    end;

  end;

  function zz_flowerbed.PreClose()
    
    if ( cmn.IsEventDone( "use_pruners" ) and not(cmn.IsEventDone( "win_flowerbed" )) ) then
      cmn.MiniGameHide("flowerbed");
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].state) then 
    private.zz_flowerbed.StartConditions();
  end;

  private.zz_flowerbed.state = ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_housegarden();
  
  if cmn.IsEventDone("clk_housegardenfirst") and not cmn.IsEventDone("get_redhatpage1") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("opn_housegardenwithred") and not cmn.IsEventDone("get_magicamuletrecipe") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("use_teleportamulet") and not cmn.IsEventDone("get_magiconion") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_housegarden_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_housegarden_env");
  
  ObjSet("rm_housegarden",  { color_r = 1, color_g = 1, color_b = 1 });
  
  if cmn.IsEventDone("get_redhatpage4") and not cmn.IsEventDone("opn_housegardenwithred") then
    cmn.Lock( 1 );
  end;
  
  if cmn.IsEventDone("get_redhatpage1") and not cmn.IsEventDone("opn_street") then
    cmn.Lock( 1 );
  end;
  
  if cmn.IsEventDone("clk_housegardenfirst") and not cmn.IsEventDone("get_redhatpage1") then
    common_impl.current_dialog = "obj_housegarden_dialog_granny1";
    ObjSet("anm_housegarden_dialog_granny1_hand_2",  { playing = 1 });
  end;
  if cmn.IsEventDone("opn_housegardenwithred") and not cmn.IsEventDone("get_magicamuletrecipe") then
    common_impl.current_dialog = "obj_housegarden_dialog_granny2";
    ObjSet("anm_housegarden_dialog_granny2_hand_2",  { playing = 1 });
  end;
  if cmn.IsEventDone("use_teleportamulet") and not cmn.IsEventDone("get_magiconion") then
    common_impl.current_dialog = "obj_housegarden_dialog_granny3";
    ObjSet("anm_housegarden_dialog_granny3_hand_2",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_teleportamulet") then
    ObjMultiSet( { { "anm_housegarden_pornal_stone", { playing = true } },
                   { "anm_housegarden_portal", { playing = true } } } );
  end;

  if cmn.IsEventDone("get_redhatpage4") then
    ObjMultiSet( { { "anm_housegarden_redhood", { playing = true } },
                   { "anm_housegarden_wolf",    { playing = true } } } );
  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cauldronwtihfertilizer()

  local item = "inv_cauldronwtihfertilizer";

  if cmn.ApplyObj( item, "gzz_housegarden_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed" );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_cauldronwtihfertilizer" ) and cmn.IsEventDone("use_poisonedseeds") ) then

    cmn.CallEventHandler( "use_cauldronwtihfertilizer_inv" );
    cmn.CallEventHandler( "use_cauldronwtihfertilizer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cauldronwtihfertilizer" );
      cmn.CallEventHandler( "use_cauldronwtihfertilizer_end" );

    end;

    local anm_flower = function ()
      
      ObjAttach("obj_flowerbed_leavewithstickydew", "anm_flowerbed_tree_grow");
      
      ObjMultiSet( { {"anm_flowerbed_tree_grow_2",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_flowerbed_tree_drops", { alp = 1 }} } );
      
    end;
                   
    local anm_grow = function ()

      ObjDelete("anm_flowerbed_use_cauldron");
      ObjAnimate("anm_flowerbed_tree_grow", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });

      ObjMultiSet( { {"anm_flowerbed_tree_grow",  { playing = 1, endtrig = anm_flower }},
                     {"anm_flowerbed_leaves", { pos_z = 15 }} } );

    end;      

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_take_flower");

    ObjSet("anm_flowerbed_use_cauldron",  { alp = 1, playing = 1, endtrig = anm_grow });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_runescoop()

  local item = "inv_runescoop";

  if cmn.ApplyObj( item, "gzz_housegarden_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed" );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_runescoop" ) and cmn.IsEventDone("use_pruners") ) then

    cmn.CallEventHandler( "use_runescoop_inv" );
    cmn.CallEventHandler( "use_runescoop_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_runescoop" );
      cmn.CallEventHandler( "use_runescoop_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_use_shovel3");

    ObjMultiSet( { {"anm_flowerbed_use_scoop",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_flowerbed_touch_ground", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pruners()

  local item = "inv_pruners";

  if cmn.ApplyObj( item, "gzz_housegarden_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed" );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_pruners" ) ) then

    cmn.CallEventHandler( "use_pruners_inv" );
    cmn.CallEventHandler( "use_pruners_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pruners" );
      cmn.CallEventHandler( "use_pruners_end" );
      
      cmn.MiniGameShow();

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_use_cutters3");

    ObjSet("anm_flowerbed_use_pruners",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_poisonedseeds()

  local item = "inv_poisonedseeds";

  if cmn.ApplyObj( item, "gzz_housegarden_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed" );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_poisonedseeds" ) and cmn.IsEventDone("use_runescoop") ) then

    cmn.CallEventHandler( "use_poisonedseeds_inv" );
    cmn.CallEventHandler( "use_poisonedseeds_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_poisonedseeds" );
      cmn.CallEventHandler( "use_poisonedseeds_end" );

    end;
    
    local anm_scoop = function ()
      
      ObjDelete("anm_flowerbed_use_seeds");
      ObjDelete("anm_flowerbed_touch_ground");
      ObjSet("anm_flowerbed_use_scoop",  { alp = 1, frame = 0, playing = 1, endtrig = func_after, animfunc = "func_use_garden_shovel_02" });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_use_shovel4");

    ObjSet("anm_flowerbed_use_seeds",  { alp = 1, playing = 1, endtrig = anm_scoop });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_copperfeather()

  local item = "inv_copperfeather";

  if cmn.ApplyObj( item, "gzz_housegarden_robinstatuette" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_robinstatuette" );

  elseif ( cmn.ApplyObj( item, "obj_robinstatuette_use_copperfeather" ) and cmn.CheckMultiObject( "copperfeather", 2 ) ) then

    cmn.CallEventHandler( "use_copperfeather_inv" );
    cmn.CallEventHandler( "use_copperfeather_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_copperfeather" );
      cmn.CallEventHandler( "use_copperfeather_end" );

    end;
    
    local anm_open = function ()
      
      ObjAnimate("anm_robinstatuette_hands_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_robinstatuette_statue_open_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_use_feathers");

    ObjAnimate( "obj_robinstatuette_feather_2", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 0,
      0.6, 0, 1,
      0.9, 0, 1
    } );
    
    ObjAnimate( "obj_robinstatuette_feather_1", "alp", 0, 0, "",
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_teleportamulet()

  local item = "inv_teleportamulet";

  if ( cmn.ApplyObj( item, "obj_housegarden_use_teleportamulet" ) ) then

    cmn.CallEventHandler( "use_teleportamulet_inv" );
    cmn.CallEventHandler( "use_teleportamulet_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_teleportamulet" );
      --cmn.CallEventHandler( "use_teleportamulet_end" );
      
      private.dialog_granny_open( 3 );

    end;

    --cmn.Lock( 1 );

    func_after();

    --ObjAnimate( "spr_housegarden_", "alp", 0, 0, func_after,
    --{
    --  0.0, 0, 0, 
    --  0.3, 0, 1
    --} );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_fernflower()
  
  ObjSet("spr_flowerbed_fernflower",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_fernflower" );
  cmn.CallEventHandler( "get_fernflower" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_pearl()

  cmn.SetEventDone( "get_pearl" );
  cmn.CallEventHandler( "get_pearl" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_leavewithstickydew()
  
  ObjSet("spr_flowerbed_leavewithstickydew",  { alp = 1 });
  
  cmn.SetEventDone( "get_leavewithstickydew" );
  cmn.CallEventHandler( "get_leavewithstickydew" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_goldcrown") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_goldcrown()
  
  ObjSet("spr_flowerbed_goldcrown",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_goldcrown" );
  cmn.CallEventHandler( "get_goldcrown" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_leavewithstickydew") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_quiverofgoldarrows()

  cmn.SetEventDone( "get_quiverofgoldarrows" );
  cmn.CallEventHandler( "get_quiverofgoldarrows" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_fleurdelis") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_fleurdelis()
  
  ObjSet("spr_robinstatuette_fleurdelis",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_fleurdelis" );
  cmn.CallEventHandler( "get_fleurdelis" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_quiverofgoldarrows") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_redhatpage1()
  
  local func_after_dlg = function ()

    --cmn.Lock(0);
    cmn.CallEventHandler( "get_redhatpage1_end" );

    ObjSet("rm_housegarden",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_street");

  end;

  cmn.SetEventDone( "get_redhatpage1" );
  cmn.CallEventHandler( "get_redhatpage1_inv" );
  cmn.CallEventHandler( "get_redhatpage1_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level3/rm_housegarden/vid_goingtoreality", func_after_dlg, "assets/levels/level3/rm_housegarden/audio/aud_gointoreality", "");

end;
--------------------------------------------------------------------------------------------
function public.get_magicamuletrecipe()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_magicamuletrecipe_end" );

  end;

  cmn.SetEventDone( "get_magicamuletrecipe" );
  cmn.CallEventHandler( "get_magicamuletrecipe_inv" );
  cmn.CallEventHandler( "get_magicamuletrecipe_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  local dlg_hide = function ()
  
    common_impl.current_dialog = "";
    common_impl.PlayBackgroundMusic();
    
    ObjAnimate("obj_housegarden_dialog_granny2", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local anm_hand = function ()
    ObjSet("anm_housegarden_dialog_granny2_recipe_1",  { frame = 0, animfunc = "func_recipe_hand2", playing = 1, endtrig = dlg_hide });
  end;
  
  local set_timer = function ()
    ObjSet("tmr_housegarden_dialog_granny2_timer",  { time = 2.5, playing = 1, endtrig = anm_hand });
  end;
  
  cmn.Lock(1);
  
  ObjMultiSet( { {"anm_housegarden_dialog_granny2_recipe_1",  { alp = 1, playing = 1, endtrig = set_timer }},
                 {"anm_housegarden_dialog_granny2_hand_down", { alp = 1, playing = 1 }},
                 {"anm_housegarden_dialog_granny2_hand_2", { alp = 0, playing = 0 }} } );

end;
--------------------------------------------------------------------------------------------
function public.get_magiconion()
  
  ObjSet("spr_housegarden_magiconion",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });
  
  local func_after_dlg = function ()

    --cmn.Lock(0);
    cmn.CallEventHandler( "get_magiconion_end" );

    ObjSet("rm_housegarden",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("ho_charmonlock");

  end;

  cmn.SetEventDone( "get_magiconion" );
  cmn.CallEventHandler( "get_magiconion_inv" );
  cmn.CallEventHandler( "get_magiconion_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level3/rm_housegarden/vid_returntofairyland", func_after_dlg, "assets/levels/level3/rm_housegarden/audio/aud_returntofairyland", "");

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_housegardenfirst()
  
  cmn.SetEventDone("clk_housegardenfirst");
  private.dialog_granny_open( 1 );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_housegarden()

  if not ( cmn.IsEventDone( "opn_housegarden" ) ) then
    cmn.SetEventDone( "opn_housegarden" );
    cmn.CallEventHandler("opn_housegarden");
    cmn.ShowBbt( "housegarden_open" );
  end;
  
  if cmn.IsEventDone("get_redhatpage1") and not cmn.IsEventDone("opn_street") then
    
    local func_after_dlg = function ()

      ObjSet("rm_housegarden",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_street");

    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_housegarden/vid_goingtoreality", func_after_dlg, "assets/levels/level3/rm_housegarden/audio/aud_gointoreality", "");
    
  end;
  
  if cmn.IsEventDone("get_redhatpage4") and not cmn.IsEventDone("opn_housegardenwithred") then
    cmn.SetEventDone("opn_housegardenwithred");
    private.dialog_granny_open( 2 );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_bush()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_flowerbed_bush_touch", { alp = 0 }},
                   {"anm_flowerbed_bush", { playing = 1, alp = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_flowerbed_use_pruners" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_xx_clk_rustle3");
  
  ObjMultiSet( { {"anm_flowerbed_bush_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_flowerbed_bush", { playing = 0, alp = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ground( num )
  
  cmn.Lock(1);
  
  if num == 1 then
    cmn.ShowBbt( "obj_flowerbed_use_runescoop" );
  else 
    cmn.ShowBbt( "obj_flowerbed_use_poisonedseeds" );
  end;
    
  cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_xx_clk_ground");
  
  ObjSet("anm_flowerbed_touch_ground",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_housegarden_wolf()
  
  cmn.Lock(1);

  local anim_funcs = { "func_howling", "func_paw" };
  local func_num = math.random(1, 2);
  
  if func_num == 1 then
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_wolf_clk");
  end;
  
  ObjSet( "anm_housegarden_wolf", {
    playing = true,
    animfunc = anim_funcs[func_num],
    endtrig = function()
      ObjSet( "anm_housegarden_wolf", { animfunc = "func_anm_breath_scratching", endtrig = "", playing = true } );
      cmn.Lock(0);
    end
  } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_robin()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_robinstatuette_use_copperfeather" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_xx_clk_stone_man");
  
  ObjMultiSet( { {"anm_robinstatuette_hands_touch", { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_robinstatuette_chain_touch", { playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_granny_open( num )
  
  private.dlg_finished = false;
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_granny1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_granny2_beg(); end;
  elseif num == 3 then
    func_after = function() private.dialog_granny3_beg(); end;
  end;
  
  ObjAttach("obj_housegarden_dialog_granny"..num, "rm_housegarden");
  ObjAnimate("obj_housegarden_dialog_granny"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_granny1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "housegarden", "granny1", 2 );
  
  local dialog_end = function ()
    
    cmn.Lock(0);
    
    cmn.ShowBbt( "housegarden_after_flashback" );
  
    cmn.CallEventHandler( "clk_housegardenfirst" );
    private.dlg_finished = true;
    
    ObjSet("anm_housegarden_dialog_granny1_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    cmn.Lock(1);
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_housegarden_env");
    
    ObjMultiSet( { {"anm_housegarden_dialog_granny1_hand_1",  { alp = 0, playing = 0 }},
                   {"anm_housegarden_dialog_granny1_hand_give",  { alp = 1, playing = 1, endtrig = dialog_end }}  } );
    
  end;
                 
  local play_flashback = function ()
    
    private.dlg_lipsync = "";
    
    ObjDelete("vid_housegarden_dialog_granny1_lipsync1");
    ObjSet("obj_housegarden_dialog_granny1_head",  { alp = 1 });
    
    interface.InterfaceSetInput( true );
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjSet("tmr_housegarden_dialog_granny1_timer",  { playing = 0 });
    
    cmn.StopAllEnv();
    
    cmn.PlayCutScene( "grannyflashback",
                      "assets/levels/level3/rm_housegarden/flashback_granny/anm_flashback_granny",
                      { 0, 7.8, 20.4, 34.4 },
                      anm_give, 
                      "assets/levels/level3/rm_housegarden/audio/aud_flashback3",
                      "assets/levels/level3/rm_housegarden/audio/aud_flashback3_voc" );
    
  end;
  
  private.dlg_lipsync = "vid_housegarden_dialog_granny1_lipsync1";

  cmn.ShowDlgBbt( "dlg_granny1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg1_voc");

  ObjMultiSet( { {"tmr_housegarden_dialog_granny1_timer", { time = 9, playing = 1, endtrig = play_flashback }},
                 {"vid_housegarden_dialog_granny1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = play_flashback }},
                 {"obj_character_dialog_continue", { event_mup = play_flashback }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_granny2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "housegarden", "granny2", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_housegardenwithred_loc" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 9 );
    
    private.dlg_finished = true;
    
    ObjSet("anm_housegarden_dialog_granny2_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_housegarden_dialog_granny2_lipsync4");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_housegarden_dialog_granny2_timer",  { playing = 0 }},
                   {"anm_housegarden_dialog_granny2_hand_1",  { alp = 0, playing = 0 }},
                   {"anm_housegarden_dialog_granny2_hand_give",  { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"obj_housegarden_dialog_granny2_head", { alp = 1 }}  } );
    
  end;
  
  local granny_talks4 = function ()
  
    ObjDelete("vid_housegarden_dialog_granny2_lipsync3");
    ObjAttach("vid_housegarden_dialog_granny2_lipsync4", "obj_housegarden_dialog_granny2");
  
    cmn.ShowDlgBbt( "dlg_granny2_phrase_4" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg2_4_voc");
    private.dlg_lipsync = "vid_housegarden_dialog_granny2_lipsync4";
    
    ObjMultiSet( { {"tmr_housegarden_dialog_granny2_timer", { endtrig = anm_give, time = 10.4, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_housegarden_dialog_granny2_lipsync4", { playing = 1 }} } );
  
  end;
                 
  local granny_talks3 = function ()
  
    ObjDelete("vid_housegarden_dialog_granny2_lipsync2");
    ObjAttach("vid_housegarden_dialog_granny2_lipsync3", "obj_housegarden_dialog_granny2");
  
    cmn.ShowDlgBbt( "dlg_granny2_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg2_3_voc");
    private.dlg_lipsync = "vid_housegarden_dialog_granny2_lipsync3";
    
    ObjMultiSet( { {"tmr_housegarden_dialog_granny2_timer", { endtrig = granny_talks4, time = 11.7, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = granny_talks4 }},
                   {"obj_character_dialog_continue", { event_mup = granny_talks4 }},
                   {"vid_housegarden_dialog_granny2_lipsync3", { playing = 1 }},
                   {"obj_housegarden_dialog_granny2_head", { alp = 0 }},
                   {"anm_housegarden_dialog_granny2_redhood_head", { alp = 1 }} } );
  
  end;
                 
  local granny_talks2 = function ()
  
    ObjDelete("vid_housegarden_dialog_granny2_lipsync1");
    ObjAttach("vid_housegarden_dialog_granny2_lipsync2", "obj_housegarden_dialog_granny2");
  
    cmn.ShowDlgBbt( "dlg_granny2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg2_2_voc");
    private.dlg_lipsync = "vid_housegarden_dialog_granny2_lipsync2";
    
    ObjMultiSet( { {"tmr_housegarden_dialog_granny2_timer", { endtrig = granny_talks3, time = 3.8, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = granny_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = granny_talks3 }},
                   {"vid_housegarden_dialog_granny2_lipsync2", { playing = 1 }},
                   {"obj_housegarden_dialog_granny2_head", { alp = 1 }},
                   {"anm_housegarden_dialog_granny2_redhood_head", { alp = 0 }} } );
  
  end;

  private.dlg_lipsync = "vid_housegarden_dialog_granny2_lipsync1";

  cmn.ShowDlgBbt( "dlg_granny2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg2_1_voc");

  ObjMultiSet( { {"tmr_housegarden_dialog_granny2_timer", { time = 6, playing = 1, endtrig = granny_talks2 }},
                 {"vid_housegarden_dialog_granny2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = granny_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = granny_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_granny3_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "housegarden", "granny3", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_teleportamulet_end" );
    private.dlg_finished = true;
    
    ObjSet("anm_housegarden_dialog_granny3_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_housegarden_dialog_granny3_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_housegarden_dialog_granny3_timer",  { playing = 0 }},
                   {"anm_housegarden_dialog_granny3_hand_1",  { alp = 0, playing = 0 }},
                   {"anm_housegarden_dialog_granny3_hand_give",  { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"obj_housegarden_dialog_granny3_head", { alp = 1 }}  } );
    
  end;
  
  local granny_talks2 = function ()
  
    ObjDelete("vid_housegarden_dialog_granny3_lipsync1");
    ObjAttach("vid_housegarden_dialog_granny3_lipsync2", "obj_housegarden_dialog_granny3");
  
    cmn.ShowDlgBbt( "dlg_granny3_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg3_2_voc");
    private.dlg_lipsync = "vid_housegarden_dialog_granny3_lipsync2";
    
    ObjMultiSet( { {"tmr_housegarden_dialog_granny3_timer", { endtrig = anm_give, time = 7, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_housegarden_dialog_granny3_lipsync2", { playing = 1 }} } );
  
  end;

  private.dlg_lipsync = "vid_housegarden_dialog_granny3_lipsync1";

  cmn.ShowDlgBbt( "dlg_granny3_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/rm_housegarden/audio/aud_grandmother_dlg3_1_voc");

  ObjMultiSet( { {"tmr_housegarden_dialog_granny3_timer", { time = 13.9, playing = 1, endtrig = granny_talks2 }},
                 {"vid_housegarden_dialog_granny3_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = granny_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = granny_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_granny1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  --cmn.Lock(1);
  private.dlg_finished = true;

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.ShowBbt( "housegarden_after_flashback" );
    cmn.CallEventHandler( "clk_housegardenfirst" );
    
    ObjSet("anm_housegarden_dialog_granny1_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;
  
  local anm_give = function ()
    
    cmn.Lock(1);
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_housegarden_env");
    
    ObjMultiSet( { {"anm_housegarden_dialog_granny1_hand_1",  { alp = 0, playing = 0 }},
                   {"anm_housegarden_dialog_granny1_hand_give",  { alp = 1, playing = 1, endtrig = func_after_dlg }}  } );
    
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_housegarden_dialog_granny1_timer",  { playing = 0 }},
                 {"obj_housegarden_dialog_granny1_head", { alp = 1 }} } );
  
  cmn.StopAllEnv();
  
  cmn.PlayCutScene( "grannyflashback",
                    "assets/levels/level3/rm_housegarden/flashback_granny/anm_flashback_granny",
                    { 0, 7.8, 20.4, 34.4 },
                    anm_give, 
                    "assets/levels/level3/rm_housegarden/audio/aud_flashback3",
                    "assets/levels/level3/rm_housegarden/audio/aud_flashback3_voc" );
  
end;  
--------------------------------------------------------------------------------------------
function public.skip_dlg_granny2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  private.dlg_finished = true;

  local func_after_dlg = function ()

    cmn.Lock(0);
    
    cmn.CallEventHandler( "opn_housegardenwithred_loc" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 9 );
    
    ObjSet("anm_housegarden_dialog_granny2_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();

  ObjMultiSet( { {"tmr_housegarden_dialog_granny2_timer",  { playing = 0 }},
                 {"anm_housegarden_dialog_granny2_hand_1",  { alp = 0, playing = 0 }},
                 {"anm_housegarden_dialog_granny2_hand_give",  { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"obj_housegarden_dialog_granny2_head", { alp = 1 }},
                 {"anm_housegarden_dialog_granny2_redhood_head", { alp = 1 }} } );
  
end;     
--------------------------------------------------------------------------------------------
function public.skip_dlg_granny3()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  private.dlg_finished = true;

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_teleportamulet_end" );
    
    ObjSet("anm_housegarden_dialog_granny3_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_housegarden_dialog_granny3_timer",  { playing = 0 }},
                 {"anm_housegarden_dialog_granny3_hand_1",  { alp = 0, playing = 0 }},
                 {"anm_housegarden_dialog_granny3_hand_give",  { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"obj_housegarden_dialog_granny3_head", { alp = 1 }}  } );
  
end;       
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Flowerbed *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_flowerbed = {};
public.zz_flowerbed = {};

function private.Init_Flowerbed()
  
  private.zz_flowerbed.start_state = { 2, 5, 4, 6, 3, 1 };
  private.zz_flowerbed.pearl_pos = { {198, -27}, {-144, 159}, {-179, -79}, {157, 57}, {190, -140}, {-176, 64} };
  private.zz_flowerbed.pearl_pos_sh = { {-2, 2}, {0, -2}, {2, 1}, {-1, -1}, {-2, 2}, {0, 0} };
  
  private.zz_flowerbed.current_stone = 0;
  private.zz_flowerbed.vacant_place = 0;
  -----------------------------------------------------------------------------------
  local win_flowerbed = function ()

    if cmn.IsEventDone( "win_flowerbed" ) then
      
      ObjDelete("obj_flowerbed_game");
      ObjDelete( "spr_housegarden_flowerbed_mmg" );

      ObjMultiSet( { {"spr_flowerbed_fernflower", { input = 1 }},
                     {"spr_flowerbed_pearl", { input = 1 }},
                     {"obj_flowerbed_use_runescoop", { input = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_flowerbed", win_flowerbed, "rm_housegarden" );

end;
--*********************************************************************************************************************
function private.zz_flowerbed.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].state = { 2, 5, 4, 6, 3, 1 }; --positions of pearls
  
end;
-----------------------------------------------------------------------------------
function public.zz_flowerbed.Reset()
  
  local need_r = false;
  local tme = 0.3;
  
  local need_sh = {0, 0, 0, 0, 0, 0};
  
  for i = 1, #private.zz_flowerbed.state, 1 do
    
    if private.zz_flowerbed.state[i] ~= private.zz_flowerbed.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local new_pos = 0;
      
      for j = 1, #private.zz_flowerbed.state, 1 do
        
        if private.zz_flowerbed.state[i] == private.zz_flowerbed.start_state[j] then
          new_pos = j;
          break;
        end;
        
      end;
      
      if private.zz_flowerbed.state[i] == i then
        ObjAnimate("spr_flowerbed_game_branch_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
      if new_pos > 0 then
        
        local point_a, point_b = {}, {};
        point_a[1] = private.zz_flowerbed.pearl_pos[ i ][1];
        point_a[2] = private.zz_flowerbed.pearl_pos[ i ][2];
        point_b[1] = private.zz_flowerbed.pearl_pos[ new_pos ][1];
        point_b[2] = private.zz_flowerbed.pearl_pos[ new_pos ][2];
        
        need_sh[ private.zz_flowerbed.state[i] ] = 1;
        
        --DbgTrace(private.zz_flowerbed.state[i].." "..new_pos);
      
        ObjAttach("spr_flowerbed_game_pearl_"..private.zz_flowerbed.state[i], "obj_flowerbed_game_fly");
        ObjAnimate("spr_flowerbed_game_pearl_"..private.zz_flowerbed.state[i], "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
        ObjAnimate("spr_flowerbed_game_pearl_"..private.zz_flowerbed.state[i].."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
      
      end;
          
    end;
    
  end;
  
  local func_after = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
    
    private.zz_flowerbed.DrawScene();
    ObjSet("tmr_flowerbed_timer",  { time = 0.1, playing = 1, endtrig = function() cmn.Lock(0); end });
    
    for i = 1, #private.zz_flowerbed.state, 1 do
      if need_sh[i] == 1 then
        ObjAnimate("spr_flowerbed_game_pearl_"..i.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
      end;
    end;
    
  end;
    
  if need_r then
    
    cmn.Lock(1);
    
    private.zz_flowerbed.StartConditions();
    private.zz_flowerbed.state = ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].state;
    
    ObjSet("tmr_flowerbed_timer",  { time = tme, playing = 1, endtrig = func_after });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_flowerbed.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].state = { 1, 2, 3, 4, 5, 6 };
  
  local tme = 0.3;
  local need_sh = {0, 0, 0, 0, 0, 0};
  
  for i = 1, #private.zz_flowerbed.state, 1 do
    
    if private.zz_flowerbed.state[i] ~= i then
      
      local new_pos = private.zz_flowerbed.state[i];
      
      if new_pos > 0 then
      
        local point_a, point_b = {}, {};
        point_a[1] = private.zz_flowerbed.pearl_pos[ i ][1];
        point_a[2] = private.zz_flowerbed.pearl_pos[ i ][2];
        point_b[1] = private.zz_flowerbed.pearl_pos[ new_pos ][1];
        point_b[2] = private.zz_flowerbed.pearl_pos[ new_pos ][2];
        
        need_sh[ private.zz_flowerbed.state[i] ] = 1;
        
        ObjAnimate("spr_flowerbed_game_branch_"..private.zz_flowerbed.state[i].."_win", "alp", 0, 0, "", { 0, 0, 0,   tme, 0, 1 });
        
        ObjAttach("spr_flowerbed_game_pearl_"..private.zz_flowerbed.state[i], "obj_flowerbed_game_fly");
        ObjAnimate("spr_flowerbed_game_pearl_"..private.zz_flowerbed.state[i], "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
        ObjAnimate("spr_flowerbed_game_pearl_"..private.zz_flowerbed.state[i].."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
      
      end;
      
    end;
    
  end;
  
  local func_after = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
    
    private.zz_flowerbed.DrawScene();
    ObjSet("tmr_flowerbed_timer",  { time = 0.1, playing = 1, endtrig = private.zz_flowerbed.CheckWin });
    
    for i = 1, #private.zz_flowerbed.state, 1 do
      if need_sh[i] == 1 then
        ObjAnimate("spr_flowerbed_game_pearl_"..i.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
      end;
    end;
    
  end;
  
  private.zz_flowerbed.state = ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].state;
    
  ObjSet("tmr_flowerbed_timer",  { time = tme, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.zz_flowerbed.DrawScene()
  
  for i = 1, #private.zz_flowerbed.state, 1 do
    
    local pearl = private.zz_flowerbed.state[i];
    
    if pearl == i then
      ObjSet("spr_flowerbed_game_branch_"..i.."_win",  { alp = 1 });
    end;
    
    ObjAttach("spr_flowerbed_game_pearl_"..pearl, "obj_flowerbed_game_branch_"..i);
    ObjAttach("spr_flowerbed_game_pearl_"..pearl.."_sh", "obj_flowerbed_game_branch_"..i);
    
    ObjMultiSet( { {"spr_flowerbed_game_pearl_"..pearl,  { pos_x = private.zz_flowerbed.pearl_pos[i][1], pos_y = private.zz_flowerbed.pearl_pos[i][2] }},
                   {"spr_flowerbed_game_pearl_"..pearl.."_sh",  { pos_x = private.zz_flowerbed.pearl_pos[i][1]+private.zz_flowerbed.pearl_pos_sh[pearl][1], pos_y = private.zz_flowerbed.pearl_pos[i][2]+private.zz_flowerbed.pearl_pos_sh[pearl][2] }} } );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_flowerbed.FocusPearl( num, inout )
  
  local obj = "spr_flowerbed_game_pearl_"..num.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_menter_stone");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
-----------------------------------------------------------------------------------
function public.zz_flowerbed.ChosePearl( num, second )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  if private.zz_flowerbed.current_stone == 0 then
    
    for i = 1, 6, 1 do
      
      if private.zz_flowerbed.state[i] == num then
        private.zz_flowerbed.vacant_place = i;
        break
      end;
      
    end;
    
  end;
  
  if private.zz_flowerbed.vacant_place == num and ObjGet("spr_flowerbed_game_branch_"..num.."_win").alp > 0 then
    ObjAnimate("spr_flowerbed_game_branch_"..num.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  public.zz_flowerbed.FocusPearl( num, 0 );
  
  private.zz_flowerbed.current_stone = num;
  
  if (second == nil) then
    ObjStartDrag("obj_flowerbed_game_drag");
  end;
  
  ObjAttach("spr_flowerbed_game_pearl_"..num, "obj_flowerbed_game_fly");
  ObjAnimate("spr_flowerbed_game_pearl_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });

end;
-----------------------------------------------------------------------------------
function public.zz_flowerbed.DragPearl()
  
  local curspos = GetZoomCursorPos();

  curspos[1] = math.floor(curspos[1] - ObjGet("zz_flowerbed").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_flowerbed").pos_y);
  
  if curspos[1] < -230 then
    curspos[1] = -230;
  elseif curspos[1] > 230 then
    curspos[1] = 230;
  end;
  
  if curspos[2] < -230 then
    curspos[2] = -230;
  elseif curspos[2] > 230 then
    curspos[2] = 230;
  end;
  
  ObjSet("spr_flowerbed_game_pearl_"..private.zz_flowerbed.current_stone,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_flowerbed.DropPearl(second)
  
  cmn.Lock(1);
  
  local num = private.zz_flowerbed.current_stone;
  local curspos = GetZoomCursorPos();
  -- port feature
  if  tostring(GetPlatform()) == "android" then
    curspos[2] = curspos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curspos[2] = curspos[2] - 75;
    else
      curspos[2] = curspos[2] - 50;
    end;
  end;
  
  curspos[1] = curspos[1] - ObjGet("zz_flowerbed").pos_x;
  curspos[2] = curspos[2] - ObjGet("zz_flowerbed").pos_y;
  
  if (second ~= nil) then
    curspos = { 0 ,0 };
  end;
  
  if curspos[1] < -230 then
    curspos[1] = -230;
  elseif curspos[1] > 230 then
    curspos[1] = 230;
  end;
  
  if curspos[2] < -230 then
    curspos[2] = -230;
  elseif curspos[2] > 230 then
    curspos[2] = 230;
  end;
  
  local pos = 0;
  
  for i = 1, 6, 1 do

    if (curspos[1] > private.zz_flowerbed.pearl_pos[i][1] - 30) and (curspos[1] < private.zz_flowerbed.pearl_pos[i][1] + 30) and 
       (curspos[2] > private.zz_flowerbed.pearl_pos[i][2] - 30) and (curspos[2] < private.zz_flowerbed.pearl_pos[i][2] + 30) then

      pos = i;
      break;
    end;

  end;
  
  if pos == 0 or pos == private.zz_flowerbed.vacant_place then
    
    pos = private.zz_flowerbed.vacant_place;
    
    private.zz_flowerbed.current_stone = 0;
    private.zz_flowerbed.vacant_place = 0;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_flowerbed.pearl_pos[ pos ][1];
    point_b[2] = private.zz_flowerbed.pearl_pos[ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_flowerbed_game_pearl_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
        private.zz_flowerbed.CheckStone( num, 0, pos, second ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
    ObjAttach("spr_flowerbed_game_pearl_"..num.."_sh", "obj_flowerbed_game_branch_"..pos);
    ObjSet("spr_flowerbed_game_pearl_"..num.."_sh",  { pos_x = private.zz_flowerbed.pearl_pos[pos][1]+private.zz_flowerbed.pearl_pos_sh[num][1], pos_y = private.zz_flowerbed.pearl_pos[pos][2]+private.zz_flowerbed.pearl_pos_sh[num][2] });
    ObjAnimate("spr_flowerbed_game_pearl_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 0,   tme-0.1, 0, 0,  tme, 0, 1 });
    
  else 
    
    private.zz_flowerbed.current_stone = private.zz_flowerbed.state[ pos ];
    private.zz_flowerbed.state[ pos ] = num;
    private.zz_flowerbed.state[ private.zz_flowerbed.vacant_place ] = private.zz_flowerbed.current_stone;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_flowerbed.pearl_pos[ pos ][1];
    point_b[2] = private.zz_flowerbed.pearl_pos[ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    end;
    
    ObjAnimate("spr_flowerbed_game_pearl_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
        private.zz_flowerbed.CheckStone( num, private.zz_flowerbed.current_stone, pos, second ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
    if private.zz_flowerbed.current_stone == pos then
      ObjAnimate("spr_flowerbed_game_branch_"..pos.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
    end;
    
    ObjAttach("spr_flowerbed_game_pearl_"..num.."_sh", "obj_flowerbed_game_branch_"..pos);
    ObjSet("spr_flowerbed_game_pearl_"..num.."_sh",  { pos_x = private.zz_flowerbed.pearl_pos[pos][1]+private.zz_flowerbed.pearl_pos_sh[num][1], pos_y = private.zz_flowerbed.pearl_pos[pos][2]+private.zz_flowerbed.pearl_pos_sh[num][2] });
    ObjAnimate("spr_flowerbed_game_pearl_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 0,   tme-0.1, 0, 0,  tme, 0, 1 });
    
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_flowerbed.CheckStone( num1, num2, place, second )
  
  num2 = num2 or 0;
  
  ObjAttach("spr_flowerbed_game_pearl_"..num1, "obj_flowerbed_game_branch_"..place);
  
  if num2 > 0 and second == nil then
    
    cmn.Lock(0);
    --ObjStartDrag("spr_flowerbed_game_pearl_"..num2);
    public.zz_flowerbed.ChosePearl( num2, true );
    ObjSet("tmr_zz_flowerbed",{ time = 0.25, playing = true, endtrig = function() public.zz_flowerbed.DropPearl(true); end });
    
  else 
    private.zz_flowerbed.CheckWin();
  end;
  
  if num1 == place then
    ObjAnimate("spr_flowerbed_game_branch_"..num1.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_flowerbed.CheckWin()
  
  local win_flag = true;
  
  for i = 1, #private.zz_flowerbed.state, 1 do
    
    if private.zz_flowerbed.state[i] ~= i then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("flowerbed");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_xx_clk_rustle3");
    
    ObjAnimate("obj_flowerbed_game", "alp", 0, 0, private.zz_flowerbed.Win, { 0, 0, 1,   1, 0, 1,    1.5, 0, 0 });
    
  else 
    
    cmn.Lock( 0 );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_flowerbed.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_flowerbed" );
  cmn.CallEventHandler( "win_flowerbed" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_flowerbed" ].skip == 0 and ng_global.noskipgames[ "win_flowerbed" ] == nil then

    ng_global.noskipgames[ "win_flowerbed" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
end;
--********************************************************************************************************************